#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 10
#define STATE_COUNT 1160
#define SYMBOL_COUNT 217
#define ALIAS_COUNT 0
#define TOKEN_COUNT 100
#define EXTERNAL_TOKEN_COUNT 6
#define FIELD_COUNT 23
#define MAX_ALIAS_SEQUENCE_LENGTH 9

enum {
  sym_identifier = 1,
  anon_sym_import = 2,
  anon_sym_DOT = 3,
  anon_sym_from = 4,
  anon_sym___future__ = 5,
  anon_sym_LPAREN = 6,
  anon_sym_RPAREN = 7,
  anon_sym_COMMA = 8,
  anon_sym_as = 9,
  anon_sym_STAR = 10,
  anon_sym_print = 11,
  anon_sym_GT_GT = 12,
  anon_sym_assert = 13,
  anon_sym_COLON_EQ = 14,
  anon_sym_return = 15,
  anon_sym_del = 16,
  anon_sym_raise = 17,
  anon_sym_pass = 18,
  anon_sym_break = 19,
  anon_sym_continue = 20,
  anon_sym_if = 21,
  anon_sym_COLON = 22,
  anon_sym_elif = 23,
  anon_sym_else = 24,
  anon_sym_async = 25,
  anon_sym_for = 26,
  anon_sym_in = 27,
  anon_sym_while = 28,
  anon_sym_try = 29,
  anon_sym_except = 30,
  anon_sym_finally = 31,
  anon_sym_with = 32,
  anon_sym_def = 33,
  anon_sym_DASH_GT = 34,
  anon_sym_EQ = 35,
  anon_sym_global = 36,
  anon_sym_nonlocal = 37,
  anon_sym_exec = 38,
  anon_sym_class = 39,
  anon_sym_AT = 40,
  anon_sym_not = 41,
  anon_sym_and = 42,
  anon_sym_or = 43,
  anon_sym_PLUS = 44,
  anon_sym_DASH = 45,
  anon_sym_SLASH = 46,
  anon_sym_PERCENT = 47,
  anon_sym_SLASH_SLASH = 48,
  anon_sym_STAR_STAR = 49,
  anon_sym_PIPE = 50,
  anon_sym_AMP = 51,
  anon_sym_CARET = 52,
  anon_sym_LT_LT = 53,
  anon_sym_TILDE = 54,
  anon_sym_LT = 55,
  anon_sym_LT_EQ = 56,
  anon_sym_EQ_EQ = 57,
  anon_sym_BANG_EQ = 58,
  anon_sym_GT_EQ = 59,
  anon_sym_GT = 60,
  anon_sym_LT_GT = 61,
  anon_sym_is = 62,
  anon_sym_lambda = 63,
  anon_sym_PLUS_EQ = 64,
  anon_sym_DASH_EQ = 65,
  anon_sym_STAR_EQ = 66,
  anon_sym_SLASH_EQ = 67,
  anon_sym_AT_EQ = 68,
  anon_sym_SLASH_SLASH_EQ = 69,
  anon_sym_PERCENT_EQ = 70,
  anon_sym_STAR_STAR_EQ = 71,
  anon_sym_GT_GT_EQ = 72,
  anon_sym_LT_LT_EQ = 73,
  anon_sym_AMP_EQ = 74,
  anon_sym_CARET_EQ = 75,
  anon_sym_PIPE_EQ = 76,
  anon_sym_yield = 77,
  anon_sym_LBRACK = 78,
  anon_sym_RBRACK = 79,
  sym_ellipsis = 80,
  anon_sym_LBRACE = 81,
  anon_sym_RBRACE = 82,
  sym_escape_sequence = 83,
  aux_sym_format_specifier_token1 = 84,
  sym_type_conversion = 85,
  sym_integer = 86,
  sym_float = 87,
  sym_true = 88,
  sym_false = 89,
  sym_none = 90,
  anon_sym_await = 91,
  sym_comment = 92,
  sym__semicolon = 93,
  sym__newline = 94,
  sym__indent = 95,
  sym__dedent = 96,
  sym__string_start = 97,
  sym__string_content = 98,
  sym__string_end = 99,
  sym_module = 100,
  sym__statement = 101,
  sym__simple_statements = 102,
  sym_import_statement = 103,
  sym_import_prefix = 104,
  sym_relative_import = 105,
  sym_future_import_statement = 106,
  sym_import_from_statement = 107,
  sym__import_list = 108,
  sym_aliased_import = 109,
  sym_wildcard_import = 110,
  sym_print_statement = 111,
  sym_chevron = 112,
  sym_assert_statement = 113,
  sym_expression_statement = 114,
  sym_named_expression = 115,
  sym_return_statement = 116,
  sym_delete_statement = 117,
  sym_raise_statement = 118,
  sym_pass_statement = 119,
  sym_break_statement = 120,
  sym_continue_statement = 121,
  sym_if_statement = 122,
  sym_elif_clause = 123,
  sym_else_clause = 124,
  sym_for_statement = 125,
  sym_while_statement = 126,
  sym_try_statement = 127,
  sym_except_clause = 128,
  sym_finally_clause = 129,
  sym_with_statement = 130,
  sym_with_item = 131,
  sym_function_definition = 132,
  sym_parameters = 133,
  sym_lambda_parameters = 134,
  sym__parameters = 135,
  sym_default_parameter = 136,
  sym_typed_default_parameter = 137,
  sym_list_splat = 138,
  sym_dictionary_splat = 139,
  sym_global_statement = 140,
  sym_nonlocal_statement = 141,
  sym_exec_statement = 142,
  sym_class_definition = 143,
  sym_argument_list = 144,
  sym_decorated_definition = 145,
  sym_decorator = 146,
  sym_block = 147,
  sym_variables = 148,
  sym_expression_list = 149,
  sym_dotted_name = 150,
  sym__expression_within_for_in_clause = 151,
  sym__expression = 152,
  sym__primary_expression = 153,
  sym_not_operator = 154,
  sym_boolean_operator = 155,
  sym_binary_operator = 156,
  sym_unary_operator = 157,
  sym_comparison_operator = 158,
  sym_lambda = 159,
  sym_lambda_within_for_in_clause = 160,
  sym_assignment = 161,
  sym_augmented_assignment = 162,
  sym__right_hand_side = 163,
  sym_yield = 164,
  sym_attribute = 165,
  sym_subscript = 166,
  sym_slice = 167,
  sym_call = 168,
  sym_typed_parameter = 169,
  sym_type = 170,
  sym_keyword_argument = 171,
  sym_list = 172,
  sym__comprehension_clauses = 173,
  sym_list_comprehension = 174,
  sym_dictionary = 175,
  sym_dictionary_comprehension = 176,
  sym_pair = 177,
  sym_set = 178,
  sym_set_comprehension = 179,
  sym_parenthesized_expression = 180,
  sym_tuple = 181,
  sym_generator_expression = 182,
  sym_for_in_clause = 183,
  sym_if_clause = 184,
  sym_conditional_expression = 185,
  sym_concatenated_string = 186,
  sym_string = 187,
  sym_interpolation = 188,
  sym_format_specifier = 189,
  sym_format_expression = 190,
  sym_await = 191,
  aux_sym_module_repeat1 = 192,
  aux_sym__simple_statements_repeat1 = 193,
  aux_sym_import_prefix_repeat1 = 194,
  aux_sym__import_list_repeat1 = 195,
  aux_sym_print_statement_repeat1 = 196,
  aux_sym_assert_statement_repeat1 = 197,
  aux_sym_if_statement_repeat1 = 198,
  aux_sym_try_statement_repeat1 = 199,
  aux_sym_with_statement_repeat1 = 200,
  aux_sym__parameters_repeat1 = 201,
  aux_sym_global_statement_repeat1 = 202,
  aux_sym_argument_list_repeat1 = 203,
  aux_sym_decorated_definition_repeat1 = 204,
  aux_sym_variables_repeat1 = 205,
  aux_sym_dotted_name_repeat1 = 206,
  aux_sym_comparison_operator_repeat1 = 207,
  aux_sym_subscript_repeat1 = 208,
  aux_sym_list_repeat1 = 209,
  aux_sym__comprehension_clauses_repeat1 = 210,
  aux_sym_dictionary_repeat1 = 211,
  aux_sym_tuple_repeat1 = 212,
  aux_sym_for_in_clause_repeat1 = 213,
  aux_sym_concatenated_string_repeat1 = 214,
  aux_sym_string_repeat1 = 215,
  aux_sym_format_specifier_repeat1 = 216,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_import] = "import",
  [anon_sym_DOT] = ".",
  [anon_sym_from] = "from",
  [anon_sym___future__] = "__future__",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_COMMA] = ",",
  [anon_sym_as] = "as",
  [anon_sym_STAR] = "*",
  [anon_sym_print] = "print",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_assert] = "assert",
  [anon_sym_COLON_EQ] = ":=",
  [anon_sym_return] = "return",
  [anon_sym_del] = "del",
  [anon_sym_raise] = "raise",
  [anon_sym_pass] = "pass",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_if] = "if",
  [anon_sym_COLON] = ":",
  [anon_sym_elif] = "elif",
  [anon_sym_else] = "else",
  [anon_sym_async] = "async",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_while] = "while",
  [anon_sym_try] = "try",
  [anon_sym_except] = "except",
  [anon_sym_finally] = "finally",
  [anon_sym_with] = "with",
  [anon_sym_def] = "def",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_EQ] = "=",
  [anon_sym_global] = "global",
  [anon_sym_nonlocal] = "nonlocal",
  [anon_sym_exec] = "exec",
  [anon_sym_class] = "class",
  [anon_sym_AT] = "@",
  [anon_sym_not] = "not",
  [anon_sym_and] = "and",
  [anon_sym_or] = "or",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_SLASH_SLASH] = "//",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_PIPE] = "|",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_TILDE] = "~",
  [anon_sym_LT] = "<",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_GT] = ">",
  [anon_sym_LT_GT] = "<>",
  [anon_sym_is] = "is",
  [anon_sym_lambda] = "lambda",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_AT_EQ] = "@=",
  [anon_sym_SLASH_SLASH_EQ] = "//=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_yield] = "yield",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [sym_ellipsis] = "ellipsis",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [sym_escape_sequence] = "escape_sequence",
  [aux_sym_format_specifier_token1] = "format_specifier_token1",
  [sym_type_conversion] = "type_conversion",
  [sym_integer] = "integer",
  [sym_float] = "float",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_none] = "none",
  [anon_sym_await] = "await",
  [sym_comment] = "comment",
  [sym__semicolon] = "_semicolon",
  [sym__newline] = "_newline",
  [sym__indent] = "_indent",
  [sym__dedent] = "_dedent",
  [sym__string_start] = "\"",
  [sym__string_content] = "_string_content",
  [sym__string_end] = "\"",
  [sym_module] = "module",
  [sym__statement] = "_statement",
  [sym__simple_statements] = "_simple_statements",
  [sym_import_statement] = "import_statement",
  [sym_import_prefix] = "import_prefix",
  [sym_relative_import] = "relative_import",
  [sym_future_import_statement] = "future_import_statement",
  [sym_import_from_statement] = "import_from_statement",
  [sym__import_list] = "_import_list",
  [sym_aliased_import] = "aliased_import",
  [sym_wildcard_import] = "wildcard_import",
  [sym_print_statement] = "print_statement",
  [sym_chevron] = "chevron",
  [sym_assert_statement] = "assert_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_named_expression] = "named_expression",
  [sym_return_statement] = "return_statement",
  [sym_delete_statement] = "delete_statement",
  [sym_raise_statement] = "raise_statement",
  [sym_pass_statement] = "pass_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_if_statement] = "if_statement",
  [sym_elif_clause] = "elif_clause",
  [sym_else_clause] = "else_clause",
  [sym_for_statement] = "for_statement",
  [sym_while_statement] = "while_statement",
  [sym_try_statement] = "try_statement",
  [sym_except_clause] = "except_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_with_statement] = "with_statement",
  [sym_with_item] = "with_item",
  [sym_function_definition] = "function_definition",
  [sym_parameters] = "parameters",
  [sym_lambda_parameters] = "lambda_parameters",
  [sym__parameters] = "_parameters",
  [sym_default_parameter] = "default_parameter",
  [sym_typed_default_parameter] = "typed_default_parameter",
  [sym_list_splat] = "list_splat",
  [sym_dictionary_splat] = "dictionary_splat",
  [sym_global_statement] = "global_statement",
  [sym_nonlocal_statement] = "nonlocal_statement",
  [sym_exec_statement] = "exec_statement",
  [sym_class_definition] = "class_definition",
  [sym_argument_list] = "argument_list",
  [sym_decorated_definition] = "decorated_definition",
  [sym_decorator] = "decorator",
  [sym_block] = "block",
  [sym_variables] = "variables",
  [sym_expression_list] = "expression_list",
  [sym_dotted_name] = "dotted_name",
  [sym__expression_within_for_in_clause] = "_expression_within_for_in_clause",
  [sym__expression] = "_expression",
  [sym__primary_expression] = "_primary_expression",
  [sym_not_operator] = "not_operator",
  [sym_boolean_operator] = "boolean_operator",
  [sym_binary_operator] = "binary_operator",
  [sym_unary_operator] = "unary_operator",
  [sym_comparison_operator] = "comparison_operator",
  [sym_lambda] = "lambda",
  [sym_lambda_within_for_in_clause] = "lambda",
  [sym_assignment] = "assignment",
  [sym_augmented_assignment] = "augmented_assignment",
  [sym__right_hand_side] = "_right_hand_side",
  [sym_yield] = "yield",
  [sym_attribute] = "attribute",
  [sym_subscript] = "subscript",
  [sym_slice] = "slice",
  [sym_call] = "call",
  [sym_typed_parameter] = "typed_parameter",
  [sym_type] = "type",
  [sym_keyword_argument] = "keyword_argument",
  [sym_list] = "list",
  [sym__comprehension_clauses] = "_comprehension_clauses",
  [sym_list_comprehension] = "list_comprehension",
  [sym_dictionary] = "dictionary",
  [sym_dictionary_comprehension] = "dictionary_comprehension",
  [sym_pair] = "pair",
  [sym_set] = "set",
  [sym_set_comprehension] = "set_comprehension",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_tuple] = "tuple",
  [sym_generator_expression] = "generator_expression",
  [sym_for_in_clause] = "for_in_clause",
  [sym_if_clause] = "if_clause",
  [sym_conditional_expression] = "conditional_expression",
  [sym_concatenated_string] = "concatenated_string",
  [sym_string] = "string",
  [sym_interpolation] = "interpolation",
  [sym_format_specifier] = "format_specifier",
  [sym_format_expression] = "format_expression",
  [sym_await] = "await",
  [aux_sym_module_repeat1] = "module_repeat1",
  [aux_sym__simple_statements_repeat1] = "_simple_statements_repeat1",
  [aux_sym_import_prefix_repeat1] = "import_prefix_repeat1",
  [aux_sym__import_list_repeat1] = "_import_list_repeat1",
  [aux_sym_print_statement_repeat1] = "print_statement_repeat1",
  [aux_sym_assert_statement_repeat1] = "assert_statement_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_try_statement_repeat1] = "try_statement_repeat1",
  [aux_sym_with_statement_repeat1] = "with_statement_repeat1",
  [aux_sym__parameters_repeat1] = "_parameters_repeat1",
  [aux_sym_global_statement_repeat1] = "global_statement_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_decorated_definition_repeat1] = "decorated_definition_repeat1",
  [aux_sym_variables_repeat1] = "variables_repeat1",
  [aux_sym_dotted_name_repeat1] = "dotted_name_repeat1",
  [aux_sym_comparison_operator_repeat1] = "comparison_operator_repeat1",
  [aux_sym_subscript_repeat1] = "subscript_repeat1",
  [aux_sym_list_repeat1] = "list_repeat1",
  [aux_sym__comprehension_clauses_repeat1] = "_comprehension_clauses_repeat1",
  [aux_sym_dictionary_repeat1] = "dictionary_repeat1",
  [aux_sym_tuple_repeat1] = "tuple_repeat1",
  [aux_sym_for_in_clause_repeat1] = "for_in_clause_repeat1",
  [aux_sym_concatenated_string_repeat1] = "concatenated_string_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_format_specifier_repeat1] = "format_specifier_repeat1",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___future__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_print] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assert] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_del] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_raise] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pass] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_except] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_def] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nonlocal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_exec] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lambda] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [sym_ellipsis] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_format_specifier_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_type_conversion] = {
    .visible = true,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_none] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__newline] = {
    .visible = false,
    .named = true,
  },
  [sym__indent] = {
    .visible = false,
    .named = true,
  },
  [sym__dedent] = {
    .visible = false,
    .named = true,
  },
  [sym__string_start] = {
    .visible = true,
    .named = false,
  },
  [sym__string_content] = {
    .visible = false,
    .named = true,
  },
  [sym__string_end] = {
    .visible = true,
    .named = false,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_statements] = {
    .visible = false,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_prefix] = {
    .visible = true,
    .named = true,
  },
  [sym_relative_import] = {
    .visible = true,
    .named = true,
  },
  [sym_future_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_from_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__import_list] = {
    .visible = false,
    .named = true,
  },
  [sym_aliased_import] = {
    .visible = true,
    .named = true,
  },
  [sym_wildcard_import] = {
    .visible = true,
    .named = true,
  },
  [sym_print_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_chevron] = {
    .visible = true,
    .named = true,
  },
  [sym_assert_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_named_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_delete_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_raise_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_pass_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elif_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_except_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym__parameters] = {
    .visible = false,
    .named = true,
  },
  [sym_default_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_typed_default_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_list_splat] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary_splat] = {
    .visible = true,
    .named = true,
  },
  [sym_global_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_nonlocal_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_exec_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_class_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_decorated_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_variables] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_list] = {
    .visible = true,
    .named = true,
  },
  [sym_dotted_name] = {
    .visible = true,
    .named = true,
  },
  [sym__expression_within_for_in_clause] = {
    .visible = false,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym__primary_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_not_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_comparison_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_within_for_in_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_augmented_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym__right_hand_side] = {
    .visible = false,
    .named = true,
  },
  [sym_yield] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript] = {
    .visible = true,
    .named = true,
  },
  [sym_slice] = {
    .visible = true,
    .named = true,
  },
  [sym_call] = {
    .visible = true,
    .named = true,
  },
  [sym_typed_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_type] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym__comprehension_clauses] = {
    .visible = false,
    .named = true,
  },
  [sym_list_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_set] = {
    .visible = true,
    .named = true,
  },
  [sym_set_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_for_in_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_if_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenated_string] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym_format_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_format_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_await] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_module_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__simple_statements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_import_prefix_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__import_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_print_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_assert_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_with_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_global_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_decorated_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variables_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dotted_name_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_comparison_operator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_subscript_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__comprehension_clauses_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dictionary_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_in_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenated_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_format_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_arguments = 4,
  field_body = 5,
  field_cause = 6,
  field_code = 7,
  field_condition = 8,
  field_consequence = 9,
  field_definition = 10,
  field_function = 11,
  field_key = 12,
  field_left = 13,
  field_module_name = 14,
  field_name = 15,
  field_operator = 16,
  field_parameters = 17,
  field_return_type = 18,
  field_right = 19,
  field_subscript = 20,
  field_superclasses = 21,
  field_type = 22,
  field_value = 23,
};

static const char *ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_body] = "body",
  [field_cause] = "cause",
  [field_code] = "code",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_definition] = "definition",
  [field_function] = "function",
  [field_key] = "key",
  [field_left] = "left",
  [field_module_name] = "module_name",
  [field_name] = "name",
  [field_operator] = "operator",
  [field_parameters] = "parameters",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_subscript] = "subscript",
  [field_superclasses] = "superclasses",
  [field_type] = "type",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 1},
  [5] = {.index = 3, .length = 1},
  [6] = {.index = 4, .length = 1},
  [7] = {.index = 5, .length = 2},
  [8] = {.index = 7, .length = 2},
  [9] = {.index = 9, .length = 1},
  [10] = {.index = 10, .length = 2},
  [11] = {.index = 12, .length = 1},
  [12] = {.index = 13, .length = 2},
  [13] = {.index = 15, .length = 1},
  [14] = {.index = 16, .length = 1},
  [15] = {.index = 17, .length = 2},
  [16] = {.index = 19, .length = 2},
  [17] = {.index = 21, .length = 2},
  [18] = {.index = 23, .length = 3},
  [19] = {.index = 26, .length = 3},
  [20] = {.index = 29, .length = 1},
  [21] = {.index = 30, .length = 2},
  [22] = {.index = 32, .length = 2},
  [23] = {.index = 34, .length = 1},
  [24] = {.index = 35, .length = 2},
  [25] = {.index = 37, .length = 1},
  [26] = {.index = 38, .length = 2},
  [27] = {.index = 40, .length = 1},
  [28] = {.index = 41, .length = 2},
  [29] = {.index = 43, .length = 2},
  [30] = {.index = 16, .length = 1},
  [31] = {.index = 45, .length = 1},
  [32] = {.index = 46, .length = 2},
  [33] = {.index = 48, .length = 2},
  [34] = {.index = 50, .length = 1},
  [36] = {.index = 17, .length = 2},
  [37] = {.index = 51, .length = 1},
  [38] = {.index = 52, .length = 2},
  [39] = {.index = 54, .length = 2},
  [40] = {.index = 56, .length = 2},
  [41] = {.index = 58, .length = 3},
  [42] = {.index = 61, .length = 1},
  [43] = {.index = 62, .length = 3},
  [44] = {.index = 65, .length = 3},
  [45] = {.index = 68, .length = 1},
  [46] = {.index = 69, .length = 3},
  [47] = {.index = 72, .length = 3},
  [48] = {.index = 75, .length = 2},
  [49] = {.index = 77, .length = 2},
  [50] = {.index = 79, .length = 3},
  [51] = {.index = 82, .length = 3},
  [52] = {.index = 85, .length = 3},
  [53] = {.index = 88, .length = 3},
  [54] = {.index = 91, .length = 3},
  [55] = {.index = 94, .length = 1},
  [56] = {.index = 95, .length = 2},
  [57] = {.index = 97, .length = 2},
  [58] = {.index = 99, .length = 4},
  [59] = {.index = 103, .length = 4},
  [60] = {.index = 107, .length = 4},
  [61] = {.index = 111, .length = 2},
  [62] = {.index = 113, .length = 2},
  [63] = {.index = 115, .length = 1},
  [64] = {.index = 116, .length = 3},
  [65] = {.index = 119, .length = 3},
  [66] = {.index = 122, .length = 4},
  [68] = {.index = 126, .length = 4},
  [69] = {.index = 130, .length = 4},
  [70] = {.index = 134, .length = 3},
  [71] = {.index = 134, .length = 3},
  [72] = {.index = 137, .length = 2},
  [73] = {.index = 139, .length = 3},
  [74] = {.index = 142, .length = 5},
  [75] = {.index = 147, .length = 3},
  [76] = {.index = 150, .length = 2},
  [77] = {.index = 152, .length = 4},
  [78] = {.index = 156, .length = 4},
  [79] = {.index = 160, .length = 4},
  [81] = {.index = 164, .length = 4},
  [82] = {.index = 168, .length = 3},
  [83] = {.index = 171, .length = 4},
  [84] = {.index = 175, .length = 4},
  [85] = {.index = 179, .length = 4},
  [86] = {.index = 183, .length = 5},
  [87] = {.index = 188, .length = 5},
  [88] = {.index = 193, .length = 5},
  [89] = {.index = 198, .length = 5},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_name, 1, .inherited = true},
  [1] =
    {field_name, 0},
  [2] =
    {field_argument, 1},
  [3] =
    {field_value, 0},
  [4] =
    {field_code, 1},
  [5] =
    {field_argument, 1},
    {field_operator, 0},
  [7] =
    {field_arguments, 1},
    {field_function, 0},
  [9] =
    {field_definition, 1},
  [10] =
    {field_name, 0},
    {field_name, 1, .inherited = true},
  [12] =
    {field_argument, 2, .inherited = true},
  [13] =
    {field_argument, 1},
    {field_argument, 2, .inherited = true},
  [15] =
    {field_cause, 2},
  [16] =
    {field_body, 2},
  [17] =
    {field_name, 0},
    {field_value, 2},
  [19] =
    {field_left, 0},
    {field_type, 2},
  [21] =
    {field_left, 0},
    {field_right, 2},
  [23] =
    {field_left, 0},
    {field_left, 2},
    {field_operator, 1},
  [26] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [29] =
    {field_name, 1},
  [30] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [32] =
    {field_alias, 2},
    {field_name, 0},
  [34] =
    {field_name, 3, .inherited = true},
  [35] =
    {field_module_name, 1},
    {field_name, 3, .inherited = true},
  [37] =
    {field_body, 1},
  [38] =
    {field_argument, 0, .inherited = true},
    {field_argument, 1, .inherited = true},
  [40] =
    {field_cause, 3},
  [41] =
    {field_condition, 1},
    {field_consequence, 3},
  [43] =
    {field_body, 3},
    {field_condition, 1},
  [45] =
    {field_body, 3},
  [46] =
    {field_alias, 2},
    {field_value, 0},
  [48] =
    {field_body, 3},
    {field_name, 1},
  [50] =
    {field_arguments, 2},
  [51] =
    {field_type, 2},
  [52] =
    {field_body, 3},
    {field_parameters, 1},
  [54] =
    {field_key, 0},
    {field_value, 2},
  [56] =
    {field_subscript, 2},
    {field_value, 0},
  [58] =
    {field_condition, 1},
    {field_consequence, 3},
    {field_consequence, 4},
  [61] =
    {field_alternative, 0},
  [62] =
    {field_alternative, 4},
    {field_condition, 1},
    {field_consequence, 3},
  [65] =
    {field_alternative, 4, .inherited = true},
    {field_condition, 1},
    {field_consequence, 3},
  [68] =
    {field_body, 4},
  [69] =
    {field_body, 3},
    {field_body, 4},
    {field_condition, 1},
  [72] =
    {field_alternative, 4},
    {field_body, 3},
    {field_condition, 1},
  [75] =
    {field_body, 2},
    {field_body, 3},
  [77] =
    {field_body, 3},
    {field_body, 4},
  [79] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 2},
  [82] =
    {field_body, 3},
    {field_body, 4},
    {field_name, 1},
  [85] =
    {field_body, 4},
    {field_name, 1},
    {field_superclasses, 2},
  [88] =
    {field_left, 0},
    {field_right, 4},
    {field_type, 2},
  [91] =
    {field_subscript, 2},
    {field_subscript, 3},
    {field_value, 0},
  [94] =
    {field_name, 4, .inherited = true},
  [95] =
    {field_module_name, 1},
    {field_name, 4, .inherited = true},
  [97] =
    {field_left, 1},
    {field_right, 3},
  [99] =
    {field_alternative, 5},
    {field_condition, 1},
    {field_consequence, 3},
    {field_consequence, 4},
  [103] =
    {field_alternative, 5, .inherited = true},
    {field_condition, 1},
    {field_consequence, 3},
    {field_consequence, 4},
  [107] =
    {field_alternative, 4, .inherited = true},
    {field_alternative, 5},
    {field_condition, 1},
    {field_consequence, 3},
  [111] =
    {field_alternative, 0, .inherited = true},
    {field_alternative, 1, .inherited = true},
  [113] =
    {field_body, 4},
    {field_body, 5},
  [115] =
    {field_body, 5},
  [116] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 3},
  [119] =
    {field_body, 5},
    {field_left, 1},
    {field_right, 3},
  [122] =
    {field_alternative, 5},
    {field_body, 3},
    {field_body, 4},
    {field_condition, 1},
  [126] =
    {field_body, 4},
    {field_body, 5},
    {field_name, 1},
    {field_parameters, 2},
  [130] =
    {field_body, 4},
    {field_body, 5},
    {field_name, 1},
    {field_superclasses, 2},
  [134] =
    {field_name, 0},
    {field_type, 2},
    {field_value, 4},
  [137] =
    {field_left, 2},
    {field_right, 4},
  [139] =
    {field_left, 1},
    {field_right, 3},
    {field_right, 4},
  [142] =
    {field_alternative, 5, .inherited = true},
    {field_alternative, 6},
    {field_condition, 1},
    {field_consequence, 3},
    {field_consequence, 4},
  [147] =
    {field_body, 6},
    {field_left, 2},
    {field_right, 4},
  [150] =
    {field_body, 5},
    {field_body, 6},
  [152] =
    {field_body, 5},
    {field_body, 6},
    {field_name, 2},
    {field_parameters, 3},
  [156] =
    {field_body, 5},
    {field_body, 6},
    {field_left, 1},
    {field_right, 3},
  [160] =
    {field_alternative, 6},
    {field_body, 5},
    {field_left, 1},
    {field_right, 3},
  [164] =
    {field_body, 6},
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 4},
  [168] =
    {field_left, 2},
    {field_right, 4},
    {field_right, 5},
  [171] =
    {field_body, 6},
    {field_body, 7},
    {field_left, 2},
    {field_right, 4},
  [175] =
    {field_alternative, 7},
    {field_body, 6},
    {field_left, 2},
    {field_right, 4},
  [179] =
    {field_body, 7},
    {field_name, 2},
    {field_parameters, 3},
    {field_return_type, 5},
  [183] =
    {field_alternative, 7},
    {field_body, 5},
    {field_body, 6},
    {field_left, 1},
    {field_right, 3},
  [188] =
    {field_body, 6},
    {field_body, 7},
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 4},
  [193] =
    {field_alternative, 8},
    {field_body, 6},
    {field_body, 7},
    {field_left, 2},
    {field_right, 4},
  [198] =
    {field_body, 7},
    {field_body, 8},
    {field_name, 2},
    {field_parameters, 3},
    {field_return_type, 5},
};

static TSSymbol ts_alias_sequences[91][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_identifier,
  },
  [28] = {
    [3] = sym_block,
  },
  [29] = {
    [3] = sym_block,
  },
  [30] = {
    [2] = sym_block,
  },
  [31] = {
    [3] = sym_block,
  },
  [33] = {
    [3] = sym_block,
  },
  [35] = {
    [1] = sym_identifier,
  },
  [36] = {
    [0] = sym_identifier,
  },
  [43] = {
    [3] = sym_block,
  },
  [44] = {
    [3] = sym_block,
  },
  [45] = {
    [4] = sym_block,
  },
  [47] = {
    [3] = sym_block,
  },
  [50] = {
    [4] = sym_block,
  },
  [52] = {
    [4] = sym_block,
  },
  [60] = {
    [3] = sym_block,
  },
  [63] = {
    [5] = sym_block,
  },
  [64] = {
    [5] = sym_block,
  },
  [65] = {
    [5] = sym_block,
  },
  [67] = {
    [2] = sym_block,
  },
  [70] = {
    [0] = sym_identifier,
  },
  [75] = {
    [6] = sym_block,
  },
  [79] = {
    [5] = sym_block,
  },
  [80] = {
    [3] = sym_block,
  },
  [81] = {
    [6] = sym_block,
  },
  [84] = {
    [6] = sym_block,
  },
  [85] = {
    [7] = sym_block,
  },
  [90] = {
    [5] = sym_block,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0) ADVANCE(44);
      if (lookahead == '!') ADVANCE(24);
      if (lookahead == '#') ADVANCE(133);
      if (lookahead == '%') ADVANCE(70);
      if (lookahead == '&') ADVANCE(78);
      if (lookahead == '(') ADVANCE(47);
      if (lookahead == ')') ADVANCE(48);
      if (lookahead == '*') ADVANCE(51);
      if (lookahead == '+') ADVANCE(63);
      if (lookahead == ',') ADVANCE(49);
      if (lookahead == '-') ADVANCE(66);
      if (lookahead == '.') ADVANCE(46);
      if (lookahead == '/') ADVANCE(67);
      if (lookahead == '0') ADVANCE(122);
      if (lookahead == ':') ADVANCE(57);
      if (lookahead == ';') ADVANCE(134);
      if (lookahead == '<') ADVANCE(84);
      if (lookahead == '=') ADVANCE(59);
      if (lookahead == '>') ADVANCE(90);
      if (lookahead == '@') ADVANCE(61);
      if (lookahead == '[') ADVANCE(106);
      if (lookahead == '\\') SKIP(2)
      if (lookahead == ']') ADVANCE(107);
      if (lookahead == '^') ADVANCE(80);
      if (lookahead == '{') ADVANCE(109);
      if (lookahead == '|') ADVANCE(76);
      if (lookahead == '}') ADVANCE(110);
      if (lookahead == '~') ADVANCE(83);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(0)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(121);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(132);
      END_STATE();
    case 1:
      if (lookahead == 0) ADVANCE(44);
      if (lookahead == '\n') SKIP(0)
      END_STATE();
    case 2:
      if (lookahead == 0) ADVANCE(44);
      if (lookahead == '\n') SKIP(0)
      if (lookahead == '\r') SKIP(1)
      END_STATE();
    case 3:
      if (lookahead == 0) ADVANCE(44);
      if (lookahead == '\n') SKIP(5)
      END_STATE();
    case 4:
      if (lookahead == 0) ADVANCE(44);
      if (lookahead == '\n') SKIP(5)
      if (lookahead == '\r') SKIP(3)
      END_STATE();
    case 5:
      if (lookahead == 0) ADVANCE(44);
      if (lookahead == '!') ADVANCE(23);
      if (lookahead == '#') ADVANCE(133);
      if (lookahead == '%') ADVANCE(70);
      if (lookahead == '&') ADVANCE(78);
      if (lookahead == '(') ADVANCE(47);
      if (lookahead == ')') ADVANCE(48);
      if (lookahead == '*') ADVANCE(51);
      if (lookahead == '+') ADVANCE(63);
      if (lookahead == ',') ADVANCE(49);
      if (lookahead == '-') ADVANCE(65);
      if (lookahead == '.') ADVANCE(46);
      if (lookahead == '/') ADVANCE(67);
      if (lookahead == '0') ADVANCE(122);
      if (lookahead == ':') ADVANCE(56);
      if (lookahead == ';') ADVANCE(134);
      if (lookahead == '<') ADVANCE(84);
      if (lookahead == '=') ADVANCE(59);
      if (lookahead == '>') ADVANCE(90);
      if (lookahead == '@') ADVANCE(61);
      if (lookahead == '[') ADVANCE(106);
      if (lookahead == '\\') SKIP(4)
      if (lookahead == ']') ADVANCE(107);
      if (lookahead == '^') ADVANCE(80);
      if (lookahead == '{') ADVANCE(109);
      if (lookahead == '|') ADVANCE(76);
      if (lookahead == '}') ADVANCE(110);
      if (lookahead == '~') ADVANCE(83);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(5)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(121);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(132);
      END_STATE();
    case 6:
      if (lookahead == '\n') SKIP(17)
      END_STATE();
    case 7:
      if (lookahead == '\n') SKIP(17)
      if (lookahead == '\r') SKIP(6)
      END_STATE();
    case 8:
      if (lookahead == '\n') SKIP(18)
      END_STATE();
    case 9:
      if (lookahead == '\n') SKIP(18)
      if (lookahead == '\r') SKIP(8)
      END_STATE();
    case 10:
      if (lookahead == '\n') SKIP(16)
      END_STATE();
    case 11:
      if (lookahead == '\n') SKIP(16)
      if (lookahead == '\r') SKIP(10)
      END_STATE();
    case 12:
      if (lookahead == '\n') ADVANCE(113);
      if (lookahead == '\r') ADVANCE(112);
      if (lookahead == 'U') ADVANCE(114);
      if (lookahead == 'o') ADVANCE(35);
      if (lookahead == 'u') ADVANCE(41);
      if (lookahead == 'x') ADVANCE(39);
      if (lookahead != 0) ADVANCE(111);
      END_STATE();
    case 13:
      if (lookahead == '\n') SKIP(13)
      if (lookahead == '#') ADVANCE(117);
      if (lookahead == '\\') ADVANCE(115);
      if (lookahead == '{') ADVANCE(109);
      if (lookahead == '}') ADVANCE(110);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(116);
      if (lookahead != 0) ADVANCE(118);
      END_STATE();
    case 14:
      if (lookahead == '\n') SKIP(19)
      END_STATE();
    case 15:
      if (lookahead == '\n') SKIP(19)
      if (lookahead == '\r') SKIP(14)
      END_STATE();
    case 16:
      if (lookahead == '!') ADVANCE(24);
      if (lookahead == '#') ADVANCE(133);
      if (lookahead == '%') ADVANCE(69);
      if (lookahead == '&') ADVANCE(77);
      if (lookahead == '(') ADVANCE(47);
      if (lookahead == ')') ADVANCE(48);
      if (lookahead == '*') ADVANCE(52);
      if (lookahead == '+') ADVANCE(62);
      if (lookahead == ',') ADVANCE(49);
      if (lookahead == '-') ADVANCE(64);
      if (lookahead == '.') ADVANCE(45);
      if (lookahead == '/') ADVANCE(68);
      if (lookahead == ':') ADVANCE(57);
      if (lookahead == ';') ADVANCE(134);
      if (lookahead == '<') ADVANCE(85);
      if (lookahead == '=') ADVANCE(59);
      if (lookahead == '>') ADVANCE(91);
      if (lookahead == '@') ADVANCE(60);
      if (lookahead == '[') ADVANCE(106);
      if (lookahead == '\\') SKIP(11)
      if (lookahead == ']') ADVANCE(107);
      if (lookahead == '^') ADVANCE(79);
      if (lookahead == '|') ADVANCE(75);
      if (lookahead == '}') ADVANCE(110);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(16)
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(132);
      END_STATE();
    case 17:
      if (lookahead == '!') ADVANCE(23);
      if (lookahead == '#') ADVANCE(133);
      if (lookahead == '%') ADVANCE(70);
      if (lookahead == '&') ADVANCE(78);
      if (lookahead == '(') ADVANCE(47);
      if (lookahead == ')') ADVANCE(48);
      if (lookahead == '*') ADVANCE(51);
      if (lookahead == '+') ADVANCE(63);
      if (lookahead == ',') ADVANCE(49);
      if (lookahead == '-') ADVANCE(65);
      if (lookahead == '.') ADVANCE(45);
      if (lookahead == '/') ADVANCE(67);
      if (lookahead == ':') ADVANCE(57);
      if (lookahead == ';') ADVANCE(134);
      if (lookahead == '<') ADVANCE(84);
      if (lookahead == '=') ADVANCE(59);
      if (lookahead == '>') ADVANCE(90);
      if (lookahead == '@') ADVANCE(61);
      if (lookahead == '[') ADVANCE(106);
      if (lookahead == '\\') SKIP(7)
      if (lookahead == '^') ADVANCE(80);
      if (lookahead == '|') ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(17)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(132);
      END_STATE();
    case 18:
      if (lookahead == '#') ADVANCE(133);
      if (lookahead == '(') ADVANCE(47);
      if (lookahead == ')') ADVANCE(48);
      if (lookahead == '*') ADVANCE(50);
      if (lookahead == '+') ADVANCE(62);
      if (lookahead == ',') ADVANCE(49);
      if (lookahead == '-') ADVANCE(64);
      if (lookahead == '.') ADVANCE(21);
      if (lookahead == '0') ADVANCE(122);
      if (lookahead == ':') ADVANCE(56);
      if (lookahead == '[') ADVANCE(106);
      if (lookahead == '\\') SKIP(9)
      if (lookahead == ']') ADVANCE(107);
      if (lookahead == '{') ADVANCE(109);
      if (lookahead == '}') ADVANCE(110);
      if (lookahead == '~') ADVANCE(83);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(18)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(121);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(132);
      END_STATE();
    case 19:
      if (lookahead == '#') ADVANCE(133);
      if (lookahead == '-') ADVANCE(25);
      if (lookahead == ':') ADVANCE(56);
      if (lookahead == '\\') SKIP(15)
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(19)
      END_STATE();
    case 20:
      if (lookahead == '#') ADVANCE(133);
      if (lookahead == '\\') ADVANCE(12);
      if (lookahead == '{') ADVANCE(109);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(20)
      END_STATE();
    case 21:
      if (lookahead == '.') ADVANCE(22);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(128);
      END_STATE();
    case 22:
      if (lookahead == '.') ADVANCE(108);
      END_STATE();
    case 23:
      if (lookahead == '=') ADVANCE(88);
      END_STATE();
    case 24:
      if (lookahead == '=') ADVANCE(88);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(119);
      END_STATE();
    case 25:
      if (lookahead == '>') ADVANCE(58);
      END_STATE();
    case 26:
      if (lookahead == '_') ADVANCE(30);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(124);
      END_STATE();
    case 27:
      if (lookahead == '_') ADVANCE(31);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(125);
      END_STATE();
    case 28:
      if (lookahead == '_') ADVANCE(36);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(126);
      END_STATE();
    case 29:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(32);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(129);
      END_STATE();
    case 30:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(124);
      END_STATE();
    case 31:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(125);
      END_STATE();
    case 32:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(129);
      END_STATE();
    case 33:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(111);
      END_STATE();
    case 34:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(33);
      END_STATE();
    case 35:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(34);
      END_STATE();
    case 36:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(126);
      END_STATE();
    case 37:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(111);
      END_STATE();
    case 38:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(41);
      END_STATE();
    case 39:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(37);
      END_STATE();
    case 40:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(39);
      END_STATE();
    case 41:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(40);
      END_STATE();
    case 42:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(38);
      END_STATE();
    case 43:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(42);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(22);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(128);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(74);
      if (lookahead == '=') ADVANCE(95);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(73);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(101);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_COLON_EQ);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '=') ADVANCE(55);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(87);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == '=') ADVANCE(97);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(93);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(94);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(94);
      if (lookahead == '>') ADVANCE(58);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(72);
      if (lookahead == '=') ADVANCE(96);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(71);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(99);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      if (lookahead == '=') ADVANCE(98);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(100);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(105);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '=') ADVANCE(103);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(104);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(102);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(82);
      if (lookahead == '=') ADVANCE(86);
      if (lookahead == '>') ADVANCE(92);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(81);
      if (lookahead == '=') ADVANCE(86);
      if (lookahead == '>') ADVANCE(92);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(89);
      if (lookahead == '>') ADVANCE(54);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(89);
      if (lookahead == '>') ADVANCE(53);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_LT_GT);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_AT_EQ);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH_EQ);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(sym_ellipsis);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n') ADVANCE(113);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(12);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(43);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(aux_sym_format_specifier_token1);
      if (lookahead == '\r') ADVANCE(118);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(118);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(aux_sym_format_specifier_token1);
      if (lookahead == '#') ADVANCE(117);
      if (lookahead == '\\') ADVANCE(115);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(116);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(118);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(aux_sym_format_specifier_token1);
      if (lookahead == '{' ||
          lookahead == '}') ADVANCE(133);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(117);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(aux_sym_format_specifier_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(118);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(sym_type_conversion);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(sym_integer);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(130);
      if (lookahead == '_') ADVANCE(123);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(29);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(120);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(121);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(130);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(26);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(27);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(28);
      if (lookahead == '_') ADVANCE(123);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(29);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(120);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(121);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(130);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(29);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(120);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(121);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(30);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(124);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(120);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(31);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(120);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(125);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(36);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(120);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(126);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(sym_float);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(130);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(29);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(127);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(128);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(131);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(127);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(129);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(29);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(127);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(128);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(127);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(129);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(132);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(133);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(sym__semicolon);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 'F') ADVANCE(1);
      if (lookahead == 'N') ADVANCE(2);
      if (lookahead == 'T') ADVANCE(3);
      if (lookahead == '\\') SKIP(4)
      if (lookahead == '_') ADVANCE(5);
      if (lookahead == 'a') ADVANCE(6);
      if (lookahead == 'b') ADVANCE(7);
      if (lookahead == 'c') ADVANCE(8);
      if (lookahead == 'd') ADVANCE(9);
      if (lookahead == 'e') ADVANCE(10);
      if (lookahead == 'f') ADVANCE(11);
      if (lookahead == 'g') ADVANCE(12);
      if (lookahead == 'i') ADVANCE(13);
      if (lookahead == 'l') ADVANCE(14);
      if (lookahead == 'n') ADVANCE(15);
      if (lookahead == 'o') ADVANCE(16);
      if (lookahead == 'p') ADVANCE(17);
      if (lookahead == 'r') ADVANCE(18);
      if (lookahead == 't') ADVANCE(19);
      if (lookahead == 'w') ADVANCE(20);
      if (lookahead == 'y') ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'a') ADVANCE(22);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(23);
      END_STATE();
    case 3:
      if (lookahead == 'r') ADVANCE(24);
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(0)
      if (lookahead == '\r') SKIP(25)
      END_STATE();
    case 5:
      if (lookahead == '_') ADVANCE(26);
      END_STATE();
    case 6:
      if (lookahead == 'n') ADVANCE(27);
      if (lookahead == 's') ADVANCE(28);
      if (lookahead == 'w') ADVANCE(29);
      END_STATE();
    case 7:
      if (lookahead == 'r') ADVANCE(30);
      END_STATE();
    case 8:
      if (lookahead == 'l') ADVANCE(31);
      if (lookahead == 'o') ADVANCE(32);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(33);
      END_STATE();
    case 10:
      if (lookahead == 'l') ADVANCE(34);
      if (lookahead == 'x') ADVANCE(35);
      END_STATE();
    case 11:
      if (lookahead == 'i') ADVANCE(36);
      if (lookahead == 'o') ADVANCE(37);
      if (lookahead == 'r') ADVANCE(38);
      END_STATE();
    case 12:
      if (lookahead == 'l') ADVANCE(39);
      END_STATE();
    case 13:
      if (lookahead == 'f') ADVANCE(40);
      if (lookahead == 'm') ADVANCE(41);
      if (lookahead == 'n') ADVANCE(42);
      if (lookahead == 's') ADVANCE(43);
      END_STATE();
    case 14:
      if (lookahead == 'a') ADVANCE(44);
      END_STATE();
    case 15:
      if (lookahead == 'o') ADVANCE(45);
      END_STATE();
    case 16:
      if (lookahead == 'r') ADVANCE(46);
      END_STATE();
    case 17:
      if (lookahead == 'a') ADVANCE(47);
      if (lookahead == 'r') ADVANCE(48);
      END_STATE();
    case 18:
      if (lookahead == 'a') ADVANCE(49);
      if (lookahead == 'e') ADVANCE(50);
      END_STATE();
    case 19:
      if (lookahead == 'r') ADVANCE(51);
      END_STATE();
    case 20:
      if (lookahead == 'h') ADVANCE(52);
      if (lookahead == 'i') ADVANCE(53);
      END_STATE();
    case 21:
      if (lookahead == 'i') ADVANCE(54);
      END_STATE();
    case 22:
      if (lookahead == 'l') ADVANCE(55);
      END_STATE();
    case 23:
      if (lookahead == 'n') ADVANCE(56);
      END_STATE();
    case 24:
      if (lookahead == 'u') ADVANCE(57);
      END_STATE();
    case 25:
      if (lookahead == '\n') SKIP(0)
      END_STATE();
    case 26:
      if (lookahead == 'f') ADVANCE(58);
      END_STATE();
    case 27:
      if (lookahead == 'd') ADVANCE(59);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 's') ADVANCE(60);
      if (lookahead == 'y') ADVANCE(61);
      END_STATE();
    case 29:
      if (lookahead == 'a') ADVANCE(62);
      END_STATE();
    case 30:
      if (lookahead == 'e') ADVANCE(63);
      END_STATE();
    case 31:
      if (lookahead == 'a') ADVANCE(64);
      END_STATE();
    case 32:
      if (lookahead == 'n') ADVANCE(65);
      END_STATE();
    case 33:
      if (lookahead == 'f') ADVANCE(66);
      if (lookahead == 'l') ADVANCE(67);
      END_STATE();
    case 34:
      if (lookahead == 'i') ADVANCE(68);
      if (lookahead == 's') ADVANCE(69);
      END_STATE();
    case 35:
      if (lookahead == 'c') ADVANCE(70);
      if (lookahead == 'e') ADVANCE(71);
      END_STATE();
    case 36:
      if (lookahead == 'n') ADVANCE(72);
      END_STATE();
    case 37:
      if (lookahead == 'r') ADVANCE(73);
      END_STATE();
    case 38:
      if (lookahead == 'o') ADVANCE(74);
      END_STATE();
    case 39:
      if (lookahead == 'o') ADVANCE(75);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 41:
      if (lookahead == 'p') ADVANCE(76);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 44:
      if (lookahead == 'm') ADVANCE(77);
      END_STATE();
    case 45:
      if (lookahead == 'n') ADVANCE(78);
      if (lookahead == 't') ADVANCE(79);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 47:
      if (lookahead == 's') ADVANCE(80);
      END_STATE();
    case 48:
      if (lookahead == 'i') ADVANCE(81);
      END_STATE();
    case 49:
      if (lookahead == 'i') ADVANCE(82);
      END_STATE();
    case 50:
      if (lookahead == 't') ADVANCE(83);
      END_STATE();
    case 51:
      if (lookahead == 'y') ADVANCE(84);
      END_STATE();
    case 52:
      if (lookahead == 'i') ADVANCE(85);
      END_STATE();
    case 53:
      if (lookahead == 't') ADVANCE(86);
      END_STATE();
    case 54:
      if (lookahead == 'e') ADVANCE(87);
      END_STATE();
    case 55:
      if (lookahead == 's') ADVANCE(88);
      END_STATE();
    case 56:
      if (lookahead == 'e') ADVANCE(89);
      END_STATE();
    case 57:
      if (lookahead == 'e') ADVANCE(90);
      END_STATE();
    case 58:
      if (lookahead == 'u') ADVANCE(91);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 60:
      if (lookahead == 'e') ADVANCE(92);
      END_STATE();
    case 61:
      if (lookahead == 'n') ADVANCE(93);
      END_STATE();
    case 62:
      if (lookahead == 'i') ADVANCE(94);
      END_STATE();
    case 63:
      if (lookahead == 'a') ADVANCE(95);
      END_STATE();
    case 64:
      if (lookahead == 's') ADVANCE(96);
      END_STATE();
    case 65:
      if (lookahead == 't') ADVANCE(97);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_def);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_del);
      END_STATE();
    case 68:
      if (lookahead == 'f') ADVANCE(98);
      END_STATE();
    case 69:
      if (lookahead == 'e') ADVANCE(99);
      END_STATE();
    case 70:
      if (lookahead == 'e') ADVANCE(100);
      END_STATE();
    case 71:
      if (lookahead == 'c') ADVANCE(101);
      END_STATE();
    case 72:
      if (lookahead == 'a') ADVANCE(102);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 74:
      if (lookahead == 'm') ADVANCE(103);
      END_STATE();
    case 75:
      if (lookahead == 'b') ADVANCE(104);
      END_STATE();
    case 76:
      if (lookahead == 'o') ADVANCE(105);
      END_STATE();
    case 77:
      if (lookahead == 'b') ADVANCE(106);
      END_STATE();
    case 78:
      if (lookahead == 'l') ADVANCE(107);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 80:
      if (lookahead == 's') ADVANCE(108);
      END_STATE();
    case 81:
      if (lookahead == 'n') ADVANCE(109);
      END_STATE();
    case 82:
      if (lookahead == 's') ADVANCE(110);
      END_STATE();
    case 83:
      if (lookahead == 'u') ADVANCE(111);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 85:
      if (lookahead == 'l') ADVANCE(112);
      END_STATE();
    case 86:
      if (lookahead == 'h') ADVANCE(113);
      END_STATE();
    case 87:
      if (lookahead == 'l') ADVANCE(114);
      END_STATE();
    case 88:
      if (lookahead == 'e') ADVANCE(115);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym_none);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 91:
      if (lookahead == 't') ADVANCE(116);
      END_STATE();
    case 92:
      if (lookahead == 'r') ADVANCE(117);
      END_STATE();
    case 93:
      if (lookahead == 'c') ADVANCE(118);
      END_STATE();
    case 94:
      if (lookahead == 't') ADVANCE(119);
      END_STATE();
    case 95:
      if (lookahead == 'k') ADVANCE(120);
      END_STATE();
    case 96:
      if (lookahead == 's') ADVANCE(121);
      END_STATE();
    case 97:
      if (lookahead == 'i') ADVANCE(122);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_elif);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 100:
      if (lookahead == 'p') ADVANCE(123);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_exec);
      END_STATE();
    case 102:
      if (lookahead == 'l') ADVANCE(124);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 104:
      if (lookahead == 'a') ADVANCE(125);
      END_STATE();
    case 105:
      if (lookahead == 'r') ADVANCE(126);
      END_STATE();
    case 106:
      if (lookahead == 'd') ADVANCE(127);
      END_STATE();
    case 107:
      if (lookahead == 'o') ADVANCE(128);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_pass);
      END_STATE();
    case 109:
      if (lookahead == 't') ADVANCE(129);
      END_STATE();
    case 110:
      if (lookahead == 'e') ADVANCE(130);
      END_STATE();
    case 111:
      if (lookahead == 'r') ADVANCE(131);
      END_STATE();
    case 112:
      if (lookahead == 'e') ADVANCE(132);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 114:
      if (lookahead == 'd') ADVANCE(133);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 116:
      if (lookahead == 'u') ADVANCE(134);
      END_STATE();
    case 117:
      if (lookahead == 't') ADVANCE(135);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 122:
      if (lookahead == 'n') ADVANCE(136);
      END_STATE();
    case 123:
      if (lookahead == 't') ADVANCE(137);
      END_STATE();
    case 124:
      if (lookahead == 'l') ADVANCE(138);
      END_STATE();
    case 125:
      if (lookahead == 'l') ADVANCE(139);
      END_STATE();
    case 126:
      if (lookahead == 't') ADVANCE(140);
      END_STATE();
    case 127:
      if (lookahead == 'a') ADVANCE(141);
      END_STATE();
    case 128:
      if (lookahead == 'c') ADVANCE(142);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_print);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_raise);
      END_STATE();
    case 131:
      if (lookahead == 'n') ADVANCE(143);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 134:
      if (lookahead == 'r') ADVANCE(144);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_assert);
      END_STATE();
    case 136:
      if (lookahead == 'u') ADVANCE(145);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_except);
      END_STATE();
    case 138:
      if (lookahead == 'y') ADVANCE(146);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_lambda);
      END_STATE();
    case 142:
      if (lookahead == 'a') ADVANCE(147);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 144:
      if (lookahead == 'e') ADVANCE(148);
      END_STATE();
    case 145:
      if (lookahead == 'e') ADVANCE(149);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 147:
      if (lookahead == 'l') ADVANCE(150);
      END_STATE();
    case 148:
      if (lookahead == '_') ADVANCE(151);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_nonlocal);
      END_STATE();
    case 151:
      if (lookahead == '_') ADVANCE(152);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym___future__);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 5, .external_lex_state = 2},
  [2] = {.lex_state = 5, .external_lex_state = 3},
  [3] = {.lex_state = 5, .external_lex_state = 3},
  [4] = {.lex_state = 5, .external_lex_state = 3},
  [5] = {.lex_state = 5, .external_lex_state = 3},
  [6] = {.lex_state = 5, .external_lex_state = 3},
  [7] = {.lex_state = 5, .external_lex_state = 3},
  [8] = {.lex_state = 5, .external_lex_state = 3},
  [9] = {.lex_state = 5, .external_lex_state = 3},
  [10] = {.lex_state = 5, .external_lex_state = 3},
  [11] = {.lex_state = 5, .external_lex_state = 3},
  [12] = {.lex_state = 5, .external_lex_state = 3},
  [13] = {.lex_state = 5, .external_lex_state = 3},
  [14] = {.lex_state = 5, .external_lex_state = 3},
  [15] = {.lex_state = 5, .external_lex_state = 3},
  [16] = {.lex_state = 5, .external_lex_state = 3},
  [17] = {.lex_state = 5, .external_lex_state = 3},
  [18] = {.lex_state = 5, .external_lex_state = 3},
  [19] = {.lex_state = 5, .external_lex_state = 3},
  [20] = {.lex_state = 5, .external_lex_state = 3},
  [21] = {.lex_state = 5, .external_lex_state = 3},
  [22] = {.lex_state = 5, .external_lex_state = 3},
  [23] = {.lex_state = 5, .external_lex_state = 3},
  [24] = {.lex_state = 5, .external_lex_state = 3},
  [25] = {.lex_state = 5, .external_lex_state = 3},
  [26] = {.lex_state = 5, .external_lex_state = 3},
  [27] = {.lex_state = 5, .external_lex_state = 3},
  [28] = {.lex_state = 5, .external_lex_state = 3},
  [29] = {.lex_state = 5, .external_lex_state = 3},
  [30] = {.lex_state = 5, .external_lex_state = 3},
  [31] = {.lex_state = 5, .external_lex_state = 3},
  [32] = {.lex_state = 5, .external_lex_state = 3},
  [33] = {.lex_state = 5, .external_lex_state = 3},
  [34] = {.lex_state = 5, .external_lex_state = 3},
  [35] = {.lex_state = 5, .external_lex_state = 3},
  [36] = {.lex_state = 5, .external_lex_state = 3},
  [37] = {.lex_state = 5, .external_lex_state = 3},
  [38] = {.lex_state = 5, .external_lex_state = 3},
  [39] = {.lex_state = 5, .external_lex_state = 3},
  [40] = {.lex_state = 5, .external_lex_state = 3},
  [41] = {.lex_state = 5, .external_lex_state = 3},
  [42] = {.lex_state = 5, .external_lex_state = 2},
  [43] = {.lex_state = 5, .external_lex_state = 3},
  [44] = {.lex_state = 5, .external_lex_state = 3},
  [45] = {.lex_state = 5, .external_lex_state = 3},
  [46] = {.lex_state = 5, .external_lex_state = 2},
  [47] = {.lex_state = 5, .external_lex_state = 3},
  [48] = {.lex_state = 5, .external_lex_state = 4},
  [49] = {.lex_state = 5, .external_lex_state = 5},
  [50] = {.lex_state = 5, .external_lex_state = 5},
  [51] = {.lex_state = 5, .external_lex_state = 5},
  [52] = {.lex_state = 5, .external_lex_state = 5},
  [53] = {.lex_state = 5, .external_lex_state = 5},
  [54] = {.lex_state = 5, .external_lex_state = 5},
  [55] = {.lex_state = 5, .external_lex_state = 5},
  [56] = {.lex_state = 5, .external_lex_state = 5},
  [57] = {.lex_state = 5, .external_lex_state = 5},
  [58] = {.lex_state = 5, .external_lex_state = 5},
  [59] = {.lex_state = 5, .external_lex_state = 5},
  [60] = {.lex_state = 5, .external_lex_state = 5},
  [61] = {.lex_state = 5, .external_lex_state = 5},
  [62] = {.lex_state = 5, .external_lex_state = 5},
  [63] = {.lex_state = 5, .external_lex_state = 5},
  [64] = {.lex_state = 5, .external_lex_state = 5},
  [65] = {.lex_state = 5, .external_lex_state = 5},
  [66] = {.lex_state = 5, .external_lex_state = 5},
  [67] = {.lex_state = 5, .external_lex_state = 5},
  [68] = {.lex_state = 5, .external_lex_state = 5},
  [69] = {.lex_state = 5, .external_lex_state = 5},
  [70] = {.lex_state = 5, .external_lex_state = 5},
  [71] = {.lex_state = 5, .external_lex_state = 5},
  [72] = {.lex_state = 5, .external_lex_state = 5},
  [73] = {.lex_state = 5, .external_lex_state = 5},
  [74] = {.lex_state = 5, .external_lex_state = 5},
  [75] = {.lex_state = 5, .external_lex_state = 5},
  [76] = {.lex_state = 5, .external_lex_state = 5},
  [77] = {.lex_state = 5, .external_lex_state = 5},
  [78] = {.lex_state = 5, .external_lex_state = 5},
  [79] = {.lex_state = 5, .external_lex_state = 5},
  [80] = {.lex_state = 5, .external_lex_state = 5},
  [81] = {.lex_state = 5, .external_lex_state = 5},
  [82] = {.lex_state = 5, .external_lex_state = 5},
  [83] = {.lex_state = 5, .external_lex_state = 5},
  [84] = {.lex_state = 5, .external_lex_state = 5},
  [85] = {.lex_state = 5, .external_lex_state = 5},
  [86] = {.lex_state = 5, .external_lex_state = 5},
  [87] = {.lex_state = 5, .external_lex_state = 5},
  [88] = {.lex_state = 5, .external_lex_state = 5},
  [89] = {.lex_state = 5, .external_lex_state = 4},
  [90] = {.lex_state = 5, .external_lex_state = 4},
  [91] = {.lex_state = 5, .external_lex_state = 4},
  [92] = {.lex_state = 5, .external_lex_state = 4},
  [93] = {.lex_state = 5, .external_lex_state = 4},
  [94] = {.lex_state = 5, .external_lex_state = 4},
  [95] = {.lex_state = 5, .external_lex_state = 2},
  [96] = {.lex_state = 5, .external_lex_state = 4},
  [97] = {.lex_state = 5, .external_lex_state = 4},
  [98] = {.lex_state = 5, .external_lex_state = 4},
  [99] = {.lex_state = 5, .external_lex_state = 4},
  [100] = {.lex_state = 5, .external_lex_state = 2},
  [101] = {.lex_state = 5, .external_lex_state = 2},
  [102] = {.lex_state = 5, .external_lex_state = 2},
  [103] = {.lex_state = 5, .external_lex_state = 2},
  [104] = {.lex_state = 17, .external_lex_state = 4},
  [105] = {.lex_state = 18, .external_lex_state = 2},
  [106] = {.lex_state = 18, .external_lex_state = 2},
  [107] = {.lex_state = 18, .external_lex_state = 2},
  [108] = {.lex_state = 18, .external_lex_state = 2},
  [109] = {.lex_state = 17, .external_lex_state = 4},
  [110] = {.lex_state = 18, .external_lex_state = 2},
  [111] = {.lex_state = 5, .external_lex_state = 2},
  [112] = {.lex_state = 18, .external_lex_state = 2},
  [113] = {.lex_state = 17, .external_lex_state = 4},
  [114] = {.lex_state = 18, .external_lex_state = 2},
  [115] = {.lex_state = 5, .external_lex_state = 2},
  [116] = {.lex_state = 5, .external_lex_state = 2},
  [117] = {.lex_state = 18, .external_lex_state = 2},
  [118] = {.lex_state = 18, .external_lex_state = 2},
  [119] = {.lex_state = 18, .external_lex_state = 2},
  [120] = {.lex_state = 17, .external_lex_state = 6},
  [121] = {.lex_state = 17, .external_lex_state = 6},
  [122] = {.lex_state = 18, .external_lex_state = 2},
  [123] = {.lex_state = 18, .external_lex_state = 2},
  [124] = {.lex_state = 17, .external_lex_state = 6},
  [125] = {.lex_state = 18, .external_lex_state = 2},
  [126] = {.lex_state = 17, .external_lex_state = 6},
  [127] = {.lex_state = 17, .external_lex_state = 6},
  [128] = {.lex_state = 17, .external_lex_state = 6},
  [129] = {.lex_state = 17, .external_lex_state = 6},
  [130] = {.lex_state = 17, .external_lex_state = 6},
  [131] = {.lex_state = 18, .external_lex_state = 2},
  [132] = {.lex_state = 17, .external_lex_state = 6},
  [133] = {.lex_state = 18, .external_lex_state = 2},
  [134] = {.lex_state = 17, .external_lex_state = 6},
  [135] = {.lex_state = 17, .external_lex_state = 6},
  [136] = {.lex_state = 18, .external_lex_state = 2},
  [137] = {.lex_state = 17, .external_lex_state = 4},
  [138] = {.lex_state = 18, .external_lex_state = 2},
  [139] = {.lex_state = 18, .external_lex_state = 2},
  [140] = {.lex_state = 18, .external_lex_state = 2},
  [141] = {.lex_state = 18, .external_lex_state = 2},
  [142] = {.lex_state = 5, .external_lex_state = 4},
  [143] = {.lex_state = 5, .external_lex_state = 2},
  [144] = {.lex_state = 5, .external_lex_state = 2},
  [145] = {.lex_state = 18, .external_lex_state = 2},
  [146] = {.lex_state = 18, .external_lex_state = 2},
  [147] = {.lex_state = 18, .external_lex_state = 2},
  [148] = {.lex_state = 18, .external_lex_state = 2},
  [149] = {.lex_state = 5, .external_lex_state = 2},
  [150] = {.lex_state = 5, .external_lex_state = 3},
  [151] = {.lex_state = 5, .external_lex_state = 2},
  [152] = {.lex_state = 17, .external_lex_state = 4},
  [153] = {.lex_state = 18, .external_lex_state = 2},
  [154] = {.lex_state = 18, .external_lex_state = 2},
  [155] = {.lex_state = 5, .external_lex_state = 2},
  [156] = {.lex_state = 18, .external_lex_state = 2},
  [157] = {.lex_state = 5, .external_lex_state = 2},
  [158] = {.lex_state = 18, .external_lex_state = 2},
  [159] = {.lex_state = 5, .external_lex_state = 2},
  [160] = {.lex_state = 17, .external_lex_state = 4},
  [161] = {.lex_state = 18, .external_lex_state = 2},
  [162] = {.lex_state = 18, .external_lex_state = 2},
  [163] = {.lex_state = 17, .external_lex_state = 6},
  [164] = {.lex_state = 5, .external_lex_state = 3},
  [165] = {.lex_state = 5, .external_lex_state = 2},
  [166] = {.lex_state = 18, .external_lex_state = 2},
  [167] = {.lex_state = 5, .external_lex_state = 4},
  [168] = {.lex_state = 18, .external_lex_state = 2},
  [169] = {.lex_state = 18, .external_lex_state = 2},
  [170] = {.lex_state = 18, .external_lex_state = 2},
  [171] = {.lex_state = 5, .external_lex_state = 2},
  [172] = {.lex_state = 5, .external_lex_state = 4},
  [173] = {.lex_state = 17, .external_lex_state = 6},
  [174] = {.lex_state = 18, .external_lex_state = 2},
  [175] = {.lex_state = 18, .external_lex_state = 2},
  [176] = {.lex_state = 17, .external_lex_state = 6},
  [177] = {.lex_state = 5, .external_lex_state = 4},
  [178] = {.lex_state = 5, .external_lex_state = 2},
  [179] = {.lex_state = 18, .external_lex_state = 2},
  [180] = {.lex_state = 17, .external_lex_state = 6},
  [181] = {.lex_state = 18, .external_lex_state = 2},
  [182] = {.lex_state = 17, .external_lex_state = 6},
  [183] = {.lex_state = 5, .external_lex_state = 2},
  [184] = {.lex_state = 17, .external_lex_state = 6},
  [185] = {.lex_state = 17, .external_lex_state = 6},
  [186] = {.lex_state = 5, .external_lex_state = 2},
  [187] = {.lex_state = 17, .external_lex_state = 6},
  [188] = {.lex_state = 5, .external_lex_state = 2},
  [189] = {.lex_state = 18, .external_lex_state = 2},
  [190] = {.lex_state = 5, .external_lex_state = 2},
  [191] = {.lex_state = 17, .external_lex_state = 6},
  [192] = {.lex_state = 17, .external_lex_state = 6},
  [193] = {.lex_state = 5, .external_lex_state = 2},
  [194] = {.lex_state = 5, .external_lex_state = 2},
  [195] = {.lex_state = 18, .external_lex_state = 2},
  [196] = {.lex_state = 18, .external_lex_state = 2},
  [197] = {.lex_state = 5, .external_lex_state = 2},
  [198] = {.lex_state = 5, .external_lex_state = 2},
  [199] = {.lex_state = 17, .external_lex_state = 6},
  [200] = {.lex_state = 5, .external_lex_state = 2},
  [201] = {.lex_state = 18, .external_lex_state = 2},
  [202] = {.lex_state = 17, .external_lex_state = 6},
  [203] = {.lex_state = 17, .external_lex_state = 6},
  [204] = {.lex_state = 5, .external_lex_state = 2},
  [205] = {.lex_state = 5, .external_lex_state = 2},
  [206] = {.lex_state = 5, .external_lex_state = 2},
  [207] = {.lex_state = 5, .external_lex_state = 2},
  [208] = {.lex_state = 18, .external_lex_state = 2},
  [209] = {.lex_state = 5, .external_lex_state = 2},
  [210] = {.lex_state = 18, .external_lex_state = 2},
  [211] = {.lex_state = 18, .external_lex_state = 2},
  [212] = {.lex_state = 17, .external_lex_state = 6},
  [213] = {.lex_state = 17, .external_lex_state = 6},
  [214] = {.lex_state = 18, .external_lex_state = 2},
  [215] = {.lex_state = 17, .external_lex_state = 6},
  [216] = {.lex_state = 5, .external_lex_state = 2},
  [217] = {.lex_state = 17, .external_lex_state = 6},
  [218] = {.lex_state = 18, .external_lex_state = 2},
  [219] = {.lex_state = 17, .external_lex_state = 6},
  [220] = {.lex_state = 5, .external_lex_state = 4},
  [221] = {.lex_state = 17, .external_lex_state = 6},
  [222] = {.lex_state = 17, .external_lex_state = 6},
  [223] = {.lex_state = 17, .external_lex_state = 6},
  [224] = {.lex_state = 17, .external_lex_state = 6},
  [225] = {.lex_state = 5, .external_lex_state = 2},
  [226] = {.lex_state = 17, .external_lex_state = 6},
  [227] = {.lex_state = 17, .external_lex_state = 6},
  [228] = {.lex_state = 5, .external_lex_state = 2},
  [229] = {.lex_state = 18, .external_lex_state = 2},
  [230] = {.lex_state = 17, .external_lex_state = 6},
  [231] = {.lex_state = 17, .external_lex_state = 6},
  [232] = {.lex_state = 17, .external_lex_state = 6},
  [233] = {.lex_state = 5, .external_lex_state = 2},
  [234] = {.lex_state = 17, .external_lex_state = 6},
  [235] = {.lex_state = 17, .external_lex_state = 6},
  [236] = {.lex_state = 18, .external_lex_state = 2},
  [237] = {.lex_state = 17, .external_lex_state = 6},
  [238] = {.lex_state = 17, .external_lex_state = 6},
  [239] = {.lex_state = 5, .external_lex_state = 2},
  [240] = {.lex_state = 17, .external_lex_state = 6},
  [241] = {.lex_state = 5, .external_lex_state = 2},
  [242] = {.lex_state = 5, .external_lex_state = 2},
  [243] = {.lex_state = 5, .external_lex_state = 3},
  [244] = {.lex_state = 5, .external_lex_state = 2},
  [245] = {.lex_state = 5, .external_lex_state = 2},
  [246] = {.lex_state = 5, .external_lex_state = 2},
  [247] = {.lex_state = 5, .external_lex_state = 2},
  [248] = {.lex_state = 5, .external_lex_state = 3},
  [249] = {.lex_state = 5, .external_lex_state = 3},
  [250] = {.lex_state = 5, .external_lex_state = 2},
  [251] = {.lex_state = 5, .external_lex_state = 2},
  [252] = {.lex_state = 5, .external_lex_state = 2},
  [253] = {.lex_state = 5, .external_lex_state = 2},
  [254] = {.lex_state = 5, .external_lex_state = 2},
  [255] = {.lex_state = 5, .external_lex_state = 2},
  [256] = {.lex_state = 5, .external_lex_state = 2},
  [257] = {.lex_state = 5, .external_lex_state = 4},
  [258] = {.lex_state = 5, .external_lex_state = 2},
  [259] = {.lex_state = 5, .external_lex_state = 4},
  [260] = {.lex_state = 5, .external_lex_state = 3},
  [261] = {.lex_state = 5, .external_lex_state = 4},
  [262] = {.lex_state = 18, .external_lex_state = 2},
  [263] = {.lex_state = 5, .external_lex_state = 4},
  [264] = {.lex_state = 5, .external_lex_state = 2},
  [265] = {.lex_state = 5, .external_lex_state = 2},
  [266] = {.lex_state = 5, .external_lex_state = 2},
  [267] = {.lex_state = 5, .external_lex_state = 2},
  [268] = {.lex_state = 5, .external_lex_state = 2},
  [269] = {.lex_state = 5, .external_lex_state = 3},
  [270] = {.lex_state = 5, .external_lex_state = 2},
  [271] = {.lex_state = 5, .external_lex_state = 2},
  [272] = {.lex_state = 5, .external_lex_state = 3},
  [273] = {.lex_state = 5, .external_lex_state = 2},
  [274] = {.lex_state = 5, .external_lex_state = 3},
  [275] = {.lex_state = 5, .external_lex_state = 2},
  [276] = {.lex_state = 5, .external_lex_state = 2},
  [277] = {.lex_state = 5, .external_lex_state = 2},
  [278] = {.lex_state = 5, .external_lex_state = 2},
  [279] = {.lex_state = 5, .external_lex_state = 2},
  [280] = {.lex_state = 5, .external_lex_state = 2},
  [281] = {.lex_state = 5, .external_lex_state = 2},
  [282] = {.lex_state = 5, .external_lex_state = 2},
  [283] = {.lex_state = 5, .external_lex_state = 3},
  [284] = {.lex_state = 5, .external_lex_state = 2},
  [285] = {.lex_state = 5, .external_lex_state = 2},
  [286] = {.lex_state = 5, .external_lex_state = 2},
  [287] = {.lex_state = 5, .external_lex_state = 2},
  [288] = {.lex_state = 5, .external_lex_state = 2},
  [289] = {.lex_state = 5, .external_lex_state = 2},
  [290] = {.lex_state = 5, .external_lex_state = 2},
  [291] = {.lex_state = 5, .external_lex_state = 2},
  [292] = {.lex_state = 5, .external_lex_state = 2},
  [293] = {.lex_state = 5, .external_lex_state = 2},
  [294] = {.lex_state = 5, .external_lex_state = 2},
  [295] = {.lex_state = 5, .external_lex_state = 3},
  [296] = {.lex_state = 5, .external_lex_state = 2},
  [297] = {.lex_state = 5, .external_lex_state = 3},
  [298] = {.lex_state = 5, .external_lex_state = 3},
  [299] = {.lex_state = 5, .external_lex_state = 2},
  [300] = {.lex_state = 5, .external_lex_state = 2},
  [301] = {.lex_state = 5, .external_lex_state = 2},
  [302] = {.lex_state = 5, .external_lex_state = 2},
  [303] = {.lex_state = 5, .external_lex_state = 2},
  [304] = {.lex_state = 5, .external_lex_state = 2},
  [305] = {.lex_state = 5, .external_lex_state = 2},
  [306] = {.lex_state = 5, .external_lex_state = 3},
  [307] = {.lex_state = 5, .external_lex_state = 2},
  [308] = {.lex_state = 5, .external_lex_state = 2},
  [309] = {.lex_state = 5, .external_lex_state = 2},
  [310] = {.lex_state = 5, .external_lex_state = 2},
  [311] = {.lex_state = 5, .external_lex_state = 2},
  [312] = {.lex_state = 5, .external_lex_state = 2},
  [313] = {.lex_state = 5, .external_lex_state = 2},
  [314] = {.lex_state = 5, .external_lex_state = 2},
  [315] = {.lex_state = 5, .external_lex_state = 2},
  [316] = {.lex_state = 5, .external_lex_state = 2},
  [317] = {.lex_state = 5, .external_lex_state = 2},
  [318] = {.lex_state = 5, .external_lex_state = 2},
  [319] = {.lex_state = 5, .external_lex_state = 2},
  [320] = {.lex_state = 5, .external_lex_state = 2},
  [321] = {.lex_state = 5, .external_lex_state = 2},
  [322] = {.lex_state = 5, .external_lex_state = 3},
  [323] = {.lex_state = 5, .external_lex_state = 2},
  [324] = {.lex_state = 5, .external_lex_state = 2},
  [325] = {.lex_state = 5, .external_lex_state = 2},
  [326] = {.lex_state = 5, .external_lex_state = 2},
  [327] = {.lex_state = 5, .external_lex_state = 2},
  [328] = {.lex_state = 5, .external_lex_state = 2},
  [329] = {.lex_state = 5, .external_lex_state = 2},
  [330] = {.lex_state = 5, .external_lex_state = 2},
  [331] = {.lex_state = 5, .external_lex_state = 2},
  [332] = {.lex_state = 5, .external_lex_state = 2},
  [333] = {.lex_state = 5, .external_lex_state = 2},
  [334] = {.lex_state = 5, .external_lex_state = 2},
  [335] = {.lex_state = 5, .external_lex_state = 2},
  [336] = {.lex_state = 5, .external_lex_state = 3},
  [337] = {.lex_state = 5, .external_lex_state = 2},
  [338] = {.lex_state = 5, .external_lex_state = 3},
  [339] = {.lex_state = 5, .external_lex_state = 2},
  [340] = {.lex_state = 5, .external_lex_state = 2},
  [341] = {.lex_state = 5, .external_lex_state = 2},
  [342] = {.lex_state = 5, .external_lex_state = 2},
  [343] = {.lex_state = 5, .external_lex_state = 2},
  [344] = {.lex_state = 5, .external_lex_state = 2},
  [345] = {.lex_state = 5, .external_lex_state = 2},
  [346] = {.lex_state = 5, .external_lex_state = 2},
  [347] = {.lex_state = 5, .external_lex_state = 2},
  [348] = {.lex_state = 5, .external_lex_state = 2},
  [349] = {.lex_state = 5, .external_lex_state = 2},
  [350] = {.lex_state = 5, .external_lex_state = 2},
  [351] = {.lex_state = 5, .external_lex_state = 2},
  [352] = {.lex_state = 5, .external_lex_state = 2},
  [353] = {.lex_state = 5, .external_lex_state = 2},
  [354] = {.lex_state = 5, .external_lex_state = 2},
  [355] = {.lex_state = 5, .external_lex_state = 2},
  [356] = {.lex_state = 5, .external_lex_state = 3},
  [357] = {.lex_state = 5, .external_lex_state = 2},
  [358] = {.lex_state = 5, .external_lex_state = 2},
  [359] = {.lex_state = 5, .external_lex_state = 2},
  [360] = {.lex_state = 5, .external_lex_state = 2},
  [361] = {.lex_state = 5, .external_lex_state = 2},
  [362] = {.lex_state = 5, .external_lex_state = 2},
  [363] = {.lex_state = 5, .external_lex_state = 2},
  [364] = {.lex_state = 5, .external_lex_state = 2},
  [365] = {.lex_state = 5, .external_lex_state = 2},
  [366] = {.lex_state = 5, .external_lex_state = 2},
  [367] = {.lex_state = 5, .external_lex_state = 2},
  [368] = {.lex_state = 5, .external_lex_state = 2},
  [369] = {.lex_state = 5, .external_lex_state = 2},
  [370] = {.lex_state = 5, .external_lex_state = 3},
  [371] = {.lex_state = 5, .external_lex_state = 2},
  [372] = {.lex_state = 5, .external_lex_state = 2},
  [373] = {.lex_state = 5, .external_lex_state = 2},
  [374] = {.lex_state = 5, .external_lex_state = 2},
  [375] = {.lex_state = 5, .external_lex_state = 2},
  [376] = {.lex_state = 5, .external_lex_state = 2},
  [377] = {.lex_state = 5, .external_lex_state = 2},
  [378] = {.lex_state = 5, .external_lex_state = 2},
  [379] = {.lex_state = 5, .external_lex_state = 2},
  [380] = {.lex_state = 5, .external_lex_state = 2},
  [381] = {.lex_state = 5, .external_lex_state = 2},
  [382] = {.lex_state = 5, .external_lex_state = 3},
  [383] = {.lex_state = 5, .external_lex_state = 3},
  [384] = {.lex_state = 5, .external_lex_state = 3},
  [385] = {.lex_state = 5, .external_lex_state = 3},
  [386] = {.lex_state = 5, .external_lex_state = 2},
  [387] = {.lex_state = 5, .external_lex_state = 3},
  [388] = {.lex_state = 5, .external_lex_state = 2},
  [389] = {.lex_state = 5, .external_lex_state = 2},
  [390] = {.lex_state = 5, .external_lex_state = 3},
  [391] = {.lex_state = 5, .external_lex_state = 2},
  [392] = {.lex_state = 5, .external_lex_state = 3},
  [393] = {.lex_state = 5, .external_lex_state = 2},
  [394] = {.lex_state = 5, .external_lex_state = 2},
  [395] = {.lex_state = 5, .external_lex_state = 2},
  [396] = {.lex_state = 5, .external_lex_state = 2},
  [397] = {.lex_state = 5, .external_lex_state = 3},
  [398] = {.lex_state = 5, .external_lex_state = 3},
  [399] = {.lex_state = 5, .external_lex_state = 2},
  [400] = {.lex_state = 5, .external_lex_state = 2},
  [401] = {.lex_state = 5, .external_lex_state = 3},
  [402] = {.lex_state = 5, .external_lex_state = 3},
  [403] = {.lex_state = 16, .external_lex_state = 2},
  [404] = {.lex_state = 16, .external_lex_state = 2},
  [405] = {.lex_state = 16},
  [406] = {.lex_state = 16, .external_lex_state = 2},
  [407] = {.lex_state = 5, .external_lex_state = 2},
  [408] = {.lex_state = 5, .external_lex_state = 2},
  [409] = {.lex_state = 5, .external_lex_state = 3},
  [410] = {.lex_state = 5, .external_lex_state = 3},
  [411] = {.lex_state = 5, .external_lex_state = 2},
  [412] = {.lex_state = 5, .external_lex_state = 3},
  [413] = {.lex_state = 5, .external_lex_state = 3},
  [414] = {.lex_state = 5, .external_lex_state = 3},
  [415] = {.lex_state = 5, .external_lex_state = 2},
  [416] = {.lex_state = 5, .external_lex_state = 3},
  [417] = {.lex_state = 5, .external_lex_state = 2},
  [418] = {.lex_state = 16},
  [419] = {.lex_state = 5, .external_lex_state = 2},
  [420] = {.lex_state = 5, .external_lex_state = 2},
  [421] = {.lex_state = 5, .external_lex_state = 2},
  [422] = {.lex_state = 16},
  [423] = {.lex_state = 5, .external_lex_state = 2},
  [424] = {.lex_state = 5, .external_lex_state = 2},
  [425] = {.lex_state = 5, .external_lex_state = 2},
  [426] = {.lex_state = 5, .external_lex_state = 2},
  [427] = {.lex_state = 16},
  [428] = {.lex_state = 16},
  [429] = {.lex_state = 16},
  [430] = {.lex_state = 16},
  [431] = {.lex_state = 16},
  [432] = {.lex_state = 16},
  [433] = {.lex_state = 16},
  [434] = {.lex_state = 5, .external_lex_state = 3},
  [435] = {.lex_state = 5, .external_lex_state = 3},
  [436] = {.lex_state = 5, .external_lex_state = 3},
  [437] = {.lex_state = 5, .external_lex_state = 3},
  [438] = {.lex_state = 5, .external_lex_state = 3},
  [439] = {.lex_state = 5, .external_lex_state = 3},
  [440] = {.lex_state = 5, .external_lex_state = 3},
  [441] = {.lex_state = 5, .external_lex_state = 3},
  [442] = {.lex_state = 5, .external_lex_state = 3},
  [443] = {.lex_state = 5, .external_lex_state = 3},
  [444] = {.lex_state = 5, .external_lex_state = 2},
  [445] = {.lex_state = 5, .external_lex_state = 3},
  [446] = {.lex_state = 5, .external_lex_state = 3},
  [447] = {.lex_state = 5, .external_lex_state = 3},
  [448] = {.lex_state = 5, .external_lex_state = 3},
  [449] = {.lex_state = 5, .external_lex_state = 3},
  [450] = {.lex_state = 5, .external_lex_state = 3},
  [451] = {.lex_state = 5, .external_lex_state = 3},
  [452] = {.lex_state = 5, .external_lex_state = 3},
  [453] = {.lex_state = 16},
  [454] = {.lex_state = 5, .external_lex_state = 3},
  [455] = {.lex_state = 5, .external_lex_state = 3},
  [456] = {.lex_state = 5, .external_lex_state = 3},
  [457] = {.lex_state = 5, .external_lex_state = 3},
  [458] = {.lex_state = 5, .external_lex_state = 3},
  [459] = {.lex_state = 5, .external_lex_state = 2},
  [460] = {.lex_state = 5, .external_lex_state = 3},
  [461] = {.lex_state = 5, .external_lex_state = 2},
  [462] = {.lex_state = 5, .external_lex_state = 2},
  [463] = {.lex_state = 5, .external_lex_state = 2},
  [464] = {.lex_state = 5, .external_lex_state = 2},
  [465] = {.lex_state = 5, .external_lex_state = 3},
  [466] = {.lex_state = 5, .external_lex_state = 2},
  [467] = {.lex_state = 5, .external_lex_state = 3},
  [468] = {.lex_state = 5, .external_lex_state = 2},
  [469] = {.lex_state = 5, .external_lex_state = 2},
  [470] = {.lex_state = 5, .external_lex_state = 2},
  [471] = {.lex_state = 5, .external_lex_state = 2},
  [472] = {.lex_state = 5, .external_lex_state = 2},
  [473] = {.lex_state = 5, .external_lex_state = 2},
  [474] = {.lex_state = 5, .external_lex_state = 2},
  [475] = {.lex_state = 5, .external_lex_state = 2},
  [476] = {.lex_state = 5, .external_lex_state = 2},
  [477] = {.lex_state = 5, .external_lex_state = 3},
  [478] = {.lex_state = 5, .external_lex_state = 3},
  [479] = {.lex_state = 5, .external_lex_state = 3},
  [480] = {.lex_state = 5, .external_lex_state = 2},
  [481] = {.lex_state = 5, .external_lex_state = 2},
  [482] = {.lex_state = 5, .external_lex_state = 2},
  [483] = {.lex_state = 5, .external_lex_state = 2},
  [484] = {.lex_state = 5, .external_lex_state = 2},
  [485] = {.lex_state = 5, .external_lex_state = 3},
  [486] = {.lex_state = 5, .external_lex_state = 2},
  [487] = {.lex_state = 5, .external_lex_state = 2},
  [488] = {.lex_state = 5, .external_lex_state = 3},
  [489] = {.lex_state = 5, .external_lex_state = 2},
  [490] = {.lex_state = 5, .external_lex_state = 2},
  [491] = {.lex_state = 5, .external_lex_state = 3},
  [492] = {.lex_state = 5, .external_lex_state = 3},
  [493] = {.lex_state = 5, .external_lex_state = 2},
  [494] = {.lex_state = 5, .external_lex_state = 2},
  [495] = {.lex_state = 16, .external_lex_state = 2},
  [496] = {.lex_state = 16, .external_lex_state = 2},
  [497] = {.lex_state = 16},
  [498] = {.lex_state = 16},
  [499] = {.lex_state = 16},
  [500] = {.lex_state = 16},
  [501] = {.lex_state = 16},
  [502] = {.lex_state = 16},
  [503] = {.lex_state = 16},
  [504] = {.lex_state = 16},
  [505] = {.lex_state = 16},
  [506] = {.lex_state = 16},
  [507] = {.lex_state = 16},
  [508] = {.lex_state = 16},
  [509] = {.lex_state = 16},
  [510] = {.lex_state = 16},
  [511] = {.lex_state = 16},
  [512] = {.lex_state = 16},
  [513] = {.lex_state = 16},
  [514] = {.lex_state = 16},
  [515] = {.lex_state = 16},
  [516] = {.lex_state = 16},
  [517] = {.lex_state = 16},
  [518] = {.lex_state = 16},
  [519] = {.lex_state = 16},
  [520] = {.lex_state = 16},
  [521] = {.lex_state = 16},
  [522] = {.lex_state = 16},
  [523] = {.lex_state = 16},
  [524] = {.lex_state = 16},
  [525] = {.lex_state = 16},
  [526] = {.lex_state = 16},
  [527] = {.lex_state = 16},
  [528] = {.lex_state = 16},
  [529] = {.lex_state = 16, .external_lex_state = 4},
  [530] = {.lex_state = 16, .external_lex_state = 4},
  [531] = {.lex_state = 16, .external_lex_state = 4},
  [532] = {.lex_state = 16, .external_lex_state = 6},
  [533] = {.lex_state = 16, .external_lex_state = 6},
  [534] = {.lex_state = 16, .external_lex_state = 6},
  [535] = {.lex_state = 16, .external_lex_state = 6},
  [536] = {.lex_state = 16, .external_lex_state = 6},
  [537] = {.lex_state = 16, .external_lex_state = 6},
  [538] = {.lex_state = 16, .external_lex_state = 6},
  [539] = {.lex_state = 16, .external_lex_state = 6},
  [540] = {.lex_state = 16, .external_lex_state = 6},
  [541] = {.lex_state = 16, .external_lex_state = 6},
  [542] = {.lex_state = 16, .external_lex_state = 6},
  [543] = {.lex_state = 16, .external_lex_state = 2},
  [544] = {.lex_state = 16, .external_lex_state = 6},
  [545] = {.lex_state = 16, .external_lex_state = 4},
  [546] = {.lex_state = 16, .external_lex_state = 4},
  [547] = {.lex_state = 16},
  [548] = {.lex_state = 16, .external_lex_state = 2},
  [549] = {.lex_state = 16, .external_lex_state = 2},
  [550] = {.lex_state = 16},
  [551] = {.lex_state = 5, .external_lex_state = 2},
  [552] = {.lex_state = 5, .external_lex_state = 2},
  [553] = {.lex_state = 16, .external_lex_state = 6},
  [554] = {.lex_state = 16, .external_lex_state = 6},
  [555] = {.lex_state = 16, .external_lex_state = 6},
  [556] = {.lex_state = 16},
  [557] = {.lex_state = 16, .external_lex_state = 6},
  [558] = {.lex_state = 16, .external_lex_state = 6},
  [559] = {.lex_state = 16, .external_lex_state = 6},
  [560] = {.lex_state = 5, .external_lex_state = 2},
  [561] = {.lex_state = 5, .external_lex_state = 2},
  [562] = {.lex_state = 5, .external_lex_state = 2},
  [563] = {.lex_state = 16},
  [564] = {.lex_state = 16},
  [565] = {.lex_state = 16},
  [566] = {.lex_state = 5, .external_lex_state = 2},
  [567] = {.lex_state = 16},
  [568] = {.lex_state = 16, .external_lex_state = 6},
  [569] = {.lex_state = 16},
  [570] = {.lex_state = 16, .external_lex_state = 6},
  [571] = {.lex_state = 16, .external_lex_state = 6},
  [572] = {.lex_state = 16, .external_lex_state = 6},
  [573] = {.lex_state = 16},
  [574] = {.lex_state = 16},
  [575] = {.lex_state = 16},
  [576] = {.lex_state = 16, .external_lex_state = 6},
  [577] = {.lex_state = 16, .external_lex_state = 6},
  [578] = {.lex_state = 16},
  [579] = {.lex_state = 16, .external_lex_state = 6},
  [580] = {.lex_state = 16, .external_lex_state = 6},
  [581] = {.lex_state = 16, .external_lex_state = 6},
  [582] = {.lex_state = 16},
  [583] = {.lex_state = 5, .external_lex_state = 2},
  [584] = {.lex_state = 16, .external_lex_state = 6},
  [585] = {.lex_state = 16, .external_lex_state = 6},
  [586] = {.lex_state = 16, .external_lex_state = 6},
  [587] = {.lex_state = 5, .external_lex_state = 2},
  [588] = {.lex_state = 16, .external_lex_state = 6},
  [589] = {.lex_state = 16, .external_lex_state = 6},
  [590] = {.lex_state = 16, .external_lex_state = 6},
  [591] = {.lex_state = 16, .external_lex_state = 6},
  [592] = {.lex_state = 16, .external_lex_state = 6},
  [593] = {.lex_state = 16, .external_lex_state = 6},
  [594] = {.lex_state = 5, .external_lex_state = 2},
  [595] = {.lex_state = 16, .external_lex_state = 6},
  [596] = {.lex_state = 5, .external_lex_state = 2},
  [597] = {.lex_state = 16, .external_lex_state = 6},
  [598] = {.lex_state = 16, .external_lex_state = 6},
  [599] = {.lex_state = 16, .external_lex_state = 6},
  [600] = {.lex_state = 16, .external_lex_state = 6},
  [601] = {.lex_state = 5, .external_lex_state = 2},
  [602] = {.lex_state = 16, .external_lex_state = 6},
  [603] = {.lex_state = 5, .external_lex_state = 2},
  [604] = {.lex_state = 16, .external_lex_state = 6},
  [605] = {.lex_state = 5, .external_lex_state = 2},
  [606] = {.lex_state = 5, .external_lex_state = 2},
  [607] = {.lex_state = 5, .external_lex_state = 2},
  [608] = {.lex_state = 16},
  [609] = {.lex_state = 5, .external_lex_state = 2},
  [610] = {.lex_state = 5, .external_lex_state = 2},
  [611] = {.lex_state = 5, .external_lex_state = 2},
  [612] = {.lex_state = 5, .external_lex_state = 2},
  [613] = {.lex_state = 5, .external_lex_state = 2},
  [614] = {.lex_state = 5, .external_lex_state = 2},
  [615] = {.lex_state = 5, .external_lex_state = 2},
  [616] = {.lex_state = 5, .external_lex_state = 2},
  [617] = {.lex_state = 5, .external_lex_state = 2},
  [618] = {.lex_state = 5, .external_lex_state = 2},
  [619] = {.lex_state = 5, .external_lex_state = 2},
  [620] = {.lex_state = 5, .external_lex_state = 2},
  [621] = {.lex_state = 5, .external_lex_state = 2},
  [622] = {.lex_state = 16, .external_lex_state = 2},
  [623] = {.lex_state = 5, .external_lex_state = 2},
  [624] = {.lex_state = 5, .external_lex_state = 2},
  [625] = {.lex_state = 5, .external_lex_state = 2},
  [626] = {.lex_state = 5, .external_lex_state = 2},
  [627] = {.lex_state = 5, .external_lex_state = 2},
  [628] = {.lex_state = 5, .external_lex_state = 2},
  [629] = {.lex_state = 5, .external_lex_state = 2},
  [630] = {.lex_state = 5, .external_lex_state = 2},
  [631] = {.lex_state = 5, .external_lex_state = 2},
  [632] = {.lex_state = 5, .external_lex_state = 2},
  [633] = {.lex_state = 5, .external_lex_state = 2},
  [634] = {.lex_state = 5, .external_lex_state = 2},
  [635] = {.lex_state = 5, .external_lex_state = 2},
  [636] = {.lex_state = 5, .external_lex_state = 2},
  [637] = {.lex_state = 5, .external_lex_state = 2},
  [638] = {.lex_state = 5, .external_lex_state = 2},
  [639] = {.lex_state = 5, .external_lex_state = 2},
  [640] = {.lex_state = 5, .external_lex_state = 2},
  [641] = {.lex_state = 16, .external_lex_state = 2},
  [642] = {.lex_state = 5, .external_lex_state = 2},
  [643] = {.lex_state = 5, .external_lex_state = 2},
  [644] = {.lex_state = 5, .external_lex_state = 2},
  [645] = {.lex_state = 5, .external_lex_state = 2},
  [646] = {.lex_state = 5, .external_lex_state = 2},
  [647] = {.lex_state = 5, .external_lex_state = 2},
  [648] = {.lex_state = 5, .external_lex_state = 2},
  [649] = {.lex_state = 16},
  [650] = {.lex_state = 0, .external_lex_state = 6},
  [651] = {.lex_state = 16},
  [652] = {.lex_state = 16},
  [653] = {.lex_state = 16},
  [654] = {.lex_state = 16},
  [655] = {.lex_state = 16},
  [656] = {.lex_state = 16},
  [657] = {.lex_state = 16},
  [658] = {.lex_state = 16},
  [659] = {.lex_state = 16},
  [660] = {.lex_state = 16},
  [661] = {.lex_state = 16},
  [662] = {.lex_state = 16},
  [663] = {.lex_state = 16},
  [664] = {.lex_state = 16},
  [665] = {.lex_state = 16},
  [666] = {.lex_state = 16},
  [667] = {.lex_state = 16},
  [668] = {.lex_state = 16},
  [669] = {.lex_state = 16},
  [670] = {.lex_state = 16},
  [671] = {.lex_state = 16},
  [672] = {.lex_state = 16},
  [673] = {.lex_state = 16},
  [674] = {.lex_state = 16},
  [675] = {.lex_state = 16},
  [676] = {.lex_state = 16},
  [677] = {.lex_state = 16},
  [678] = {.lex_state = 16},
  [679] = {.lex_state = 16},
  [680] = {.lex_state = 16},
  [681] = {.lex_state = 0, .external_lex_state = 6},
  [682] = {.lex_state = 0},
  [683] = {.lex_state = 0},
  [684] = {.lex_state = 0, .external_lex_state = 6},
  [685] = {.lex_state = 0, .external_lex_state = 6},
  [686] = {.lex_state = 0, .external_lex_state = 6},
  [687] = {.lex_state = 0, .external_lex_state = 6},
  [688] = {.lex_state = 0, .external_lex_state = 6},
  [689] = {.lex_state = 0, .external_lex_state = 6},
  [690] = {.lex_state = 0, .external_lex_state = 6},
  [691] = {.lex_state = 0, .external_lex_state = 6},
  [692] = {.lex_state = 0, .external_lex_state = 6},
  [693] = {.lex_state = 0, .external_lex_state = 6},
  [694] = {.lex_state = 16},
  [695] = {.lex_state = 0, .external_lex_state = 6},
  [696] = {.lex_state = 16},
  [697] = {.lex_state = 0, .external_lex_state = 6},
  [698] = {.lex_state = 0, .external_lex_state = 6},
  [699] = {.lex_state = 0, .external_lex_state = 6},
  [700] = {.lex_state = 0, .external_lex_state = 6},
  [701] = {.lex_state = 0, .external_lex_state = 6},
  [702] = {.lex_state = 0, .external_lex_state = 6},
  [703] = {.lex_state = 0},
  [704] = {.lex_state = 0},
  [705] = {.lex_state = 0},
  [706] = {.lex_state = 18},
  [707] = {.lex_state = 18},
  [708] = {.lex_state = 18},
  [709] = {.lex_state = 18},
  [710] = {.lex_state = 18},
  [711] = {.lex_state = 0},
  [712] = {.lex_state = 0},
  [713] = {.lex_state = 0},
  [714] = {.lex_state = 0},
  [715] = {.lex_state = 0},
  [716] = {.lex_state = 18},
  [717] = {.lex_state = 0},
  [718] = {.lex_state = 0},
  [719] = {.lex_state = 0},
  [720] = {.lex_state = 18},
  [721] = {.lex_state = 18},
  [722] = {.lex_state = 18},
  [723] = {.lex_state = 18},
  [724] = {.lex_state = 18},
  [725] = {.lex_state = 18},
  [726] = {.lex_state = 18},
  [727] = {.lex_state = 18},
  [728] = {.lex_state = 18},
  [729] = {.lex_state = 0},
  [730] = {.lex_state = 18},
  [731] = {.lex_state = 0},
  [732] = {.lex_state = 0},
  [733] = {.lex_state = 0},
  [734] = {.lex_state = 0},
  [735] = {.lex_state = 0},
  [736] = {.lex_state = 0},
  [737] = {.lex_state = 0},
  [738] = {.lex_state = 0},
  [739] = {.lex_state = 0},
  [740] = {.lex_state = 0},
  [741] = {.lex_state = 0},
  [742] = {.lex_state = 0},
  [743] = {.lex_state = 0},
  [744] = {.lex_state = 0},
  [745] = {.lex_state = 0},
  [746] = {.lex_state = 0},
  [747] = {.lex_state = 0},
  [748] = {.lex_state = 0},
  [749] = {.lex_state = 0},
  [750] = {.lex_state = 0},
  [751] = {.lex_state = 0},
  [752] = {.lex_state = 0},
  [753] = {.lex_state = 0, .external_lex_state = 6},
  [754] = {.lex_state = 0},
  [755] = {.lex_state = 0},
  [756] = {.lex_state = 0},
  [757] = {.lex_state = 0},
  [758] = {.lex_state = 0},
  [759] = {.lex_state = 0},
  [760] = {.lex_state = 0, .external_lex_state = 6},
  [761] = {.lex_state = 0},
  [762] = {.lex_state = 0, .external_lex_state = 6},
  [763] = {.lex_state = 0},
  [764] = {.lex_state = 0, .external_lex_state = 6},
  [765] = {.lex_state = 0, .external_lex_state = 6},
  [766] = {.lex_state = 0, .external_lex_state = 6},
  [767] = {.lex_state = 0, .external_lex_state = 6},
  [768] = {.lex_state = 0},
  [769] = {.lex_state = 0},
  [770] = {.lex_state = 0},
  [771] = {.lex_state = 17, .external_lex_state = 6},
  [772] = {.lex_state = 0, .external_lex_state = 6},
  [773] = {.lex_state = 0},
  [774] = {.lex_state = 0},
  [775] = {.lex_state = 0, .external_lex_state = 6},
  [776] = {.lex_state = 0},
  [777] = {.lex_state = 0, .external_lex_state = 6},
  [778] = {.lex_state = 0},
  [779] = {.lex_state = 0},
  [780] = {.lex_state = 0},
  [781] = {.lex_state = 0},
  [782] = {.lex_state = 0},
  [783] = {.lex_state = 0},
  [784] = {.lex_state = 0},
  [785] = {.lex_state = 18},
  [786] = {.lex_state = 0},
  [787] = {.lex_state = 17},
  [788] = {.lex_state = 17, .external_lex_state = 6},
  [789] = {.lex_state = 0, .external_lex_state = 6},
  [790] = {.lex_state = 17, .external_lex_state = 6},
  [791] = {.lex_state = 0},
  [792] = {.lex_state = 0},
  [793] = {.lex_state = 0},
  [794] = {.lex_state = 0},
  [795] = {.lex_state = 0},
  [796] = {.lex_state = 20, .external_lex_state = 7},
  [797] = {.lex_state = 0},
  [798] = {.lex_state = 20, .external_lex_state = 7},
  [799] = {.lex_state = 0, .external_lex_state = 6},
  [800] = {.lex_state = 20, .external_lex_state = 7},
  [801] = {.lex_state = 20, .external_lex_state = 7},
  [802] = {.lex_state = 20, .external_lex_state = 7},
  [803] = {.lex_state = 0},
  [804] = {.lex_state = 20, .external_lex_state = 7},
  [805] = {.lex_state = 17},
  [806] = {.lex_state = 0},
  [807] = {.lex_state = 0, .external_lex_state = 6},
  [808] = {.lex_state = 20, .external_lex_state = 7},
  [809] = {.lex_state = 0},
  [810] = {.lex_state = 0},
  [811] = {.lex_state = 0},
  [812] = {.lex_state = 0},
  [813] = {.lex_state = 20, .external_lex_state = 7},
  [814] = {.lex_state = 0},
  [815] = {.lex_state = 0},
  [816] = {.lex_state = 20, .external_lex_state = 7},
  [817] = {.lex_state = 0},
  [818] = {.lex_state = 0},
  [819] = {.lex_state = 0},
  [820] = {.lex_state = 17},
  [821] = {.lex_state = 0},
  [822] = {.lex_state = 0, .external_lex_state = 6},
  [823] = {.lex_state = 20, .external_lex_state = 7},
  [824] = {.lex_state = 0},
  [825] = {.lex_state = 17, .external_lex_state = 6},
  [826] = {.lex_state = 0},
  [827] = {.lex_state = 0},
  [828] = {.lex_state = 20, .external_lex_state = 7},
  [829] = {.lex_state = 0},
  [830] = {.lex_state = 0},
  [831] = {.lex_state = 0},
  [832] = {.lex_state = 0},
  [833] = {.lex_state = 0},
  [834] = {.lex_state = 17},
  [835] = {.lex_state = 0},
  [836] = {.lex_state = 13},
  [837] = {.lex_state = 0},
  [838] = {.lex_state = 0},
  [839] = {.lex_state = 0},
  [840] = {.lex_state = 0},
  [841] = {.lex_state = 0},
  [842] = {.lex_state = 0, .external_lex_state = 6},
  [843] = {.lex_state = 0, .external_lex_state = 6},
  [844] = {.lex_state = 0},
  [845] = {.lex_state = 0},
  [846] = {.lex_state = 0},
  [847] = {.lex_state = 0},
  [848] = {.lex_state = 0, .external_lex_state = 6},
  [849] = {.lex_state = 0, .external_lex_state = 6},
  [850] = {.lex_state = 17},
  [851] = {.lex_state = 0},
  [852] = {.lex_state = 0, .external_lex_state = 6},
  [853] = {.lex_state = 13},
  [854] = {.lex_state = 0, .external_lex_state = 6},
  [855] = {.lex_state = 0, .external_lex_state = 6},
  [856] = {.lex_state = 0, .external_lex_state = 6},
  [857] = {.lex_state = 0},
  [858] = {.lex_state = 0},
  [859] = {.lex_state = 0},
  [860] = {.lex_state = 13},
  [861] = {.lex_state = 0},
  [862] = {.lex_state = 0},
  [863] = {.lex_state = 0},
  [864] = {.lex_state = 17},
  [865] = {.lex_state = 0},
  [866] = {.lex_state = 0, .external_lex_state = 6},
  [867] = {.lex_state = 0},
  [868] = {.lex_state = 0},
  [869] = {.lex_state = 0},
  [870] = {.lex_state = 0},
  [871] = {.lex_state = 0},
  [872] = {.lex_state = 0},
  [873] = {.lex_state = 0},
  [874] = {.lex_state = 0},
  [875] = {.lex_state = 0},
  [876] = {.lex_state = 0, .external_lex_state = 6},
  [877] = {.lex_state = 0, .external_lex_state = 6},
  [878] = {.lex_state = 0, .external_lex_state = 6},
  [879] = {.lex_state = 17},
  [880] = {.lex_state = 0},
  [881] = {.lex_state = 20, .external_lex_state = 7},
  [882] = {.lex_state = 0},
  [883] = {.lex_state = 0},
  [884] = {.lex_state = 0, .external_lex_state = 6},
  [885] = {.lex_state = 0},
  [886] = {.lex_state = 0},
  [887] = {.lex_state = 0},
  [888] = {.lex_state = 0},
  [889] = {.lex_state = 0},
  [890] = {.lex_state = 0},
  [891] = {.lex_state = 20, .external_lex_state = 7},
  [892] = {.lex_state = 0, .external_lex_state = 6},
  [893] = {.lex_state = 0, .external_lex_state = 6},
  [894] = {.lex_state = 0},
  [895] = {.lex_state = 0},
  [896] = {.lex_state = 0},
  [897] = {.lex_state = 0},
  [898] = {.lex_state = 0},
  [899] = {.lex_state = 0, .external_lex_state = 6},
  [900] = {.lex_state = 0},
  [901] = {.lex_state = 20, .external_lex_state = 7},
  [902] = {.lex_state = 0},
  [903] = {.lex_state = 0, .external_lex_state = 6},
  [904] = {.lex_state = 0},
  [905] = {.lex_state = 0, .external_lex_state = 6},
  [906] = {.lex_state = 0, .external_lex_state = 6},
  [907] = {.lex_state = 0, .external_lex_state = 6},
  [908] = {.lex_state = 0},
  [909] = {.lex_state = 0, .external_lex_state = 6},
  [910] = {.lex_state = 0, .external_lex_state = 6},
  [911] = {.lex_state = 0},
  [912] = {.lex_state = 0},
  [913] = {.lex_state = 0, .external_lex_state = 6},
  [914] = {.lex_state = 0},
  [915] = {.lex_state = 0},
  [916] = {.lex_state = 0, .external_lex_state = 6},
  [917] = {.lex_state = 0},
  [918] = {.lex_state = 0},
  [919] = {.lex_state = 0},
  [920] = {.lex_state = 0},
  [921] = {.lex_state = 0},
  [922] = {.lex_state = 0},
  [923] = {.lex_state = 0},
  [924] = {.lex_state = 0},
  [925] = {.lex_state = 0},
  [926] = {.lex_state = 0},
  [927] = {.lex_state = 0},
  [928] = {.lex_state = 0},
  [929] = {.lex_state = 0},
  [930] = {.lex_state = 0},
  [931] = {.lex_state = 0, .external_lex_state = 6},
  [932] = {.lex_state = 0},
  [933] = {.lex_state = 0},
  [934] = {.lex_state = 13},
  [935] = {.lex_state = 0, .external_lex_state = 6},
  [936] = {.lex_state = 0, .external_lex_state = 6},
  [937] = {.lex_state = 0, .external_lex_state = 6},
  [938] = {.lex_state = 0, .external_lex_state = 6},
  [939] = {.lex_state = 0},
  [940] = {.lex_state = 0},
  [941] = {.lex_state = 0},
  [942] = {.lex_state = 0, .external_lex_state = 6},
  [943] = {.lex_state = 0},
  [944] = {.lex_state = 0},
  [945] = {.lex_state = 0},
  [946] = {.lex_state = 0},
  [947] = {.lex_state = 0},
  [948] = {.lex_state = 0},
  [949] = {.lex_state = 0},
  [950] = {.lex_state = 0},
  [951] = {.lex_state = 0},
  [952] = {.lex_state = 0},
  [953] = {.lex_state = 0},
  [954] = {.lex_state = 0},
  [955] = {.lex_state = 0},
  [956] = {.lex_state = 0},
  [957] = {.lex_state = 0},
  [958] = {.lex_state = 0, .external_lex_state = 6},
  [959] = {.lex_state = 0},
  [960] = {.lex_state = 0},
  [961] = {.lex_state = 0},
  [962] = {.lex_state = 0},
  [963] = {.lex_state = 0},
  [964] = {.lex_state = 0},
  [965] = {.lex_state = 0},
  [966] = {.lex_state = 0},
  [967] = {.lex_state = 0},
  [968] = {.lex_state = 0},
  [969] = {.lex_state = 0},
  [970] = {.lex_state = 0},
  [971] = {.lex_state = 0},
  [972] = {.lex_state = 0},
  [973] = {.lex_state = 0},
  [974] = {.lex_state = 0},
  [975] = {.lex_state = 0},
  [976] = {.lex_state = 0},
  [977] = {.lex_state = 0},
  [978] = {.lex_state = 0},
  [979] = {.lex_state = 0},
  [980] = {.lex_state = 0},
  [981] = {.lex_state = 0},
  [982] = {.lex_state = 0},
  [983] = {.lex_state = 0},
  [984] = {.lex_state = 0},
  [985] = {.lex_state = 0},
  [986] = {.lex_state = 0, .external_lex_state = 6},
  [987] = {.lex_state = 0, .external_lex_state = 6},
  [988] = {.lex_state = 0, .external_lex_state = 6},
  [989] = {.lex_state = 0},
  [990] = {.lex_state = 0},
  [991] = {.lex_state = 0, .external_lex_state = 6},
  [992] = {.lex_state = 0},
  [993] = {.lex_state = 0},
  [994] = {.lex_state = 0},
  [995] = {.lex_state = 0},
  [996] = {.lex_state = 0},
  [997] = {.lex_state = 0},
  [998] = {.lex_state = 0},
  [999] = {.lex_state = 0},
  [1000] = {.lex_state = 0},
  [1001] = {.lex_state = 0},
  [1002] = {.lex_state = 0},
  [1003] = {.lex_state = 0},
  [1004] = {.lex_state = 0, .external_lex_state = 6},
  [1005] = {.lex_state = 0},
  [1006] = {.lex_state = 0},
  [1007] = {.lex_state = 0, .external_lex_state = 6},
  [1008] = {.lex_state = 0},
  [1009] = {.lex_state = 0},
  [1010] = {.lex_state = 0},
  [1011] = {.lex_state = 0},
  [1012] = {.lex_state = 0},
  [1013] = {.lex_state = 0},
  [1014] = {.lex_state = 0},
  [1015] = {.lex_state = 0, .external_lex_state = 6},
  [1016] = {.lex_state = 0},
  [1017] = {.lex_state = 0},
  [1018] = {.lex_state = 0},
  [1019] = {.lex_state = 0},
  [1020] = {.lex_state = 0, .external_lex_state = 6},
  [1021] = {.lex_state = 0},
  [1022] = {.lex_state = 0},
  [1023] = {.lex_state = 0},
  [1024] = {.lex_state = 19},
  [1025] = {.lex_state = 19},
  [1026] = {.lex_state = 0},
  [1027] = {.lex_state = 0},
  [1028] = {.lex_state = 0},
  [1029] = {.lex_state = 0},
  [1030] = {.lex_state = 0, .external_lex_state = 6},
  [1031] = {.lex_state = 0},
  [1032] = {.lex_state = 0},
  [1033] = {.lex_state = 0, .external_lex_state = 6},
  [1034] = {.lex_state = 0, .external_lex_state = 6},
  [1035] = {.lex_state = 0},
  [1036] = {.lex_state = 0},
  [1037] = {.lex_state = 0},
  [1038] = {.lex_state = 0},
  [1039] = {.lex_state = 19},
  [1040] = {.lex_state = 19},
  [1041] = {.lex_state = 19},
  [1042] = {.lex_state = 0},
  [1043] = {.lex_state = 0, .external_lex_state = 6},
  [1044] = {.lex_state = 0, .external_lex_state = 6},
  [1045] = {.lex_state = 0, .external_lex_state = 6},
  [1046] = {.lex_state = 0, .external_lex_state = 6},
  [1047] = {.lex_state = 0, .external_lex_state = 6},
  [1048] = {.lex_state = 0, .external_lex_state = 6},
  [1049] = {.lex_state = 0},
  [1050] = {.lex_state = 0, .external_lex_state = 6},
  [1051] = {.lex_state = 19},
  [1052] = {.lex_state = 0},
  [1053] = {.lex_state = 0, .external_lex_state = 6},
  [1054] = {.lex_state = 0},
  [1055] = {.lex_state = 0, .external_lex_state = 6},
  [1056] = {.lex_state = 0},
  [1057] = {.lex_state = 0},
  [1058] = {.lex_state = 0, .external_lex_state = 6},
  [1059] = {.lex_state = 0},
  [1060] = {.lex_state = 0, .external_lex_state = 6},
  [1061] = {.lex_state = 0, .external_lex_state = 6},
  [1062] = {.lex_state = 0, .external_lex_state = 6},
  [1063] = {.lex_state = 0, .external_lex_state = 6},
  [1064] = {.lex_state = 0},
  [1065] = {.lex_state = 0},
  [1066] = {.lex_state = 0},
  [1067] = {.lex_state = 0},
  [1068] = {.lex_state = 0},
  [1069] = {.lex_state = 0},
  [1070] = {.lex_state = 0},
  [1071] = {.lex_state = 0},
  [1072] = {.lex_state = 0},
  [1073] = {.lex_state = 0},
  [1074] = {.lex_state = 0},
  [1075] = {.lex_state = 0},
  [1076] = {.lex_state = 0},
  [1077] = {.lex_state = 0},
  [1078] = {.lex_state = 0},
  [1079] = {.lex_state = 0},
  [1080] = {.lex_state = 0},
  [1081] = {.lex_state = 0},
  [1082] = {.lex_state = 0},
  [1083] = {.lex_state = 0},
  [1084] = {.lex_state = 0},
  [1085] = {.lex_state = 0},
  [1086] = {.lex_state = 0},
  [1087] = {.lex_state = 0},
  [1088] = {.lex_state = 0},
  [1089] = {.lex_state = 0},
  [1090] = {.lex_state = 0},
  [1091] = {.lex_state = 0},
  [1092] = {.lex_state = 0},
  [1093] = {.lex_state = 0},
  [1094] = {.lex_state = 0},
  [1095] = {.lex_state = 0},
  [1096] = {.lex_state = 0},
  [1097] = {.lex_state = 0},
  [1098] = {.lex_state = 0},
  [1099] = {.lex_state = 0},
  [1100] = {.lex_state = 0},
  [1101] = {.lex_state = 0},
  [1102] = {.lex_state = 0},
  [1103] = {.lex_state = 0},
  [1104] = {.lex_state = 0},
  [1105] = {.lex_state = 0},
  [1106] = {.lex_state = 0},
  [1107] = {.lex_state = 0},
  [1108] = {.lex_state = 0},
  [1109] = {.lex_state = 0},
  [1110] = {.lex_state = 0},
  [1111] = {.lex_state = 0},
  [1112] = {.lex_state = 0},
  [1113] = {.lex_state = 0},
  [1114] = {.lex_state = 0},
  [1115] = {.lex_state = 0},
  [1116] = {.lex_state = 0},
  [1117] = {.lex_state = 0},
  [1118] = {.lex_state = 18},
  [1119] = {.lex_state = 0},
  [1120] = {.lex_state = 0},
  [1121] = {.lex_state = 0},
  [1122] = {.lex_state = 0},
  [1123] = {.lex_state = 0},
  [1124] = {.lex_state = 0},
  [1125] = {.lex_state = 0},
  [1126] = {.lex_state = 0},
  [1127] = {.lex_state = 0},
  [1128] = {.lex_state = 0},
  [1129] = {.lex_state = 0},
  [1130] = {.lex_state = 0},
  [1131] = {.lex_state = 0},
  [1132] = {.lex_state = 0},
  [1133] = {.lex_state = 0},
  [1134] = {.lex_state = 0, .external_lex_state = 6},
  [1135] = {.lex_state = 0},
  [1136] = {.lex_state = 0},
  [1137] = {.lex_state = 0},
  [1138] = {.lex_state = 0},
  [1139] = {.lex_state = 0},
  [1140] = {.lex_state = 0},
  [1141] = {.lex_state = 0},
  [1142] = {.lex_state = 0},
  [1143] = {.lex_state = 0},
  [1144] = {.lex_state = 0},
  [1145] = {.lex_state = 0},
  [1146] = {.lex_state = 0},
  [1147] = {.lex_state = 0},
  [1148] = {.lex_state = 0},
  [1149] = {.lex_state = 0},
  [1150] = {.lex_state = 0},
  [1151] = {.lex_state = 0},
  [1152] = {.lex_state = 0},
  [1153] = {.lex_state = 0},
  [1154] = {.lex_state = 0},
  [1155] = {.lex_state = 0},
  [1156] = {.lex_state = 0},
  [1157] = {.lex_state = 0},
  [1158] = {.lex_state = 0},
  [1159] = {.lex_state = 0},
};

enum {
  ts_external_token__newline = 0,
  ts_external_token__indent = 1,
  ts_external_token__dedent = 2,
  ts_external_token__string_start = 3,
  ts_external_token__string_content = 4,
  ts_external_token__string_end = 5,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__newline] = sym__newline,
  [ts_external_token__indent] = sym__indent,
  [ts_external_token__dedent] = sym__dedent,
  [ts_external_token__string_start] = sym__string_start,
  [ts_external_token__string_content] = sym__string_content,
  [ts_external_token__string_end] = sym__string_end,
};

static bool ts_external_scanner_states[8][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__newline] = true,
    [ts_external_token__indent] = true,
    [ts_external_token__dedent] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__string_content] = true,
    [ts_external_token__string_end] = true,
  },
  [2] = {
    [ts_external_token__string_start] = true,
  },
  [3] = {
    [ts_external_token__dedent] = true,
    [ts_external_token__string_start] = true,
  },
  [4] = {
    [ts_external_token__newline] = true,
    [ts_external_token__string_start] = true,
  },
  [5] = {
    [ts_external_token__indent] = true,
    [ts_external_token__string_start] = true,
  },
  [6] = {
    [ts_external_token__newline] = true,
  },
  [7] = {
    [ts_external_token__string_content] = true,
    [ts_external_token__string_end] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym___future__] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_print] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_assert] = ACTIONS(1),
    [anon_sym_COLON_EQ] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_del] = ACTIONS(1),
    [anon_sym_raise] = ACTIONS(1),
    [anon_sym_pass] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_elif] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_except] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_def] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_nonlocal] = ACTIONS(1),
    [anon_sym_exec] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_SLASH_SLASH] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_LT_GT] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_lambda] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_AT_EQ] = ACTIONS(1),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [sym_ellipsis] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [sym_type_conversion] = ACTIONS(1),
    [sym_integer] = ACTIONS(1),
    [sym_float] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_none] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1),
    [sym__newline] = ACTIONS(1),
    [sym__indent] = ACTIONS(1),
    [sym__dedent] = ACTIONS(1),
    [sym__string_start] = ACTIONS(1),
    [sym__string_content] = ACTIONS(1),
    [sym__string_end] = ACTIONS(1),
  },
  [1] = {
    [sym_module] = STATE(1136),
    [sym__statement] = STATE(42),
    [sym__simple_statements] = STATE(42),
    [sym_import_statement] = STATE(938),
    [sym_future_import_statement] = STATE(938),
    [sym_import_from_statement] = STATE(938),
    [sym_print_statement] = STATE(938),
    [sym_assert_statement] = STATE(938),
    [sym_expression_statement] = STATE(938),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(938),
    [sym_delete_statement] = STATE(938),
    [sym_raise_statement] = STATE(938),
    [sym_pass_statement] = STATE(938),
    [sym_break_statement] = STATE(938),
    [sym_continue_statement] = STATE(938),
    [sym_if_statement] = STATE(42),
    [sym_for_statement] = STATE(42),
    [sym_while_statement] = STATE(42),
    [sym_try_statement] = STATE(42),
    [sym_with_statement] = STATE(42),
    [sym_function_definition] = STATE(42),
    [sym_global_statement] = STATE(938),
    [sym_nonlocal_statement] = STATE(938),
    [sym_exec_statement] = STATE(938),
    [sym_class_definition] = STATE(42),
    [sym_decorated_definition] = STATE(42),
    [sym_decorator] = STATE(754),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(42),
    [aux_sym_decorated_definition_repeat1] = STATE(754),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_with] = ACTIONS(41),
    [anon_sym_def] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [2] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(43),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(758),
    [sym_block] = STATE(356),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [3] = {
    [sym__statement] = STATE(47),
    [sym__simple_statements] = STATE(47),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_try_statement] = STATE(47),
    [sym_with_statement] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(47),
    [sym_decorated_definition] = STATE(47),
    [sym_decorator] = STATE(758),
    [sym_block] = STATE(265),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(47),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(93),
    [sym__string_start] = ACTIONS(73),
  },
  [4] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(43),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(758),
    [sym_block] = STATE(479),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [5] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(43),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(758),
    [sym_block] = STATE(454),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [6] = {
    [sym__statement] = STATE(47),
    [sym__simple_statements] = STATE(47),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_try_statement] = STATE(47),
    [sym_with_statement] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(47),
    [sym_decorated_definition] = STATE(47),
    [sym_decorator] = STATE(758),
    [sym_block] = STATE(349),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(47),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(93),
    [sym__string_start] = ACTIONS(73),
  },
  [7] = {
    [sym__statement] = STATE(47),
    [sym__simple_statements] = STATE(47),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_try_statement] = STATE(47),
    [sym_with_statement] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(47),
    [sym_decorated_definition] = STATE(47),
    [sym_decorator] = STATE(758),
    [sym_block] = STATE(486),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(47),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(93),
    [sym__string_start] = ACTIONS(73),
  },
  [8] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(43),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(758),
    [sym_block] = STATE(460),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [9] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(43),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(758),
    [sym_block] = STATE(458),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [10] = {
    [sym__statement] = STATE(47),
    [sym__simple_statements] = STATE(47),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_try_statement] = STATE(47),
    [sym_with_statement] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(47),
    [sym_decorated_definition] = STATE(47),
    [sym_decorator] = STATE(758),
    [sym_block] = STATE(466),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(47),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(93),
    [sym__string_start] = ACTIONS(73),
  },
  [11] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(43),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(758),
    [sym_block] = STATE(383),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [12] = {
    [sym__statement] = STATE(47),
    [sym__simple_statements] = STATE(47),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_try_statement] = STATE(47),
    [sym_with_statement] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(47),
    [sym_decorated_definition] = STATE(47),
    [sym_decorator] = STATE(758),
    [sym_block] = STATE(461),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(47),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(93),
    [sym__string_start] = ACTIONS(73),
  },
  [13] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(43),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(758),
    [sym_block] = STATE(336),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [14] = {
    [sym__statement] = STATE(47),
    [sym__simple_statements] = STATE(47),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_try_statement] = STATE(47),
    [sym_with_statement] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(47),
    [sym_decorated_definition] = STATE(47),
    [sym_decorator] = STATE(758),
    [sym_block] = STATE(353),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(47),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(93),
    [sym__string_start] = ACTIONS(73),
  },
  [15] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(43),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(758),
    [sym_block] = STATE(465),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [16] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(43),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(758),
    [sym_block] = STATE(452),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [17] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(43),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(758),
    [sym_block] = STATE(449),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [18] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(43),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(758),
    [sym_block] = STATE(410),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [19] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(43),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(758),
    [sym_block] = STATE(445),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [20] = {
    [sym__statement] = STATE(47),
    [sym__simple_statements] = STATE(47),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_try_statement] = STATE(47),
    [sym_with_statement] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(47),
    [sym_decorated_definition] = STATE(47),
    [sym_decorator] = STATE(758),
    [sym_block] = STATE(494),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(47),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(93),
    [sym__string_start] = ACTIONS(73),
  },
  [21] = {
    [sym__statement] = STATE(47),
    [sym__simple_statements] = STATE(47),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_try_statement] = STATE(47),
    [sym_with_statement] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(47),
    [sym_decorated_definition] = STATE(47),
    [sym_decorator] = STATE(758),
    [sym_block] = STATE(423),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(47),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(93),
    [sym__string_start] = ACTIONS(73),
  },
  [22] = {
    [sym__statement] = STATE(47),
    [sym__simple_statements] = STATE(47),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_try_statement] = STATE(47),
    [sym_with_statement] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(47),
    [sym_decorated_definition] = STATE(47),
    [sym_decorator] = STATE(758),
    [sym_block] = STATE(462),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(47),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(93),
    [sym__string_start] = ACTIONS(73),
  },
  [23] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(43),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(758),
    [sym_block] = STATE(387),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [24] = {
    [sym__statement] = STATE(47),
    [sym__simple_statements] = STATE(47),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_try_statement] = STATE(47),
    [sym_with_statement] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(47),
    [sym_decorated_definition] = STATE(47),
    [sym_decorator] = STATE(758),
    [sym_block] = STATE(395),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(47),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(93),
    [sym__string_start] = ACTIONS(73),
  },
  [25] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(43),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(758),
    [sym_block] = STATE(439),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [26] = {
    [sym__statement] = STATE(47),
    [sym__simple_statements] = STATE(47),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_try_statement] = STATE(47),
    [sym_with_statement] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(47),
    [sym_decorated_definition] = STATE(47),
    [sym_decorator] = STATE(758),
    [sym_block] = STATE(302),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(47),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(93),
    [sym__string_start] = ACTIONS(73),
  },
  [27] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(43),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(758),
    [sym_block] = STATE(402),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [28] = {
    [sym__statement] = STATE(47),
    [sym__simple_statements] = STATE(47),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_try_statement] = STATE(47),
    [sym_with_statement] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(47),
    [sym_decorated_definition] = STATE(47),
    [sym_decorator] = STATE(758),
    [sym_block] = STATE(417),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(47),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(93),
    [sym__string_start] = ACTIONS(73),
  },
  [29] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(43),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(758),
    [sym_block] = STATE(435),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [30] = {
    [sym__statement] = STATE(47),
    [sym__simple_statements] = STATE(47),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_try_statement] = STATE(47),
    [sym_with_statement] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(47),
    [sym_decorated_definition] = STATE(47),
    [sym_decorator] = STATE(758),
    [sym_block] = STATE(483),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(47),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(93),
    [sym__string_start] = ACTIONS(73),
  },
  [31] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(43),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(758),
    [sym_block] = STATE(382),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [32] = {
    [sym__statement] = STATE(47),
    [sym__simple_statements] = STATE(47),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_try_statement] = STATE(47),
    [sym_with_statement] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(47),
    [sym_decorated_definition] = STATE(47),
    [sym_decorator] = STATE(758),
    [sym_block] = STATE(389),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(47),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(93),
    [sym__string_start] = ACTIONS(73),
  },
  [33] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(43),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(758),
    [sym_block] = STATE(306),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [34] = {
    [sym__statement] = STATE(47),
    [sym__simple_statements] = STATE(47),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_try_statement] = STATE(47),
    [sym_with_statement] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(47),
    [sym_decorated_definition] = STATE(47),
    [sym_decorator] = STATE(758),
    [sym_block] = STATE(400),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(47),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(93),
    [sym__string_start] = ACTIONS(73),
  },
  [35] = {
    [sym__statement] = STATE(44),
    [sym__simple_statements] = STATE(44),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_try_statement] = STATE(44),
    [sym_with_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(44),
    [sym_decorated_definition] = STATE(44),
    [sym_decorator] = STATE(758),
    [sym_block] = STATE(859),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(44),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(95),
    [sym__string_start] = ACTIONS(73),
  },
  [36] = {
    [sym__statement] = STATE(47),
    [sym__simple_statements] = STATE(47),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_try_statement] = STATE(47),
    [sym_with_statement] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(47),
    [sym_decorated_definition] = STATE(47),
    [sym_decorator] = STATE(758),
    [sym_block] = STATE(386),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(47),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(93),
    [sym__string_start] = ACTIONS(73),
  },
  [37] = {
    [sym__statement] = STATE(44),
    [sym__simple_statements] = STATE(44),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_try_statement] = STATE(44),
    [sym_with_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(44),
    [sym_decorated_definition] = STATE(44),
    [sym_decorator] = STATE(758),
    [sym_block] = STATE(847),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(44),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(95),
    [sym__string_start] = ACTIONS(73),
  },
  [38] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(43),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(758),
    [sym_block] = STATE(248),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [39] = {
    [sym__statement] = STATE(47),
    [sym__simple_statements] = STATE(47),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_try_statement] = STATE(47),
    [sym_with_statement] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(47),
    [sym_decorated_definition] = STATE(47),
    [sym_decorator] = STATE(758),
    [sym_block] = STATE(408),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(47),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(93),
    [sym__string_start] = ACTIONS(73),
  },
  [40] = {
    [sym__statement] = STATE(47),
    [sym__simple_statements] = STATE(47),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_try_statement] = STATE(47),
    [sym_with_statement] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(47),
    [sym_decorated_definition] = STATE(47),
    [sym_decorator] = STATE(758),
    [sym_block] = STATE(484),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(47),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(93),
    [sym__string_start] = ACTIONS(73),
  },
  [41] = {
    [sym__statement] = STATE(47),
    [sym__simple_statements] = STATE(47),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_try_statement] = STATE(47),
    [sym_with_statement] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(47),
    [sym_decorated_definition] = STATE(47),
    [sym_decorator] = STATE(758),
    [sym_block] = STATE(471),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(47),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(93),
    [sym__string_start] = ACTIONS(73),
  },
  [42] = {
    [sym__statement] = STATE(46),
    [sym__simple_statements] = STATE(46),
    [sym_import_statement] = STATE(938),
    [sym_future_import_statement] = STATE(938),
    [sym_import_from_statement] = STATE(938),
    [sym_print_statement] = STATE(938),
    [sym_assert_statement] = STATE(938),
    [sym_expression_statement] = STATE(938),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(938),
    [sym_delete_statement] = STATE(938),
    [sym_raise_statement] = STATE(938),
    [sym_pass_statement] = STATE(938),
    [sym_break_statement] = STATE(938),
    [sym_continue_statement] = STATE(938),
    [sym_if_statement] = STATE(46),
    [sym_for_statement] = STATE(46),
    [sym_while_statement] = STATE(46),
    [sym_try_statement] = STATE(46),
    [sym_with_statement] = STATE(46),
    [sym_function_definition] = STATE(46),
    [sym_global_statement] = STATE(938),
    [sym_nonlocal_statement] = STATE(938),
    [sym_exec_statement] = STATE(938),
    [sym_class_definition] = STATE(46),
    [sym_decorated_definition] = STATE(46),
    [sym_decorator] = STATE(754),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(46),
    [aux_sym_decorated_definition_repeat1] = STATE(754),
    [ts_builtin_sym_end] = ACTIONS(97),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_with] = ACTIONS(41),
    [anon_sym_def] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [43] = {
    [sym__statement] = STATE(45),
    [sym__simple_statements] = STATE(45),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_try_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(45),
    [sym_decorated_definition] = STATE(45),
    [sym_decorator] = STATE(758),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(45),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(99),
    [sym__string_start] = ACTIONS(73),
  },
  [44] = {
    [sym__statement] = STATE(45),
    [sym__simple_statements] = STATE(45),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_try_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(45),
    [sym_decorated_definition] = STATE(45),
    [sym_decorator] = STATE(758),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(45),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(101),
    [sym__string_start] = ACTIONS(73),
  },
  [45] = {
    [sym__statement] = STATE(45),
    [sym__simple_statements] = STATE(45),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_try_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(45),
    [sym_decorated_definition] = STATE(45),
    [sym_decorator] = STATE(758),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(45),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(103),
    [anon_sym_import] = ACTIONS(106),
    [anon_sym_from] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(112),
    [anon_sym_print] = ACTIONS(115),
    [anon_sym_assert] = ACTIONS(118),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_del] = ACTIONS(124),
    [anon_sym_raise] = ACTIONS(127),
    [anon_sym_pass] = ACTIONS(130),
    [anon_sym_break] = ACTIONS(133),
    [anon_sym_continue] = ACTIONS(136),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_async] = ACTIONS(142),
    [anon_sym_for] = ACTIONS(145),
    [anon_sym_while] = ACTIONS(148),
    [anon_sym_try] = ACTIONS(151),
    [anon_sym_with] = ACTIONS(154),
    [anon_sym_def] = ACTIONS(157),
    [anon_sym_global] = ACTIONS(160),
    [anon_sym_nonlocal] = ACTIONS(163),
    [anon_sym_exec] = ACTIONS(166),
    [anon_sym_class] = ACTIONS(169),
    [anon_sym_AT] = ACTIONS(172),
    [anon_sym_not] = ACTIONS(175),
    [anon_sym_PLUS] = ACTIONS(178),
    [anon_sym_DASH] = ACTIONS(178),
    [anon_sym_TILDE] = ACTIONS(178),
    [anon_sym_lambda] = ACTIONS(181),
    [anon_sym_yield] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym_ellipsis] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(193),
    [sym_integer] = ACTIONS(196),
    [sym_float] = ACTIONS(190),
    [sym_true] = ACTIONS(196),
    [sym_false] = ACTIONS(196),
    [sym_none] = ACTIONS(196),
    [anon_sym_await] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(202),
    [sym__string_start] = ACTIONS(204),
  },
  [46] = {
    [sym__statement] = STATE(46),
    [sym__simple_statements] = STATE(46),
    [sym_import_statement] = STATE(938),
    [sym_future_import_statement] = STATE(938),
    [sym_import_from_statement] = STATE(938),
    [sym_print_statement] = STATE(938),
    [sym_assert_statement] = STATE(938),
    [sym_expression_statement] = STATE(938),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(938),
    [sym_delete_statement] = STATE(938),
    [sym_raise_statement] = STATE(938),
    [sym_pass_statement] = STATE(938),
    [sym_break_statement] = STATE(938),
    [sym_continue_statement] = STATE(938),
    [sym_if_statement] = STATE(46),
    [sym_for_statement] = STATE(46),
    [sym_while_statement] = STATE(46),
    [sym_try_statement] = STATE(46),
    [sym_with_statement] = STATE(46),
    [sym_function_definition] = STATE(46),
    [sym_global_statement] = STATE(938),
    [sym_nonlocal_statement] = STATE(938),
    [sym_exec_statement] = STATE(938),
    [sym_class_definition] = STATE(46),
    [sym_decorated_definition] = STATE(46),
    [sym_decorator] = STATE(754),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(46),
    [aux_sym_decorated_definition_repeat1] = STATE(754),
    [ts_builtin_sym_end] = ACTIONS(202),
    [sym_identifier] = ACTIONS(103),
    [anon_sym_import] = ACTIONS(106),
    [anon_sym_from] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(112),
    [anon_sym_print] = ACTIONS(115),
    [anon_sym_assert] = ACTIONS(118),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_del] = ACTIONS(124),
    [anon_sym_raise] = ACTIONS(127),
    [anon_sym_pass] = ACTIONS(130),
    [anon_sym_break] = ACTIONS(133),
    [anon_sym_continue] = ACTIONS(136),
    [anon_sym_if] = ACTIONS(207),
    [anon_sym_async] = ACTIONS(210),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_while] = ACTIONS(216),
    [anon_sym_try] = ACTIONS(219),
    [anon_sym_with] = ACTIONS(222),
    [anon_sym_def] = ACTIONS(225),
    [anon_sym_global] = ACTIONS(160),
    [anon_sym_nonlocal] = ACTIONS(163),
    [anon_sym_exec] = ACTIONS(166),
    [anon_sym_class] = ACTIONS(228),
    [anon_sym_AT] = ACTIONS(172),
    [anon_sym_not] = ACTIONS(175),
    [anon_sym_PLUS] = ACTIONS(178),
    [anon_sym_DASH] = ACTIONS(178),
    [anon_sym_TILDE] = ACTIONS(178),
    [anon_sym_lambda] = ACTIONS(181),
    [anon_sym_yield] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym_ellipsis] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(193),
    [sym_integer] = ACTIONS(196),
    [sym_float] = ACTIONS(190),
    [sym_true] = ACTIONS(196),
    [sym_false] = ACTIONS(196),
    [sym_none] = ACTIONS(196),
    [anon_sym_await] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(204),
  },
  [47] = {
    [sym__statement] = STATE(45),
    [sym__simple_statements] = STATE(45),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_if_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_try_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_class_definition] = STATE(45),
    [sym_decorated_definition] = STATE(45),
    [sym_decorator] = STATE(758),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [aux_sym_module_repeat1] = STATE(45),
    [aux_sym_decorated_definition_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(231),
    [sym__string_start] = ACTIONS(73),
  },
  [48] = {
    [sym_chevron] = STATE(884),
    [sym_named_expression] = STATE(775),
    [sym__expression] = STATE(775),
    [sym__primary_expression] = STATE(532),
    [sym_not_operator] = STATE(775),
    [sym_boolean_operator] = STATE(775),
    [sym_binary_operator] = STATE(532),
    [sym_unary_operator] = STATE(532),
    [sym_comparison_operator] = STATE(775),
    [sym_lambda] = STATE(775),
    [sym_attribute] = STATE(532),
    [sym_subscript] = STATE(532),
    [sym_call] = STATE(532),
    [sym_list] = STATE(532),
    [sym_list_comprehension] = STATE(532),
    [sym_dictionary] = STATE(532),
    [sym_dictionary_comprehension] = STATE(532),
    [sym_set] = STATE(532),
    [sym_set_comprehension] = STATE(532),
    [sym_parenthesized_expression] = STATE(532),
    [sym_tuple] = STATE(532),
    [sym_generator_expression] = STATE(532),
    [sym_conditional_expression] = STATE(775),
    [sym_concatenated_string] = STATE(532),
    [sym_string] = STATE(530),
    [sym_await] = STATE(775),
    [sym_identifier] = ACTIONS(233),
    [anon_sym_DOT] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_COMMA] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(235),
    [anon_sym_print] = ACTIONS(239),
    [anon_sym_GT_GT] = ACTIONS(241),
    [anon_sym_if] = ACTIONS(235),
    [anon_sym_COLON] = ACTIONS(237),
    [anon_sym_in] = ACTIONS(235),
    [anon_sym_EQ] = ACTIONS(235),
    [anon_sym_exec] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(235),
    [anon_sym_and] = ACTIONS(235),
    [anon_sym_or] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_SLASH_SLASH] = ACTIONS(235),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_TILDE] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_LT_GT] = ACTIONS(237),
    [anon_sym_is] = ACTIONS(235),
    [anon_sym_lambda] = ACTIONS(245),
    [anon_sym_PLUS_EQ] = ACTIONS(237),
    [anon_sym_DASH_EQ] = ACTIONS(237),
    [anon_sym_STAR_EQ] = ACTIONS(237),
    [anon_sym_SLASH_EQ] = ACTIONS(237),
    [anon_sym_AT_EQ] = ACTIONS(237),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(237),
    [anon_sym_PERCENT_EQ] = ACTIONS(237),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(237),
    [anon_sym_GT_GT_EQ] = ACTIONS(237),
    [anon_sym_LT_LT_EQ] = ACTIONS(237),
    [anon_sym_AMP_EQ] = ACTIONS(237),
    [anon_sym_CARET_EQ] = ACTIONS(237),
    [anon_sym_PIPE_EQ] = ACTIONS(237),
    [anon_sym_LBRACK] = ACTIONS(237),
    [sym_ellipsis] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [sym_integer] = ACTIONS(251),
    [sym_float] = ACTIONS(247),
    [sym_true] = ACTIONS(251),
    [sym_false] = ACTIONS(251),
    [sym_none] = ACTIONS(251),
    [anon_sym_await] = ACTIONS(253),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(237),
    [sym__newline] = ACTIONS(237),
    [sym__string_start] = ACTIONS(255),
  },
  [49] = {
    [sym__simple_statements] = STATE(399),
    [sym_import_statement] = STATE(938),
    [sym_future_import_statement] = STATE(938),
    [sym_import_from_statement] = STATE(938),
    [sym_print_statement] = STATE(938),
    [sym_assert_statement] = STATE(938),
    [sym_expression_statement] = STATE(938),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(938),
    [sym_delete_statement] = STATE(938),
    [sym_raise_statement] = STATE(938),
    [sym_pass_statement] = STATE(938),
    [sym_break_statement] = STATE(938),
    [sym_continue_statement] = STATE(938),
    [sym_global_statement] = STATE(938),
    [sym_nonlocal_statement] = STATE(938),
    [sym_exec_statement] = STATE(938),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(257),
    [sym__string_start] = ACTIONS(73),
  },
  [50] = {
    [sym__simple_statements] = STATE(845),
    [sym_import_statement] = STATE(916),
    [sym_future_import_statement] = STATE(916),
    [sym_import_from_statement] = STATE(916),
    [sym_print_statement] = STATE(916),
    [sym_assert_statement] = STATE(916),
    [sym_expression_statement] = STATE(916),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(916),
    [sym_delete_statement] = STATE(916),
    [sym_raise_statement] = STATE(916),
    [sym_pass_statement] = STATE(916),
    [sym_break_statement] = STATE(916),
    [sym_continue_statement] = STATE(916),
    [sym_global_statement] = STATE(916),
    [sym_nonlocal_statement] = STATE(916),
    [sym_exec_statement] = STATE(916),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(259),
    [sym__string_start] = ACTIONS(73),
  },
  [51] = {
    [sym__simple_statements] = STATE(841),
    [sym_import_statement] = STATE(916),
    [sym_future_import_statement] = STATE(916),
    [sym_import_from_statement] = STATE(916),
    [sym_print_statement] = STATE(916),
    [sym_assert_statement] = STATE(916),
    [sym_expression_statement] = STATE(916),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(916),
    [sym_delete_statement] = STATE(916),
    [sym_raise_statement] = STATE(916),
    [sym_pass_statement] = STATE(916),
    [sym_break_statement] = STATE(916),
    [sym_continue_statement] = STATE(916),
    [sym_global_statement] = STATE(916),
    [sym_nonlocal_statement] = STATE(916),
    [sym_exec_statement] = STATE(916),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(261),
    [sym__string_start] = ACTIONS(73),
  },
  [52] = {
    [sym__simple_statements] = STATE(473),
    [sym_import_statement] = STATE(938),
    [sym_future_import_statement] = STATE(938),
    [sym_import_from_statement] = STATE(938),
    [sym_print_statement] = STATE(938),
    [sym_assert_statement] = STATE(938),
    [sym_expression_statement] = STATE(938),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(938),
    [sym_delete_statement] = STATE(938),
    [sym_raise_statement] = STATE(938),
    [sym_pass_statement] = STATE(938),
    [sym_break_statement] = STATE(938),
    [sym_continue_statement] = STATE(938),
    [sym_global_statement] = STATE(938),
    [sym_nonlocal_statement] = STATE(938),
    [sym_exec_statement] = STATE(938),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(263),
    [sym__string_start] = ACTIONS(73),
  },
  [53] = {
    [sym__simple_statements] = STATE(318),
    [sym_import_statement] = STATE(938),
    [sym_future_import_statement] = STATE(938),
    [sym_import_from_statement] = STATE(938),
    [sym_print_statement] = STATE(938),
    [sym_assert_statement] = STATE(938),
    [sym_expression_statement] = STATE(938),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(938),
    [sym_delete_statement] = STATE(938),
    [sym_raise_statement] = STATE(938),
    [sym_pass_statement] = STATE(938),
    [sym_break_statement] = STATE(938),
    [sym_continue_statement] = STATE(938),
    [sym_global_statement] = STATE(938),
    [sym_nonlocal_statement] = STATE(938),
    [sym_exec_statement] = STATE(938),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(265),
    [sym__string_start] = ACTIONS(73),
  },
  [54] = {
    [sym__simple_statements] = STATE(470),
    [sym_import_statement] = STATE(938),
    [sym_future_import_statement] = STATE(938),
    [sym_import_from_statement] = STATE(938),
    [sym_print_statement] = STATE(938),
    [sym_assert_statement] = STATE(938),
    [sym_expression_statement] = STATE(938),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(938),
    [sym_delete_statement] = STATE(938),
    [sym_raise_statement] = STATE(938),
    [sym_pass_statement] = STATE(938),
    [sym_break_statement] = STATE(938),
    [sym_continue_statement] = STATE(938),
    [sym_global_statement] = STATE(938),
    [sym_nonlocal_statement] = STATE(938),
    [sym_exec_statement] = STATE(938),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(267),
    [sym__string_start] = ACTIONS(73),
  },
  [55] = {
    [sym__simple_statements] = STATE(409),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(269),
    [sym__string_start] = ACTIONS(73),
  },
  [56] = {
    [sym__simple_statements] = STATE(384),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(271),
    [sym__string_start] = ACTIONS(73),
  },
  [57] = {
    [sym__simple_statements] = STATE(468),
    [sym_import_statement] = STATE(938),
    [sym_future_import_statement] = STATE(938),
    [sym_import_from_statement] = STATE(938),
    [sym_print_statement] = STATE(938),
    [sym_assert_statement] = STATE(938),
    [sym_expression_statement] = STATE(938),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(938),
    [sym_delete_statement] = STATE(938),
    [sym_raise_statement] = STATE(938),
    [sym_pass_statement] = STATE(938),
    [sym_break_statement] = STATE(938),
    [sym_continue_statement] = STATE(938),
    [sym_global_statement] = STATE(938),
    [sym_nonlocal_statement] = STATE(938),
    [sym_exec_statement] = STATE(938),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(273),
    [sym__string_start] = ACTIONS(73),
  },
  [58] = {
    [sym__simple_statements] = STATE(493),
    [sym_import_statement] = STATE(938),
    [sym_future_import_statement] = STATE(938),
    [sym_import_from_statement] = STATE(938),
    [sym_print_statement] = STATE(938),
    [sym_assert_statement] = STATE(938),
    [sym_expression_statement] = STATE(938),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(938),
    [sym_delete_statement] = STATE(938),
    [sym_raise_statement] = STATE(938),
    [sym_pass_statement] = STATE(938),
    [sym_break_statement] = STATE(938),
    [sym_continue_statement] = STATE(938),
    [sym_global_statement] = STATE(938),
    [sym_nonlocal_statement] = STATE(938),
    [sym_exec_statement] = STATE(938),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(275),
    [sym__string_start] = ACTIONS(73),
  },
  [59] = {
    [sym__simple_statements] = STATE(437),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(277),
    [sym__string_start] = ACTIONS(73),
  },
  [60] = {
    [sym__simple_statements] = STATE(322),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(279),
    [sym__string_start] = ACTIONS(73),
  },
  [61] = {
    [sym__simple_statements] = STATE(385),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(281),
    [sym__string_start] = ACTIONS(73),
  },
  [62] = {
    [sym__simple_statements] = STATE(477),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(283),
    [sym__string_start] = ACTIONS(73),
  },
  [63] = {
    [sym__simple_statements] = STATE(338),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(285),
    [sym__string_start] = ACTIONS(73),
  },
  [64] = {
    [sym__simple_statements] = STATE(467),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(287),
    [sym__string_start] = ACTIONS(73),
  },
  [65] = {
    [sym__simple_statements] = STATE(419),
    [sym_import_statement] = STATE(938),
    [sym_future_import_statement] = STATE(938),
    [sym_import_from_statement] = STATE(938),
    [sym_print_statement] = STATE(938),
    [sym_assert_statement] = STATE(938),
    [sym_expression_statement] = STATE(938),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(938),
    [sym_delete_statement] = STATE(938),
    [sym_raise_statement] = STATE(938),
    [sym_pass_statement] = STATE(938),
    [sym_break_statement] = STATE(938),
    [sym_continue_statement] = STATE(938),
    [sym_global_statement] = STATE(938),
    [sym_nonlocal_statement] = STATE(938),
    [sym_exec_statement] = STATE(938),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(289),
    [sym__string_start] = ACTIONS(73),
  },
  [66] = {
    [sym__simple_statements] = STATE(407),
    [sym_import_statement] = STATE(938),
    [sym_future_import_statement] = STATE(938),
    [sym_import_from_statement] = STATE(938),
    [sym_print_statement] = STATE(938),
    [sym_assert_statement] = STATE(938),
    [sym_expression_statement] = STATE(938),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(938),
    [sym_delete_statement] = STATE(938),
    [sym_raise_statement] = STATE(938),
    [sym_pass_statement] = STATE(938),
    [sym_break_statement] = STATE(938),
    [sym_continue_statement] = STATE(938),
    [sym_global_statement] = STATE(938),
    [sym_nonlocal_statement] = STATE(938),
    [sym_exec_statement] = STATE(938),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(291),
    [sym__string_start] = ACTIONS(73),
  },
  [67] = {
    [sym__simple_statements] = STATE(451),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(293),
    [sym__string_start] = ACTIONS(73),
  },
  [68] = {
    [sym__simple_statements] = STATE(351),
    [sym_import_statement] = STATE(938),
    [sym_future_import_statement] = STATE(938),
    [sym_import_from_statement] = STATE(938),
    [sym_print_statement] = STATE(938),
    [sym_assert_statement] = STATE(938),
    [sym_expression_statement] = STATE(938),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(938),
    [sym_delete_statement] = STATE(938),
    [sym_raise_statement] = STATE(938),
    [sym_pass_statement] = STATE(938),
    [sym_break_statement] = STATE(938),
    [sym_continue_statement] = STATE(938),
    [sym_global_statement] = STATE(938),
    [sym_nonlocal_statement] = STATE(938),
    [sym_exec_statement] = STATE(938),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(295),
    [sym__string_start] = ACTIONS(73),
  },
  [69] = {
    [sym__simple_statements] = STATE(450),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(297),
    [sym__string_start] = ACTIONS(73),
  },
  [70] = {
    [sym__simple_statements] = STATE(388),
    [sym_import_statement] = STATE(938),
    [sym_future_import_statement] = STATE(938),
    [sym_import_from_statement] = STATE(938),
    [sym_print_statement] = STATE(938),
    [sym_assert_statement] = STATE(938),
    [sym_expression_statement] = STATE(938),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(938),
    [sym_delete_statement] = STATE(938),
    [sym_raise_statement] = STATE(938),
    [sym_pass_statement] = STATE(938),
    [sym_break_statement] = STATE(938),
    [sym_continue_statement] = STATE(938),
    [sym_global_statement] = STATE(938),
    [sym_nonlocal_statement] = STATE(938),
    [sym_exec_statement] = STATE(938),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(299),
    [sym__string_start] = ACTIONS(73),
  },
  [71] = {
    [sym__simple_statements] = STATE(391),
    [sym_import_statement] = STATE(938),
    [sym_future_import_statement] = STATE(938),
    [sym_import_from_statement] = STATE(938),
    [sym_print_statement] = STATE(938),
    [sym_assert_statement] = STATE(938),
    [sym_expression_statement] = STATE(938),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(938),
    [sym_delete_statement] = STATE(938),
    [sym_raise_statement] = STATE(938),
    [sym_pass_statement] = STATE(938),
    [sym_break_statement] = STATE(938),
    [sym_continue_statement] = STATE(938),
    [sym_global_statement] = STATE(938),
    [sym_nonlocal_statement] = STATE(938),
    [sym_exec_statement] = STATE(938),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(301),
    [sym__string_start] = ACTIONS(73),
  },
  [72] = {
    [sym__simple_statements] = STATE(482),
    [sym_import_statement] = STATE(938),
    [sym_future_import_statement] = STATE(938),
    [sym_import_from_statement] = STATE(938),
    [sym_print_statement] = STATE(938),
    [sym_assert_statement] = STATE(938),
    [sym_expression_statement] = STATE(938),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(938),
    [sym_delete_statement] = STATE(938),
    [sym_raise_statement] = STATE(938),
    [sym_pass_statement] = STATE(938),
    [sym_break_statement] = STATE(938),
    [sym_continue_statement] = STATE(938),
    [sym_global_statement] = STATE(938),
    [sym_nonlocal_statement] = STATE(938),
    [sym_exec_statement] = STATE(938),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(303),
    [sym__string_start] = ACTIONS(73),
  },
  [73] = {
    [sym__simple_statements] = STATE(315),
    [sym_import_statement] = STATE(938),
    [sym_future_import_statement] = STATE(938),
    [sym_import_from_statement] = STATE(938),
    [sym_print_statement] = STATE(938),
    [sym_assert_statement] = STATE(938),
    [sym_expression_statement] = STATE(938),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(938),
    [sym_delete_statement] = STATE(938),
    [sym_raise_statement] = STATE(938),
    [sym_pass_statement] = STATE(938),
    [sym_break_statement] = STATE(938),
    [sym_continue_statement] = STATE(938),
    [sym_global_statement] = STATE(938),
    [sym_nonlocal_statement] = STATE(938),
    [sym_exec_statement] = STATE(938),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(305),
    [sym__string_start] = ACTIONS(73),
  },
  [74] = {
    [sym__simple_statements] = STATE(447),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(307),
    [sym__string_start] = ACTIONS(73),
  },
  [75] = {
    [sym__simple_statements] = STATE(370),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(309),
    [sym__string_start] = ACTIONS(73),
  },
  [76] = {
    [sym__simple_statements] = STATE(394),
    [sym_import_statement] = STATE(938),
    [sym_future_import_statement] = STATE(938),
    [sym_import_from_statement] = STATE(938),
    [sym_print_statement] = STATE(938),
    [sym_assert_statement] = STATE(938),
    [sym_expression_statement] = STATE(938),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(938),
    [sym_delete_statement] = STATE(938),
    [sym_raise_statement] = STATE(938),
    [sym_pass_statement] = STATE(938),
    [sym_break_statement] = STATE(938),
    [sym_continue_statement] = STATE(938),
    [sym_global_statement] = STATE(938),
    [sym_nonlocal_statement] = STATE(938),
    [sym_exec_statement] = STATE(938),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(311),
    [sym__string_start] = ACTIONS(73),
  },
  [77] = {
    [sym__simple_statements] = STATE(392),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(313),
    [sym__string_start] = ACTIONS(73),
  },
  [78] = {
    [sym__simple_statements] = STATE(480),
    [sym_import_statement] = STATE(938),
    [sym_future_import_statement] = STATE(938),
    [sym_import_from_statement] = STATE(938),
    [sym_print_statement] = STATE(938),
    [sym_assert_statement] = STATE(938),
    [sym_expression_statement] = STATE(938),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(938),
    [sym_delete_statement] = STATE(938),
    [sym_raise_statement] = STATE(938),
    [sym_pass_statement] = STATE(938),
    [sym_break_statement] = STATE(938),
    [sym_continue_statement] = STATE(938),
    [sym_global_statement] = STATE(938),
    [sym_nonlocal_statement] = STATE(938),
    [sym_exec_statement] = STATE(938),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(315),
    [sym__string_start] = ACTIONS(73),
  },
  [79] = {
    [sym__simple_statements] = STATE(269),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(317),
    [sym__string_start] = ACTIONS(73),
  },
  [80] = {
    [sym__simple_statements] = STATE(413),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(319),
    [sym__string_start] = ACTIONS(73),
  },
  [81] = {
    [sym__simple_statements] = STATE(397),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(321),
    [sym__string_start] = ACTIONS(73),
  },
  [82] = {
    [sym__simple_statements] = STATE(414),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(323),
    [sym__string_start] = ACTIONS(73),
  },
  [83] = {
    [sym__simple_statements] = STATE(254),
    [sym_import_statement] = STATE(938),
    [sym_future_import_statement] = STATE(938),
    [sym_import_from_statement] = STATE(938),
    [sym_print_statement] = STATE(938),
    [sym_assert_statement] = STATE(938),
    [sym_expression_statement] = STATE(938),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(938),
    [sym_delete_statement] = STATE(938),
    [sym_raise_statement] = STATE(938),
    [sym_pass_statement] = STATE(938),
    [sym_break_statement] = STATE(938),
    [sym_continue_statement] = STATE(938),
    [sym_global_statement] = STATE(938),
    [sym_nonlocal_statement] = STATE(938),
    [sym_exec_statement] = STATE(938),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(325),
    [sym__string_start] = ACTIONS(73),
  },
  [84] = {
    [sym__simple_statements] = STATE(469),
    [sym_import_statement] = STATE(938),
    [sym_future_import_statement] = STATE(938),
    [sym_import_from_statement] = STATE(938),
    [sym_print_statement] = STATE(938),
    [sym_assert_statement] = STATE(938),
    [sym_expression_statement] = STATE(938),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(938),
    [sym_delete_statement] = STATE(938),
    [sym_raise_statement] = STATE(938),
    [sym_pass_statement] = STATE(938),
    [sym_break_statement] = STATE(938),
    [sym_continue_statement] = STATE(938),
    [sym_global_statement] = STATE(938),
    [sym_nonlocal_statement] = STATE(938),
    [sym_exec_statement] = STATE(938),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(327),
    [sym__string_start] = ACTIONS(73),
  },
  [85] = {
    [sym__simple_statements] = STATE(425),
    [sym_import_statement] = STATE(938),
    [sym_future_import_statement] = STATE(938),
    [sym_import_from_statement] = STATE(938),
    [sym_print_statement] = STATE(938),
    [sym_assert_statement] = STATE(938),
    [sym_expression_statement] = STATE(938),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(938),
    [sym_delete_statement] = STATE(938),
    [sym_raise_statement] = STATE(938),
    [sym_pass_statement] = STATE(938),
    [sym_break_statement] = STATE(938),
    [sym_continue_statement] = STATE(938),
    [sym_global_statement] = STATE(938),
    [sym_nonlocal_statement] = STATE(938),
    [sym_exec_statement] = STATE(938),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(329),
    [sym__string_start] = ACTIONS(73),
  },
  [86] = {
    [sym__simple_statements] = STATE(420),
    [sym_import_statement] = STATE(938),
    [sym_future_import_statement] = STATE(938),
    [sym_import_from_statement] = STATE(938),
    [sym_print_statement] = STATE(938),
    [sym_assert_statement] = STATE(938),
    [sym_expression_statement] = STATE(938),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(938),
    [sym_delete_statement] = STATE(938),
    [sym_raise_statement] = STATE(938),
    [sym_pass_statement] = STATE(938),
    [sym_break_statement] = STATE(938),
    [sym_continue_statement] = STATE(938),
    [sym_global_statement] = STATE(938),
    [sym_nonlocal_statement] = STATE(938),
    [sym_exec_statement] = STATE(938),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(331),
    [sym__string_start] = ACTIONS(73),
  },
  [87] = {
    [sym__simple_statements] = STATE(443),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(333),
    [sym__string_start] = ACTIONS(73),
  },
  [88] = {
    [sym__simple_statements] = STATE(492),
    [sym_import_statement] = STATE(1007),
    [sym_future_import_statement] = STATE(1007),
    [sym_import_from_statement] = STATE(1007),
    [sym_print_statement] = STATE(1007),
    [sym_assert_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1007),
    [sym_delete_statement] = STATE(1007),
    [sym_raise_statement] = STATE(1007),
    [sym_pass_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_global_statement] = STATE(1007),
    [sym_nonlocal_statement] = STATE(1007),
    [sym_exec_statement] = STATE(1007),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(335),
    [sym__string_start] = ACTIONS(73),
  },
  [89] = {
    [sym_import_statement] = STATE(1046),
    [sym_future_import_statement] = STATE(1046),
    [sym_import_from_statement] = STATE(1046),
    [sym_print_statement] = STATE(1046),
    [sym_assert_statement] = STATE(1046),
    [sym_expression_statement] = STATE(1046),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1046),
    [sym_delete_statement] = STATE(1046),
    [sym_raise_statement] = STATE(1046),
    [sym_pass_statement] = STATE(1046),
    [sym_break_statement] = STATE(1046),
    [sym_continue_statement] = STATE(1046),
    [sym_global_statement] = STATE(1046),
    [sym_nonlocal_statement] = STATE(1046),
    [sym_exec_statement] = STATE(1046),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(337),
    [sym__string_start] = ACTIONS(73),
  },
  [90] = {
    [sym_import_statement] = STATE(1046),
    [sym_future_import_statement] = STATE(1046),
    [sym_import_from_statement] = STATE(1046),
    [sym_print_statement] = STATE(1046),
    [sym_assert_statement] = STATE(1046),
    [sym_expression_statement] = STATE(1046),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1046),
    [sym_delete_statement] = STATE(1046),
    [sym_raise_statement] = STATE(1046),
    [sym_pass_statement] = STATE(1046),
    [sym_break_statement] = STATE(1046),
    [sym_continue_statement] = STATE(1046),
    [sym_global_statement] = STATE(1046),
    [sym_nonlocal_statement] = STATE(1046),
    [sym_exec_statement] = STATE(1046),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(339),
    [sym__string_start] = ACTIONS(73),
  },
  [91] = {
    [sym_import_statement] = STATE(1046),
    [sym_future_import_statement] = STATE(1046),
    [sym_import_from_statement] = STATE(1046),
    [sym_print_statement] = STATE(1046),
    [sym_assert_statement] = STATE(1046),
    [sym_expression_statement] = STATE(1046),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1046),
    [sym_delete_statement] = STATE(1046),
    [sym_raise_statement] = STATE(1046),
    [sym_pass_statement] = STATE(1046),
    [sym_break_statement] = STATE(1046),
    [sym_continue_statement] = STATE(1046),
    [sym_global_statement] = STATE(1046),
    [sym_nonlocal_statement] = STATE(1046),
    [sym_exec_statement] = STATE(1046),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(341),
    [sym__string_start] = ACTIONS(73),
  },
  [92] = {
    [sym_import_statement] = STATE(1046),
    [sym_future_import_statement] = STATE(1046),
    [sym_import_from_statement] = STATE(1046),
    [sym_print_statement] = STATE(1046),
    [sym_assert_statement] = STATE(1046),
    [sym_expression_statement] = STATE(1046),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1046),
    [sym_delete_statement] = STATE(1046),
    [sym_raise_statement] = STATE(1046),
    [sym_pass_statement] = STATE(1046),
    [sym_break_statement] = STATE(1046),
    [sym_continue_statement] = STATE(1046),
    [sym_global_statement] = STATE(1046),
    [sym_nonlocal_statement] = STATE(1046),
    [sym_exec_statement] = STATE(1046),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(343),
    [sym__string_start] = ACTIONS(73),
  },
  [93] = {
    [sym_import_statement] = STATE(1046),
    [sym_future_import_statement] = STATE(1046),
    [sym_import_from_statement] = STATE(1046),
    [sym_print_statement] = STATE(1046),
    [sym_assert_statement] = STATE(1046),
    [sym_expression_statement] = STATE(1046),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1046),
    [sym_delete_statement] = STATE(1046),
    [sym_raise_statement] = STATE(1046),
    [sym_pass_statement] = STATE(1046),
    [sym_break_statement] = STATE(1046),
    [sym_continue_statement] = STATE(1046),
    [sym_global_statement] = STATE(1046),
    [sym_nonlocal_statement] = STATE(1046),
    [sym_exec_statement] = STATE(1046),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(345),
    [sym__string_start] = ACTIONS(73),
  },
  [94] = {
    [sym_import_statement] = STATE(1046),
    [sym_future_import_statement] = STATE(1046),
    [sym_import_from_statement] = STATE(1046),
    [sym_print_statement] = STATE(1046),
    [sym_assert_statement] = STATE(1046),
    [sym_expression_statement] = STATE(1046),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1046),
    [sym_delete_statement] = STATE(1046),
    [sym_raise_statement] = STATE(1046),
    [sym_pass_statement] = STATE(1046),
    [sym_break_statement] = STATE(1046),
    [sym_continue_statement] = STATE(1046),
    [sym_global_statement] = STATE(1046),
    [sym_nonlocal_statement] = STATE(1046),
    [sym_exec_statement] = STATE(1046),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(347),
    [sym__string_start] = ACTIONS(73),
  },
  [95] = {
    [sym_import_statement] = STATE(1046),
    [sym_future_import_statement] = STATE(1046),
    [sym_import_from_statement] = STATE(1046),
    [sym_print_statement] = STATE(1046),
    [sym_assert_statement] = STATE(1046),
    [sym_expression_statement] = STATE(1046),
    [sym_named_expression] = STATE(687),
    [sym_return_statement] = STATE(1046),
    [sym_delete_statement] = STATE(1046),
    [sym_raise_statement] = STATE(1046),
    [sym_pass_statement] = STATE(1046),
    [sym_break_statement] = STATE(1046),
    [sym_continue_statement] = STATE(1046),
    [sym_global_statement] = STATE(1046),
    [sym_nonlocal_statement] = STATE(1046),
    [sym_exec_statement] = STATE(1046),
    [sym_expression_list] = STATE(705),
    [sym__expression] = STATE(687),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(687),
    [sym_boolean_operator] = STATE(687),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_assignment] = STATE(1034),
    [sym_augmented_assignment] = STATE(1034),
    [sym_yield] = STATE(1034),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(687),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(687),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [96] = {
    [sym_named_expression] = STATE(695),
    [sym__expression] = STATE(695),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(695),
    [sym_boolean_operator] = STATE(695),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(695),
    [sym_lambda] = STATE(695),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(695),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(695),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(349),
    [anon_sym_COLON] = ACTIONS(351),
    [anon_sym_EQ] = ACTIONS(351),
    [anon_sym_exec] = ACTIONS(349),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(353),
    [anon_sym_DASH] = ACTIONS(353),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_PLUS_EQ] = ACTIONS(351),
    [anon_sym_DASH_EQ] = ACTIONS(351),
    [anon_sym_STAR_EQ] = ACTIONS(351),
    [anon_sym_SLASH_EQ] = ACTIONS(351),
    [anon_sym_AT_EQ] = ACTIONS(351),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(351),
    [anon_sym_PERCENT_EQ] = ACTIONS(351),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(351),
    [anon_sym_GT_GT_EQ] = ACTIONS(351),
    [anon_sym_LT_LT_EQ] = ACTIONS(351),
    [anon_sym_AMP_EQ] = ACTIONS(351),
    [anon_sym_CARET_EQ] = ACTIONS(351),
    [anon_sym_PIPE_EQ] = ACTIONS(351),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(351),
    [sym__newline] = ACTIONS(351),
    [sym__string_start] = ACTIONS(73),
  },
  [97] = {
    [sym_named_expression] = STATE(695),
    [sym__expression] = STATE(695),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(695),
    [sym_boolean_operator] = STATE(695),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(695),
    [sym_lambda] = STATE(695),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(695),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(695),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(349),
    [anon_sym_COLON] = ACTIONS(355),
    [anon_sym_EQ] = ACTIONS(355),
    [anon_sym_exec] = ACTIONS(349),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(353),
    [anon_sym_DASH] = ACTIONS(353),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_PLUS_EQ] = ACTIONS(355),
    [anon_sym_DASH_EQ] = ACTIONS(355),
    [anon_sym_STAR_EQ] = ACTIONS(355),
    [anon_sym_SLASH_EQ] = ACTIONS(355),
    [anon_sym_AT_EQ] = ACTIONS(355),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(355),
    [anon_sym_PERCENT_EQ] = ACTIONS(355),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(355),
    [anon_sym_GT_GT_EQ] = ACTIONS(355),
    [anon_sym_LT_LT_EQ] = ACTIONS(355),
    [anon_sym_AMP_EQ] = ACTIONS(355),
    [anon_sym_CARET_EQ] = ACTIONS(355),
    [anon_sym_PIPE_EQ] = ACTIONS(355),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(357),
    [sym__newline] = ACTIONS(357),
    [sym__string_start] = ACTIONS(73),
  },
  [98] = {
    [sym_named_expression] = STATE(695),
    [sym__expression] = STATE(695),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(695),
    [sym_boolean_operator] = STATE(695),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(695),
    [sym_lambda] = STATE(695),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(695),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(695),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(349),
    [anon_sym_COLON] = ACTIONS(351),
    [anon_sym_EQ] = ACTIONS(351),
    [anon_sym_exec] = ACTIONS(349),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(353),
    [anon_sym_DASH] = ACTIONS(353),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_PLUS_EQ] = ACTIONS(351),
    [anon_sym_DASH_EQ] = ACTIONS(351),
    [anon_sym_STAR_EQ] = ACTIONS(351),
    [anon_sym_SLASH_EQ] = ACTIONS(351),
    [anon_sym_AT_EQ] = ACTIONS(351),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(351),
    [anon_sym_PERCENT_EQ] = ACTIONS(351),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(351),
    [anon_sym_GT_GT_EQ] = ACTIONS(351),
    [anon_sym_LT_LT_EQ] = ACTIONS(351),
    [anon_sym_AMP_EQ] = ACTIONS(351),
    [anon_sym_CARET_EQ] = ACTIONS(351),
    [anon_sym_PIPE_EQ] = ACTIONS(351),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(359),
    [sym__newline] = ACTIONS(359),
    [sym__string_start] = ACTIONS(73),
  },
  [99] = {
    [sym_named_expression] = STATE(695),
    [sym__expression] = STATE(695),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(695),
    [sym_boolean_operator] = STATE(695),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(695),
    [sym_lambda] = STATE(695),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(695),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(695),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(349),
    [anon_sym_COLON] = ACTIONS(355),
    [anon_sym_EQ] = ACTIONS(355),
    [anon_sym_exec] = ACTIONS(349),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(353),
    [anon_sym_DASH] = ACTIONS(353),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_PLUS_EQ] = ACTIONS(355),
    [anon_sym_DASH_EQ] = ACTIONS(355),
    [anon_sym_STAR_EQ] = ACTIONS(355),
    [anon_sym_SLASH_EQ] = ACTIONS(355),
    [anon_sym_AT_EQ] = ACTIONS(355),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(355),
    [anon_sym_PERCENT_EQ] = ACTIONS(355),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(355),
    [anon_sym_GT_GT_EQ] = ACTIONS(355),
    [anon_sym_LT_LT_EQ] = ACTIONS(355),
    [anon_sym_AMP_EQ] = ACTIONS(355),
    [anon_sym_CARET_EQ] = ACTIONS(355),
    [anon_sym_PIPE_EQ] = ACTIONS(355),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(355),
    [sym__newline] = ACTIONS(355),
    [sym__string_start] = ACTIONS(73),
  },
  [100] = {
    [sym_named_expression] = STATE(749),
    [sym__expression_within_for_in_clause] = STATE(781),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(749),
    [sym_boolean_operator] = STATE(749),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(749),
    [sym_lambda] = STATE(749),
    [sym_lambda_within_for_in_clause] = STATE(781),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(749),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(749),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_RPAREN] = ACTIONS(365),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_async] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(377),
    [anon_sym_RBRACK] = ACTIONS(365),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_RBRACE] = ACTIONS(365),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [101] = {
    [sym_named_expression] = STATE(749),
    [sym__expression_within_for_in_clause] = STATE(781),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(749),
    [sym_boolean_operator] = STATE(749),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(749),
    [sym_lambda] = STATE(749),
    [sym_lambda_within_for_in_clause] = STATE(781),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(749),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(749),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_RPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_if] = ACTIONS(391),
    [anon_sym_async] = ACTIONS(391),
    [anon_sym_for] = ACTIONS(391),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(377),
    [anon_sym_RBRACK] = ACTIONS(389),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_RBRACE] = ACTIONS(389),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [102] = {
    [sym_named_expression] = STATE(749),
    [sym__expression_within_for_in_clause] = STATE(781),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(749),
    [sym_boolean_operator] = STATE(749),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(749),
    [sym_lambda] = STATE(749),
    [sym_lambda_within_for_in_clause] = STATE(781),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(749),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(749),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_RPAREN] = ACTIONS(393),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_if] = ACTIONS(395),
    [anon_sym_async] = ACTIONS(395),
    [anon_sym_for] = ACTIONS(395),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(377),
    [anon_sym_RBRACK] = ACTIONS(393),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_RBRACE] = ACTIONS(393),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [103] = {
    [sym_named_expression] = STATE(749),
    [sym__expression_within_for_in_clause] = STATE(781),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(749),
    [sym_boolean_operator] = STATE(749),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(749),
    [sym_lambda] = STATE(749),
    [sym_lambda_within_for_in_clause] = STATE(781),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(749),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(749),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_RPAREN] = ACTIONS(397),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_if] = ACTIONS(399),
    [anon_sym_async] = ACTIONS(399),
    [anon_sym_for] = ACTIONS(399),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(377),
    [anon_sym_RBRACK] = ACTIONS(397),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_RBRACE] = ACTIONS(397),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [104] = {
    [sym_string] = STATE(109),
    [aux_sym_concatenated_string_repeat1] = STATE(109),
    [anon_sym_DOT] = ACTIONS(401),
    [anon_sym_LPAREN] = ACTIONS(401),
    [anon_sym_COMMA] = ACTIONS(401),
    [anon_sym_STAR] = ACTIONS(403),
    [anon_sym_GT_GT] = ACTIONS(403),
    [anon_sym_if] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(401),
    [anon_sym_in] = ACTIONS(401),
    [anon_sym_EQ] = ACTIONS(403),
    [anon_sym_AT] = ACTIONS(403),
    [anon_sym_not] = ACTIONS(401),
    [anon_sym_and] = ACTIONS(401),
    [anon_sym_or] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_SLASH] = ACTIONS(403),
    [anon_sym_PERCENT] = ACTIONS(403),
    [anon_sym_SLASH_SLASH] = ACTIONS(403),
    [anon_sym_STAR_STAR] = ACTIONS(403),
    [anon_sym_PIPE] = ACTIONS(403),
    [anon_sym_AMP] = ACTIONS(403),
    [anon_sym_CARET] = ACTIONS(403),
    [anon_sym_LT_LT] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(403),
    [anon_sym_LT_EQ] = ACTIONS(401),
    [anon_sym_EQ_EQ] = ACTIONS(401),
    [anon_sym_BANG_EQ] = ACTIONS(401),
    [anon_sym_GT_EQ] = ACTIONS(401),
    [anon_sym_GT] = ACTIONS(403),
    [anon_sym_LT_GT] = ACTIONS(401),
    [anon_sym_is] = ACTIONS(401),
    [anon_sym_PLUS_EQ] = ACTIONS(401),
    [anon_sym_DASH_EQ] = ACTIONS(401),
    [anon_sym_STAR_EQ] = ACTIONS(401),
    [anon_sym_SLASH_EQ] = ACTIONS(401),
    [anon_sym_AT_EQ] = ACTIONS(401),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(401),
    [anon_sym_PERCENT_EQ] = ACTIONS(401),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(401),
    [anon_sym_GT_GT_EQ] = ACTIONS(401),
    [anon_sym_LT_LT_EQ] = ACTIONS(401),
    [anon_sym_AMP_EQ] = ACTIONS(401),
    [anon_sym_CARET_EQ] = ACTIONS(401),
    [anon_sym_PIPE_EQ] = ACTIONS(401),
    [anon_sym_LBRACK] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(401),
    [sym__newline] = ACTIONS(401),
    [sym__string_start] = ACTIONS(73),
  },
  [105] = {
    [sym_named_expression] = STATE(733),
    [sym_list_splat] = STATE(926),
    [sym_dictionary_splat] = STATE(927),
    [sym__expression] = STATE(733),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(733),
    [sym_boolean_operator] = STATE(733),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(733),
    [sym_lambda] = STATE(733),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_pair] = STATE(769),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(733),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(733),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_COMMA] = ACTIONS(405),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_RBRACE] = ACTIONS(411),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [106] = {
    [sym_named_expression] = STATE(729),
    [sym_list_splat] = STATE(1017),
    [sym_dictionary_splat] = STATE(1018),
    [sym__expression] = STATE(729),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(729),
    [sym_boolean_operator] = STATE(729),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(729),
    [sym_lambda] = STATE(729),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_pair] = STATE(792),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(729),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(729),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_COMMA] = ACTIONS(413),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_RBRACE] = ACTIONS(415),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [107] = {
    [sym_named_expression] = STATE(743),
    [sym_list_splat] = STATE(956),
    [sym_dictionary_splat] = STATE(956),
    [sym__expression] = STATE(743),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(743),
    [sym_boolean_operator] = STATE(743),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(743),
    [sym_lambda] = STATE(743),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_keyword_argument] = STATE(956),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(743),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(743),
    [sym_identifier] = ACTIONS(417),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_print] = ACTIONS(423),
    [anon_sym_exec] = ACTIONS(423),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [108] = {
    [sym_named_expression] = STATE(744),
    [sym_list_splat] = STATE(1021),
    [sym_dictionary_splat] = STATE(1021),
    [sym__expression] = STATE(744),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(744),
    [sym_boolean_operator] = STATE(744),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(744),
    [sym_lambda] = STATE(744),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_keyword_argument] = STATE(1021),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(744),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(744),
    [sym_identifier] = ACTIONS(417),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_RPAREN] = ACTIONS(425),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_print] = ACTIONS(423),
    [anon_sym_exec] = ACTIONS(423),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [109] = {
    [sym_string] = STATE(109),
    [aux_sym_concatenated_string_repeat1] = STATE(109),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_COMMA] = ACTIONS(429),
    [anon_sym_STAR] = ACTIONS(431),
    [anon_sym_GT_GT] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(429),
    [anon_sym_COLON] = ACTIONS(429),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_EQ] = ACTIONS(431),
    [anon_sym_AT] = ACTIONS(431),
    [anon_sym_not] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PLUS] = ACTIONS(431),
    [anon_sym_DASH] = ACTIONS(431),
    [anon_sym_SLASH] = ACTIONS(431),
    [anon_sym_PERCENT] = ACTIONS(431),
    [anon_sym_SLASH_SLASH] = ACTIONS(431),
    [anon_sym_STAR_STAR] = ACTIONS(431),
    [anon_sym_PIPE] = ACTIONS(431),
    [anon_sym_AMP] = ACTIONS(431),
    [anon_sym_CARET] = ACTIONS(431),
    [anon_sym_LT_LT] = ACTIONS(431),
    [anon_sym_LT] = ACTIONS(431),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(431),
    [anon_sym_LT_GT] = ACTIONS(429),
    [anon_sym_is] = ACTIONS(429),
    [anon_sym_PLUS_EQ] = ACTIONS(429),
    [anon_sym_DASH_EQ] = ACTIONS(429),
    [anon_sym_STAR_EQ] = ACTIONS(429),
    [anon_sym_SLASH_EQ] = ACTIONS(429),
    [anon_sym_AT_EQ] = ACTIONS(429),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(429),
    [anon_sym_PERCENT_EQ] = ACTIONS(429),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(429),
    [anon_sym_GT_GT_EQ] = ACTIONS(429),
    [anon_sym_LT_LT_EQ] = ACTIONS(429),
    [anon_sym_AMP_EQ] = ACTIONS(429),
    [anon_sym_CARET_EQ] = ACTIONS(429),
    [anon_sym_PIPE_EQ] = ACTIONS(429),
    [anon_sym_LBRACK] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(429),
    [sym__newline] = ACTIONS(429),
    [sym__string_start] = ACTIONS(433),
  },
  [110] = {
    [sym_named_expression] = STATE(827),
    [sym_list_splat] = STATE(957),
    [sym_dictionary_splat] = STATE(957),
    [sym__expression] = STATE(827),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(827),
    [sym_boolean_operator] = STATE(827),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(827),
    [sym_lambda] = STATE(827),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_keyword_argument] = STATE(957),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(827),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(827),
    [sym_identifier] = ACTIONS(417),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_RPAREN] = ACTIONS(436),
    [anon_sym_COMMA] = ACTIONS(438),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_print] = ACTIONS(423),
    [anon_sym_exec] = ACTIONS(423),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [111] = {
    [sym_named_expression] = STATE(685),
    [sym_expression_list] = STATE(702),
    [sym__expression] = STATE(685),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(685),
    [sym_boolean_operator] = STATE(685),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(685),
    [sym_lambda] = STATE(685),
    [sym_assignment] = STATE(1043),
    [sym_augmented_assignment] = STATE(1043),
    [sym__right_hand_side] = STATE(1043),
    [sym_yield] = STATE(1043),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(685),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(685),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(349),
    [anon_sym_exec] = ACTIONS(349),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [112] = {
    [sym_named_expression] = STATE(824),
    [sym_list_splat] = STATE(1021),
    [sym_dictionary_splat] = STATE(1021),
    [sym__expression] = STATE(824),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(824),
    [sym_boolean_operator] = STATE(824),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(824),
    [sym_lambda] = STATE(824),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_keyword_argument] = STATE(1021),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(824),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(824),
    [sym_identifier] = ACTIONS(417),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_RPAREN] = ACTIONS(425),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_print] = ACTIONS(423),
    [anon_sym_exec] = ACTIONS(423),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [113] = {
    [sym_string] = STATE(104),
    [aux_sym_concatenated_string_repeat1] = STATE(104),
    [anon_sym_DOT] = ACTIONS(440),
    [anon_sym_LPAREN] = ACTIONS(440),
    [anon_sym_COMMA] = ACTIONS(440),
    [anon_sym_STAR] = ACTIONS(442),
    [anon_sym_GT_GT] = ACTIONS(442),
    [anon_sym_if] = ACTIONS(440),
    [anon_sym_COLON] = ACTIONS(440),
    [anon_sym_in] = ACTIONS(440),
    [anon_sym_EQ] = ACTIONS(442),
    [anon_sym_AT] = ACTIONS(442),
    [anon_sym_not] = ACTIONS(440),
    [anon_sym_and] = ACTIONS(440),
    [anon_sym_or] = ACTIONS(440),
    [anon_sym_PLUS] = ACTIONS(442),
    [anon_sym_DASH] = ACTIONS(442),
    [anon_sym_SLASH] = ACTIONS(442),
    [anon_sym_PERCENT] = ACTIONS(442),
    [anon_sym_SLASH_SLASH] = ACTIONS(442),
    [anon_sym_STAR_STAR] = ACTIONS(442),
    [anon_sym_PIPE] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(442),
    [anon_sym_CARET] = ACTIONS(442),
    [anon_sym_LT_LT] = ACTIONS(442),
    [anon_sym_LT] = ACTIONS(442),
    [anon_sym_LT_EQ] = ACTIONS(440),
    [anon_sym_EQ_EQ] = ACTIONS(440),
    [anon_sym_BANG_EQ] = ACTIONS(440),
    [anon_sym_GT_EQ] = ACTIONS(440),
    [anon_sym_GT] = ACTIONS(442),
    [anon_sym_LT_GT] = ACTIONS(440),
    [anon_sym_is] = ACTIONS(440),
    [anon_sym_PLUS_EQ] = ACTIONS(440),
    [anon_sym_DASH_EQ] = ACTIONS(440),
    [anon_sym_STAR_EQ] = ACTIONS(440),
    [anon_sym_SLASH_EQ] = ACTIONS(440),
    [anon_sym_AT_EQ] = ACTIONS(440),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(440),
    [anon_sym_PERCENT_EQ] = ACTIONS(440),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(440),
    [anon_sym_GT_GT_EQ] = ACTIONS(440),
    [anon_sym_LT_LT_EQ] = ACTIONS(440),
    [anon_sym_AMP_EQ] = ACTIONS(440),
    [anon_sym_CARET_EQ] = ACTIONS(440),
    [anon_sym_PIPE_EQ] = ACTIONS(440),
    [anon_sym_LBRACK] = ACTIONS(440),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(440),
    [sym__newline] = ACTIONS(440),
    [sym__string_start] = ACTIONS(73),
  },
  [114] = {
    [sym_named_expression] = STATE(740),
    [sym_list_splat] = STATE(957),
    [sym_dictionary_splat] = STATE(957),
    [sym__expression] = STATE(740),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(740),
    [sym_boolean_operator] = STATE(740),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(740),
    [sym_lambda] = STATE(740),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_keyword_argument] = STATE(957),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(740),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(740),
    [sym_identifier] = ACTIONS(417),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_RPAREN] = ACTIONS(436),
    [anon_sym_COMMA] = ACTIONS(438),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_print] = ACTIONS(423),
    [anon_sym_exec] = ACTIONS(423),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [115] = {
    [sym_named_expression] = STATE(685),
    [sym_expression_list] = STATE(702),
    [sym__expression] = STATE(685),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(685),
    [sym_boolean_operator] = STATE(685),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(685),
    [sym_lambda] = STATE(685),
    [sym_assignment] = STATE(1062),
    [sym_augmented_assignment] = STATE(1062),
    [sym__right_hand_side] = STATE(1062),
    [sym_yield] = STATE(1062),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(685),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(685),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(349),
    [anon_sym_exec] = ACTIONS(349),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [116] = {
    [sym_named_expression] = STATE(685),
    [sym_expression_list] = STATE(702),
    [sym__expression] = STATE(685),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(685),
    [sym_boolean_operator] = STATE(685),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(685),
    [sym_lambda] = STATE(685),
    [sym_assignment] = STATE(1063),
    [sym_augmented_assignment] = STATE(1063),
    [sym__right_hand_side] = STATE(1063),
    [sym_yield] = STATE(1063),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(685),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(685),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(349),
    [anon_sym_exec] = ACTIONS(349),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [117] = {
    [sym_named_expression] = STATE(735),
    [sym_list_splat] = STATE(1012),
    [sym_dictionary_splat] = STATE(1012),
    [sym__expression] = STATE(735),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(735),
    [sym_boolean_operator] = STATE(735),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(735),
    [sym_lambda] = STATE(735),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_keyword_argument] = STATE(1012),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(735),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(735),
    [sym_identifier] = ACTIONS(417),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_RPAREN] = ACTIONS(444),
    [anon_sym_COMMA] = ACTIONS(446),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_print] = ACTIONS(423),
    [anon_sym_exec] = ACTIONS(423),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [118] = {
    [sym_named_expression] = STATE(731),
    [sym_list_splat] = STATE(925),
    [sym_dictionary_splat] = STATE(922),
    [sym__expression] = STATE(731),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(731),
    [sym_boolean_operator] = STATE(731),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(731),
    [sym_lambda] = STATE(731),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_pair] = STATE(778),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(731),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(731),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_COMMA] = ACTIONS(448),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_RBRACE] = ACTIONS(450),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [119] = {
    [sym_named_expression] = STATE(732),
    [sym_list_splat] = STATE(996),
    [sym_dictionary_splat] = STATE(995),
    [sym__expression] = STATE(732),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(732),
    [sym_boolean_operator] = STATE(732),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(732),
    [sym_lambda] = STATE(732),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_pair] = STATE(783),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(732),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(732),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_COMMA] = ACTIONS(452),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_RBRACE] = ACTIONS(454),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [120] = {
    [sym_argument_list] = STATE(221),
    [sym_generator_expression] = STATE(221),
    [aux_sym_comparison_operator_repeat1] = STATE(681),
    [anon_sym_DOT] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(458),
    [anon_sym_COMMA] = ACTIONS(460),
    [anon_sym_STAR] = ACTIONS(462),
    [anon_sym_GT_GT] = ACTIONS(464),
    [anon_sym_if] = ACTIONS(460),
    [anon_sym_COLON] = ACTIONS(460),
    [anon_sym_in] = ACTIONS(466),
    [anon_sym_EQ] = ACTIONS(468),
    [anon_sym_AT] = ACTIONS(462),
    [anon_sym_not] = ACTIONS(470),
    [anon_sym_and] = ACTIONS(460),
    [anon_sym_or] = ACTIONS(460),
    [anon_sym_PLUS] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(472),
    [anon_sym_SLASH] = ACTIONS(462),
    [anon_sym_PERCENT] = ACTIONS(462),
    [anon_sym_SLASH_SLASH] = ACTIONS(462),
    [anon_sym_STAR_STAR] = ACTIONS(474),
    [anon_sym_PIPE] = ACTIONS(476),
    [anon_sym_AMP] = ACTIONS(478),
    [anon_sym_CARET] = ACTIONS(480),
    [anon_sym_LT_LT] = ACTIONS(464),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_LT_EQ] = ACTIONS(466),
    [anon_sym_EQ_EQ] = ACTIONS(466),
    [anon_sym_BANG_EQ] = ACTIONS(466),
    [anon_sym_GT_EQ] = ACTIONS(466),
    [anon_sym_GT] = ACTIONS(482),
    [anon_sym_LT_GT] = ACTIONS(466),
    [anon_sym_is] = ACTIONS(484),
    [anon_sym_PLUS_EQ] = ACTIONS(460),
    [anon_sym_DASH_EQ] = ACTIONS(460),
    [anon_sym_STAR_EQ] = ACTIONS(460),
    [anon_sym_SLASH_EQ] = ACTIONS(460),
    [anon_sym_AT_EQ] = ACTIONS(460),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(460),
    [anon_sym_PERCENT_EQ] = ACTIONS(460),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(460),
    [anon_sym_GT_GT_EQ] = ACTIONS(460),
    [anon_sym_LT_LT_EQ] = ACTIONS(460),
    [anon_sym_AMP_EQ] = ACTIONS(460),
    [anon_sym_CARET_EQ] = ACTIONS(460),
    [anon_sym_PIPE_EQ] = ACTIONS(460),
    [anon_sym_LBRACK] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(460),
    [sym__newline] = ACTIONS(460),
  },
  [121] = {
    [sym_argument_list] = STATE(221),
    [sym_generator_expression] = STATE(221),
    [anon_sym_DOT] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(458),
    [anon_sym_COMMA] = ACTIONS(488),
    [anon_sym_STAR] = ACTIONS(490),
    [anon_sym_GT_GT] = ACTIONS(490),
    [anon_sym_if] = ACTIONS(488),
    [anon_sym_COLON] = ACTIONS(488),
    [anon_sym_in] = ACTIONS(488),
    [anon_sym_EQ] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(490),
    [anon_sym_not] = ACTIONS(488),
    [anon_sym_and] = ACTIONS(488),
    [anon_sym_or] = ACTIONS(488),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_SLASH] = ACTIONS(490),
    [anon_sym_PERCENT] = ACTIONS(490),
    [anon_sym_SLASH_SLASH] = ACTIONS(490),
    [anon_sym_STAR_STAR] = ACTIONS(474),
    [anon_sym_PIPE] = ACTIONS(490),
    [anon_sym_AMP] = ACTIONS(490),
    [anon_sym_CARET] = ACTIONS(490),
    [anon_sym_LT_LT] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(490),
    [anon_sym_LT_EQ] = ACTIONS(488),
    [anon_sym_EQ_EQ] = ACTIONS(488),
    [anon_sym_BANG_EQ] = ACTIONS(488),
    [anon_sym_GT_EQ] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(490),
    [anon_sym_LT_GT] = ACTIONS(488),
    [anon_sym_is] = ACTIONS(488),
    [anon_sym_PLUS_EQ] = ACTIONS(488),
    [anon_sym_DASH_EQ] = ACTIONS(488),
    [anon_sym_STAR_EQ] = ACTIONS(488),
    [anon_sym_SLASH_EQ] = ACTIONS(488),
    [anon_sym_AT_EQ] = ACTIONS(488),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(488),
    [anon_sym_PERCENT_EQ] = ACTIONS(488),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(488),
    [anon_sym_GT_GT_EQ] = ACTIONS(488),
    [anon_sym_LT_LT_EQ] = ACTIONS(488),
    [anon_sym_AMP_EQ] = ACTIONS(488),
    [anon_sym_CARET_EQ] = ACTIONS(488),
    [anon_sym_PIPE_EQ] = ACTIONS(488),
    [anon_sym_LBRACK] = ACTIONS(488),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(488),
    [sym__newline] = ACTIONS(488),
  },
  [122] = {
    [sym_named_expression] = STATE(858),
    [sym_list_splat] = STATE(1029),
    [sym_dictionary_splat] = STATE(1029),
    [sym__expression] = STATE(858),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(858),
    [sym_boolean_operator] = STATE(858),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(858),
    [sym_lambda] = STATE(858),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_keyword_argument] = STATE(1029),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(858),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(858),
    [sym_identifier] = ACTIONS(417),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_RPAREN] = ACTIONS(492),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_print] = ACTIONS(423),
    [anon_sym_exec] = ACTIONS(423),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [123] = {
    [sym_named_expression] = STATE(858),
    [sym_list_splat] = STATE(1029),
    [sym_dictionary_splat] = STATE(1029),
    [sym__expression] = STATE(858),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(858),
    [sym_boolean_operator] = STATE(858),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(858),
    [sym_lambda] = STATE(858),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_keyword_argument] = STATE(1029),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(858),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(858),
    [sym_identifier] = ACTIONS(417),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_RPAREN] = ACTIONS(494),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_print] = ACTIONS(423),
    [anon_sym_exec] = ACTIONS(423),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [124] = {
    [sym_argument_list] = STATE(221),
    [sym_generator_expression] = STATE(221),
    [anon_sym_DOT] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(458),
    [anon_sym_COMMA] = ACTIONS(496),
    [anon_sym_STAR] = ACTIONS(462),
    [anon_sym_GT_GT] = ACTIONS(464),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_COLON] = ACTIONS(496),
    [anon_sym_in] = ACTIONS(496),
    [anon_sym_EQ] = ACTIONS(498),
    [anon_sym_AT] = ACTIONS(462),
    [anon_sym_not] = ACTIONS(496),
    [anon_sym_and] = ACTIONS(496),
    [anon_sym_or] = ACTIONS(496),
    [anon_sym_PLUS] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(472),
    [anon_sym_SLASH] = ACTIONS(462),
    [anon_sym_PERCENT] = ACTIONS(462),
    [anon_sym_SLASH_SLASH] = ACTIONS(462),
    [anon_sym_STAR_STAR] = ACTIONS(474),
    [anon_sym_PIPE] = ACTIONS(476),
    [anon_sym_AMP] = ACTIONS(478),
    [anon_sym_CARET] = ACTIONS(480),
    [anon_sym_LT_LT] = ACTIONS(464),
    [anon_sym_LT] = ACTIONS(498),
    [anon_sym_LT_EQ] = ACTIONS(496),
    [anon_sym_EQ_EQ] = ACTIONS(496),
    [anon_sym_BANG_EQ] = ACTIONS(496),
    [anon_sym_GT_EQ] = ACTIONS(496),
    [anon_sym_GT] = ACTIONS(498),
    [anon_sym_LT_GT] = ACTIONS(496),
    [anon_sym_is] = ACTIONS(496),
    [anon_sym_PLUS_EQ] = ACTIONS(496),
    [anon_sym_DASH_EQ] = ACTIONS(496),
    [anon_sym_STAR_EQ] = ACTIONS(496),
    [anon_sym_SLASH_EQ] = ACTIONS(496),
    [anon_sym_AT_EQ] = ACTIONS(496),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(496),
    [anon_sym_PERCENT_EQ] = ACTIONS(496),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(496),
    [anon_sym_GT_GT_EQ] = ACTIONS(496),
    [anon_sym_LT_LT_EQ] = ACTIONS(496),
    [anon_sym_AMP_EQ] = ACTIONS(496),
    [anon_sym_CARET_EQ] = ACTIONS(496),
    [anon_sym_PIPE_EQ] = ACTIONS(496),
    [anon_sym_LBRACK] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(496),
    [sym__newline] = ACTIONS(496),
  },
  [125] = {
    [sym_named_expression] = STATE(858),
    [sym_list_splat] = STATE(1029),
    [sym_dictionary_splat] = STATE(1029),
    [sym__expression] = STATE(858),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(858),
    [sym_boolean_operator] = STATE(858),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(858),
    [sym_lambda] = STATE(858),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_keyword_argument] = STATE(1029),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(858),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(858),
    [sym_identifier] = ACTIONS(417),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_RPAREN] = ACTIONS(500),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_print] = ACTIONS(423),
    [anon_sym_exec] = ACTIONS(423),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [126] = {
    [sym_argument_list] = STATE(221),
    [sym_generator_expression] = STATE(221),
    [anon_sym_DOT] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(458),
    [anon_sym_COMMA] = ACTIONS(488),
    [anon_sym_STAR] = ACTIONS(462),
    [anon_sym_GT_GT] = ACTIONS(490),
    [anon_sym_if] = ACTIONS(488),
    [anon_sym_COLON] = ACTIONS(488),
    [anon_sym_in] = ACTIONS(488),
    [anon_sym_EQ] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(462),
    [anon_sym_not] = ACTIONS(488),
    [anon_sym_and] = ACTIONS(488),
    [anon_sym_or] = ACTIONS(488),
    [anon_sym_PLUS] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(472),
    [anon_sym_SLASH] = ACTIONS(462),
    [anon_sym_PERCENT] = ACTIONS(462),
    [anon_sym_SLASH_SLASH] = ACTIONS(462),
    [anon_sym_STAR_STAR] = ACTIONS(474),
    [anon_sym_PIPE] = ACTIONS(490),
    [anon_sym_AMP] = ACTIONS(490),
    [anon_sym_CARET] = ACTIONS(490),
    [anon_sym_LT_LT] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(490),
    [anon_sym_LT_EQ] = ACTIONS(488),
    [anon_sym_EQ_EQ] = ACTIONS(488),
    [anon_sym_BANG_EQ] = ACTIONS(488),
    [anon_sym_GT_EQ] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(490),
    [anon_sym_LT_GT] = ACTIONS(488),
    [anon_sym_is] = ACTIONS(488),
    [anon_sym_PLUS_EQ] = ACTIONS(488),
    [anon_sym_DASH_EQ] = ACTIONS(488),
    [anon_sym_STAR_EQ] = ACTIONS(488),
    [anon_sym_SLASH_EQ] = ACTIONS(488),
    [anon_sym_AT_EQ] = ACTIONS(488),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(488),
    [anon_sym_PERCENT_EQ] = ACTIONS(488),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(488),
    [anon_sym_GT_GT_EQ] = ACTIONS(488),
    [anon_sym_LT_LT_EQ] = ACTIONS(488),
    [anon_sym_AMP_EQ] = ACTIONS(488),
    [anon_sym_CARET_EQ] = ACTIONS(488),
    [anon_sym_PIPE_EQ] = ACTIONS(488),
    [anon_sym_LBRACK] = ACTIONS(488),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(488),
    [sym__newline] = ACTIONS(488),
  },
  [127] = {
    [sym_argument_list] = STATE(221),
    [sym_generator_expression] = STATE(221),
    [anon_sym_DOT] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(458),
    [anon_sym_COMMA] = ACTIONS(502),
    [anon_sym_STAR] = ACTIONS(462),
    [anon_sym_GT_GT] = ACTIONS(464),
    [anon_sym_if] = ACTIONS(502),
    [anon_sym_COLON] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(502),
    [anon_sym_EQ] = ACTIONS(504),
    [anon_sym_AT] = ACTIONS(462),
    [anon_sym_not] = ACTIONS(502),
    [anon_sym_and] = ACTIONS(502),
    [anon_sym_or] = ACTIONS(502),
    [anon_sym_PLUS] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(472),
    [anon_sym_SLASH] = ACTIONS(462),
    [anon_sym_PERCENT] = ACTIONS(462),
    [anon_sym_SLASH_SLASH] = ACTIONS(462),
    [anon_sym_STAR_STAR] = ACTIONS(474),
    [anon_sym_PIPE] = ACTIONS(476),
    [anon_sym_AMP] = ACTIONS(478),
    [anon_sym_CARET] = ACTIONS(480),
    [anon_sym_LT_LT] = ACTIONS(464),
    [anon_sym_LT] = ACTIONS(504),
    [anon_sym_LT_EQ] = ACTIONS(502),
    [anon_sym_EQ_EQ] = ACTIONS(502),
    [anon_sym_BANG_EQ] = ACTIONS(502),
    [anon_sym_GT_EQ] = ACTIONS(502),
    [anon_sym_GT] = ACTIONS(504),
    [anon_sym_LT_GT] = ACTIONS(502),
    [anon_sym_is] = ACTIONS(502),
    [anon_sym_PLUS_EQ] = ACTIONS(502),
    [anon_sym_DASH_EQ] = ACTIONS(502),
    [anon_sym_STAR_EQ] = ACTIONS(502),
    [anon_sym_SLASH_EQ] = ACTIONS(502),
    [anon_sym_AT_EQ] = ACTIONS(502),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(502),
    [anon_sym_PERCENT_EQ] = ACTIONS(502),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(502),
    [anon_sym_GT_GT_EQ] = ACTIONS(502),
    [anon_sym_LT_LT_EQ] = ACTIONS(502),
    [anon_sym_AMP_EQ] = ACTIONS(502),
    [anon_sym_CARET_EQ] = ACTIONS(502),
    [anon_sym_PIPE_EQ] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(502),
    [sym__newline] = ACTIONS(502),
  },
  [128] = {
    [sym_argument_list] = STATE(221),
    [sym_generator_expression] = STATE(221),
    [anon_sym_DOT] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(458),
    [anon_sym_COMMA] = ACTIONS(488),
    [anon_sym_STAR] = ACTIONS(462),
    [anon_sym_GT_GT] = ACTIONS(490),
    [anon_sym_if] = ACTIONS(488),
    [anon_sym_COLON] = ACTIONS(488),
    [anon_sym_in] = ACTIONS(488),
    [anon_sym_EQ] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(462),
    [anon_sym_not] = ACTIONS(488),
    [anon_sym_and] = ACTIONS(488),
    [anon_sym_or] = ACTIONS(488),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_SLASH] = ACTIONS(462),
    [anon_sym_PERCENT] = ACTIONS(462),
    [anon_sym_SLASH_SLASH] = ACTIONS(462),
    [anon_sym_STAR_STAR] = ACTIONS(474),
    [anon_sym_PIPE] = ACTIONS(490),
    [anon_sym_AMP] = ACTIONS(490),
    [anon_sym_CARET] = ACTIONS(490),
    [anon_sym_LT_LT] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(490),
    [anon_sym_LT_EQ] = ACTIONS(488),
    [anon_sym_EQ_EQ] = ACTIONS(488),
    [anon_sym_BANG_EQ] = ACTIONS(488),
    [anon_sym_GT_EQ] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(490),
    [anon_sym_LT_GT] = ACTIONS(488),
    [anon_sym_is] = ACTIONS(488),
    [anon_sym_PLUS_EQ] = ACTIONS(488),
    [anon_sym_DASH_EQ] = ACTIONS(488),
    [anon_sym_STAR_EQ] = ACTIONS(488),
    [anon_sym_SLASH_EQ] = ACTIONS(488),
    [anon_sym_AT_EQ] = ACTIONS(488),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(488),
    [anon_sym_PERCENT_EQ] = ACTIONS(488),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(488),
    [anon_sym_GT_GT_EQ] = ACTIONS(488),
    [anon_sym_LT_LT_EQ] = ACTIONS(488),
    [anon_sym_AMP_EQ] = ACTIONS(488),
    [anon_sym_CARET_EQ] = ACTIONS(488),
    [anon_sym_PIPE_EQ] = ACTIONS(488),
    [anon_sym_LBRACK] = ACTIONS(488),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(488),
    [sym__newline] = ACTIONS(488),
  },
  [129] = {
    [sym_argument_list] = STATE(221),
    [sym_generator_expression] = STATE(221),
    [anon_sym_DOT] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(458),
    [anon_sym_COMMA] = ACTIONS(488),
    [anon_sym_STAR] = ACTIONS(490),
    [anon_sym_GT_GT] = ACTIONS(490),
    [anon_sym_if] = ACTIONS(488),
    [anon_sym_COLON] = ACTIONS(488),
    [anon_sym_in] = ACTIONS(488),
    [anon_sym_EQ] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(490),
    [anon_sym_not] = ACTIONS(488),
    [anon_sym_and] = ACTIONS(488),
    [anon_sym_or] = ACTIONS(488),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_SLASH] = ACTIONS(490),
    [anon_sym_PERCENT] = ACTIONS(490),
    [anon_sym_SLASH_SLASH] = ACTIONS(490),
    [anon_sym_STAR_STAR] = ACTIONS(490),
    [anon_sym_PIPE] = ACTIONS(490),
    [anon_sym_AMP] = ACTIONS(490),
    [anon_sym_CARET] = ACTIONS(490),
    [anon_sym_LT_LT] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(490),
    [anon_sym_LT_EQ] = ACTIONS(488),
    [anon_sym_EQ_EQ] = ACTIONS(488),
    [anon_sym_BANG_EQ] = ACTIONS(488),
    [anon_sym_GT_EQ] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(490),
    [anon_sym_LT_GT] = ACTIONS(488),
    [anon_sym_is] = ACTIONS(488),
    [anon_sym_PLUS_EQ] = ACTIONS(488),
    [anon_sym_DASH_EQ] = ACTIONS(488),
    [anon_sym_STAR_EQ] = ACTIONS(488),
    [anon_sym_SLASH_EQ] = ACTIONS(488),
    [anon_sym_AT_EQ] = ACTIONS(488),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(488),
    [anon_sym_PERCENT_EQ] = ACTIONS(488),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(488),
    [anon_sym_GT_GT_EQ] = ACTIONS(488),
    [anon_sym_LT_LT_EQ] = ACTIONS(488),
    [anon_sym_AMP_EQ] = ACTIONS(488),
    [anon_sym_CARET_EQ] = ACTIONS(488),
    [anon_sym_PIPE_EQ] = ACTIONS(488),
    [anon_sym_LBRACK] = ACTIONS(488),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(488),
    [sym__newline] = ACTIONS(488),
  },
  [130] = {
    [sym_argument_list] = STATE(221),
    [sym_generator_expression] = STATE(221),
    [anon_sym_DOT] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(458),
    [anon_sym_COMMA] = ACTIONS(488),
    [anon_sym_STAR] = ACTIONS(462),
    [anon_sym_GT_GT] = ACTIONS(464),
    [anon_sym_if] = ACTIONS(488),
    [anon_sym_COLON] = ACTIONS(488),
    [anon_sym_in] = ACTIONS(488),
    [anon_sym_EQ] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(462),
    [anon_sym_not] = ACTIONS(488),
    [anon_sym_and] = ACTIONS(488),
    [anon_sym_or] = ACTIONS(488),
    [anon_sym_PLUS] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(472),
    [anon_sym_SLASH] = ACTIONS(462),
    [anon_sym_PERCENT] = ACTIONS(462),
    [anon_sym_SLASH_SLASH] = ACTIONS(462),
    [anon_sym_STAR_STAR] = ACTIONS(474),
    [anon_sym_PIPE] = ACTIONS(490),
    [anon_sym_AMP] = ACTIONS(478),
    [anon_sym_CARET] = ACTIONS(480),
    [anon_sym_LT_LT] = ACTIONS(464),
    [anon_sym_LT] = ACTIONS(490),
    [anon_sym_LT_EQ] = ACTIONS(488),
    [anon_sym_EQ_EQ] = ACTIONS(488),
    [anon_sym_BANG_EQ] = ACTIONS(488),
    [anon_sym_GT_EQ] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(490),
    [anon_sym_LT_GT] = ACTIONS(488),
    [anon_sym_is] = ACTIONS(488),
    [anon_sym_PLUS_EQ] = ACTIONS(488),
    [anon_sym_DASH_EQ] = ACTIONS(488),
    [anon_sym_STAR_EQ] = ACTIONS(488),
    [anon_sym_SLASH_EQ] = ACTIONS(488),
    [anon_sym_AT_EQ] = ACTIONS(488),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(488),
    [anon_sym_PERCENT_EQ] = ACTIONS(488),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(488),
    [anon_sym_GT_GT_EQ] = ACTIONS(488),
    [anon_sym_LT_LT_EQ] = ACTIONS(488),
    [anon_sym_AMP_EQ] = ACTIONS(488),
    [anon_sym_CARET_EQ] = ACTIONS(488),
    [anon_sym_PIPE_EQ] = ACTIONS(488),
    [anon_sym_LBRACK] = ACTIONS(488),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(488),
    [sym__newline] = ACTIONS(488),
  },
  [131] = {
    [sym_named_expression] = STATE(858),
    [sym_list_splat] = STATE(1029),
    [sym_dictionary_splat] = STATE(1029),
    [sym__expression] = STATE(858),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(858),
    [sym_boolean_operator] = STATE(858),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(858),
    [sym_lambda] = STATE(858),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_keyword_argument] = STATE(1029),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(858),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(858),
    [sym_identifier] = ACTIONS(417),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_RPAREN] = ACTIONS(506),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_print] = ACTIONS(423),
    [anon_sym_exec] = ACTIONS(423),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [132] = {
    [sym_argument_list] = STATE(221),
    [sym_generator_expression] = STATE(221),
    [anon_sym_DOT] = ACTIONS(508),
    [anon_sym_LPAREN] = ACTIONS(458),
    [anon_sym_COMMA] = ACTIONS(508),
    [anon_sym_STAR] = ACTIONS(510),
    [anon_sym_GT_GT] = ACTIONS(510),
    [anon_sym_if] = ACTIONS(508),
    [anon_sym_COLON] = ACTIONS(508),
    [anon_sym_in] = ACTIONS(508),
    [anon_sym_EQ] = ACTIONS(510),
    [anon_sym_AT] = ACTIONS(510),
    [anon_sym_not] = ACTIONS(508),
    [anon_sym_and] = ACTIONS(508),
    [anon_sym_or] = ACTIONS(508),
    [anon_sym_PLUS] = ACTIONS(510),
    [anon_sym_DASH] = ACTIONS(510),
    [anon_sym_SLASH] = ACTIONS(510),
    [anon_sym_PERCENT] = ACTIONS(510),
    [anon_sym_SLASH_SLASH] = ACTIONS(510),
    [anon_sym_STAR_STAR] = ACTIONS(510),
    [anon_sym_PIPE] = ACTIONS(510),
    [anon_sym_AMP] = ACTIONS(510),
    [anon_sym_CARET] = ACTIONS(510),
    [anon_sym_LT_LT] = ACTIONS(510),
    [anon_sym_LT] = ACTIONS(510),
    [anon_sym_LT_EQ] = ACTIONS(508),
    [anon_sym_EQ_EQ] = ACTIONS(508),
    [anon_sym_BANG_EQ] = ACTIONS(508),
    [anon_sym_GT_EQ] = ACTIONS(508),
    [anon_sym_GT] = ACTIONS(510),
    [anon_sym_LT_GT] = ACTIONS(508),
    [anon_sym_is] = ACTIONS(508),
    [anon_sym_PLUS_EQ] = ACTIONS(508),
    [anon_sym_DASH_EQ] = ACTIONS(508),
    [anon_sym_STAR_EQ] = ACTIONS(508),
    [anon_sym_SLASH_EQ] = ACTIONS(508),
    [anon_sym_AT_EQ] = ACTIONS(508),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(508),
    [anon_sym_PERCENT_EQ] = ACTIONS(508),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(508),
    [anon_sym_GT_GT_EQ] = ACTIONS(508),
    [anon_sym_LT_LT_EQ] = ACTIONS(508),
    [anon_sym_AMP_EQ] = ACTIONS(508),
    [anon_sym_CARET_EQ] = ACTIONS(508),
    [anon_sym_PIPE_EQ] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(508),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(508),
    [sym__newline] = ACTIONS(508),
  },
  [133] = {
    [sym_named_expression] = STATE(858),
    [sym_list_splat] = STATE(1029),
    [sym_dictionary_splat] = STATE(1029),
    [sym__expression] = STATE(858),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(858),
    [sym_boolean_operator] = STATE(858),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(858),
    [sym_lambda] = STATE(858),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_keyword_argument] = STATE(1029),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(858),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(858),
    [sym_identifier] = ACTIONS(417),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_RPAREN] = ACTIONS(512),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_print] = ACTIONS(423),
    [anon_sym_exec] = ACTIONS(423),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [134] = {
    [sym_argument_list] = STATE(221),
    [sym_generator_expression] = STATE(221),
    [anon_sym_DOT] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(458),
    [anon_sym_COMMA] = ACTIONS(488),
    [anon_sym_STAR] = ACTIONS(462),
    [anon_sym_GT_GT] = ACTIONS(464),
    [anon_sym_if] = ACTIONS(488),
    [anon_sym_COLON] = ACTIONS(488),
    [anon_sym_in] = ACTIONS(488),
    [anon_sym_EQ] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(462),
    [anon_sym_not] = ACTIONS(488),
    [anon_sym_and] = ACTIONS(488),
    [anon_sym_or] = ACTIONS(488),
    [anon_sym_PLUS] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(472),
    [anon_sym_SLASH] = ACTIONS(462),
    [anon_sym_PERCENT] = ACTIONS(462),
    [anon_sym_SLASH_SLASH] = ACTIONS(462),
    [anon_sym_STAR_STAR] = ACTIONS(474),
    [anon_sym_PIPE] = ACTIONS(490),
    [anon_sym_AMP] = ACTIONS(490),
    [anon_sym_CARET] = ACTIONS(480),
    [anon_sym_LT_LT] = ACTIONS(464),
    [anon_sym_LT] = ACTIONS(490),
    [anon_sym_LT_EQ] = ACTIONS(488),
    [anon_sym_EQ_EQ] = ACTIONS(488),
    [anon_sym_BANG_EQ] = ACTIONS(488),
    [anon_sym_GT_EQ] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(490),
    [anon_sym_LT_GT] = ACTIONS(488),
    [anon_sym_is] = ACTIONS(488),
    [anon_sym_PLUS_EQ] = ACTIONS(488),
    [anon_sym_DASH_EQ] = ACTIONS(488),
    [anon_sym_STAR_EQ] = ACTIONS(488),
    [anon_sym_SLASH_EQ] = ACTIONS(488),
    [anon_sym_AT_EQ] = ACTIONS(488),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(488),
    [anon_sym_PERCENT_EQ] = ACTIONS(488),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(488),
    [anon_sym_GT_GT_EQ] = ACTIONS(488),
    [anon_sym_LT_LT_EQ] = ACTIONS(488),
    [anon_sym_AMP_EQ] = ACTIONS(488),
    [anon_sym_CARET_EQ] = ACTIONS(488),
    [anon_sym_PIPE_EQ] = ACTIONS(488),
    [anon_sym_LBRACK] = ACTIONS(488),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(488),
    [sym__newline] = ACTIONS(488),
  },
  [135] = {
    [sym_argument_list] = STATE(221),
    [sym_generator_expression] = STATE(221),
    [anon_sym_DOT] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(458),
    [anon_sym_COMMA] = ACTIONS(488),
    [anon_sym_STAR] = ACTIONS(462),
    [anon_sym_GT_GT] = ACTIONS(464),
    [anon_sym_if] = ACTIONS(488),
    [anon_sym_COLON] = ACTIONS(488),
    [anon_sym_in] = ACTIONS(488),
    [anon_sym_EQ] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(462),
    [anon_sym_not] = ACTIONS(488),
    [anon_sym_and] = ACTIONS(488),
    [anon_sym_or] = ACTIONS(488),
    [anon_sym_PLUS] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(472),
    [anon_sym_SLASH] = ACTIONS(462),
    [anon_sym_PERCENT] = ACTIONS(462),
    [anon_sym_SLASH_SLASH] = ACTIONS(462),
    [anon_sym_STAR_STAR] = ACTIONS(474),
    [anon_sym_PIPE] = ACTIONS(490),
    [anon_sym_AMP] = ACTIONS(490),
    [anon_sym_CARET] = ACTIONS(490),
    [anon_sym_LT_LT] = ACTIONS(464),
    [anon_sym_LT] = ACTIONS(490),
    [anon_sym_LT_EQ] = ACTIONS(488),
    [anon_sym_EQ_EQ] = ACTIONS(488),
    [anon_sym_BANG_EQ] = ACTIONS(488),
    [anon_sym_GT_EQ] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(490),
    [anon_sym_LT_GT] = ACTIONS(488),
    [anon_sym_is] = ACTIONS(488),
    [anon_sym_PLUS_EQ] = ACTIONS(488),
    [anon_sym_DASH_EQ] = ACTIONS(488),
    [anon_sym_STAR_EQ] = ACTIONS(488),
    [anon_sym_SLASH_EQ] = ACTIONS(488),
    [anon_sym_AT_EQ] = ACTIONS(488),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(488),
    [anon_sym_PERCENT_EQ] = ACTIONS(488),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(488),
    [anon_sym_GT_GT_EQ] = ACTIONS(488),
    [anon_sym_LT_LT_EQ] = ACTIONS(488),
    [anon_sym_AMP_EQ] = ACTIONS(488),
    [anon_sym_CARET_EQ] = ACTIONS(488),
    [anon_sym_PIPE_EQ] = ACTIONS(488),
    [anon_sym_LBRACK] = ACTIONS(488),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(488),
    [sym__newline] = ACTIONS(488),
  },
  [136] = {
    [sym_named_expression] = STATE(858),
    [sym_list_splat] = STATE(1029),
    [sym_dictionary_splat] = STATE(1029),
    [sym__expression] = STATE(858),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(858),
    [sym_boolean_operator] = STATE(858),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(858),
    [sym_lambda] = STATE(858),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_keyword_argument] = STATE(1029),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(858),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(858),
    [sym_identifier] = ACTIONS(417),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_RPAREN] = ACTIONS(514),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_print] = ACTIONS(423),
    [anon_sym_exec] = ACTIONS(423),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [137] = {
    [sym_string] = STATE(958),
    [anon_sym_DOT] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_COMMA] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_if] = ACTIONS(237),
    [anon_sym_COLON] = ACTIONS(237),
    [anon_sym_in] = ACTIONS(237),
    [anon_sym_EQ] = ACTIONS(235),
    [anon_sym_AT] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(237),
    [anon_sym_and] = ACTIONS(237),
    [anon_sym_or] = ACTIONS(237),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_SLASH_SLASH] = ACTIONS(235),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_LT_GT] = ACTIONS(237),
    [anon_sym_is] = ACTIONS(237),
    [anon_sym_PLUS_EQ] = ACTIONS(237),
    [anon_sym_DASH_EQ] = ACTIONS(237),
    [anon_sym_STAR_EQ] = ACTIONS(237),
    [anon_sym_SLASH_EQ] = ACTIONS(237),
    [anon_sym_AT_EQ] = ACTIONS(237),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(237),
    [anon_sym_PERCENT_EQ] = ACTIONS(237),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(237),
    [anon_sym_GT_GT_EQ] = ACTIONS(237),
    [anon_sym_LT_LT_EQ] = ACTIONS(237),
    [anon_sym_AMP_EQ] = ACTIONS(237),
    [anon_sym_CARET_EQ] = ACTIONS(237),
    [anon_sym_PIPE_EQ] = ACTIONS(237),
    [anon_sym_LBRACK] = ACTIONS(237),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(237),
    [sym__newline] = ACTIONS(237),
    [sym__string_start] = ACTIONS(516),
  },
  [138] = {
    [sym_named_expression] = STATE(858),
    [sym_list_splat] = STATE(1029),
    [sym_dictionary_splat] = STATE(1029),
    [sym__expression] = STATE(858),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(858),
    [sym_boolean_operator] = STATE(858),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(858),
    [sym_lambda] = STATE(858),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_keyword_argument] = STATE(1029),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(858),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(858),
    [sym_identifier] = ACTIONS(417),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_RPAREN] = ACTIONS(518),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_print] = ACTIONS(423),
    [anon_sym_exec] = ACTIONS(423),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [139] = {
    [sym_named_expression] = STATE(763),
    [sym__expression] = STATE(763),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(763),
    [sym_boolean_operator] = STATE(763),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(763),
    [sym_lambda] = STATE(763),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(763),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(763),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_RPAREN] = ACTIONS(520),
    [anon_sym_COMMA] = ACTIONS(520),
    [anon_sym_STAR] = ACTIONS(522),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_COLON] = ACTIONS(520),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_RBRACE] = ACTIONS(520),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [140] = {
    [sym_named_expression] = STATE(858),
    [sym_list_splat] = STATE(1029),
    [sym_dictionary_splat] = STATE(1029),
    [sym__expression] = STATE(858),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(858),
    [sym_boolean_operator] = STATE(858),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(858),
    [sym_lambda] = STATE(858),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_keyword_argument] = STATE(1029),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(858),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(858),
    [sym_identifier] = ACTIONS(417),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_RPAREN] = ACTIONS(524),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_print] = ACTIONS(423),
    [anon_sym_exec] = ACTIONS(423),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [141] = {
    [sym_named_expression] = STATE(737),
    [sym_list_splat] = STATE(923),
    [sym__expression] = STATE(737),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(737),
    [sym_boolean_operator] = STATE(737),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(737),
    [sym_lambda] = STATE(737),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(737),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(737),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_COMMA] = ACTIONS(526),
    [anon_sym_STAR] = ACTIONS(528),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [anon_sym_RBRACK] = ACTIONS(530),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [142] = {
    [sym_named_expression] = STATE(760),
    [sym_expression_list] = STATE(936),
    [sym__expression] = STATE(760),
    [sym__primary_expression] = STATE(532),
    [sym_not_operator] = STATE(760),
    [sym_boolean_operator] = STATE(760),
    [sym_binary_operator] = STATE(532),
    [sym_unary_operator] = STATE(532),
    [sym_comparison_operator] = STATE(760),
    [sym_lambda] = STATE(760),
    [sym_attribute] = STATE(532),
    [sym_subscript] = STATE(532),
    [sym_call] = STATE(532),
    [sym_list] = STATE(532),
    [sym_list_comprehension] = STATE(532),
    [sym_dictionary] = STATE(532),
    [sym_dictionary_comprehension] = STATE(532),
    [sym_set] = STATE(532),
    [sym_set_comprehension] = STATE(532),
    [sym_parenthesized_expression] = STATE(532),
    [sym_tuple] = STATE(532),
    [sym_generator_expression] = STATE(532),
    [sym_conditional_expression] = STATE(760),
    [sym_concatenated_string] = STATE(532),
    [sym_string] = STATE(530),
    [sym_await] = STATE(760),
    [sym_identifier] = ACTIONS(233),
    [anon_sym_from] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_print] = ACTIONS(239),
    [anon_sym_exec] = ACTIONS(239),
    [anon_sym_not] = ACTIONS(536),
    [anon_sym_PLUS] = ACTIONS(243),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_TILDE] = ACTIONS(243),
    [anon_sym_lambda] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(538),
    [sym_ellipsis] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [sym_integer] = ACTIONS(251),
    [sym_float] = ACTIONS(247),
    [sym_true] = ACTIONS(251),
    [sym_false] = ACTIONS(251),
    [sym_none] = ACTIONS(251),
    [anon_sym_await] = ACTIONS(253),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(540),
    [sym__newline] = ACTIONS(540),
    [sym__string_start] = ACTIONS(255),
  },
  [143] = {
    [sym_named_expression] = STATE(742),
    [sym__expression] = STATE(742),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(742),
    [sym_boolean_operator] = STATE(742),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(742),
    [sym_lambda] = STATE(742),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(742),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(742),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_RPAREN] = ACTIONS(542),
    [anon_sym_COMMA] = ACTIONS(544),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_yield] = ACTIONS(546),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [144] = {
    [sym_named_expression] = STATE(779),
    [sym_expression_list] = STATE(1027),
    [sym__expression] = STATE(779),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(779),
    [sym_boolean_operator] = STATE(779),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(779),
    [sym_lambda] = STATE(779),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(779),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(779),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_from] = ACTIONS(548),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_RPAREN] = ACTIONS(550),
    [anon_sym_COMMA] = ACTIONS(550),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [145] = {
    [sym_named_expression] = STATE(912),
    [sym_dictionary_splat] = STATE(1023),
    [sym__expression] = STATE(912),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(912),
    [sym_boolean_operator] = STATE(912),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(912),
    [sym_lambda] = STATE(912),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_pair] = STATE(1023),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(912),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(912),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(552),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_RBRACE] = ACTIONS(554),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [146] = {
    [sym_named_expression] = STATE(858),
    [sym_list_splat] = STATE(1029),
    [sym_dictionary_splat] = STATE(1029),
    [sym__expression] = STATE(858),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(858),
    [sym_boolean_operator] = STATE(858),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(858),
    [sym_lambda] = STATE(858),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_keyword_argument] = STATE(1029),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(858),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(858),
    [sym_identifier] = ACTIONS(417),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_print] = ACTIONS(423),
    [anon_sym_exec] = ACTIONS(423),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [147] = {
    [sym_named_expression] = STATE(912),
    [sym_dictionary_splat] = STATE(1023),
    [sym__expression] = STATE(912),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(912),
    [sym_boolean_operator] = STATE(912),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(912),
    [sym_lambda] = STATE(912),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_pair] = STATE(1023),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(912),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(912),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(552),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_RBRACE] = ACTIONS(556),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [148] = {
    [sym_named_expression] = STATE(912),
    [sym_dictionary_splat] = STATE(1023),
    [sym__expression] = STATE(912),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(912),
    [sym_boolean_operator] = STATE(912),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(912),
    [sym_lambda] = STATE(912),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_pair] = STATE(1023),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(912),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(912),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(552),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_RBRACE] = ACTIONS(558),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [149] = {
    [sym_named_expression] = STATE(745),
    [sym__expression] = STATE(745),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(745),
    [sym_boolean_operator] = STATE(745),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(745),
    [sym_lambda] = STATE(745),
    [sym_yield] = STATE(918),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(745),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(745),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_RPAREN] = ACTIONS(560),
    [anon_sym_COMMA] = ACTIONS(562),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_yield] = ACTIONS(546),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [150] = {
    [sym_else_clause] = STATE(398),
    [sym_except_clause] = STATE(249),
    [sym_finally_clause] = STATE(478),
    [aux_sym_try_statement_repeat1] = STATE(249),
    [sym_identifier] = ACTIONS(564),
    [anon_sym_import] = ACTIONS(564),
    [anon_sym_from] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_print] = ACTIONS(564),
    [anon_sym_assert] = ACTIONS(564),
    [anon_sym_return] = ACTIONS(564),
    [anon_sym_del] = ACTIONS(564),
    [anon_sym_raise] = ACTIONS(564),
    [anon_sym_pass] = ACTIONS(564),
    [anon_sym_break] = ACTIONS(564),
    [anon_sym_continue] = ACTIONS(564),
    [anon_sym_if] = ACTIONS(564),
    [anon_sym_else] = ACTIONS(568),
    [anon_sym_async] = ACTIONS(564),
    [anon_sym_for] = ACTIONS(564),
    [anon_sym_while] = ACTIONS(564),
    [anon_sym_try] = ACTIONS(564),
    [anon_sym_except] = ACTIONS(570),
    [anon_sym_finally] = ACTIONS(572),
    [anon_sym_with] = ACTIONS(564),
    [anon_sym_def] = ACTIONS(564),
    [anon_sym_global] = ACTIONS(564),
    [anon_sym_nonlocal] = ACTIONS(564),
    [anon_sym_exec] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(564),
    [anon_sym_AT] = ACTIONS(566),
    [anon_sym_not] = ACTIONS(564),
    [anon_sym_PLUS] = ACTIONS(566),
    [anon_sym_DASH] = ACTIONS(566),
    [anon_sym_TILDE] = ACTIONS(566),
    [anon_sym_lambda] = ACTIONS(564),
    [anon_sym_yield] = ACTIONS(564),
    [anon_sym_LBRACK] = ACTIONS(566),
    [sym_ellipsis] = ACTIONS(566),
    [anon_sym_LBRACE] = ACTIONS(566),
    [sym_integer] = ACTIONS(564),
    [sym_float] = ACTIONS(566),
    [sym_true] = ACTIONS(564),
    [sym_false] = ACTIONS(564),
    [sym_none] = ACTIONS(564),
    [anon_sym_await] = ACTIONS(564),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(566),
    [sym__string_start] = ACTIONS(566),
  },
  [151] = {
    [sym_named_expression] = STATE(734),
    [sym__expression] = STATE(734),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(734),
    [sym_boolean_operator] = STATE(734),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(734),
    [sym_lambda] = STATE(734),
    [sym_yield] = STATE(914),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(734),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(734),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_RPAREN] = ACTIONS(574),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_yield] = ACTIONS(546),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [152] = {
    [anon_sym_DOT] = ACTIONS(578),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(580),
    [anon_sym_GT_GT] = ACTIONS(580),
    [anon_sym_if] = ACTIONS(578),
    [anon_sym_COLON] = ACTIONS(578),
    [anon_sym_in] = ACTIONS(578),
    [anon_sym_EQ] = ACTIONS(580),
    [anon_sym_AT] = ACTIONS(580),
    [anon_sym_not] = ACTIONS(578),
    [anon_sym_and] = ACTIONS(578),
    [anon_sym_or] = ACTIONS(578),
    [anon_sym_PLUS] = ACTIONS(580),
    [anon_sym_DASH] = ACTIONS(580),
    [anon_sym_SLASH] = ACTIONS(580),
    [anon_sym_PERCENT] = ACTIONS(580),
    [anon_sym_SLASH_SLASH] = ACTIONS(580),
    [anon_sym_STAR_STAR] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(580),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_CARET] = ACTIONS(580),
    [anon_sym_LT_LT] = ACTIONS(580),
    [anon_sym_LT] = ACTIONS(580),
    [anon_sym_LT_EQ] = ACTIONS(578),
    [anon_sym_EQ_EQ] = ACTIONS(578),
    [anon_sym_BANG_EQ] = ACTIONS(578),
    [anon_sym_GT_EQ] = ACTIONS(578),
    [anon_sym_GT] = ACTIONS(580),
    [anon_sym_LT_GT] = ACTIONS(578),
    [anon_sym_is] = ACTIONS(578),
    [anon_sym_PLUS_EQ] = ACTIONS(578),
    [anon_sym_DASH_EQ] = ACTIONS(578),
    [anon_sym_STAR_EQ] = ACTIONS(578),
    [anon_sym_SLASH_EQ] = ACTIONS(578),
    [anon_sym_AT_EQ] = ACTIONS(578),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(578),
    [anon_sym_PERCENT_EQ] = ACTIONS(578),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(578),
    [anon_sym_GT_GT_EQ] = ACTIONS(578),
    [anon_sym_LT_LT_EQ] = ACTIONS(578),
    [anon_sym_AMP_EQ] = ACTIONS(578),
    [anon_sym_CARET_EQ] = ACTIONS(578),
    [anon_sym_PIPE_EQ] = ACTIONS(578),
    [anon_sym_LBRACK] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(578),
    [sym__newline] = ACTIONS(578),
    [sym__string_start] = ACTIONS(578),
  },
  [153] = {
    [sym_named_expression] = STATE(912),
    [sym_dictionary_splat] = STATE(1023),
    [sym__expression] = STATE(912),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(912),
    [sym_boolean_operator] = STATE(912),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(912),
    [sym_lambda] = STATE(912),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_pair] = STATE(1023),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(912),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(912),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(552),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_RBRACE] = ACTIONS(582),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [154] = {
    [sym_named_expression] = STATE(912),
    [sym_dictionary_splat] = STATE(1023),
    [sym__expression] = STATE(912),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(912),
    [sym_boolean_operator] = STATE(912),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(912),
    [sym_lambda] = STATE(912),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_pair] = STATE(1023),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(912),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(912),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(552),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_RBRACE] = ACTIONS(584),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [155] = {
    [sym_named_expression] = STATE(826),
    [sym__expression] = STATE(826),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(826),
    [sym_boolean_operator] = STATE(826),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(826),
    [sym_lambda] = STATE(826),
    [sym_yield] = STATE(941),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(826),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(826),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_RPAREN] = ACTIONS(560),
    [anon_sym_COMMA] = ACTIONS(562),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_yield] = ACTIONS(546),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [156] = {
    [sym_named_expression] = STATE(736),
    [sym_list_splat] = STATE(1014),
    [sym__expression] = STATE(736),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(736),
    [sym_boolean_operator] = STATE(736),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(736),
    [sym_lambda] = STATE(736),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(736),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(736),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_COMMA] = ACTIONS(586),
    [anon_sym_STAR] = ACTIONS(528),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [anon_sym_RBRACK] = ACTIONS(588),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [157] = {
    [sym_else_clause] = STATE(381),
    [sym_except_clause] = STATE(253),
    [sym_finally_clause] = STATE(476),
    [aux_sym_try_statement_repeat1] = STATE(253),
    [ts_builtin_sym_end] = ACTIONS(566),
    [sym_identifier] = ACTIONS(564),
    [anon_sym_import] = ACTIONS(564),
    [anon_sym_from] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_print] = ACTIONS(564),
    [anon_sym_assert] = ACTIONS(564),
    [anon_sym_return] = ACTIONS(564),
    [anon_sym_del] = ACTIONS(564),
    [anon_sym_raise] = ACTIONS(564),
    [anon_sym_pass] = ACTIONS(564),
    [anon_sym_break] = ACTIONS(564),
    [anon_sym_continue] = ACTIONS(564),
    [anon_sym_if] = ACTIONS(564),
    [anon_sym_else] = ACTIONS(590),
    [anon_sym_async] = ACTIONS(564),
    [anon_sym_for] = ACTIONS(564),
    [anon_sym_while] = ACTIONS(564),
    [anon_sym_try] = ACTIONS(564),
    [anon_sym_except] = ACTIONS(592),
    [anon_sym_finally] = ACTIONS(594),
    [anon_sym_with] = ACTIONS(564),
    [anon_sym_def] = ACTIONS(564),
    [anon_sym_global] = ACTIONS(564),
    [anon_sym_nonlocal] = ACTIONS(564),
    [anon_sym_exec] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(564),
    [anon_sym_AT] = ACTIONS(566),
    [anon_sym_not] = ACTIONS(564),
    [anon_sym_PLUS] = ACTIONS(566),
    [anon_sym_DASH] = ACTIONS(566),
    [anon_sym_TILDE] = ACTIONS(566),
    [anon_sym_lambda] = ACTIONS(564),
    [anon_sym_yield] = ACTIONS(564),
    [anon_sym_LBRACK] = ACTIONS(566),
    [sym_ellipsis] = ACTIONS(566),
    [anon_sym_LBRACE] = ACTIONS(566),
    [sym_integer] = ACTIONS(564),
    [sym_float] = ACTIONS(566),
    [sym_true] = ACTIONS(564),
    [sym_false] = ACTIONS(564),
    [sym_none] = ACTIONS(564),
    [anon_sym_await] = ACTIONS(564),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(566),
  },
  [158] = {
    [sym_named_expression] = STATE(912),
    [sym_dictionary_splat] = STATE(1023),
    [sym__expression] = STATE(912),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(912),
    [sym_boolean_operator] = STATE(912),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(912),
    [sym_lambda] = STATE(912),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_pair] = STATE(1023),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(912),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(912),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(552),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_RBRACE] = ACTIONS(596),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [159] = {
    [sym_else_clause] = STATE(396),
    [sym_except_clause] = STATE(253),
    [sym_finally_clause] = STATE(415),
    [aux_sym_try_statement_repeat1] = STATE(253),
    [ts_builtin_sym_end] = ACTIONS(598),
    [sym_identifier] = ACTIONS(600),
    [anon_sym_import] = ACTIONS(600),
    [anon_sym_from] = ACTIONS(600),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_print] = ACTIONS(600),
    [anon_sym_assert] = ACTIONS(600),
    [anon_sym_return] = ACTIONS(600),
    [anon_sym_del] = ACTIONS(600),
    [anon_sym_raise] = ACTIONS(600),
    [anon_sym_pass] = ACTIONS(600),
    [anon_sym_break] = ACTIONS(600),
    [anon_sym_continue] = ACTIONS(600),
    [anon_sym_if] = ACTIONS(600),
    [anon_sym_else] = ACTIONS(590),
    [anon_sym_async] = ACTIONS(600),
    [anon_sym_for] = ACTIONS(600),
    [anon_sym_while] = ACTIONS(600),
    [anon_sym_try] = ACTIONS(600),
    [anon_sym_except] = ACTIONS(592),
    [anon_sym_finally] = ACTIONS(594),
    [anon_sym_with] = ACTIONS(600),
    [anon_sym_def] = ACTIONS(600),
    [anon_sym_global] = ACTIONS(600),
    [anon_sym_nonlocal] = ACTIONS(600),
    [anon_sym_exec] = ACTIONS(600),
    [anon_sym_class] = ACTIONS(600),
    [anon_sym_AT] = ACTIONS(598),
    [anon_sym_not] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(598),
    [anon_sym_DASH] = ACTIONS(598),
    [anon_sym_TILDE] = ACTIONS(598),
    [anon_sym_lambda] = ACTIONS(600),
    [anon_sym_yield] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(598),
    [sym_ellipsis] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(598),
    [sym_integer] = ACTIONS(600),
    [sym_float] = ACTIONS(598),
    [sym_true] = ACTIONS(600),
    [sym_false] = ACTIONS(600),
    [sym_none] = ACTIONS(600),
    [anon_sym_await] = ACTIONS(600),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(598),
  },
  [160] = {
    [anon_sym_DOT] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(602),
    [anon_sym_STAR] = ACTIONS(604),
    [anon_sym_GT_GT] = ACTIONS(604),
    [anon_sym_if] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(602),
    [anon_sym_in] = ACTIONS(602),
    [anon_sym_EQ] = ACTIONS(604),
    [anon_sym_AT] = ACTIONS(604),
    [anon_sym_not] = ACTIONS(602),
    [anon_sym_and] = ACTIONS(602),
    [anon_sym_or] = ACTIONS(602),
    [anon_sym_PLUS] = ACTIONS(604),
    [anon_sym_DASH] = ACTIONS(604),
    [anon_sym_SLASH] = ACTIONS(604),
    [anon_sym_PERCENT] = ACTIONS(604),
    [anon_sym_SLASH_SLASH] = ACTIONS(604),
    [anon_sym_STAR_STAR] = ACTIONS(604),
    [anon_sym_PIPE] = ACTIONS(604),
    [anon_sym_AMP] = ACTIONS(604),
    [anon_sym_CARET] = ACTIONS(604),
    [anon_sym_LT_LT] = ACTIONS(604),
    [anon_sym_LT] = ACTIONS(604),
    [anon_sym_LT_EQ] = ACTIONS(602),
    [anon_sym_EQ_EQ] = ACTIONS(602),
    [anon_sym_BANG_EQ] = ACTIONS(602),
    [anon_sym_GT_EQ] = ACTIONS(602),
    [anon_sym_GT] = ACTIONS(604),
    [anon_sym_LT_GT] = ACTIONS(602),
    [anon_sym_is] = ACTIONS(602),
    [anon_sym_PLUS_EQ] = ACTIONS(602),
    [anon_sym_DASH_EQ] = ACTIONS(602),
    [anon_sym_STAR_EQ] = ACTIONS(602),
    [anon_sym_SLASH_EQ] = ACTIONS(602),
    [anon_sym_AT_EQ] = ACTIONS(602),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(602),
    [anon_sym_PERCENT_EQ] = ACTIONS(602),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(602),
    [anon_sym_GT_GT_EQ] = ACTIONS(602),
    [anon_sym_LT_LT_EQ] = ACTIONS(602),
    [anon_sym_AMP_EQ] = ACTIONS(602),
    [anon_sym_CARET_EQ] = ACTIONS(602),
    [anon_sym_PIPE_EQ] = ACTIONS(602),
    [anon_sym_LBRACK] = ACTIONS(602),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(602),
    [sym__newline] = ACTIONS(602),
    [sym__string_start] = ACTIONS(602),
  },
  [161] = {
    [sym_named_expression] = STATE(912),
    [sym_dictionary_splat] = STATE(1023),
    [sym__expression] = STATE(912),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(912),
    [sym_boolean_operator] = STATE(912),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(912),
    [sym_lambda] = STATE(912),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_pair] = STATE(1023),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(912),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(912),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(552),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_RBRACE] = ACTIONS(606),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [162] = {
    [sym_named_expression] = STATE(912),
    [sym_dictionary_splat] = STATE(1023),
    [sym__expression] = STATE(912),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(912),
    [sym_boolean_operator] = STATE(912),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(912),
    [sym_lambda] = STATE(912),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_pair] = STATE(1023),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(912),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(912),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(552),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_RBRACE] = ACTIONS(608),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [163] = {
    [anon_sym_DOT] = ACTIONS(440),
    [anon_sym_LPAREN] = ACTIONS(440),
    [anon_sym_COMMA] = ACTIONS(440),
    [anon_sym_STAR] = ACTIONS(442),
    [anon_sym_GT_GT] = ACTIONS(442),
    [anon_sym_COLON_EQ] = ACTIONS(610),
    [anon_sym_if] = ACTIONS(440),
    [anon_sym_COLON] = ACTIONS(442),
    [anon_sym_in] = ACTIONS(440),
    [anon_sym_EQ] = ACTIONS(442),
    [anon_sym_AT] = ACTIONS(442),
    [anon_sym_not] = ACTIONS(440),
    [anon_sym_and] = ACTIONS(440),
    [anon_sym_or] = ACTIONS(440),
    [anon_sym_PLUS] = ACTIONS(442),
    [anon_sym_DASH] = ACTIONS(442),
    [anon_sym_SLASH] = ACTIONS(442),
    [anon_sym_PERCENT] = ACTIONS(442),
    [anon_sym_SLASH_SLASH] = ACTIONS(442),
    [anon_sym_STAR_STAR] = ACTIONS(442),
    [anon_sym_PIPE] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(442),
    [anon_sym_CARET] = ACTIONS(442),
    [anon_sym_LT_LT] = ACTIONS(442),
    [anon_sym_LT] = ACTIONS(442),
    [anon_sym_LT_EQ] = ACTIONS(440),
    [anon_sym_EQ_EQ] = ACTIONS(440),
    [anon_sym_BANG_EQ] = ACTIONS(440),
    [anon_sym_GT_EQ] = ACTIONS(440),
    [anon_sym_GT] = ACTIONS(442),
    [anon_sym_LT_GT] = ACTIONS(440),
    [anon_sym_is] = ACTIONS(440),
    [anon_sym_PLUS_EQ] = ACTIONS(440),
    [anon_sym_DASH_EQ] = ACTIONS(440),
    [anon_sym_STAR_EQ] = ACTIONS(440),
    [anon_sym_SLASH_EQ] = ACTIONS(440),
    [anon_sym_AT_EQ] = ACTIONS(440),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(440),
    [anon_sym_PERCENT_EQ] = ACTIONS(440),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(440),
    [anon_sym_GT_GT_EQ] = ACTIONS(440),
    [anon_sym_LT_LT_EQ] = ACTIONS(440),
    [anon_sym_AMP_EQ] = ACTIONS(440),
    [anon_sym_CARET_EQ] = ACTIONS(440),
    [anon_sym_PIPE_EQ] = ACTIONS(440),
    [anon_sym_LBRACK] = ACTIONS(440),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(440),
    [sym__newline] = ACTIONS(440),
  },
  [164] = {
    [sym_else_clause] = STATE(390),
    [sym_except_clause] = STATE(249),
    [sym_finally_clause] = STATE(441),
    [aux_sym_try_statement_repeat1] = STATE(249),
    [sym_identifier] = ACTIONS(600),
    [anon_sym_import] = ACTIONS(600),
    [anon_sym_from] = ACTIONS(600),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_print] = ACTIONS(600),
    [anon_sym_assert] = ACTIONS(600),
    [anon_sym_return] = ACTIONS(600),
    [anon_sym_del] = ACTIONS(600),
    [anon_sym_raise] = ACTIONS(600),
    [anon_sym_pass] = ACTIONS(600),
    [anon_sym_break] = ACTIONS(600),
    [anon_sym_continue] = ACTIONS(600),
    [anon_sym_if] = ACTIONS(600),
    [anon_sym_else] = ACTIONS(568),
    [anon_sym_async] = ACTIONS(600),
    [anon_sym_for] = ACTIONS(600),
    [anon_sym_while] = ACTIONS(600),
    [anon_sym_try] = ACTIONS(600),
    [anon_sym_except] = ACTIONS(570),
    [anon_sym_finally] = ACTIONS(572),
    [anon_sym_with] = ACTIONS(600),
    [anon_sym_def] = ACTIONS(600),
    [anon_sym_global] = ACTIONS(600),
    [anon_sym_nonlocal] = ACTIONS(600),
    [anon_sym_exec] = ACTIONS(600),
    [anon_sym_class] = ACTIONS(600),
    [anon_sym_AT] = ACTIONS(598),
    [anon_sym_not] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(598),
    [anon_sym_DASH] = ACTIONS(598),
    [anon_sym_TILDE] = ACTIONS(598),
    [anon_sym_lambda] = ACTIONS(600),
    [anon_sym_yield] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(598),
    [sym_ellipsis] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(598),
    [sym_integer] = ACTIONS(600),
    [sym_float] = ACTIONS(598),
    [sym_true] = ACTIONS(600),
    [sym_false] = ACTIONS(600),
    [sym_none] = ACTIONS(600),
    [anon_sym_await] = ACTIONS(600),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(598),
    [sym__string_start] = ACTIONS(598),
  },
  [165] = {
    [sym_named_expression] = STATE(739),
    [sym__expression] = STATE(739),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(739),
    [sym_boolean_operator] = STATE(739),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(739),
    [sym_lambda] = STATE(739),
    [sym_yield] = STATE(1011),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(739),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(739),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_RPAREN] = ACTIONS(612),
    [anon_sym_COMMA] = ACTIONS(614),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_yield] = ACTIONS(546),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [166] = {
    [sym_named_expression] = STATE(738),
    [sym_list_splat] = STATE(999),
    [sym__expression] = STATE(738),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(738),
    [sym_boolean_operator] = STATE(738),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(738),
    [sym_lambda] = STATE(738),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(738),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(738),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_COMMA] = ACTIONS(616),
    [anon_sym_STAR] = ACTIONS(528),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [anon_sym_RBRACK] = ACTIONS(618),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [167] = {
    [sym_named_expression] = STATE(760),
    [sym_expression_list] = STATE(1044),
    [sym__expression] = STATE(760),
    [sym__primary_expression] = STATE(532),
    [sym_not_operator] = STATE(760),
    [sym_boolean_operator] = STATE(760),
    [sym_binary_operator] = STATE(532),
    [sym_unary_operator] = STATE(532),
    [sym_comparison_operator] = STATE(760),
    [sym_lambda] = STATE(760),
    [sym_attribute] = STATE(532),
    [sym_subscript] = STATE(532),
    [sym_call] = STATE(532),
    [sym_list] = STATE(532),
    [sym_list_comprehension] = STATE(532),
    [sym_dictionary] = STATE(532),
    [sym_dictionary_comprehension] = STATE(532),
    [sym_set] = STATE(532),
    [sym_set_comprehension] = STATE(532),
    [sym_parenthesized_expression] = STATE(532),
    [sym_tuple] = STATE(532),
    [sym_generator_expression] = STATE(532),
    [sym_conditional_expression] = STATE(760),
    [sym_concatenated_string] = STATE(532),
    [sym_string] = STATE(530),
    [sym_await] = STATE(760),
    [sym_identifier] = ACTIONS(233),
    [anon_sym_from] = ACTIONS(620),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_print] = ACTIONS(239),
    [anon_sym_exec] = ACTIONS(239),
    [anon_sym_not] = ACTIONS(536),
    [anon_sym_PLUS] = ACTIONS(243),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_TILDE] = ACTIONS(243),
    [anon_sym_lambda] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(538),
    [sym_ellipsis] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [sym_integer] = ACTIONS(251),
    [sym_float] = ACTIONS(247),
    [sym_true] = ACTIONS(251),
    [sym_false] = ACTIONS(251),
    [sym_none] = ACTIONS(251),
    [anon_sym_await] = ACTIONS(253),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(550),
    [sym__newline] = ACTIONS(550),
    [sym__string_start] = ACTIONS(255),
  },
  [168] = {
    [sym_named_expression] = STATE(741),
    [sym_list_splat] = STATE(929),
    [sym__expression] = STATE(741),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(741),
    [sym_boolean_operator] = STATE(741),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(741),
    [sym_lambda] = STATE(741),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(741),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(741),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_COMMA] = ACTIONS(622),
    [anon_sym_STAR] = ACTIONS(528),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [anon_sym_RBRACK] = ACTIONS(624),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [169] = {
    [sym_named_expression] = STATE(793),
    [sym_list_splat] = STATE(970),
    [sym__expression] = STATE(793),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(793),
    [sym_boolean_operator] = STATE(793),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(793),
    [sym_lambda] = STATE(793),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(793),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(793),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(528),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [anon_sym_RBRACK] = ACTIONS(626),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [170] = {
    [sym_named_expression] = STATE(793),
    [sym_list_splat] = STATE(970),
    [sym__expression] = STATE(793),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(793),
    [sym_boolean_operator] = STATE(793),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(793),
    [sym_lambda] = STATE(793),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(793),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(793),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(528),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_RBRACE] = ACTIONS(628),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [171] = {
    [sym_named_expression] = STATE(803),
    [sym__expression] = STATE(803),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(803),
    [sym_boolean_operator] = STATE(803),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(803),
    [sym_lambda] = STATE(803),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_slice] = STATE(1038),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(803),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(803),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_COLON] = ACTIONS(630),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [anon_sym_RBRACK] = ACTIONS(632),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [172] = {
    [sym_named_expression] = STATE(760),
    [sym_expression_list] = STATE(1055),
    [sym__expression] = STATE(760),
    [sym__primary_expression] = STATE(532),
    [sym_not_operator] = STATE(760),
    [sym_boolean_operator] = STATE(760),
    [sym_binary_operator] = STATE(532),
    [sym_unary_operator] = STATE(532),
    [sym_comparison_operator] = STATE(760),
    [sym_lambda] = STATE(760),
    [sym_attribute] = STATE(532),
    [sym_subscript] = STATE(532),
    [sym_call] = STATE(532),
    [sym_list] = STATE(532),
    [sym_list_comprehension] = STATE(532),
    [sym_dictionary] = STATE(532),
    [sym_dictionary_comprehension] = STATE(532),
    [sym_set] = STATE(532),
    [sym_set_comprehension] = STATE(532),
    [sym_parenthesized_expression] = STATE(532),
    [sym_tuple] = STATE(532),
    [sym_generator_expression] = STATE(532),
    [sym_conditional_expression] = STATE(760),
    [sym_concatenated_string] = STATE(532),
    [sym_string] = STATE(530),
    [sym_await] = STATE(760),
    [sym_identifier] = ACTIONS(233),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_print] = ACTIONS(239),
    [anon_sym_exec] = ACTIONS(239),
    [anon_sym_not] = ACTIONS(536),
    [anon_sym_PLUS] = ACTIONS(243),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_TILDE] = ACTIONS(243),
    [anon_sym_lambda] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(538),
    [sym_ellipsis] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [sym_integer] = ACTIONS(251),
    [sym_float] = ACTIONS(247),
    [sym_true] = ACTIONS(251),
    [sym_false] = ACTIONS(251),
    [sym_none] = ACTIONS(251),
    [anon_sym_await] = ACTIONS(253),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(634),
    [sym__newline] = ACTIONS(634),
    [sym__string_start] = ACTIONS(255),
  },
  [173] = {
    [anon_sym_DOT] = ACTIONS(636),
    [anon_sym_LPAREN] = ACTIONS(636),
    [anon_sym_COMMA] = ACTIONS(636),
    [anon_sym_STAR] = ACTIONS(638),
    [anon_sym_GT_GT] = ACTIONS(638),
    [anon_sym_if] = ACTIONS(636),
    [anon_sym_COLON] = ACTIONS(636),
    [anon_sym_in] = ACTIONS(636),
    [anon_sym_EQ] = ACTIONS(638),
    [anon_sym_AT] = ACTIONS(638),
    [anon_sym_not] = ACTIONS(636),
    [anon_sym_and] = ACTIONS(636),
    [anon_sym_or] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(638),
    [anon_sym_DASH] = ACTIONS(638),
    [anon_sym_SLASH] = ACTIONS(638),
    [anon_sym_PERCENT] = ACTIONS(638),
    [anon_sym_SLASH_SLASH] = ACTIONS(638),
    [anon_sym_STAR_STAR] = ACTIONS(638),
    [anon_sym_PIPE] = ACTIONS(638),
    [anon_sym_AMP] = ACTIONS(638),
    [anon_sym_CARET] = ACTIONS(638),
    [anon_sym_LT_LT] = ACTIONS(638),
    [anon_sym_LT] = ACTIONS(638),
    [anon_sym_LT_EQ] = ACTIONS(636),
    [anon_sym_EQ_EQ] = ACTIONS(636),
    [anon_sym_BANG_EQ] = ACTIONS(636),
    [anon_sym_GT_EQ] = ACTIONS(636),
    [anon_sym_GT] = ACTIONS(638),
    [anon_sym_LT_GT] = ACTIONS(636),
    [anon_sym_is] = ACTIONS(636),
    [anon_sym_PLUS_EQ] = ACTIONS(636),
    [anon_sym_DASH_EQ] = ACTIONS(636),
    [anon_sym_STAR_EQ] = ACTIONS(636),
    [anon_sym_SLASH_EQ] = ACTIONS(636),
    [anon_sym_AT_EQ] = ACTIONS(636),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(636),
    [anon_sym_PERCENT_EQ] = ACTIONS(636),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(636),
    [anon_sym_GT_GT_EQ] = ACTIONS(636),
    [anon_sym_LT_LT_EQ] = ACTIONS(636),
    [anon_sym_AMP_EQ] = ACTIONS(636),
    [anon_sym_CARET_EQ] = ACTIONS(636),
    [anon_sym_PIPE_EQ] = ACTIONS(636),
    [anon_sym_LBRACK] = ACTIONS(636),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(636),
    [sym__newline] = ACTIONS(636),
  },
  [174] = {
    [sym_named_expression] = STATE(793),
    [sym_list_splat] = STATE(970),
    [sym__expression] = STATE(793),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(793),
    [sym_boolean_operator] = STATE(793),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(793),
    [sym_lambda] = STATE(793),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(793),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(793),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(528),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_RBRACE] = ACTIONS(640),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [175] = {
    [sym_named_expression] = STATE(793),
    [sym_list_splat] = STATE(970),
    [sym__expression] = STATE(793),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(793),
    [sym_boolean_operator] = STATE(793),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(793),
    [sym_lambda] = STATE(793),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(793),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(793),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(528),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [anon_sym_RBRACK] = ACTIONS(642),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [176] = {
    [anon_sym_DOT] = ACTIONS(644),
    [anon_sym_LPAREN] = ACTIONS(644),
    [anon_sym_COMMA] = ACTIONS(644),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_GT_GT] = ACTIONS(646),
    [anon_sym_if] = ACTIONS(644),
    [anon_sym_COLON] = ACTIONS(644),
    [anon_sym_in] = ACTIONS(644),
    [anon_sym_EQ] = ACTIONS(646),
    [anon_sym_AT] = ACTIONS(646),
    [anon_sym_not] = ACTIONS(644),
    [anon_sym_and] = ACTIONS(644),
    [anon_sym_or] = ACTIONS(644),
    [anon_sym_PLUS] = ACTIONS(646),
    [anon_sym_DASH] = ACTIONS(646),
    [anon_sym_SLASH] = ACTIONS(646),
    [anon_sym_PERCENT] = ACTIONS(646),
    [anon_sym_SLASH_SLASH] = ACTIONS(646),
    [anon_sym_STAR_STAR] = ACTIONS(646),
    [anon_sym_PIPE] = ACTIONS(646),
    [anon_sym_AMP] = ACTIONS(646),
    [anon_sym_CARET] = ACTIONS(646),
    [anon_sym_LT_LT] = ACTIONS(646),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_LT_EQ] = ACTIONS(644),
    [anon_sym_EQ_EQ] = ACTIONS(644),
    [anon_sym_BANG_EQ] = ACTIONS(644),
    [anon_sym_GT_EQ] = ACTIONS(644),
    [anon_sym_GT] = ACTIONS(646),
    [anon_sym_LT_GT] = ACTIONS(644),
    [anon_sym_is] = ACTIONS(644),
    [anon_sym_PLUS_EQ] = ACTIONS(644),
    [anon_sym_DASH_EQ] = ACTIONS(644),
    [anon_sym_STAR_EQ] = ACTIONS(644),
    [anon_sym_SLASH_EQ] = ACTIONS(644),
    [anon_sym_AT_EQ] = ACTIONS(644),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(644),
    [anon_sym_PERCENT_EQ] = ACTIONS(644),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(644),
    [anon_sym_GT_GT_EQ] = ACTIONS(644),
    [anon_sym_LT_LT_EQ] = ACTIONS(644),
    [anon_sym_AMP_EQ] = ACTIONS(644),
    [anon_sym_CARET_EQ] = ACTIONS(644),
    [anon_sym_PIPE_EQ] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(644),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(644),
    [sym__newline] = ACTIONS(644),
  },
  [177] = {
    [sym_named_expression] = STATE(772),
    [sym__expression] = STATE(772),
    [sym__primary_expression] = STATE(532),
    [sym_not_operator] = STATE(772),
    [sym_boolean_operator] = STATE(772),
    [sym_binary_operator] = STATE(532),
    [sym_unary_operator] = STATE(532),
    [sym_comparison_operator] = STATE(772),
    [sym_lambda] = STATE(772),
    [sym_attribute] = STATE(532),
    [sym_subscript] = STATE(532),
    [sym_call] = STATE(532),
    [sym_list] = STATE(532),
    [sym_list_comprehension] = STATE(532),
    [sym_dictionary] = STATE(532),
    [sym_dictionary_comprehension] = STATE(532),
    [sym_set] = STATE(532),
    [sym_set_comprehension] = STATE(532),
    [sym_parenthesized_expression] = STATE(532),
    [sym_tuple] = STATE(532),
    [sym_generator_expression] = STATE(532),
    [sym_conditional_expression] = STATE(772),
    [sym_concatenated_string] = STATE(532),
    [sym_string] = STATE(530),
    [sym_await] = STATE(772),
    [sym_identifier] = ACTIONS(233),
    [anon_sym_from] = ACTIONS(648),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_print] = ACTIONS(239),
    [anon_sym_exec] = ACTIONS(239),
    [anon_sym_not] = ACTIONS(536),
    [anon_sym_PLUS] = ACTIONS(243),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_TILDE] = ACTIONS(243),
    [anon_sym_lambda] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(538),
    [sym_ellipsis] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [sym_integer] = ACTIONS(251),
    [sym_float] = ACTIONS(247),
    [sym_true] = ACTIONS(251),
    [sym_false] = ACTIONS(251),
    [sym_none] = ACTIONS(251),
    [anon_sym_await] = ACTIONS(253),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(355),
    [sym__newline] = ACTIONS(355),
    [sym__string_start] = ACTIONS(255),
  },
  [178] = {
    [sym_named_expression] = STATE(803),
    [sym__expression] = STATE(803),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(803),
    [sym_boolean_operator] = STATE(803),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(803),
    [sym_lambda] = STATE(803),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_slice] = STATE(1038),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(803),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(803),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_COLON] = ACTIONS(630),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [anon_sym_RBRACK] = ACTIONS(650),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [179] = {
    [sym_named_expression] = STATE(793),
    [sym_list_splat] = STATE(970),
    [sym__expression] = STATE(793),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(793),
    [sym_boolean_operator] = STATE(793),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(793),
    [sym_lambda] = STATE(793),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(793),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(793),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(528),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_RBRACE] = ACTIONS(652),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [180] = {
    [anon_sym_DOT] = ACTIONS(654),
    [anon_sym_LPAREN] = ACTIONS(654),
    [anon_sym_COMMA] = ACTIONS(654),
    [anon_sym_STAR] = ACTIONS(656),
    [anon_sym_GT_GT] = ACTIONS(656),
    [anon_sym_if] = ACTIONS(654),
    [anon_sym_COLON] = ACTIONS(654),
    [anon_sym_in] = ACTIONS(654),
    [anon_sym_EQ] = ACTIONS(656),
    [anon_sym_AT] = ACTIONS(656),
    [anon_sym_not] = ACTIONS(654),
    [anon_sym_and] = ACTIONS(654),
    [anon_sym_or] = ACTIONS(654),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_SLASH] = ACTIONS(656),
    [anon_sym_PERCENT] = ACTIONS(656),
    [anon_sym_SLASH_SLASH] = ACTIONS(656),
    [anon_sym_STAR_STAR] = ACTIONS(656),
    [anon_sym_PIPE] = ACTIONS(656),
    [anon_sym_AMP] = ACTIONS(656),
    [anon_sym_CARET] = ACTIONS(656),
    [anon_sym_LT_LT] = ACTIONS(656),
    [anon_sym_LT] = ACTIONS(656),
    [anon_sym_LT_EQ] = ACTIONS(654),
    [anon_sym_EQ_EQ] = ACTIONS(654),
    [anon_sym_BANG_EQ] = ACTIONS(654),
    [anon_sym_GT_EQ] = ACTIONS(654),
    [anon_sym_GT] = ACTIONS(656),
    [anon_sym_LT_GT] = ACTIONS(654),
    [anon_sym_is] = ACTIONS(654),
    [anon_sym_PLUS_EQ] = ACTIONS(654),
    [anon_sym_DASH_EQ] = ACTIONS(654),
    [anon_sym_STAR_EQ] = ACTIONS(654),
    [anon_sym_SLASH_EQ] = ACTIONS(654),
    [anon_sym_AT_EQ] = ACTIONS(654),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(654),
    [anon_sym_PERCENT_EQ] = ACTIONS(654),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(654),
    [anon_sym_GT_GT_EQ] = ACTIONS(654),
    [anon_sym_LT_LT_EQ] = ACTIONS(654),
    [anon_sym_AMP_EQ] = ACTIONS(654),
    [anon_sym_CARET_EQ] = ACTIONS(654),
    [anon_sym_PIPE_EQ] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(654),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(654),
    [sym__newline] = ACTIONS(654),
  },
  [181] = {
    [sym_named_expression] = STATE(793),
    [sym_list_splat] = STATE(970),
    [sym__expression] = STATE(793),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(793),
    [sym_boolean_operator] = STATE(793),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(793),
    [sym_lambda] = STATE(793),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(793),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(793),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(528),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [anon_sym_RBRACK] = ACTIONS(658),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [182] = {
    [anon_sym_DOT] = ACTIONS(660),
    [anon_sym_LPAREN] = ACTIONS(660),
    [anon_sym_COMMA] = ACTIONS(660),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_GT_GT] = ACTIONS(662),
    [anon_sym_if] = ACTIONS(660),
    [anon_sym_COLON] = ACTIONS(660),
    [anon_sym_in] = ACTIONS(660),
    [anon_sym_EQ] = ACTIONS(662),
    [anon_sym_AT] = ACTIONS(662),
    [anon_sym_not] = ACTIONS(660),
    [anon_sym_and] = ACTIONS(660),
    [anon_sym_or] = ACTIONS(660),
    [anon_sym_PLUS] = ACTIONS(662),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_PERCENT] = ACTIONS(662),
    [anon_sym_SLASH_SLASH] = ACTIONS(662),
    [anon_sym_STAR_STAR] = ACTIONS(662),
    [anon_sym_PIPE] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(662),
    [anon_sym_CARET] = ACTIONS(662),
    [anon_sym_LT_LT] = ACTIONS(662),
    [anon_sym_LT] = ACTIONS(662),
    [anon_sym_LT_EQ] = ACTIONS(660),
    [anon_sym_EQ_EQ] = ACTIONS(660),
    [anon_sym_BANG_EQ] = ACTIONS(660),
    [anon_sym_GT_EQ] = ACTIONS(660),
    [anon_sym_GT] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(660),
    [anon_sym_is] = ACTIONS(660),
    [anon_sym_PLUS_EQ] = ACTIONS(660),
    [anon_sym_DASH_EQ] = ACTIONS(660),
    [anon_sym_STAR_EQ] = ACTIONS(660),
    [anon_sym_SLASH_EQ] = ACTIONS(660),
    [anon_sym_AT_EQ] = ACTIONS(660),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(660),
    [anon_sym_PERCENT_EQ] = ACTIONS(660),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(660),
    [anon_sym_GT_GT_EQ] = ACTIONS(660),
    [anon_sym_LT_LT_EQ] = ACTIONS(660),
    [anon_sym_AMP_EQ] = ACTIONS(660),
    [anon_sym_CARET_EQ] = ACTIONS(660),
    [anon_sym_PIPE_EQ] = ACTIONS(660),
    [anon_sym_LBRACK] = ACTIONS(660),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(660),
    [sym__newline] = ACTIONS(660),
  },
  [183] = {
    [sym_named_expression] = STATE(763),
    [sym__expression] = STATE(763),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(763),
    [sym_boolean_operator] = STATE(763),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(763),
    [sym_lambda] = STATE(763),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(763),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(763),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_COMMA] = ACTIONS(520),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [anon_sym_RBRACK] = ACTIONS(520),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_RBRACE] = ACTIONS(520),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [184] = {
    [anon_sym_DOT] = ACTIONS(664),
    [anon_sym_LPAREN] = ACTIONS(664),
    [anon_sym_COMMA] = ACTIONS(664),
    [anon_sym_STAR] = ACTIONS(666),
    [anon_sym_GT_GT] = ACTIONS(666),
    [anon_sym_if] = ACTIONS(664),
    [anon_sym_COLON] = ACTIONS(664),
    [anon_sym_in] = ACTIONS(664),
    [anon_sym_EQ] = ACTIONS(666),
    [anon_sym_AT] = ACTIONS(666),
    [anon_sym_not] = ACTIONS(664),
    [anon_sym_and] = ACTIONS(664),
    [anon_sym_or] = ACTIONS(664),
    [anon_sym_PLUS] = ACTIONS(666),
    [anon_sym_DASH] = ACTIONS(666),
    [anon_sym_SLASH] = ACTIONS(666),
    [anon_sym_PERCENT] = ACTIONS(666),
    [anon_sym_SLASH_SLASH] = ACTIONS(666),
    [anon_sym_STAR_STAR] = ACTIONS(666),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(666),
    [anon_sym_CARET] = ACTIONS(666),
    [anon_sym_LT_LT] = ACTIONS(666),
    [anon_sym_LT] = ACTIONS(666),
    [anon_sym_LT_EQ] = ACTIONS(664),
    [anon_sym_EQ_EQ] = ACTIONS(664),
    [anon_sym_BANG_EQ] = ACTIONS(664),
    [anon_sym_GT_EQ] = ACTIONS(664),
    [anon_sym_GT] = ACTIONS(666),
    [anon_sym_LT_GT] = ACTIONS(664),
    [anon_sym_is] = ACTIONS(664),
    [anon_sym_PLUS_EQ] = ACTIONS(664),
    [anon_sym_DASH_EQ] = ACTIONS(664),
    [anon_sym_STAR_EQ] = ACTIONS(664),
    [anon_sym_SLASH_EQ] = ACTIONS(664),
    [anon_sym_AT_EQ] = ACTIONS(664),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(664),
    [anon_sym_PERCENT_EQ] = ACTIONS(664),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(664),
    [anon_sym_GT_GT_EQ] = ACTIONS(664),
    [anon_sym_LT_LT_EQ] = ACTIONS(664),
    [anon_sym_AMP_EQ] = ACTIONS(664),
    [anon_sym_CARET_EQ] = ACTIONS(664),
    [anon_sym_PIPE_EQ] = ACTIONS(664),
    [anon_sym_LBRACK] = ACTIONS(664),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(664),
    [sym__newline] = ACTIONS(664),
  },
  [185] = {
    [anon_sym_DOT] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_COMMA] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_if] = ACTIONS(237),
    [anon_sym_COLON] = ACTIONS(237),
    [anon_sym_in] = ACTIONS(237),
    [anon_sym_EQ] = ACTIONS(235),
    [anon_sym_AT] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(237),
    [anon_sym_and] = ACTIONS(237),
    [anon_sym_or] = ACTIONS(237),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_SLASH_SLASH] = ACTIONS(235),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_LT_GT] = ACTIONS(237),
    [anon_sym_is] = ACTIONS(237),
    [anon_sym_PLUS_EQ] = ACTIONS(237),
    [anon_sym_DASH_EQ] = ACTIONS(237),
    [anon_sym_STAR_EQ] = ACTIONS(237),
    [anon_sym_SLASH_EQ] = ACTIONS(237),
    [anon_sym_AT_EQ] = ACTIONS(237),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(237),
    [anon_sym_PERCENT_EQ] = ACTIONS(237),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(237),
    [anon_sym_GT_GT_EQ] = ACTIONS(237),
    [anon_sym_LT_LT_EQ] = ACTIONS(237),
    [anon_sym_AMP_EQ] = ACTIONS(237),
    [anon_sym_CARET_EQ] = ACTIONS(237),
    [anon_sym_PIPE_EQ] = ACTIONS(237),
    [anon_sym_LBRACK] = ACTIONS(237),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(237),
    [sym__newline] = ACTIONS(237),
  },
  [186] = {
    [sym_named_expression] = STATE(851),
    [sym__expression] = STATE(851),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(851),
    [sym_boolean_operator] = STATE(851),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(851),
    [sym_lambda] = STATE(851),
    [sym_yield] = STATE(1049),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(851),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(851),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_RPAREN] = ACTIONS(668),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_yield] = ACTIONS(546),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [187] = {
    [anon_sym_DOT] = ACTIONS(670),
    [anon_sym_LPAREN] = ACTIONS(670),
    [anon_sym_COMMA] = ACTIONS(670),
    [anon_sym_STAR] = ACTIONS(672),
    [anon_sym_GT_GT] = ACTIONS(672),
    [anon_sym_if] = ACTIONS(670),
    [anon_sym_COLON] = ACTIONS(670),
    [anon_sym_in] = ACTIONS(670),
    [anon_sym_EQ] = ACTIONS(672),
    [anon_sym_AT] = ACTIONS(672),
    [anon_sym_not] = ACTIONS(670),
    [anon_sym_and] = ACTIONS(670),
    [anon_sym_or] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_SLASH] = ACTIONS(672),
    [anon_sym_PERCENT] = ACTIONS(672),
    [anon_sym_SLASH_SLASH] = ACTIONS(672),
    [anon_sym_STAR_STAR] = ACTIONS(672),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_AMP] = ACTIONS(672),
    [anon_sym_CARET] = ACTIONS(672),
    [anon_sym_LT_LT] = ACTIONS(672),
    [anon_sym_LT] = ACTIONS(672),
    [anon_sym_LT_EQ] = ACTIONS(670),
    [anon_sym_EQ_EQ] = ACTIONS(670),
    [anon_sym_BANG_EQ] = ACTIONS(670),
    [anon_sym_GT_EQ] = ACTIONS(670),
    [anon_sym_GT] = ACTIONS(672),
    [anon_sym_LT_GT] = ACTIONS(670),
    [anon_sym_is] = ACTIONS(670),
    [anon_sym_PLUS_EQ] = ACTIONS(670),
    [anon_sym_DASH_EQ] = ACTIONS(670),
    [anon_sym_STAR_EQ] = ACTIONS(670),
    [anon_sym_SLASH_EQ] = ACTIONS(670),
    [anon_sym_AT_EQ] = ACTIONS(670),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(670),
    [anon_sym_PERCENT_EQ] = ACTIONS(670),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(670),
    [anon_sym_GT_GT_EQ] = ACTIONS(670),
    [anon_sym_LT_LT_EQ] = ACTIONS(670),
    [anon_sym_AMP_EQ] = ACTIONS(670),
    [anon_sym_CARET_EQ] = ACTIONS(670),
    [anon_sym_PIPE_EQ] = ACTIONS(670),
    [anon_sym_LBRACK] = ACTIONS(670),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(670),
    [sym__newline] = ACTIONS(670),
  },
  [188] = {
    [sym_named_expression] = STATE(851),
    [sym__expression] = STATE(851),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(851),
    [sym_boolean_operator] = STATE(851),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(851),
    [sym_lambda] = STATE(851),
    [sym_yield] = STATE(1049),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(851),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(851),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_RPAREN] = ACTIONS(674),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_yield] = ACTIONS(546),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [189] = {
    [sym_named_expression] = STATE(793),
    [sym_list_splat] = STATE(970),
    [sym__expression] = STATE(793),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(793),
    [sym_boolean_operator] = STATE(793),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(793),
    [sym_lambda] = STATE(793),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(793),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(793),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(528),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_RBRACE] = ACTIONS(676),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [190] = {
    [sym_named_expression] = STATE(819),
    [sym__expression] = STATE(819),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(819),
    [sym_boolean_operator] = STATE(819),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(819),
    [sym_lambda] = STATE(819),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(819),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(819),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_RPAREN] = ACTIONS(355),
    [anon_sym_COMMA] = ACTIONS(355),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_COLON] = ACTIONS(355),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [191] = {
    [anon_sym_DOT] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_COMMA] = ACTIONS(678),
    [anon_sym_STAR] = ACTIONS(680),
    [anon_sym_GT_GT] = ACTIONS(680),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_COLON] = ACTIONS(678),
    [anon_sym_in] = ACTIONS(678),
    [anon_sym_EQ] = ACTIONS(680),
    [anon_sym_AT] = ACTIONS(680),
    [anon_sym_not] = ACTIONS(678),
    [anon_sym_and] = ACTIONS(678),
    [anon_sym_or] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(680),
    [anon_sym_DASH] = ACTIONS(680),
    [anon_sym_SLASH] = ACTIONS(680),
    [anon_sym_PERCENT] = ACTIONS(680),
    [anon_sym_SLASH_SLASH] = ACTIONS(680),
    [anon_sym_STAR_STAR] = ACTIONS(680),
    [anon_sym_PIPE] = ACTIONS(680),
    [anon_sym_AMP] = ACTIONS(680),
    [anon_sym_CARET] = ACTIONS(680),
    [anon_sym_LT_LT] = ACTIONS(680),
    [anon_sym_LT] = ACTIONS(680),
    [anon_sym_LT_EQ] = ACTIONS(678),
    [anon_sym_EQ_EQ] = ACTIONS(678),
    [anon_sym_BANG_EQ] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(678),
    [anon_sym_GT] = ACTIONS(680),
    [anon_sym_LT_GT] = ACTIONS(678),
    [anon_sym_is] = ACTIONS(678),
    [anon_sym_PLUS_EQ] = ACTIONS(678),
    [anon_sym_DASH_EQ] = ACTIONS(678),
    [anon_sym_STAR_EQ] = ACTIONS(678),
    [anon_sym_SLASH_EQ] = ACTIONS(678),
    [anon_sym_AT_EQ] = ACTIONS(678),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(678),
    [anon_sym_PERCENT_EQ] = ACTIONS(678),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(678),
    [anon_sym_GT_GT_EQ] = ACTIONS(678),
    [anon_sym_LT_LT_EQ] = ACTIONS(678),
    [anon_sym_AMP_EQ] = ACTIONS(678),
    [anon_sym_CARET_EQ] = ACTIONS(678),
    [anon_sym_PIPE_EQ] = ACTIONS(678),
    [anon_sym_LBRACK] = ACTIONS(678),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(678),
    [sym__newline] = ACTIONS(678),
  },
  [192] = {
    [anon_sym_DOT] = ACTIONS(682),
    [anon_sym_LPAREN] = ACTIONS(682),
    [anon_sym_COMMA] = ACTIONS(682),
    [anon_sym_STAR] = ACTIONS(684),
    [anon_sym_GT_GT] = ACTIONS(684),
    [anon_sym_if] = ACTIONS(682),
    [anon_sym_COLON] = ACTIONS(682),
    [anon_sym_in] = ACTIONS(682),
    [anon_sym_EQ] = ACTIONS(684),
    [anon_sym_AT] = ACTIONS(684),
    [anon_sym_not] = ACTIONS(682),
    [anon_sym_and] = ACTIONS(682),
    [anon_sym_or] = ACTIONS(682),
    [anon_sym_PLUS] = ACTIONS(684),
    [anon_sym_DASH] = ACTIONS(684),
    [anon_sym_SLASH] = ACTIONS(684),
    [anon_sym_PERCENT] = ACTIONS(684),
    [anon_sym_SLASH_SLASH] = ACTIONS(684),
    [anon_sym_STAR_STAR] = ACTIONS(684),
    [anon_sym_PIPE] = ACTIONS(684),
    [anon_sym_AMP] = ACTIONS(684),
    [anon_sym_CARET] = ACTIONS(684),
    [anon_sym_LT_LT] = ACTIONS(684),
    [anon_sym_LT] = ACTIONS(684),
    [anon_sym_LT_EQ] = ACTIONS(682),
    [anon_sym_EQ_EQ] = ACTIONS(682),
    [anon_sym_BANG_EQ] = ACTIONS(682),
    [anon_sym_GT_EQ] = ACTIONS(682),
    [anon_sym_GT] = ACTIONS(684),
    [anon_sym_LT_GT] = ACTIONS(682),
    [anon_sym_is] = ACTIONS(682),
    [anon_sym_PLUS_EQ] = ACTIONS(682),
    [anon_sym_DASH_EQ] = ACTIONS(682),
    [anon_sym_STAR_EQ] = ACTIONS(682),
    [anon_sym_SLASH_EQ] = ACTIONS(682),
    [anon_sym_AT_EQ] = ACTIONS(682),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(682),
    [anon_sym_PERCENT_EQ] = ACTIONS(682),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(682),
    [anon_sym_GT_GT_EQ] = ACTIONS(682),
    [anon_sym_LT_LT_EQ] = ACTIONS(682),
    [anon_sym_AMP_EQ] = ACTIONS(682),
    [anon_sym_CARET_EQ] = ACTIONS(682),
    [anon_sym_PIPE_EQ] = ACTIONS(682),
    [anon_sym_LBRACK] = ACTIONS(682),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(682),
    [sym__newline] = ACTIONS(682),
  },
  [193] = {
    [sym_named_expression] = STATE(803),
    [sym__expression] = STATE(803),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(803),
    [sym_boolean_operator] = STATE(803),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(803),
    [sym_lambda] = STATE(803),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_slice] = STATE(1038),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(803),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(803),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_COLON] = ACTIONS(630),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [anon_sym_RBRACK] = ACTIONS(686),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [194] = {
    [sym_named_expression] = STATE(851),
    [sym__expression] = STATE(851),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(851),
    [sym_boolean_operator] = STATE(851),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(851),
    [sym_lambda] = STATE(851),
    [sym_yield] = STATE(1049),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(851),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(851),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_RPAREN] = ACTIONS(688),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_yield] = ACTIONS(546),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [195] = {
    [sym_named_expression] = STATE(793),
    [sym_list_splat] = STATE(970),
    [sym__expression] = STATE(793),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(793),
    [sym_boolean_operator] = STATE(793),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(793),
    [sym_lambda] = STATE(793),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(793),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(793),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(528),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [anon_sym_RBRACK] = ACTIONS(690),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [196] = {
    [sym_named_expression] = STATE(793),
    [sym_list_splat] = STATE(970),
    [sym__expression] = STATE(793),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(793),
    [sym_boolean_operator] = STATE(793),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(793),
    [sym_lambda] = STATE(793),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(793),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(793),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(528),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_RBRACE] = ACTIONS(692),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [197] = {
    [sym_named_expression] = STATE(851),
    [sym__expression] = STATE(851),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(851),
    [sym_boolean_operator] = STATE(851),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(851),
    [sym_lambda] = STATE(851),
    [sym_yield] = STATE(1049),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(851),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(851),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_RPAREN] = ACTIONS(694),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_yield] = ACTIONS(546),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [198] = {
    [sym_named_expression] = STATE(851),
    [sym__expression] = STATE(851),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(851),
    [sym_boolean_operator] = STATE(851),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(851),
    [sym_lambda] = STATE(851),
    [sym_yield] = STATE(1049),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(851),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(851),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_RPAREN] = ACTIONS(696),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_yield] = ACTIONS(546),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [199] = {
    [anon_sym_DOT] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(698),
    [anon_sym_COMMA] = ACTIONS(698),
    [anon_sym_STAR] = ACTIONS(700),
    [anon_sym_GT_GT] = ACTIONS(700),
    [anon_sym_if] = ACTIONS(698),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_in] = ACTIONS(698),
    [anon_sym_EQ] = ACTIONS(700),
    [anon_sym_AT] = ACTIONS(700),
    [anon_sym_not] = ACTIONS(698),
    [anon_sym_and] = ACTIONS(698),
    [anon_sym_or] = ACTIONS(698),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_SLASH] = ACTIONS(700),
    [anon_sym_PERCENT] = ACTIONS(700),
    [anon_sym_SLASH_SLASH] = ACTIONS(700),
    [anon_sym_STAR_STAR] = ACTIONS(700),
    [anon_sym_PIPE] = ACTIONS(700),
    [anon_sym_AMP] = ACTIONS(700),
    [anon_sym_CARET] = ACTIONS(700),
    [anon_sym_LT_LT] = ACTIONS(700),
    [anon_sym_LT] = ACTIONS(700),
    [anon_sym_LT_EQ] = ACTIONS(698),
    [anon_sym_EQ_EQ] = ACTIONS(698),
    [anon_sym_BANG_EQ] = ACTIONS(698),
    [anon_sym_GT_EQ] = ACTIONS(698),
    [anon_sym_GT] = ACTIONS(700),
    [anon_sym_LT_GT] = ACTIONS(698),
    [anon_sym_is] = ACTIONS(698),
    [anon_sym_PLUS_EQ] = ACTIONS(698),
    [anon_sym_DASH_EQ] = ACTIONS(698),
    [anon_sym_STAR_EQ] = ACTIONS(698),
    [anon_sym_SLASH_EQ] = ACTIONS(698),
    [anon_sym_AT_EQ] = ACTIONS(698),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(698),
    [anon_sym_PERCENT_EQ] = ACTIONS(698),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(698),
    [anon_sym_GT_GT_EQ] = ACTIONS(698),
    [anon_sym_LT_LT_EQ] = ACTIONS(698),
    [anon_sym_AMP_EQ] = ACTIONS(698),
    [anon_sym_CARET_EQ] = ACTIONS(698),
    [anon_sym_PIPE_EQ] = ACTIONS(698),
    [anon_sym_LBRACK] = ACTIONS(698),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(698),
    [sym__newline] = ACTIONS(698),
  },
  [200] = {
    [sym_named_expression] = STATE(851),
    [sym__expression] = STATE(851),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(851),
    [sym_boolean_operator] = STATE(851),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(851),
    [sym_lambda] = STATE(851),
    [sym_yield] = STATE(1049),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(851),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(851),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_RPAREN] = ACTIONS(702),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_yield] = ACTIONS(546),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [201] = {
    [sym_named_expression] = STATE(793),
    [sym_list_splat] = STATE(970),
    [sym__expression] = STATE(793),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(793),
    [sym_boolean_operator] = STATE(793),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(793),
    [sym_lambda] = STATE(793),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(793),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(793),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(528),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [anon_sym_RBRACK] = ACTIONS(704),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [202] = {
    [anon_sym_DOT] = ACTIONS(706),
    [anon_sym_LPAREN] = ACTIONS(706),
    [anon_sym_COMMA] = ACTIONS(706),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_GT_GT] = ACTIONS(708),
    [anon_sym_if] = ACTIONS(706),
    [anon_sym_COLON] = ACTIONS(706),
    [anon_sym_in] = ACTIONS(706),
    [anon_sym_EQ] = ACTIONS(708),
    [anon_sym_AT] = ACTIONS(708),
    [anon_sym_not] = ACTIONS(706),
    [anon_sym_and] = ACTIONS(706),
    [anon_sym_or] = ACTIONS(706),
    [anon_sym_PLUS] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(708),
    [anon_sym_SLASH] = ACTIONS(708),
    [anon_sym_PERCENT] = ACTIONS(708),
    [anon_sym_SLASH_SLASH] = ACTIONS(708),
    [anon_sym_STAR_STAR] = ACTIONS(708),
    [anon_sym_PIPE] = ACTIONS(708),
    [anon_sym_AMP] = ACTIONS(708),
    [anon_sym_CARET] = ACTIONS(708),
    [anon_sym_LT_LT] = ACTIONS(708),
    [anon_sym_LT] = ACTIONS(708),
    [anon_sym_LT_EQ] = ACTIONS(706),
    [anon_sym_EQ_EQ] = ACTIONS(706),
    [anon_sym_BANG_EQ] = ACTIONS(706),
    [anon_sym_GT_EQ] = ACTIONS(706),
    [anon_sym_GT] = ACTIONS(708),
    [anon_sym_LT_GT] = ACTIONS(706),
    [anon_sym_is] = ACTIONS(706),
    [anon_sym_PLUS_EQ] = ACTIONS(706),
    [anon_sym_DASH_EQ] = ACTIONS(706),
    [anon_sym_STAR_EQ] = ACTIONS(706),
    [anon_sym_SLASH_EQ] = ACTIONS(706),
    [anon_sym_AT_EQ] = ACTIONS(706),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(706),
    [anon_sym_PERCENT_EQ] = ACTIONS(706),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(706),
    [anon_sym_GT_GT_EQ] = ACTIONS(706),
    [anon_sym_LT_LT_EQ] = ACTIONS(706),
    [anon_sym_AMP_EQ] = ACTIONS(706),
    [anon_sym_CARET_EQ] = ACTIONS(706),
    [anon_sym_PIPE_EQ] = ACTIONS(706),
    [anon_sym_LBRACK] = ACTIONS(706),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(706),
    [sym__newline] = ACTIONS(706),
  },
  [203] = {
    [anon_sym_DOT] = ACTIONS(710),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_COMMA] = ACTIONS(710),
    [anon_sym_STAR] = ACTIONS(712),
    [anon_sym_GT_GT] = ACTIONS(712),
    [anon_sym_if] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(710),
    [anon_sym_in] = ACTIONS(710),
    [anon_sym_EQ] = ACTIONS(712),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_not] = ACTIONS(710),
    [anon_sym_and] = ACTIONS(710),
    [anon_sym_or] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(712),
    [anon_sym_DASH] = ACTIONS(712),
    [anon_sym_SLASH] = ACTIONS(712),
    [anon_sym_PERCENT] = ACTIONS(712),
    [anon_sym_SLASH_SLASH] = ACTIONS(712),
    [anon_sym_STAR_STAR] = ACTIONS(712),
    [anon_sym_PIPE] = ACTIONS(712),
    [anon_sym_AMP] = ACTIONS(712),
    [anon_sym_CARET] = ACTIONS(712),
    [anon_sym_LT_LT] = ACTIONS(712),
    [anon_sym_LT] = ACTIONS(712),
    [anon_sym_LT_EQ] = ACTIONS(710),
    [anon_sym_EQ_EQ] = ACTIONS(710),
    [anon_sym_BANG_EQ] = ACTIONS(710),
    [anon_sym_GT_EQ] = ACTIONS(710),
    [anon_sym_GT] = ACTIONS(712),
    [anon_sym_LT_GT] = ACTIONS(710),
    [anon_sym_is] = ACTIONS(710),
    [anon_sym_PLUS_EQ] = ACTIONS(710),
    [anon_sym_DASH_EQ] = ACTIONS(710),
    [anon_sym_STAR_EQ] = ACTIONS(710),
    [anon_sym_SLASH_EQ] = ACTIONS(710),
    [anon_sym_AT_EQ] = ACTIONS(710),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(710),
    [anon_sym_PERCENT_EQ] = ACTIONS(710),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(710),
    [anon_sym_GT_GT_EQ] = ACTIONS(710),
    [anon_sym_LT_LT_EQ] = ACTIONS(710),
    [anon_sym_AMP_EQ] = ACTIONS(710),
    [anon_sym_CARET_EQ] = ACTIONS(710),
    [anon_sym_PIPE_EQ] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(710),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(710),
    [sym__newline] = ACTIONS(710),
  },
  [204] = {
    [sym_named_expression] = STATE(851),
    [sym__expression] = STATE(851),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(851),
    [sym_boolean_operator] = STATE(851),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(851),
    [sym_lambda] = STATE(851),
    [sym_yield] = STATE(1049),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(851),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(851),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_RPAREN] = ACTIONS(714),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_yield] = ACTIONS(546),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [205] = {
    [sym_named_expression] = STATE(806),
    [sym__expression] = STATE(806),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(806),
    [sym_boolean_operator] = STATE(806),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(806),
    [sym_lambda] = STATE(806),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(806),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(806),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_COMMA] = ACTIONS(716),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [anon_sym_RBRACK] = ACTIONS(716),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [206] = {
    [sym_named_expression] = STATE(803),
    [sym__expression] = STATE(803),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(803),
    [sym_boolean_operator] = STATE(803),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(803),
    [sym_lambda] = STATE(803),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_slice] = STATE(1038),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(803),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(803),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_COLON] = ACTIONS(630),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [anon_sym_RBRACK] = ACTIONS(720),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [207] = {
    [sym_named_expression] = STATE(833),
    [sym__expression] = STATE(833),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(833),
    [sym_boolean_operator] = STATE(833),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(833),
    [sym_lambda] = STATE(833),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(833),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(833),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_COMMA] = ACTIONS(722),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [anon_sym_RBRACK] = ACTIONS(722),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [208] = {
    [sym_named_expression] = STATE(912),
    [sym_dictionary_splat] = STATE(1023),
    [sym__expression] = STATE(912),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(912),
    [sym_boolean_operator] = STATE(912),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(912),
    [sym_lambda] = STATE(912),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_pair] = STATE(1023),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(912),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(912),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(552),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [209] = {
    [sym_named_expression] = STATE(819),
    [sym__expression] = STATE(819),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(819),
    [sym_boolean_operator] = STATE(819),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(819),
    [sym_lambda] = STATE(819),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(819),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(819),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_RPAREN] = ACTIONS(351),
    [anon_sym_COMMA] = ACTIONS(351),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_COLON] = ACTIONS(351),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [210] = {
    [sym_named_expression] = STATE(793),
    [sym_list_splat] = STATE(970),
    [sym__expression] = STATE(793),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(793),
    [sym_boolean_operator] = STATE(793),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(793),
    [sym_lambda] = STATE(793),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(793),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(793),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(528),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_RBRACE] = ACTIONS(726),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [211] = {
    [sym_named_expression] = STATE(793),
    [sym_list_splat] = STATE(970),
    [sym__expression] = STATE(793),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(793),
    [sym_boolean_operator] = STATE(793),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(793),
    [sym_lambda] = STATE(793),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(793),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(793),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(528),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [anon_sym_RBRACK] = ACTIONS(728),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [212] = {
    [anon_sym_DOT] = ACTIONS(730),
    [anon_sym_LPAREN] = ACTIONS(730),
    [anon_sym_COMMA] = ACTIONS(730),
    [anon_sym_STAR] = ACTIONS(732),
    [anon_sym_GT_GT] = ACTIONS(732),
    [anon_sym_if] = ACTIONS(730),
    [anon_sym_COLON] = ACTIONS(730),
    [anon_sym_in] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_AT] = ACTIONS(732),
    [anon_sym_not] = ACTIONS(730),
    [anon_sym_and] = ACTIONS(730),
    [anon_sym_or] = ACTIONS(730),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_SLASH] = ACTIONS(732),
    [anon_sym_PERCENT] = ACTIONS(732),
    [anon_sym_SLASH_SLASH] = ACTIONS(732),
    [anon_sym_STAR_STAR] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(732),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_CARET] = ACTIONS(732),
    [anon_sym_LT_LT] = ACTIONS(732),
    [anon_sym_LT] = ACTIONS(732),
    [anon_sym_LT_EQ] = ACTIONS(730),
    [anon_sym_EQ_EQ] = ACTIONS(730),
    [anon_sym_BANG_EQ] = ACTIONS(730),
    [anon_sym_GT_EQ] = ACTIONS(730),
    [anon_sym_GT] = ACTIONS(732),
    [anon_sym_LT_GT] = ACTIONS(730),
    [anon_sym_is] = ACTIONS(730),
    [anon_sym_PLUS_EQ] = ACTIONS(730),
    [anon_sym_DASH_EQ] = ACTIONS(730),
    [anon_sym_STAR_EQ] = ACTIONS(730),
    [anon_sym_SLASH_EQ] = ACTIONS(730),
    [anon_sym_AT_EQ] = ACTIONS(730),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(730),
    [anon_sym_PERCENT_EQ] = ACTIONS(730),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(730),
    [anon_sym_GT_GT_EQ] = ACTIONS(730),
    [anon_sym_LT_LT_EQ] = ACTIONS(730),
    [anon_sym_AMP_EQ] = ACTIONS(730),
    [anon_sym_CARET_EQ] = ACTIONS(730),
    [anon_sym_PIPE_EQ] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(730),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(730),
    [sym__newline] = ACTIONS(730),
  },
  [213] = {
    [anon_sym_DOT] = ACTIONS(734),
    [anon_sym_LPAREN] = ACTIONS(734),
    [anon_sym_COMMA] = ACTIONS(734),
    [anon_sym_STAR] = ACTIONS(736),
    [anon_sym_GT_GT] = ACTIONS(736),
    [anon_sym_if] = ACTIONS(734),
    [anon_sym_COLON] = ACTIONS(734),
    [anon_sym_in] = ACTIONS(734),
    [anon_sym_EQ] = ACTIONS(736),
    [anon_sym_AT] = ACTIONS(736),
    [anon_sym_not] = ACTIONS(734),
    [anon_sym_and] = ACTIONS(734),
    [anon_sym_or] = ACTIONS(734),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_PERCENT] = ACTIONS(736),
    [anon_sym_SLASH_SLASH] = ACTIONS(736),
    [anon_sym_STAR_STAR] = ACTIONS(736),
    [anon_sym_PIPE] = ACTIONS(736),
    [anon_sym_AMP] = ACTIONS(736),
    [anon_sym_CARET] = ACTIONS(736),
    [anon_sym_LT_LT] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_LT_EQ] = ACTIONS(734),
    [anon_sym_EQ_EQ] = ACTIONS(734),
    [anon_sym_BANG_EQ] = ACTIONS(734),
    [anon_sym_GT_EQ] = ACTIONS(734),
    [anon_sym_GT] = ACTIONS(736),
    [anon_sym_LT_GT] = ACTIONS(734),
    [anon_sym_is] = ACTIONS(734),
    [anon_sym_PLUS_EQ] = ACTIONS(734),
    [anon_sym_DASH_EQ] = ACTIONS(734),
    [anon_sym_STAR_EQ] = ACTIONS(734),
    [anon_sym_SLASH_EQ] = ACTIONS(734),
    [anon_sym_AT_EQ] = ACTIONS(734),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(734),
    [anon_sym_PERCENT_EQ] = ACTIONS(734),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(734),
    [anon_sym_GT_GT_EQ] = ACTIONS(734),
    [anon_sym_LT_LT_EQ] = ACTIONS(734),
    [anon_sym_AMP_EQ] = ACTIONS(734),
    [anon_sym_CARET_EQ] = ACTIONS(734),
    [anon_sym_PIPE_EQ] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(734),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(734),
    [sym__newline] = ACTIONS(734),
  },
  [214] = {
    [sym_named_expression] = STATE(793),
    [sym_list_splat] = STATE(970),
    [sym__expression] = STATE(793),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(793),
    [sym_boolean_operator] = STATE(793),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(793),
    [sym_lambda] = STATE(793),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(793),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(793),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(528),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [anon_sym_RBRACK] = ACTIONS(738),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [215] = {
    [anon_sym_DOT] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(740),
    [anon_sym_COMMA] = ACTIONS(740),
    [anon_sym_STAR] = ACTIONS(742),
    [anon_sym_GT_GT] = ACTIONS(742),
    [anon_sym_if] = ACTIONS(740),
    [anon_sym_COLON] = ACTIONS(740),
    [anon_sym_in] = ACTIONS(740),
    [anon_sym_EQ] = ACTIONS(742),
    [anon_sym_AT] = ACTIONS(742),
    [anon_sym_not] = ACTIONS(740),
    [anon_sym_and] = ACTIONS(740),
    [anon_sym_or] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(742),
    [anon_sym_DASH] = ACTIONS(742),
    [anon_sym_SLASH] = ACTIONS(742),
    [anon_sym_PERCENT] = ACTIONS(742),
    [anon_sym_SLASH_SLASH] = ACTIONS(742),
    [anon_sym_STAR_STAR] = ACTIONS(742),
    [anon_sym_PIPE] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_CARET] = ACTIONS(742),
    [anon_sym_LT_LT] = ACTIONS(742),
    [anon_sym_LT] = ACTIONS(742),
    [anon_sym_LT_EQ] = ACTIONS(740),
    [anon_sym_EQ_EQ] = ACTIONS(740),
    [anon_sym_BANG_EQ] = ACTIONS(740),
    [anon_sym_GT_EQ] = ACTIONS(740),
    [anon_sym_GT] = ACTIONS(742),
    [anon_sym_LT_GT] = ACTIONS(740),
    [anon_sym_is] = ACTIONS(740),
    [anon_sym_PLUS_EQ] = ACTIONS(740),
    [anon_sym_DASH_EQ] = ACTIONS(740),
    [anon_sym_STAR_EQ] = ACTIONS(740),
    [anon_sym_SLASH_EQ] = ACTIONS(740),
    [anon_sym_AT_EQ] = ACTIONS(740),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(740),
    [anon_sym_PERCENT_EQ] = ACTIONS(740),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(740),
    [anon_sym_GT_GT_EQ] = ACTIONS(740),
    [anon_sym_LT_LT_EQ] = ACTIONS(740),
    [anon_sym_AMP_EQ] = ACTIONS(740),
    [anon_sym_CARET_EQ] = ACTIONS(740),
    [anon_sym_PIPE_EQ] = ACTIONS(740),
    [anon_sym_LBRACK] = ACTIONS(740),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(740),
    [sym__newline] = ACTIONS(740),
  },
  [216] = {
    [sym_named_expression] = STATE(851),
    [sym__expression] = STATE(851),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(851),
    [sym_boolean_operator] = STATE(851),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(851),
    [sym_lambda] = STATE(851),
    [sym_yield] = STATE(1049),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(851),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(851),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_RPAREN] = ACTIONS(744),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_yield] = ACTIONS(546),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [217] = {
    [anon_sym_DOT] = ACTIONS(746),
    [anon_sym_LPAREN] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_GT_GT] = ACTIONS(748),
    [anon_sym_if] = ACTIONS(746),
    [anon_sym_COLON] = ACTIONS(746),
    [anon_sym_in] = ACTIONS(746),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_AT] = ACTIONS(748),
    [anon_sym_not] = ACTIONS(746),
    [anon_sym_and] = ACTIONS(746),
    [anon_sym_or] = ACTIONS(746),
    [anon_sym_PLUS] = ACTIONS(748),
    [anon_sym_DASH] = ACTIONS(748),
    [anon_sym_SLASH] = ACTIONS(748),
    [anon_sym_PERCENT] = ACTIONS(748),
    [anon_sym_SLASH_SLASH] = ACTIONS(748),
    [anon_sym_STAR_STAR] = ACTIONS(748),
    [anon_sym_PIPE] = ACTIONS(748),
    [anon_sym_AMP] = ACTIONS(748),
    [anon_sym_CARET] = ACTIONS(748),
    [anon_sym_LT_LT] = ACTIONS(748),
    [anon_sym_LT] = ACTIONS(748),
    [anon_sym_LT_EQ] = ACTIONS(746),
    [anon_sym_EQ_EQ] = ACTIONS(746),
    [anon_sym_BANG_EQ] = ACTIONS(746),
    [anon_sym_GT_EQ] = ACTIONS(746),
    [anon_sym_GT] = ACTIONS(748),
    [anon_sym_LT_GT] = ACTIONS(746),
    [anon_sym_is] = ACTIONS(746),
    [anon_sym_PLUS_EQ] = ACTIONS(746),
    [anon_sym_DASH_EQ] = ACTIONS(746),
    [anon_sym_STAR_EQ] = ACTIONS(746),
    [anon_sym_SLASH_EQ] = ACTIONS(746),
    [anon_sym_AT_EQ] = ACTIONS(746),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(746),
    [anon_sym_PERCENT_EQ] = ACTIONS(746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(746),
    [anon_sym_GT_GT_EQ] = ACTIONS(746),
    [anon_sym_LT_LT_EQ] = ACTIONS(746),
    [anon_sym_AMP_EQ] = ACTIONS(746),
    [anon_sym_CARET_EQ] = ACTIONS(746),
    [anon_sym_PIPE_EQ] = ACTIONS(746),
    [anon_sym_LBRACK] = ACTIONS(746),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(746),
    [sym__newline] = ACTIONS(746),
  },
  [218] = {
    [sym_named_expression] = STATE(793),
    [sym_list_splat] = STATE(970),
    [sym__expression] = STATE(793),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(793),
    [sym_boolean_operator] = STATE(793),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(793),
    [sym_lambda] = STATE(793),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(793),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(793),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(528),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_RBRACE] = ACTIONS(750),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [219] = {
    [anon_sym_DOT] = ACTIONS(752),
    [anon_sym_LPAREN] = ACTIONS(752),
    [anon_sym_COMMA] = ACTIONS(752),
    [anon_sym_STAR] = ACTIONS(754),
    [anon_sym_GT_GT] = ACTIONS(754),
    [anon_sym_if] = ACTIONS(752),
    [anon_sym_COLON] = ACTIONS(752),
    [anon_sym_in] = ACTIONS(752),
    [anon_sym_EQ] = ACTIONS(754),
    [anon_sym_AT] = ACTIONS(754),
    [anon_sym_not] = ACTIONS(752),
    [anon_sym_and] = ACTIONS(752),
    [anon_sym_or] = ACTIONS(752),
    [anon_sym_PLUS] = ACTIONS(754),
    [anon_sym_DASH] = ACTIONS(754),
    [anon_sym_SLASH] = ACTIONS(754),
    [anon_sym_PERCENT] = ACTIONS(754),
    [anon_sym_SLASH_SLASH] = ACTIONS(754),
    [anon_sym_STAR_STAR] = ACTIONS(754),
    [anon_sym_PIPE] = ACTIONS(754),
    [anon_sym_AMP] = ACTIONS(754),
    [anon_sym_CARET] = ACTIONS(754),
    [anon_sym_LT_LT] = ACTIONS(754),
    [anon_sym_LT] = ACTIONS(754),
    [anon_sym_LT_EQ] = ACTIONS(752),
    [anon_sym_EQ_EQ] = ACTIONS(752),
    [anon_sym_BANG_EQ] = ACTIONS(752),
    [anon_sym_GT_EQ] = ACTIONS(752),
    [anon_sym_GT] = ACTIONS(754),
    [anon_sym_LT_GT] = ACTIONS(752),
    [anon_sym_is] = ACTIONS(752),
    [anon_sym_PLUS_EQ] = ACTIONS(752),
    [anon_sym_DASH_EQ] = ACTIONS(752),
    [anon_sym_STAR_EQ] = ACTIONS(752),
    [anon_sym_SLASH_EQ] = ACTIONS(752),
    [anon_sym_AT_EQ] = ACTIONS(752),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(752),
    [anon_sym_PERCENT_EQ] = ACTIONS(752),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(752),
    [anon_sym_GT_GT_EQ] = ACTIONS(752),
    [anon_sym_LT_LT_EQ] = ACTIONS(752),
    [anon_sym_AMP_EQ] = ACTIONS(752),
    [anon_sym_CARET_EQ] = ACTIONS(752),
    [anon_sym_PIPE_EQ] = ACTIONS(752),
    [anon_sym_LBRACK] = ACTIONS(752),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(752),
    [sym__newline] = ACTIONS(752),
  },
  [220] = {
    [sym_named_expression] = STATE(772),
    [sym__expression] = STATE(772),
    [sym__primary_expression] = STATE(532),
    [sym_not_operator] = STATE(772),
    [sym_boolean_operator] = STATE(772),
    [sym_binary_operator] = STATE(532),
    [sym_unary_operator] = STATE(532),
    [sym_comparison_operator] = STATE(772),
    [sym_lambda] = STATE(772),
    [sym_attribute] = STATE(532),
    [sym_subscript] = STATE(532),
    [sym_call] = STATE(532),
    [sym_list] = STATE(532),
    [sym_list_comprehension] = STATE(532),
    [sym_dictionary] = STATE(532),
    [sym_dictionary_comprehension] = STATE(532),
    [sym_set] = STATE(532),
    [sym_set_comprehension] = STATE(532),
    [sym_parenthesized_expression] = STATE(532),
    [sym_tuple] = STATE(532),
    [sym_generator_expression] = STATE(532),
    [sym_conditional_expression] = STATE(772),
    [sym_concatenated_string] = STATE(532),
    [sym_string] = STATE(530),
    [sym_await] = STATE(772),
    [sym_identifier] = ACTIONS(233),
    [anon_sym_from] = ACTIONS(756),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_print] = ACTIONS(239),
    [anon_sym_exec] = ACTIONS(239),
    [anon_sym_not] = ACTIONS(536),
    [anon_sym_PLUS] = ACTIONS(243),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_TILDE] = ACTIONS(243),
    [anon_sym_lambda] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(538),
    [sym_ellipsis] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [sym_integer] = ACTIONS(251),
    [sym_float] = ACTIONS(247),
    [sym_true] = ACTIONS(251),
    [sym_false] = ACTIONS(251),
    [sym_none] = ACTIONS(251),
    [anon_sym_await] = ACTIONS(253),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(351),
    [sym__newline] = ACTIONS(351),
    [sym__string_start] = ACTIONS(255),
  },
  [221] = {
    [anon_sym_DOT] = ACTIONS(758),
    [anon_sym_LPAREN] = ACTIONS(758),
    [anon_sym_COMMA] = ACTIONS(758),
    [anon_sym_STAR] = ACTIONS(760),
    [anon_sym_GT_GT] = ACTIONS(760),
    [anon_sym_if] = ACTIONS(758),
    [anon_sym_COLON] = ACTIONS(758),
    [anon_sym_in] = ACTIONS(758),
    [anon_sym_EQ] = ACTIONS(760),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_not] = ACTIONS(758),
    [anon_sym_and] = ACTIONS(758),
    [anon_sym_or] = ACTIONS(758),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_SLASH] = ACTIONS(760),
    [anon_sym_PERCENT] = ACTIONS(760),
    [anon_sym_SLASH_SLASH] = ACTIONS(760),
    [anon_sym_STAR_STAR] = ACTIONS(760),
    [anon_sym_PIPE] = ACTIONS(760),
    [anon_sym_AMP] = ACTIONS(760),
    [anon_sym_CARET] = ACTIONS(760),
    [anon_sym_LT_LT] = ACTIONS(760),
    [anon_sym_LT] = ACTIONS(760),
    [anon_sym_LT_EQ] = ACTIONS(758),
    [anon_sym_EQ_EQ] = ACTIONS(758),
    [anon_sym_BANG_EQ] = ACTIONS(758),
    [anon_sym_GT_EQ] = ACTIONS(758),
    [anon_sym_GT] = ACTIONS(760),
    [anon_sym_LT_GT] = ACTIONS(758),
    [anon_sym_is] = ACTIONS(758),
    [anon_sym_PLUS_EQ] = ACTIONS(758),
    [anon_sym_DASH_EQ] = ACTIONS(758),
    [anon_sym_STAR_EQ] = ACTIONS(758),
    [anon_sym_SLASH_EQ] = ACTIONS(758),
    [anon_sym_AT_EQ] = ACTIONS(758),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(758),
    [anon_sym_PERCENT_EQ] = ACTIONS(758),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(758),
    [anon_sym_GT_GT_EQ] = ACTIONS(758),
    [anon_sym_LT_LT_EQ] = ACTIONS(758),
    [anon_sym_AMP_EQ] = ACTIONS(758),
    [anon_sym_CARET_EQ] = ACTIONS(758),
    [anon_sym_PIPE_EQ] = ACTIONS(758),
    [anon_sym_LBRACK] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(758),
    [sym__newline] = ACTIONS(758),
  },
  [222] = {
    [anon_sym_DOT] = ACTIONS(762),
    [anon_sym_LPAREN] = ACTIONS(762),
    [anon_sym_COMMA] = ACTIONS(762),
    [anon_sym_STAR] = ACTIONS(764),
    [anon_sym_GT_GT] = ACTIONS(764),
    [anon_sym_if] = ACTIONS(762),
    [anon_sym_COLON] = ACTIONS(762),
    [anon_sym_in] = ACTIONS(762),
    [anon_sym_EQ] = ACTIONS(764),
    [anon_sym_AT] = ACTIONS(764),
    [anon_sym_not] = ACTIONS(762),
    [anon_sym_and] = ACTIONS(762),
    [anon_sym_or] = ACTIONS(762),
    [anon_sym_PLUS] = ACTIONS(764),
    [anon_sym_DASH] = ACTIONS(764),
    [anon_sym_SLASH] = ACTIONS(764),
    [anon_sym_PERCENT] = ACTIONS(764),
    [anon_sym_SLASH_SLASH] = ACTIONS(764),
    [anon_sym_STAR_STAR] = ACTIONS(764),
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_AMP] = ACTIONS(764),
    [anon_sym_CARET] = ACTIONS(764),
    [anon_sym_LT_LT] = ACTIONS(764),
    [anon_sym_LT] = ACTIONS(764),
    [anon_sym_LT_EQ] = ACTIONS(762),
    [anon_sym_EQ_EQ] = ACTIONS(762),
    [anon_sym_BANG_EQ] = ACTIONS(762),
    [anon_sym_GT_EQ] = ACTIONS(762),
    [anon_sym_GT] = ACTIONS(764),
    [anon_sym_LT_GT] = ACTIONS(762),
    [anon_sym_is] = ACTIONS(762),
    [anon_sym_PLUS_EQ] = ACTIONS(762),
    [anon_sym_DASH_EQ] = ACTIONS(762),
    [anon_sym_STAR_EQ] = ACTIONS(762),
    [anon_sym_SLASH_EQ] = ACTIONS(762),
    [anon_sym_AT_EQ] = ACTIONS(762),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(762),
    [anon_sym_PERCENT_EQ] = ACTIONS(762),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(762),
    [anon_sym_GT_GT_EQ] = ACTIONS(762),
    [anon_sym_LT_LT_EQ] = ACTIONS(762),
    [anon_sym_AMP_EQ] = ACTIONS(762),
    [anon_sym_CARET_EQ] = ACTIONS(762),
    [anon_sym_PIPE_EQ] = ACTIONS(762),
    [anon_sym_LBRACK] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(762),
    [sym__newline] = ACTIONS(762),
  },
  [223] = {
    [anon_sym_DOT] = ACTIONS(766),
    [anon_sym_LPAREN] = ACTIONS(766),
    [anon_sym_COMMA] = ACTIONS(766),
    [anon_sym_STAR] = ACTIONS(768),
    [anon_sym_GT_GT] = ACTIONS(768),
    [anon_sym_if] = ACTIONS(766),
    [anon_sym_COLON] = ACTIONS(766),
    [anon_sym_in] = ACTIONS(766),
    [anon_sym_EQ] = ACTIONS(768),
    [anon_sym_AT] = ACTIONS(768),
    [anon_sym_not] = ACTIONS(766),
    [anon_sym_and] = ACTIONS(766),
    [anon_sym_or] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(768),
    [anon_sym_DASH] = ACTIONS(768),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_PERCENT] = ACTIONS(768),
    [anon_sym_SLASH_SLASH] = ACTIONS(768),
    [anon_sym_STAR_STAR] = ACTIONS(768),
    [anon_sym_PIPE] = ACTIONS(768),
    [anon_sym_AMP] = ACTIONS(768),
    [anon_sym_CARET] = ACTIONS(768),
    [anon_sym_LT_LT] = ACTIONS(768),
    [anon_sym_LT] = ACTIONS(768),
    [anon_sym_LT_EQ] = ACTIONS(766),
    [anon_sym_EQ_EQ] = ACTIONS(766),
    [anon_sym_BANG_EQ] = ACTIONS(766),
    [anon_sym_GT_EQ] = ACTIONS(766),
    [anon_sym_GT] = ACTIONS(768),
    [anon_sym_LT_GT] = ACTIONS(766),
    [anon_sym_is] = ACTIONS(766),
    [anon_sym_PLUS_EQ] = ACTIONS(766),
    [anon_sym_DASH_EQ] = ACTIONS(766),
    [anon_sym_STAR_EQ] = ACTIONS(766),
    [anon_sym_SLASH_EQ] = ACTIONS(766),
    [anon_sym_AT_EQ] = ACTIONS(766),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(766),
    [anon_sym_PERCENT_EQ] = ACTIONS(766),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(766),
    [anon_sym_GT_GT_EQ] = ACTIONS(766),
    [anon_sym_LT_LT_EQ] = ACTIONS(766),
    [anon_sym_AMP_EQ] = ACTIONS(766),
    [anon_sym_CARET_EQ] = ACTIONS(766),
    [anon_sym_PIPE_EQ] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(766),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(766),
    [sym__newline] = ACTIONS(766),
  },
  [224] = {
    [anon_sym_DOT] = ACTIONS(770),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_COMMA] = ACTIONS(770),
    [anon_sym_STAR] = ACTIONS(772),
    [anon_sym_GT_GT] = ACTIONS(772),
    [anon_sym_if] = ACTIONS(770),
    [anon_sym_COLON] = ACTIONS(770),
    [anon_sym_in] = ACTIONS(770),
    [anon_sym_EQ] = ACTIONS(772),
    [anon_sym_AT] = ACTIONS(772),
    [anon_sym_not] = ACTIONS(770),
    [anon_sym_and] = ACTIONS(770),
    [anon_sym_or] = ACTIONS(770),
    [anon_sym_PLUS] = ACTIONS(772),
    [anon_sym_DASH] = ACTIONS(772),
    [anon_sym_SLASH] = ACTIONS(772),
    [anon_sym_PERCENT] = ACTIONS(772),
    [anon_sym_SLASH_SLASH] = ACTIONS(772),
    [anon_sym_STAR_STAR] = ACTIONS(772),
    [anon_sym_PIPE] = ACTIONS(772),
    [anon_sym_AMP] = ACTIONS(772),
    [anon_sym_CARET] = ACTIONS(772),
    [anon_sym_LT_LT] = ACTIONS(772),
    [anon_sym_LT] = ACTIONS(772),
    [anon_sym_LT_EQ] = ACTIONS(770),
    [anon_sym_EQ_EQ] = ACTIONS(770),
    [anon_sym_BANG_EQ] = ACTIONS(770),
    [anon_sym_GT_EQ] = ACTIONS(770),
    [anon_sym_GT] = ACTIONS(772),
    [anon_sym_LT_GT] = ACTIONS(770),
    [anon_sym_is] = ACTIONS(770),
    [anon_sym_PLUS_EQ] = ACTIONS(770),
    [anon_sym_DASH_EQ] = ACTIONS(770),
    [anon_sym_STAR_EQ] = ACTIONS(770),
    [anon_sym_SLASH_EQ] = ACTIONS(770),
    [anon_sym_AT_EQ] = ACTIONS(770),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(770),
    [anon_sym_PERCENT_EQ] = ACTIONS(770),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(770),
    [anon_sym_GT_GT_EQ] = ACTIONS(770),
    [anon_sym_LT_LT_EQ] = ACTIONS(770),
    [anon_sym_AMP_EQ] = ACTIONS(770),
    [anon_sym_CARET_EQ] = ACTIONS(770),
    [anon_sym_PIPE_EQ] = ACTIONS(770),
    [anon_sym_LBRACK] = ACTIONS(770),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(770),
    [sym__newline] = ACTIONS(770),
  },
  [225] = {
    [sym_named_expression] = STATE(803),
    [sym__expression] = STATE(803),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(803),
    [sym_boolean_operator] = STATE(803),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(803),
    [sym_lambda] = STATE(803),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_slice] = STATE(1038),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(803),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(803),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_COLON] = ACTIONS(630),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [anon_sym_RBRACK] = ACTIONS(774),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [226] = {
    [anon_sym_DOT] = ACTIONS(776),
    [anon_sym_LPAREN] = ACTIONS(776),
    [anon_sym_COMMA] = ACTIONS(776),
    [anon_sym_STAR] = ACTIONS(778),
    [anon_sym_GT_GT] = ACTIONS(778),
    [anon_sym_if] = ACTIONS(776),
    [anon_sym_COLON] = ACTIONS(776),
    [anon_sym_in] = ACTIONS(776),
    [anon_sym_EQ] = ACTIONS(778),
    [anon_sym_AT] = ACTIONS(778),
    [anon_sym_not] = ACTIONS(776),
    [anon_sym_and] = ACTIONS(776),
    [anon_sym_or] = ACTIONS(776),
    [anon_sym_PLUS] = ACTIONS(778),
    [anon_sym_DASH] = ACTIONS(778),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_PERCENT] = ACTIONS(778),
    [anon_sym_SLASH_SLASH] = ACTIONS(778),
    [anon_sym_STAR_STAR] = ACTIONS(778),
    [anon_sym_PIPE] = ACTIONS(778),
    [anon_sym_AMP] = ACTIONS(778),
    [anon_sym_CARET] = ACTIONS(778),
    [anon_sym_LT_LT] = ACTIONS(778),
    [anon_sym_LT] = ACTIONS(778),
    [anon_sym_LT_EQ] = ACTIONS(776),
    [anon_sym_EQ_EQ] = ACTIONS(776),
    [anon_sym_BANG_EQ] = ACTIONS(776),
    [anon_sym_GT_EQ] = ACTIONS(776),
    [anon_sym_GT] = ACTIONS(778),
    [anon_sym_LT_GT] = ACTIONS(776),
    [anon_sym_is] = ACTIONS(776),
    [anon_sym_PLUS_EQ] = ACTIONS(776),
    [anon_sym_DASH_EQ] = ACTIONS(776),
    [anon_sym_STAR_EQ] = ACTIONS(776),
    [anon_sym_SLASH_EQ] = ACTIONS(776),
    [anon_sym_AT_EQ] = ACTIONS(776),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(776),
    [anon_sym_PERCENT_EQ] = ACTIONS(776),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(776),
    [anon_sym_GT_GT_EQ] = ACTIONS(776),
    [anon_sym_LT_LT_EQ] = ACTIONS(776),
    [anon_sym_AMP_EQ] = ACTIONS(776),
    [anon_sym_CARET_EQ] = ACTIONS(776),
    [anon_sym_PIPE_EQ] = ACTIONS(776),
    [anon_sym_LBRACK] = ACTIONS(776),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(776),
    [sym__newline] = ACTIONS(776),
  },
  [227] = {
    [anon_sym_DOT] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(780),
    [anon_sym_COMMA] = ACTIONS(780),
    [anon_sym_STAR] = ACTIONS(782),
    [anon_sym_GT_GT] = ACTIONS(782),
    [anon_sym_if] = ACTIONS(780),
    [anon_sym_COLON] = ACTIONS(780),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_EQ] = ACTIONS(782),
    [anon_sym_AT] = ACTIONS(782),
    [anon_sym_not] = ACTIONS(780),
    [anon_sym_and] = ACTIONS(780),
    [anon_sym_or] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(782),
    [anon_sym_DASH] = ACTIONS(782),
    [anon_sym_SLASH] = ACTIONS(782),
    [anon_sym_PERCENT] = ACTIONS(782),
    [anon_sym_SLASH_SLASH] = ACTIONS(782),
    [anon_sym_STAR_STAR] = ACTIONS(782),
    [anon_sym_PIPE] = ACTIONS(782),
    [anon_sym_AMP] = ACTIONS(782),
    [anon_sym_CARET] = ACTIONS(782),
    [anon_sym_LT_LT] = ACTIONS(782),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_LT_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_GT_EQ] = ACTIONS(780),
    [anon_sym_GT] = ACTIONS(782),
    [anon_sym_LT_GT] = ACTIONS(780),
    [anon_sym_is] = ACTIONS(780),
    [anon_sym_PLUS_EQ] = ACTIONS(780),
    [anon_sym_DASH_EQ] = ACTIONS(780),
    [anon_sym_STAR_EQ] = ACTIONS(780),
    [anon_sym_SLASH_EQ] = ACTIONS(780),
    [anon_sym_AT_EQ] = ACTIONS(780),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(780),
    [anon_sym_PERCENT_EQ] = ACTIONS(780),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(780),
    [anon_sym_GT_GT_EQ] = ACTIONS(780),
    [anon_sym_LT_LT_EQ] = ACTIONS(780),
    [anon_sym_AMP_EQ] = ACTIONS(780),
    [anon_sym_CARET_EQ] = ACTIONS(780),
    [anon_sym_PIPE_EQ] = ACTIONS(780),
    [anon_sym_LBRACK] = ACTIONS(780),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(780),
    [sym__newline] = ACTIONS(780),
  },
  [228] = {
    [sym_named_expression] = STATE(803),
    [sym__expression] = STATE(803),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(803),
    [sym_boolean_operator] = STATE(803),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(803),
    [sym_lambda] = STATE(803),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_slice] = STATE(1038),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(803),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(803),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_COLON] = ACTIONS(630),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [anon_sym_RBRACK] = ACTIONS(784),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [229] = {
    [sym_named_expression] = STATE(793),
    [sym_list_splat] = STATE(970),
    [sym__expression] = STATE(793),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(793),
    [sym_boolean_operator] = STATE(793),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(793),
    [sym_lambda] = STATE(793),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(793),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(793),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(528),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_RBRACE] = ACTIONS(786),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [230] = {
    [anon_sym_DOT] = ACTIONS(788),
    [anon_sym_LPAREN] = ACTIONS(788),
    [anon_sym_COMMA] = ACTIONS(788),
    [anon_sym_STAR] = ACTIONS(790),
    [anon_sym_GT_GT] = ACTIONS(790),
    [anon_sym_if] = ACTIONS(788),
    [anon_sym_COLON] = ACTIONS(788),
    [anon_sym_in] = ACTIONS(788),
    [anon_sym_EQ] = ACTIONS(790),
    [anon_sym_AT] = ACTIONS(790),
    [anon_sym_not] = ACTIONS(788),
    [anon_sym_and] = ACTIONS(788),
    [anon_sym_or] = ACTIONS(788),
    [anon_sym_PLUS] = ACTIONS(790),
    [anon_sym_DASH] = ACTIONS(790),
    [anon_sym_SLASH] = ACTIONS(790),
    [anon_sym_PERCENT] = ACTIONS(790),
    [anon_sym_SLASH_SLASH] = ACTIONS(790),
    [anon_sym_STAR_STAR] = ACTIONS(790),
    [anon_sym_PIPE] = ACTIONS(790),
    [anon_sym_AMP] = ACTIONS(790),
    [anon_sym_CARET] = ACTIONS(790),
    [anon_sym_LT_LT] = ACTIONS(790),
    [anon_sym_LT] = ACTIONS(790),
    [anon_sym_LT_EQ] = ACTIONS(788),
    [anon_sym_EQ_EQ] = ACTIONS(788),
    [anon_sym_BANG_EQ] = ACTIONS(788),
    [anon_sym_GT_EQ] = ACTIONS(788),
    [anon_sym_GT] = ACTIONS(790),
    [anon_sym_LT_GT] = ACTIONS(788),
    [anon_sym_is] = ACTIONS(788),
    [anon_sym_PLUS_EQ] = ACTIONS(788),
    [anon_sym_DASH_EQ] = ACTIONS(788),
    [anon_sym_STAR_EQ] = ACTIONS(788),
    [anon_sym_SLASH_EQ] = ACTIONS(788),
    [anon_sym_AT_EQ] = ACTIONS(788),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(788),
    [anon_sym_PERCENT_EQ] = ACTIONS(788),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(788),
    [anon_sym_GT_GT_EQ] = ACTIONS(788),
    [anon_sym_LT_LT_EQ] = ACTIONS(788),
    [anon_sym_AMP_EQ] = ACTIONS(788),
    [anon_sym_CARET_EQ] = ACTIONS(788),
    [anon_sym_PIPE_EQ] = ACTIONS(788),
    [anon_sym_LBRACK] = ACTIONS(788),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(788),
    [sym__newline] = ACTIONS(788),
  },
  [231] = {
    [anon_sym_DOT] = ACTIONS(792),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_COMMA] = ACTIONS(792),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_GT_GT] = ACTIONS(794),
    [anon_sym_if] = ACTIONS(792),
    [anon_sym_COLON] = ACTIONS(792),
    [anon_sym_in] = ACTIONS(792),
    [anon_sym_EQ] = ACTIONS(794),
    [anon_sym_AT] = ACTIONS(794),
    [anon_sym_not] = ACTIONS(792),
    [anon_sym_and] = ACTIONS(792),
    [anon_sym_or] = ACTIONS(792),
    [anon_sym_PLUS] = ACTIONS(794),
    [anon_sym_DASH] = ACTIONS(794),
    [anon_sym_SLASH] = ACTIONS(794),
    [anon_sym_PERCENT] = ACTIONS(794),
    [anon_sym_SLASH_SLASH] = ACTIONS(794),
    [anon_sym_STAR_STAR] = ACTIONS(794),
    [anon_sym_PIPE] = ACTIONS(794),
    [anon_sym_AMP] = ACTIONS(794),
    [anon_sym_CARET] = ACTIONS(794),
    [anon_sym_LT_LT] = ACTIONS(794),
    [anon_sym_LT] = ACTIONS(794),
    [anon_sym_LT_EQ] = ACTIONS(792),
    [anon_sym_EQ_EQ] = ACTIONS(792),
    [anon_sym_BANG_EQ] = ACTIONS(792),
    [anon_sym_GT_EQ] = ACTIONS(792),
    [anon_sym_GT] = ACTIONS(794),
    [anon_sym_LT_GT] = ACTIONS(792),
    [anon_sym_is] = ACTIONS(792),
    [anon_sym_PLUS_EQ] = ACTIONS(792),
    [anon_sym_DASH_EQ] = ACTIONS(792),
    [anon_sym_STAR_EQ] = ACTIONS(792),
    [anon_sym_SLASH_EQ] = ACTIONS(792),
    [anon_sym_AT_EQ] = ACTIONS(792),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(792),
    [anon_sym_PERCENT_EQ] = ACTIONS(792),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(792),
    [anon_sym_GT_GT_EQ] = ACTIONS(792),
    [anon_sym_LT_LT_EQ] = ACTIONS(792),
    [anon_sym_AMP_EQ] = ACTIONS(792),
    [anon_sym_CARET_EQ] = ACTIONS(792),
    [anon_sym_PIPE_EQ] = ACTIONS(792),
    [anon_sym_LBRACK] = ACTIONS(792),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(792),
    [sym__newline] = ACTIONS(792),
  },
  [232] = {
    [anon_sym_DOT] = ACTIONS(796),
    [anon_sym_LPAREN] = ACTIONS(796),
    [anon_sym_COMMA] = ACTIONS(796),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_GT_GT] = ACTIONS(798),
    [anon_sym_if] = ACTIONS(796),
    [anon_sym_COLON] = ACTIONS(796),
    [anon_sym_in] = ACTIONS(796),
    [anon_sym_EQ] = ACTIONS(798),
    [anon_sym_AT] = ACTIONS(798),
    [anon_sym_not] = ACTIONS(796),
    [anon_sym_and] = ACTIONS(796),
    [anon_sym_or] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_PERCENT] = ACTIONS(798),
    [anon_sym_SLASH_SLASH] = ACTIONS(798),
    [anon_sym_STAR_STAR] = ACTIONS(798),
    [anon_sym_PIPE] = ACTIONS(798),
    [anon_sym_AMP] = ACTIONS(798),
    [anon_sym_CARET] = ACTIONS(798),
    [anon_sym_LT_LT] = ACTIONS(798),
    [anon_sym_LT] = ACTIONS(798),
    [anon_sym_LT_EQ] = ACTIONS(796),
    [anon_sym_EQ_EQ] = ACTIONS(796),
    [anon_sym_BANG_EQ] = ACTIONS(796),
    [anon_sym_GT_EQ] = ACTIONS(796),
    [anon_sym_GT] = ACTIONS(798),
    [anon_sym_LT_GT] = ACTIONS(796),
    [anon_sym_is] = ACTIONS(796),
    [anon_sym_PLUS_EQ] = ACTIONS(796),
    [anon_sym_DASH_EQ] = ACTIONS(796),
    [anon_sym_STAR_EQ] = ACTIONS(796),
    [anon_sym_SLASH_EQ] = ACTIONS(796),
    [anon_sym_AT_EQ] = ACTIONS(796),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(796),
    [anon_sym_PERCENT_EQ] = ACTIONS(796),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(796),
    [anon_sym_GT_GT_EQ] = ACTIONS(796),
    [anon_sym_LT_LT_EQ] = ACTIONS(796),
    [anon_sym_AMP_EQ] = ACTIONS(796),
    [anon_sym_CARET_EQ] = ACTIONS(796),
    [anon_sym_PIPE_EQ] = ACTIONS(796),
    [anon_sym_LBRACK] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(796),
    [sym__newline] = ACTIONS(796),
  },
  [233] = {
    [sym_named_expression] = STATE(803),
    [sym__expression] = STATE(803),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(803),
    [sym_boolean_operator] = STATE(803),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(803),
    [sym_lambda] = STATE(803),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_slice] = STATE(1038),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(803),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(803),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_COLON] = ACTIONS(630),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [anon_sym_RBRACK] = ACTIONS(800),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [234] = {
    [anon_sym_DOT] = ACTIONS(802),
    [anon_sym_LPAREN] = ACTIONS(802),
    [anon_sym_COMMA] = ACTIONS(802),
    [anon_sym_STAR] = ACTIONS(804),
    [anon_sym_GT_GT] = ACTIONS(804),
    [anon_sym_if] = ACTIONS(802),
    [anon_sym_COLON] = ACTIONS(802),
    [anon_sym_in] = ACTIONS(802),
    [anon_sym_EQ] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(804),
    [anon_sym_not] = ACTIONS(802),
    [anon_sym_and] = ACTIONS(802),
    [anon_sym_or] = ACTIONS(802),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_SLASH] = ACTIONS(804),
    [anon_sym_PERCENT] = ACTIONS(804),
    [anon_sym_SLASH_SLASH] = ACTIONS(804),
    [anon_sym_STAR_STAR] = ACTIONS(804),
    [anon_sym_PIPE] = ACTIONS(804),
    [anon_sym_AMP] = ACTIONS(804),
    [anon_sym_CARET] = ACTIONS(804),
    [anon_sym_LT_LT] = ACTIONS(804),
    [anon_sym_LT] = ACTIONS(804),
    [anon_sym_LT_EQ] = ACTIONS(802),
    [anon_sym_EQ_EQ] = ACTIONS(802),
    [anon_sym_BANG_EQ] = ACTIONS(802),
    [anon_sym_GT_EQ] = ACTIONS(802),
    [anon_sym_GT] = ACTIONS(804),
    [anon_sym_LT_GT] = ACTIONS(802),
    [anon_sym_is] = ACTIONS(802),
    [anon_sym_PLUS_EQ] = ACTIONS(802),
    [anon_sym_DASH_EQ] = ACTIONS(802),
    [anon_sym_STAR_EQ] = ACTIONS(802),
    [anon_sym_SLASH_EQ] = ACTIONS(802),
    [anon_sym_AT_EQ] = ACTIONS(802),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(802),
    [anon_sym_PERCENT_EQ] = ACTIONS(802),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(802),
    [anon_sym_GT_GT_EQ] = ACTIONS(802),
    [anon_sym_LT_LT_EQ] = ACTIONS(802),
    [anon_sym_AMP_EQ] = ACTIONS(802),
    [anon_sym_CARET_EQ] = ACTIONS(802),
    [anon_sym_PIPE_EQ] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(802),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(802),
    [sym__newline] = ACTIONS(802),
  },
  [235] = {
    [anon_sym_DOT] = ACTIONS(806),
    [anon_sym_LPAREN] = ACTIONS(806),
    [anon_sym_COMMA] = ACTIONS(806),
    [anon_sym_STAR] = ACTIONS(808),
    [anon_sym_GT_GT] = ACTIONS(808),
    [anon_sym_if] = ACTIONS(806),
    [anon_sym_COLON] = ACTIONS(806),
    [anon_sym_in] = ACTIONS(806),
    [anon_sym_EQ] = ACTIONS(808),
    [anon_sym_AT] = ACTIONS(808),
    [anon_sym_not] = ACTIONS(806),
    [anon_sym_and] = ACTIONS(806),
    [anon_sym_or] = ACTIONS(806),
    [anon_sym_PLUS] = ACTIONS(808),
    [anon_sym_DASH] = ACTIONS(808),
    [anon_sym_SLASH] = ACTIONS(808),
    [anon_sym_PERCENT] = ACTIONS(808),
    [anon_sym_SLASH_SLASH] = ACTIONS(808),
    [anon_sym_STAR_STAR] = ACTIONS(808),
    [anon_sym_PIPE] = ACTIONS(808),
    [anon_sym_AMP] = ACTIONS(808),
    [anon_sym_CARET] = ACTIONS(808),
    [anon_sym_LT_LT] = ACTIONS(808),
    [anon_sym_LT] = ACTIONS(808),
    [anon_sym_LT_EQ] = ACTIONS(806),
    [anon_sym_EQ_EQ] = ACTIONS(806),
    [anon_sym_BANG_EQ] = ACTIONS(806),
    [anon_sym_GT_EQ] = ACTIONS(806),
    [anon_sym_GT] = ACTIONS(808),
    [anon_sym_LT_GT] = ACTIONS(806),
    [anon_sym_is] = ACTIONS(806),
    [anon_sym_PLUS_EQ] = ACTIONS(806),
    [anon_sym_DASH_EQ] = ACTIONS(806),
    [anon_sym_STAR_EQ] = ACTIONS(806),
    [anon_sym_SLASH_EQ] = ACTIONS(806),
    [anon_sym_AT_EQ] = ACTIONS(806),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(806),
    [anon_sym_PERCENT_EQ] = ACTIONS(806),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(806),
    [anon_sym_GT_GT_EQ] = ACTIONS(806),
    [anon_sym_LT_LT_EQ] = ACTIONS(806),
    [anon_sym_AMP_EQ] = ACTIONS(806),
    [anon_sym_CARET_EQ] = ACTIONS(806),
    [anon_sym_PIPE_EQ] = ACTIONS(806),
    [anon_sym_LBRACK] = ACTIONS(806),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(806),
    [sym__newline] = ACTIONS(806),
  },
  [236] = {
    [sym_named_expression] = STATE(793),
    [sym_list_splat] = STATE(970),
    [sym__expression] = STATE(793),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(793),
    [sym_boolean_operator] = STATE(793),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(793),
    [sym_lambda] = STATE(793),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(793),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(793),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(528),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [anon_sym_RBRACK] = ACTIONS(810),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [237] = {
    [anon_sym_DOT] = ACTIONS(812),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_COMMA] = ACTIONS(812),
    [anon_sym_STAR] = ACTIONS(814),
    [anon_sym_GT_GT] = ACTIONS(814),
    [anon_sym_if] = ACTIONS(812),
    [anon_sym_COLON] = ACTIONS(812),
    [anon_sym_in] = ACTIONS(812),
    [anon_sym_EQ] = ACTIONS(814),
    [anon_sym_AT] = ACTIONS(814),
    [anon_sym_not] = ACTIONS(812),
    [anon_sym_and] = ACTIONS(812),
    [anon_sym_or] = ACTIONS(812),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_SLASH] = ACTIONS(814),
    [anon_sym_PERCENT] = ACTIONS(814),
    [anon_sym_SLASH_SLASH] = ACTIONS(814),
    [anon_sym_STAR_STAR] = ACTIONS(814),
    [anon_sym_PIPE] = ACTIONS(814),
    [anon_sym_AMP] = ACTIONS(814),
    [anon_sym_CARET] = ACTIONS(814),
    [anon_sym_LT_LT] = ACTIONS(814),
    [anon_sym_LT] = ACTIONS(814),
    [anon_sym_LT_EQ] = ACTIONS(812),
    [anon_sym_EQ_EQ] = ACTIONS(812),
    [anon_sym_BANG_EQ] = ACTIONS(812),
    [anon_sym_GT_EQ] = ACTIONS(812),
    [anon_sym_GT] = ACTIONS(814),
    [anon_sym_LT_GT] = ACTIONS(812),
    [anon_sym_is] = ACTIONS(812),
    [anon_sym_PLUS_EQ] = ACTIONS(812),
    [anon_sym_DASH_EQ] = ACTIONS(812),
    [anon_sym_STAR_EQ] = ACTIONS(812),
    [anon_sym_SLASH_EQ] = ACTIONS(812),
    [anon_sym_AT_EQ] = ACTIONS(812),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(812),
    [anon_sym_PERCENT_EQ] = ACTIONS(812),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(812),
    [anon_sym_GT_GT_EQ] = ACTIONS(812),
    [anon_sym_LT_LT_EQ] = ACTIONS(812),
    [anon_sym_AMP_EQ] = ACTIONS(812),
    [anon_sym_CARET_EQ] = ACTIONS(812),
    [anon_sym_PIPE_EQ] = ACTIONS(812),
    [anon_sym_LBRACK] = ACTIONS(812),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(812),
    [sym__newline] = ACTIONS(812),
  },
  [238] = {
    [anon_sym_DOT] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(816),
    [anon_sym_COMMA] = ACTIONS(816),
    [anon_sym_STAR] = ACTIONS(818),
    [anon_sym_GT_GT] = ACTIONS(818),
    [anon_sym_if] = ACTIONS(816),
    [anon_sym_COLON] = ACTIONS(816),
    [anon_sym_in] = ACTIONS(816),
    [anon_sym_EQ] = ACTIONS(818),
    [anon_sym_AT] = ACTIONS(818),
    [anon_sym_not] = ACTIONS(816),
    [anon_sym_and] = ACTIONS(816),
    [anon_sym_or] = ACTIONS(816),
    [anon_sym_PLUS] = ACTIONS(818),
    [anon_sym_DASH] = ACTIONS(818),
    [anon_sym_SLASH] = ACTIONS(818),
    [anon_sym_PERCENT] = ACTIONS(818),
    [anon_sym_SLASH_SLASH] = ACTIONS(818),
    [anon_sym_STAR_STAR] = ACTIONS(818),
    [anon_sym_PIPE] = ACTIONS(818),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_CARET] = ACTIONS(818),
    [anon_sym_LT_LT] = ACTIONS(818),
    [anon_sym_LT] = ACTIONS(818),
    [anon_sym_LT_EQ] = ACTIONS(816),
    [anon_sym_EQ_EQ] = ACTIONS(816),
    [anon_sym_BANG_EQ] = ACTIONS(816),
    [anon_sym_GT_EQ] = ACTIONS(816),
    [anon_sym_GT] = ACTIONS(818),
    [anon_sym_LT_GT] = ACTIONS(816),
    [anon_sym_is] = ACTIONS(816),
    [anon_sym_PLUS_EQ] = ACTIONS(816),
    [anon_sym_DASH_EQ] = ACTIONS(816),
    [anon_sym_STAR_EQ] = ACTIONS(816),
    [anon_sym_SLASH_EQ] = ACTIONS(816),
    [anon_sym_AT_EQ] = ACTIONS(816),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(816),
    [anon_sym_PERCENT_EQ] = ACTIONS(816),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(816),
    [anon_sym_GT_GT_EQ] = ACTIONS(816),
    [anon_sym_LT_LT_EQ] = ACTIONS(816),
    [anon_sym_AMP_EQ] = ACTIONS(816),
    [anon_sym_CARET_EQ] = ACTIONS(816),
    [anon_sym_PIPE_EQ] = ACTIONS(816),
    [anon_sym_LBRACK] = ACTIONS(816),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(816),
    [sym__newline] = ACTIONS(816),
  },
  [239] = {
    [sym_named_expression] = STATE(803),
    [sym__expression] = STATE(803),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(803),
    [sym_boolean_operator] = STATE(803),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(803),
    [sym_lambda] = STATE(803),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_slice] = STATE(1038),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(803),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(803),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_COLON] = ACTIONS(630),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [anon_sym_RBRACK] = ACTIONS(820),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [240] = {
    [anon_sym_DOT] = ACTIONS(822),
    [anon_sym_LPAREN] = ACTIONS(822),
    [anon_sym_COMMA] = ACTIONS(822),
    [anon_sym_STAR] = ACTIONS(824),
    [anon_sym_GT_GT] = ACTIONS(824),
    [anon_sym_if] = ACTIONS(822),
    [anon_sym_COLON] = ACTIONS(822),
    [anon_sym_in] = ACTIONS(822),
    [anon_sym_EQ] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(824),
    [anon_sym_not] = ACTIONS(822),
    [anon_sym_and] = ACTIONS(822),
    [anon_sym_or] = ACTIONS(822),
    [anon_sym_PLUS] = ACTIONS(824),
    [anon_sym_DASH] = ACTIONS(824),
    [anon_sym_SLASH] = ACTIONS(824),
    [anon_sym_PERCENT] = ACTIONS(824),
    [anon_sym_SLASH_SLASH] = ACTIONS(824),
    [anon_sym_STAR_STAR] = ACTIONS(824),
    [anon_sym_PIPE] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(824),
    [anon_sym_CARET] = ACTIONS(824),
    [anon_sym_LT_LT] = ACTIONS(824),
    [anon_sym_LT] = ACTIONS(824),
    [anon_sym_LT_EQ] = ACTIONS(822),
    [anon_sym_EQ_EQ] = ACTIONS(822),
    [anon_sym_BANG_EQ] = ACTIONS(822),
    [anon_sym_GT_EQ] = ACTIONS(822),
    [anon_sym_GT] = ACTIONS(824),
    [anon_sym_LT_GT] = ACTIONS(822),
    [anon_sym_is] = ACTIONS(822),
    [anon_sym_PLUS_EQ] = ACTIONS(822),
    [anon_sym_DASH_EQ] = ACTIONS(822),
    [anon_sym_STAR_EQ] = ACTIONS(822),
    [anon_sym_SLASH_EQ] = ACTIONS(822),
    [anon_sym_AT_EQ] = ACTIONS(822),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(822),
    [anon_sym_PERCENT_EQ] = ACTIONS(822),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(822),
    [anon_sym_GT_GT_EQ] = ACTIONS(822),
    [anon_sym_LT_LT_EQ] = ACTIONS(822),
    [anon_sym_AMP_EQ] = ACTIONS(822),
    [anon_sym_CARET_EQ] = ACTIONS(822),
    [anon_sym_PIPE_EQ] = ACTIONS(822),
    [anon_sym_LBRACK] = ACTIONS(822),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(822),
    [sym__newline] = ACTIONS(822),
  },
  [241] = {
    [sym_named_expression] = STATE(749),
    [sym__expression_within_for_in_clause] = STATE(761),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(749),
    [sym_boolean_operator] = STATE(749),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(749),
    [sym_lambda] = STATE(749),
    [sym_lambda_within_for_in_clause] = STATE(761),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(749),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(749),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [242] = {
    [sym_named_expression] = STATE(747),
    [sym__expression_within_for_in_clause] = STATE(784),
    [sym__expression] = STATE(747),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(747),
    [sym_boolean_operator] = STATE(747),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(747),
    [sym_lambda] = STATE(747),
    [sym_lambda_within_for_in_clause] = STATE(784),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(747),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(747),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [243] = {
    [sym_elif_clause] = STATE(401),
    [sym_else_clause] = STATE(488),
    [aux_sym_if_statement_repeat1] = STATE(297),
    [sym_identifier] = ACTIONS(826),
    [anon_sym_import] = ACTIONS(826),
    [anon_sym_from] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(828),
    [anon_sym_print] = ACTIONS(826),
    [anon_sym_assert] = ACTIONS(826),
    [anon_sym_return] = ACTIONS(826),
    [anon_sym_del] = ACTIONS(826),
    [anon_sym_raise] = ACTIONS(826),
    [anon_sym_pass] = ACTIONS(826),
    [anon_sym_break] = ACTIONS(826),
    [anon_sym_continue] = ACTIONS(826),
    [anon_sym_if] = ACTIONS(826),
    [anon_sym_elif] = ACTIONS(830),
    [anon_sym_else] = ACTIONS(568),
    [anon_sym_async] = ACTIONS(826),
    [anon_sym_for] = ACTIONS(826),
    [anon_sym_while] = ACTIONS(826),
    [anon_sym_try] = ACTIONS(826),
    [anon_sym_with] = ACTIONS(826),
    [anon_sym_def] = ACTIONS(826),
    [anon_sym_global] = ACTIONS(826),
    [anon_sym_nonlocal] = ACTIONS(826),
    [anon_sym_exec] = ACTIONS(826),
    [anon_sym_class] = ACTIONS(826),
    [anon_sym_AT] = ACTIONS(828),
    [anon_sym_not] = ACTIONS(826),
    [anon_sym_PLUS] = ACTIONS(828),
    [anon_sym_DASH] = ACTIONS(828),
    [anon_sym_TILDE] = ACTIONS(828),
    [anon_sym_lambda] = ACTIONS(826),
    [anon_sym_yield] = ACTIONS(826),
    [anon_sym_LBRACK] = ACTIONS(828),
    [sym_ellipsis] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(828),
    [sym_integer] = ACTIONS(826),
    [sym_float] = ACTIONS(828),
    [sym_true] = ACTIONS(826),
    [sym_false] = ACTIONS(826),
    [sym_none] = ACTIONS(826),
    [anon_sym_await] = ACTIONS(826),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(828),
    [sym__string_start] = ACTIONS(828),
  },
  [244] = {
    [sym_named_expression] = STATE(791),
    [sym__expression] = STATE(791),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(791),
    [sym_boolean_operator] = STATE(791),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(791),
    [sym_lambda] = STATE(791),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_slice] = STATE(951),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(791),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(791),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_COLON] = ACTIONS(630),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [245] = {
    [sym_named_expression] = STATE(780),
    [sym__expression] = STATE(780),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(780),
    [sym_boolean_operator] = STATE(780),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(780),
    [sym_lambda] = STATE(780),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_slice] = STATE(1009),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(780),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(780),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_COLON] = ACTIONS(630),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [246] = {
    [sym_named_expression] = STATE(846),
    [sym__expression] = STATE(846),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(846),
    [sym_boolean_operator] = STATE(846),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(846),
    [sym_lambda] = STATE(846),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(846),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(846),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_COMMA] = ACTIONS(832),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [anon_sym_RBRACK] = ACTIONS(832),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [247] = {
    [sym_named_expression] = STATE(749),
    [sym__expression_within_for_in_clause] = STATE(781),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(749),
    [sym_boolean_operator] = STATE(749),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(749),
    [sym_lambda] = STATE(749),
    [sym_lambda_within_for_in_clause] = STATE(781),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(749),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(749),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [248] = {
    [sym_elif_clause] = STATE(401),
    [sym_else_clause] = STATE(412),
    [aux_sym_if_statement_repeat1] = STATE(243),
    [sym_identifier] = ACTIONS(834),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_from] = ACTIONS(834),
    [anon_sym_LPAREN] = ACTIONS(836),
    [anon_sym_print] = ACTIONS(834),
    [anon_sym_assert] = ACTIONS(834),
    [anon_sym_return] = ACTIONS(834),
    [anon_sym_del] = ACTIONS(834),
    [anon_sym_raise] = ACTIONS(834),
    [anon_sym_pass] = ACTIONS(834),
    [anon_sym_break] = ACTIONS(834),
    [anon_sym_continue] = ACTIONS(834),
    [anon_sym_if] = ACTIONS(834),
    [anon_sym_elif] = ACTIONS(830),
    [anon_sym_else] = ACTIONS(568),
    [anon_sym_async] = ACTIONS(834),
    [anon_sym_for] = ACTIONS(834),
    [anon_sym_while] = ACTIONS(834),
    [anon_sym_try] = ACTIONS(834),
    [anon_sym_with] = ACTIONS(834),
    [anon_sym_def] = ACTIONS(834),
    [anon_sym_global] = ACTIONS(834),
    [anon_sym_nonlocal] = ACTIONS(834),
    [anon_sym_exec] = ACTIONS(834),
    [anon_sym_class] = ACTIONS(834),
    [anon_sym_AT] = ACTIONS(836),
    [anon_sym_not] = ACTIONS(834),
    [anon_sym_PLUS] = ACTIONS(836),
    [anon_sym_DASH] = ACTIONS(836),
    [anon_sym_TILDE] = ACTIONS(836),
    [anon_sym_lambda] = ACTIONS(834),
    [anon_sym_yield] = ACTIONS(834),
    [anon_sym_LBRACK] = ACTIONS(836),
    [sym_ellipsis] = ACTIONS(836),
    [anon_sym_LBRACE] = ACTIONS(836),
    [sym_integer] = ACTIONS(834),
    [sym_float] = ACTIONS(836),
    [sym_true] = ACTIONS(834),
    [sym_false] = ACTIONS(834),
    [sym_none] = ACTIONS(834),
    [anon_sym_await] = ACTIONS(834),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(836),
    [sym__string_start] = ACTIONS(836),
  },
  [249] = {
    [sym_except_clause] = STATE(249),
    [aux_sym_try_statement_repeat1] = STATE(249),
    [sym_identifier] = ACTIONS(838),
    [anon_sym_import] = ACTIONS(838),
    [anon_sym_from] = ACTIONS(838),
    [anon_sym_LPAREN] = ACTIONS(840),
    [anon_sym_print] = ACTIONS(838),
    [anon_sym_assert] = ACTIONS(838),
    [anon_sym_return] = ACTIONS(838),
    [anon_sym_del] = ACTIONS(838),
    [anon_sym_raise] = ACTIONS(838),
    [anon_sym_pass] = ACTIONS(838),
    [anon_sym_break] = ACTIONS(838),
    [anon_sym_continue] = ACTIONS(838),
    [anon_sym_if] = ACTIONS(838),
    [anon_sym_else] = ACTIONS(838),
    [anon_sym_async] = ACTIONS(838),
    [anon_sym_for] = ACTIONS(838),
    [anon_sym_while] = ACTIONS(838),
    [anon_sym_try] = ACTIONS(838),
    [anon_sym_except] = ACTIONS(842),
    [anon_sym_finally] = ACTIONS(838),
    [anon_sym_with] = ACTIONS(838),
    [anon_sym_def] = ACTIONS(838),
    [anon_sym_global] = ACTIONS(838),
    [anon_sym_nonlocal] = ACTIONS(838),
    [anon_sym_exec] = ACTIONS(838),
    [anon_sym_class] = ACTIONS(838),
    [anon_sym_AT] = ACTIONS(840),
    [anon_sym_not] = ACTIONS(838),
    [anon_sym_PLUS] = ACTIONS(840),
    [anon_sym_DASH] = ACTIONS(840),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_lambda] = ACTIONS(838),
    [anon_sym_yield] = ACTIONS(838),
    [anon_sym_LBRACK] = ACTIONS(840),
    [sym_ellipsis] = ACTIONS(840),
    [anon_sym_LBRACE] = ACTIONS(840),
    [sym_integer] = ACTIONS(838),
    [sym_float] = ACTIONS(840),
    [sym_true] = ACTIONS(838),
    [sym_false] = ACTIONS(838),
    [sym_none] = ACTIONS(838),
    [anon_sym_await] = ACTIONS(838),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(840),
    [sym__string_start] = ACTIONS(840),
  },
  [250] = {
    [sym_named_expression] = STATE(749),
    [sym__expression_within_for_in_clause] = STATE(759),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(749),
    [sym_boolean_operator] = STATE(749),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(749),
    [sym_lambda] = STATE(749),
    [sym_lambda_within_for_in_clause] = STATE(759),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(749),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(749),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [251] = {
    [sym_named_expression] = STATE(835),
    [sym__expression] = STATE(835),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(835),
    [sym_boolean_operator] = STATE(835),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(835),
    [sym_lambda] = STATE(835),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(835),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(835),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_COMMA] = ACTIONS(845),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [anon_sym_RBRACK] = ACTIONS(845),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [252] = {
    [sym_elif_clause] = STATE(393),
    [sym_else_clause] = STATE(487),
    [aux_sym_if_statement_repeat1] = STATE(284),
    [ts_builtin_sym_end] = ACTIONS(828),
    [sym_identifier] = ACTIONS(826),
    [anon_sym_import] = ACTIONS(826),
    [anon_sym_from] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(828),
    [anon_sym_print] = ACTIONS(826),
    [anon_sym_assert] = ACTIONS(826),
    [anon_sym_return] = ACTIONS(826),
    [anon_sym_del] = ACTIONS(826),
    [anon_sym_raise] = ACTIONS(826),
    [anon_sym_pass] = ACTIONS(826),
    [anon_sym_break] = ACTIONS(826),
    [anon_sym_continue] = ACTIONS(826),
    [anon_sym_if] = ACTIONS(826),
    [anon_sym_elif] = ACTIONS(847),
    [anon_sym_else] = ACTIONS(590),
    [anon_sym_async] = ACTIONS(826),
    [anon_sym_for] = ACTIONS(826),
    [anon_sym_while] = ACTIONS(826),
    [anon_sym_try] = ACTIONS(826),
    [anon_sym_with] = ACTIONS(826),
    [anon_sym_def] = ACTIONS(826),
    [anon_sym_global] = ACTIONS(826),
    [anon_sym_nonlocal] = ACTIONS(826),
    [anon_sym_exec] = ACTIONS(826),
    [anon_sym_class] = ACTIONS(826),
    [anon_sym_AT] = ACTIONS(828),
    [anon_sym_not] = ACTIONS(826),
    [anon_sym_PLUS] = ACTIONS(828),
    [anon_sym_DASH] = ACTIONS(828),
    [anon_sym_TILDE] = ACTIONS(828),
    [anon_sym_lambda] = ACTIONS(826),
    [anon_sym_yield] = ACTIONS(826),
    [anon_sym_LBRACK] = ACTIONS(828),
    [sym_ellipsis] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(828),
    [sym_integer] = ACTIONS(826),
    [sym_float] = ACTIONS(828),
    [sym_true] = ACTIONS(826),
    [sym_false] = ACTIONS(826),
    [sym_none] = ACTIONS(826),
    [anon_sym_await] = ACTIONS(826),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(828),
  },
  [253] = {
    [sym_except_clause] = STATE(253),
    [aux_sym_try_statement_repeat1] = STATE(253),
    [ts_builtin_sym_end] = ACTIONS(840),
    [sym_identifier] = ACTIONS(838),
    [anon_sym_import] = ACTIONS(838),
    [anon_sym_from] = ACTIONS(838),
    [anon_sym_LPAREN] = ACTIONS(840),
    [anon_sym_print] = ACTIONS(838),
    [anon_sym_assert] = ACTIONS(838),
    [anon_sym_return] = ACTIONS(838),
    [anon_sym_del] = ACTIONS(838),
    [anon_sym_raise] = ACTIONS(838),
    [anon_sym_pass] = ACTIONS(838),
    [anon_sym_break] = ACTIONS(838),
    [anon_sym_continue] = ACTIONS(838),
    [anon_sym_if] = ACTIONS(838),
    [anon_sym_else] = ACTIONS(838),
    [anon_sym_async] = ACTIONS(838),
    [anon_sym_for] = ACTIONS(838),
    [anon_sym_while] = ACTIONS(838),
    [anon_sym_try] = ACTIONS(838),
    [anon_sym_except] = ACTIONS(849),
    [anon_sym_finally] = ACTIONS(838),
    [anon_sym_with] = ACTIONS(838),
    [anon_sym_def] = ACTIONS(838),
    [anon_sym_global] = ACTIONS(838),
    [anon_sym_nonlocal] = ACTIONS(838),
    [anon_sym_exec] = ACTIONS(838),
    [anon_sym_class] = ACTIONS(838),
    [anon_sym_AT] = ACTIONS(840),
    [anon_sym_not] = ACTIONS(838),
    [anon_sym_PLUS] = ACTIONS(840),
    [anon_sym_DASH] = ACTIONS(840),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_lambda] = ACTIONS(838),
    [anon_sym_yield] = ACTIONS(838),
    [anon_sym_LBRACK] = ACTIONS(840),
    [sym_ellipsis] = ACTIONS(840),
    [anon_sym_LBRACE] = ACTIONS(840),
    [sym_integer] = ACTIONS(838),
    [sym_float] = ACTIONS(840),
    [sym_true] = ACTIONS(838),
    [sym_false] = ACTIONS(838),
    [sym_none] = ACTIONS(838),
    [anon_sym_await] = ACTIONS(838),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(840),
  },
  [254] = {
    [sym_elif_clause] = STATE(393),
    [sym_else_clause] = STATE(426),
    [aux_sym_if_statement_repeat1] = STATE(264),
    [ts_builtin_sym_end] = ACTIONS(852),
    [sym_identifier] = ACTIONS(854),
    [anon_sym_import] = ACTIONS(854),
    [anon_sym_from] = ACTIONS(854),
    [anon_sym_LPAREN] = ACTIONS(852),
    [anon_sym_print] = ACTIONS(854),
    [anon_sym_assert] = ACTIONS(854),
    [anon_sym_return] = ACTIONS(854),
    [anon_sym_del] = ACTIONS(854),
    [anon_sym_raise] = ACTIONS(854),
    [anon_sym_pass] = ACTIONS(854),
    [anon_sym_break] = ACTIONS(854),
    [anon_sym_continue] = ACTIONS(854),
    [anon_sym_if] = ACTIONS(854),
    [anon_sym_elif] = ACTIONS(847),
    [anon_sym_else] = ACTIONS(590),
    [anon_sym_async] = ACTIONS(854),
    [anon_sym_for] = ACTIONS(854),
    [anon_sym_while] = ACTIONS(854),
    [anon_sym_try] = ACTIONS(854),
    [anon_sym_with] = ACTIONS(854),
    [anon_sym_def] = ACTIONS(854),
    [anon_sym_global] = ACTIONS(854),
    [anon_sym_nonlocal] = ACTIONS(854),
    [anon_sym_exec] = ACTIONS(854),
    [anon_sym_class] = ACTIONS(854),
    [anon_sym_AT] = ACTIONS(852),
    [anon_sym_not] = ACTIONS(854),
    [anon_sym_PLUS] = ACTIONS(852),
    [anon_sym_DASH] = ACTIONS(852),
    [anon_sym_TILDE] = ACTIONS(852),
    [anon_sym_lambda] = ACTIONS(854),
    [anon_sym_yield] = ACTIONS(854),
    [anon_sym_LBRACK] = ACTIONS(852),
    [sym_ellipsis] = ACTIONS(852),
    [anon_sym_LBRACE] = ACTIONS(852),
    [sym_integer] = ACTIONS(854),
    [sym_float] = ACTIONS(852),
    [sym_true] = ACTIONS(854),
    [sym_false] = ACTIONS(854),
    [sym_none] = ACTIONS(854),
    [anon_sym_await] = ACTIONS(854),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(852),
  },
  [255] = {
    [sym_named_expression] = STATE(782),
    [sym__expression] = STATE(782),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(782),
    [sym_boolean_operator] = STATE(782),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(782),
    [sym_lambda] = STATE(782),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_slice] = STATE(960),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(782),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(782),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_COLON] = ACTIONS(630),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [256] = {
    [sym_named_expression] = STATE(803),
    [sym__expression] = STATE(803),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(803),
    [sym_boolean_operator] = STATE(803),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(803),
    [sym_lambda] = STATE(803),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_slice] = STATE(1038),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(803),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(803),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_COLON] = ACTIONS(630),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [257] = {
    [sym_named_expression] = STATE(807),
    [sym__expression] = STATE(807),
    [sym__primary_expression] = STATE(532),
    [sym_not_operator] = STATE(807),
    [sym_boolean_operator] = STATE(807),
    [sym_binary_operator] = STATE(532),
    [sym_unary_operator] = STATE(532),
    [sym_comparison_operator] = STATE(807),
    [sym_lambda] = STATE(807),
    [sym_attribute] = STATE(532),
    [sym_subscript] = STATE(532),
    [sym_call] = STATE(532),
    [sym_list] = STATE(532),
    [sym_list_comprehension] = STATE(532),
    [sym_dictionary] = STATE(532),
    [sym_dictionary_comprehension] = STATE(532),
    [sym_set] = STATE(532),
    [sym_set_comprehension] = STATE(532),
    [sym_parenthesized_expression] = STATE(532),
    [sym_tuple] = STATE(532),
    [sym_generator_expression] = STATE(532),
    [sym_conditional_expression] = STATE(807),
    [sym_concatenated_string] = STATE(532),
    [sym_string] = STATE(530),
    [sym_await] = STATE(807),
    [sym_identifier] = ACTIONS(233),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_print] = ACTIONS(239),
    [anon_sym_exec] = ACTIONS(239),
    [anon_sym_not] = ACTIONS(536),
    [anon_sym_PLUS] = ACTIONS(243),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_TILDE] = ACTIONS(243),
    [anon_sym_lambda] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(538),
    [sym_ellipsis] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [sym_integer] = ACTIONS(251),
    [sym_float] = ACTIONS(247),
    [sym_true] = ACTIONS(251),
    [sym_false] = ACTIONS(251),
    [sym_none] = ACTIONS(251),
    [anon_sym_await] = ACTIONS(253),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(856),
    [sym__newline] = ACTIONS(856),
    [sym__string_start] = ACTIONS(255),
  },
  [258] = {
    [sym_named_expression] = STATE(857),
    [sym__expression] = STATE(857),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(857),
    [sym_boolean_operator] = STATE(857),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(857),
    [sym_lambda] = STATE(857),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(857),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(857),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_COMMA] = ACTIONS(716),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [anon_sym_RBRACK] = ACTIONS(716),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [259] = {
    [sym_named_expression] = STATE(807),
    [sym__expression] = STATE(807),
    [sym__primary_expression] = STATE(532),
    [sym_not_operator] = STATE(807),
    [sym_boolean_operator] = STATE(807),
    [sym_binary_operator] = STATE(532),
    [sym_unary_operator] = STATE(532),
    [sym_comparison_operator] = STATE(807),
    [sym_lambda] = STATE(807),
    [sym_attribute] = STATE(532),
    [sym_subscript] = STATE(532),
    [sym_call] = STATE(532),
    [sym_list] = STATE(532),
    [sym_list_comprehension] = STATE(532),
    [sym_dictionary] = STATE(532),
    [sym_dictionary_comprehension] = STATE(532),
    [sym_set] = STATE(532),
    [sym_set_comprehension] = STATE(532),
    [sym_parenthesized_expression] = STATE(532),
    [sym_tuple] = STATE(532),
    [sym_generator_expression] = STATE(532),
    [sym_conditional_expression] = STATE(807),
    [sym_concatenated_string] = STATE(532),
    [sym_string] = STATE(530),
    [sym_await] = STATE(807),
    [sym_identifier] = ACTIONS(233),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_print] = ACTIONS(239),
    [anon_sym_exec] = ACTIONS(239),
    [anon_sym_not] = ACTIONS(536),
    [anon_sym_PLUS] = ACTIONS(243),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_TILDE] = ACTIONS(243),
    [anon_sym_lambda] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(538),
    [sym_ellipsis] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [sym_integer] = ACTIONS(251),
    [sym_float] = ACTIONS(247),
    [sym_true] = ACTIONS(251),
    [sym_false] = ACTIONS(251),
    [sym_none] = ACTIONS(251),
    [anon_sym_await] = ACTIONS(253),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(858),
    [sym__newline] = ACTIONS(858),
    [sym__string_start] = ACTIONS(255),
  },
  [260] = {
    [sym_elif_clause] = STATE(401),
    [sym_else_clause] = STATE(456),
    [aux_sym_if_statement_repeat1] = STATE(297),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_import] = ACTIONS(860),
    [anon_sym_from] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_print] = ACTIONS(860),
    [anon_sym_assert] = ACTIONS(860),
    [anon_sym_return] = ACTIONS(860),
    [anon_sym_del] = ACTIONS(860),
    [anon_sym_raise] = ACTIONS(860),
    [anon_sym_pass] = ACTIONS(860),
    [anon_sym_break] = ACTIONS(860),
    [anon_sym_continue] = ACTIONS(860),
    [anon_sym_if] = ACTIONS(860),
    [anon_sym_elif] = ACTIONS(830),
    [anon_sym_else] = ACTIONS(568),
    [anon_sym_async] = ACTIONS(860),
    [anon_sym_for] = ACTIONS(860),
    [anon_sym_while] = ACTIONS(860),
    [anon_sym_try] = ACTIONS(860),
    [anon_sym_with] = ACTIONS(860),
    [anon_sym_def] = ACTIONS(860),
    [anon_sym_global] = ACTIONS(860),
    [anon_sym_nonlocal] = ACTIONS(860),
    [anon_sym_exec] = ACTIONS(860),
    [anon_sym_class] = ACTIONS(860),
    [anon_sym_AT] = ACTIONS(862),
    [anon_sym_not] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(862),
    [anon_sym_DASH] = ACTIONS(862),
    [anon_sym_TILDE] = ACTIONS(862),
    [anon_sym_lambda] = ACTIONS(860),
    [anon_sym_yield] = ACTIONS(860),
    [anon_sym_LBRACK] = ACTIONS(862),
    [sym_ellipsis] = ACTIONS(862),
    [anon_sym_LBRACE] = ACTIONS(862),
    [sym_integer] = ACTIONS(860),
    [sym_float] = ACTIONS(862),
    [sym_true] = ACTIONS(860),
    [sym_false] = ACTIONS(860),
    [sym_none] = ACTIONS(860),
    [anon_sym_await] = ACTIONS(860),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(862),
    [sym__string_start] = ACTIONS(862),
  },
  [261] = {
    [sym_named_expression] = STATE(807),
    [sym__expression] = STATE(807),
    [sym__primary_expression] = STATE(532),
    [sym_not_operator] = STATE(807),
    [sym_boolean_operator] = STATE(807),
    [sym_binary_operator] = STATE(532),
    [sym_unary_operator] = STATE(532),
    [sym_comparison_operator] = STATE(807),
    [sym_lambda] = STATE(807),
    [sym_attribute] = STATE(532),
    [sym_subscript] = STATE(532),
    [sym_call] = STATE(532),
    [sym_list] = STATE(532),
    [sym_list_comprehension] = STATE(532),
    [sym_dictionary] = STATE(532),
    [sym_dictionary_comprehension] = STATE(532),
    [sym_set] = STATE(532),
    [sym_set_comprehension] = STATE(532),
    [sym_parenthesized_expression] = STATE(532),
    [sym_tuple] = STATE(532),
    [sym_generator_expression] = STATE(532),
    [sym_conditional_expression] = STATE(807),
    [sym_concatenated_string] = STATE(532),
    [sym_string] = STATE(530),
    [sym_await] = STATE(807),
    [sym_identifier] = ACTIONS(233),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_print] = ACTIONS(239),
    [anon_sym_exec] = ACTIONS(239),
    [anon_sym_not] = ACTIONS(536),
    [anon_sym_PLUS] = ACTIONS(243),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_TILDE] = ACTIONS(243),
    [anon_sym_lambda] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(538),
    [sym_ellipsis] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [sym_integer] = ACTIONS(251),
    [sym_float] = ACTIONS(247),
    [sym_true] = ACTIONS(251),
    [sym_false] = ACTIONS(251),
    [sym_none] = ACTIONS(251),
    [anon_sym_await] = ACTIONS(253),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(864),
    [sym__newline] = ACTIONS(864),
    [sym__string_start] = ACTIONS(255),
  },
  [262] = {
    [sym_named_expression] = STATE(793),
    [sym_list_splat] = STATE(970),
    [sym__expression] = STATE(793),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(793),
    [sym_boolean_operator] = STATE(793),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(793),
    [sym_lambda] = STATE(793),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(793),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(793),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(528),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [263] = {
    [sym_named_expression] = STATE(807),
    [sym__expression] = STATE(807),
    [sym__primary_expression] = STATE(532),
    [sym_not_operator] = STATE(807),
    [sym_boolean_operator] = STATE(807),
    [sym_binary_operator] = STATE(532),
    [sym_unary_operator] = STATE(532),
    [sym_comparison_operator] = STATE(807),
    [sym_lambda] = STATE(807),
    [sym_attribute] = STATE(532),
    [sym_subscript] = STATE(532),
    [sym_call] = STATE(532),
    [sym_list] = STATE(532),
    [sym_list_comprehension] = STATE(532),
    [sym_dictionary] = STATE(532),
    [sym_dictionary_comprehension] = STATE(532),
    [sym_set] = STATE(532),
    [sym_set_comprehension] = STATE(532),
    [sym_parenthesized_expression] = STATE(532),
    [sym_tuple] = STATE(532),
    [sym_generator_expression] = STATE(532),
    [sym_conditional_expression] = STATE(807),
    [sym_concatenated_string] = STATE(532),
    [sym_string] = STATE(530),
    [sym_await] = STATE(807),
    [sym_identifier] = ACTIONS(233),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_print] = ACTIONS(239),
    [anon_sym_exec] = ACTIONS(239),
    [anon_sym_not] = ACTIONS(536),
    [anon_sym_PLUS] = ACTIONS(243),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_TILDE] = ACTIONS(243),
    [anon_sym_lambda] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(538),
    [sym_ellipsis] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [sym_integer] = ACTIONS(251),
    [sym_float] = ACTIONS(247),
    [sym_true] = ACTIONS(251),
    [sym_false] = ACTIONS(251),
    [sym_none] = ACTIONS(251),
    [anon_sym_await] = ACTIONS(253),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(866),
    [sym__newline] = ACTIONS(866),
    [sym__string_start] = ACTIONS(255),
  },
  [264] = {
    [sym_elif_clause] = STATE(393),
    [sym_else_clause] = STATE(463),
    [aux_sym_if_statement_repeat1] = STATE(284),
    [ts_builtin_sym_end] = ACTIONS(862),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_import] = ACTIONS(860),
    [anon_sym_from] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_print] = ACTIONS(860),
    [anon_sym_assert] = ACTIONS(860),
    [anon_sym_return] = ACTIONS(860),
    [anon_sym_del] = ACTIONS(860),
    [anon_sym_raise] = ACTIONS(860),
    [anon_sym_pass] = ACTIONS(860),
    [anon_sym_break] = ACTIONS(860),
    [anon_sym_continue] = ACTIONS(860),
    [anon_sym_if] = ACTIONS(860),
    [anon_sym_elif] = ACTIONS(847),
    [anon_sym_else] = ACTIONS(590),
    [anon_sym_async] = ACTIONS(860),
    [anon_sym_for] = ACTIONS(860),
    [anon_sym_while] = ACTIONS(860),
    [anon_sym_try] = ACTIONS(860),
    [anon_sym_with] = ACTIONS(860),
    [anon_sym_def] = ACTIONS(860),
    [anon_sym_global] = ACTIONS(860),
    [anon_sym_nonlocal] = ACTIONS(860),
    [anon_sym_exec] = ACTIONS(860),
    [anon_sym_class] = ACTIONS(860),
    [anon_sym_AT] = ACTIONS(862),
    [anon_sym_not] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(862),
    [anon_sym_DASH] = ACTIONS(862),
    [anon_sym_TILDE] = ACTIONS(862),
    [anon_sym_lambda] = ACTIONS(860),
    [anon_sym_yield] = ACTIONS(860),
    [anon_sym_LBRACK] = ACTIONS(862),
    [sym_ellipsis] = ACTIONS(862),
    [anon_sym_LBRACE] = ACTIONS(862),
    [sym_integer] = ACTIONS(860),
    [sym_float] = ACTIONS(862),
    [sym_true] = ACTIONS(860),
    [sym_false] = ACTIONS(860),
    [sym_none] = ACTIONS(860),
    [anon_sym_await] = ACTIONS(860),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(862),
  },
  [265] = {
    [sym_elif_clause] = STATE(393),
    [sym_else_clause] = STATE(459),
    [aux_sym_if_statement_repeat1] = STATE(252),
    [ts_builtin_sym_end] = ACTIONS(836),
    [sym_identifier] = ACTIONS(834),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_from] = ACTIONS(834),
    [anon_sym_LPAREN] = ACTIONS(836),
    [anon_sym_print] = ACTIONS(834),
    [anon_sym_assert] = ACTIONS(834),
    [anon_sym_return] = ACTIONS(834),
    [anon_sym_del] = ACTIONS(834),
    [anon_sym_raise] = ACTIONS(834),
    [anon_sym_pass] = ACTIONS(834),
    [anon_sym_break] = ACTIONS(834),
    [anon_sym_continue] = ACTIONS(834),
    [anon_sym_if] = ACTIONS(834),
    [anon_sym_elif] = ACTIONS(847),
    [anon_sym_else] = ACTIONS(590),
    [anon_sym_async] = ACTIONS(834),
    [anon_sym_for] = ACTIONS(834),
    [anon_sym_while] = ACTIONS(834),
    [anon_sym_try] = ACTIONS(834),
    [anon_sym_with] = ACTIONS(834),
    [anon_sym_def] = ACTIONS(834),
    [anon_sym_global] = ACTIONS(834),
    [anon_sym_nonlocal] = ACTIONS(834),
    [anon_sym_exec] = ACTIONS(834),
    [anon_sym_class] = ACTIONS(834),
    [anon_sym_AT] = ACTIONS(836),
    [anon_sym_not] = ACTIONS(834),
    [anon_sym_PLUS] = ACTIONS(836),
    [anon_sym_DASH] = ACTIONS(836),
    [anon_sym_TILDE] = ACTIONS(836),
    [anon_sym_lambda] = ACTIONS(834),
    [anon_sym_yield] = ACTIONS(834),
    [anon_sym_LBRACK] = ACTIONS(836),
    [sym_ellipsis] = ACTIONS(836),
    [anon_sym_LBRACE] = ACTIONS(836),
    [sym_integer] = ACTIONS(834),
    [sym_float] = ACTIONS(836),
    [sym_true] = ACTIONS(834),
    [sym_false] = ACTIONS(834),
    [sym_none] = ACTIONS(834),
    [anon_sym_await] = ACTIONS(834),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(836),
  },
  [266] = {
    [sym_named_expression] = STATE(774),
    [sym__expression] = STATE(774),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(774),
    [sym_boolean_operator] = STATE(774),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(774),
    [sym_lambda] = STATE(774),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_slice] = STATE(1006),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(774),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(774),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_COLON] = ACTIONS(630),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [267] = {
    [sym_named_expression] = STATE(751),
    [sym__expression_within_for_in_clause] = STATE(768),
    [sym__expression] = STATE(751),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(751),
    [sym_boolean_operator] = STATE(751),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(751),
    [sym_lambda] = STATE(751),
    [sym_lambda_within_for_in_clause] = STATE(768),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(751),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(751),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [268] = {
    [sym_named_expression] = STATE(851),
    [sym__expression] = STATE(851),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(851),
    [sym_boolean_operator] = STATE(851),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(851),
    [sym_lambda] = STATE(851),
    [sym_yield] = STATE(1049),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(851),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(851),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_yield] = ACTIONS(546),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [269] = {
    [sym_elif_clause] = STATE(401),
    [sym_else_clause] = STATE(434),
    [aux_sym_if_statement_repeat1] = STATE(260),
    [sym_identifier] = ACTIONS(854),
    [anon_sym_import] = ACTIONS(854),
    [anon_sym_from] = ACTIONS(854),
    [anon_sym_LPAREN] = ACTIONS(852),
    [anon_sym_print] = ACTIONS(854),
    [anon_sym_assert] = ACTIONS(854),
    [anon_sym_return] = ACTIONS(854),
    [anon_sym_del] = ACTIONS(854),
    [anon_sym_raise] = ACTIONS(854),
    [anon_sym_pass] = ACTIONS(854),
    [anon_sym_break] = ACTIONS(854),
    [anon_sym_continue] = ACTIONS(854),
    [anon_sym_if] = ACTIONS(854),
    [anon_sym_elif] = ACTIONS(830),
    [anon_sym_else] = ACTIONS(568),
    [anon_sym_async] = ACTIONS(854),
    [anon_sym_for] = ACTIONS(854),
    [anon_sym_while] = ACTIONS(854),
    [anon_sym_try] = ACTIONS(854),
    [anon_sym_with] = ACTIONS(854),
    [anon_sym_def] = ACTIONS(854),
    [anon_sym_global] = ACTIONS(854),
    [anon_sym_nonlocal] = ACTIONS(854),
    [anon_sym_exec] = ACTIONS(854),
    [anon_sym_class] = ACTIONS(854),
    [anon_sym_AT] = ACTIONS(852),
    [anon_sym_not] = ACTIONS(854),
    [anon_sym_PLUS] = ACTIONS(852),
    [anon_sym_DASH] = ACTIONS(852),
    [anon_sym_TILDE] = ACTIONS(852),
    [anon_sym_lambda] = ACTIONS(854),
    [anon_sym_yield] = ACTIONS(854),
    [anon_sym_LBRACK] = ACTIONS(852),
    [sym_ellipsis] = ACTIONS(852),
    [anon_sym_LBRACE] = ACTIONS(852),
    [sym_integer] = ACTIONS(854),
    [sym_float] = ACTIONS(852),
    [sym_true] = ACTIONS(854),
    [sym_false] = ACTIONS(854),
    [sym_none] = ACTIONS(854),
    [anon_sym_await] = ACTIONS(854),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(852),
    [sym__string_start] = ACTIONS(852),
  },
  [270] = {
    [sym_named_expression] = STATE(794),
    [sym_with_item] = STATE(1057),
    [sym__expression] = STATE(794),
    [sym__primary_expression] = STATE(547),
    [sym_not_operator] = STATE(794),
    [sym_boolean_operator] = STATE(794),
    [sym_binary_operator] = STATE(547),
    [sym_unary_operator] = STATE(547),
    [sym_comparison_operator] = STATE(794),
    [sym_lambda] = STATE(794),
    [sym_attribute] = STATE(547),
    [sym_subscript] = STATE(547),
    [sym_call] = STATE(547),
    [sym_list] = STATE(547),
    [sym_list_comprehension] = STATE(547),
    [sym_dictionary] = STATE(547),
    [sym_dictionary_comprehension] = STATE(547),
    [sym_set] = STATE(547),
    [sym_set_comprehension] = STATE(547),
    [sym_parenthesized_expression] = STATE(547),
    [sym_tuple] = STATE(547),
    [sym_generator_expression] = STATE(547),
    [sym_conditional_expression] = STATE(794),
    [sym_concatenated_string] = STATE(547),
    [sym_string] = STATE(543),
    [sym_await] = STATE(794),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_LPAREN] = ACTIONS(870),
    [anon_sym_print] = ACTIONS(872),
    [anon_sym_exec] = ACTIONS(872),
    [anon_sym_not] = ACTIONS(874),
    [anon_sym_PLUS] = ACTIONS(876),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_TILDE] = ACTIONS(876),
    [anon_sym_lambda] = ACTIONS(878),
    [anon_sym_LBRACK] = ACTIONS(880),
    [sym_ellipsis] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(884),
    [sym_integer] = ACTIONS(886),
    [sym_float] = ACTIONS(882),
    [sym_true] = ACTIONS(886),
    [sym_false] = ACTIONS(886),
    [sym_none] = ACTIONS(886),
    [anon_sym_await] = ACTIONS(888),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(890),
  },
  [271] = {
    [sym_named_expression] = STATE(773),
    [sym__expression] = STATE(773),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(773),
    [sym_boolean_operator] = STATE(773),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(773),
    [sym_lambda] = STATE(773),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_type] = STATE(1095),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(773),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(773),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [272] = {
    [sym_identifier] = ACTIONS(892),
    [anon_sym_import] = ACTIONS(892),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_LPAREN] = ACTIONS(894),
    [anon_sym_print] = ACTIONS(892),
    [anon_sym_assert] = ACTIONS(892),
    [anon_sym_return] = ACTIONS(892),
    [anon_sym_del] = ACTIONS(892),
    [anon_sym_raise] = ACTIONS(892),
    [anon_sym_pass] = ACTIONS(892),
    [anon_sym_break] = ACTIONS(892),
    [anon_sym_continue] = ACTIONS(892),
    [anon_sym_if] = ACTIONS(892),
    [anon_sym_elif] = ACTIONS(892),
    [anon_sym_else] = ACTIONS(892),
    [anon_sym_async] = ACTIONS(892),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(892),
    [anon_sym_try] = ACTIONS(892),
    [anon_sym_except] = ACTIONS(892),
    [anon_sym_finally] = ACTIONS(892),
    [anon_sym_with] = ACTIONS(892),
    [anon_sym_def] = ACTIONS(892),
    [anon_sym_global] = ACTIONS(892),
    [anon_sym_nonlocal] = ACTIONS(892),
    [anon_sym_exec] = ACTIONS(892),
    [anon_sym_class] = ACTIONS(892),
    [anon_sym_AT] = ACTIONS(894),
    [anon_sym_not] = ACTIONS(892),
    [anon_sym_PLUS] = ACTIONS(894),
    [anon_sym_DASH] = ACTIONS(894),
    [anon_sym_TILDE] = ACTIONS(894),
    [anon_sym_lambda] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(892),
    [anon_sym_LBRACK] = ACTIONS(894),
    [sym_ellipsis] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(894),
    [sym_integer] = ACTIONS(892),
    [sym_float] = ACTIONS(894),
    [sym_true] = ACTIONS(892),
    [sym_false] = ACTIONS(892),
    [sym_none] = ACTIONS(892),
    [anon_sym_await] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(894),
    [sym__string_start] = ACTIONS(894),
  },
  [273] = {
    [sym_named_expression] = STATE(779),
    [sym_expression_list] = STATE(1159),
    [sym__expression] = STATE(779),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(779),
    [sym_boolean_operator] = STATE(779),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(779),
    [sym_lambda] = STATE(779),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(779),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(779),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [274] = {
    [sym_identifier] = ACTIONS(896),
    [anon_sym_import] = ACTIONS(896),
    [anon_sym_from] = ACTIONS(896),
    [anon_sym_LPAREN] = ACTIONS(898),
    [anon_sym_print] = ACTIONS(896),
    [anon_sym_assert] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(896),
    [anon_sym_del] = ACTIONS(896),
    [anon_sym_raise] = ACTIONS(896),
    [anon_sym_pass] = ACTIONS(896),
    [anon_sym_break] = ACTIONS(896),
    [anon_sym_continue] = ACTIONS(896),
    [anon_sym_if] = ACTIONS(896),
    [anon_sym_elif] = ACTIONS(896),
    [anon_sym_else] = ACTIONS(896),
    [anon_sym_async] = ACTIONS(896),
    [anon_sym_for] = ACTIONS(896),
    [anon_sym_while] = ACTIONS(896),
    [anon_sym_try] = ACTIONS(896),
    [anon_sym_except] = ACTIONS(896),
    [anon_sym_finally] = ACTIONS(896),
    [anon_sym_with] = ACTIONS(896),
    [anon_sym_def] = ACTIONS(896),
    [anon_sym_global] = ACTIONS(896),
    [anon_sym_nonlocal] = ACTIONS(896),
    [anon_sym_exec] = ACTIONS(896),
    [anon_sym_class] = ACTIONS(896),
    [anon_sym_AT] = ACTIONS(898),
    [anon_sym_not] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_TILDE] = ACTIONS(898),
    [anon_sym_lambda] = ACTIONS(896),
    [anon_sym_yield] = ACTIONS(896),
    [anon_sym_LBRACK] = ACTIONS(898),
    [sym_ellipsis] = ACTIONS(898),
    [anon_sym_LBRACE] = ACTIONS(898),
    [sym_integer] = ACTIONS(896),
    [sym_float] = ACTIONS(898),
    [sym_true] = ACTIONS(896),
    [sym_false] = ACTIONS(896),
    [sym_none] = ACTIONS(896),
    [anon_sym_await] = ACTIONS(896),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(898),
    [sym__string_start] = ACTIONS(898),
  },
  [275] = {
    [sym_named_expression] = STATE(794),
    [sym_with_item] = STATE(983),
    [sym__expression] = STATE(794),
    [sym__primary_expression] = STATE(547),
    [sym_not_operator] = STATE(794),
    [sym_boolean_operator] = STATE(794),
    [sym_binary_operator] = STATE(547),
    [sym_unary_operator] = STATE(547),
    [sym_comparison_operator] = STATE(794),
    [sym_lambda] = STATE(794),
    [sym_attribute] = STATE(547),
    [sym_subscript] = STATE(547),
    [sym_call] = STATE(547),
    [sym_list] = STATE(547),
    [sym_list_comprehension] = STATE(547),
    [sym_dictionary] = STATE(547),
    [sym_dictionary_comprehension] = STATE(547),
    [sym_set] = STATE(547),
    [sym_set_comprehension] = STATE(547),
    [sym_parenthesized_expression] = STATE(547),
    [sym_tuple] = STATE(547),
    [sym_generator_expression] = STATE(547),
    [sym_conditional_expression] = STATE(794),
    [sym_concatenated_string] = STATE(547),
    [sym_string] = STATE(543),
    [sym_await] = STATE(794),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_LPAREN] = ACTIONS(870),
    [anon_sym_print] = ACTIONS(872),
    [anon_sym_exec] = ACTIONS(872),
    [anon_sym_not] = ACTIONS(874),
    [anon_sym_PLUS] = ACTIONS(876),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_TILDE] = ACTIONS(876),
    [anon_sym_lambda] = ACTIONS(878),
    [anon_sym_LBRACK] = ACTIONS(880),
    [sym_ellipsis] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(884),
    [sym_integer] = ACTIONS(886),
    [sym_float] = ACTIONS(882),
    [sym_true] = ACTIONS(886),
    [sym_false] = ACTIONS(886),
    [sym_none] = ACTIONS(886),
    [anon_sym_await] = ACTIONS(888),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(890),
  },
  [276] = {
    [ts_builtin_sym_end] = ACTIONS(894),
    [sym_identifier] = ACTIONS(892),
    [anon_sym_import] = ACTIONS(892),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_LPAREN] = ACTIONS(894),
    [anon_sym_print] = ACTIONS(892),
    [anon_sym_assert] = ACTIONS(892),
    [anon_sym_return] = ACTIONS(892),
    [anon_sym_del] = ACTIONS(892),
    [anon_sym_raise] = ACTIONS(892),
    [anon_sym_pass] = ACTIONS(892),
    [anon_sym_break] = ACTIONS(892),
    [anon_sym_continue] = ACTIONS(892),
    [anon_sym_if] = ACTIONS(892),
    [anon_sym_elif] = ACTIONS(892),
    [anon_sym_else] = ACTIONS(892),
    [anon_sym_async] = ACTIONS(892),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(892),
    [anon_sym_try] = ACTIONS(892),
    [anon_sym_except] = ACTIONS(892),
    [anon_sym_finally] = ACTIONS(892),
    [anon_sym_with] = ACTIONS(892),
    [anon_sym_def] = ACTIONS(892),
    [anon_sym_global] = ACTIONS(892),
    [anon_sym_nonlocal] = ACTIONS(892),
    [anon_sym_exec] = ACTIONS(892),
    [anon_sym_class] = ACTIONS(892),
    [anon_sym_AT] = ACTIONS(894),
    [anon_sym_not] = ACTIONS(892),
    [anon_sym_PLUS] = ACTIONS(894),
    [anon_sym_DASH] = ACTIONS(894),
    [anon_sym_TILDE] = ACTIONS(894),
    [anon_sym_lambda] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(892),
    [anon_sym_LBRACK] = ACTIONS(894),
    [sym_ellipsis] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(894),
    [sym_integer] = ACTIONS(892),
    [sym_float] = ACTIONS(894),
    [sym_true] = ACTIONS(892),
    [sym_false] = ACTIONS(892),
    [sym_none] = ACTIONS(892),
    [anon_sym_await] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(894),
  },
  [277] = {
    [sym_named_expression] = STATE(799),
    [sym__expression] = STATE(799),
    [sym__primary_expression] = STATE(532),
    [sym_not_operator] = STATE(799),
    [sym_boolean_operator] = STATE(799),
    [sym_binary_operator] = STATE(532),
    [sym_unary_operator] = STATE(532),
    [sym_comparison_operator] = STATE(799),
    [sym_lambda] = STATE(799),
    [sym_attribute] = STATE(532),
    [sym_subscript] = STATE(532),
    [sym_call] = STATE(532),
    [sym_type] = STATE(935),
    [sym_list] = STATE(532),
    [sym_list_comprehension] = STATE(532),
    [sym_dictionary] = STATE(532),
    [sym_dictionary_comprehension] = STATE(532),
    [sym_set] = STATE(532),
    [sym_set_comprehension] = STATE(532),
    [sym_parenthesized_expression] = STATE(532),
    [sym_tuple] = STATE(532),
    [sym_generator_expression] = STATE(532),
    [sym_conditional_expression] = STATE(799),
    [sym_concatenated_string] = STATE(532),
    [sym_string] = STATE(530),
    [sym_await] = STATE(799),
    [sym_identifier] = ACTIONS(233),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_print] = ACTIONS(239),
    [anon_sym_exec] = ACTIONS(239),
    [anon_sym_not] = ACTIONS(536),
    [anon_sym_PLUS] = ACTIONS(243),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_TILDE] = ACTIONS(243),
    [anon_sym_lambda] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(538),
    [sym_ellipsis] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [sym_integer] = ACTIONS(251),
    [sym_float] = ACTIONS(247),
    [sym_true] = ACTIONS(251),
    [sym_false] = ACTIONS(251),
    [sym_none] = ACTIONS(251),
    [anon_sym_await] = ACTIONS(253),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(255),
  },
  [278] = {
    [sym_named_expression] = STATE(794),
    [sym_with_item] = STATE(975),
    [sym__expression] = STATE(794),
    [sym__primary_expression] = STATE(547),
    [sym_not_operator] = STATE(794),
    [sym_boolean_operator] = STATE(794),
    [sym_binary_operator] = STATE(547),
    [sym_unary_operator] = STATE(547),
    [sym_comparison_operator] = STATE(794),
    [sym_lambda] = STATE(794),
    [sym_attribute] = STATE(547),
    [sym_subscript] = STATE(547),
    [sym_call] = STATE(547),
    [sym_list] = STATE(547),
    [sym_list_comprehension] = STATE(547),
    [sym_dictionary] = STATE(547),
    [sym_dictionary_comprehension] = STATE(547),
    [sym_set] = STATE(547),
    [sym_set_comprehension] = STATE(547),
    [sym_parenthesized_expression] = STATE(547),
    [sym_tuple] = STATE(547),
    [sym_generator_expression] = STATE(547),
    [sym_conditional_expression] = STATE(794),
    [sym_concatenated_string] = STATE(547),
    [sym_string] = STATE(543),
    [sym_await] = STATE(794),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_LPAREN] = ACTIONS(870),
    [anon_sym_print] = ACTIONS(872),
    [anon_sym_exec] = ACTIONS(872),
    [anon_sym_not] = ACTIONS(874),
    [anon_sym_PLUS] = ACTIONS(876),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_TILDE] = ACTIONS(876),
    [anon_sym_lambda] = ACTIONS(878),
    [anon_sym_LBRACK] = ACTIONS(880),
    [sym_ellipsis] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(884),
    [sym_integer] = ACTIONS(886),
    [sym_float] = ACTIONS(882),
    [sym_true] = ACTIONS(886),
    [sym_false] = ACTIONS(886),
    [sym_none] = ACTIONS(886),
    [anon_sym_await] = ACTIONS(888),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(890),
  },
  [279] = {
    [sym_named_expression] = STATE(773),
    [sym__expression] = STATE(773),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(773),
    [sym_boolean_operator] = STATE(773),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(773),
    [sym_lambda] = STATE(773),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_type] = STATE(1132),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(773),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(773),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [280] = {
    [sym_named_expression] = STATE(760),
    [sym_expression_list] = STATE(1053),
    [sym__expression] = STATE(760),
    [sym__primary_expression] = STATE(532),
    [sym_not_operator] = STATE(760),
    [sym_boolean_operator] = STATE(760),
    [sym_binary_operator] = STATE(532),
    [sym_unary_operator] = STATE(532),
    [sym_comparison_operator] = STATE(760),
    [sym_lambda] = STATE(760),
    [sym_attribute] = STATE(532),
    [sym_subscript] = STATE(532),
    [sym_call] = STATE(532),
    [sym_list] = STATE(532),
    [sym_list_comprehension] = STATE(532),
    [sym_dictionary] = STATE(532),
    [sym_dictionary_comprehension] = STATE(532),
    [sym_set] = STATE(532),
    [sym_set_comprehension] = STATE(532),
    [sym_parenthesized_expression] = STATE(532),
    [sym_tuple] = STATE(532),
    [sym_generator_expression] = STATE(532),
    [sym_conditional_expression] = STATE(760),
    [sym_concatenated_string] = STATE(532),
    [sym_string] = STATE(530),
    [sym_await] = STATE(760),
    [sym_identifier] = ACTIONS(233),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_print] = ACTIONS(239),
    [anon_sym_exec] = ACTIONS(239),
    [anon_sym_not] = ACTIONS(536),
    [anon_sym_PLUS] = ACTIONS(243),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_TILDE] = ACTIONS(243),
    [anon_sym_lambda] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(538),
    [sym_ellipsis] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [sym_integer] = ACTIONS(251),
    [sym_float] = ACTIONS(247),
    [sym_true] = ACTIONS(251),
    [sym_false] = ACTIONS(251),
    [sym_none] = ACTIONS(251),
    [anon_sym_await] = ACTIONS(253),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(255),
  },
  [281] = {
    [sym_named_expression] = STATE(773),
    [sym__expression] = STATE(773),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(773),
    [sym_boolean_operator] = STATE(773),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(773),
    [sym_lambda] = STATE(773),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_type] = STATE(1073),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(773),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(773),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [282] = {
    [sym_named_expression] = STATE(794),
    [sym_with_item] = STATE(944),
    [sym__expression] = STATE(794),
    [sym__primary_expression] = STATE(547),
    [sym_not_operator] = STATE(794),
    [sym_boolean_operator] = STATE(794),
    [sym_binary_operator] = STATE(547),
    [sym_unary_operator] = STATE(547),
    [sym_comparison_operator] = STATE(794),
    [sym_lambda] = STATE(794),
    [sym_attribute] = STATE(547),
    [sym_subscript] = STATE(547),
    [sym_call] = STATE(547),
    [sym_list] = STATE(547),
    [sym_list_comprehension] = STATE(547),
    [sym_dictionary] = STATE(547),
    [sym_dictionary_comprehension] = STATE(547),
    [sym_set] = STATE(547),
    [sym_set_comprehension] = STATE(547),
    [sym_parenthesized_expression] = STATE(547),
    [sym_tuple] = STATE(547),
    [sym_generator_expression] = STATE(547),
    [sym_conditional_expression] = STATE(794),
    [sym_concatenated_string] = STATE(547),
    [sym_string] = STATE(543),
    [sym_await] = STATE(794),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_LPAREN] = ACTIONS(870),
    [anon_sym_print] = ACTIONS(872),
    [anon_sym_exec] = ACTIONS(872),
    [anon_sym_not] = ACTIONS(874),
    [anon_sym_PLUS] = ACTIONS(876),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_TILDE] = ACTIONS(876),
    [anon_sym_lambda] = ACTIONS(878),
    [anon_sym_LBRACK] = ACTIONS(880),
    [sym_ellipsis] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(884),
    [sym_integer] = ACTIONS(886),
    [sym_float] = ACTIONS(882),
    [sym_true] = ACTIONS(886),
    [sym_false] = ACTIONS(886),
    [sym_none] = ACTIONS(886),
    [anon_sym_await] = ACTIONS(888),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(890),
  },
  [283] = {
    [sym_identifier] = ACTIONS(900),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(900),
    [anon_sym_LPAREN] = ACTIONS(902),
    [anon_sym_print] = ACTIONS(900),
    [anon_sym_assert] = ACTIONS(900),
    [anon_sym_return] = ACTIONS(900),
    [anon_sym_del] = ACTIONS(900),
    [anon_sym_raise] = ACTIONS(900),
    [anon_sym_pass] = ACTIONS(900),
    [anon_sym_break] = ACTIONS(900),
    [anon_sym_continue] = ACTIONS(900),
    [anon_sym_if] = ACTIONS(900),
    [anon_sym_elif] = ACTIONS(900),
    [anon_sym_else] = ACTIONS(900),
    [anon_sym_async] = ACTIONS(900),
    [anon_sym_for] = ACTIONS(900),
    [anon_sym_while] = ACTIONS(900),
    [anon_sym_try] = ACTIONS(900),
    [anon_sym_except] = ACTIONS(900),
    [anon_sym_finally] = ACTIONS(900),
    [anon_sym_with] = ACTIONS(900),
    [anon_sym_def] = ACTIONS(900),
    [anon_sym_global] = ACTIONS(900),
    [anon_sym_nonlocal] = ACTIONS(900),
    [anon_sym_exec] = ACTIONS(900),
    [anon_sym_class] = ACTIONS(900),
    [anon_sym_AT] = ACTIONS(902),
    [anon_sym_not] = ACTIONS(900),
    [anon_sym_PLUS] = ACTIONS(902),
    [anon_sym_DASH] = ACTIONS(902),
    [anon_sym_TILDE] = ACTIONS(902),
    [anon_sym_lambda] = ACTIONS(900),
    [anon_sym_yield] = ACTIONS(900),
    [anon_sym_LBRACK] = ACTIONS(902),
    [sym_ellipsis] = ACTIONS(902),
    [anon_sym_LBRACE] = ACTIONS(902),
    [sym_integer] = ACTIONS(900),
    [sym_float] = ACTIONS(902),
    [sym_true] = ACTIONS(900),
    [sym_false] = ACTIONS(900),
    [sym_none] = ACTIONS(900),
    [anon_sym_await] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(902),
    [sym__string_start] = ACTIONS(902),
  },
  [284] = {
    [sym_elif_clause] = STATE(393),
    [aux_sym_if_statement_repeat1] = STATE(284),
    [ts_builtin_sym_end] = ACTIONS(904),
    [sym_identifier] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_from] = ACTIONS(906),
    [anon_sym_LPAREN] = ACTIONS(904),
    [anon_sym_print] = ACTIONS(906),
    [anon_sym_assert] = ACTIONS(906),
    [anon_sym_return] = ACTIONS(906),
    [anon_sym_del] = ACTIONS(906),
    [anon_sym_raise] = ACTIONS(906),
    [anon_sym_pass] = ACTIONS(906),
    [anon_sym_break] = ACTIONS(906),
    [anon_sym_continue] = ACTIONS(906),
    [anon_sym_if] = ACTIONS(906),
    [anon_sym_elif] = ACTIONS(908),
    [anon_sym_else] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(906),
    [anon_sym_for] = ACTIONS(906),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_try] = ACTIONS(906),
    [anon_sym_with] = ACTIONS(906),
    [anon_sym_def] = ACTIONS(906),
    [anon_sym_global] = ACTIONS(906),
    [anon_sym_nonlocal] = ACTIONS(906),
    [anon_sym_exec] = ACTIONS(906),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_AT] = ACTIONS(904),
    [anon_sym_not] = ACTIONS(906),
    [anon_sym_PLUS] = ACTIONS(904),
    [anon_sym_DASH] = ACTIONS(904),
    [anon_sym_TILDE] = ACTIONS(904),
    [anon_sym_lambda] = ACTIONS(906),
    [anon_sym_yield] = ACTIONS(906),
    [anon_sym_LBRACK] = ACTIONS(904),
    [sym_ellipsis] = ACTIONS(904),
    [anon_sym_LBRACE] = ACTIONS(904),
    [sym_integer] = ACTIONS(906),
    [sym_float] = ACTIONS(904),
    [sym_true] = ACTIONS(906),
    [sym_false] = ACTIONS(906),
    [sym_none] = ACTIONS(906),
    [anon_sym_await] = ACTIONS(906),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(904),
  },
  [285] = {
    [sym_named_expression] = STATE(773),
    [sym__expression] = STATE(773),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(773),
    [sym_boolean_operator] = STATE(773),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(773),
    [sym_lambda] = STATE(773),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_type] = STATE(1120),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(773),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(773),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [286] = {
    [sym_named_expression] = STATE(773),
    [sym__expression] = STATE(773),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(773),
    [sym_boolean_operator] = STATE(773),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(773),
    [sym_lambda] = STATE(773),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_type] = STATE(911),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(773),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(773),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [287] = {
    [ts_builtin_sym_end] = ACTIONS(911),
    [sym_identifier] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(913),
    [anon_sym_from] = ACTIONS(913),
    [anon_sym_LPAREN] = ACTIONS(911),
    [anon_sym_print] = ACTIONS(913),
    [anon_sym_assert] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_del] = ACTIONS(913),
    [anon_sym_raise] = ACTIONS(913),
    [anon_sym_pass] = ACTIONS(913),
    [anon_sym_break] = ACTIONS(913),
    [anon_sym_continue] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(913),
    [anon_sym_elif] = ACTIONS(913),
    [anon_sym_else] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(913),
    [anon_sym_for] = ACTIONS(913),
    [anon_sym_while] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(913),
    [anon_sym_except] = ACTIONS(913),
    [anon_sym_finally] = ACTIONS(913),
    [anon_sym_with] = ACTIONS(913),
    [anon_sym_def] = ACTIONS(913),
    [anon_sym_global] = ACTIONS(913),
    [anon_sym_nonlocal] = ACTIONS(913),
    [anon_sym_exec] = ACTIONS(913),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_AT] = ACTIONS(911),
    [anon_sym_not] = ACTIONS(913),
    [anon_sym_PLUS] = ACTIONS(911),
    [anon_sym_DASH] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(911),
    [anon_sym_lambda] = ACTIONS(913),
    [anon_sym_yield] = ACTIONS(913),
    [anon_sym_LBRACK] = ACTIONS(911),
    [sym_ellipsis] = ACTIONS(911),
    [anon_sym_LBRACE] = ACTIONS(911),
    [sym_integer] = ACTIONS(913),
    [sym_float] = ACTIONS(911),
    [sym_true] = ACTIONS(913),
    [sym_false] = ACTIONS(913),
    [sym_none] = ACTIONS(913),
    [anon_sym_await] = ACTIONS(913),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(911),
  },
  [288] = {
    [sym_named_expression] = STATE(773),
    [sym__expression] = STATE(773),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(773),
    [sym_boolean_operator] = STATE(773),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(773),
    [sym_lambda] = STATE(773),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_type] = STATE(1130),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(773),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(773),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [289] = {
    [ts_builtin_sym_end] = ACTIONS(902),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(900),
    [anon_sym_LPAREN] = ACTIONS(902),
    [anon_sym_print] = ACTIONS(900),
    [anon_sym_assert] = ACTIONS(900),
    [anon_sym_return] = ACTIONS(900),
    [anon_sym_del] = ACTIONS(900),
    [anon_sym_raise] = ACTIONS(900),
    [anon_sym_pass] = ACTIONS(900),
    [anon_sym_break] = ACTIONS(900),
    [anon_sym_continue] = ACTIONS(900),
    [anon_sym_if] = ACTIONS(900),
    [anon_sym_elif] = ACTIONS(900),
    [anon_sym_else] = ACTIONS(900),
    [anon_sym_async] = ACTIONS(900),
    [anon_sym_for] = ACTIONS(900),
    [anon_sym_while] = ACTIONS(900),
    [anon_sym_try] = ACTIONS(900),
    [anon_sym_except] = ACTIONS(900),
    [anon_sym_finally] = ACTIONS(900),
    [anon_sym_with] = ACTIONS(900),
    [anon_sym_def] = ACTIONS(900),
    [anon_sym_global] = ACTIONS(900),
    [anon_sym_nonlocal] = ACTIONS(900),
    [anon_sym_exec] = ACTIONS(900),
    [anon_sym_class] = ACTIONS(900),
    [anon_sym_AT] = ACTIONS(902),
    [anon_sym_not] = ACTIONS(900),
    [anon_sym_PLUS] = ACTIONS(902),
    [anon_sym_DASH] = ACTIONS(902),
    [anon_sym_TILDE] = ACTIONS(902),
    [anon_sym_lambda] = ACTIONS(900),
    [anon_sym_yield] = ACTIONS(900),
    [anon_sym_LBRACK] = ACTIONS(902),
    [sym_ellipsis] = ACTIONS(902),
    [anon_sym_LBRACE] = ACTIONS(902),
    [sym_integer] = ACTIONS(900),
    [sym_float] = ACTIONS(902),
    [sym_true] = ACTIONS(900),
    [sym_false] = ACTIONS(900),
    [sym_none] = ACTIONS(900),
    [anon_sym_await] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(902),
  },
  [290] = {
    [sym_named_expression] = STATE(773),
    [sym__expression] = STATE(773),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(773),
    [sym_boolean_operator] = STATE(773),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(773),
    [sym_lambda] = STATE(773),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_type] = STATE(969),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(773),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(773),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [291] = {
    [sym_named_expression] = STATE(779),
    [sym_expression_list] = STATE(1128),
    [sym__expression] = STATE(779),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(779),
    [sym_boolean_operator] = STATE(779),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(779),
    [sym_lambda] = STATE(779),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(779),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(779),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [292] = {
    [sym_named_expression] = STATE(779),
    [sym_expression_list] = STATE(1124),
    [sym__expression] = STATE(779),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(779),
    [sym_boolean_operator] = STATE(779),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(779),
    [sym_lambda] = STATE(779),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(779),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(779),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [293] = {
    [sym_named_expression] = STATE(779),
    [sym_expression_list] = STATE(1102),
    [sym__expression] = STATE(779),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(779),
    [sym_boolean_operator] = STATE(779),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(779),
    [sym_lambda] = STATE(779),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(779),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(779),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [294] = {
    [sym_named_expression] = STATE(797),
    [sym__expression] = STATE(797),
    [sym__primary_expression] = STATE(547),
    [sym_not_operator] = STATE(797),
    [sym_boolean_operator] = STATE(797),
    [sym_binary_operator] = STATE(547),
    [sym_unary_operator] = STATE(547),
    [sym_comparison_operator] = STATE(797),
    [sym_lambda] = STATE(797),
    [sym_attribute] = STATE(547),
    [sym_subscript] = STATE(547),
    [sym_call] = STATE(547),
    [sym_list] = STATE(547),
    [sym_list_comprehension] = STATE(547),
    [sym_dictionary] = STATE(547),
    [sym_dictionary_comprehension] = STATE(547),
    [sym_set] = STATE(547),
    [sym_set_comprehension] = STATE(547),
    [sym_parenthesized_expression] = STATE(547),
    [sym_tuple] = STATE(547),
    [sym_generator_expression] = STATE(547),
    [sym_conditional_expression] = STATE(797),
    [sym_concatenated_string] = STATE(547),
    [sym_string] = STATE(543),
    [sym_await] = STATE(797),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_LPAREN] = ACTIONS(870),
    [anon_sym_print] = ACTIONS(872),
    [anon_sym_COLON] = ACTIONS(915),
    [anon_sym_exec] = ACTIONS(872),
    [anon_sym_not] = ACTIONS(874),
    [anon_sym_PLUS] = ACTIONS(876),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_TILDE] = ACTIONS(876),
    [anon_sym_lambda] = ACTIONS(878),
    [anon_sym_LBRACK] = ACTIONS(880),
    [sym_ellipsis] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(884),
    [sym_integer] = ACTIONS(886),
    [sym_float] = ACTIONS(882),
    [sym_true] = ACTIONS(886),
    [sym_false] = ACTIONS(886),
    [sym_none] = ACTIONS(886),
    [anon_sym_await] = ACTIONS(888),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(890),
  },
  [295] = {
    [sym_identifier] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(913),
    [anon_sym_from] = ACTIONS(913),
    [anon_sym_LPAREN] = ACTIONS(911),
    [anon_sym_print] = ACTIONS(913),
    [anon_sym_assert] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_del] = ACTIONS(913),
    [anon_sym_raise] = ACTIONS(913),
    [anon_sym_pass] = ACTIONS(913),
    [anon_sym_break] = ACTIONS(913),
    [anon_sym_continue] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(913),
    [anon_sym_elif] = ACTIONS(913),
    [anon_sym_else] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(913),
    [anon_sym_for] = ACTIONS(913),
    [anon_sym_while] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(913),
    [anon_sym_except] = ACTIONS(913),
    [anon_sym_finally] = ACTIONS(913),
    [anon_sym_with] = ACTIONS(913),
    [anon_sym_def] = ACTIONS(913),
    [anon_sym_global] = ACTIONS(913),
    [anon_sym_nonlocal] = ACTIONS(913),
    [anon_sym_exec] = ACTIONS(913),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_AT] = ACTIONS(911),
    [anon_sym_not] = ACTIONS(913),
    [anon_sym_PLUS] = ACTIONS(911),
    [anon_sym_DASH] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(911),
    [anon_sym_lambda] = ACTIONS(913),
    [anon_sym_yield] = ACTIONS(913),
    [anon_sym_LBRACK] = ACTIONS(911),
    [sym_ellipsis] = ACTIONS(911),
    [anon_sym_LBRACE] = ACTIONS(911),
    [sym_integer] = ACTIONS(913),
    [sym_float] = ACTIONS(911),
    [sym_true] = ACTIONS(913),
    [sym_false] = ACTIONS(913),
    [sym_none] = ACTIONS(913),
    [anon_sym_await] = ACTIONS(913),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(911),
    [sym__string_start] = ACTIONS(911),
  },
  [296] = {
    [ts_builtin_sym_end] = ACTIONS(898),
    [sym_identifier] = ACTIONS(896),
    [anon_sym_import] = ACTIONS(896),
    [anon_sym_from] = ACTIONS(896),
    [anon_sym_LPAREN] = ACTIONS(898),
    [anon_sym_print] = ACTIONS(896),
    [anon_sym_assert] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(896),
    [anon_sym_del] = ACTIONS(896),
    [anon_sym_raise] = ACTIONS(896),
    [anon_sym_pass] = ACTIONS(896),
    [anon_sym_break] = ACTIONS(896),
    [anon_sym_continue] = ACTIONS(896),
    [anon_sym_if] = ACTIONS(896),
    [anon_sym_elif] = ACTIONS(896),
    [anon_sym_else] = ACTIONS(896),
    [anon_sym_async] = ACTIONS(896),
    [anon_sym_for] = ACTIONS(896),
    [anon_sym_while] = ACTIONS(896),
    [anon_sym_try] = ACTIONS(896),
    [anon_sym_except] = ACTIONS(896),
    [anon_sym_finally] = ACTIONS(896),
    [anon_sym_with] = ACTIONS(896),
    [anon_sym_def] = ACTIONS(896),
    [anon_sym_global] = ACTIONS(896),
    [anon_sym_nonlocal] = ACTIONS(896),
    [anon_sym_exec] = ACTIONS(896),
    [anon_sym_class] = ACTIONS(896),
    [anon_sym_AT] = ACTIONS(898),
    [anon_sym_not] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_TILDE] = ACTIONS(898),
    [anon_sym_lambda] = ACTIONS(896),
    [anon_sym_yield] = ACTIONS(896),
    [anon_sym_LBRACK] = ACTIONS(898),
    [sym_ellipsis] = ACTIONS(898),
    [anon_sym_LBRACE] = ACTIONS(898),
    [sym_integer] = ACTIONS(896),
    [sym_float] = ACTIONS(898),
    [sym_true] = ACTIONS(896),
    [sym_false] = ACTIONS(896),
    [sym_none] = ACTIONS(896),
    [anon_sym_await] = ACTIONS(896),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(898),
  },
  [297] = {
    [sym_elif_clause] = STATE(401),
    [aux_sym_if_statement_repeat1] = STATE(297),
    [sym_identifier] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_from] = ACTIONS(906),
    [anon_sym_LPAREN] = ACTIONS(904),
    [anon_sym_print] = ACTIONS(906),
    [anon_sym_assert] = ACTIONS(906),
    [anon_sym_return] = ACTIONS(906),
    [anon_sym_del] = ACTIONS(906),
    [anon_sym_raise] = ACTIONS(906),
    [anon_sym_pass] = ACTIONS(906),
    [anon_sym_break] = ACTIONS(906),
    [anon_sym_continue] = ACTIONS(906),
    [anon_sym_if] = ACTIONS(906),
    [anon_sym_elif] = ACTIONS(917),
    [anon_sym_else] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(906),
    [anon_sym_for] = ACTIONS(906),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_try] = ACTIONS(906),
    [anon_sym_with] = ACTIONS(906),
    [anon_sym_def] = ACTIONS(906),
    [anon_sym_global] = ACTIONS(906),
    [anon_sym_nonlocal] = ACTIONS(906),
    [anon_sym_exec] = ACTIONS(906),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_AT] = ACTIONS(904),
    [anon_sym_not] = ACTIONS(906),
    [anon_sym_PLUS] = ACTIONS(904),
    [anon_sym_DASH] = ACTIONS(904),
    [anon_sym_TILDE] = ACTIONS(904),
    [anon_sym_lambda] = ACTIONS(906),
    [anon_sym_yield] = ACTIONS(906),
    [anon_sym_LBRACK] = ACTIONS(904),
    [sym_ellipsis] = ACTIONS(904),
    [anon_sym_LBRACE] = ACTIONS(904),
    [sym_integer] = ACTIONS(906),
    [sym_float] = ACTIONS(904),
    [sym_true] = ACTIONS(906),
    [sym_false] = ACTIONS(906),
    [sym_none] = ACTIONS(906),
    [anon_sym_await] = ACTIONS(906),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(904),
    [sym__string_start] = ACTIONS(904),
  },
  [298] = {
    [sym_identifier] = ACTIONS(920),
    [anon_sym_import] = ACTIONS(920),
    [anon_sym_from] = ACTIONS(920),
    [anon_sym_LPAREN] = ACTIONS(922),
    [anon_sym_print] = ACTIONS(920),
    [anon_sym_assert] = ACTIONS(920),
    [anon_sym_return] = ACTIONS(920),
    [anon_sym_del] = ACTIONS(920),
    [anon_sym_raise] = ACTIONS(920),
    [anon_sym_pass] = ACTIONS(920),
    [anon_sym_break] = ACTIONS(920),
    [anon_sym_continue] = ACTIONS(920),
    [anon_sym_if] = ACTIONS(920),
    [anon_sym_elif] = ACTIONS(920),
    [anon_sym_else] = ACTIONS(920),
    [anon_sym_async] = ACTIONS(920),
    [anon_sym_for] = ACTIONS(920),
    [anon_sym_while] = ACTIONS(920),
    [anon_sym_try] = ACTIONS(920),
    [anon_sym_except] = ACTIONS(920),
    [anon_sym_finally] = ACTIONS(920),
    [anon_sym_with] = ACTIONS(920),
    [anon_sym_def] = ACTIONS(920),
    [anon_sym_global] = ACTIONS(920),
    [anon_sym_nonlocal] = ACTIONS(920),
    [anon_sym_exec] = ACTIONS(920),
    [anon_sym_class] = ACTIONS(920),
    [anon_sym_AT] = ACTIONS(922),
    [anon_sym_not] = ACTIONS(920),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_TILDE] = ACTIONS(922),
    [anon_sym_lambda] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(920),
    [anon_sym_LBRACK] = ACTIONS(922),
    [sym_ellipsis] = ACTIONS(922),
    [anon_sym_LBRACE] = ACTIONS(922),
    [sym_integer] = ACTIONS(920),
    [sym_float] = ACTIONS(922),
    [sym_true] = ACTIONS(920),
    [sym_false] = ACTIONS(920),
    [sym_none] = ACTIONS(920),
    [anon_sym_await] = ACTIONS(920),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(922),
    [sym__string_start] = ACTIONS(922),
  },
  [299] = {
    [sym_named_expression] = STATE(794),
    [sym_with_item] = STATE(967),
    [sym__expression] = STATE(794),
    [sym__primary_expression] = STATE(547),
    [sym_not_operator] = STATE(794),
    [sym_boolean_operator] = STATE(794),
    [sym_binary_operator] = STATE(547),
    [sym_unary_operator] = STATE(547),
    [sym_comparison_operator] = STATE(794),
    [sym_lambda] = STATE(794),
    [sym_attribute] = STATE(547),
    [sym_subscript] = STATE(547),
    [sym_call] = STATE(547),
    [sym_list] = STATE(547),
    [sym_list_comprehension] = STATE(547),
    [sym_dictionary] = STATE(547),
    [sym_dictionary_comprehension] = STATE(547),
    [sym_set] = STATE(547),
    [sym_set_comprehension] = STATE(547),
    [sym_parenthesized_expression] = STATE(547),
    [sym_tuple] = STATE(547),
    [sym_generator_expression] = STATE(547),
    [sym_conditional_expression] = STATE(794),
    [sym_concatenated_string] = STATE(547),
    [sym_string] = STATE(543),
    [sym_await] = STATE(794),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_LPAREN] = ACTIONS(870),
    [anon_sym_print] = ACTIONS(872),
    [anon_sym_exec] = ACTIONS(872),
    [anon_sym_not] = ACTIONS(874),
    [anon_sym_PLUS] = ACTIONS(876),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_TILDE] = ACTIONS(876),
    [anon_sym_lambda] = ACTIONS(878),
    [anon_sym_LBRACK] = ACTIONS(880),
    [sym_ellipsis] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(884),
    [sym_integer] = ACTIONS(886),
    [sym_float] = ACTIONS(882),
    [sym_true] = ACTIONS(886),
    [sym_false] = ACTIONS(886),
    [sym_none] = ACTIONS(886),
    [anon_sym_await] = ACTIONS(888),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(890),
  },
  [300] = {
    [ts_builtin_sym_end] = ACTIONS(922),
    [sym_identifier] = ACTIONS(920),
    [anon_sym_import] = ACTIONS(920),
    [anon_sym_from] = ACTIONS(920),
    [anon_sym_LPAREN] = ACTIONS(922),
    [anon_sym_print] = ACTIONS(920),
    [anon_sym_assert] = ACTIONS(920),
    [anon_sym_return] = ACTIONS(920),
    [anon_sym_del] = ACTIONS(920),
    [anon_sym_raise] = ACTIONS(920),
    [anon_sym_pass] = ACTIONS(920),
    [anon_sym_break] = ACTIONS(920),
    [anon_sym_continue] = ACTIONS(920),
    [anon_sym_if] = ACTIONS(920),
    [anon_sym_elif] = ACTIONS(920),
    [anon_sym_else] = ACTIONS(920),
    [anon_sym_async] = ACTIONS(920),
    [anon_sym_for] = ACTIONS(920),
    [anon_sym_while] = ACTIONS(920),
    [anon_sym_try] = ACTIONS(920),
    [anon_sym_except] = ACTIONS(920),
    [anon_sym_finally] = ACTIONS(920),
    [anon_sym_with] = ACTIONS(920),
    [anon_sym_def] = ACTIONS(920),
    [anon_sym_global] = ACTIONS(920),
    [anon_sym_nonlocal] = ACTIONS(920),
    [anon_sym_exec] = ACTIONS(920),
    [anon_sym_class] = ACTIONS(920),
    [anon_sym_AT] = ACTIONS(922),
    [anon_sym_not] = ACTIONS(920),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_TILDE] = ACTIONS(922),
    [anon_sym_lambda] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(920),
    [anon_sym_LBRACK] = ACTIONS(922),
    [sym_ellipsis] = ACTIONS(922),
    [anon_sym_LBRACE] = ACTIONS(922),
    [sym_integer] = ACTIONS(920),
    [sym_float] = ACTIONS(922),
    [sym_true] = ACTIONS(920),
    [sym_false] = ACTIONS(920),
    [sym_none] = ACTIONS(920),
    [anon_sym_await] = ACTIONS(920),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(922),
  },
  [301] = {
    [sym_named_expression] = STATE(795),
    [sym__expression] = STATE(795),
    [sym__primary_expression] = STATE(547),
    [sym_not_operator] = STATE(795),
    [sym_boolean_operator] = STATE(795),
    [sym_binary_operator] = STATE(547),
    [sym_unary_operator] = STATE(547),
    [sym_comparison_operator] = STATE(795),
    [sym_lambda] = STATE(795),
    [sym_attribute] = STATE(547),
    [sym_subscript] = STATE(547),
    [sym_call] = STATE(547),
    [sym_list] = STATE(547),
    [sym_list_comprehension] = STATE(547),
    [sym_dictionary] = STATE(547),
    [sym_dictionary_comprehension] = STATE(547),
    [sym_set] = STATE(547),
    [sym_set_comprehension] = STATE(547),
    [sym_parenthesized_expression] = STATE(547),
    [sym_tuple] = STATE(547),
    [sym_generator_expression] = STATE(547),
    [sym_conditional_expression] = STATE(795),
    [sym_concatenated_string] = STATE(547),
    [sym_string] = STATE(543),
    [sym_await] = STATE(795),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_LPAREN] = ACTIONS(870),
    [anon_sym_print] = ACTIONS(872),
    [anon_sym_COLON] = ACTIONS(924),
    [anon_sym_exec] = ACTIONS(872),
    [anon_sym_not] = ACTIONS(874),
    [anon_sym_PLUS] = ACTIONS(876),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_TILDE] = ACTIONS(876),
    [anon_sym_lambda] = ACTIONS(878),
    [anon_sym_LBRACK] = ACTIONS(880),
    [sym_ellipsis] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(884),
    [sym_integer] = ACTIONS(886),
    [sym_float] = ACTIONS(882),
    [sym_true] = ACTIONS(886),
    [sym_false] = ACTIONS(886),
    [sym_none] = ACTIONS(886),
    [anon_sym_await] = ACTIONS(888),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(890),
  },
  [302] = {
    [ts_builtin_sym_end] = ACTIONS(926),
    [sym_identifier] = ACTIONS(928),
    [anon_sym_import] = ACTIONS(928),
    [anon_sym_from] = ACTIONS(928),
    [anon_sym_LPAREN] = ACTIONS(926),
    [anon_sym_print] = ACTIONS(928),
    [anon_sym_assert] = ACTIONS(928),
    [anon_sym_return] = ACTIONS(928),
    [anon_sym_del] = ACTIONS(928),
    [anon_sym_raise] = ACTIONS(928),
    [anon_sym_pass] = ACTIONS(928),
    [anon_sym_break] = ACTIONS(928),
    [anon_sym_continue] = ACTIONS(928),
    [anon_sym_if] = ACTIONS(928),
    [anon_sym_else] = ACTIONS(928),
    [anon_sym_async] = ACTIONS(928),
    [anon_sym_for] = ACTIONS(928),
    [anon_sym_while] = ACTIONS(928),
    [anon_sym_try] = ACTIONS(928),
    [anon_sym_except] = ACTIONS(928),
    [anon_sym_finally] = ACTIONS(928),
    [anon_sym_with] = ACTIONS(928),
    [anon_sym_def] = ACTIONS(928),
    [anon_sym_global] = ACTIONS(928),
    [anon_sym_nonlocal] = ACTIONS(928),
    [anon_sym_exec] = ACTIONS(928),
    [anon_sym_class] = ACTIONS(928),
    [anon_sym_AT] = ACTIONS(926),
    [anon_sym_not] = ACTIONS(928),
    [anon_sym_PLUS] = ACTIONS(926),
    [anon_sym_DASH] = ACTIONS(926),
    [anon_sym_TILDE] = ACTIONS(926),
    [anon_sym_lambda] = ACTIONS(928),
    [anon_sym_yield] = ACTIONS(928),
    [anon_sym_LBRACK] = ACTIONS(926),
    [sym_ellipsis] = ACTIONS(926),
    [anon_sym_LBRACE] = ACTIONS(926),
    [sym_integer] = ACTIONS(928),
    [sym_float] = ACTIONS(926),
    [sym_true] = ACTIONS(928),
    [sym_false] = ACTIONS(928),
    [sym_none] = ACTIONS(928),
    [anon_sym_await] = ACTIONS(928),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(926),
  },
  [303] = {
    [sym_named_expression] = STATE(765),
    [sym__expression] = STATE(765),
    [sym__primary_expression] = STATE(532),
    [sym_not_operator] = STATE(765),
    [sym_boolean_operator] = STATE(765),
    [sym_binary_operator] = STATE(532),
    [sym_unary_operator] = STATE(532),
    [sym_comparison_operator] = STATE(765),
    [sym_lambda] = STATE(765),
    [sym_attribute] = STATE(532),
    [sym_subscript] = STATE(532),
    [sym_call] = STATE(532),
    [sym_list] = STATE(532),
    [sym_list_comprehension] = STATE(532),
    [sym_dictionary] = STATE(532),
    [sym_dictionary_comprehension] = STATE(532),
    [sym_set] = STATE(532),
    [sym_set_comprehension] = STATE(532),
    [sym_parenthesized_expression] = STATE(532),
    [sym_tuple] = STATE(532),
    [sym_generator_expression] = STATE(532),
    [sym_conditional_expression] = STATE(765),
    [sym_concatenated_string] = STATE(532),
    [sym_string] = STATE(530),
    [sym_await] = STATE(765),
    [sym_identifier] = ACTIONS(233),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_print] = ACTIONS(239),
    [anon_sym_exec] = ACTIONS(239),
    [anon_sym_not] = ACTIONS(536),
    [anon_sym_PLUS] = ACTIONS(243),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_TILDE] = ACTIONS(243),
    [anon_sym_lambda] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(538),
    [sym_ellipsis] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [sym_integer] = ACTIONS(251),
    [sym_float] = ACTIONS(247),
    [sym_true] = ACTIONS(251),
    [sym_false] = ACTIONS(251),
    [sym_none] = ACTIONS(251),
    [anon_sym_await] = ACTIONS(253),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(255),
  },
  [304] = {
    [sym_named_expression] = STATE(762),
    [sym__expression] = STATE(762),
    [sym__primary_expression] = STATE(532),
    [sym_not_operator] = STATE(762),
    [sym_boolean_operator] = STATE(762),
    [sym_binary_operator] = STATE(532),
    [sym_unary_operator] = STATE(532),
    [sym_comparison_operator] = STATE(762),
    [sym_lambda] = STATE(762),
    [sym_attribute] = STATE(532),
    [sym_subscript] = STATE(532),
    [sym_call] = STATE(532),
    [sym_list] = STATE(532),
    [sym_list_comprehension] = STATE(532),
    [sym_dictionary] = STATE(532),
    [sym_dictionary_comprehension] = STATE(532),
    [sym_set] = STATE(532),
    [sym_set_comprehension] = STATE(532),
    [sym_parenthesized_expression] = STATE(532),
    [sym_tuple] = STATE(532),
    [sym_generator_expression] = STATE(532),
    [sym_conditional_expression] = STATE(762),
    [sym_concatenated_string] = STATE(532),
    [sym_string] = STATE(530),
    [sym_await] = STATE(762),
    [sym_identifier] = ACTIONS(233),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_print] = ACTIONS(239),
    [anon_sym_exec] = ACTIONS(239),
    [anon_sym_not] = ACTIONS(536),
    [anon_sym_PLUS] = ACTIONS(243),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_TILDE] = ACTIONS(243),
    [anon_sym_lambda] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(538),
    [sym_ellipsis] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [sym_integer] = ACTIONS(251),
    [sym_float] = ACTIONS(247),
    [sym_true] = ACTIONS(251),
    [sym_false] = ACTIONS(251),
    [sym_none] = ACTIONS(251),
    [anon_sym_await] = ACTIONS(253),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(255),
  },
  [305] = {
    [sym_named_expression] = STATE(895),
    [sym__expression] = STATE(895),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(895),
    [sym_boolean_operator] = STATE(895),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(895),
    [sym_lambda] = STATE(895),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(895),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(895),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [306] = {
    [sym_identifier] = ACTIONS(930),
    [anon_sym_import] = ACTIONS(930),
    [anon_sym_from] = ACTIONS(930),
    [anon_sym_LPAREN] = ACTIONS(932),
    [anon_sym_print] = ACTIONS(930),
    [anon_sym_assert] = ACTIONS(930),
    [anon_sym_return] = ACTIONS(930),
    [anon_sym_del] = ACTIONS(930),
    [anon_sym_raise] = ACTIONS(930),
    [anon_sym_pass] = ACTIONS(930),
    [anon_sym_break] = ACTIONS(930),
    [anon_sym_continue] = ACTIONS(930),
    [anon_sym_if] = ACTIONS(930),
    [anon_sym_else] = ACTIONS(930),
    [anon_sym_async] = ACTIONS(930),
    [anon_sym_for] = ACTIONS(930),
    [anon_sym_while] = ACTIONS(930),
    [anon_sym_try] = ACTIONS(930),
    [anon_sym_except] = ACTIONS(930),
    [anon_sym_finally] = ACTIONS(930),
    [anon_sym_with] = ACTIONS(930),
    [anon_sym_def] = ACTIONS(930),
    [anon_sym_global] = ACTIONS(930),
    [anon_sym_nonlocal] = ACTIONS(930),
    [anon_sym_exec] = ACTIONS(930),
    [anon_sym_class] = ACTIONS(930),
    [anon_sym_AT] = ACTIONS(932),
    [anon_sym_not] = ACTIONS(930),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(932),
    [anon_sym_lambda] = ACTIONS(930),
    [anon_sym_yield] = ACTIONS(930),
    [anon_sym_LBRACK] = ACTIONS(932),
    [sym_ellipsis] = ACTIONS(932),
    [anon_sym_LBRACE] = ACTIONS(932),
    [sym_integer] = ACTIONS(930),
    [sym_float] = ACTIONS(932),
    [sym_true] = ACTIONS(930),
    [sym_false] = ACTIONS(930),
    [sym_none] = ACTIONS(930),
    [anon_sym_await] = ACTIONS(930),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(932),
    [sym__string_start] = ACTIONS(932),
  },
  [307] = {
    [sym_named_expression] = STATE(817),
    [sym__expression] = STATE(817),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(817),
    [sym_boolean_operator] = STATE(817),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(817),
    [sym_lambda] = STATE(817),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(817),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(817),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [308] = {
    [sym_named_expression] = STATE(684),
    [sym__expression] = STATE(684),
    [sym__primary_expression] = STATE(532),
    [sym_not_operator] = STATE(684),
    [sym_boolean_operator] = STATE(684),
    [sym_binary_operator] = STATE(532),
    [sym_unary_operator] = STATE(532),
    [sym_comparison_operator] = STATE(684),
    [sym_lambda] = STATE(684),
    [sym_attribute] = STATE(532),
    [sym_subscript] = STATE(532),
    [sym_call] = STATE(532),
    [sym_list] = STATE(532),
    [sym_list_comprehension] = STATE(532),
    [sym_dictionary] = STATE(532),
    [sym_dictionary_comprehension] = STATE(532),
    [sym_set] = STATE(532),
    [sym_set_comprehension] = STATE(532),
    [sym_parenthesized_expression] = STATE(532),
    [sym_tuple] = STATE(532),
    [sym_generator_expression] = STATE(532),
    [sym_conditional_expression] = STATE(684),
    [sym_concatenated_string] = STATE(532),
    [sym_string] = STATE(530),
    [sym_await] = STATE(684),
    [sym_identifier] = ACTIONS(233),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_print] = ACTIONS(239),
    [anon_sym_exec] = ACTIONS(239),
    [anon_sym_not] = ACTIONS(536),
    [anon_sym_PLUS] = ACTIONS(243),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_TILDE] = ACTIONS(243),
    [anon_sym_lambda] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(538),
    [sym_ellipsis] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [sym_integer] = ACTIONS(251),
    [sym_float] = ACTIONS(247),
    [sym_true] = ACTIONS(251),
    [sym_false] = ACTIONS(251),
    [sym_none] = ACTIONS(251),
    [anon_sym_await] = ACTIONS(253),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(255),
  },
  [309] = {
    [sym_named_expression] = STATE(684),
    [sym__expression] = STATE(684),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(684),
    [sym_boolean_operator] = STATE(684),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(684),
    [sym_lambda] = STATE(684),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(684),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(684),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(349),
    [anon_sym_exec] = ACTIONS(349),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [310] = {
    [sym_named_expression] = STATE(757),
    [sym__expression] = STATE(757),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(757),
    [sym_boolean_operator] = STATE(757),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(757),
    [sym_lambda] = STATE(757),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(757),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(757),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [311] = {
    [sym_named_expression] = STATE(904),
    [sym__expression] = STATE(904),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(904),
    [sym_boolean_operator] = STATE(904),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(904),
    [sym_lambda] = STATE(904),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(904),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(904),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [312] = {
    [sym_named_expression] = STATE(814),
    [sym__expression] = STATE(814),
    [sym__primary_expression] = STATE(547),
    [sym_not_operator] = STATE(814),
    [sym_boolean_operator] = STATE(814),
    [sym_binary_operator] = STATE(547),
    [sym_unary_operator] = STATE(547),
    [sym_comparison_operator] = STATE(814),
    [sym_lambda] = STATE(814),
    [sym_attribute] = STATE(547),
    [sym_subscript] = STATE(547),
    [sym_call] = STATE(547),
    [sym_list] = STATE(547),
    [sym_list_comprehension] = STATE(547),
    [sym_dictionary] = STATE(547),
    [sym_dictionary_comprehension] = STATE(547),
    [sym_set] = STATE(547),
    [sym_set_comprehension] = STATE(547),
    [sym_parenthesized_expression] = STATE(547),
    [sym_tuple] = STATE(547),
    [sym_generator_expression] = STATE(547),
    [sym_conditional_expression] = STATE(814),
    [sym_concatenated_string] = STATE(547),
    [sym_string] = STATE(543),
    [sym_await] = STATE(814),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_LPAREN] = ACTIONS(870),
    [anon_sym_print] = ACTIONS(872),
    [anon_sym_exec] = ACTIONS(872),
    [anon_sym_not] = ACTIONS(874),
    [anon_sym_PLUS] = ACTIONS(876),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_TILDE] = ACTIONS(876),
    [anon_sym_lambda] = ACTIONS(878),
    [anon_sym_LBRACK] = ACTIONS(880),
    [sym_ellipsis] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(884),
    [sym_integer] = ACTIONS(886),
    [sym_float] = ACTIONS(882),
    [sym_true] = ACTIONS(886),
    [sym_false] = ACTIONS(886),
    [sym_none] = ACTIONS(886),
    [anon_sym_await] = ACTIONS(888),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(890),
  },
  [313] = {
    [sym_named_expression] = STATE(869),
    [sym__expression] = STATE(869),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(869),
    [sym_boolean_operator] = STATE(869),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(869),
    [sym_lambda] = STATE(869),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(869),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(869),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [314] = {
    [sym_named_expression] = STATE(715),
    [sym__expression] = STATE(715),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(715),
    [sym_boolean_operator] = STATE(715),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(715),
    [sym_lambda] = STATE(715),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(715),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(715),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [315] = {
    [ts_builtin_sym_end] = ACTIONS(934),
    [sym_identifier] = ACTIONS(936),
    [anon_sym_import] = ACTIONS(936),
    [anon_sym_from] = ACTIONS(936),
    [anon_sym_LPAREN] = ACTIONS(934),
    [anon_sym_print] = ACTIONS(936),
    [anon_sym_assert] = ACTIONS(936),
    [anon_sym_return] = ACTIONS(936),
    [anon_sym_del] = ACTIONS(936),
    [anon_sym_raise] = ACTIONS(936),
    [anon_sym_pass] = ACTIONS(936),
    [anon_sym_break] = ACTIONS(936),
    [anon_sym_continue] = ACTIONS(936),
    [anon_sym_if] = ACTIONS(936),
    [anon_sym_else] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_for] = ACTIONS(936),
    [anon_sym_while] = ACTIONS(936),
    [anon_sym_try] = ACTIONS(936),
    [anon_sym_except] = ACTIONS(936),
    [anon_sym_finally] = ACTIONS(936),
    [anon_sym_with] = ACTIONS(936),
    [anon_sym_def] = ACTIONS(936),
    [anon_sym_global] = ACTIONS(936),
    [anon_sym_nonlocal] = ACTIONS(936),
    [anon_sym_exec] = ACTIONS(936),
    [anon_sym_class] = ACTIONS(936),
    [anon_sym_AT] = ACTIONS(934),
    [anon_sym_not] = ACTIONS(936),
    [anon_sym_PLUS] = ACTIONS(934),
    [anon_sym_DASH] = ACTIONS(934),
    [anon_sym_TILDE] = ACTIONS(934),
    [anon_sym_lambda] = ACTIONS(936),
    [anon_sym_yield] = ACTIONS(936),
    [anon_sym_LBRACK] = ACTIONS(934),
    [sym_ellipsis] = ACTIONS(934),
    [anon_sym_LBRACE] = ACTIONS(934),
    [sym_integer] = ACTIONS(936),
    [sym_float] = ACTIONS(934),
    [sym_true] = ACTIONS(936),
    [sym_false] = ACTIONS(936),
    [sym_none] = ACTIONS(936),
    [anon_sym_await] = ACTIONS(936),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(934),
  },
  [316] = {
    [sym_named_expression] = STATE(868),
    [sym__expression] = STATE(868),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(868),
    [sym_boolean_operator] = STATE(868),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(868),
    [sym_lambda] = STATE(868),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(868),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(868),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [317] = {
    [sym_named_expression] = STATE(882),
    [sym__expression] = STATE(882),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(882),
    [sym_boolean_operator] = STATE(882),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(882),
    [sym_lambda] = STATE(882),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(882),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(882),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [318] = {
    [ts_builtin_sym_end] = ACTIONS(938),
    [sym_identifier] = ACTIONS(940),
    [anon_sym_import] = ACTIONS(940),
    [anon_sym_from] = ACTIONS(940),
    [anon_sym_LPAREN] = ACTIONS(938),
    [anon_sym_print] = ACTIONS(940),
    [anon_sym_assert] = ACTIONS(940),
    [anon_sym_return] = ACTIONS(940),
    [anon_sym_del] = ACTIONS(940),
    [anon_sym_raise] = ACTIONS(940),
    [anon_sym_pass] = ACTIONS(940),
    [anon_sym_break] = ACTIONS(940),
    [anon_sym_continue] = ACTIONS(940),
    [anon_sym_if] = ACTIONS(940),
    [anon_sym_else] = ACTIONS(940),
    [anon_sym_async] = ACTIONS(940),
    [anon_sym_for] = ACTIONS(940),
    [anon_sym_while] = ACTIONS(940),
    [anon_sym_try] = ACTIONS(940),
    [anon_sym_except] = ACTIONS(940),
    [anon_sym_finally] = ACTIONS(940),
    [anon_sym_with] = ACTIONS(940),
    [anon_sym_def] = ACTIONS(940),
    [anon_sym_global] = ACTIONS(940),
    [anon_sym_nonlocal] = ACTIONS(940),
    [anon_sym_exec] = ACTIONS(940),
    [anon_sym_class] = ACTIONS(940),
    [anon_sym_AT] = ACTIONS(938),
    [anon_sym_not] = ACTIONS(940),
    [anon_sym_PLUS] = ACTIONS(938),
    [anon_sym_DASH] = ACTIONS(938),
    [anon_sym_TILDE] = ACTIONS(938),
    [anon_sym_lambda] = ACTIONS(940),
    [anon_sym_yield] = ACTIONS(940),
    [anon_sym_LBRACK] = ACTIONS(938),
    [sym_ellipsis] = ACTIONS(938),
    [anon_sym_LBRACE] = ACTIONS(938),
    [sym_integer] = ACTIONS(940),
    [sym_float] = ACTIONS(938),
    [sym_true] = ACTIONS(940),
    [sym_false] = ACTIONS(940),
    [sym_none] = ACTIONS(940),
    [anon_sym_await] = ACTIONS(940),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(938),
  },
  [319] = {
    [sym_named_expression] = STATE(695),
    [sym__expression] = STATE(695),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(695),
    [sym_boolean_operator] = STATE(695),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(695),
    [sym_lambda] = STATE(695),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(695),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(695),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(349),
    [anon_sym_exec] = ACTIONS(349),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [320] = {
    [sym_named_expression] = STATE(777),
    [sym__expression] = STATE(777),
    [sym__primary_expression] = STATE(532),
    [sym_not_operator] = STATE(777),
    [sym_boolean_operator] = STATE(777),
    [sym_binary_operator] = STATE(532),
    [sym_unary_operator] = STATE(532),
    [sym_comparison_operator] = STATE(777),
    [sym_lambda] = STATE(777),
    [sym_attribute] = STATE(532),
    [sym_subscript] = STATE(532),
    [sym_call] = STATE(532),
    [sym_list] = STATE(532),
    [sym_list_comprehension] = STATE(532),
    [sym_dictionary] = STATE(532),
    [sym_dictionary_comprehension] = STATE(532),
    [sym_set] = STATE(532),
    [sym_set_comprehension] = STATE(532),
    [sym_parenthesized_expression] = STATE(532),
    [sym_tuple] = STATE(532),
    [sym_generator_expression] = STATE(532),
    [sym_conditional_expression] = STATE(777),
    [sym_concatenated_string] = STATE(532),
    [sym_string] = STATE(530),
    [sym_await] = STATE(777),
    [sym_identifier] = ACTIONS(233),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_print] = ACTIONS(239),
    [anon_sym_exec] = ACTIONS(239),
    [anon_sym_not] = ACTIONS(536),
    [anon_sym_PLUS] = ACTIONS(243),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_TILDE] = ACTIONS(243),
    [anon_sym_lambda] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(538),
    [sym_ellipsis] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [sym_integer] = ACTIONS(251),
    [sym_float] = ACTIONS(247),
    [sym_true] = ACTIONS(251),
    [sym_false] = ACTIONS(251),
    [sym_none] = ACTIONS(251),
    [anon_sym_await] = ACTIONS(253),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(255),
  },
  [321] = {
    [sym_named_expression] = STATE(689),
    [sym__expression] = STATE(689),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(689),
    [sym_boolean_operator] = STATE(689),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(689),
    [sym_lambda] = STATE(689),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(689),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(689),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(349),
    [anon_sym_exec] = ACTIONS(349),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [322] = {
    [sym_identifier] = ACTIONS(940),
    [anon_sym_import] = ACTIONS(940),
    [anon_sym_from] = ACTIONS(940),
    [anon_sym_LPAREN] = ACTIONS(938),
    [anon_sym_print] = ACTIONS(940),
    [anon_sym_assert] = ACTIONS(940),
    [anon_sym_return] = ACTIONS(940),
    [anon_sym_del] = ACTIONS(940),
    [anon_sym_raise] = ACTIONS(940),
    [anon_sym_pass] = ACTIONS(940),
    [anon_sym_break] = ACTIONS(940),
    [anon_sym_continue] = ACTIONS(940),
    [anon_sym_if] = ACTIONS(940),
    [anon_sym_else] = ACTIONS(940),
    [anon_sym_async] = ACTIONS(940),
    [anon_sym_for] = ACTIONS(940),
    [anon_sym_while] = ACTIONS(940),
    [anon_sym_try] = ACTIONS(940),
    [anon_sym_except] = ACTIONS(940),
    [anon_sym_finally] = ACTIONS(940),
    [anon_sym_with] = ACTIONS(940),
    [anon_sym_def] = ACTIONS(940),
    [anon_sym_global] = ACTIONS(940),
    [anon_sym_nonlocal] = ACTIONS(940),
    [anon_sym_exec] = ACTIONS(940),
    [anon_sym_class] = ACTIONS(940),
    [anon_sym_AT] = ACTIONS(938),
    [anon_sym_not] = ACTIONS(940),
    [anon_sym_PLUS] = ACTIONS(938),
    [anon_sym_DASH] = ACTIONS(938),
    [anon_sym_TILDE] = ACTIONS(938),
    [anon_sym_lambda] = ACTIONS(940),
    [anon_sym_yield] = ACTIONS(940),
    [anon_sym_LBRACK] = ACTIONS(938),
    [sym_ellipsis] = ACTIONS(938),
    [anon_sym_LBRACE] = ACTIONS(938),
    [sym_integer] = ACTIONS(940),
    [sym_float] = ACTIONS(938),
    [sym_true] = ACTIONS(940),
    [sym_false] = ACTIONS(940),
    [sym_none] = ACTIONS(940),
    [anon_sym_await] = ACTIONS(940),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(938),
    [sym__string_start] = ACTIONS(938),
  },
  [323] = {
    [sym_named_expression] = STATE(772),
    [sym__expression] = STATE(772),
    [sym__primary_expression] = STATE(532),
    [sym_not_operator] = STATE(772),
    [sym_boolean_operator] = STATE(772),
    [sym_binary_operator] = STATE(532),
    [sym_unary_operator] = STATE(532),
    [sym_comparison_operator] = STATE(772),
    [sym_lambda] = STATE(772),
    [sym_attribute] = STATE(532),
    [sym_subscript] = STATE(532),
    [sym_call] = STATE(532),
    [sym_list] = STATE(532),
    [sym_list_comprehension] = STATE(532),
    [sym_dictionary] = STATE(532),
    [sym_dictionary_comprehension] = STATE(532),
    [sym_set] = STATE(532),
    [sym_set_comprehension] = STATE(532),
    [sym_parenthesized_expression] = STATE(532),
    [sym_tuple] = STATE(532),
    [sym_generator_expression] = STATE(532),
    [sym_conditional_expression] = STATE(772),
    [sym_concatenated_string] = STATE(532),
    [sym_string] = STATE(530),
    [sym_await] = STATE(772),
    [sym_identifier] = ACTIONS(233),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_print] = ACTIONS(239),
    [anon_sym_exec] = ACTIONS(239),
    [anon_sym_not] = ACTIONS(536),
    [anon_sym_PLUS] = ACTIONS(243),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_TILDE] = ACTIONS(243),
    [anon_sym_lambda] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(538),
    [sym_ellipsis] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [sym_integer] = ACTIONS(251),
    [sym_float] = ACTIONS(247),
    [sym_true] = ACTIONS(251),
    [sym_false] = ACTIONS(251),
    [sym_none] = ACTIONS(251),
    [anon_sym_await] = ACTIONS(253),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(255),
  },
  [324] = {
    [sym_named_expression] = STATE(688),
    [sym__expression] = STATE(688),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(688),
    [sym_boolean_operator] = STATE(688),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(688),
    [sym_lambda] = STATE(688),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(688),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(688),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(349),
    [anon_sym_exec] = ACTIONS(349),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [325] = {
    [sym_named_expression] = STATE(686),
    [sym__expression] = STATE(686),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(686),
    [sym_boolean_operator] = STATE(686),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(686),
    [sym_lambda] = STATE(686),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(686),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(686),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(349),
    [anon_sym_exec] = ACTIONS(349),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [326] = {
    [sym_named_expression] = STATE(875),
    [sym__expression] = STATE(875),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(875),
    [sym_boolean_operator] = STATE(875),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(875),
    [sym_lambda] = STATE(875),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(875),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(875),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [327] = {
    [sym_named_expression] = STATE(873),
    [sym__expression] = STATE(873),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(873),
    [sym_boolean_operator] = STATE(873),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(873),
    [sym_lambda] = STATE(873),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(873),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(873),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [328] = {
    [sym_named_expression] = STATE(815),
    [sym__expression] = STATE(815),
    [sym__primary_expression] = STATE(547),
    [sym_not_operator] = STATE(815),
    [sym_boolean_operator] = STATE(815),
    [sym_binary_operator] = STATE(547),
    [sym_unary_operator] = STATE(547),
    [sym_comparison_operator] = STATE(815),
    [sym_lambda] = STATE(815),
    [sym_attribute] = STATE(547),
    [sym_subscript] = STATE(547),
    [sym_call] = STATE(547),
    [sym_list] = STATE(547),
    [sym_list_comprehension] = STATE(547),
    [sym_dictionary] = STATE(547),
    [sym_dictionary_comprehension] = STATE(547),
    [sym_set] = STATE(547),
    [sym_set_comprehension] = STATE(547),
    [sym_parenthesized_expression] = STATE(547),
    [sym_tuple] = STATE(547),
    [sym_generator_expression] = STATE(547),
    [sym_conditional_expression] = STATE(815),
    [sym_concatenated_string] = STATE(547),
    [sym_string] = STATE(543),
    [sym_await] = STATE(815),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_LPAREN] = ACTIONS(870),
    [anon_sym_print] = ACTIONS(872),
    [anon_sym_exec] = ACTIONS(872),
    [anon_sym_not] = ACTIONS(874),
    [anon_sym_PLUS] = ACTIONS(876),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_TILDE] = ACTIONS(876),
    [anon_sym_lambda] = ACTIONS(878),
    [anon_sym_LBRACK] = ACTIONS(880),
    [sym_ellipsis] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(884),
    [sym_integer] = ACTIONS(886),
    [sym_float] = ACTIONS(882),
    [sym_true] = ACTIONS(886),
    [sym_false] = ACTIONS(886),
    [sym_none] = ACTIONS(886),
    [anon_sym_await] = ACTIONS(888),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(890),
  },
  [329] = {
    [sym_named_expression] = STATE(811),
    [sym__expression] = STATE(811),
    [sym__primary_expression] = STATE(547),
    [sym_not_operator] = STATE(811),
    [sym_boolean_operator] = STATE(811),
    [sym_binary_operator] = STATE(547),
    [sym_unary_operator] = STATE(547),
    [sym_comparison_operator] = STATE(811),
    [sym_lambda] = STATE(811),
    [sym_attribute] = STATE(547),
    [sym_subscript] = STATE(547),
    [sym_call] = STATE(547),
    [sym_list] = STATE(547),
    [sym_list_comprehension] = STATE(547),
    [sym_dictionary] = STATE(547),
    [sym_dictionary_comprehension] = STATE(547),
    [sym_set] = STATE(547),
    [sym_set_comprehension] = STATE(547),
    [sym_parenthesized_expression] = STATE(547),
    [sym_tuple] = STATE(547),
    [sym_generator_expression] = STATE(547),
    [sym_conditional_expression] = STATE(811),
    [sym_concatenated_string] = STATE(547),
    [sym_string] = STATE(543),
    [sym_await] = STATE(811),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_LPAREN] = ACTIONS(870),
    [anon_sym_print] = ACTIONS(872),
    [anon_sym_exec] = ACTIONS(872),
    [anon_sym_not] = ACTIONS(874),
    [anon_sym_PLUS] = ACTIONS(876),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_TILDE] = ACTIONS(876),
    [anon_sym_lambda] = ACTIONS(878),
    [anon_sym_LBRACK] = ACTIONS(880),
    [sym_ellipsis] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(884),
    [sym_integer] = ACTIONS(886),
    [sym_float] = ACTIONS(882),
    [sym_true] = ACTIONS(886),
    [sym_false] = ACTIONS(886),
    [sym_none] = ACTIONS(886),
    [anon_sym_await] = ACTIONS(888),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(890),
  },
  [330] = {
    [sym_named_expression] = STATE(821),
    [sym__expression] = STATE(821),
    [sym__primary_expression] = STATE(547),
    [sym_not_operator] = STATE(821),
    [sym_boolean_operator] = STATE(821),
    [sym_binary_operator] = STATE(547),
    [sym_unary_operator] = STATE(547),
    [sym_comparison_operator] = STATE(821),
    [sym_lambda] = STATE(821),
    [sym_attribute] = STATE(547),
    [sym_subscript] = STATE(547),
    [sym_call] = STATE(547),
    [sym_list] = STATE(547),
    [sym_list_comprehension] = STATE(547),
    [sym_dictionary] = STATE(547),
    [sym_dictionary_comprehension] = STATE(547),
    [sym_set] = STATE(547),
    [sym_set_comprehension] = STATE(547),
    [sym_parenthesized_expression] = STATE(547),
    [sym_tuple] = STATE(547),
    [sym_generator_expression] = STATE(547),
    [sym_conditional_expression] = STATE(821),
    [sym_concatenated_string] = STATE(547),
    [sym_string] = STATE(543),
    [sym_await] = STATE(821),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_LPAREN] = ACTIONS(870),
    [anon_sym_print] = ACTIONS(872),
    [anon_sym_exec] = ACTIONS(872),
    [anon_sym_not] = ACTIONS(874),
    [anon_sym_PLUS] = ACTIONS(876),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_TILDE] = ACTIONS(876),
    [anon_sym_lambda] = ACTIONS(878),
    [anon_sym_LBRACK] = ACTIONS(880),
    [sym_ellipsis] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(884),
    [sym_integer] = ACTIONS(886),
    [sym_float] = ACTIONS(882),
    [sym_true] = ACTIONS(886),
    [sym_false] = ACTIONS(886),
    [sym_none] = ACTIONS(886),
    [anon_sym_await] = ACTIONS(888),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(890),
  },
  [331] = {
    [sym_named_expression] = STATE(809),
    [sym__expression] = STATE(809),
    [sym__primary_expression] = STATE(547),
    [sym_not_operator] = STATE(809),
    [sym_boolean_operator] = STATE(809),
    [sym_binary_operator] = STATE(547),
    [sym_unary_operator] = STATE(547),
    [sym_comparison_operator] = STATE(809),
    [sym_lambda] = STATE(809),
    [sym_attribute] = STATE(547),
    [sym_subscript] = STATE(547),
    [sym_call] = STATE(547),
    [sym_list] = STATE(547),
    [sym_list_comprehension] = STATE(547),
    [sym_dictionary] = STATE(547),
    [sym_dictionary_comprehension] = STATE(547),
    [sym_set] = STATE(547),
    [sym_set_comprehension] = STATE(547),
    [sym_parenthesized_expression] = STATE(547),
    [sym_tuple] = STATE(547),
    [sym_generator_expression] = STATE(547),
    [sym_conditional_expression] = STATE(809),
    [sym_concatenated_string] = STATE(547),
    [sym_string] = STATE(543),
    [sym_await] = STATE(809),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_LPAREN] = ACTIONS(870),
    [anon_sym_print] = ACTIONS(872),
    [anon_sym_exec] = ACTIONS(872),
    [anon_sym_not] = ACTIONS(874),
    [anon_sym_PLUS] = ACTIONS(876),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_TILDE] = ACTIONS(876),
    [anon_sym_lambda] = ACTIONS(878),
    [anon_sym_LBRACK] = ACTIONS(880),
    [sym_ellipsis] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(884),
    [sym_integer] = ACTIONS(886),
    [sym_float] = ACTIONS(882),
    [sym_true] = ACTIONS(886),
    [sym_false] = ACTIONS(886),
    [sym_none] = ACTIONS(886),
    [anon_sym_await] = ACTIONS(888),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(890),
  },
  [332] = {
    [sym_named_expression] = STATE(886),
    [sym__expression] = STATE(886),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(886),
    [sym_boolean_operator] = STATE(886),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(886),
    [sym_lambda] = STATE(886),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(886),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(886),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [333] = {
    [sym_named_expression] = STATE(822),
    [sym__expression] = STATE(822),
    [sym__primary_expression] = STATE(532),
    [sym_not_operator] = STATE(822),
    [sym_boolean_operator] = STATE(822),
    [sym_binary_operator] = STATE(532),
    [sym_unary_operator] = STATE(532),
    [sym_comparison_operator] = STATE(822),
    [sym_lambda] = STATE(822),
    [sym_attribute] = STATE(532),
    [sym_subscript] = STATE(532),
    [sym_call] = STATE(532),
    [sym_list] = STATE(532),
    [sym_list_comprehension] = STATE(532),
    [sym_dictionary] = STATE(532),
    [sym_dictionary_comprehension] = STATE(532),
    [sym_set] = STATE(532),
    [sym_set_comprehension] = STATE(532),
    [sym_parenthesized_expression] = STATE(532),
    [sym_tuple] = STATE(532),
    [sym_generator_expression] = STATE(532),
    [sym_conditional_expression] = STATE(822),
    [sym_concatenated_string] = STATE(532),
    [sym_string] = STATE(530),
    [sym_await] = STATE(822),
    [sym_identifier] = ACTIONS(233),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_print] = ACTIONS(239),
    [anon_sym_exec] = ACTIONS(239),
    [anon_sym_not] = ACTIONS(536),
    [anon_sym_PLUS] = ACTIONS(243),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_TILDE] = ACTIONS(243),
    [anon_sym_lambda] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(538),
    [sym_ellipsis] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [sym_integer] = ACTIONS(251),
    [sym_float] = ACTIONS(247),
    [sym_true] = ACTIONS(251),
    [sym_false] = ACTIONS(251),
    [sym_none] = ACTIONS(251),
    [anon_sym_await] = ACTIONS(253),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(255),
  },
  [334] = {
    [sym_named_expression] = STATE(855),
    [sym__expression] = STATE(855),
    [sym__primary_expression] = STATE(532),
    [sym_not_operator] = STATE(855),
    [sym_boolean_operator] = STATE(855),
    [sym_binary_operator] = STATE(532),
    [sym_unary_operator] = STATE(532),
    [sym_comparison_operator] = STATE(855),
    [sym_lambda] = STATE(855),
    [sym_attribute] = STATE(532),
    [sym_subscript] = STATE(532),
    [sym_call] = STATE(532),
    [sym_list] = STATE(532),
    [sym_list_comprehension] = STATE(532),
    [sym_dictionary] = STATE(532),
    [sym_dictionary_comprehension] = STATE(532),
    [sym_set] = STATE(532),
    [sym_set_comprehension] = STATE(532),
    [sym_parenthesized_expression] = STATE(532),
    [sym_tuple] = STATE(532),
    [sym_generator_expression] = STATE(532),
    [sym_conditional_expression] = STATE(855),
    [sym_concatenated_string] = STATE(532),
    [sym_string] = STATE(530),
    [sym_await] = STATE(855),
    [sym_identifier] = ACTIONS(233),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_print] = ACTIONS(239),
    [anon_sym_exec] = ACTIONS(239),
    [anon_sym_not] = ACTIONS(536),
    [anon_sym_PLUS] = ACTIONS(243),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_TILDE] = ACTIONS(243),
    [anon_sym_lambda] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(538),
    [sym_ellipsis] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [sym_integer] = ACTIONS(251),
    [sym_float] = ACTIONS(247),
    [sym_true] = ACTIONS(251),
    [sym_false] = ACTIONS(251),
    [sym_none] = ACTIONS(251),
    [anon_sym_await] = ACTIONS(253),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(255),
  },
  [335] = {
    [sym_named_expression] = STATE(691),
    [sym__expression] = STATE(691),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(691),
    [sym_boolean_operator] = STATE(691),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(691),
    [sym_lambda] = STATE(691),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(691),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(691),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(349),
    [anon_sym_exec] = ACTIONS(349),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [336] = {
    [sym_identifier] = ACTIONS(928),
    [anon_sym_import] = ACTIONS(928),
    [anon_sym_from] = ACTIONS(928),
    [anon_sym_LPAREN] = ACTIONS(926),
    [anon_sym_print] = ACTIONS(928),
    [anon_sym_assert] = ACTIONS(928),
    [anon_sym_return] = ACTIONS(928),
    [anon_sym_del] = ACTIONS(928),
    [anon_sym_raise] = ACTIONS(928),
    [anon_sym_pass] = ACTIONS(928),
    [anon_sym_break] = ACTIONS(928),
    [anon_sym_continue] = ACTIONS(928),
    [anon_sym_if] = ACTIONS(928),
    [anon_sym_else] = ACTIONS(928),
    [anon_sym_async] = ACTIONS(928),
    [anon_sym_for] = ACTIONS(928),
    [anon_sym_while] = ACTIONS(928),
    [anon_sym_try] = ACTIONS(928),
    [anon_sym_except] = ACTIONS(928),
    [anon_sym_finally] = ACTIONS(928),
    [anon_sym_with] = ACTIONS(928),
    [anon_sym_def] = ACTIONS(928),
    [anon_sym_global] = ACTIONS(928),
    [anon_sym_nonlocal] = ACTIONS(928),
    [anon_sym_exec] = ACTIONS(928),
    [anon_sym_class] = ACTIONS(928),
    [anon_sym_AT] = ACTIONS(926),
    [anon_sym_not] = ACTIONS(928),
    [anon_sym_PLUS] = ACTIONS(926),
    [anon_sym_DASH] = ACTIONS(926),
    [anon_sym_TILDE] = ACTIONS(926),
    [anon_sym_lambda] = ACTIONS(928),
    [anon_sym_yield] = ACTIONS(928),
    [anon_sym_LBRACK] = ACTIONS(926),
    [sym_ellipsis] = ACTIONS(926),
    [anon_sym_LBRACE] = ACTIONS(926),
    [sym_integer] = ACTIONS(928),
    [sym_float] = ACTIONS(926),
    [sym_true] = ACTIONS(928),
    [sym_false] = ACTIONS(928),
    [sym_none] = ACTIONS(928),
    [anon_sym_await] = ACTIONS(928),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(926),
    [sym__string_start] = ACTIONS(926),
  },
  [337] = {
    [sym_named_expression] = STATE(718),
    [sym__expression] = STATE(718),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(718),
    [sym_boolean_operator] = STATE(718),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(718),
    [sym_lambda] = STATE(718),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(718),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(718),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [338] = {
    [sym_identifier] = ACTIONS(936),
    [anon_sym_import] = ACTIONS(936),
    [anon_sym_from] = ACTIONS(936),
    [anon_sym_LPAREN] = ACTIONS(934),
    [anon_sym_print] = ACTIONS(936),
    [anon_sym_assert] = ACTIONS(936),
    [anon_sym_return] = ACTIONS(936),
    [anon_sym_del] = ACTIONS(936),
    [anon_sym_raise] = ACTIONS(936),
    [anon_sym_pass] = ACTIONS(936),
    [anon_sym_break] = ACTIONS(936),
    [anon_sym_continue] = ACTIONS(936),
    [anon_sym_if] = ACTIONS(936),
    [anon_sym_else] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_for] = ACTIONS(936),
    [anon_sym_while] = ACTIONS(936),
    [anon_sym_try] = ACTIONS(936),
    [anon_sym_except] = ACTIONS(936),
    [anon_sym_finally] = ACTIONS(936),
    [anon_sym_with] = ACTIONS(936),
    [anon_sym_def] = ACTIONS(936),
    [anon_sym_global] = ACTIONS(936),
    [anon_sym_nonlocal] = ACTIONS(936),
    [anon_sym_exec] = ACTIONS(936),
    [anon_sym_class] = ACTIONS(936),
    [anon_sym_AT] = ACTIONS(934),
    [anon_sym_not] = ACTIONS(936),
    [anon_sym_PLUS] = ACTIONS(934),
    [anon_sym_DASH] = ACTIONS(934),
    [anon_sym_TILDE] = ACTIONS(934),
    [anon_sym_lambda] = ACTIONS(936),
    [anon_sym_yield] = ACTIONS(936),
    [anon_sym_LBRACK] = ACTIONS(934),
    [sym_ellipsis] = ACTIONS(934),
    [anon_sym_LBRACE] = ACTIONS(934),
    [sym_integer] = ACTIONS(936),
    [sym_float] = ACTIONS(934),
    [sym_true] = ACTIONS(936),
    [sym_false] = ACTIONS(936),
    [sym_none] = ACTIONS(936),
    [anon_sym_await] = ACTIONS(936),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(934),
    [sym__string_start] = ACTIONS(934),
  },
  [339] = {
    [sym_named_expression] = STATE(888),
    [sym__expression] = STATE(888),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(888),
    [sym_boolean_operator] = STATE(888),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(888),
    [sym_lambda] = STATE(888),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(888),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(888),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [340] = {
    [sym_named_expression] = STATE(830),
    [sym__expression] = STATE(830),
    [sym__primary_expression] = STATE(547),
    [sym_not_operator] = STATE(830),
    [sym_boolean_operator] = STATE(830),
    [sym_binary_operator] = STATE(547),
    [sym_unary_operator] = STATE(547),
    [sym_comparison_operator] = STATE(830),
    [sym_lambda] = STATE(830),
    [sym_attribute] = STATE(547),
    [sym_subscript] = STATE(547),
    [sym_call] = STATE(547),
    [sym_list] = STATE(547),
    [sym_list_comprehension] = STATE(547),
    [sym_dictionary] = STATE(547),
    [sym_dictionary_comprehension] = STATE(547),
    [sym_set] = STATE(547),
    [sym_set_comprehension] = STATE(547),
    [sym_parenthesized_expression] = STATE(547),
    [sym_tuple] = STATE(547),
    [sym_generator_expression] = STATE(547),
    [sym_conditional_expression] = STATE(830),
    [sym_concatenated_string] = STATE(547),
    [sym_string] = STATE(543),
    [sym_await] = STATE(830),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_LPAREN] = ACTIONS(870),
    [anon_sym_print] = ACTIONS(872),
    [anon_sym_exec] = ACTIONS(872),
    [anon_sym_not] = ACTIONS(874),
    [anon_sym_PLUS] = ACTIONS(876),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_TILDE] = ACTIONS(876),
    [anon_sym_lambda] = ACTIONS(878),
    [anon_sym_LBRACK] = ACTIONS(880),
    [sym_ellipsis] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(884),
    [sym_integer] = ACTIONS(886),
    [sym_float] = ACTIONS(882),
    [sym_true] = ACTIONS(886),
    [sym_false] = ACTIONS(886),
    [sym_none] = ACTIONS(886),
    [anon_sym_await] = ACTIONS(888),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(890),
  },
  [341] = {
    [sym_named_expression] = STATE(753),
    [sym__expression] = STATE(753),
    [sym__primary_expression] = STATE(532),
    [sym_not_operator] = STATE(753),
    [sym_boolean_operator] = STATE(753),
    [sym_binary_operator] = STATE(532),
    [sym_unary_operator] = STATE(532),
    [sym_comparison_operator] = STATE(753),
    [sym_lambda] = STATE(753),
    [sym_attribute] = STATE(532),
    [sym_subscript] = STATE(532),
    [sym_call] = STATE(532),
    [sym_list] = STATE(532),
    [sym_list_comprehension] = STATE(532),
    [sym_dictionary] = STATE(532),
    [sym_dictionary_comprehension] = STATE(532),
    [sym_set] = STATE(532),
    [sym_set_comprehension] = STATE(532),
    [sym_parenthesized_expression] = STATE(532),
    [sym_tuple] = STATE(532),
    [sym_generator_expression] = STATE(532),
    [sym_conditional_expression] = STATE(753),
    [sym_concatenated_string] = STATE(532),
    [sym_string] = STATE(530),
    [sym_await] = STATE(753),
    [sym_identifier] = ACTIONS(233),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_print] = ACTIONS(239),
    [anon_sym_exec] = ACTIONS(239),
    [anon_sym_not] = ACTIONS(536),
    [anon_sym_PLUS] = ACTIONS(243),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_TILDE] = ACTIONS(243),
    [anon_sym_lambda] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(538),
    [sym_ellipsis] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [sym_integer] = ACTIONS(251),
    [sym_float] = ACTIONS(247),
    [sym_true] = ACTIONS(251),
    [sym_false] = ACTIONS(251),
    [sym_none] = ACTIONS(251),
    [anon_sym_await] = ACTIONS(253),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(255),
  },
  [342] = {
    [sym_named_expression] = STATE(890),
    [sym__expression] = STATE(890),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(890),
    [sym_boolean_operator] = STATE(890),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(890),
    [sym_lambda] = STATE(890),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(890),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(890),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [343] = {
    [sym_named_expression] = STATE(819),
    [sym__expression] = STATE(819),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(819),
    [sym_boolean_operator] = STATE(819),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(819),
    [sym_lambda] = STATE(819),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(819),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(819),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [344] = {
    [sym_named_expression] = STATE(807),
    [sym__expression] = STATE(807),
    [sym__primary_expression] = STATE(532),
    [sym_not_operator] = STATE(807),
    [sym_boolean_operator] = STATE(807),
    [sym_binary_operator] = STATE(532),
    [sym_unary_operator] = STATE(532),
    [sym_comparison_operator] = STATE(807),
    [sym_lambda] = STATE(807),
    [sym_attribute] = STATE(532),
    [sym_subscript] = STATE(532),
    [sym_call] = STATE(532),
    [sym_list] = STATE(532),
    [sym_list_comprehension] = STATE(532),
    [sym_dictionary] = STATE(532),
    [sym_dictionary_comprehension] = STATE(532),
    [sym_set] = STATE(532),
    [sym_set_comprehension] = STATE(532),
    [sym_parenthesized_expression] = STATE(532),
    [sym_tuple] = STATE(532),
    [sym_generator_expression] = STATE(532),
    [sym_conditional_expression] = STATE(807),
    [sym_concatenated_string] = STATE(532),
    [sym_string] = STATE(530),
    [sym_await] = STATE(807),
    [sym_identifier] = ACTIONS(233),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_print] = ACTIONS(239),
    [anon_sym_exec] = ACTIONS(239),
    [anon_sym_not] = ACTIONS(536),
    [anon_sym_PLUS] = ACTIONS(243),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_TILDE] = ACTIONS(243),
    [anon_sym_lambda] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(538),
    [sym_ellipsis] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [sym_integer] = ACTIONS(251),
    [sym_float] = ACTIONS(247),
    [sym_true] = ACTIONS(251),
    [sym_false] = ACTIONS(251),
    [sym_none] = ACTIONS(251),
    [anon_sym_await] = ACTIONS(253),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(255),
  },
  [345] = {
    [sym_named_expression] = STATE(856),
    [sym__expression] = STATE(856),
    [sym__primary_expression] = STATE(532),
    [sym_not_operator] = STATE(856),
    [sym_boolean_operator] = STATE(856),
    [sym_binary_operator] = STATE(532),
    [sym_unary_operator] = STATE(532),
    [sym_comparison_operator] = STATE(856),
    [sym_lambda] = STATE(856),
    [sym_attribute] = STATE(532),
    [sym_subscript] = STATE(532),
    [sym_call] = STATE(532),
    [sym_list] = STATE(532),
    [sym_list_comprehension] = STATE(532),
    [sym_dictionary] = STATE(532),
    [sym_dictionary_comprehension] = STATE(532),
    [sym_set] = STATE(532),
    [sym_set_comprehension] = STATE(532),
    [sym_parenthesized_expression] = STATE(532),
    [sym_tuple] = STATE(532),
    [sym_generator_expression] = STATE(532),
    [sym_conditional_expression] = STATE(856),
    [sym_concatenated_string] = STATE(532),
    [sym_string] = STATE(530),
    [sym_await] = STATE(856),
    [sym_identifier] = ACTIONS(233),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_print] = ACTIONS(239),
    [anon_sym_exec] = ACTIONS(239),
    [anon_sym_not] = ACTIONS(536),
    [anon_sym_PLUS] = ACTIONS(243),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_TILDE] = ACTIONS(243),
    [anon_sym_lambda] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(538),
    [sym_ellipsis] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [sym_integer] = ACTIONS(251),
    [sym_float] = ACTIONS(247),
    [sym_true] = ACTIONS(251),
    [sym_false] = ACTIONS(251),
    [sym_none] = ACTIONS(251),
    [anon_sym_await] = ACTIONS(253),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(255),
  },
  [346] = {
    [sym_named_expression] = STATE(767),
    [sym__expression] = STATE(767),
    [sym__primary_expression] = STATE(532),
    [sym_not_operator] = STATE(767),
    [sym_boolean_operator] = STATE(767),
    [sym_binary_operator] = STATE(532),
    [sym_unary_operator] = STATE(532),
    [sym_comparison_operator] = STATE(767),
    [sym_lambda] = STATE(767),
    [sym_attribute] = STATE(532),
    [sym_subscript] = STATE(532),
    [sym_call] = STATE(532),
    [sym_list] = STATE(532),
    [sym_list_comprehension] = STATE(532),
    [sym_dictionary] = STATE(532),
    [sym_dictionary_comprehension] = STATE(532),
    [sym_set] = STATE(532),
    [sym_set_comprehension] = STATE(532),
    [sym_parenthesized_expression] = STATE(532),
    [sym_tuple] = STATE(532),
    [sym_generator_expression] = STATE(532),
    [sym_conditional_expression] = STATE(767),
    [sym_concatenated_string] = STATE(532),
    [sym_string] = STATE(530),
    [sym_await] = STATE(767),
    [sym_identifier] = ACTIONS(233),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_print] = ACTIONS(239),
    [anon_sym_exec] = ACTIONS(239),
    [anon_sym_not] = ACTIONS(536),
    [anon_sym_PLUS] = ACTIONS(243),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_TILDE] = ACTIONS(243),
    [anon_sym_lambda] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(538),
    [sym_ellipsis] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [sym_integer] = ACTIONS(251),
    [sym_float] = ACTIONS(247),
    [sym_true] = ACTIONS(251),
    [sym_false] = ACTIONS(251),
    [sym_none] = ACTIONS(251),
    [anon_sym_await] = ACTIONS(253),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(255),
  },
  [347] = {
    [sym_named_expression] = STATE(766),
    [sym__expression] = STATE(766),
    [sym__primary_expression] = STATE(532),
    [sym_not_operator] = STATE(766),
    [sym_boolean_operator] = STATE(766),
    [sym_binary_operator] = STATE(532),
    [sym_unary_operator] = STATE(532),
    [sym_comparison_operator] = STATE(766),
    [sym_lambda] = STATE(766),
    [sym_attribute] = STATE(532),
    [sym_subscript] = STATE(532),
    [sym_call] = STATE(532),
    [sym_list] = STATE(532),
    [sym_list_comprehension] = STATE(532),
    [sym_dictionary] = STATE(532),
    [sym_dictionary_comprehension] = STATE(532),
    [sym_set] = STATE(532),
    [sym_set_comprehension] = STATE(532),
    [sym_parenthesized_expression] = STATE(532),
    [sym_tuple] = STATE(532),
    [sym_generator_expression] = STATE(532),
    [sym_conditional_expression] = STATE(766),
    [sym_concatenated_string] = STATE(532),
    [sym_string] = STATE(530),
    [sym_await] = STATE(766),
    [sym_identifier] = ACTIONS(233),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_print] = ACTIONS(239),
    [anon_sym_exec] = ACTIONS(239),
    [anon_sym_not] = ACTIONS(536),
    [anon_sym_PLUS] = ACTIONS(243),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_TILDE] = ACTIONS(243),
    [anon_sym_lambda] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(538),
    [sym_ellipsis] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [sym_integer] = ACTIONS(251),
    [sym_float] = ACTIONS(247),
    [sym_true] = ACTIONS(251),
    [sym_false] = ACTIONS(251),
    [sym_none] = ACTIONS(251),
    [anon_sym_await] = ACTIONS(253),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(255),
  },
  [348] = {
    [sym_named_expression] = STATE(848),
    [sym__expression] = STATE(848),
    [sym__primary_expression] = STATE(532),
    [sym_not_operator] = STATE(848),
    [sym_boolean_operator] = STATE(848),
    [sym_binary_operator] = STATE(532),
    [sym_unary_operator] = STATE(532),
    [sym_comparison_operator] = STATE(848),
    [sym_lambda] = STATE(848),
    [sym_attribute] = STATE(532),
    [sym_subscript] = STATE(532),
    [sym_call] = STATE(532),
    [sym_list] = STATE(532),
    [sym_list_comprehension] = STATE(532),
    [sym_dictionary] = STATE(532),
    [sym_dictionary_comprehension] = STATE(532),
    [sym_set] = STATE(532),
    [sym_set_comprehension] = STATE(532),
    [sym_parenthesized_expression] = STATE(532),
    [sym_tuple] = STATE(532),
    [sym_generator_expression] = STATE(532),
    [sym_conditional_expression] = STATE(848),
    [sym_concatenated_string] = STATE(532),
    [sym_string] = STATE(530),
    [sym_await] = STATE(848),
    [sym_identifier] = ACTIONS(233),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_print] = ACTIONS(239),
    [anon_sym_exec] = ACTIONS(239),
    [anon_sym_not] = ACTIONS(536),
    [anon_sym_PLUS] = ACTIONS(243),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_TILDE] = ACTIONS(243),
    [anon_sym_lambda] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(538),
    [sym_ellipsis] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [sym_integer] = ACTIONS(251),
    [sym_float] = ACTIONS(247),
    [sym_true] = ACTIONS(251),
    [sym_false] = ACTIONS(251),
    [sym_none] = ACTIONS(251),
    [anon_sym_await] = ACTIONS(253),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(255),
  },
  [349] = {
    [ts_builtin_sym_end] = ACTIONS(942),
    [sym_identifier] = ACTIONS(944),
    [anon_sym_import] = ACTIONS(944),
    [anon_sym_from] = ACTIONS(944),
    [anon_sym_LPAREN] = ACTIONS(942),
    [anon_sym_print] = ACTIONS(944),
    [anon_sym_assert] = ACTIONS(944),
    [anon_sym_return] = ACTIONS(944),
    [anon_sym_del] = ACTIONS(944),
    [anon_sym_raise] = ACTIONS(944),
    [anon_sym_pass] = ACTIONS(944),
    [anon_sym_break] = ACTIONS(944),
    [anon_sym_continue] = ACTIONS(944),
    [anon_sym_if] = ACTIONS(944),
    [anon_sym_else] = ACTIONS(944),
    [anon_sym_async] = ACTIONS(944),
    [anon_sym_for] = ACTIONS(944),
    [anon_sym_while] = ACTIONS(944),
    [anon_sym_try] = ACTIONS(944),
    [anon_sym_except] = ACTIONS(944),
    [anon_sym_finally] = ACTIONS(944),
    [anon_sym_with] = ACTIONS(944),
    [anon_sym_def] = ACTIONS(944),
    [anon_sym_global] = ACTIONS(944),
    [anon_sym_nonlocal] = ACTIONS(944),
    [anon_sym_exec] = ACTIONS(944),
    [anon_sym_class] = ACTIONS(944),
    [anon_sym_AT] = ACTIONS(942),
    [anon_sym_not] = ACTIONS(944),
    [anon_sym_PLUS] = ACTIONS(942),
    [anon_sym_DASH] = ACTIONS(942),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_lambda] = ACTIONS(944),
    [anon_sym_yield] = ACTIONS(944),
    [anon_sym_LBRACK] = ACTIONS(942),
    [sym_ellipsis] = ACTIONS(942),
    [anon_sym_LBRACE] = ACTIONS(942),
    [sym_integer] = ACTIONS(944),
    [sym_float] = ACTIONS(942),
    [sym_true] = ACTIONS(944),
    [sym_false] = ACTIONS(944),
    [sym_none] = ACTIONS(944),
    [anon_sym_await] = ACTIONS(944),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(942),
  },
  [350] = {
    [sym_named_expression] = STATE(840),
    [sym__expression] = STATE(840),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(840),
    [sym_boolean_operator] = STATE(840),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(840),
    [sym_lambda] = STATE(840),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(840),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(840),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [351] = {
    [ts_builtin_sym_end] = ACTIONS(946),
    [sym_identifier] = ACTIONS(948),
    [anon_sym_import] = ACTIONS(948),
    [anon_sym_from] = ACTIONS(948),
    [anon_sym_LPAREN] = ACTIONS(946),
    [anon_sym_print] = ACTIONS(948),
    [anon_sym_assert] = ACTIONS(948),
    [anon_sym_return] = ACTIONS(948),
    [anon_sym_del] = ACTIONS(948),
    [anon_sym_raise] = ACTIONS(948),
    [anon_sym_pass] = ACTIONS(948),
    [anon_sym_break] = ACTIONS(948),
    [anon_sym_continue] = ACTIONS(948),
    [anon_sym_if] = ACTIONS(948),
    [anon_sym_else] = ACTIONS(948),
    [anon_sym_async] = ACTIONS(948),
    [anon_sym_for] = ACTIONS(948),
    [anon_sym_while] = ACTIONS(948),
    [anon_sym_try] = ACTIONS(948),
    [anon_sym_except] = ACTIONS(948),
    [anon_sym_finally] = ACTIONS(948),
    [anon_sym_with] = ACTIONS(948),
    [anon_sym_def] = ACTIONS(948),
    [anon_sym_global] = ACTIONS(948),
    [anon_sym_nonlocal] = ACTIONS(948),
    [anon_sym_exec] = ACTIONS(948),
    [anon_sym_class] = ACTIONS(948),
    [anon_sym_AT] = ACTIONS(946),
    [anon_sym_not] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(946),
    [anon_sym_DASH] = ACTIONS(946),
    [anon_sym_TILDE] = ACTIONS(946),
    [anon_sym_lambda] = ACTIONS(948),
    [anon_sym_yield] = ACTIONS(948),
    [anon_sym_LBRACK] = ACTIONS(946),
    [sym_ellipsis] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(946),
    [sym_integer] = ACTIONS(948),
    [sym_float] = ACTIONS(946),
    [sym_true] = ACTIONS(948),
    [sym_false] = ACTIONS(948),
    [sym_none] = ACTIONS(948),
    [anon_sym_await] = ACTIONS(948),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(946),
  },
  [352] = {
    [sym_named_expression] = STATE(810),
    [sym__expression] = STATE(810),
    [sym__primary_expression] = STATE(547),
    [sym_not_operator] = STATE(810),
    [sym_boolean_operator] = STATE(810),
    [sym_binary_operator] = STATE(547),
    [sym_unary_operator] = STATE(547),
    [sym_comparison_operator] = STATE(810),
    [sym_lambda] = STATE(810),
    [sym_attribute] = STATE(547),
    [sym_subscript] = STATE(547),
    [sym_call] = STATE(547),
    [sym_list] = STATE(547),
    [sym_list_comprehension] = STATE(547),
    [sym_dictionary] = STATE(547),
    [sym_dictionary_comprehension] = STATE(547),
    [sym_set] = STATE(547),
    [sym_set_comprehension] = STATE(547),
    [sym_parenthesized_expression] = STATE(547),
    [sym_tuple] = STATE(547),
    [sym_generator_expression] = STATE(547),
    [sym_conditional_expression] = STATE(810),
    [sym_concatenated_string] = STATE(547),
    [sym_string] = STATE(543),
    [sym_await] = STATE(810),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_LPAREN] = ACTIONS(870),
    [anon_sym_print] = ACTIONS(872),
    [anon_sym_exec] = ACTIONS(872),
    [anon_sym_not] = ACTIONS(874),
    [anon_sym_PLUS] = ACTIONS(876),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_TILDE] = ACTIONS(876),
    [anon_sym_lambda] = ACTIONS(878),
    [anon_sym_LBRACK] = ACTIONS(880),
    [sym_ellipsis] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(884),
    [sym_integer] = ACTIONS(886),
    [sym_float] = ACTIONS(882),
    [sym_true] = ACTIONS(886),
    [sym_false] = ACTIONS(886),
    [sym_none] = ACTIONS(886),
    [anon_sym_await] = ACTIONS(888),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(890),
  },
  [353] = {
    [ts_builtin_sym_end] = ACTIONS(932),
    [sym_identifier] = ACTIONS(930),
    [anon_sym_import] = ACTIONS(930),
    [anon_sym_from] = ACTIONS(930),
    [anon_sym_LPAREN] = ACTIONS(932),
    [anon_sym_print] = ACTIONS(930),
    [anon_sym_assert] = ACTIONS(930),
    [anon_sym_return] = ACTIONS(930),
    [anon_sym_del] = ACTIONS(930),
    [anon_sym_raise] = ACTIONS(930),
    [anon_sym_pass] = ACTIONS(930),
    [anon_sym_break] = ACTIONS(930),
    [anon_sym_continue] = ACTIONS(930),
    [anon_sym_if] = ACTIONS(930),
    [anon_sym_else] = ACTIONS(930),
    [anon_sym_async] = ACTIONS(930),
    [anon_sym_for] = ACTIONS(930),
    [anon_sym_while] = ACTIONS(930),
    [anon_sym_try] = ACTIONS(930),
    [anon_sym_except] = ACTIONS(930),
    [anon_sym_finally] = ACTIONS(930),
    [anon_sym_with] = ACTIONS(930),
    [anon_sym_def] = ACTIONS(930),
    [anon_sym_global] = ACTIONS(930),
    [anon_sym_nonlocal] = ACTIONS(930),
    [anon_sym_exec] = ACTIONS(930),
    [anon_sym_class] = ACTIONS(930),
    [anon_sym_AT] = ACTIONS(932),
    [anon_sym_not] = ACTIONS(930),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(932),
    [anon_sym_lambda] = ACTIONS(930),
    [anon_sym_yield] = ACTIONS(930),
    [anon_sym_LBRACK] = ACTIONS(932),
    [sym_ellipsis] = ACTIONS(932),
    [anon_sym_LBRACE] = ACTIONS(932),
    [sym_integer] = ACTIONS(930),
    [sym_float] = ACTIONS(932),
    [sym_true] = ACTIONS(930),
    [sym_false] = ACTIONS(930),
    [sym_none] = ACTIONS(930),
    [anon_sym_await] = ACTIONS(930),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
  },
  [354] = {
    [sym_named_expression] = STATE(712),
    [sym__expression] = STATE(712),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(712),
    [sym_boolean_operator] = STATE(712),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(712),
    [sym_lambda] = STATE(712),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(712),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(712),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [355] = {
    [sym_named_expression] = STATE(776),
    [sym__expression] = STATE(776),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(776),
    [sym_boolean_operator] = STATE(776),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(776),
    [sym_lambda] = STATE(776),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(776),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(776),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [356] = {
    [sym_identifier] = ACTIONS(944),
    [anon_sym_import] = ACTIONS(944),
    [anon_sym_from] = ACTIONS(944),
    [anon_sym_LPAREN] = ACTIONS(942),
    [anon_sym_print] = ACTIONS(944),
    [anon_sym_assert] = ACTIONS(944),
    [anon_sym_return] = ACTIONS(944),
    [anon_sym_del] = ACTIONS(944),
    [anon_sym_raise] = ACTIONS(944),
    [anon_sym_pass] = ACTIONS(944),
    [anon_sym_break] = ACTIONS(944),
    [anon_sym_continue] = ACTIONS(944),
    [anon_sym_if] = ACTIONS(944),
    [anon_sym_else] = ACTIONS(944),
    [anon_sym_async] = ACTIONS(944),
    [anon_sym_for] = ACTIONS(944),
    [anon_sym_while] = ACTIONS(944),
    [anon_sym_try] = ACTIONS(944),
    [anon_sym_except] = ACTIONS(944),
    [anon_sym_finally] = ACTIONS(944),
    [anon_sym_with] = ACTIONS(944),
    [anon_sym_def] = ACTIONS(944),
    [anon_sym_global] = ACTIONS(944),
    [anon_sym_nonlocal] = ACTIONS(944),
    [anon_sym_exec] = ACTIONS(944),
    [anon_sym_class] = ACTIONS(944),
    [anon_sym_AT] = ACTIONS(942),
    [anon_sym_not] = ACTIONS(944),
    [anon_sym_PLUS] = ACTIONS(942),
    [anon_sym_DASH] = ACTIONS(942),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_lambda] = ACTIONS(944),
    [anon_sym_yield] = ACTIONS(944),
    [anon_sym_LBRACK] = ACTIONS(942),
    [sym_ellipsis] = ACTIONS(942),
    [anon_sym_LBRACE] = ACTIONS(942),
    [sym_integer] = ACTIONS(944),
    [sym_float] = ACTIONS(942),
    [sym_true] = ACTIONS(944),
    [sym_false] = ACTIONS(944),
    [sym_none] = ACTIONS(944),
    [anon_sym_await] = ACTIONS(944),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(942),
    [sym__string_start] = ACTIONS(942),
  },
  [357] = {
    [sym_named_expression] = STATE(789),
    [sym__expression] = STATE(789),
    [sym__primary_expression] = STATE(532),
    [sym_not_operator] = STATE(789),
    [sym_boolean_operator] = STATE(789),
    [sym_binary_operator] = STATE(532),
    [sym_unary_operator] = STATE(532),
    [sym_comparison_operator] = STATE(789),
    [sym_lambda] = STATE(789),
    [sym_attribute] = STATE(532),
    [sym_subscript] = STATE(532),
    [sym_call] = STATE(532),
    [sym_list] = STATE(532),
    [sym_list_comprehension] = STATE(532),
    [sym_dictionary] = STATE(532),
    [sym_dictionary_comprehension] = STATE(532),
    [sym_set] = STATE(532),
    [sym_set_comprehension] = STATE(532),
    [sym_parenthesized_expression] = STATE(532),
    [sym_tuple] = STATE(532),
    [sym_generator_expression] = STATE(532),
    [sym_conditional_expression] = STATE(789),
    [sym_concatenated_string] = STATE(532),
    [sym_string] = STATE(530),
    [sym_await] = STATE(789),
    [sym_identifier] = ACTIONS(233),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_print] = ACTIONS(239),
    [anon_sym_exec] = ACTIONS(239),
    [anon_sym_not] = ACTIONS(536),
    [anon_sym_PLUS] = ACTIONS(243),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_TILDE] = ACTIONS(243),
    [anon_sym_lambda] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(538),
    [sym_ellipsis] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [sym_integer] = ACTIONS(251),
    [sym_float] = ACTIONS(247),
    [sym_true] = ACTIONS(251),
    [sym_false] = ACTIONS(251),
    [sym_none] = ACTIONS(251),
    [anon_sym_await] = ACTIONS(253),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(255),
  },
  [358] = {
    [sym_named_expression] = STATE(686),
    [sym__expression] = STATE(686),
    [sym__primary_expression] = STATE(532),
    [sym_not_operator] = STATE(686),
    [sym_boolean_operator] = STATE(686),
    [sym_binary_operator] = STATE(532),
    [sym_unary_operator] = STATE(532),
    [sym_comparison_operator] = STATE(686),
    [sym_lambda] = STATE(686),
    [sym_attribute] = STATE(532),
    [sym_subscript] = STATE(532),
    [sym_call] = STATE(532),
    [sym_list] = STATE(532),
    [sym_list_comprehension] = STATE(532),
    [sym_dictionary] = STATE(532),
    [sym_dictionary_comprehension] = STATE(532),
    [sym_set] = STATE(532),
    [sym_set_comprehension] = STATE(532),
    [sym_parenthesized_expression] = STATE(532),
    [sym_tuple] = STATE(532),
    [sym_generator_expression] = STATE(532),
    [sym_conditional_expression] = STATE(686),
    [sym_concatenated_string] = STATE(532),
    [sym_string] = STATE(530),
    [sym_await] = STATE(686),
    [sym_identifier] = ACTIONS(233),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_print] = ACTIONS(239),
    [anon_sym_exec] = ACTIONS(239),
    [anon_sym_not] = ACTIONS(536),
    [anon_sym_PLUS] = ACTIONS(243),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_TILDE] = ACTIONS(243),
    [anon_sym_lambda] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(538),
    [sym_ellipsis] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [sym_integer] = ACTIONS(251),
    [sym_float] = ACTIONS(247),
    [sym_true] = ACTIONS(251),
    [sym_false] = ACTIONS(251),
    [sym_none] = ACTIONS(251),
    [anon_sym_await] = ACTIONS(253),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(255),
  },
  [359] = {
    [sym_named_expression] = STATE(764),
    [sym__expression] = STATE(764),
    [sym__primary_expression] = STATE(532),
    [sym_not_operator] = STATE(764),
    [sym_boolean_operator] = STATE(764),
    [sym_binary_operator] = STATE(532),
    [sym_unary_operator] = STATE(532),
    [sym_comparison_operator] = STATE(764),
    [sym_lambda] = STATE(764),
    [sym_attribute] = STATE(532),
    [sym_subscript] = STATE(532),
    [sym_call] = STATE(532),
    [sym_list] = STATE(532),
    [sym_list_comprehension] = STATE(532),
    [sym_dictionary] = STATE(532),
    [sym_dictionary_comprehension] = STATE(532),
    [sym_set] = STATE(532),
    [sym_set_comprehension] = STATE(532),
    [sym_parenthesized_expression] = STATE(532),
    [sym_tuple] = STATE(532),
    [sym_generator_expression] = STATE(532),
    [sym_conditional_expression] = STATE(764),
    [sym_concatenated_string] = STATE(532),
    [sym_string] = STATE(530),
    [sym_await] = STATE(764),
    [sym_identifier] = ACTIONS(233),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_print] = ACTIONS(239),
    [anon_sym_exec] = ACTIONS(239),
    [anon_sym_not] = ACTIONS(536),
    [anon_sym_PLUS] = ACTIONS(243),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_TILDE] = ACTIONS(243),
    [anon_sym_lambda] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(538),
    [sym_ellipsis] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [sym_integer] = ACTIONS(251),
    [sym_float] = ACTIONS(247),
    [sym_true] = ACTIONS(251),
    [sym_false] = ACTIONS(251),
    [sym_none] = ACTIONS(251),
    [anon_sym_await] = ACTIONS(253),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(255),
  },
  [360] = {
    [sym_named_expression] = STATE(711),
    [sym__expression] = STATE(711),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(711),
    [sym_boolean_operator] = STATE(711),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(711),
    [sym_lambda] = STATE(711),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(711),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(711),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [361] = {
    [sym_named_expression] = STATE(844),
    [sym__expression] = STATE(844),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(844),
    [sym_boolean_operator] = STATE(844),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(844),
    [sym_lambda] = STATE(844),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(844),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(844),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [362] = {
    [sym_named_expression] = STATE(770),
    [sym__expression] = STATE(770),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(770),
    [sym_boolean_operator] = STATE(770),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(770),
    [sym_lambda] = STATE(770),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(770),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(770),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [363] = {
    [sym_named_expression] = STATE(719),
    [sym__expression] = STATE(719),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(719),
    [sym_boolean_operator] = STATE(719),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(719),
    [sym_lambda] = STATE(719),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(719),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(719),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [364] = {
    [sym_named_expression] = STATE(889),
    [sym__expression] = STATE(889),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(889),
    [sym_boolean_operator] = STATE(889),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(889),
    [sym_lambda] = STATE(889),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(889),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(889),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [365] = {
    [sym_named_expression] = STATE(692),
    [sym__expression] = STATE(692),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(692),
    [sym_boolean_operator] = STATE(692),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(692),
    [sym_lambda] = STATE(692),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(692),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(692),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(349),
    [anon_sym_exec] = ACTIONS(349),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [366] = {
    [sym_named_expression] = STATE(832),
    [sym__expression] = STATE(832),
    [sym__primary_expression] = STATE(547),
    [sym_not_operator] = STATE(832),
    [sym_boolean_operator] = STATE(832),
    [sym_binary_operator] = STATE(547),
    [sym_unary_operator] = STATE(547),
    [sym_comparison_operator] = STATE(832),
    [sym_lambda] = STATE(832),
    [sym_attribute] = STATE(547),
    [sym_subscript] = STATE(547),
    [sym_call] = STATE(547),
    [sym_list] = STATE(547),
    [sym_list_comprehension] = STATE(547),
    [sym_dictionary] = STATE(547),
    [sym_dictionary_comprehension] = STATE(547),
    [sym_set] = STATE(547),
    [sym_set_comprehension] = STATE(547),
    [sym_parenthesized_expression] = STATE(547),
    [sym_tuple] = STATE(547),
    [sym_generator_expression] = STATE(547),
    [sym_conditional_expression] = STATE(832),
    [sym_concatenated_string] = STATE(547),
    [sym_string] = STATE(543),
    [sym_await] = STATE(832),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_LPAREN] = ACTIONS(870),
    [anon_sym_print] = ACTIONS(872),
    [anon_sym_exec] = ACTIONS(872),
    [anon_sym_not] = ACTIONS(874),
    [anon_sym_PLUS] = ACTIONS(876),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_TILDE] = ACTIONS(876),
    [anon_sym_lambda] = ACTIONS(878),
    [anon_sym_LBRACK] = ACTIONS(880),
    [sym_ellipsis] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(884),
    [sym_integer] = ACTIONS(886),
    [sym_float] = ACTIONS(882),
    [sym_true] = ACTIONS(886),
    [sym_false] = ACTIONS(886),
    [sym_none] = ACTIONS(886),
    [anon_sym_await] = ACTIONS(888),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(890),
  },
  [367] = {
    [sym_named_expression] = STATE(862),
    [sym__expression] = STATE(862),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(862),
    [sym_boolean_operator] = STATE(862),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(862),
    [sym_lambda] = STATE(862),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(862),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(862),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [368] = {
    [sym_named_expression] = STATE(861),
    [sym__expression] = STATE(861),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(861),
    [sym_boolean_operator] = STATE(861),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(861),
    [sym_lambda] = STATE(861),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(861),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(861),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [369] = {
    [sym_named_expression] = STATE(714),
    [sym__expression] = STATE(714),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(714),
    [sym_boolean_operator] = STATE(714),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(714),
    [sym_lambda] = STATE(714),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(714),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(714),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [370] = {
    [sym_identifier] = ACTIONS(948),
    [anon_sym_import] = ACTIONS(948),
    [anon_sym_from] = ACTIONS(948),
    [anon_sym_LPAREN] = ACTIONS(946),
    [anon_sym_print] = ACTIONS(948),
    [anon_sym_assert] = ACTIONS(948),
    [anon_sym_return] = ACTIONS(948),
    [anon_sym_del] = ACTIONS(948),
    [anon_sym_raise] = ACTIONS(948),
    [anon_sym_pass] = ACTIONS(948),
    [anon_sym_break] = ACTIONS(948),
    [anon_sym_continue] = ACTIONS(948),
    [anon_sym_if] = ACTIONS(948),
    [anon_sym_else] = ACTIONS(948),
    [anon_sym_async] = ACTIONS(948),
    [anon_sym_for] = ACTIONS(948),
    [anon_sym_while] = ACTIONS(948),
    [anon_sym_try] = ACTIONS(948),
    [anon_sym_except] = ACTIONS(948),
    [anon_sym_finally] = ACTIONS(948),
    [anon_sym_with] = ACTIONS(948),
    [anon_sym_def] = ACTIONS(948),
    [anon_sym_global] = ACTIONS(948),
    [anon_sym_nonlocal] = ACTIONS(948),
    [anon_sym_exec] = ACTIONS(948),
    [anon_sym_class] = ACTIONS(948),
    [anon_sym_AT] = ACTIONS(946),
    [anon_sym_not] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(946),
    [anon_sym_DASH] = ACTIONS(946),
    [anon_sym_TILDE] = ACTIONS(946),
    [anon_sym_lambda] = ACTIONS(948),
    [anon_sym_yield] = ACTIONS(948),
    [anon_sym_LBRACK] = ACTIONS(946),
    [sym_ellipsis] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(946),
    [sym_integer] = ACTIONS(948),
    [sym_float] = ACTIONS(946),
    [sym_true] = ACTIONS(948),
    [sym_false] = ACTIONS(948),
    [sym_none] = ACTIONS(948),
    [anon_sym_await] = ACTIONS(948),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(946),
    [sym__string_start] = ACTIONS(946),
  },
  [371] = {
    [sym_named_expression] = STATE(870),
    [sym__expression] = STATE(870),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(870),
    [sym_boolean_operator] = STATE(870),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(870),
    [sym_lambda] = STATE(870),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(870),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(870),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [372] = {
    [sym_named_expression] = STATE(690),
    [sym__expression] = STATE(690),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(690),
    [sym_boolean_operator] = STATE(690),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(690),
    [sym_lambda] = STATE(690),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(690),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(690),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(349),
    [anon_sym_exec] = ACTIONS(349),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [373] = {
    [sym_named_expression] = STATE(717),
    [sym__expression] = STATE(717),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(717),
    [sym_boolean_operator] = STATE(717),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(717),
    [sym_lambda] = STATE(717),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(717),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(717),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [374] = {
    [sym_named_expression] = STATE(812),
    [sym__expression] = STATE(812),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(812),
    [sym_boolean_operator] = STATE(812),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(812),
    [sym_lambda] = STATE(812),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(812),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(812),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [375] = {
    [sym_named_expression] = STATE(713),
    [sym__expression] = STATE(713),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(713),
    [sym_boolean_operator] = STATE(713),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(713),
    [sym_lambda] = STATE(713),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(713),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(713),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [376] = {
    [sym_named_expression] = STATE(818),
    [sym__expression] = STATE(818),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(818),
    [sym_boolean_operator] = STATE(818),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(818),
    [sym_lambda] = STATE(818),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(818),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(818),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [377] = {
    [sym_named_expression] = STATE(831),
    [sym__expression] = STATE(831),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(831),
    [sym_boolean_operator] = STATE(831),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(831),
    [sym_lambda] = STATE(831),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(831),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(831),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [378] = {
    [sym_named_expression] = STATE(894),
    [sym__expression] = STATE(894),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(894),
    [sym_boolean_operator] = STATE(894),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(894),
    [sym_lambda] = STATE(894),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(894),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(894),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [379] = {
    [sym_named_expression] = STATE(786),
    [sym__expression] = STATE(786),
    [sym__primary_expression] = STATE(405),
    [sym_not_operator] = STATE(786),
    [sym_boolean_operator] = STATE(786),
    [sym_binary_operator] = STATE(405),
    [sym_unary_operator] = STATE(405),
    [sym_comparison_operator] = STATE(786),
    [sym_lambda] = STATE(786),
    [sym_attribute] = STATE(405),
    [sym_subscript] = STATE(405),
    [sym_call] = STATE(405),
    [sym_list] = STATE(405),
    [sym_list_comprehension] = STATE(405),
    [sym_dictionary] = STATE(405),
    [sym_dictionary_comprehension] = STATE(405),
    [sym_set] = STATE(405),
    [sym_set_comprehension] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_generator_expression] = STATE(405),
    [sym_conditional_expression] = STATE(786),
    [sym_concatenated_string] = STATE(405),
    [sym_string] = STATE(403),
    [sym_await] = STATE(786),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_lambda] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(383),
    [sym_float] = ACTIONS(379),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_none] = ACTIONS(383),
    [anon_sym_await] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [380] = {
    [sym_named_expression] = STATE(693),
    [sym__expression] = STATE(693),
    [sym__primary_expression] = STATE(120),
    [sym_not_operator] = STATE(693),
    [sym_boolean_operator] = STATE(693),
    [sym_binary_operator] = STATE(120),
    [sym_unary_operator] = STATE(120),
    [sym_comparison_operator] = STATE(693),
    [sym_lambda] = STATE(693),
    [sym_attribute] = STATE(120),
    [sym_subscript] = STATE(120),
    [sym_call] = STATE(120),
    [sym_list] = STATE(120),
    [sym_list_comprehension] = STATE(120),
    [sym_dictionary] = STATE(120),
    [sym_dictionary_comprehension] = STATE(120),
    [sym_set] = STATE(120),
    [sym_set_comprehension] = STATE(120),
    [sym_parenthesized_expression] = STATE(120),
    [sym_tuple] = STATE(120),
    [sym_generator_expression] = STATE(120),
    [sym_conditional_expression] = STATE(693),
    [sym_concatenated_string] = STATE(120),
    [sym_string] = STATE(113),
    [sym_await] = STATE(693),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(349),
    [anon_sym_exec] = ACTIONS(349),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [381] = {
    [sym_finally_clause] = STATE(490),
    [ts_builtin_sym_end] = ACTIONS(950),
    [sym_identifier] = ACTIONS(952),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_from] = ACTIONS(952),
    [anon_sym_LPAREN] = ACTIONS(950),
    [anon_sym_print] = ACTIONS(952),
    [anon_sym_assert] = ACTIONS(952),
    [anon_sym_return] = ACTIONS(952),
    [anon_sym_del] = ACTIONS(952),
    [anon_sym_raise] = ACTIONS(952),
    [anon_sym_pass] = ACTIONS(952),
    [anon_sym_break] = ACTIONS(952),
    [anon_sym_continue] = ACTIONS(952),
    [anon_sym_if] = ACTIONS(952),
    [anon_sym_async] = ACTIONS(952),
    [anon_sym_for] = ACTIONS(952),
    [anon_sym_while] = ACTIONS(952),
    [anon_sym_try] = ACTIONS(952),
    [anon_sym_finally] = ACTIONS(594),
    [anon_sym_with] = ACTIONS(952),
    [anon_sym_def] = ACTIONS(952),
    [anon_sym_global] = ACTIONS(952),
    [anon_sym_nonlocal] = ACTIONS(952),
    [anon_sym_exec] = ACTIONS(952),
    [anon_sym_class] = ACTIONS(952),
    [anon_sym_AT] = ACTIONS(950),
    [anon_sym_not] = ACTIONS(952),
    [anon_sym_PLUS] = ACTIONS(950),
    [anon_sym_DASH] = ACTIONS(950),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_lambda] = ACTIONS(952),
    [anon_sym_yield] = ACTIONS(952),
    [anon_sym_LBRACK] = ACTIONS(950),
    [sym_ellipsis] = ACTIONS(950),
    [anon_sym_LBRACE] = ACTIONS(950),
    [sym_integer] = ACTIONS(952),
    [sym_float] = ACTIONS(950),
    [sym_true] = ACTIONS(952),
    [sym_false] = ACTIONS(952),
    [sym_none] = ACTIONS(952),
    [anon_sym_await] = ACTIONS(952),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(950),
  },
  [382] = {
    [sym_else_clause] = STATE(491),
    [sym_identifier] = ACTIONS(954),
    [anon_sym_import] = ACTIONS(954),
    [anon_sym_from] = ACTIONS(954),
    [anon_sym_LPAREN] = ACTIONS(956),
    [anon_sym_print] = ACTIONS(954),
    [anon_sym_assert] = ACTIONS(954),
    [anon_sym_return] = ACTIONS(954),
    [anon_sym_del] = ACTIONS(954),
    [anon_sym_raise] = ACTIONS(954),
    [anon_sym_pass] = ACTIONS(954),
    [anon_sym_break] = ACTIONS(954),
    [anon_sym_continue] = ACTIONS(954),
    [anon_sym_if] = ACTIONS(954),
    [anon_sym_else] = ACTIONS(568),
    [anon_sym_async] = ACTIONS(954),
    [anon_sym_for] = ACTIONS(954),
    [anon_sym_while] = ACTIONS(954),
    [anon_sym_try] = ACTIONS(954),
    [anon_sym_with] = ACTIONS(954),
    [anon_sym_def] = ACTIONS(954),
    [anon_sym_global] = ACTIONS(954),
    [anon_sym_nonlocal] = ACTIONS(954),
    [anon_sym_exec] = ACTIONS(954),
    [anon_sym_class] = ACTIONS(954),
    [anon_sym_AT] = ACTIONS(956),
    [anon_sym_not] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_TILDE] = ACTIONS(956),
    [anon_sym_lambda] = ACTIONS(954),
    [anon_sym_yield] = ACTIONS(954),
    [anon_sym_LBRACK] = ACTIONS(956),
    [sym_ellipsis] = ACTIONS(956),
    [anon_sym_LBRACE] = ACTIONS(956),
    [sym_integer] = ACTIONS(954),
    [sym_float] = ACTIONS(956),
    [sym_true] = ACTIONS(954),
    [sym_false] = ACTIONS(954),
    [sym_none] = ACTIONS(954),
    [anon_sym_await] = ACTIONS(954),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(956),
    [sym__string_start] = ACTIONS(956),
  },
  [383] = {
    [sym_else_clause] = STATE(442),
    [sym_identifier] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(958),
    [anon_sym_from] = ACTIONS(958),
    [anon_sym_LPAREN] = ACTIONS(960),
    [anon_sym_print] = ACTIONS(958),
    [anon_sym_assert] = ACTIONS(958),
    [anon_sym_return] = ACTIONS(958),
    [anon_sym_del] = ACTIONS(958),
    [anon_sym_raise] = ACTIONS(958),
    [anon_sym_pass] = ACTIONS(958),
    [anon_sym_break] = ACTIONS(958),
    [anon_sym_continue] = ACTIONS(958),
    [anon_sym_if] = ACTIONS(958),
    [anon_sym_else] = ACTIONS(568),
    [anon_sym_async] = ACTIONS(958),
    [anon_sym_for] = ACTIONS(958),
    [anon_sym_while] = ACTIONS(958),
    [anon_sym_try] = ACTIONS(958),
    [anon_sym_with] = ACTIONS(958),
    [anon_sym_def] = ACTIONS(958),
    [anon_sym_global] = ACTIONS(958),
    [anon_sym_nonlocal] = ACTIONS(958),
    [anon_sym_exec] = ACTIONS(958),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_AT] = ACTIONS(960),
    [anon_sym_not] = ACTIONS(958),
    [anon_sym_PLUS] = ACTIONS(960),
    [anon_sym_DASH] = ACTIONS(960),
    [anon_sym_TILDE] = ACTIONS(960),
    [anon_sym_lambda] = ACTIONS(958),
    [anon_sym_yield] = ACTIONS(958),
    [anon_sym_LBRACK] = ACTIONS(960),
    [sym_ellipsis] = ACTIONS(960),
    [anon_sym_LBRACE] = ACTIONS(960),
    [sym_integer] = ACTIONS(958),
    [sym_float] = ACTIONS(960),
    [sym_true] = ACTIONS(958),
    [sym_false] = ACTIONS(958),
    [sym_none] = ACTIONS(958),
    [anon_sym_await] = ACTIONS(958),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(960),
    [sym__string_start] = ACTIONS(960),
  },
  [384] = {
    [sym_else_clause] = STATE(446),
    [sym_identifier] = ACTIONS(962),
    [anon_sym_import] = ACTIONS(962),
    [anon_sym_from] = ACTIONS(962),
    [anon_sym_LPAREN] = ACTIONS(964),
    [anon_sym_print] = ACTIONS(962),
    [anon_sym_assert] = ACTIONS(962),
    [anon_sym_return] = ACTIONS(962),
    [anon_sym_del] = ACTIONS(962),
    [anon_sym_raise] = ACTIONS(962),
    [anon_sym_pass] = ACTIONS(962),
    [anon_sym_break] = ACTIONS(962),
    [anon_sym_continue] = ACTIONS(962),
    [anon_sym_if] = ACTIONS(962),
    [anon_sym_else] = ACTIONS(568),
    [anon_sym_async] = ACTIONS(962),
    [anon_sym_for] = ACTIONS(962),
    [anon_sym_while] = ACTIONS(962),
    [anon_sym_try] = ACTIONS(962),
    [anon_sym_with] = ACTIONS(962),
    [anon_sym_def] = ACTIONS(962),
    [anon_sym_global] = ACTIONS(962),
    [anon_sym_nonlocal] = ACTIONS(962),
    [anon_sym_exec] = ACTIONS(962),
    [anon_sym_class] = ACTIONS(962),
    [anon_sym_AT] = ACTIONS(964),
    [anon_sym_not] = ACTIONS(962),
    [anon_sym_PLUS] = ACTIONS(964),
    [anon_sym_DASH] = ACTIONS(964),
    [anon_sym_TILDE] = ACTIONS(964),
    [anon_sym_lambda] = ACTIONS(962),
    [anon_sym_yield] = ACTIONS(962),
    [anon_sym_LBRACK] = ACTIONS(964),
    [sym_ellipsis] = ACTIONS(964),
    [anon_sym_LBRACE] = ACTIONS(964),
    [sym_integer] = ACTIONS(962),
    [sym_float] = ACTIONS(964),
    [sym_true] = ACTIONS(962),
    [sym_false] = ACTIONS(962),
    [sym_none] = ACTIONS(962),
    [anon_sym_await] = ACTIONS(962),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(964),
    [sym__string_start] = ACTIONS(964),
  },
  [385] = {
    [sym_else_clause] = STATE(457),
    [sym_identifier] = ACTIONS(966),
    [anon_sym_import] = ACTIONS(966),
    [anon_sym_from] = ACTIONS(966),
    [anon_sym_LPAREN] = ACTIONS(968),
    [anon_sym_print] = ACTIONS(966),
    [anon_sym_assert] = ACTIONS(966),
    [anon_sym_return] = ACTIONS(966),
    [anon_sym_del] = ACTIONS(966),
    [anon_sym_raise] = ACTIONS(966),
    [anon_sym_pass] = ACTIONS(966),
    [anon_sym_break] = ACTIONS(966),
    [anon_sym_continue] = ACTIONS(966),
    [anon_sym_if] = ACTIONS(966),
    [anon_sym_else] = ACTIONS(568),
    [anon_sym_async] = ACTIONS(966),
    [anon_sym_for] = ACTIONS(966),
    [anon_sym_while] = ACTIONS(966),
    [anon_sym_try] = ACTIONS(966),
    [anon_sym_with] = ACTIONS(966),
    [anon_sym_def] = ACTIONS(966),
    [anon_sym_global] = ACTIONS(966),
    [anon_sym_nonlocal] = ACTIONS(966),
    [anon_sym_exec] = ACTIONS(966),
    [anon_sym_class] = ACTIONS(966),
    [anon_sym_AT] = ACTIONS(968),
    [anon_sym_not] = ACTIONS(966),
    [anon_sym_PLUS] = ACTIONS(968),
    [anon_sym_DASH] = ACTIONS(968),
    [anon_sym_TILDE] = ACTIONS(968),
    [anon_sym_lambda] = ACTIONS(966),
    [anon_sym_yield] = ACTIONS(966),
    [anon_sym_LBRACK] = ACTIONS(968),
    [sym_ellipsis] = ACTIONS(968),
    [anon_sym_LBRACE] = ACTIONS(968),
    [sym_integer] = ACTIONS(966),
    [sym_float] = ACTIONS(968),
    [sym_true] = ACTIONS(966),
    [sym_false] = ACTIONS(966),
    [sym_none] = ACTIONS(966),
    [anon_sym_await] = ACTIONS(966),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(968),
    [sym__string_start] = ACTIONS(968),
  },
  [386] = {
    [ts_builtin_sym_end] = ACTIONS(970),
    [sym_identifier] = ACTIONS(972),
    [anon_sym_import] = ACTIONS(972),
    [anon_sym_from] = ACTIONS(972),
    [anon_sym_LPAREN] = ACTIONS(970),
    [anon_sym_print] = ACTIONS(972),
    [anon_sym_assert] = ACTIONS(972),
    [anon_sym_return] = ACTIONS(972),
    [anon_sym_del] = ACTIONS(972),
    [anon_sym_raise] = ACTIONS(972),
    [anon_sym_pass] = ACTIONS(972),
    [anon_sym_break] = ACTIONS(972),
    [anon_sym_continue] = ACTIONS(972),
    [anon_sym_if] = ACTIONS(972),
    [anon_sym_elif] = ACTIONS(972),
    [anon_sym_else] = ACTIONS(972),
    [anon_sym_async] = ACTIONS(972),
    [anon_sym_for] = ACTIONS(972),
    [anon_sym_while] = ACTIONS(972),
    [anon_sym_try] = ACTIONS(972),
    [anon_sym_with] = ACTIONS(972),
    [anon_sym_def] = ACTIONS(972),
    [anon_sym_global] = ACTIONS(972),
    [anon_sym_nonlocal] = ACTIONS(972),
    [anon_sym_exec] = ACTIONS(972),
    [anon_sym_class] = ACTIONS(972),
    [anon_sym_AT] = ACTIONS(970),
    [anon_sym_not] = ACTIONS(972),
    [anon_sym_PLUS] = ACTIONS(970),
    [anon_sym_DASH] = ACTIONS(970),
    [anon_sym_TILDE] = ACTIONS(970),
    [anon_sym_lambda] = ACTIONS(972),
    [anon_sym_yield] = ACTIONS(972),
    [anon_sym_LBRACK] = ACTIONS(970),
    [sym_ellipsis] = ACTIONS(970),
    [anon_sym_LBRACE] = ACTIONS(970),
    [sym_integer] = ACTIONS(972),
    [sym_float] = ACTIONS(970),
    [sym_true] = ACTIONS(972),
    [sym_false] = ACTIONS(972),
    [sym_none] = ACTIONS(972),
    [anon_sym_await] = ACTIONS(972),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(970),
  },
  [387] = {
    [sym_else_clause] = STATE(436),
    [sym_identifier] = ACTIONS(974),
    [anon_sym_import] = ACTIONS(974),
    [anon_sym_from] = ACTIONS(974),
    [anon_sym_LPAREN] = ACTIONS(976),
    [anon_sym_print] = ACTIONS(974),
    [anon_sym_assert] = ACTIONS(974),
    [anon_sym_return] = ACTIONS(974),
    [anon_sym_del] = ACTIONS(974),
    [anon_sym_raise] = ACTIONS(974),
    [anon_sym_pass] = ACTIONS(974),
    [anon_sym_break] = ACTIONS(974),
    [anon_sym_continue] = ACTIONS(974),
    [anon_sym_if] = ACTIONS(974),
    [anon_sym_else] = ACTIONS(568),
    [anon_sym_async] = ACTIONS(974),
    [anon_sym_for] = ACTIONS(974),
    [anon_sym_while] = ACTIONS(974),
    [anon_sym_try] = ACTIONS(974),
    [anon_sym_with] = ACTIONS(974),
    [anon_sym_def] = ACTIONS(974),
    [anon_sym_global] = ACTIONS(974),
    [anon_sym_nonlocal] = ACTIONS(974),
    [anon_sym_exec] = ACTIONS(974),
    [anon_sym_class] = ACTIONS(974),
    [anon_sym_AT] = ACTIONS(976),
    [anon_sym_not] = ACTIONS(974),
    [anon_sym_PLUS] = ACTIONS(976),
    [anon_sym_DASH] = ACTIONS(976),
    [anon_sym_TILDE] = ACTIONS(976),
    [anon_sym_lambda] = ACTIONS(974),
    [anon_sym_yield] = ACTIONS(974),
    [anon_sym_LBRACK] = ACTIONS(976),
    [sym_ellipsis] = ACTIONS(976),
    [anon_sym_LBRACE] = ACTIONS(976),
    [sym_integer] = ACTIONS(974),
    [sym_float] = ACTIONS(976),
    [sym_true] = ACTIONS(974),
    [sym_false] = ACTIONS(974),
    [sym_none] = ACTIONS(974),
    [anon_sym_await] = ACTIONS(974),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(976),
    [sym__string_start] = ACTIONS(976),
  },
  [388] = {
    [sym_else_clause] = STATE(421),
    [ts_builtin_sym_end] = ACTIONS(978),
    [sym_identifier] = ACTIONS(980),
    [anon_sym_import] = ACTIONS(980),
    [anon_sym_from] = ACTIONS(980),
    [anon_sym_LPAREN] = ACTIONS(978),
    [anon_sym_print] = ACTIONS(980),
    [anon_sym_assert] = ACTIONS(980),
    [anon_sym_return] = ACTIONS(980),
    [anon_sym_del] = ACTIONS(980),
    [anon_sym_raise] = ACTIONS(980),
    [anon_sym_pass] = ACTIONS(980),
    [anon_sym_break] = ACTIONS(980),
    [anon_sym_continue] = ACTIONS(980),
    [anon_sym_if] = ACTIONS(980),
    [anon_sym_else] = ACTIONS(590),
    [anon_sym_async] = ACTIONS(980),
    [anon_sym_for] = ACTIONS(980),
    [anon_sym_while] = ACTIONS(980),
    [anon_sym_try] = ACTIONS(980),
    [anon_sym_with] = ACTIONS(980),
    [anon_sym_def] = ACTIONS(980),
    [anon_sym_global] = ACTIONS(980),
    [anon_sym_nonlocal] = ACTIONS(980),
    [anon_sym_exec] = ACTIONS(980),
    [anon_sym_class] = ACTIONS(980),
    [anon_sym_AT] = ACTIONS(978),
    [anon_sym_not] = ACTIONS(980),
    [anon_sym_PLUS] = ACTIONS(978),
    [anon_sym_DASH] = ACTIONS(978),
    [anon_sym_TILDE] = ACTIONS(978),
    [anon_sym_lambda] = ACTIONS(980),
    [anon_sym_yield] = ACTIONS(980),
    [anon_sym_LBRACK] = ACTIONS(978),
    [sym_ellipsis] = ACTIONS(978),
    [anon_sym_LBRACE] = ACTIONS(978),
    [sym_integer] = ACTIONS(980),
    [sym_float] = ACTIONS(978),
    [sym_true] = ACTIONS(980),
    [sym_false] = ACTIONS(980),
    [sym_none] = ACTIONS(980),
    [anon_sym_await] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(978),
  },
  [389] = {
    [sym_else_clause] = STATE(464),
    [ts_builtin_sym_end] = ACTIONS(976),
    [sym_identifier] = ACTIONS(974),
    [anon_sym_import] = ACTIONS(974),
    [anon_sym_from] = ACTIONS(974),
    [anon_sym_LPAREN] = ACTIONS(976),
    [anon_sym_print] = ACTIONS(974),
    [anon_sym_assert] = ACTIONS(974),
    [anon_sym_return] = ACTIONS(974),
    [anon_sym_del] = ACTIONS(974),
    [anon_sym_raise] = ACTIONS(974),
    [anon_sym_pass] = ACTIONS(974),
    [anon_sym_break] = ACTIONS(974),
    [anon_sym_continue] = ACTIONS(974),
    [anon_sym_if] = ACTIONS(974),
    [anon_sym_else] = ACTIONS(590),
    [anon_sym_async] = ACTIONS(974),
    [anon_sym_for] = ACTIONS(974),
    [anon_sym_while] = ACTIONS(974),
    [anon_sym_try] = ACTIONS(974),
    [anon_sym_with] = ACTIONS(974),
    [anon_sym_def] = ACTIONS(974),
    [anon_sym_global] = ACTIONS(974),
    [anon_sym_nonlocal] = ACTIONS(974),
    [anon_sym_exec] = ACTIONS(974),
    [anon_sym_class] = ACTIONS(974),
    [anon_sym_AT] = ACTIONS(976),
    [anon_sym_not] = ACTIONS(974),
    [anon_sym_PLUS] = ACTIONS(976),
    [anon_sym_DASH] = ACTIONS(976),
    [anon_sym_TILDE] = ACTIONS(976),
    [anon_sym_lambda] = ACTIONS(974),
    [anon_sym_yield] = ACTIONS(974),
    [anon_sym_LBRACK] = ACTIONS(976),
    [sym_ellipsis] = ACTIONS(976),
    [anon_sym_LBRACE] = ACTIONS(976),
    [sym_integer] = ACTIONS(974),
    [sym_float] = ACTIONS(976),
    [sym_true] = ACTIONS(974),
    [sym_false] = ACTIONS(974),
    [sym_none] = ACTIONS(974),
    [anon_sym_await] = ACTIONS(974),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(976),
  },
  [390] = {
    [sym_finally_clause] = STATE(485),
    [sym_identifier] = ACTIONS(982),
    [anon_sym_import] = ACTIONS(982),
    [anon_sym_from] = ACTIONS(982),
    [anon_sym_LPAREN] = ACTIONS(984),
    [anon_sym_print] = ACTIONS(982),
    [anon_sym_assert] = ACTIONS(982),
    [anon_sym_return] = ACTIONS(982),
    [anon_sym_del] = ACTIONS(982),
    [anon_sym_raise] = ACTIONS(982),
    [anon_sym_pass] = ACTIONS(982),
    [anon_sym_break] = ACTIONS(982),
    [anon_sym_continue] = ACTIONS(982),
    [anon_sym_if] = ACTIONS(982),
    [anon_sym_async] = ACTIONS(982),
    [anon_sym_for] = ACTIONS(982),
    [anon_sym_while] = ACTIONS(982),
    [anon_sym_try] = ACTIONS(982),
    [anon_sym_finally] = ACTIONS(572),
    [anon_sym_with] = ACTIONS(982),
    [anon_sym_def] = ACTIONS(982),
    [anon_sym_global] = ACTIONS(982),
    [anon_sym_nonlocal] = ACTIONS(982),
    [anon_sym_exec] = ACTIONS(982),
    [anon_sym_class] = ACTIONS(982),
    [anon_sym_AT] = ACTIONS(984),
    [anon_sym_not] = ACTIONS(982),
    [anon_sym_PLUS] = ACTIONS(984),
    [anon_sym_DASH] = ACTIONS(984),
    [anon_sym_TILDE] = ACTIONS(984),
    [anon_sym_lambda] = ACTIONS(982),
    [anon_sym_yield] = ACTIONS(982),
    [anon_sym_LBRACK] = ACTIONS(984),
    [sym_ellipsis] = ACTIONS(984),
    [anon_sym_LBRACE] = ACTIONS(984),
    [sym_integer] = ACTIONS(982),
    [sym_float] = ACTIONS(984),
    [sym_true] = ACTIONS(982),
    [sym_false] = ACTIONS(982),
    [sym_none] = ACTIONS(982),
    [anon_sym_await] = ACTIONS(982),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(984),
    [sym__string_start] = ACTIONS(984),
  },
  [391] = {
    [sym_else_clause] = STATE(475),
    [ts_builtin_sym_end] = ACTIONS(964),
    [sym_identifier] = ACTIONS(962),
    [anon_sym_import] = ACTIONS(962),
    [anon_sym_from] = ACTIONS(962),
    [anon_sym_LPAREN] = ACTIONS(964),
    [anon_sym_print] = ACTIONS(962),
    [anon_sym_assert] = ACTIONS(962),
    [anon_sym_return] = ACTIONS(962),
    [anon_sym_del] = ACTIONS(962),
    [anon_sym_raise] = ACTIONS(962),
    [anon_sym_pass] = ACTIONS(962),
    [anon_sym_break] = ACTIONS(962),
    [anon_sym_continue] = ACTIONS(962),
    [anon_sym_if] = ACTIONS(962),
    [anon_sym_else] = ACTIONS(590),
    [anon_sym_async] = ACTIONS(962),
    [anon_sym_for] = ACTIONS(962),
    [anon_sym_while] = ACTIONS(962),
    [anon_sym_try] = ACTIONS(962),
    [anon_sym_with] = ACTIONS(962),
    [anon_sym_def] = ACTIONS(962),
    [anon_sym_global] = ACTIONS(962),
    [anon_sym_nonlocal] = ACTIONS(962),
    [anon_sym_exec] = ACTIONS(962),
    [anon_sym_class] = ACTIONS(962),
    [anon_sym_AT] = ACTIONS(964),
    [anon_sym_not] = ACTIONS(962),
    [anon_sym_PLUS] = ACTIONS(964),
    [anon_sym_DASH] = ACTIONS(964),
    [anon_sym_TILDE] = ACTIONS(964),
    [anon_sym_lambda] = ACTIONS(962),
    [anon_sym_yield] = ACTIONS(962),
    [anon_sym_LBRACK] = ACTIONS(964),
    [sym_ellipsis] = ACTIONS(964),
    [anon_sym_LBRACE] = ACTIONS(964),
    [sym_integer] = ACTIONS(962),
    [sym_float] = ACTIONS(964),
    [sym_true] = ACTIONS(962),
    [sym_false] = ACTIONS(962),
    [sym_none] = ACTIONS(962),
    [anon_sym_await] = ACTIONS(962),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(964),
  },
  [392] = {
    [sym_identifier] = ACTIONS(986),
    [anon_sym_import] = ACTIONS(986),
    [anon_sym_from] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_print] = ACTIONS(986),
    [anon_sym_assert] = ACTIONS(986),
    [anon_sym_return] = ACTIONS(986),
    [anon_sym_del] = ACTIONS(986),
    [anon_sym_raise] = ACTIONS(986),
    [anon_sym_pass] = ACTIONS(986),
    [anon_sym_break] = ACTIONS(986),
    [anon_sym_continue] = ACTIONS(986),
    [anon_sym_if] = ACTIONS(986),
    [anon_sym_elif] = ACTIONS(986),
    [anon_sym_else] = ACTIONS(986),
    [anon_sym_async] = ACTIONS(986),
    [anon_sym_for] = ACTIONS(986),
    [anon_sym_while] = ACTIONS(986),
    [anon_sym_try] = ACTIONS(986),
    [anon_sym_with] = ACTIONS(986),
    [anon_sym_def] = ACTIONS(986),
    [anon_sym_global] = ACTIONS(986),
    [anon_sym_nonlocal] = ACTIONS(986),
    [anon_sym_exec] = ACTIONS(986),
    [anon_sym_class] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_not] = ACTIONS(986),
    [anon_sym_PLUS] = ACTIONS(988),
    [anon_sym_DASH] = ACTIONS(988),
    [anon_sym_TILDE] = ACTIONS(988),
    [anon_sym_lambda] = ACTIONS(986),
    [anon_sym_yield] = ACTIONS(986),
    [anon_sym_LBRACK] = ACTIONS(988),
    [sym_ellipsis] = ACTIONS(988),
    [anon_sym_LBRACE] = ACTIONS(988),
    [sym_integer] = ACTIONS(986),
    [sym_float] = ACTIONS(988),
    [sym_true] = ACTIONS(986),
    [sym_false] = ACTIONS(986),
    [sym_none] = ACTIONS(986),
    [anon_sym_await] = ACTIONS(986),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(988),
    [sym__string_start] = ACTIONS(988),
  },
  [393] = {
    [ts_builtin_sym_end] = ACTIONS(990),
    [sym_identifier] = ACTIONS(992),
    [anon_sym_import] = ACTIONS(992),
    [anon_sym_from] = ACTIONS(992),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_print] = ACTIONS(992),
    [anon_sym_assert] = ACTIONS(992),
    [anon_sym_return] = ACTIONS(992),
    [anon_sym_del] = ACTIONS(992),
    [anon_sym_raise] = ACTIONS(992),
    [anon_sym_pass] = ACTIONS(992),
    [anon_sym_break] = ACTIONS(992),
    [anon_sym_continue] = ACTIONS(992),
    [anon_sym_if] = ACTIONS(992),
    [anon_sym_elif] = ACTIONS(992),
    [anon_sym_else] = ACTIONS(992),
    [anon_sym_async] = ACTIONS(992),
    [anon_sym_for] = ACTIONS(992),
    [anon_sym_while] = ACTIONS(992),
    [anon_sym_try] = ACTIONS(992),
    [anon_sym_with] = ACTIONS(992),
    [anon_sym_def] = ACTIONS(992),
    [anon_sym_global] = ACTIONS(992),
    [anon_sym_nonlocal] = ACTIONS(992),
    [anon_sym_exec] = ACTIONS(992),
    [anon_sym_class] = ACTIONS(992),
    [anon_sym_AT] = ACTIONS(990),
    [anon_sym_not] = ACTIONS(992),
    [anon_sym_PLUS] = ACTIONS(990),
    [anon_sym_DASH] = ACTIONS(990),
    [anon_sym_TILDE] = ACTIONS(990),
    [anon_sym_lambda] = ACTIONS(992),
    [anon_sym_yield] = ACTIONS(992),
    [anon_sym_LBRACK] = ACTIONS(990),
    [sym_ellipsis] = ACTIONS(990),
    [anon_sym_LBRACE] = ACTIONS(990),
    [sym_integer] = ACTIONS(992),
    [sym_float] = ACTIONS(990),
    [sym_true] = ACTIONS(992),
    [sym_false] = ACTIONS(992),
    [sym_none] = ACTIONS(992),
    [anon_sym_await] = ACTIONS(992),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(990),
  },
  [394] = {
    [ts_builtin_sym_end] = ACTIONS(988),
    [sym_identifier] = ACTIONS(986),
    [anon_sym_import] = ACTIONS(986),
    [anon_sym_from] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_print] = ACTIONS(986),
    [anon_sym_assert] = ACTIONS(986),
    [anon_sym_return] = ACTIONS(986),
    [anon_sym_del] = ACTIONS(986),
    [anon_sym_raise] = ACTIONS(986),
    [anon_sym_pass] = ACTIONS(986),
    [anon_sym_break] = ACTIONS(986),
    [anon_sym_continue] = ACTIONS(986),
    [anon_sym_if] = ACTIONS(986),
    [anon_sym_elif] = ACTIONS(986),
    [anon_sym_else] = ACTIONS(986),
    [anon_sym_async] = ACTIONS(986),
    [anon_sym_for] = ACTIONS(986),
    [anon_sym_while] = ACTIONS(986),
    [anon_sym_try] = ACTIONS(986),
    [anon_sym_with] = ACTIONS(986),
    [anon_sym_def] = ACTIONS(986),
    [anon_sym_global] = ACTIONS(986),
    [anon_sym_nonlocal] = ACTIONS(986),
    [anon_sym_exec] = ACTIONS(986),
    [anon_sym_class] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_not] = ACTIONS(986),
    [anon_sym_PLUS] = ACTIONS(988),
    [anon_sym_DASH] = ACTIONS(988),
    [anon_sym_TILDE] = ACTIONS(988),
    [anon_sym_lambda] = ACTIONS(986),
    [anon_sym_yield] = ACTIONS(986),
    [anon_sym_LBRACK] = ACTIONS(988),
    [sym_ellipsis] = ACTIONS(988),
    [anon_sym_LBRACE] = ACTIONS(988),
    [sym_integer] = ACTIONS(986),
    [sym_float] = ACTIONS(988),
    [sym_true] = ACTIONS(986),
    [sym_false] = ACTIONS(986),
    [sym_none] = ACTIONS(986),
    [anon_sym_await] = ACTIONS(986),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(988),
  },
  [395] = {
    [sym_else_clause] = STATE(472),
    [ts_builtin_sym_end] = ACTIONS(960),
    [sym_identifier] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(958),
    [anon_sym_from] = ACTIONS(958),
    [anon_sym_LPAREN] = ACTIONS(960),
    [anon_sym_print] = ACTIONS(958),
    [anon_sym_assert] = ACTIONS(958),
    [anon_sym_return] = ACTIONS(958),
    [anon_sym_del] = ACTIONS(958),
    [anon_sym_raise] = ACTIONS(958),
    [anon_sym_pass] = ACTIONS(958),
    [anon_sym_break] = ACTIONS(958),
    [anon_sym_continue] = ACTIONS(958),
    [anon_sym_if] = ACTIONS(958),
    [anon_sym_else] = ACTIONS(590),
    [anon_sym_async] = ACTIONS(958),
    [anon_sym_for] = ACTIONS(958),
    [anon_sym_while] = ACTIONS(958),
    [anon_sym_try] = ACTIONS(958),
    [anon_sym_with] = ACTIONS(958),
    [anon_sym_def] = ACTIONS(958),
    [anon_sym_global] = ACTIONS(958),
    [anon_sym_nonlocal] = ACTIONS(958),
    [anon_sym_exec] = ACTIONS(958),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_AT] = ACTIONS(960),
    [anon_sym_not] = ACTIONS(958),
    [anon_sym_PLUS] = ACTIONS(960),
    [anon_sym_DASH] = ACTIONS(960),
    [anon_sym_TILDE] = ACTIONS(960),
    [anon_sym_lambda] = ACTIONS(958),
    [anon_sym_yield] = ACTIONS(958),
    [anon_sym_LBRACK] = ACTIONS(960),
    [sym_ellipsis] = ACTIONS(960),
    [anon_sym_LBRACE] = ACTIONS(960),
    [sym_integer] = ACTIONS(958),
    [sym_float] = ACTIONS(960),
    [sym_true] = ACTIONS(958),
    [sym_false] = ACTIONS(958),
    [sym_none] = ACTIONS(958),
    [anon_sym_await] = ACTIONS(958),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(960),
  },
  [396] = {
    [sym_finally_clause] = STATE(411),
    [ts_builtin_sym_end] = ACTIONS(984),
    [sym_identifier] = ACTIONS(982),
    [anon_sym_import] = ACTIONS(982),
    [anon_sym_from] = ACTIONS(982),
    [anon_sym_LPAREN] = ACTIONS(984),
    [anon_sym_print] = ACTIONS(982),
    [anon_sym_assert] = ACTIONS(982),
    [anon_sym_return] = ACTIONS(982),
    [anon_sym_del] = ACTIONS(982),
    [anon_sym_raise] = ACTIONS(982),
    [anon_sym_pass] = ACTIONS(982),
    [anon_sym_break] = ACTIONS(982),
    [anon_sym_continue] = ACTIONS(982),
    [anon_sym_if] = ACTIONS(982),
    [anon_sym_async] = ACTIONS(982),
    [anon_sym_for] = ACTIONS(982),
    [anon_sym_while] = ACTIONS(982),
    [anon_sym_try] = ACTIONS(982),
    [anon_sym_finally] = ACTIONS(594),
    [anon_sym_with] = ACTIONS(982),
    [anon_sym_def] = ACTIONS(982),
    [anon_sym_global] = ACTIONS(982),
    [anon_sym_nonlocal] = ACTIONS(982),
    [anon_sym_exec] = ACTIONS(982),
    [anon_sym_class] = ACTIONS(982),
    [anon_sym_AT] = ACTIONS(984),
    [anon_sym_not] = ACTIONS(982),
    [anon_sym_PLUS] = ACTIONS(984),
    [anon_sym_DASH] = ACTIONS(984),
    [anon_sym_TILDE] = ACTIONS(984),
    [anon_sym_lambda] = ACTIONS(982),
    [anon_sym_yield] = ACTIONS(982),
    [anon_sym_LBRACK] = ACTIONS(984),
    [sym_ellipsis] = ACTIONS(984),
    [anon_sym_LBRACE] = ACTIONS(984),
    [sym_integer] = ACTIONS(982),
    [sym_float] = ACTIONS(984),
    [sym_true] = ACTIONS(982),
    [sym_false] = ACTIONS(982),
    [sym_none] = ACTIONS(982),
    [anon_sym_await] = ACTIONS(982),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(984),
  },
  [397] = {
    [sym_else_clause] = STATE(438),
    [sym_identifier] = ACTIONS(980),
    [anon_sym_import] = ACTIONS(980),
    [anon_sym_from] = ACTIONS(980),
    [anon_sym_LPAREN] = ACTIONS(978),
    [anon_sym_print] = ACTIONS(980),
    [anon_sym_assert] = ACTIONS(980),
    [anon_sym_return] = ACTIONS(980),
    [anon_sym_del] = ACTIONS(980),
    [anon_sym_raise] = ACTIONS(980),
    [anon_sym_pass] = ACTIONS(980),
    [anon_sym_break] = ACTIONS(980),
    [anon_sym_continue] = ACTIONS(980),
    [anon_sym_if] = ACTIONS(980),
    [anon_sym_else] = ACTIONS(568),
    [anon_sym_async] = ACTIONS(980),
    [anon_sym_for] = ACTIONS(980),
    [anon_sym_while] = ACTIONS(980),
    [anon_sym_try] = ACTIONS(980),
    [anon_sym_with] = ACTIONS(980),
    [anon_sym_def] = ACTIONS(980),
    [anon_sym_global] = ACTIONS(980),
    [anon_sym_nonlocal] = ACTIONS(980),
    [anon_sym_exec] = ACTIONS(980),
    [anon_sym_class] = ACTIONS(980),
    [anon_sym_AT] = ACTIONS(978),
    [anon_sym_not] = ACTIONS(980),
    [anon_sym_PLUS] = ACTIONS(978),
    [anon_sym_DASH] = ACTIONS(978),
    [anon_sym_TILDE] = ACTIONS(978),
    [anon_sym_lambda] = ACTIONS(980),
    [anon_sym_yield] = ACTIONS(980),
    [anon_sym_LBRACK] = ACTIONS(978),
    [sym_ellipsis] = ACTIONS(978),
    [anon_sym_LBRACE] = ACTIONS(978),
    [sym_integer] = ACTIONS(980),
    [sym_float] = ACTIONS(978),
    [sym_true] = ACTIONS(980),
    [sym_false] = ACTIONS(980),
    [sym_none] = ACTIONS(980),
    [anon_sym_await] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(978),
    [sym__string_start] = ACTIONS(978),
  },
  [398] = {
    [sym_finally_clause] = STATE(455),
    [sym_identifier] = ACTIONS(952),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_from] = ACTIONS(952),
    [anon_sym_LPAREN] = ACTIONS(950),
    [anon_sym_print] = ACTIONS(952),
    [anon_sym_assert] = ACTIONS(952),
    [anon_sym_return] = ACTIONS(952),
    [anon_sym_del] = ACTIONS(952),
    [anon_sym_raise] = ACTIONS(952),
    [anon_sym_pass] = ACTIONS(952),
    [anon_sym_break] = ACTIONS(952),
    [anon_sym_continue] = ACTIONS(952),
    [anon_sym_if] = ACTIONS(952),
    [anon_sym_async] = ACTIONS(952),
    [anon_sym_for] = ACTIONS(952),
    [anon_sym_while] = ACTIONS(952),
    [anon_sym_try] = ACTIONS(952),
    [anon_sym_finally] = ACTIONS(572),
    [anon_sym_with] = ACTIONS(952),
    [anon_sym_def] = ACTIONS(952),
    [anon_sym_global] = ACTIONS(952),
    [anon_sym_nonlocal] = ACTIONS(952),
    [anon_sym_exec] = ACTIONS(952),
    [anon_sym_class] = ACTIONS(952),
    [anon_sym_AT] = ACTIONS(950),
    [anon_sym_not] = ACTIONS(952),
    [anon_sym_PLUS] = ACTIONS(950),
    [anon_sym_DASH] = ACTIONS(950),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_lambda] = ACTIONS(952),
    [anon_sym_yield] = ACTIONS(952),
    [anon_sym_LBRACK] = ACTIONS(950),
    [sym_ellipsis] = ACTIONS(950),
    [anon_sym_LBRACE] = ACTIONS(950),
    [sym_integer] = ACTIONS(952),
    [sym_float] = ACTIONS(950),
    [sym_true] = ACTIONS(952),
    [sym_false] = ACTIONS(952),
    [sym_none] = ACTIONS(952),
    [anon_sym_await] = ACTIONS(952),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(950),
    [sym__string_start] = ACTIONS(950),
  },
  [399] = {
    [sym_else_clause] = STATE(489),
    [ts_builtin_sym_end] = ACTIONS(968),
    [sym_identifier] = ACTIONS(966),
    [anon_sym_import] = ACTIONS(966),
    [anon_sym_from] = ACTIONS(966),
    [anon_sym_LPAREN] = ACTIONS(968),
    [anon_sym_print] = ACTIONS(966),
    [anon_sym_assert] = ACTIONS(966),
    [anon_sym_return] = ACTIONS(966),
    [anon_sym_del] = ACTIONS(966),
    [anon_sym_raise] = ACTIONS(966),
    [anon_sym_pass] = ACTIONS(966),
    [anon_sym_break] = ACTIONS(966),
    [anon_sym_continue] = ACTIONS(966),
    [anon_sym_if] = ACTIONS(966),
    [anon_sym_else] = ACTIONS(590),
    [anon_sym_async] = ACTIONS(966),
    [anon_sym_for] = ACTIONS(966),
    [anon_sym_while] = ACTIONS(966),
    [anon_sym_try] = ACTIONS(966),
    [anon_sym_with] = ACTIONS(966),
    [anon_sym_def] = ACTIONS(966),
    [anon_sym_global] = ACTIONS(966),
    [anon_sym_nonlocal] = ACTIONS(966),
    [anon_sym_exec] = ACTIONS(966),
    [anon_sym_class] = ACTIONS(966),
    [anon_sym_AT] = ACTIONS(968),
    [anon_sym_not] = ACTIONS(966),
    [anon_sym_PLUS] = ACTIONS(968),
    [anon_sym_DASH] = ACTIONS(968),
    [anon_sym_TILDE] = ACTIONS(968),
    [anon_sym_lambda] = ACTIONS(966),
    [anon_sym_yield] = ACTIONS(966),
    [anon_sym_LBRACK] = ACTIONS(968),
    [sym_ellipsis] = ACTIONS(968),
    [anon_sym_LBRACE] = ACTIONS(968),
    [sym_integer] = ACTIONS(966),
    [sym_float] = ACTIONS(968),
    [sym_true] = ACTIONS(966),
    [sym_false] = ACTIONS(966),
    [sym_none] = ACTIONS(966),
    [anon_sym_await] = ACTIONS(966),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(968),
  },
  [400] = {
    [sym_else_clause] = STATE(474),
    [ts_builtin_sym_end] = ACTIONS(956),
    [sym_identifier] = ACTIONS(954),
    [anon_sym_import] = ACTIONS(954),
    [anon_sym_from] = ACTIONS(954),
    [anon_sym_LPAREN] = ACTIONS(956),
    [anon_sym_print] = ACTIONS(954),
    [anon_sym_assert] = ACTIONS(954),
    [anon_sym_return] = ACTIONS(954),
    [anon_sym_del] = ACTIONS(954),
    [anon_sym_raise] = ACTIONS(954),
    [anon_sym_pass] = ACTIONS(954),
    [anon_sym_break] = ACTIONS(954),
    [anon_sym_continue] = ACTIONS(954),
    [anon_sym_if] = ACTIONS(954),
    [anon_sym_else] = ACTIONS(590),
    [anon_sym_async] = ACTIONS(954),
    [anon_sym_for] = ACTIONS(954),
    [anon_sym_while] = ACTIONS(954),
    [anon_sym_try] = ACTIONS(954),
    [anon_sym_with] = ACTIONS(954),
    [anon_sym_def] = ACTIONS(954),
    [anon_sym_global] = ACTIONS(954),
    [anon_sym_nonlocal] = ACTIONS(954),
    [anon_sym_exec] = ACTIONS(954),
    [anon_sym_class] = ACTIONS(954),
    [anon_sym_AT] = ACTIONS(956),
    [anon_sym_not] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_TILDE] = ACTIONS(956),
    [anon_sym_lambda] = ACTIONS(954),
    [anon_sym_yield] = ACTIONS(954),
    [anon_sym_LBRACK] = ACTIONS(956),
    [sym_ellipsis] = ACTIONS(956),
    [anon_sym_LBRACE] = ACTIONS(956),
    [sym_integer] = ACTIONS(954),
    [sym_float] = ACTIONS(956),
    [sym_true] = ACTIONS(954),
    [sym_false] = ACTIONS(954),
    [sym_none] = ACTIONS(954),
    [anon_sym_await] = ACTIONS(954),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(956),
  },
  [401] = {
    [sym_identifier] = ACTIONS(992),
    [anon_sym_import] = ACTIONS(992),
    [anon_sym_from] = ACTIONS(992),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_print] = ACTIONS(992),
    [anon_sym_assert] = ACTIONS(992),
    [anon_sym_return] = ACTIONS(992),
    [anon_sym_del] = ACTIONS(992),
    [anon_sym_raise] = ACTIONS(992),
    [anon_sym_pass] = ACTIONS(992),
    [anon_sym_break] = ACTIONS(992),
    [anon_sym_continue] = ACTIONS(992),
    [anon_sym_if] = ACTIONS(992),
    [anon_sym_elif] = ACTIONS(992),
    [anon_sym_else] = ACTIONS(992),
    [anon_sym_async] = ACTIONS(992),
    [anon_sym_for] = ACTIONS(992),
    [anon_sym_while] = ACTIONS(992),
    [anon_sym_try] = ACTIONS(992),
    [anon_sym_with] = ACTIONS(992),
    [anon_sym_def] = ACTIONS(992),
    [anon_sym_global] = ACTIONS(992),
    [anon_sym_nonlocal] = ACTIONS(992),
    [anon_sym_exec] = ACTIONS(992),
    [anon_sym_class] = ACTIONS(992),
    [anon_sym_AT] = ACTIONS(990),
    [anon_sym_not] = ACTIONS(992),
    [anon_sym_PLUS] = ACTIONS(990),
    [anon_sym_DASH] = ACTIONS(990),
    [anon_sym_TILDE] = ACTIONS(990),
    [anon_sym_lambda] = ACTIONS(992),
    [anon_sym_yield] = ACTIONS(992),
    [anon_sym_LBRACK] = ACTIONS(990),
    [sym_ellipsis] = ACTIONS(990),
    [anon_sym_LBRACE] = ACTIONS(990),
    [sym_integer] = ACTIONS(992),
    [sym_float] = ACTIONS(990),
    [sym_true] = ACTIONS(992),
    [sym_false] = ACTIONS(992),
    [sym_none] = ACTIONS(992),
    [anon_sym_await] = ACTIONS(992),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(990),
    [sym__string_start] = ACTIONS(990),
  },
  [402] = {
    [sym_identifier] = ACTIONS(972),
    [anon_sym_import] = ACTIONS(972),
    [anon_sym_from] = ACTIONS(972),
    [anon_sym_LPAREN] = ACTIONS(970),
    [anon_sym_print] = ACTIONS(972),
    [anon_sym_assert] = ACTIONS(972),
    [anon_sym_return] = ACTIONS(972),
    [anon_sym_del] = ACTIONS(972),
    [anon_sym_raise] = ACTIONS(972),
    [anon_sym_pass] = ACTIONS(972),
    [anon_sym_break] = ACTIONS(972),
    [anon_sym_continue] = ACTIONS(972),
    [anon_sym_if] = ACTIONS(972),
    [anon_sym_elif] = ACTIONS(972),
    [anon_sym_else] = ACTIONS(972),
    [anon_sym_async] = ACTIONS(972),
    [anon_sym_for] = ACTIONS(972),
    [anon_sym_while] = ACTIONS(972),
    [anon_sym_try] = ACTIONS(972),
    [anon_sym_with] = ACTIONS(972),
    [anon_sym_def] = ACTIONS(972),
    [anon_sym_global] = ACTIONS(972),
    [anon_sym_nonlocal] = ACTIONS(972),
    [anon_sym_exec] = ACTIONS(972),
    [anon_sym_class] = ACTIONS(972),
    [anon_sym_AT] = ACTIONS(970),
    [anon_sym_not] = ACTIONS(972),
    [anon_sym_PLUS] = ACTIONS(970),
    [anon_sym_DASH] = ACTIONS(970),
    [anon_sym_TILDE] = ACTIONS(970),
    [anon_sym_lambda] = ACTIONS(972),
    [anon_sym_yield] = ACTIONS(972),
    [anon_sym_LBRACK] = ACTIONS(970),
    [sym_ellipsis] = ACTIONS(970),
    [anon_sym_LBRACE] = ACTIONS(970),
    [sym_integer] = ACTIONS(972),
    [sym_float] = ACTIONS(970),
    [sym_true] = ACTIONS(972),
    [sym_false] = ACTIONS(972),
    [sym_none] = ACTIONS(972),
    [anon_sym_await] = ACTIONS(972),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(970),
    [sym__string_start] = ACTIONS(970),
  },
  [403] = {
    [sym_string] = STATE(406),
    [aux_sym_concatenated_string_repeat1] = STATE(406),
    [anon_sym_DOT] = ACTIONS(440),
    [anon_sym_LPAREN] = ACTIONS(440),
    [anon_sym_RPAREN] = ACTIONS(440),
    [anon_sym_COMMA] = ACTIONS(440),
    [anon_sym_STAR] = ACTIONS(442),
    [anon_sym_GT_GT] = ACTIONS(440),
    [anon_sym_if] = ACTIONS(440),
    [anon_sym_COLON] = ACTIONS(440),
    [anon_sym_else] = ACTIONS(440),
    [anon_sym_async] = ACTIONS(440),
    [anon_sym_for] = ACTIONS(440),
    [anon_sym_in] = ACTIONS(440),
    [anon_sym_EQ] = ACTIONS(442),
    [anon_sym_AT] = ACTIONS(440),
    [anon_sym_not] = ACTIONS(440),
    [anon_sym_and] = ACTIONS(440),
    [anon_sym_or] = ACTIONS(440),
    [anon_sym_PLUS] = ACTIONS(440),
    [anon_sym_DASH] = ACTIONS(440),
    [anon_sym_SLASH] = ACTIONS(442),
    [anon_sym_PERCENT] = ACTIONS(440),
    [anon_sym_SLASH_SLASH] = ACTIONS(440),
    [anon_sym_STAR_STAR] = ACTIONS(440),
    [anon_sym_PIPE] = ACTIONS(440),
    [anon_sym_AMP] = ACTIONS(440),
    [anon_sym_CARET] = ACTIONS(440),
    [anon_sym_LT_LT] = ACTIONS(440),
    [anon_sym_LT] = ACTIONS(442),
    [anon_sym_LT_EQ] = ACTIONS(440),
    [anon_sym_EQ_EQ] = ACTIONS(440),
    [anon_sym_BANG_EQ] = ACTIONS(440),
    [anon_sym_GT_EQ] = ACTIONS(440),
    [anon_sym_GT] = ACTIONS(442),
    [anon_sym_LT_GT] = ACTIONS(440),
    [anon_sym_is] = ACTIONS(440),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_RBRACK] = ACTIONS(440),
    [anon_sym_RBRACE] = ACTIONS(440),
    [sym_type_conversion] = ACTIONS(440),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [404] = {
    [sym_string] = STATE(404),
    [aux_sym_concatenated_string_repeat1] = STATE(404),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(429),
    [anon_sym_COMMA] = ACTIONS(429),
    [anon_sym_STAR] = ACTIONS(431),
    [anon_sym_GT_GT] = ACTIONS(429),
    [anon_sym_if] = ACTIONS(429),
    [anon_sym_COLON] = ACTIONS(429),
    [anon_sym_else] = ACTIONS(429),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_for] = ACTIONS(429),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_EQ] = ACTIONS(431),
    [anon_sym_AT] = ACTIONS(429),
    [anon_sym_not] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PLUS] = ACTIONS(429),
    [anon_sym_DASH] = ACTIONS(429),
    [anon_sym_SLASH] = ACTIONS(431),
    [anon_sym_PERCENT] = ACTIONS(429),
    [anon_sym_SLASH_SLASH] = ACTIONS(429),
    [anon_sym_STAR_STAR] = ACTIONS(429),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(429),
    [anon_sym_LT_LT] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(431),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(431),
    [anon_sym_LT_GT] = ACTIONS(429),
    [anon_sym_is] = ACTIONS(429),
    [anon_sym_LBRACK] = ACTIONS(429),
    [anon_sym_RBRACK] = ACTIONS(429),
    [anon_sym_RBRACE] = ACTIONS(429),
    [sym_type_conversion] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(994),
  },
  [405] = {
    [sym_argument_list] = STATE(498),
    [sym_generator_expression] = STATE(498),
    [aux_sym_comparison_operator_repeat1] = STATE(682),
    [anon_sym_DOT] = ACTIONS(997),
    [anon_sym_LPAREN] = ACTIONS(999),
    [anon_sym_RPAREN] = ACTIONS(460),
    [anon_sym_COMMA] = ACTIONS(460),
    [anon_sym_STAR] = ACTIONS(1001),
    [anon_sym_GT_GT] = ACTIONS(1003),
    [anon_sym_if] = ACTIONS(460),
    [anon_sym_COLON] = ACTIONS(460),
    [anon_sym_else] = ACTIONS(460),
    [anon_sym_async] = ACTIONS(460),
    [anon_sym_for] = ACTIONS(460),
    [anon_sym_in] = ACTIONS(1005),
    [anon_sym_EQ] = ACTIONS(468),
    [anon_sym_AT] = ACTIONS(1007),
    [anon_sym_not] = ACTIONS(1009),
    [anon_sym_and] = ACTIONS(460),
    [anon_sym_or] = ACTIONS(460),
    [anon_sym_PLUS] = ACTIONS(1011),
    [anon_sym_DASH] = ACTIONS(1011),
    [anon_sym_SLASH] = ACTIONS(1001),
    [anon_sym_PERCENT] = ACTIONS(1007),
    [anon_sym_SLASH_SLASH] = ACTIONS(1007),
    [anon_sym_STAR_STAR] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_AMP] = ACTIONS(1017),
    [anon_sym_CARET] = ACTIONS(1019),
    [anon_sym_LT_LT] = ACTIONS(1003),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1005),
    [anon_sym_EQ_EQ] = ACTIONS(1005),
    [anon_sym_BANG_EQ] = ACTIONS(1005),
    [anon_sym_GT_EQ] = ACTIONS(1005),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT_GT] = ACTIONS(1005),
    [anon_sym_is] = ACTIONS(1023),
    [anon_sym_LBRACK] = ACTIONS(1025),
    [anon_sym_RBRACK] = ACTIONS(460),
    [anon_sym_RBRACE] = ACTIONS(460),
    [sym_type_conversion] = ACTIONS(460),
    [sym_comment] = ACTIONS(3),
  },
  [406] = {
    [sym_string] = STATE(404),
    [aux_sym_concatenated_string_repeat1] = STATE(404),
    [anon_sym_DOT] = ACTIONS(401),
    [anon_sym_LPAREN] = ACTIONS(401),
    [anon_sym_RPAREN] = ACTIONS(401),
    [anon_sym_COMMA] = ACTIONS(401),
    [anon_sym_STAR] = ACTIONS(403),
    [anon_sym_GT_GT] = ACTIONS(401),
    [anon_sym_if] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(401),
    [anon_sym_else] = ACTIONS(401),
    [anon_sym_async] = ACTIONS(401),
    [anon_sym_for] = ACTIONS(401),
    [anon_sym_in] = ACTIONS(401),
    [anon_sym_EQ] = ACTIONS(403),
    [anon_sym_AT] = ACTIONS(401),
    [anon_sym_not] = ACTIONS(401),
    [anon_sym_and] = ACTIONS(401),
    [anon_sym_or] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(401),
    [anon_sym_DASH] = ACTIONS(401),
    [anon_sym_SLASH] = ACTIONS(403),
    [anon_sym_PERCENT] = ACTIONS(401),
    [anon_sym_SLASH_SLASH] = ACTIONS(401),
    [anon_sym_STAR_STAR] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(401),
    [anon_sym_AMP] = ACTIONS(401),
    [anon_sym_CARET] = ACTIONS(401),
    [anon_sym_LT_LT] = ACTIONS(401),
    [anon_sym_LT] = ACTIONS(403),
    [anon_sym_LT_EQ] = ACTIONS(401),
    [anon_sym_EQ_EQ] = ACTIONS(401),
    [anon_sym_BANG_EQ] = ACTIONS(401),
    [anon_sym_GT_EQ] = ACTIONS(401),
    [anon_sym_GT] = ACTIONS(403),
    [anon_sym_LT_GT] = ACTIONS(401),
    [anon_sym_is] = ACTIONS(401),
    [anon_sym_LBRACK] = ACTIONS(401),
    [anon_sym_RBRACK] = ACTIONS(401),
    [anon_sym_RBRACE] = ACTIONS(401),
    [sym_type_conversion] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [407] = {
    [ts_builtin_sym_end] = ACTIONS(1027),
    [sym_identifier] = ACTIONS(1029),
    [anon_sym_import] = ACTIONS(1029),
    [anon_sym_from] = ACTIONS(1029),
    [anon_sym_LPAREN] = ACTIONS(1027),
    [anon_sym_print] = ACTIONS(1029),
    [anon_sym_assert] = ACTIONS(1029),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_del] = ACTIONS(1029),
    [anon_sym_raise] = ACTIONS(1029),
    [anon_sym_pass] = ACTIONS(1029),
    [anon_sym_break] = ACTIONS(1029),
    [anon_sym_continue] = ACTIONS(1029),
    [anon_sym_if] = ACTIONS(1029),
    [anon_sym_async] = ACTIONS(1029),
    [anon_sym_for] = ACTIONS(1029),
    [anon_sym_while] = ACTIONS(1029),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_finally] = ACTIONS(1029),
    [anon_sym_with] = ACTIONS(1029),
    [anon_sym_def] = ACTIONS(1029),
    [anon_sym_global] = ACTIONS(1029),
    [anon_sym_nonlocal] = ACTIONS(1029),
    [anon_sym_exec] = ACTIONS(1029),
    [anon_sym_class] = ACTIONS(1029),
    [anon_sym_AT] = ACTIONS(1027),
    [anon_sym_not] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [anon_sym_lambda] = ACTIONS(1029),
    [anon_sym_yield] = ACTIONS(1029),
    [anon_sym_LBRACK] = ACTIONS(1027),
    [sym_ellipsis] = ACTIONS(1027),
    [anon_sym_LBRACE] = ACTIONS(1027),
    [sym_integer] = ACTIONS(1029),
    [sym_float] = ACTIONS(1027),
    [sym_true] = ACTIONS(1029),
    [sym_false] = ACTIONS(1029),
    [sym_none] = ACTIONS(1029),
    [anon_sym_await] = ACTIONS(1029),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1027),
  },
  [408] = {
    [ts_builtin_sym_end] = ACTIONS(1031),
    [sym_identifier] = ACTIONS(1033),
    [anon_sym_import] = ACTIONS(1033),
    [anon_sym_from] = ACTIONS(1033),
    [anon_sym_LPAREN] = ACTIONS(1031),
    [anon_sym_print] = ACTIONS(1033),
    [anon_sym_assert] = ACTIONS(1033),
    [anon_sym_return] = ACTIONS(1033),
    [anon_sym_del] = ACTIONS(1033),
    [anon_sym_raise] = ACTIONS(1033),
    [anon_sym_pass] = ACTIONS(1033),
    [anon_sym_break] = ACTIONS(1033),
    [anon_sym_continue] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1033),
    [anon_sym_async] = ACTIONS(1033),
    [anon_sym_for] = ACTIONS(1033),
    [anon_sym_while] = ACTIONS(1033),
    [anon_sym_try] = ACTIONS(1033),
    [anon_sym_finally] = ACTIONS(1033),
    [anon_sym_with] = ACTIONS(1033),
    [anon_sym_def] = ACTIONS(1033),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_nonlocal] = ACTIONS(1033),
    [anon_sym_exec] = ACTIONS(1033),
    [anon_sym_class] = ACTIONS(1033),
    [anon_sym_AT] = ACTIONS(1031),
    [anon_sym_not] = ACTIONS(1033),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_TILDE] = ACTIONS(1031),
    [anon_sym_lambda] = ACTIONS(1033),
    [anon_sym_yield] = ACTIONS(1033),
    [anon_sym_LBRACK] = ACTIONS(1031),
    [sym_ellipsis] = ACTIONS(1031),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [sym_integer] = ACTIONS(1033),
    [sym_float] = ACTIONS(1031),
    [sym_true] = ACTIONS(1033),
    [sym_false] = ACTIONS(1033),
    [sym_none] = ACTIONS(1033),
    [anon_sym_await] = ACTIONS(1033),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1031),
  },
  [409] = {
    [sym_identifier] = ACTIONS(1029),
    [anon_sym_import] = ACTIONS(1029),
    [anon_sym_from] = ACTIONS(1029),
    [anon_sym_LPAREN] = ACTIONS(1027),
    [anon_sym_print] = ACTIONS(1029),
    [anon_sym_assert] = ACTIONS(1029),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_del] = ACTIONS(1029),
    [anon_sym_raise] = ACTIONS(1029),
    [anon_sym_pass] = ACTIONS(1029),
    [anon_sym_break] = ACTIONS(1029),
    [anon_sym_continue] = ACTIONS(1029),
    [anon_sym_if] = ACTIONS(1029),
    [anon_sym_async] = ACTIONS(1029),
    [anon_sym_for] = ACTIONS(1029),
    [anon_sym_while] = ACTIONS(1029),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_finally] = ACTIONS(1029),
    [anon_sym_with] = ACTIONS(1029),
    [anon_sym_def] = ACTIONS(1029),
    [anon_sym_global] = ACTIONS(1029),
    [anon_sym_nonlocal] = ACTIONS(1029),
    [anon_sym_exec] = ACTIONS(1029),
    [anon_sym_class] = ACTIONS(1029),
    [anon_sym_AT] = ACTIONS(1027),
    [anon_sym_not] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [anon_sym_lambda] = ACTIONS(1029),
    [anon_sym_yield] = ACTIONS(1029),
    [anon_sym_LBRACK] = ACTIONS(1027),
    [sym_ellipsis] = ACTIONS(1027),
    [anon_sym_LBRACE] = ACTIONS(1027),
    [sym_integer] = ACTIONS(1029),
    [sym_float] = ACTIONS(1027),
    [sym_true] = ACTIONS(1029),
    [sym_false] = ACTIONS(1029),
    [sym_none] = ACTIONS(1029),
    [anon_sym_await] = ACTIONS(1029),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1027),
    [sym__string_start] = ACTIONS(1027),
  },
  [410] = {
    [sym_identifier] = ACTIONS(1033),
    [anon_sym_import] = ACTIONS(1033),
    [anon_sym_from] = ACTIONS(1033),
    [anon_sym_LPAREN] = ACTIONS(1031),
    [anon_sym_print] = ACTIONS(1033),
    [anon_sym_assert] = ACTIONS(1033),
    [anon_sym_return] = ACTIONS(1033),
    [anon_sym_del] = ACTIONS(1033),
    [anon_sym_raise] = ACTIONS(1033),
    [anon_sym_pass] = ACTIONS(1033),
    [anon_sym_break] = ACTIONS(1033),
    [anon_sym_continue] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1033),
    [anon_sym_async] = ACTIONS(1033),
    [anon_sym_for] = ACTIONS(1033),
    [anon_sym_while] = ACTIONS(1033),
    [anon_sym_try] = ACTIONS(1033),
    [anon_sym_finally] = ACTIONS(1033),
    [anon_sym_with] = ACTIONS(1033),
    [anon_sym_def] = ACTIONS(1033),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_nonlocal] = ACTIONS(1033),
    [anon_sym_exec] = ACTIONS(1033),
    [anon_sym_class] = ACTIONS(1033),
    [anon_sym_AT] = ACTIONS(1031),
    [anon_sym_not] = ACTIONS(1033),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_TILDE] = ACTIONS(1031),
    [anon_sym_lambda] = ACTIONS(1033),
    [anon_sym_yield] = ACTIONS(1033),
    [anon_sym_LBRACK] = ACTIONS(1031),
    [sym_ellipsis] = ACTIONS(1031),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [sym_integer] = ACTIONS(1033),
    [sym_float] = ACTIONS(1031),
    [sym_true] = ACTIONS(1033),
    [sym_false] = ACTIONS(1033),
    [sym_none] = ACTIONS(1033),
    [anon_sym_await] = ACTIONS(1033),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1031),
    [sym__string_start] = ACTIONS(1031),
  },
  [411] = {
    [ts_builtin_sym_end] = ACTIONS(1035),
    [sym_identifier] = ACTIONS(1037),
    [anon_sym_import] = ACTIONS(1037),
    [anon_sym_from] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(1035),
    [anon_sym_print] = ACTIONS(1037),
    [anon_sym_assert] = ACTIONS(1037),
    [anon_sym_return] = ACTIONS(1037),
    [anon_sym_del] = ACTIONS(1037),
    [anon_sym_raise] = ACTIONS(1037),
    [anon_sym_pass] = ACTIONS(1037),
    [anon_sym_break] = ACTIONS(1037),
    [anon_sym_continue] = ACTIONS(1037),
    [anon_sym_if] = ACTIONS(1037),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1037),
    [anon_sym_while] = ACTIONS(1037),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_with] = ACTIONS(1037),
    [anon_sym_def] = ACTIONS(1037),
    [anon_sym_global] = ACTIONS(1037),
    [anon_sym_nonlocal] = ACTIONS(1037),
    [anon_sym_exec] = ACTIONS(1037),
    [anon_sym_class] = ACTIONS(1037),
    [anon_sym_AT] = ACTIONS(1035),
    [anon_sym_not] = ACTIONS(1037),
    [anon_sym_PLUS] = ACTIONS(1035),
    [anon_sym_DASH] = ACTIONS(1035),
    [anon_sym_TILDE] = ACTIONS(1035),
    [anon_sym_lambda] = ACTIONS(1037),
    [anon_sym_yield] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1035),
    [sym_ellipsis] = ACTIONS(1035),
    [anon_sym_LBRACE] = ACTIONS(1035),
    [sym_integer] = ACTIONS(1037),
    [sym_float] = ACTIONS(1035),
    [sym_true] = ACTIONS(1037),
    [sym_false] = ACTIONS(1037),
    [sym_none] = ACTIONS(1037),
    [anon_sym_await] = ACTIONS(1037),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1035),
  },
  [412] = {
    [sym_identifier] = ACTIONS(1039),
    [anon_sym_import] = ACTIONS(1039),
    [anon_sym_from] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1041),
    [anon_sym_print] = ACTIONS(1039),
    [anon_sym_assert] = ACTIONS(1039),
    [anon_sym_return] = ACTIONS(1039),
    [anon_sym_del] = ACTIONS(1039),
    [anon_sym_raise] = ACTIONS(1039),
    [anon_sym_pass] = ACTIONS(1039),
    [anon_sym_break] = ACTIONS(1039),
    [anon_sym_continue] = ACTIONS(1039),
    [anon_sym_if] = ACTIONS(1039),
    [anon_sym_async] = ACTIONS(1039),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1039),
    [anon_sym_try] = ACTIONS(1039),
    [anon_sym_with] = ACTIONS(1039),
    [anon_sym_def] = ACTIONS(1039),
    [anon_sym_global] = ACTIONS(1039),
    [anon_sym_nonlocal] = ACTIONS(1039),
    [anon_sym_exec] = ACTIONS(1039),
    [anon_sym_class] = ACTIONS(1039),
    [anon_sym_AT] = ACTIONS(1041),
    [anon_sym_not] = ACTIONS(1039),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_TILDE] = ACTIONS(1041),
    [anon_sym_lambda] = ACTIONS(1039),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(1041),
    [sym_ellipsis] = ACTIONS(1041),
    [anon_sym_LBRACE] = ACTIONS(1041),
    [sym_integer] = ACTIONS(1039),
    [sym_float] = ACTIONS(1041),
    [sym_true] = ACTIONS(1039),
    [sym_false] = ACTIONS(1039),
    [sym_none] = ACTIONS(1039),
    [anon_sym_await] = ACTIONS(1039),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1041),
    [sym__string_start] = ACTIONS(1041),
  },
  [413] = {
    [sym_identifier] = ACTIONS(1043),
    [anon_sym_import] = ACTIONS(1043),
    [anon_sym_from] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(1045),
    [anon_sym_print] = ACTIONS(1043),
    [anon_sym_assert] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1043),
    [anon_sym_del] = ACTIONS(1043),
    [anon_sym_raise] = ACTIONS(1043),
    [anon_sym_pass] = ACTIONS(1043),
    [anon_sym_break] = ACTIONS(1043),
    [anon_sym_continue] = ACTIONS(1043),
    [anon_sym_if] = ACTIONS(1043),
    [anon_sym_async] = ACTIONS(1043),
    [anon_sym_for] = ACTIONS(1043),
    [anon_sym_while] = ACTIONS(1043),
    [anon_sym_try] = ACTIONS(1043),
    [anon_sym_with] = ACTIONS(1043),
    [anon_sym_def] = ACTIONS(1043),
    [anon_sym_global] = ACTIONS(1043),
    [anon_sym_nonlocal] = ACTIONS(1043),
    [anon_sym_exec] = ACTIONS(1043),
    [anon_sym_class] = ACTIONS(1043),
    [anon_sym_AT] = ACTIONS(1045),
    [anon_sym_not] = ACTIONS(1043),
    [anon_sym_PLUS] = ACTIONS(1045),
    [anon_sym_DASH] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_lambda] = ACTIONS(1043),
    [anon_sym_yield] = ACTIONS(1043),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [sym_ellipsis] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1043),
    [sym_float] = ACTIONS(1045),
    [sym_true] = ACTIONS(1043),
    [sym_false] = ACTIONS(1043),
    [sym_none] = ACTIONS(1043),
    [anon_sym_await] = ACTIONS(1043),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
  },
  [414] = {
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_import] = ACTIONS(1047),
    [anon_sym_from] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1049),
    [anon_sym_print] = ACTIONS(1047),
    [anon_sym_assert] = ACTIONS(1047),
    [anon_sym_return] = ACTIONS(1047),
    [anon_sym_del] = ACTIONS(1047),
    [anon_sym_raise] = ACTIONS(1047),
    [anon_sym_pass] = ACTIONS(1047),
    [anon_sym_break] = ACTIONS(1047),
    [anon_sym_continue] = ACTIONS(1047),
    [anon_sym_if] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_for] = ACTIONS(1047),
    [anon_sym_while] = ACTIONS(1047),
    [anon_sym_try] = ACTIONS(1047),
    [anon_sym_with] = ACTIONS(1047),
    [anon_sym_def] = ACTIONS(1047),
    [anon_sym_global] = ACTIONS(1047),
    [anon_sym_nonlocal] = ACTIONS(1047),
    [anon_sym_exec] = ACTIONS(1047),
    [anon_sym_class] = ACTIONS(1047),
    [anon_sym_AT] = ACTIONS(1049),
    [anon_sym_not] = ACTIONS(1047),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_DASH] = ACTIONS(1049),
    [anon_sym_TILDE] = ACTIONS(1049),
    [anon_sym_lambda] = ACTIONS(1047),
    [anon_sym_yield] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [sym_ellipsis] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [sym_integer] = ACTIONS(1047),
    [sym_float] = ACTIONS(1049),
    [sym_true] = ACTIONS(1047),
    [sym_false] = ACTIONS(1047),
    [sym_none] = ACTIONS(1047),
    [anon_sym_await] = ACTIONS(1047),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1049),
    [sym__string_start] = ACTIONS(1049),
  },
  [415] = {
    [ts_builtin_sym_end] = ACTIONS(984),
    [sym_identifier] = ACTIONS(982),
    [anon_sym_import] = ACTIONS(982),
    [anon_sym_from] = ACTIONS(982),
    [anon_sym_LPAREN] = ACTIONS(984),
    [anon_sym_print] = ACTIONS(982),
    [anon_sym_assert] = ACTIONS(982),
    [anon_sym_return] = ACTIONS(982),
    [anon_sym_del] = ACTIONS(982),
    [anon_sym_raise] = ACTIONS(982),
    [anon_sym_pass] = ACTIONS(982),
    [anon_sym_break] = ACTIONS(982),
    [anon_sym_continue] = ACTIONS(982),
    [anon_sym_if] = ACTIONS(982),
    [anon_sym_async] = ACTIONS(982),
    [anon_sym_for] = ACTIONS(982),
    [anon_sym_while] = ACTIONS(982),
    [anon_sym_try] = ACTIONS(982),
    [anon_sym_with] = ACTIONS(982),
    [anon_sym_def] = ACTIONS(982),
    [anon_sym_global] = ACTIONS(982),
    [anon_sym_nonlocal] = ACTIONS(982),
    [anon_sym_exec] = ACTIONS(982),
    [anon_sym_class] = ACTIONS(982),
    [anon_sym_AT] = ACTIONS(984),
    [anon_sym_not] = ACTIONS(982),
    [anon_sym_PLUS] = ACTIONS(984),
    [anon_sym_DASH] = ACTIONS(984),
    [anon_sym_TILDE] = ACTIONS(984),
    [anon_sym_lambda] = ACTIONS(982),
    [anon_sym_yield] = ACTIONS(982),
    [anon_sym_LBRACK] = ACTIONS(984),
    [sym_ellipsis] = ACTIONS(984),
    [anon_sym_LBRACE] = ACTIONS(984),
    [sym_integer] = ACTIONS(982),
    [sym_float] = ACTIONS(984),
    [sym_true] = ACTIONS(982),
    [sym_false] = ACTIONS(982),
    [sym_none] = ACTIONS(982),
    [anon_sym_await] = ACTIONS(982),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(984),
  },
  [416] = {
    [sym_identifier] = ACTIONS(600),
    [anon_sym_import] = ACTIONS(600),
    [anon_sym_from] = ACTIONS(600),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_print] = ACTIONS(600),
    [anon_sym_assert] = ACTIONS(600),
    [anon_sym_return] = ACTIONS(600),
    [anon_sym_del] = ACTIONS(600),
    [anon_sym_raise] = ACTIONS(600),
    [anon_sym_pass] = ACTIONS(600),
    [anon_sym_break] = ACTIONS(600),
    [anon_sym_continue] = ACTIONS(600),
    [anon_sym_if] = ACTIONS(600),
    [anon_sym_async] = ACTIONS(600),
    [anon_sym_for] = ACTIONS(600),
    [anon_sym_while] = ACTIONS(600),
    [anon_sym_try] = ACTIONS(600),
    [anon_sym_with] = ACTIONS(600),
    [anon_sym_def] = ACTIONS(600),
    [anon_sym_global] = ACTIONS(600),
    [anon_sym_nonlocal] = ACTIONS(600),
    [anon_sym_exec] = ACTIONS(600),
    [anon_sym_class] = ACTIONS(600),
    [anon_sym_AT] = ACTIONS(598),
    [anon_sym_not] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(598),
    [anon_sym_DASH] = ACTIONS(598),
    [anon_sym_TILDE] = ACTIONS(598),
    [anon_sym_lambda] = ACTIONS(600),
    [anon_sym_yield] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(598),
    [sym_ellipsis] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(598),
    [sym_integer] = ACTIONS(600),
    [sym_float] = ACTIONS(598),
    [sym_true] = ACTIONS(600),
    [sym_false] = ACTIONS(600),
    [sym_none] = ACTIONS(600),
    [anon_sym_await] = ACTIONS(600),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(598),
    [sym__string_start] = ACTIONS(598),
  },
  [417] = {
    [ts_builtin_sym_end] = ACTIONS(1051),
    [sym_identifier] = ACTIONS(1053),
    [anon_sym_import] = ACTIONS(1053),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_print] = ACTIONS(1053),
    [anon_sym_assert] = ACTIONS(1053),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_del] = ACTIONS(1053),
    [anon_sym_raise] = ACTIONS(1053),
    [anon_sym_pass] = ACTIONS(1053),
    [anon_sym_break] = ACTIONS(1053),
    [anon_sym_continue] = ACTIONS(1053),
    [anon_sym_if] = ACTIONS(1053),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_for] = ACTIONS(1053),
    [anon_sym_while] = ACTIONS(1053),
    [anon_sym_try] = ACTIONS(1053),
    [anon_sym_with] = ACTIONS(1053),
    [anon_sym_def] = ACTIONS(1053),
    [anon_sym_global] = ACTIONS(1053),
    [anon_sym_nonlocal] = ACTIONS(1053),
    [anon_sym_exec] = ACTIONS(1053),
    [anon_sym_class] = ACTIONS(1053),
    [anon_sym_AT] = ACTIONS(1051),
    [anon_sym_not] = ACTIONS(1053),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1051),
    [anon_sym_lambda] = ACTIONS(1053),
    [anon_sym_yield] = ACTIONS(1053),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [sym_ellipsis] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1051),
    [sym_integer] = ACTIONS(1053),
    [sym_float] = ACTIONS(1051),
    [sym_true] = ACTIONS(1053),
    [sym_false] = ACTIONS(1053),
    [sym_none] = ACTIONS(1053),
    [anon_sym_await] = ACTIONS(1053),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1051),
  },
  [418] = {
    [sym_argument_list] = STATE(498),
    [sym_generator_expression] = STATE(498),
    [anon_sym_DOT] = ACTIONS(997),
    [anon_sym_LPAREN] = ACTIONS(999),
    [anon_sym_RPAREN] = ACTIONS(496),
    [anon_sym_COMMA] = ACTIONS(496),
    [anon_sym_STAR] = ACTIONS(1001),
    [anon_sym_GT_GT] = ACTIONS(1003),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_COLON] = ACTIONS(496),
    [anon_sym_else] = ACTIONS(496),
    [anon_sym_async] = ACTIONS(496),
    [anon_sym_for] = ACTIONS(496),
    [anon_sym_in] = ACTIONS(496),
    [anon_sym_EQ] = ACTIONS(498),
    [anon_sym_AT] = ACTIONS(1007),
    [anon_sym_not] = ACTIONS(496),
    [anon_sym_and] = ACTIONS(496),
    [anon_sym_or] = ACTIONS(496),
    [anon_sym_PLUS] = ACTIONS(1011),
    [anon_sym_DASH] = ACTIONS(1011),
    [anon_sym_SLASH] = ACTIONS(1001),
    [anon_sym_PERCENT] = ACTIONS(1007),
    [anon_sym_SLASH_SLASH] = ACTIONS(1007),
    [anon_sym_STAR_STAR] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_AMP] = ACTIONS(1017),
    [anon_sym_CARET] = ACTIONS(1019),
    [anon_sym_LT_LT] = ACTIONS(1003),
    [anon_sym_LT] = ACTIONS(498),
    [anon_sym_LT_EQ] = ACTIONS(496),
    [anon_sym_EQ_EQ] = ACTIONS(496),
    [anon_sym_BANG_EQ] = ACTIONS(496),
    [anon_sym_GT_EQ] = ACTIONS(496),
    [anon_sym_GT] = ACTIONS(498),
    [anon_sym_LT_GT] = ACTIONS(496),
    [anon_sym_is] = ACTIONS(496),
    [anon_sym_LBRACK] = ACTIONS(1025),
    [anon_sym_RBRACK] = ACTIONS(496),
    [anon_sym_RBRACE] = ACTIONS(496),
    [sym_type_conversion] = ACTIONS(496),
    [sym_comment] = ACTIONS(3),
  },
  [419] = {
    [ts_builtin_sym_end] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_from] = ACTIONS(1057),
    [anon_sym_LPAREN] = ACTIONS(1055),
    [anon_sym_print] = ACTIONS(1057),
    [anon_sym_assert] = ACTIONS(1057),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_del] = ACTIONS(1057),
    [anon_sym_raise] = ACTIONS(1057),
    [anon_sym_pass] = ACTIONS(1057),
    [anon_sym_break] = ACTIONS(1057),
    [anon_sym_continue] = ACTIONS(1057),
    [anon_sym_if] = ACTIONS(1057),
    [anon_sym_async] = ACTIONS(1057),
    [anon_sym_for] = ACTIONS(1057),
    [anon_sym_while] = ACTIONS(1057),
    [anon_sym_try] = ACTIONS(1057),
    [anon_sym_with] = ACTIONS(1057),
    [anon_sym_def] = ACTIONS(1057),
    [anon_sym_global] = ACTIONS(1057),
    [anon_sym_nonlocal] = ACTIONS(1057),
    [anon_sym_exec] = ACTIONS(1057),
    [anon_sym_class] = ACTIONS(1057),
    [anon_sym_AT] = ACTIONS(1055),
    [anon_sym_not] = ACTIONS(1057),
    [anon_sym_PLUS] = ACTIONS(1055),
    [anon_sym_DASH] = ACTIONS(1055),
    [anon_sym_TILDE] = ACTIONS(1055),
    [anon_sym_lambda] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1055),
    [sym_ellipsis] = ACTIONS(1055),
    [anon_sym_LBRACE] = ACTIONS(1055),
    [sym_integer] = ACTIONS(1057),
    [sym_float] = ACTIONS(1055),
    [sym_true] = ACTIONS(1057),
    [sym_false] = ACTIONS(1057),
    [sym_none] = ACTIONS(1057),
    [anon_sym_await] = ACTIONS(1057),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1055),
  },
  [420] = {
    [ts_builtin_sym_end] = ACTIONS(1059),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_import] = ACTIONS(1061),
    [anon_sym_from] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1059),
    [anon_sym_print] = ACTIONS(1061),
    [anon_sym_assert] = ACTIONS(1061),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_del] = ACTIONS(1061),
    [anon_sym_raise] = ACTIONS(1061),
    [anon_sym_pass] = ACTIONS(1061),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_continue] = ACTIONS(1061),
    [anon_sym_if] = ACTIONS(1061),
    [anon_sym_async] = ACTIONS(1061),
    [anon_sym_for] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(1061),
    [anon_sym_try] = ACTIONS(1061),
    [anon_sym_with] = ACTIONS(1061),
    [anon_sym_def] = ACTIONS(1061),
    [anon_sym_global] = ACTIONS(1061),
    [anon_sym_nonlocal] = ACTIONS(1061),
    [anon_sym_exec] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(1061),
    [anon_sym_AT] = ACTIONS(1059),
    [anon_sym_not] = ACTIONS(1061),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_lambda] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1061),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [sym_ellipsis] = ACTIONS(1059),
    [anon_sym_LBRACE] = ACTIONS(1059),
    [sym_integer] = ACTIONS(1061),
    [sym_float] = ACTIONS(1059),
    [sym_true] = ACTIONS(1061),
    [sym_false] = ACTIONS(1061),
    [sym_none] = ACTIONS(1061),
    [anon_sym_await] = ACTIONS(1061),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1059),
  },
  [421] = {
    [ts_builtin_sym_end] = ACTIONS(1063),
    [sym_identifier] = ACTIONS(1065),
    [anon_sym_import] = ACTIONS(1065),
    [anon_sym_from] = ACTIONS(1065),
    [anon_sym_LPAREN] = ACTIONS(1063),
    [anon_sym_print] = ACTIONS(1065),
    [anon_sym_assert] = ACTIONS(1065),
    [anon_sym_return] = ACTIONS(1065),
    [anon_sym_del] = ACTIONS(1065),
    [anon_sym_raise] = ACTIONS(1065),
    [anon_sym_pass] = ACTIONS(1065),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_continue] = ACTIONS(1065),
    [anon_sym_if] = ACTIONS(1065),
    [anon_sym_async] = ACTIONS(1065),
    [anon_sym_for] = ACTIONS(1065),
    [anon_sym_while] = ACTIONS(1065),
    [anon_sym_try] = ACTIONS(1065),
    [anon_sym_with] = ACTIONS(1065),
    [anon_sym_def] = ACTIONS(1065),
    [anon_sym_global] = ACTIONS(1065),
    [anon_sym_nonlocal] = ACTIONS(1065),
    [anon_sym_exec] = ACTIONS(1065),
    [anon_sym_class] = ACTIONS(1065),
    [anon_sym_AT] = ACTIONS(1063),
    [anon_sym_not] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_DASH] = ACTIONS(1063),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_lambda] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(1063),
    [sym_ellipsis] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [sym_integer] = ACTIONS(1065),
    [sym_float] = ACTIONS(1063),
    [sym_true] = ACTIONS(1065),
    [sym_false] = ACTIONS(1065),
    [sym_none] = ACTIONS(1065),
    [anon_sym_await] = ACTIONS(1065),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1063),
  },
  [422] = {
    [sym_argument_list] = STATE(498),
    [sym_generator_expression] = STATE(498),
    [anon_sym_DOT] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(999),
    [anon_sym_RPAREN] = ACTIONS(488),
    [anon_sym_COMMA] = ACTIONS(488),
    [anon_sym_STAR] = ACTIONS(1001),
    [anon_sym_GT_GT] = ACTIONS(1003),
    [anon_sym_if] = ACTIONS(488),
    [anon_sym_COLON] = ACTIONS(488),
    [anon_sym_else] = ACTIONS(488),
    [anon_sym_async] = ACTIONS(488),
    [anon_sym_for] = ACTIONS(488),
    [anon_sym_in] = ACTIONS(488),
    [anon_sym_EQ] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(1007),
    [anon_sym_not] = ACTIONS(488),
    [anon_sym_and] = ACTIONS(488),
    [anon_sym_or] = ACTIONS(488),
    [anon_sym_PLUS] = ACTIONS(1011),
    [anon_sym_DASH] = ACTIONS(1011),
    [anon_sym_SLASH] = ACTIONS(1001),
    [anon_sym_PERCENT] = ACTIONS(1007),
    [anon_sym_SLASH_SLASH] = ACTIONS(1007),
    [anon_sym_STAR_STAR] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(488),
    [anon_sym_AMP] = ACTIONS(488),
    [anon_sym_CARET] = ACTIONS(488),
    [anon_sym_LT_LT] = ACTIONS(1003),
    [anon_sym_LT] = ACTIONS(490),
    [anon_sym_LT_EQ] = ACTIONS(488),
    [anon_sym_EQ_EQ] = ACTIONS(488),
    [anon_sym_BANG_EQ] = ACTIONS(488),
    [anon_sym_GT_EQ] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(490),
    [anon_sym_LT_GT] = ACTIONS(488),
    [anon_sym_is] = ACTIONS(488),
    [anon_sym_LBRACK] = ACTIONS(488),
    [anon_sym_RBRACK] = ACTIONS(488),
    [anon_sym_RBRACE] = ACTIONS(488),
    [sym_type_conversion] = ACTIONS(488),
    [sym_comment] = ACTIONS(3),
  },
  [423] = {
    [ts_builtin_sym_end] = ACTIONS(1067),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_import] = ACTIONS(1069),
    [anon_sym_from] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(1067),
    [anon_sym_print] = ACTIONS(1069),
    [anon_sym_assert] = ACTIONS(1069),
    [anon_sym_return] = ACTIONS(1069),
    [anon_sym_del] = ACTIONS(1069),
    [anon_sym_raise] = ACTIONS(1069),
    [anon_sym_pass] = ACTIONS(1069),
    [anon_sym_break] = ACTIONS(1069),
    [anon_sym_continue] = ACTIONS(1069),
    [anon_sym_if] = ACTIONS(1069),
    [anon_sym_async] = ACTIONS(1069),
    [anon_sym_for] = ACTIONS(1069),
    [anon_sym_while] = ACTIONS(1069),
    [anon_sym_try] = ACTIONS(1069),
    [anon_sym_with] = ACTIONS(1069),
    [anon_sym_def] = ACTIONS(1069),
    [anon_sym_global] = ACTIONS(1069),
    [anon_sym_nonlocal] = ACTIONS(1069),
    [anon_sym_exec] = ACTIONS(1069),
    [anon_sym_class] = ACTIONS(1069),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_lambda] = ACTIONS(1069),
    [anon_sym_yield] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [sym_ellipsis] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(1067),
    [sym_integer] = ACTIONS(1069),
    [sym_float] = ACTIONS(1067),
    [sym_true] = ACTIONS(1069),
    [sym_false] = ACTIONS(1069),
    [sym_none] = ACTIONS(1069),
    [anon_sym_await] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1067),
  },
  [424] = {
    [ts_builtin_sym_end] = ACTIONS(566),
    [sym_identifier] = ACTIONS(564),
    [anon_sym_import] = ACTIONS(564),
    [anon_sym_from] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_print] = ACTIONS(564),
    [anon_sym_assert] = ACTIONS(564),
    [anon_sym_return] = ACTIONS(564),
    [anon_sym_del] = ACTIONS(564),
    [anon_sym_raise] = ACTIONS(564),
    [anon_sym_pass] = ACTIONS(564),
    [anon_sym_break] = ACTIONS(564),
    [anon_sym_continue] = ACTIONS(564),
    [anon_sym_if] = ACTIONS(564),
    [anon_sym_async] = ACTIONS(564),
    [anon_sym_for] = ACTIONS(564),
    [anon_sym_while] = ACTIONS(564),
    [anon_sym_try] = ACTIONS(564),
    [anon_sym_with] = ACTIONS(564),
    [anon_sym_def] = ACTIONS(564),
    [anon_sym_global] = ACTIONS(564),
    [anon_sym_nonlocal] = ACTIONS(564),
    [anon_sym_exec] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(564),
    [anon_sym_AT] = ACTIONS(566),
    [anon_sym_not] = ACTIONS(564),
    [anon_sym_PLUS] = ACTIONS(566),
    [anon_sym_DASH] = ACTIONS(566),
    [anon_sym_TILDE] = ACTIONS(566),
    [anon_sym_lambda] = ACTIONS(564),
    [anon_sym_yield] = ACTIONS(564),
    [anon_sym_LBRACK] = ACTIONS(566),
    [sym_ellipsis] = ACTIONS(566),
    [anon_sym_LBRACE] = ACTIONS(566),
    [sym_integer] = ACTIONS(564),
    [sym_float] = ACTIONS(566),
    [sym_true] = ACTIONS(564),
    [sym_false] = ACTIONS(564),
    [sym_none] = ACTIONS(564),
    [anon_sym_await] = ACTIONS(564),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(566),
  },
  [425] = {
    [ts_builtin_sym_end] = ACTIONS(1071),
    [sym_identifier] = ACTIONS(1073),
    [anon_sym_import] = ACTIONS(1073),
    [anon_sym_from] = ACTIONS(1073),
    [anon_sym_LPAREN] = ACTIONS(1071),
    [anon_sym_print] = ACTIONS(1073),
    [anon_sym_assert] = ACTIONS(1073),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_del] = ACTIONS(1073),
    [anon_sym_raise] = ACTIONS(1073),
    [anon_sym_pass] = ACTIONS(1073),
    [anon_sym_break] = ACTIONS(1073),
    [anon_sym_continue] = ACTIONS(1073),
    [anon_sym_if] = ACTIONS(1073),
    [anon_sym_async] = ACTIONS(1073),
    [anon_sym_for] = ACTIONS(1073),
    [anon_sym_while] = ACTIONS(1073),
    [anon_sym_try] = ACTIONS(1073),
    [anon_sym_with] = ACTIONS(1073),
    [anon_sym_def] = ACTIONS(1073),
    [anon_sym_global] = ACTIONS(1073),
    [anon_sym_nonlocal] = ACTIONS(1073),
    [anon_sym_exec] = ACTIONS(1073),
    [anon_sym_class] = ACTIONS(1073),
    [anon_sym_AT] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_DASH] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_lambda] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1073),
    [anon_sym_LBRACK] = ACTIONS(1071),
    [sym_ellipsis] = ACTIONS(1071),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [sym_integer] = ACTIONS(1073),
    [sym_float] = ACTIONS(1071),
    [sym_true] = ACTIONS(1073),
    [sym_false] = ACTIONS(1073),
    [sym_none] = ACTIONS(1073),
    [anon_sym_await] = ACTIONS(1073),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1071),
  },
  [426] = {
    [ts_builtin_sym_end] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(1077),
    [anon_sym_import] = ACTIONS(1077),
    [anon_sym_from] = ACTIONS(1077),
    [anon_sym_LPAREN] = ACTIONS(1075),
    [anon_sym_print] = ACTIONS(1077),
    [anon_sym_assert] = ACTIONS(1077),
    [anon_sym_return] = ACTIONS(1077),
    [anon_sym_del] = ACTIONS(1077),
    [anon_sym_raise] = ACTIONS(1077),
    [anon_sym_pass] = ACTIONS(1077),
    [anon_sym_break] = ACTIONS(1077),
    [anon_sym_continue] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1077),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_for] = ACTIONS(1077),
    [anon_sym_while] = ACTIONS(1077),
    [anon_sym_try] = ACTIONS(1077),
    [anon_sym_with] = ACTIONS(1077),
    [anon_sym_def] = ACTIONS(1077),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_nonlocal] = ACTIONS(1077),
    [anon_sym_exec] = ACTIONS(1077),
    [anon_sym_class] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1075),
    [anon_sym_not] = ACTIONS(1077),
    [anon_sym_PLUS] = ACTIONS(1075),
    [anon_sym_DASH] = ACTIONS(1075),
    [anon_sym_TILDE] = ACTIONS(1075),
    [anon_sym_lambda] = ACTIONS(1077),
    [anon_sym_yield] = ACTIONS(1077),
    [anon_sym_LBRACK] = ACTIONS(1075),
    [sym_ellipsis] = ACTIONS(1075),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [sym_integer] = ACTIONS(1077),
    [sym_float] = ACTIONS(1075),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_none] = ACTIONS(1077),
    [anon_sym_await] = ACTIONS(1077),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1075),
  },
  [427] = {
    [sym_argument_list] = STATE(498),
    [sym_generator_expression] = STATE(498),
    [anon_sym_DOT] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(999),
    [anon_sym_RPAREN] = ACTIONS(488),
    [anon_sym_COMMA] = ACTIONS(488),
    [anon_sym_STAR] = ACTIONS(1001),
    [anon_sym_GT_GT] = ACTIONS(1003),
    [anon_sym_if] = ACTIONS(488),
    [anon_sym_COLON] = ACTIONS(488),
    [anon_sym_else] = ACTIONS(488),
    [anon_sym_async] = ACTIONS(488),
    [anon_sym_for] = ACTIONS(488),
    [anon_sym_in] = ACTIONS(488),
    [anon_sym_EQ] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(1007),
    [anon_sym_not] = ACTIONS(488),
    [anon_sym_and] = ACTIONS(488),
    [anon_sym_or] = ACTIONS(488),
    [anon_sym_PLUS] = ACTIONS(1011),
    [anon_sym_DASH] = ACTIONS(1011),
    [anon_sym_SLASH] = ACTIONS(1001),
    [anon_sym_PERCENT] = ACTIONS(1007),
    [anon_sym_SLASH_SLASH] = ACTIONS(1007),
    [anon_sym_STAR_STAR] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(488),
    [anon_sym_AMP] = ACTIONS(488),
    [anon_sym_CARET] = ACTIONS(1019),
    [anon_sym_LT_LT] = ACTIONS(1003),
    [anon_sym_LT] = ACTIONS(490),
    [anon_sym_LT_EQ] = ACTIONS(488),
    [anon_sym_EQ_EQ] = ACTIONS(488),
    [anon_sym_BANG_EQ] = ACTIONS(488),
    [anon_sym_GT_EQ] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(490),
    [anon_sym_LT_GT] = ACTIONS(488),
    [anon_sym_is] = ACTIONS(488),
    [anon_sym_LBRACK] = ACTIONS(488),
    [anon_sym_RBRACK] = ACTIONS(488),
    [anon_sym_RBRACE] = ACTIONS(488),
    [sym_type_conversion] = ACTIONS(488),
    [sym_comment] = ACTIONS(3),
  },
  [428] = {
    [sym_argument_list] = STATE(498),
    [sym_generator_expression] = STATE(498),
    [anon_sym_DOT] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(999),
    [anon_sym_RPAREN] = ACTIONS(488),
    [anon_sym_COMMA] = ACTIONS(488),
    [anon_sym_STAR] = ACTIONS(1001),
    [anon_sym_GT_GT] = ACTIONS(1003),
    [anon_sym_if] = ACTIONS(488),
    [anon_sym_COLON] = ACTIONS(488),
    [anon_sym_else] = ACTIONS(488),
    [anon_sym_async] = ACTIONS(488),
    [anon_sym_for] = ACTIONS(488),
    [anon_sym_in] = ACTIONS(488),
    [anon_sym_EQ] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(1007),
    [anon_sym_not] = ACTIONS(488),
    [anon_sym_and] = ACTIONS(488),
    [anon_sym_or] = ACTIONS(488),
    [anon_sym_PLUS] = ACTIONS(1011),
    [anon_sym_DASH] = ACTIONS(1011),
    [anon_sym_SLASH] = ACTIONS(1001),
    [anon_sym_PERCENT] = ACTIONS(1007),
    [anon_sym_SLASH_SLASH] = ACTIONS(1007),
    [anon_sym_STAR_STAR] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(488),
    [anon_sym_AMP] = ACTIONS(1017),
    [anon_sym_CARET] = ACTIONS(1019),
    [anon_sym_LT_LT] = ACTIONS(1003),
    [anon_sym_LT] = ACTIONS(490),
    [anon_sym_LT_EQ] = ACTIONS(488),
    [anon_sym_EQ_EQ] = ACTIONS(488),
    [anon_sym_BANG_EQ] = ACTIONS(488),
    [anon_sym_GT_EQ] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(490),
    [anon_sym_LT_GT] = ACTIONS(488),
    [anon_sym_is] = ACTIONS(488),
    [anon_sym_LBRACK] = ACTIONS(488),
    [anon_sym_RBRACK] = ACTIONS(488),
    [anon_sym_RBRACE] = ACTIONS(488),
    [sym_type_conversion] = ACTIONS(488),
    [sym_comment] = ACTIONS(3),
  },
  [429] = {
    [sym_argument_list] = STATE(498),
    [sym_generator_expression] = STATE(498),
    [anon_sym_DOT] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(999),
    [anon_sym_RPAREN] = ACTIONS(488),
    [anon_sym_COMMA] = ACTIONS(488),
    [anon_sym_STAR] = ACTIONS(490),
    [anon_sym_GT_GT] = ACTIONS(488),
    [anon_sym_if] = ACTIONS(488),
    [anon_sym_COLON] = ACTIONS(488),
    [anon_sym_else] = ACTIONS(488),
    [anon_sym_async] = ACTIONS(488),
    [anon_sym_for] = ACTIONS(488),
    [anon_sym_in] = ACTIONS(488),
    [anon_sym_EQ] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_not] = ACTIONS(488),
    [anon_sym_and] = ACTIONS(488),
    [anon_sym_or] = ACTIONS(488),
    [anon_sym_PLUS] = ACTIONS(488),
    [anon_sym_DASH] = ACTIONS(488),
    [anon_sym_SLASH] = ACTIONS(490),
    [anon_sym_PERCENT] = ACTIONS(488),
    [anon_sym_SLASH_SLASH] = ACTIONS(488),
    [anon_sym_STAR_STAR] = ACTIONS(488),
    [anon_sym_PIPE] = ACTIONS(488),
    [anon_sym_AMP] = ACTIONS(488),
    [anon_sym_CARET] = ACTIONS(488),
    [anon_sym_LT_LT] = ACTIONS(488),
    [anon_sym_LT] = ACTIONS(490),
    [anon_sym_LT_EQ] = ACTIONS(488),
    [anon_sym_EQ_EQ] = ACTIONS(488),
    [anon_sym_BANG_EQ] = ACTIONS(488),
    [anon_sym_GT_EQ] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(490),
    [anon_sym_LT_GT] = ACTIONS(488),
    [anon_sym_is] = ACTIONS(488),
    [anon_sym_LBRACK] = ACTIONS(488),
    [anon_sym_RBRACK] = ACTIONS(488),
    [anon_sym_RBRACE] = ACTIONS(488),
    [sym_type_conversion] = ACTIONS(488),
    [sym_comment] = ACTIONS(3),
  },
  [430] = {
    [sym_argument_list] = STATE(498),
    [sym_generator_expression] = STATE(498),
    [anon_sym_DOT] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(999),
    [anon_sym_RPAREN] = ACTIONS(488),
    [anon_sym_COMMA] = ACTIONS(488),
    [anon_sym_STAR] = ACTIONS(1001),
    [anon_sym_GT_GT] = ACTIONS(488),
    [anon_sym_if] = ACTIONS(488),
    [anon_sym_COLON] = ACTIONS(488),
    [anon_sym_else] = ACTIONS(488),
    [anon_sym_async] = ACTIONS(488),
    [anon_sym_for] = ACTIONS(488),
    [anon_sym_in] = ACTIONS(488),
    [anon_sym_EQ] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(1007),
    [anon_sym_not] = ACTIONS(488),
    [anon_sym_and] = ACTIONS(488),
    [anon_sym_or] = ACTIONS(488),
    [anon_sym_PLUS] = ACTIONS(488),
    [anon_sym_DASH] = ACTIONS(488),
    [anon_sym_SLASH] = ACTIONS(1001),
    [anon_sym_PERCENT] = ACTIONS(1007),
    [anon_sym_SLASH_SLASH] = ACTIONS(1007),
    [anon_sym_STAR_STAR] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(488),
    [anon_sym_AMP] = ACTIONS(488),
    [anon_sym_CARET] = ACTIONS(488),
    [anon_sym_LT_LT] = ACTIONS(488),
    [anon_sym_LT] = ACTIONS(490),
    [anon_sym_LT_EQ] = ACTIONS(488),
    [anon_sym_EQ_EQ] = ACTIONS(488),
    [anon_sym_BANG_EQ] = ACTIONS(488),
    [anon_sym_GT_EQ] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(490),
    [anon_sym_LT_GT] = ACTIONS(488),
    [anon_sym_is] = ACTIONS(488),
    [anon_sym_LBRACK] = ACTIONS(488),
    [anon_sym_RBRACK] = ACTIONS(488),
    [anon_sym_RBRACE] = ACTIONS(488),
    [sym_type_conversion] = ACTIONS(488),
    [sym_comment] = ACTIONS(3),
  },
  [431] = {
    [sym_argument_list] = STATE(498),
    [sym_generator_expression] = STATE(498),
    [anon_sym_DOT] = ACTIONS(997),
    [anon_sym_LPAREN] = ACTIONS(999),
    [anon_sym_RPAREN] = ACTIONS(502),
    [anon_sym_COMMA] = ACTIONS(502),
    [anon_sym_STAR] = ACTIONS(1001),
    [anon_sym_GT_GT] = ACTIONS(1003),
    [anon_sym_if] = ACTIONS(502),
    [anon_sym_COLON] = ACTIONS(502),
    [anon_sym_else] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_for] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(502),
    [anon_sym_EQ] = ACTIONS(504),
    [anon_sym_AT] = ACTIONS(1007),
    [anon_sym_not] = ACTIONS(502),
    [anon_sym_and] = ACTIONS(502),
    [anon_sym_or] = ACTIONS(502),
    [anon_sym_PLUS] = ACTIONS(1011),
    [anon_sym_DASH] = ACTIONS(1011),
    [anon_sym_SLASH] = ACTIONS(1001),
    [anon_sym_PERCENT] = ACTIONS(1007),
    [anon_sym_SLASH_SLASH] = ACTIONS(1007),
    [anon_sym_STAR_STAR] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_AMP] = ACTIONS(1017),
    [anon_sym_CARET] = ACTIONS(1019),
    [anon_sym_LT_LT] = ACTIONS(1003),
    [anon_sym_LT] = ACTIONS(504),
    [anon_sym_LT_EQ] = ACTIONS(502),
    [anon_sym_EQ_EQ] = ACTIONS(502),
    [anon_sym_BANG_EQ] = ACTIONS(502),
    [anon_sym_GT_EQ] = ACTIONS(502),
    [anon_sym_GT] = ACTIONS(504),
    [anon_sym_LT_GT] = ACTIONS(502),
    [anon_sym_is] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(1025),
    [anon_sym_RBRACK] = ACTIONS(502),
    [anon_sym_RBRACE] = ACTIONS(502),
    [sym_type_conversion] = ACTIONS(502),
    [sym_comment] = ACTIONS(3),
  },
  [432] = {
    [sym_argument_list] = STATE(498),
    [sym_generator_expression] = STATE(498),
    [anon_sym_DOT] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(999),
    [anon_sym_RPAREN] = ACTIONS(488),
    [anon_sym_COMMA] = ACTIONS(488),
    [anon_sym_STAR] = ACTIONS(1001),
    [anon_sym_GT_GT] = ACTIONS(488),
    [anon_sym_if] = ACTIONS(488),
    [anon_sym_COLON] = ACTIONS(488),
    [anon_sym_else] = ACTIONS(488),
    [anon_sym_async] = ACTIONS(488),
    [anon_sym_for] = ACTIONS(488),
    [anon_sym_in] = ACTIONS(488),
    [anon_sym_EQ] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(1007),
    [anon_sym_not] = ACTIONS(488),
    [anon_sym_and] = ACTIONS(488),
    [anon_sym_or] = ACTIONS(488),
    [anon_sym_PLUS] = ACTIONS(1011),
    [anon_sym_DASH] = ACTIONS(1011),
    [anon_sym_SLASH] = ACTIONS(1001),
    [anon_sym_PERCENT] = ACTIONS(1007),
    [anon_sym_SLASH_SLASH] = ACTIONS(1007),
    [anon_sym_STAR_STAR] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(488),
    [anon_sym_AMP] = ACTIONS(488),
    [anon_sym_CARET] = ACTIONS(488),
    [anon_sym_LT_LT] = ACTIONS(488),
    [anon_sym_LT] = ACTIONS(490),
    [anon_sym_LT_EQ] = ACTIONS(488),
    [anon_sym_EQ_EQ] = ACTIONS(488),
    [anon_sym_BANG_EQ] = ACTIONS(488),
    [anon_sym_GT_EQ] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(490),
    [anon_sym_LT_GT] = ACTIONS(488),
    [anon_sym_is] = ACTIONS(488),
    [anon_sym_LBRACK] = ACTIONS(488),
    [anon_sym_RBRACK] = ACTIONS(488),
    [anon_sym_RBRACE] = ACTIONS(488),
    [sym_type_conversion] = ACTIONS(488),
    [sym_comment] = ACTIONS(3),
  },
  [433] = {
    [sym_argument_list] = STATE(498),
    [sym_generator_expression] = STATE(498),
    [anon_sym_DOT] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(999),
    [anon_sym_RPAREN] = ACTIONS(488),
    [anon_sym_COMMA] = ACTIONS(488),
    [anon_sym_STAR] = ACTIONS(490),
    [anon_sym_GT_GT] = ACTIONS(488),
    [anon_sym_if] = ACTIONS(488),
    [anon_sym_COLON] = ACTIONS(488),
    [anon_sym_else] = ACTIONS(488),
    [anon_sym_async] = ACTIONS(488),
    [anon_sym_for] = ACTIONS(488),
    [anon_sym_in] = ACTIONS(488),
    [anon_sym_EQ] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_not] = ACTIONS(488),
    [anon_sym_and] = ACTIONS(488),
    [anon_sym_or] = ACTIONS(488),
    [anon_sym_PLUS] = ACTIONS(488),
    [anon_sym_DASH] = ACTIONS(488),
    [anon_sym_SLASH] = ACTIONS(490),
    [anon_sym_PERCENT] = ACTIONS(488),
    [anon_sym_SLASH_SLASH] = ACTIONS(488),
    [anon_sym_STAR_STAR] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(488),
    [anon_sym_AMP] = ACTIONS(488),
    [anon_sym_CARET] = ACTIONS(488),
    [anon_sym_LT_LT] = ACTIONS(488),
    [anon_sym_LT] = ACTIONS(490),
    [anon_sym_LT_EQ] = ACTIONS(488),
    [anon_sym_EQ_EQ] = ACTIONS(488),
    [anon_sym_BANG_EQ] = ACTIONS(488),
    [anon_sym_GT_EQ] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(490),
    [anon_sym_LT_GT] = ACTIONS(488),
    [anon_sym_is] = ACTIONS(488),
    [anon_sym_LBRACK] = ACTIONS(488),
    [anon_sym_RBRACK] = ACTIONS(488),
    [anon_sym_RBRACE] = ACTIONS(488),
    [sym_type_conversion] = ACTIONS(488),
    [sym_comment] = ACTIONS(3),
  },
  [434] = {
    [sym_identifier] = ACTIONS(1077),
    [anon_sym_import] = ACTIONS(1077),
    [anon_sym_from] = ACTIONS(1077),
    [anon_sym_LPAREN] = ACTIONS(1075),
    [anon_sym_print] = ACTIONS(1077),
    [anon_sym_assert] = ACTIONS(1077),
    [anon_sym_return] = ACTIONS(1077),
    [anon_sym_del] = ACTIONS(1077),
    [anon_sym_raise] = ACTIONS(1077),
    [anon_sym_pass] = ACTIONS(1077),
    [anon_sym_break] = ACTIONS(1077),
    [anon_sym_continue] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1077),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_for] = ACTIONS(1077),
    [anon_sym_while] = ACTIONS(1077),
    [anon_sym_try] = ACTIONS(1077),
    [anon_sym_with] = ACTIONS(1077),
    [anon_sym_def] = ACTIONS(1077),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_nonlocal] = ACTIONS(1077),
    [anon_sym_exec] = ACTIONS(1077),
    [anon_sym_class] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1075),
    [anon_sym_not] = ACTIONS(1077),
    [anon_sym_PLUS] = ACTIONS(1075),
    [anon_sym_DASH] = ACTIONS(1075),
    [anon_sym_TILDE] = ACTIONS(1075),
    [anon_sym_lambda] = ACTIONS(1077),
    [anon_sym_yield] = ACTIONS(1077),
    [anon_sym_LBRACK] = ACTIONS(1075),
    [sym_ellipsis] = ACTIONS(1075),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [sym_integer] = ACTIONS(1077),
    [sym_float] = ACTIONS(1075),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_none] = ACTIONS(1077),
    [anon_sym_await] = ACTIONS(1077),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1075),
    [sym__string_start] = ACTIONS(1075),
  },
  [435] = {
    [sym_identifier] = ACTIONS(1079),
    [anon_sym_import] = ACTIONS(1079),
    [anon_sym_from] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(1081),
    [anon_sym_print] = ACTIONS(1079),
    [anon_sym_assert] = ACTIONS(1079),
    [anon_sym_return] = ACTIONS(1079),
    [anon_sym_del] = ACTIONS(1079),
    [anon_sym_raise] = ACTIONS(1079),
    [anon_sym_pass] = ACTIONS(1079),
    [anon_sym_break] = ACTIONS(1079),
    [anon_sym_continue] = ACTIONS(1079),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_async] = ACTIONS(1079),
    [anon_sym_for] = ACTIONS(1079),
    [anon_sym_while] = ACTIONS(1079),
    [anon_sym_try] = ACTIONS(1079),
    [anon_sym_with] = ACTIONS(1079),
    [anon_sym_def] = ACTIONS(1079),
    [anon_sym_global] = ACTIONS(1079),
    [anon_sym_nonlocal] = ACTIONS(1079),
    [anon_sym_exec] = ACTIONS(1079),
    [anon_sym_class] = ACTIONS(1079),
    [anon_sym_AT] = ACTIONS(1081),
    [anon_sym_not] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_lambda] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(1079),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [sym_ellipsis] = ACTIONS(1081),
    [anon_sym_LBRACE] = ACTIONS(1081),
    [sym_integer] = ACTIONS(1079),
    [sym_float] = ACTIONS(1081),
    [sym_true] = ACTIONS(1079),
    [sym_false] = ACTIONS(1079),
    [sym_none] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(1079),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1081),
    [sym__string_start] = ACTIONS(1081),
  },
  [436] = {
    [sym_identifier] = ACTIONS(1083),
    [anon_sym_import] = ACTIONS(1083),
    [anon_sym_from] = ACTIONS(1083),
    [anon_sym_LPAREN] = ACTIONS(1085),
    [anon_sym_print] = ACTIONS(1083),
    [anon_sym_assert] = ACTIONS(1083),
    [anon_sym_return] = ACTIONS(1083),
    [anon_sym_del] = ACTIONS(1083),
    [anon_sym_raise] = ACTIONS(1083),
    [anon_sym_pass] = ACTIONS(1083),
    [anon_sym_break] = ACTIONS(1083),
    [anon_sym_continue] = ACTIONS(1083),
    [anon_sym_if] = ACTIONS(1083),
    [anon_sym_async] = ACTIONS(1083),
    [anon_sym_for] = ACTIONS(1083),
    [anon_sym_while] = ACTIONS(1083),
    [anon_sym_try] = ACTIONS(1083),
    [anon_sym_with] = ACTIONS(1083),
    [anon_sym_def] = ACTIONS(1083),
    [anon_sym_global] = ACTIONS(1083),
    [anon_sym_nonlocal] = ACTIONS(1083),
    [anon_sym_exec] = ACTIONS(1083),
    [anon_sym_class] = ACTIONS(1083),
    [anon_sym_AT] = ACTIONS(1085),
    [anon_sym_not] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1085),
    [anon_sym_lambda] = ACTIONS(1083),
    [anon_sym_yield] = ACTIONS(1083),
    [anon_sym_LBRACK] = ACTIONS(1085),
    [sym_ellipsis] = ACTIONS(1085),
    [anon_sym_LBRACE] = ACTIONS(1085),
    [sym_integer] = ACTIONS(1083),
    [sym_float] = ACTIONS(1085),
    [sym_true] = ACTIONS(1083),
    [sym_false] = ACTIONS(1083),
    [sym_none] = ACTIONS(1083),
    [anon_sym_await] = ACTIONS(1083),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1085),
    [sym__string_start] = ACTIONS(1085),
  },
  [437] = {
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_from] = ACTIONS(1057),
    [anon_sym_LPAREN] = ACTIONS(1055),
    [anon_sym_print] = ACTIONS(1057),
    [anon_sym_assert] = ACTIONS(1057),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_del] = ACTIONS(1057),
    [anon_sym_raise] = ACTIONS(1057),
    [anon_sym_pass] = ACTIONS(1057),
    [anon_sym_break] = ACTIONS(1057),
    [anon_sym_continue] = ACTIONS(1057),
    [anon_sym_if] = ACTIONS(1057),
    [anon_sym_async] = ACTIONS(1057),
    [anon_sym_for] = ACTIONS(1057),
    [anon_sym_while] = ACTIONS(1057),
    [anon_sym_try] = ACTIONS(1057),
    [anon_sym_with] = ACTIONS(1057),
    [anon_sym_def] = ACTIONS(1057),
    [anon_sym_global] = ACTIONS(1057),
    [anon_sym_nonlocal] = ACTIONS(1057),
    [anon_sym_exec] = ACTIONS(1057),
    [anon_sym_class] = ACTIONS(1057),
    [anon_sym_AT] = ACTIONS(1055),
    [anon_sym_not] = ACTIONS(1057),
    [anon_sym_PLUS] = ACTIONS(1055),
    [anon_sym_DASH] = ACTIONS(1055),
    [anon_sym_TILDE] = ACTIONS(1055),
    [anon_sym_lambda] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1055),
    [sym_ellipsis] = ACTIONS(1055),
    [anon_sym_LBRACE] = ACTIONS(1055),
    [sym_integer] = ACTIONS(1057),
    [sym_float] = ACTIONS(1055),
    [sym_true] = ACTIONS(1057),
    [sym_false] = ACTIONS(1057),
    [sym_none] = ACTIONS(1057),
    [anon_sym_await] = ACTIONS(1057),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1055),
    [sym__string_start] = ACTIONS(1055),
  },
  [438] = {
    [sym_identifier] = ACTIONS(1065),
    [anon_sym_import] = ACTIONS(1065),
    [anon_sym_from] = ACTIONS(1065),
    [anon_sym_LPAREN] = ACTIONS(1063),
    [anon_sym_print] = ACTIONS(1065),
    [anon_sym_assert] = ACTIONS(1065),
    [anon_sym_return] = ACTIONS(1065),
    [anon_sym_del] = ACTIONS(1065),
    [anon_sym_raise] = ACTIONS(1065),
    [anon_sym_pass] = ACTIONS(1065),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_continue] = ACTIONS(1065),
    [anon_sym_if] = ACTIONS(1065),
    [anon_sym_async] = ACTIONS(1065),
    [anon_sym_for] = ACTIONS(1065),
    [anon_sym_while] = ACTIONS(1065),
    [anon_sym_try] = ACTIONS(1065),
    [anon_sym_with] = ACTIONS(1065),
    [anon_sym_def] = ACTIONS(1065),
    [anon_sym_global] = ACTIONS(1065),
    [anon_sym_nonlocal] = ACTIONS(1065),
    [anon_sym_exec] = ACTIONS(1065),
    [anon_sym_class] = ACTIONS(1065),
    [anon_sym_AT] = ACTIONS(1063),
    [anon_sym_not] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_DASH] = ACTIONS(1063),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_lambda] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(1063),
    [sym_ellipsis] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [sym_integer] = ACTIONS(1065),
    [sym_float] = ACTIONS(1063),
    [sym_true] = ACTIONS(1065),
    [sym_false] = ACTIONS(1065),
    [sym_none] = ACTIONS(1065),
    [anon_sym_await] = ACTIONS(1065),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1063),
    [sym__string_start] = ACTIONS(1063),
  },
  [439] = {
    [sym_identifier] = ACTIONS(1087),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_print] = ACTIONS(1087),
    [anon_sym_assert] = ACTIONS(1087),
    [anon_sym_return] = ACTIONS(1087),
    [anon_sym_del] = ACTIONS(1087),
    [anon_sym_raise] = ACTIONS(1087),
    [anon_sym_pass] = ACTIONS(1087),
    [anon_sym_break] = ACTIONS(1087),
    [anon_sym_continue] = ACTIONS(1087),
    [anon_sym_if] = ACTIONS(1087),
    [anon_sym_async] = ACTIONS(1087),
    [anon_sym_for] = ACTIONS(1087),
    [anon_sym_while] = ACTIONS(1087),
    [anon_sym_try] = ACTIONS(1087),
    [anon_sym_with] = ACTIONS(1087),
    [anon_sym_def] = ACTIONS(1087),
    [anon_sym_global] = ACTIONS(1087),
    [anon_sym_nonlocal] = ACTIONS(1087),
    [anon_sym_exec] = ACTIONS(1087),
    [anon_sym_class] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1087),
    [anon_sym_PLUS] = ACTIONS(1089),
    [anon_sym_DASH] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1089),
    [anon_sym_lambda] = ACTIONS(1087),
    [anon_sym_yield] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [sym_ellipsis] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [sym_integer] = ACTIONS(1087),
    [sym_float] = ACTIONS(1089),
    [sym_true] = ACTIONS(1087),
    [sym_false] = ACTIONS(1087),
    [sym_none] = ACTIONS(1087),
    [anon_sym_await] = ACTIONS(1087),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
  },
  [440] = {
    [sym_identifier] = ACTIONS(564),
    [anon_sym_import] = ACTIONS(564),
    [anon_sym_from] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_print] = ACTIONS(564),
    [anon_sym_assert] = ACTIONS(564),
    [anon_sym_return] = ACTIONS(564),
    [anon_sym_del] = ACTIONS(564),
    [anon_sym_raise] = ACTIONS(564),
    [anon_sym_pass] = ACTIONS(564),
    [anon_sym_break] = ACTIONS(564),
    [anon_sym_continue] = ACTIONS(564),
    [anon_sym_if] = ACTIONS(564),
    [anon_sym_async] = ACTIONS(564),
    [anon_sym_for] = ACTIONS(564),
    [anon_sym_while] = ACTIONS(564),
    [anon_sym_try] = ACTIONS(564),
    [anon_sym_with] = ACTIONS(564),
    [anon_sym_def] = ACTIONS(564),
    [anon_sym_global] = ACTIONS(564),
    [anon_sym_nonlocal] = ACTIONS(564),
    [anon_sym_exec] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(564),
    [anon_sym_AT] = ACTIONS(566),
    [anon_sym_not] = ACTIONS(564),
    [anon_sym_PLUS] = ACTIONS(566),
    [anon_sym_DASH] = ACTIONS(566),
    [anon_sym_TILDE] = ACTIONS(566),
    [anon_sym_lambda] = ACTIONS(564),
    [anon_sym_yield] = ACTIONS(564),
    [anon_sym_LBRACK] = ACTIONS(566),
    [sym_ellipsis] = ACTIONS(566),
    [anon_sym_LBRACE] = ACTIONS(566),
    [sym_integer] = ACTIONS(564),
    [sym_float] = ACTIONS(566),
    [sym_true] = ACTIONS(564),
    [sym_false] = ACTIONS(564),
    [sym_none] = ACTIONS(564),
    [anon_sym_await] = ACTIONS(564),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(566),
    [sym__string_start] = ACTIONS(566),
  },
  [441] = {
    [sym_identifier] = ACTIONS(982),
    [anon_sym_import] = ACTIONS(982),
    [anon_sym_from] = ACTIONS(982),
    [anon_sym_LPAREN] = ACTIONS(984),
    [anon_sym_print] = ACTIONS(982),
    [anon_sym_assert] = ACTIONS(982),
    [anon_sym_return] = ACTIONS(982),
    [anon_sym_del] = ACTIONS(982),
    [anon_sym_raise] = ACTIONS(982),
    [anon_sym_pass] = ACTIONS(982),
    [anon_sym_break] = ACTIONS(982),
    [anon_sym_continue] = ACTIONS(982),
    [anon_sym_if] = ACTIONS(982),
    [anon_sym_async] = ACTIONS(982),
    [anon_sym_for] = ACTIONS(982),
    [anon_sym_while] = ACTIONS(982),
    [anon_sym_try] = ACTIONS(982),
    [anon_sym_with] = ACTIONS(982),
    [anon_sym_def] = ACTIONS(982),
    [anon_sym_global] = ACTIONS(982),
    [anon_sym_nonlocal] = ACTIONS(982),
    [anon_sym_exec] = ACTIONS(982),
    [anon_sym_class] = ACTIONS(982),
    [anon_sym_AT] = ACTIONS(984),
    [anon_sym_not] = ACTIONS(982),
    [anon_sym_PLUS] = ACTIONS(984),
    [anon_sym_DASH] = ACTIONS(984),
    [anon_sym_TILDE] = ACTIONS(984),
    [anon_sym_lambda] = ACTIONS(982),
    [anon_sym_yield] = ACTIONS(982),
    [anon_sym_LBRACK] = ACTIONS(984),
    [sym_ellipsis] = ACTIONS(984),
    [anon_sym_LBRACE] = ACTIONS(984),
    [sym_integer] = ACTIONS(982),
    [sym_float] = ACTIONS(984),
    [sym_true] = ACTIONS(982),
    [sym_false] = ACTIONS(982),
    [sym_none] = ACTIONS(982),
    [anon_sym_await] = ACTIONS(982),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(984),
    [sym__string_start] = ACTIONS(984),
  },
  [442] = {
    [sym_identifier] = ACTIONS(1091),
    [anon_sym_import] = ACTIONS(1091),
    [anon_sym_from] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1093),
    [anon_sym_print] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_del] = ACTIONS(1091),
    [anon_sym_raise] = ACTIONS(1091),
    [anon_sym_pass] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_continue] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_async] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_try] = ACTIONS(1091),
    [anon_sym_with] = ACTIONS(1091),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_global] = ACTIONS(1091),
    [anon_sym_nonlocal] = ACTIONS(1091),
    [anon_sym_exec] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_AT] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1093),
    [anon_sym_DASH] = ACTIONS(1093),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_lambda] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [sym_ellipsis] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1093),
    [sym_true] = ACTIONS(1091),
    [sym_false] = ACTIONS(1091),
    [sym_none] = ACTIONS(1091),
    [anon_sym_await] = ACTIONS(1091),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1093),
    [sym__string_start] = ACTIONS(1093),
  },
  [443] = {
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_import] = ACTIONS(1095),
    [anon_sym_from] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1097),
    [anon_sym_print] = ACTIONS(1095),
    [anon_sym_assert] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_del] = ACTIONS(1095),
    [anon_sym_raise] = ACTIONS(1095),
    [anon_sym_pass] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_continue] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_async] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_try] = ACTIONS(1095),
    [anon_sym_with] = ACTIONS(1095),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_global] = ACTIONS(1095),
    [anon_sym_nonlocal] = ACTIONS(1095),
    [anon_sym_exec] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_AT] = ACTIONS(1097),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1097),
    [anon_sym_DASH] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_lambda] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(1097),
    [sym_ellipsis] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1097),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1097),
    [sym_true] = ACTIONS(1095),
    [sym_false] = ACTIONS(1095),
    [sym_none] = ACTIONS(1095),
    [anon_sym_await] = ACTIONS(1095),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1097),
    [sym__string_start] = ACTIONS(1097),
  },
  [444] = {
    [ts_builtin_sym_end] = ACTIONS(1099),
    [sym_identifier] = ACTIONS(1101),
    [anon_sym_import] = ACTIONS(1101),
    [anon_sym_from] = ACTIONS(1101),
    [anon_sym_LPAREN] = ACTIONS(1099),
    [anon_sym_print] = ACTIONS(1101),
    [anon_sym_assert] = ACTIONS(1101),
    [anon_sym_return] = ACTIONS(1101),
    [anon_sym_del] = ACTIONS(1101),
    [anon_sym_raise] = ACTIONS(1101),
    [anon_sym_pass] = ACTIONS(1101),
    [anon_sym_break] = ACTIONS(1101),
    [anon_sym_continue] = ACTIONS(1101),
    [anon_sym_if] = ACTIONS(1101),
    [anon_sym_async] = ACTIONS(1101),
    [anon_sym_for] = ACTIONS(1101),
    [anon_sym_while] = ACTIONS(1101),
    [anon_sym_try] = ACTIONS(1101),
    [anon_sym_with] = ACTIONS(1101),
    [anon_sym_def] = ACTIONS(1101),
    [anon_sym_global] = ACTIONS(1101),
    [anon_sym_nonlocal] = ACTIONS(1101),
    [anon_sym_exec] = ACTIONS(1101),
    [anon_sym_class] = ACTIONS(1101),
    [anon_sym_AT] = ACTIONS(1099),
    [anon_sym_not] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_TILDE] = ACTIONS(1099),
    [anon_sym_lambda] = ACTIONS(1101),
    [anon_sym_yield] = ACTIONS(1101),
    [anon_sym_LBRACK] = ACTIONS(1099),
    [sym_ellipsis] = ACTIONS(1099),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [sym_integer] = ACTIONS(1101),
    [sym_float] = ACTIONS(1099),
    [sym_true] = ACTIONS(1101),
    [sym_false] = ACTIONS(1101),
    [sym_none] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1101),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1099),
  },
  [445] = {
    [sym_identifier] = ACTIONS(1053),
    [anon_sym_import] = ACTIONS(1053),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_print] = ACTIONS(1053),
    [anon_sym_assert] = ACTIONS(1053),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_del] = ACTIONS(1053),
    [anon_sym_raise] = ACTIONS(1053),
    [anon_sym_pass] = ACTIONS(1053),
    [anon_sym_break] = ACTIONS(1053),
    [anon_sym_continue] = ACTIONS(1053),
    [anon_sym_if] = ACTIONS(1053),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_for] = ACTIONS(1053),
    [anon_sym_while] = ACTIONS(1053),
    [anon_sym_try] = ACTIONS(1053),
    [anon_sym_with] = ACTIONS(1053),
    [anon_sym_def] = ACTIONS(1053),
    [anon_sym_global] = ACTIONS(1053),
    [anon_sym_nonlocal] = ACTIONS(1053),
    [anon_sym_exec] = ACTIONS(1053),
    [anon_sym_class] = ACTIONS(1053),
    [anon_sym_AT] = ACTIONS(1051),
    [anon_sym_not] = ACTIONS(1053),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1051),
    [anon_sym_lambda] = ACTIONS(1053),
    [anon_sym_yield] = ACTIONS(1053),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [sym_ellipsis] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1051),
    [sym_integer] = ACTIONS(1053),
    [sym_float] = ACTIONS(1051),
    [sym_true] = ACTIONS(1053),
    [sym_false] = ACTIONS(1053),
    [sym_none] = ACTIONS(1053),
    [anon_sym_await] = ACTIONS(1053),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1051),
    [sym__string_start] = ACTIONS(1051),
  },
  [446] = {
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_import] = ACTIONS(1103),
    [anon_sym_from] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_print] = ACTIONS(1103),
    [anon_sym_assert] = ACTIONS(1103),
    [anon_sym_return] = ACTIONS(1103),
    [anon_sym_del] = ACTIONS(1103),
    [anon_sym_raise] = ACTIONS(1103),
    [anon_sym_pass] = ACTIONS(1103),
    [anon_sym_break] = ACTIONS(1103),
    [anon_sym_continue] = ACTIONS(1103),
    [anon_sym_if] = ACTIONS(1103),
    [anon_sym_async] = ACTIONS(1103),
    [anon_sym_for] = ACTIONS(1103),
    [anon_sym_while] = ACTIONS(1103),
    [anon_sym_try] = ACTIONS(1103),
    [anon_sym_with] = ACTIONS(1103),
    [anon_sym_def] = ACTIONS(1103),
    [anon_sym_global] = ACTIONS(1103),
    [anon_sym_nonlocal] = ACTIONS(1103),
    [anon_sym_exec] = ACTIONS(1103),
    [anon_sym_class] = ACTIONS(1103),
    [anon_sym_AT] = ACTIONS(1105),
    [anon_sym_not] = ACTIONS(1103),
    [anon_sym_PLUS] = ACTIONS(1105),
    [anon_sym_DASH] = ACTIONS(1105),
    [anon_sym_TILDE] = ACTIONS(1105),
    [anon_sym_lambda] = ACTIONS(1103),
    [anon_sym_yield] = ACTIONS(1103),
    [anon_sym_LBRACK] = ACTIONS(1105),
    [sym_ellipsis] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(1105),
    [sym_integer] = ACTIONS(1103),
    [sym_float] = ACTIONS(1105),
    [sym_true] = ACTIONS(1103),
    [sym_false] = ACTIONS(1103),
    [sym_none] = ACTIONS(1103),
    [anon_sym_await] = ACTIONS(1103),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1105),
    [sym__string_start] = ACTIONS(1105),
  },
  [447] = {
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_import] = ACTIONS(1061),
    [anon_sym_from] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1059),
    [anon_sym_print] = ACTIONS(1061),
    [anon_sym_assert] = ACTIONS(1061),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_del] = ACTIONS(1061),
    [anon_sym_raise] = ACTIONS(1061),
    [anon_sym_pass] = ACTIONS(1061),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_continue] = ACTIONS(1061),
    [anon_sym_if] = ACTIONS(1061),
    [anon_sym_async] = ACTIONS(1061),
    [anon_sym_for] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(1061),
    [anon_sym_try] = ACTIONS(1061),
    [anon_sym_with] = ACTIONS(1061),
    [anon_sym_def] = ACTIONS(1061),
    [anon_sym_global] = ACTIONS(1061),
    [anon_sym_nonlocal] = ACTIONS(1061),
    [anon_sym_exec] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(1061),
    [anon_sym_AT] = ACTIONS(1059),
    [anon_sym_not] = ACTIONS(1061),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_lambda] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1061),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [sym_ellipsis] = ACTIONS(1059),
    [anon_sym_LBRACE] = ACTIONS(1059),
    [sym_integer] = ACTIONS(1061),
    [sym_float] = ACTIONS(1059),
    [sym_true] = ACTIONS(1061),
    [sym_false] = ACTIONS(1061),
    [sym_none] = ACTIONS(1061),
    [anon_sym_await] = ACTIONS(1061),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1059),
    [sym__string_start] = ACTIONS(1059),
  },
  [448] = {
    [sym_identifier] = ACTIONS(1101),
    [anon_sym_import] = ACTIONS(1101),
    [anon_sym_from] = ACTIONS(1101),
    [anon_sym_LPAREN] = ACTIONS(1099),
    [anon_sym_print] = ACTIONS(1101),
    [anon_sym_assert] = ACTIONS(1101),
    [anon_sym_return] = ACTIONS(1101),
    [anon_sym_del] = ACTIONS(1101),
    [anon_sym_raise] = ACTIONS(1101),
    [anon_sym_pass] = ACTIONS(1101),
    [anon_sym_break] = ACTIONS(1101),
    [anon_sym_continue] = ACTIONS(1101),
    [anon_sym_if] = ACTIONS(1101),
    [anon_sym_async] = ACTIONS(1101),
    [anon_sym_for] = ACTIONS(1101),
    [anon_sym_while] = ACTIONS(1101),
    [anon_sym_try] = ACTIONS(1101),
    [anon_sym_with] = ACTIONS(1101),
    [anon_sym_def] = ACTIONS(1101),
    [anon_sym_global] = ACTIONS(1101),
    [anon_sym_nonlocal] = ACTIONS(1101),
    [anon_sym_exec] = ACTIONS(1101),
    [anon_sym_class] = ACTIONS(1101),
    [anon_sym_AT] = ACTIONS(1099),
    [anon_sym_not] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_TILDE] = ACTIONS(1099),
    [anon_sym_lambda] = ACTIONS(1101),
    [anon_sym_yield] = ACTIONS(1101),
    [anon_sym_LBRACK] = ACTIONS(1099),
    [sym_ellipsis] = ACTIONS(1099),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [sym_integer] = ACTIONS(1101),
    [sym_float] = ACTIONS(1099),
    [sym_true] = ACTIONS(1101),
    [sym_false] = ACTIONS(1101),
    [sym_none] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1101),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1099),
    [sym__string_start] = ACTIONS(1099),
  },
  [449] = {
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_import] = ACTIONS(1069),
    [anon_sym_from] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(1067),
    [anon_sym_print] = ACTIONS(1069),
    [anon_sym_assert] = ACTIONS(1069),
    [anon_sym_return] = ACTIONS(1069),
    [anon_sym_del] = ACTIONS(1069),
    [anon_sym_raise] = ACTIONS(1069),
    [anon_sym_pass] = ACTIONS(1069),
    [anon_sym_break] = ACTIONS(1069),
    [anon_sym_continue] = ACTIONS(1069),
    [anon_sym_if] = ACTIONS(1069),
    [anon_sym_async] = ACTIONS(1069),
    [anon_sym_for] = ACTIONS(1069),
    [anon_sym_while] = ACTIONS(1069),
    [anon_sym_try] = ACTIONS(1069),
    [anon_sym_with] = ACTIONS(1069),
    [anon_sym_def] = ACTIONS(1069),
    [anon_sym_global] = ACTIONS(1069),
    [anon_sym_nonlocal] = ACTIONS(1069),
    [anon_sym_exec] = ACTIONS(1069),
    [anon_sym_class] = ACTIONS(1069),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_lambda] = ACTIONS(1069),
    [anon_sym_yield] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [sym_ellipsis] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(1067),
    [sym_integer] = ACTIONS(1069),
    [sym_float] = ACTIONS(1067),
    [sym_true] = ACTIONS(1069),
    [sym_false] = ACTIONS(1069),
    [sym_none] = ACTIONS(1069),
    [anon_sym_await] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1067),
    [sym__string_start] = ACTIONS(1067),
  },
  [450] = {
    [sym_identifier] = ACTIONS(1073),
    [anon_sym_import] = ACTIONS(1073),
    [anon_sym_from] = ACTIONS(1073),
    [anon_sym_LPAREN] = ACTIONS(1071),
    [anon_sym_print] = ACTIONS(1073),
    [anon_sym_assert] = ACTIONS(1073),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_del] = ACTIONS(1073),
    [anon_sym_raise] = ACTIONS(1073),
    [anon_sym_pass] = ACTIONS(1073),
    [anon_sym_break] = ACTIONS(1073),
    [anon_sym_continue] = ACTIONS(1073),
    [anon_sym_if] = ACTIONS(1073),
    [anon_sym_async] = ACTIONS(1073),
    [anon_sym_for] = ACTIONS(1073),
    [anon_sym_while] = ACTIONS(1073),
    [anon_sym_try] = ACTIONS(1073),
    [anon_sym_with] = ACTIONS(1073),
    [anon_sym_def] = ACTIONS(1073),
    [anon_sym_global] = ACTIONS(1073),
    [anon_sym_nonlocal] = ACTIONS(1073),
    [anon_sym_exec] = ACTIONS(1073),
    [anon_sym_class] = ACTIONS(1073),
    [anon_sym_AT] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_DASH] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_lambda] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1073),
    [anon_sym_LBRACK] = ACTIONS(1071),
    [sym_ellipsis] = ACTIONS(1071),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [sym_integer] = ACTIONS(1073),
    [sym_float] = ACTIONS(1071),
    [sym_true] = ACTIONS(1073),
    [sym_false] = ACTIONS(1073),
    [sym_none] = ACTIONS(1073),
    [anon_sym_await] = ACTIONS(1073),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1071),
    [sym__string_start] = ACTIONS(1071),
  },
  [451] = {
    [sym_identifier] = ACTIONS(1107),
    [anon_sym_import] = ACTIONS(1107),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_LPAREN] = ACTIONS(1109),
    [anon_sym_print] = ACTIONS(1107),
    [anon_sym_assert] = ACTIONS(1107),
    [anon_sym_return] = ACTIONS(1107),
    [anon_sym_del] = ACTIONS(1107),
    [anon_sym_raise] = ACTIONS(1107),
    [anon_sym_pass] = ACTIONS(1107),
    [anon_sym_break] = ACTIONS(1107),
    [anon_sym_continue] = ACTIONS(1107),
    [anon_sym_if] = ACTIONS(1107),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_for] = ACTIONS(1107),
    [anon_sym_while] = ACTIONS(1107),
    [anon_sym_try] = ACTIONS(1107),
    [anon_sym_with] = ACTIONS(1107),
    [anon_sym_def] = ACTIONS(1107),
    [anon_sym_global] = ACTIONS(1107),
    [anon_sym_nonlocal] = ACTIONS(1107),
    [anon_sym_exec] = ACTIONS(1107),
    [anon_sym_class] = ACTIONS(1107),
    [anon_sym_AT] = ACTIONS(1109),
    [anon_sym_not] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_DASH] = ACTIONS(1109),
    [anon_sym_TILDE] = ACTIONS(1109),
    [anon_sym_lambda] = ACTIONS(1107),
    [anon_sym_yield] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [sym_ellipsis] = ACTIONS(1109),
    [anon_sym_LBRACE] = ACTIONS(1109),
    [sym_integer] = ACTIONS(1107),
    [sym_float] = ACTIONS(1109),
    [sym_true] = ACTIONS(1107),
    [sym_false] = ACTIONS(1107),
    [sym_none] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1107),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1109),
    [sym__string_start] = ACTIONS(1109),
  },
  [452] = {
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_import] = ACTIONS(1111),
    [anon_sym_from] = ACTIONS(1111),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_print] = ACTIONS(1111),
    [anon_sym_assert] = ACTIONS(1111),
    [anon_sym_return] = ACTIONS(1111),
    [anon_sym_del] = ACTIONS(1111),
    [anon_sym_raise] = ACTIONS(1111),
    [anon_sym_pass] = ACTIONS(1111),
    [anon_sym_break] = ACTIONS(1111),
    [anon_sym_continue] = ACTIONS(1111),
    [anon_sym_if] = ACTIONS(1111),
    [anon_sym_async] = ACTIONS(1111),
    [anon_sym_for] = ACTIONS(1111),
    [anon_sym_while] = ACTIONS(1111),
    [anon_sym_try] = ACTIONS(1111),
    [anon_sym_with] = ACTIONS(1111),
    [anon_sym_def] = ACTIONS(1111),
    [anon_sym_global] = ACTIONS(1111),
    [anon_sym_nonlocal] = ACTIONS(1111),
    [anon_sym_exec] = ACTIONS(1111),
    [anon_sym_class] = ACTIONS(1111),
    [anon_sym_AT] = ACTIONS(1113),
    [anon_sym_not] = ACTIONS(1111),
    [anon_sym_PLUS] = ACTIONS(1113),
    [anon_sym_DASH] = ACTIONS(1113),
    [anon_sym_TILDE] = ACTIONS(1113),
    [anon_sym_lambda] = ACTIONS(1111),
    [anon_sym_yield] = ACTIONS(1111),
    [anon_sym_LBRACK] = ACTIONS(1113),
    [sym_ellipsis] = ACTIONS(1113),
    [anon_sym_LBRACE] = ACTIONS(1113),
    [sym_integer] = ACTIONS(1111),
    [sym_float] = ACTIONS(1113),
    [sym_true] = ACTIONS(1111),
    [sym_false] = ACTIONS(1111),
    [sym_none] = ACTIONS(1111),
    [anon_sym_await] = ACTIONS(1111),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1113),
    [sym__string_start] = ACTIONS(1113),
  },
  [453] = {
    [sym_argument_list] = STATE(498),
    [sym_generator_expression] = STATE(498),
    [anon_sym_DOT] = ACTIONS(508),
    [anon_sym_LPAREN] = ACTIONS(999),
    [anon_sym_RPAREN] = ACTIONS(508),
    [anon_sym_COMMA] = ACTIONS(508),
    [anon_sym_STAR] = ACTIONS(510),
    [anon_sym_GT_GT] = ACTIONS(508),
    [anon_sym_if] = ACTIONS(508),
    [anon_sym_COLON] = ACTIONS(508),
    [anon_sym_else] = ACTIONS(508),
    [anon_sym_async] = ACTIONS(508),
    [anon_sym_for] = ACTIONS(508),
    [anon_sym_in] = ACTIONS(508),
    [anon_sym_EQ] = ACTIONS(510),
    [anon_sym_AT] = ACTIONS(508),
    [anon_sym_not] = ACTIONS(508),
    [anon_sym_and] = ACTIONS(508),
    [anon_sym_or] = ACTIONS(508),
    [anon_sym_PLUS] = ACTIONS(508),
    [anon_sym_DASH] = ACTIONS(508),
    [anon_sym_SLASH] = ACTIONS(510),
    [anon_sym_PERCENT] = ACTIONS(508),
    [anon_sym_SLASH_SLASH] = ACTIONS(508),
    [anon_sym_STAR_STAR] = ACTIONS(508),
    [anon_sym_PIPE] = ACTIONS(508),
    [anon_sym_AMP] = ACTIONS(508),
    [anon_sym_CARET] = ACTIONS(508),
    [anon_sym_LT_LT] = ACTIONS(508),
    [anon_sym_LT] = ACTIONS(510),
    [anon_sym_LT_EQ] = ACTIONS(508),
    [anon_sym_EQ_EQ] = ACTIONS(508),
    [anon_sym_BANG_EQ] = ACTIONS(508),
    [anon_sym_GT_EQ] = ACTIONS(508),
    [anon_sym_GT] = ACTIONS(510),
    [anon_sym_LT_GT] = ACTIONS(508),
    [anon_sym_is] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(508),
    [anon_sym_RBRACK] = ACTIONS(508),
    [anon_sym_RBRACE] = ACTIONS(508),
    [sym_type_conversion] = ACTIONS(508),
    [sym_comment] = ACTIONS(3),
  },
  [454] = {
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_import] = ACTIONS(1115),
    [anon_sym_from] = ACTIONS(1115),
    [anon_sym_LPAREN] = ACTIONS(1117),
    [anon_sym_print] = ACTIONS(1115),
    [anon_sym_assert] = ACTIONS(1115),
    [anon_sym_return] = ACTIONS(1115),
    [anon_sym_del] = ACTIONS(1115),
    [anon_sym_raise] = ACTIONS(1115),
    [anon_sym_pass] = ACTIONS(1115),
    [anon_sym_break] = ACTIONS(1115),
    [anon_sym_continue] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(1115),
    [anon_sym_async] = ACTIONS(1115),
    [anon_sym_for] = ACTIONS(1115),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_try] = ACTIONS(1115),
    [anon_sym_with] = ACTIONS(1115),
    [anon_sym_def] = ACTIONS(1115),
    [anon_sym_global] = ACTIONS(1115),
    [anon_sym_nonlocal] = ACTIONS(1115),
    [anon_sym_exec] = ACTIONS(1115),
    [anon_sym_class] = ACTIONS(1115),
    [anon_sym_AT] = ACTIONS(1117),
    [anon_sym_not] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_TILDE] = ACTIONS(1117),
    [anon_sym_lambda] = ACTIONS(1115),
    [anon_sym_yield] = ACTIONS(1115),
    [anon_sym_LBRACK] = ACTIONS(1117),
    [sym_ellipsis] = ACTIONS(1117),
    [anon_sym_LBRACE] = ACTIONS(1117),
    [sym_integer] = ACTIONS(1115),
    [sym_float] = ACTIONS(1117),
    [sym_true] = ACTIONS(1115),
    [sym_false] = ACTIONS(1115),
    [sym_none] = ACTIONS(1115),
    [anon_sym_await] = ACTIONS(1115),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1117),
    [sym__string_start] = ACTIONS(1117),
  },
  [455] = {
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_from] = ACTIONS(1119),
    [anon_sym_LPAREN] = ACTIONS(1121),
    [anon_sym_print] = ACTIONS(1119),
    [anon_sym_assert] = ACTIONS(1119),
    [anon_sym_return] = ACTIONS(1119),
    [anon_sym_del] = ACTIONS(1119),
    [anon_sym_raise] = ACTIONS(1119),
    [anon_sym_pass] = ACTIONS(1119),
    [anon_sym_break] = ACTIONS(1119),
    [anon_sym_continue] = ACTIONS(1119),
    [anon_sym_if] = ACTIONS(1119),
    [anon_sym_async] = ACTIONS(1119),
    [anon_sym_for] = ACTIONS(1119),
    [anon_sym_while] = ACTIONS(1119),
    [anon_sym_try] = ACTIONS(1119),
    [anon_sym_with] = ACTIONS(1119),
    [anon_sym_def] = ACTIONS(1119),
    [anon_sym_global] = ACTIONS(1119),
    [anon_sym_nonlocal] = ACTIONS(1119),
    [anon_sym_exec] = ACTIONS(1119),
    [anon_sym_class] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(1121),
    [anon_sym_not] = ACTIONS(1119),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_TILDE] = ACTIONS(1121),
    [anon_sym_lambda] = ACTIONS(1119),
    [anon_sym_yield] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [sym_ellipsis] = ACTIONS(1121),
    [anon_sym_LBRACE] = ACTIONS(1121),
    [sym_integer] = ACTIONS(1119),
    [sym_float] = ACTIONS(1121),
    [sym_true] = ACTIONS(1119),
    [sym_false] = ACTIONS(1119),
    [sym_none] = ACTIONS(1119),
    [anon_sym_await] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1121),
    [sym__string_start] = ACTIONS(1121),
  },
  [456] = {
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_import] = ACTIONS(1123),
    [anon_sym_from] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1125),
    [anon_sym_print] = ACTIONS(1123),
    [anon_sym_assert] = ACTIONS(1123),
    [anon_sym_return] = ACTIONS(1123),
    [anon_sym_del] = ACTIONS(1123),
    [anon_sym_raise] = ACTIONS(1123),
    [anon_sym_pass] = ACTIONS(1123),
    [anon_sym_break] = ACTIONS(1123),
    [anon_sym_continue] = ACTIONS(1123),
    [anon_sym_if] = ACTIONS(1123),
    [anon_sym_async] = ACTIONS(1123),
    [anon_sym_for] = ACTIONS(1123),
    [anon_sym_while] = ACTIONS(1123),
    [anon_sym_try] = ACTIONS(1123),
    [anon_sym_with] = ACTIONS(1123),
    [anon_sym_def] = ACTIONS(1123),
    [anon_sym_global] = ACTIONS(1123),
    [anon_sym_nonlocal] = ACTIONS(1123),
    [anon_sym_exec] = ACTIONS(1123),
    [anon_sym_class] = ACTIONS(1123),
    [anon_sym_AT] = ACTIONS(1125),
    [anon_sym_not] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(1125),
    [anon_sym_DASH] = ACTIONS(1125),
    [anon_sym_TILDE] = ACTIONS(1125),
    [anon_sym_lambda] = ACTIONS(1123),
    [anon_sym_yield] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(1125),
    [sym_ellipsis] = ACTIONS(1125),
    [anon_sym_LBRACE] = ACTIONS(1125),
    [sym_integer] = ACTIONS(1123),
    [sym_float] = ACTIONS(1125),
    [sym_true] = ACTIONS(1123),
    [sym_false] = ACTIONS(1123),
    [sym_none] = ACTIONS(1123),
    [anon_sym_await] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1125),
    [sym__string_start] = ACTIONS(1125),
  },
  [457] = {
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_import] = ACTIONS(1127),
    [anon_sym_from] = ACTIONS(1127),
    [anon_sym_LPAREN] = ACTIONS(1129),
    [anon_sym_print] = ACTIONS(1127),
    [anon_sym_assert] = ACTIONS(1127),
    [anon_sym_return] = ACTIONS(1127),
    [anon_sym_del] = ACTIONS(1127),
    [anon_sym_raise] = ACTIONS(1127),
    [anon_sym_pass] = ACTIONS(1127),
    [anon_sym_break] = ACTIONS(1127),
    [anon_sym_continue] = ACTIONS(1127),
    [anon_sym_if] = ACTIONS(1127),
    [anon_sym_async] = ACTIONS(1127),
    [anon_sym_for] = ACTIONS(1127),
    [anon_sym_while] = ACTIONS(1127),
    [anon_sym_try] = ACTIONS(1127),
    [anon_sym_with] = ACTIONS(1127),
    [anon_sym_def] = ACTIONS(1127),
    [anon_sym_global] = ACTIONS(1127),
    [anon_sym_nonlocal] = ACTIONS(1127),
    [anon_sym_exec] = ACTIONS(1127),
    [anon_sym_class] = ACTIONS(1127),
    [anon_sym_AT] = ACTIONS(1129),
    [anon_sym_not] = ACTIONS(1127),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_lambda] = ACTIONS(1127),
    [anon_sym_yield] = ACTIONS(1127),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [sym_ellipsis] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(1129),
    [sym_integer] = ACTIONS(1127),
    [sym_float] = ACTIONS(1129),
    [sym_true] = ACTIONS(1127),
    [sym_false] = ACTIONS(1127),
    [sym_none] = ACTIONS(1127),
    [anon_sym_await] = ACTIONS(1127),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1129),
    [sym__string_start] = ACTIONS(1129),
  },
  [458] = {
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_import] = ACTIONS(1131),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_print] = ACTIONS(1131),
    [anon_sym_assert] = ACTIONS(1131),
    [anon_sym_return] = ACTIONS(1131),
    [anon_sym_del] = ACTIONS(1131),
    [anon_sym_raise] = ACTIONS(1131),
    [anon_sym_pass] = ACTIONS(1131),
    [anon_sym_break] = ACTIONS(1131),
    [anon_sym_continue] = ACTIONS(1131),
    [anon_sym_if] = ACTIONS(1131),
    [anon_sym_async] = ACTIONS(1131),
    [anon_sym_for] = ACTIONS(1131),
    [anon_sym_while] = ACTIONS(1131),
    [anon_sym_try] = ACTIONS(1131),
    [anon_sym_with] = ACTIONS(1131),
    [anon_sym_def] = ACTIONS(1131),
    [anon_sym_global] = ACTIONS(1131),
    [anon_sym_nonlocal] = ACTIONS(1131),
    [anon_sym_exec] = ACTIONS(1131),
    [anon_sym_class] = ACTIONS(1131),
    [anon_sym_AT] = ACTIONS(1133),
    [anon_sym_not] = ACTIONS(1131),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_DASH] = ACTIONS(1133),
    [anon_sym_TILDE] = ACTIONS(1133),
    [anon_sym_lambda] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1131),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [sym_ellipsis] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(1133),
    [sym_integer] = ACTIONS(1131),
    [sym_float] = ACTIONS(1133),
    [sym_true] = ACTIONS(1131),
    [sym_false] = ACTIONS(1131),
    [sym_none] = ACTIONS(1131),
    [anon_sym_await] = ACTIONS(1131),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1133),
    [sym__string_start] = ACTIONS(1133),
  },
  [459] = {
    [ts_builtin_sym_end] = ACTIONS(1041),
    [sym_identifier] = ACTIONS(1039),
    [anon_sym_import] = ACTIONS(1039),
    [anon_sym_from] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1041),
    [anon_sym_print] = ACTIONS(1039),
    [anon_sym_assert] = ACTIONS(1039),
    [anon_sym_return] = ACTIONS(1039),
    [anon_sym_del] = ACTIONS(1039),
    [anon_sym_raise] = ACTIONS(1039),
    [anon_sym_pass] = ACTIONS(1039),
    [anon_sym_break] = ACTIONS(1039),
    [anon_sym_continue] = ACTIONS(1039),
    [anon_sym_if] = ACTIONS(1039),
    [anon_sym_async] = ACTIONS(1039),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1039),
    [anon_sym_try] = ACTIONS(1039),
    [anon_sym_with] = ACTIONS(1039),
    [anon_sym_def] = ACTIONS(1039),
    [anon_sym_global] = ACTIONS(1039),
    [anon_sym_nonlocal] = ACTIONS(1039),
    [anon_sym_exec] = ACTIONS(1039),
    [anon_sym_class] = ACTIONS(1039),
    [anon_sym_AT] = ACTIONS(1041),
    [anon_sym_not] = ACTIONS(1039),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_TILDE] = ACTIONS(1041),
    [anon_sym_lambda] = ACTIONS(1039),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(1041),
    [sym_ellipsis] = ACTIONS(1041),
    [anon_sym_LBRACE] = ACTIONS(1041),
    [sym_integer] = ACTIONS(1039),
    [sym_float] = ACTIONS(1041),
    [sym_true] = ACTIONS(1039),
    [sym_false] = ACTIONS(1039),
    [sym_none] = ACTIONS(1039),
    [anon_sym_await] = ACTIONS(1039),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1041),
  },
  [460] = {
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_from] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_print] = ACTIONS(1135),
    [anon_sym_assert] = ACTIONS(1135),
    [anon_sym_return] = ACTIONS(1135),
    [anon_sym_del] = ACTIONS(1135),
    [anon_sym_raise] = ACTIONS(1135),
    [anon_sym_pass] = ACTIONS(1135),
    [anon_sym_break] = ACTIONS(1135),
    [anon_sym_continue] = ACTIONS(1135),
    [anon_sym_if] = ACTIONS(1135),
    [anon_sym_async] = ACTIONS(1135),
    [anon_sym_for] = ACTIONS(1135),
    [anon_sym_while] = ACTIONS(1135),
    [anon_sym_try] = ACTIONS(1135),
    [anon_sym_with] = ACTIONS(1135),
    [anon_sym_def] = ACTIONS(1135),
    [anon_sym_global] = ACTIONS(1135),
    [anon_sym_nonlocal] = ACTIONS(1135),
    [anon_sym_exec] = ACTIONS(1135),
    [anon_sym_class] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(1137),
    [anon_sym_not] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1137),
    [anon_sym_DASH] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1137),
    [anon_sym_lambda] = ACTIONS(1135),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_ellipsis] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(1137),
    [sym_integer] = ACTIONS(1135),
    [sym_float] = ACTIONS(1137),
    [sym_true] = ACTIONS(1135),
    [sym_false] = ACTIONS(1135),
    [sym_none] = ACTIONS(1135),
    [anon_sym_await] = ACTIONS(1135),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1137),
    [sym__string_start] = ACTIONS(1137),
  },
  [461] = {
    [ts_builtin_sym_end] = ACTIONS(1081),
    [sym_identifier] = ACTIONS(1079),
    [anon_sym_import] = ACTIONS(1079),
    [anon_sym_from] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(1081),
    [anon_sym_print] = ACTIONS(1079),
    [anon_sym_assert] = ACTIONS(1079),
    [anon_sym_return] = ACTIONS(1079),
    [anon_sym_del] = ACTIONS(1079),
    [anon_sym_raise] = ACTIONS(1079),
    [anon_sym_pass] = ACTIONS(1079),
    [anon_sym_break] = ACTIONS(1079),
    [anon_sym_continue] = ACTIONS(1079),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_async] = ACTIONS(1079),
    [anon_sym_for] = ACTIONS(1079),
    [anon_sym_while] = ACTIONS(1079),
    [anon_sym_try] = ACTIONS(1079),
    [anon_sym_with] = ACTIONS(1079),
    [anon_sym_def] = ACTIONS(1079),
    [anon_sym_global] = ACTIONS(1079),
    [anon_sym_nonlocal] = ACTIONS(1079),
    [anon_sym_exec] = ACTIONS(1079),
    [anon_sym_class] = ACTIONS(1079),
    [anon_sym_AT] = ACTIONS(1081),
    [anon_sym_not] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_lambda] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(1079),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [sym_ellipsis] = ACTIONS(1081),
    [anon_sym_LBRACE] = ACTIONS(1081),
    [sym_integer] = ACTIONS(1079),
    [sym_float] = ACTIONS(1081),
    [sym_true] = ACTIONS(1079),
    [sym_false] = ACTIONS(1079),
    [sym_none] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(1079),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1081),
  },
  [462] = {
    [ts_builtin_sym_end] = ACTIONS(1133),
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_import] = ACTIONS(1131),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_print] = ACTIONS(1131),
    [anon_sym_assert] = ACTIONS(1131),
    [anon_sym_return] = ACTIONS(1131),
    [anon_sym_del] = ACTIONS(1131),
    [anon_sym_raise] = ACTIONS(1131),
    [anon_sym_pass] = ACTIONS(1131),
    [anon_sym_break] = ACTIONS(1131),
    [anon_sym_continue] = ACTIONS(1131),
    [anon_sym_if] = ACTIONS(1131),
    [anon_sym_async] = ACTIONS(1131),
    [anon_sym_for] = ACTIONS(1131),
    [anon_sym_while] = ACTIONS(1131),
    [anon_sym_try] = ACTIONS(1131),
    [anon_sym_with] = ACTIONS(1131),
    [anon_sym_def] = ACTIONS(1131),
    [anon_sym_global] = ACTIONS(1131),
    [anon_sym_nonlocal] = ACTIONS(1131),
    [anon_sym_exec] = ACTIONS(1131),
    [anon_sym_class] = ACTIONS(1131),
    [anon_sym_AT] = ACTIONS(1133),
    [anon_sym_not] = ACTIONS(1131),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_DASH] = ACTIONS(1133),
    [anon_sym_TILDE] = ACTIONS(1133),
    [anon_sym_lambda] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1131),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [sym_ellipsis] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(1133),
    [sym_integer] = ACTIONS(1131),
    [sym_float] = ACTIONS(1133),
    [sym_true] = ACTIONS(1131),
    [sym_false] = ACTIONS(1131),
    [sym_none] = ACTIONS(1131),
    [anon_sym_await] = ACTIONS(1131),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1133),
  },
  [463] = {
    [ts_builtin_sym_end] = ACTIONS(1125),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_import] = ACTIONS(1123),
    [anon_sym_from] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1125),
    [anon_sym_print] = ACTIONS(1123),
    [anon_sym_assert] = ACTIONS(1123),
    [anon_sym_return] = ACTIONS(1123),
    [anon_sym_del] = ACTIONS(1123),
    [anon_sym_raise] = ACTIONS(1123),
    [anon_sym_pass] = ACTIONS(1123),
    [anon_sym_break] = ACTIONS(1123),
    [anon_sym_continue] = ACTIONS(1123),
    [anon_sym_if] = ACTIONS(1123),
    [anon_sym_async] = ACTIONS(1123),
    [anon_sym_for] = ACTIONS(1123),
    [anon_sym_while] = ACTIONS(1123),
    [anon_sym_try] = ACTIONS(1123),
    [anon_sym_with] = ACTIONS(1123),
    [anon_sym_def] = ACTIONS(1123),
    [anon_sym_global] = ACTIONS(1123),
    [anon_sym_nonlocal] = ACTIONS(1123),
    [anon_sym_exec] = ACTIONS(1123),
    [anon_sym_class] = ACTIONS(1123),
    [anon_sym_AT] = ACTIONS(1125),
    [anon_sym_not] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(1125),
    [anon_sym_DASH] = ACTIONS(1125),
    [anon_sym_TILDE] = ACTIONS(1125),
    [anon_sym_lambda] = ACTIONS(1123),
    [anon_sym_yield] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(1125),
    [sym_ellipsis] = ACTIONS(1125),
    [anon_sym_LBRACE] = ACTIONS(1125),
    [sym_integer] = ACTIONS(1123),
    [sym_float] = ACTIONS(1125),
    [sym_true] = ACTIONS(1123),
    [sym_false] = ACTIONS(1123),
    [sym_none] = ACTIONS(1123),
    [anon_sym_await] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1125),
  },
  [464] = {
    [ts_builtin_sym_end] = ACTIONS(1085),
    [sym_identifier] = ACTIONS(1083),
    [anon_sym_import] = ACTIONS(1083),
    [anon_sym_from] = ACTIONS(1083),
    [anon_sym_LPAREN] = ACTIONS(1085),
    [anon_sym_print] = ACTIONS(1083),
    [anon_sym_assert] = ACTIONS(1083),
    [anon_sym_return] = ACTIONS(1083),
    [anon_sym_del] = ACTIONS(1083),
    [anon_sym_raise] = ACTIONS(1083),
    [anon_sym_pass] = ACTIONS(1083),
    [anon_sym_break] = ACTIONS(1083),
    [anon_sym_continue] = ACTIONS(1083),
    [anon_sym_if] = ACTIONS(1083),
    [anon_sym_async] = ACTIONS(1083),
    [anon_sym_for] = ACTIONS(1083),
    [anon_sym_while] = ACTIONS(1083),
    [anon_sym_try] = ACTIONS(1083),
    [anon_sym_with] = ACTIONS(1083),
    [anon_sym_def] = ACTIONS(1083),
    [anon_sym_global] = ACTIONS(1083),
    [anon_sym_nonlocal] = ACTIONS(1083),
    [anon_sym_exec] = ACTIONS(1083),
    [anon_sym_class] = ACTIONS(1083),
    [anon_sym_AT] = ACTIONS(1085),
    [anon_sym_not] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1085),
    [anon_sym_lambda] = ACTIONS(1083),
    [anon_sym_yield] = ACTIONS(1083),
    [anon_sym_LBRACK] = ACTIONS(1085),
    [sym_ellipsis] = ACTIONS(1085),
    [anon_sym_LBRACE] = ACTIONS(1085),
    [sym_integer] = ACTIONS(1083),
    [sym_float] = ACTIONS(1085),
    [sym_true] = ACTIONS(1083),
    [sym_false] = ACTIONS(1083),
    [sym_none] = ACTIONS(1083),
    [anon_sym_await] = ACTIONS(1083),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1085),
  },
  [465] = {
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_import] = ACTIONS(1139),
    [anon_sym_from] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(1141),
    [anon_sym_print] = ACTIONS(1139),
    [anon_sym_assert] = ACTIONS(1139),
    [anon_sym_return] = ACTIONS(1139),
    [anon_sym_del] = ACTIONS(1139),
    [anon_sym_raise] = ACTIONS(1139),
    [anon_sym_pass] = ACTIONS(1139),
    [anon_sym_break] = ACTIONS(1139),
    [anon_sym_continue] = ACTIONS(1139),
    [anon_sym_if] = ACTIONS(1139),
    [anon_sym_async] = ACTIONS(1139),
    [anon_sym_for] = ACTIONS(1139),
    [anon_sym_while] = ACTIONS(1139),
    [anon_sym_try] = ACTIONS(1139),
    [anon_sym_with] = ACTIONS(1139),
    [anon_sym_def] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1139),
    [anon_sym_nonlocal] = ACTIONS(1139),
    [anon_sym_exec] = ACTIONS(1139),
    [anon_sym_class] = ACTIONS(1139),
    [anon_sym_AT] = ACTIONS(1141),
    [anon_sym_not] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_TILDE] = ACTIONS(1141),
    [anon_sym_lambda] = ACTIONS(1139),
    [anon_sym_yield] = ACTIONS(1139),
    [anon_sym_LBRACK] = ACTIONS(1141),
    [sym_ellipsis] = ACTIONS(1141),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [sym_integer] = ACTIONS(1139),
    [sym_float] = ACTIONS(1141),
    [sym_true] = ACTIONS(1139),
    [sym_false] = ACTIONS(1139),
    [sym_none] = ACTIONS(1139),
    [anon_sym_await] = ACTIONS(1139),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1141),
    [sym__string_start] = ACTIONS(1141),
  },
  [466] = {
    [ts_builtin_sym_end] = ACTIONS(1141),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_import] = ACTIONS(1139),
    [anon_sym_from] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(1141),
    [anon_sym_print] = ACTIONS(1139),
    [anon_sym_assert] = ACTIONS(1139),
    [anon_sym_return] = ACTIONS(1139),
    [anon_sym_del] = ACTIONS(1139),
    [anon_sym_raise] = ACTIONS(1139),
    [anon_sym_pass] = ACTIONS(1139),
    [anon_sym_break] = ACTIONS(1139),
    [anon_sym_continue] = ACTIONS(1139),
    [anon_sym_if] = ACTIONS(1139),
    [anon_sym_async] = ACTIONS(1139),
    [anon_sym_for] = ACTIONS(1139),
    [anon_sym_while] = ACTIONS(1139),
    [anon_sym_try] = ACTIONS(1139),
    [anon_sym_with] = ACTIONS(1139),
    [anon_sym_def] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1139),
    [anon_sym_nonlocal] = ACTIONS(1139),
    [anon_sym_exec] = ACTIONS(1139),
    [anon_sym_class] = ACTIONS(1139),
    [anon_sym_AT] = ACTIONS(1141),
    [anon_sym_not] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_TILDE] = ACTIONS(1141),
    [anon_sym_lambda] = ACTIONS(1139),
    [anon_sym_yield] = ACTIONS(1139),
    [anon_sym_LBRACK] = ACTIONS(1141),
    [sym_ellipsis] = ACTIONS(1141),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [sym_integer] = ACTIONS(1139),
    [sym_float] = ACTIONS(1141),
    [sym_true] = ACTIONS(1139),
    [sym_false] = ACTIONS(1139),
    [sym_none] = ACTIONS(1139),
    [anon_sym_await] = ACTIONS(1139),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1141),
  },
  [467] = {
    [sym_identifier] = ACTIONS(1143),
    [anon_sym_import] = ACTIONS(1143),
    [anon_sym_from] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [anon_sym_print] = ACTIONS(1143),
    [anon_sym_assert] = ACTIONS(1143),
    [anon_sym_return] = ACTIONS(1143),
    [anon_sym_del] = ACTIONS(1143),
    [anon_sym_raise] = ACTIONS(1143),
    [anon_sym_pass] = ACTIONS(1143),
    [anon_sym_break] = ACTIONS(1143),
    [anon_sym_continue] = ACTIONS(1143),
    [anon_sym_if] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1143),
    [anon_sym_for] = ACTIONS(1143),
    [anon_sym_while] = ACTIONS(1143),
    [anon_sym_try] = ACTIONS(1143),
    [anon_sym_with] = ACTIONS(1143),
    [anon_sym_def] = ACTIONS(1143),
    [anon_sym_global] = ACTIONS(1143),
    [anon_sym_nonlocal] = ACTIONS(1143),
    [anon_sym_exec] = ACTIONS(1143),
    [anon_sym_class] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(1145),
    [anon_sym_not] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_TILDE] = ACTIONS(1145),
    [anon_sym_lambda] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1143),
    [anon_sym_LBRACK] = ACTIONS(1145),
    [sym_ellipsis] = ACTIONS(1145),
    [anon_sym_LBRACE] = ACTIONS(1145),
    [sym_integer] = ACTIONS(1143),
    [sym_float] = ACTIONS(1145),
    [sym_true] = ACTIONS(1143),
    [sym_false] = ACTIONS(1143),
    [sym_none] = ACTIONS(1143),
    [anon_sym_await] = ACTIONS(1143),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1145),
    [sym__string_start] = ACTIONS(1145),
  },
  [468] = {
    [ts_builtin_sym_end] = ACTIONS(1145),
    [sym_identifier] = ACTIONS(1143),
    [anon_sym_import] = ACTIONS(1143),
    [anon_sym_from] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [anon_sym_print] = ACTIONS(1143),
    [anon_sym_assert] = ACTIONS(1143),
    [anon_sym_return] = ACTIONS(1143),
    [anon_sym_del] = ACTIONS(1143),
    [anon_sym_raise] = ACTIONS(1143),
    [anon_sym_pass] = ACTIONS(1143),
    [anon_sym_break] = ACTIONS(1143),
    [anon_sym_continue] = ACTIONS(1143),
    [anon_sym_if] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1143),
    [anon_sym_for] = ACTIONS(1143),
    [anon_sym_while] = ACTIONS(1143),
    [anon_sym_try] = ACTIONS(1143),
    [anon_sym_with] = ACTIONS(1143),
    [anon_sym_def] = ACTIONS(1143),
    [anon_sym_global] = ACTIONS(1143),
    [anon_sym_nonlocal] = ACTIONS(1143),
    [anon_sym_exec] = ACTIONS(1143),
    [anon_sym_class] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(1145),
    [anon_sym_not] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_TILDE] = ACTIONS(1145),
    [anon_sym_lambda] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1143),
    [anon_sym_LBRACK] = ACTIONS(1145),
    [sym_ellipsis] = ACTIONS(1145),
    [anon_sym_LBRACE] = ACTIONS(1145),
    [sym_integer] = ACTIONS(1143),
    [sym_float] = ACTIONS(1145),
    [sym_true] = ACTIONS(1143),
    [sym_false] = ACTIONS(1143),
    [sym_none] = ACTIONS(1143),
    [anon_sym_await] = ACTIONS(1143),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1145),
  },
  [469] = {
    [ts_builtin_sym_end] = ACTIONS(1045),
    [sym_identifier] = ACTIONS(1043),
    [anon_sym_import] = ACTIONS(1043),
    [anon_sym_from] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(1045),
    [anon_sym_print] = ACTIONS(1043),
    [anon_sym_assert] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1043),
    [anon_sym_del] = ACTIONS(1043),
    [anon_sym_raise] = ACTIONS(1043),
    [anon_sym_pass] = ACTIONS(1043),
    [anon_sym_break] = ACTIONS(1043),
    [anon_sym_continue] = ACTIONS(1043),
    [anon_sym_if] = ACTIONS(1043),
    [anon_sym_async] = ACTIONS(1043),
    [anon_sym_for] = ACTIONS(1043),
    [anon_sym_while] = ACTIONS(1043),
    [anon_sym_try] = ACTIONS(1043),
    [anon_sym_with] = ACTIONS(1043),
    [anon_sym_def] = ACTIONS(1043),
    [anon_sym_global] = ACTIONS(1043),
    [anon_sym_nonlocal] = ACTIONS(1043),
    [anon_sym_exec] = ACTIONS(1043),
    [anon_sym_class] = ACTIONS(1043),
    [anon_sym_AT] = ACTIONS(1045),
    [anon_sym_not] = ACTIONS(1043),
    [anon_sym_PLUS] = ACTIONS(1045),
    [anon_sym_DASH] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_lambda] = ACTIONS(1043),
    [anon_sym_yield] = ACTIONS(1043),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [sym_ellipsis] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1043),
    [sym_float] = ACTIONS(1045),
    [sym_true] = ACTIONS(1043),
    [sym_false] = ACTIONS(1043),
    [sym_none] = ACTIONS(1043),
    [anon_sym_await] = ACTIONS(1043),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1045),
  },
  [470] = {
    [ts_builtin_sym_end] = ACTIONS(1147),
    [sym_identifier] = ACTIONS(1149),
    [anon_sym_import] = ACTIONS(1149),
    [anon_sym_from] = ACTIONS(1149),
    [anon_sym_LPAREN] = ACTIONS(1147),
    [anon_sym_print] = ACTIONS(1149),
    [anon_sym_assert] = ACTIONS(1149),
    [anon_sym_return] = ACTIONS(1149),
    [anon_sym_del] = ACTIONS(1149),
    [anon_sym_raise] = ACTIONS(1149),
    [anon_sym_pass] = ACTIONS(1149),
    [anon_sym_break] = ACTIONS(1149),
    [anon_sym_continue] = ACTIONS(1149),
    [anon_sym_if] = ACTIONS(1149),
    [anon_sym_async] = ACTIONS(1149),
    [anon_sym_for] = ACTIONS(1149),
    [anon_sym_while] = ACTIONS(1149),
    [anon_sym_try] = ACTIONS(1149),
    [anon_sym_with] = ACTIONS(1149),
    [anon_sym_def] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1149),
    [anon_sym_nonlocal] = ACTIONS(1149),
    [anon_sym_exec] = ACTIONS(1149),
    [anon_sym_class] = ACTIONS(1149),
    [anon_sym_AT] = ACTIONS(1147),
    [anon_sym_not] = ACTIONS(1149),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_lambda] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(1149),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [sym_ellipsis] = ACTIONS(1147),
    [anon_sym_LBRACE] = ACTIONS(1147),
    [sym_integer] = ACTIONS(1149),
    [sym_float] = ACTIONS(1147),
    [sym_true] = ACTIONS(1149),
    [sym_false] = ACTIONS(1149),
    [sym_none] = ACTIONS(1149),
    [anon_sym_await] = ACTIONS(1149),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1147),
  },
  [471] = {
    [ts_builtin_sym_end] = ACTIONS(1089),
    [sym_identifier] = ACTIONS(1087),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_print] = ACTIONS(1087),
    [anon_sym_assert] = ACTIONS(1087),
    [anon_sym_return] = ACTIONS(1087),
    [anon_sym_del] = ACTIONS(1087),
    [anon_sym_raise] = ACTIONS(1087),
    [anon_sym_pass] = ACTIONS(1087),
    [anon_sym_break] = ACTIONS(1087),
    [anon_sym_continue] = ACTIONS(1087),
    [anon_sym_if] = ACTIONS(1087),
    [anon_sym_async] = ACTIONS(1087),
    [anon_sym_for] = ACTIONS(1087),
    [anon_sym_while] = ACTIONS(1087),
    [anon_sym_try] = ACTIONS(1087),
    [anon_sym_with] = ACTIONS(1087),
    [anon_sym_def] = ACTIONS(1087),
    [anon_sym_global] = ACTIONS(1087),
    [anon_sym_nonlocal] = ACTIONS(1087),
    [anon_sym_exec] = ACTIONS(1087),
    [anon_sym_class] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1087),
    [anon_sym_PLUS] = ACTIONS(1089),
    [anon_sym_DASH] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1089),
    [anon_sym_lambda] = ACTIONS(1087),
    [anon_sym_yield] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [sym_ellipsis] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [sym_integer] = ACTIONS(1087),
    [sym_float] = ACTIONS(1089),
    [sym_true] = ACTIONS(1087),
    [sym_false] = ACTIONS(1087),
    [sym_none] = ACTIONS(1087),
    [anon_sym_await] = ACTIONS(1087),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1089),
  },
  [472] = {
    [ts_builtin_sym_end] = ACTIONS(1093),
    [sym_identifier] = ACTIONS(1091),
    [anon_sym_import] = ACTIONS(1091),
    [anon_sym_from] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1093),
    [anon_sym_print] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_del] = ACTIONS(1091),
    [anon_sym_raise] = ACTIONS(1091),
    [anon_sym_pass] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_continue] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_async] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_try] = ACTIONS(1091),
    [anon_sym_with] = ACTIONS(1091),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_global] = ACTIONS(1091),
    [anon_sym_nonlocal] = ACTIONS(1091),
    [anon_sym_exec] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_AT] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1093),
    [anon_sym_DASH] = ACTIONS(1093),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_lambda] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [sym_ellipsis] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1093),
    [sym_true] = ACTIONS(1091),
    [sym_false] = ACTIONS(1091),
    [sym_none] = ACTIONS(1091),
    [anon_sym_await] = ACTIONS(1091),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1093),
  },
  [473] = {
    [ts_builtin_sym_end] = ACTIONS(1097),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_import] = ACTIONS(1095),
    [anon_sym_from] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1097),
    [anon_sym_print] = ACTIONS(1095),
    [anon_sym_assert] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_del] = ACTIONS(1095),
    [anon_sym_raise] = ACTIONS(1095),
    [anon_sym_pass] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_continue] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_async] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_try] = ACTIONS(1095),
    [anon_sym_with] = ACTIONS(1095),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_global] = ACTIONS(1095),
    [anon_sym_nonlocal] = ACTIONS(1095),
    [anon_sym_exec] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_AT] = ACTIONS(1097),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1097),
    [anon_sym_DASH] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_lambda] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(1097),
    [sym_ellipsis] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1097),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1097),
    [sym_true] = ACTIONS(1095),
    [sym_false] = ACTIONS(1095),
    [sym_none] = ACTIONS(1095),
    [anon_sym_await] = ACTIONS(1095),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1097),
  },
  [474] = {
    [ts_builtin_sym_end] = ACTIONS(1151),
    [sym_identifier] = ACTIONS(1153),
    [anon_sym_import] = ACTIONS(1153),
    [anon_sym_from] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_print] = ACTIONS(1153),
    [anon_sym_assert] = ACTIONS(1153),
    [anon_sym_return] = ACTIONS(1153),
    [anon_sym_del] = ACTIONS(1153),
    [anon_sym_raise] = ACTIONS(1153),
    [anon_sym_pass] = ACTIONS(1153),
    [anon_sym_break] = ACTIONS(1153),
    [anon_sym_continue] = ACTIONS(1153),
    [anon_sym_if] = ACTIONS(1153),
    [anon_sym_async] = ACTIONS(1153),
    [anon_sym_for] = ACTIONS(1153),
    [anon_sym_while] = ACTIONS(1153),
    [anon_sym_try] = ACTIONS(1153),
    [anon_sym_with] = ACTIONS(1153),
    [anon_sym_def] = ACTIONS(1153),
    [anon_sym_global] = ACTIONS(1153),
    [anon_sym_nonlocal] = ACTIONS(1153),
    [anon_sym_exec] = ACTIONS(1153),
    [anon_sym_class] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(1151),
    [anon_sym_not] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_TILDE] = ACTIONS(1151),
    [anon_sym_lambda] = ACTIONS(1153),
    [anon_sym_yield] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1151),
    [sym_ellipsis] = ACTIONS(1151),
    [anon_sym_LBRACE] = ACTIONS(1151),
    [sym_integer] = ACTIONS(1153),
    [sym_float] = ACTIONS(1151),
    [sym_true] = ACTIONS(1153),
    [sym_false] = ACTIONS(1153),
    [sym_none] = ACTIONS(1153),
    [anon_sym_await] = ACTIONS(1153),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1151),
  },
  [475] = {
    [ts_builtin_sym_end] = ACTIONS(1105),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_import] = ACTIONS(1103),
    [anon_sym_from] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_print] = ACTIONS(1103),
    [anon_sym_assert] = ACTIONS(1103),
    [anon_sym_return] = ACTIONS(1103),
    [anon_sym_del] = ACTIONS(1103),
    [anon_sym_raise] = ACTIONS(1103),
    [anon_sym_pass] = ACTIONS(1103),
    [anon_sym_break] = ACTIONS(1103),
    [anon_sym_continue] = ACTIONS(1103),
    [anon_sym_if] = ACTIONS(1103),
    [anon_sym_async] = ACTIONS(1103),
    [anon_sym_for] = ACTIONS(1103),
    [anon_sym_while] = ACTIONS(1103),
    [anon_sym_try] = ACTIONS(1103),
    [anon_sym_with] = ACTIONS(1103),
    [anon_sym_def] = ACTIONS(1103),
    [anon_sym_global] = ACTIONS(1103),
    [anon_sym_nonlocal] = ACTIONS(1103),
    [anon_sym_exec] = ACTIONS(1103),
    [anon_sym_class] = ACTIONS(1103),
    [anon_sym_AT] = ACTIONS(1105),
    [anon_sym_not] = ACTIONS(1103),
    [anon_sym_PLUS] = ACTIONS(1105),
    [anon_sym_DASH] = ACTIONS(1105),
    [anon_sym_TILDE] = ACTIONS(1105),
    [anon_sym_lambda] = ACTIONS(1103),
    [anon_sym_yield] = ACTIONS(1103),
    [anon_sym_LBRACK] = ACTIONS(1105),
    [sym_ellipsis] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(1105),
    [sym_integer] = ACTIONS(1103),
    [sym_float] = ACTIONS(1105),
    [sym_true] = ACTIONS(1103),
    [sym_false] = ACTIONS(1103),
    [sym_none] = ACTIONS(1103),
    [anon_sym_await] = ACTIONS(1103),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1105),
  },
  [476] = {
    [ts_builtin_sym_end] = ACTIONS(950),
    [sym_identifier] = ACTIONS(952),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_from] = ACTIONS(952),
    [anon_sym_LPAREN] = ACTIONS(950),
    [anon_sym_print] = ACTIONS(952),
    [anon_sym_assert] = ACTIONS(952),
    [anon_sym_return] = ACTIONS(952),
    [anon_sym_del] = ACTIONS(952),
    [anon_sym_raise] = ACTIONS(952),
    [anon_sym_pass] = ACTIONS(952),
    [anon_sym_break] = ACTIONS(952),
    [anon_sym_continue] = ACTIONS(952),
    [anon_sym_if] = ACTIONS(952),
    [anon_sym_async] = ACTIONS(952),
    [anon_sym_for] = ACTIONS(952),
    [anon_sym_while] = ACTIONS(952),
    [anon_sym_try] = ACTIONS(952),
    [anon_sym_with] = ACTIONS(952),
    [anon_sym_def] = ACTIONS(952),
    [anon_sym_global] = ACTIONS(952),
    [anon_sym_nonlocal] = ACTIONS(952),
    [anon_sym_exec] = ACTIONS(952),
    [anon_sym_class] = ACTIONS(952),
    [anon_sym_AT] = ACTIONS(950),
    [anon_sym_not] = ACTIONS(952),
    [anon_sym_PLUS] = ACTIONS(950),
    [anon_sym_DASH] = ACTIONS(950),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_lambda] = ACTIONS(952),
    [anon_sym_yield] = ACTIONS(952),
    [anon_sym_LBRACK] = ACTIONS(950),
    [sym_ellipsis] = ACTIONS(950),
    [anon_sym_LBRACE] = ACTIONS(950),
    [sym_integer] = ACTIONS(952),
    [sym_float] = ACTIONS(950),
    [sym_true] = ACTIONS(952),
    [sym_false] = ACTIONS(952),
    [sym_none] = ACTIONS(952),
    [anon_sym_await] = ACTIONS(952),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(950),
  },
  [477] = {
    [sym_identifier] = ACTIONS(1149),
    [anon_sym_import] = ACTIONS(1149),
    [anon_sym_from] = ACTIONS(1149),
    [anon_sym_LPAREN] = ACTIONS(1147),
    [anon_sym_print] = ACTIONS(1149),
    [anon_sym_assert] = ACTIONS(1149),
    [anon_sym_return] = ACTIONS(1149),
    [anon_sym_del] = ACTIONS(1149),
    [anon_sym_raise] = ACTIONS(1149),
    [anon_sym_pass] = ACTIONS(1149),
    [anon_sym_break] = ACTIONS(1149),
    [anon_sym_continue] = ACTIONS(1149),
    [anon_sym_if] = ACTIONS(1149),
    [anon_sym_async] = ACTIONS(1149),
    [anon_sym_for] = ACTIONS(1149),
    [anon_sym_while] = ACTIONS(1149),
    [anon_sym_try] = ACTIONS(1149),
    [anon_sym_with] = ACTIONS(1149),
    [anon_sym_def] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1149),
    [anon_sym_nonlocal] = ACTIONS(1149),
    [anon_sym_exec] = ACTIONS(1149),
    [anon_sym_class] = ACTIONS(1149),
    [anon_sym_AT] = ACTIONS(1147),
    [anon_sym_not] = ACTIONS(1149),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_lambda] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(1149),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [sym_ellipsis] = ACTIONS(1147),
    [anon_sym_LBRACE] = ACTIONS(1147),
    [sym_integer] = ACTIONS(1149),
    [sym_float] = ACTIONS(1147),
    [sym_true] = ACTIONS(1149),
    [sym_false] = ACTIONS(1149),
    [sym_none] = ACTIONS(1149),
    [anon_sym_await] = ACTIONS(1149),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1147),
    [sym__string_start] = ACTIONS(1147),
  },
  [478] = {
    [sym_identifier] = ACTIONS(952),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_from] = ACTIONS(952),
    [anon_sym_LPAREN] = ACTIONS(950),
    [anon_sym_print] = ACTIONS(952),
    [anon_sym_assert] = ACTIONS(952),
    [anon_sym_return] = ACTIONS(952),
    [anon_sym_del] = ACTIONS(952),
    [anon_sym_raise] = ACTIONS(952),
    [anon_sym_pass] = ACTIONS(952),
    [anon_sym_break] = ACTIONS(952),
    [anon_sym_continue] = ACTIONS(952),
    [anon_sym_if] = ACTIONS(952),
    [anon_sym_async] = ACTIONS(952),
    [anon_sym_for] = ACTIONS(952),
    [anon_sym_while] = ACTIONS(952),
    [anon_sym_try] = ACTIONS(952),
    [anon_sym_with] = ACTIONS(952),
    [anon_sym_def] = ACTIONS(952),
    [anon_sym_global] = ACTIONS(952),
    [anon_sym_nonlocal] = ACTIONS(952),
    [anon_sym_exec] = ACTIONS(952),
    [anon_sym_class] = ACTIONS(952),
    [anon_sym_AT] = ACTIONS(950),
    [anon_sym_not] = ACTIONS(952),
    [anon_sym_PLUS] = ACTIONS(950),
    [anon_sym_DASH] = ACTIONS(950),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_lambda] = ACTIONS(952),
    [anon_sym_yield] = ACTIONS(952),
    [anon_sym_LBRACK] = ACTIONS(950),
    [sym_ellipsis] = ACTIONS(950),
    [anon_sym_LBRACE] = ACTIONS(950),
    [sym_integer] = ACTIONS(952),
    [sym_float] = ACTIONS(950),
    [sym_true] = ACTIONS(952),
    [sym_false] = ACTIONS(952),
    [sym_none] = ACTIONS(952),
    [anon_sym_await] = ACTIONS(952),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(950),
    [sym__string_start] = ACTIONS(950),
  },
  [479] = {
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_import] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_print] = ACTIONS(1155),
    [anon_sym_assert] = ACTIONS(1155),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_del] = ACTIONS(1155),
    [anon_sym_raise] = ACTIONS(1155),
    [anon_sym_pass] = ACTIONS(1155),
    [anon_sym_break] = ACTIONS(1155),
    [anon_sym_continue] = ACTIONS(1155),
    [anon_sym_if] = ACTIONS(1155),
    [anon_sym_async] = ACTIONS(1155),
    [anon_sym_for] = ACTIONS(1155),
    [anon_sym_while] = ACTIONS(1155),
    [anon_sym_try] = ACTIONS(1155),
    [anon_sym_with] = ACTIONS(1155),
    [anon_sym_def] = ACTIONS(1155),
    [anon_sym_global] = ACTIONS(1155),
    [anon_sym_nonlocal] = ACTIONS(1155),
    [anon_sym_exec] = ACTIONS(1155),
    [anon_sym_class] = ACTIONS(1155),
    [anon_sym_AT] = ACTIONS(1157),
    [anon_sym_not] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1157),
    [anon_sym_DASH] = ACTIONS(1157),
    [anon_sym_TILDE] = ACTIONS(1157),
    [anon_sym_lambda] = ACTIONS(1155),
    [anon_sym_yield] = ACTIONS(1155),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [sym_ellipsis] = ACTIONS(1157),
    [anon_sym_LBRACE] = ACTIONS(1157),
    [sym_integer] = ACTIONS(1155),
    [sym_float] = ACTIONS(1157),
    [sym_true] = ACTIONS(1155),
    [sym_false] = ACTIONS(1155),
    [sym_none] = ACTIONS(1155),
    [anon_sym_await] = ACTIONS(1155),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1157),
    [sym__string_start] = ACTIONS(1157),
  },
  [480] = {
    [ts_builtin_sym_end] = ACTIONS(1049),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_import] = ACTIONS(1047),
    [anon_sym_from] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1049),
    [anon_sym_print] = ACTIONS(1047),
    [anon_sym_assert] = ACTIONS(1047),
    [anon_sym_return] = ACTIONS(1047),
    [anon_sym_del] = ACTIONS(1047),
    [anon_sym_raise] = ACTIONS(1047),
    [anon_sym_pass] = ACTIONS(1047),
    [anon_sym_break] = ACTIONS(1047),
    [anon_sym_continue] = ACTIONS(1047),
    [anon_sym_if] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_for] = ACTIONS(1047),
    [anon_sym_while] = ACTIONS(1047),
    [anon_sym_try] = ACTIONS(1047),
    [anon_sym_with] = ACTIONS(1047),
    [anon_sym_def] = ACTIONS(1047),
    [anon_sym_global] = ACTIONS(1047),
    [anon_sym_nonlocal] = ACTIONS(1047),
    [anon_sym_exec] = ACTIONS(1047),
    [anon_sym_class] = ACTIONS(1047),
    [anon_sym_AT] = ACTIONS(1049),
    [anon_sym_not] = ACTIONS(1047),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_DASH] = ACTIONS(1049),
    [anon_sym_TILDE] = ACTIONS(1049),
    [anon_sym_lambda] = ACTIONS(1047),
    [anon_sym_yield] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [sym_ellipsis] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [sym_integer] = ACTIONS(1047),
    [sym_float] = ACTIONS(1049),
    [sym_true] = ACTIONS(1047),
    [sym_false] = ACTIONS(1047),
    [sym_none] = ACTIONS(1047),
    [anon_sym_await] = ACTIONS(1047),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1049),
  },
  [481] = {
    [ts_builtin_sym_end] = ACTIONS(598),
    [sym_identifier] = ACTIONS(600),
    [anon_sym_import] = ACTIONS(600),
    [anon_sym_from] = ACTIONS(600),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_print] = ACTIONS(600),
    [anon_sym_assert] = ACTIONS(600),
    [anon_sym_return] = ACTIONS(600),
    [anon_sym_del] = ACTIONS(600),
    [anon_sym_raise] = ACTIONS(600),
    [anon_sym_pass] = ACTIONS(600),
    [anon_sym_break] = ACTIONS(600),
    [anon_sym_continue] = ACTIONS(600),
    [anon_sym_if] = ACTIONS(600),
    [anon_sym_async] = ACTIONS(600),
    [anon_sym_for] = ACTIONS(600),
    [anon_sym_while] = ACTIONS(600),
    [anon_sym_try] = ACTIONS(600),
    [anon_sym_with] = ACTIONS(600),
    [anon_sym_def] = ACTIONS(600),
    [anon_sym_global] = ACTIONS(600),
    [anon_sym_nonlocal] = ACTIONS(600),
    [anon_sym_exec] = ACTIONS(600),
    [anon_sym_class] = ACTIONS(600),
    [anon_sym_AT] = ACTIONS(598),
    [anon_sym_not] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(598),
    [anon_sym_DASH] = ACTIONS(598),
    [anon_sym_TILDE] = ACTIONS(598),
    [anon_sym_lambda] = ACTIONS(600),
    [anon_sym_yield] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(598),
    [sym_ellipsis] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(598),
    [sym_integer] = ACTIONS(600),
    [sym_float] = ACTIONS(598),
    [sym_true] = ACTIONS(600),
    [sym_false] = ACTIONS(600),
    [sym_none] = ACTIONS(600),
    [anon_sym_await] = ACTIONS(600),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(598),
  },
  [482] = {
    [ts_builtin_sym_end] = ACTIONS(1159),
    [sym_identifier] = ACTIONS(1161),
    [anon_sym_import] = ACTIONS(1161),
    [anon_sym_from] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [anon_sym_print] = ACTIONS(1161),
    [anon_sym_assert] = ACTIONS(1161),
    [anon_sym_return] = ACTIONS(1161),
    [anon_sym_del] = ACTIONS(1161),
    [anon_sym_raise] = ACTIONS(1161),
    [anon_sym_pass] = ACTIONS(1161),
    [anon_sym_break] = ACTIONS(1161),
    [anon_sym_continue] = ACTIONS(1161),
    [anon_sym_if] = ACTIONS(1161),
    [anon_sym_async] = ACTIONS(1161),
    [anon_sym_for] = ACTIONS(1161),
    [anon_sym_while] = ACTIONS(1161),
    [anon_sym_try] = ACTIONS(1161),
    [anon_sym_with] = ACTIONS(1161),
    [anon_sym_def] = ACTIONS(1161),
    [anon_sym_global] = ACTIONS(1161),
    [anon_sym_nonlocal] = ACTIONS(1161),
    [anon_sym_exec] = ACTIONS(1161),
    [anon_sym_class] = ACTIONS(1161),
    [anon_sym_AT] = ACTIONS(1159),
    [anon_sym_not] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_TILDE] = ACTIONS(1159),
    [anon_sym_lambda] = ACTIONS(1161),
    [anon_sym_yield] = ACTIONS(1161),
    [anon_sym_LBRACK] = ACTIONS(1159),
    [sym_ellipsis] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [sym_integer] = ACTIONS(1161),
    [sym_float] = ACTIONS(1159),
    [sym_true] = ACTIONS(1161),
    [sym_false] = ACTIONS(1161),
    [sym_none] = ACTIONS(1161),
    [anon_sym_await] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1159),
  },
  [483] = {
    [ts_builtin_sym_end] = ACTIONS(1113),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_import] = ACTIONS(1111),
    [anon_sym_from] = ACTIONS(1111),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_print] = ACTIONS(1111),
    [anon_sym_assert] = ACTIONS(1111),
    [anon_sym_return] = ACTIONS(1111),
    [anon_sym_del] = ACTIONS(1111),
    [anon_sym_raise] = ACTIONS(1111),
    [anon_sym_pass] = ACTIONS(1111),
    [anon_sym_break] = ACTIONS(1111),
    [anon_sym_continue] = ACTIONS(1111),
    [anon_sym_if] = ACTIONS(1111),
    [anon_sym_async] = ACTIONS(1111),
    [anon_sym_for] = ACTIONS(1111),
    [anon_sym_while] = ACTIONS(1111),
    [anon_sym_try] = ACTIONS(1111),
    [anon_sym_with] = ACTIONS(1111),
    [anon_sym_def] = ACTIONS(1111),
    [anon_sym_global] = ACTIONS(1111),
    [anon_sym_nonlocal] = ACTIONS(1111),
    [anon_sym_exec] = ACTIONS(1111),
    [anon_sym_class] = ACTIONS(1111),
    [anon_sym_AT] = ACTIONS(1113),
    [anon_sym_not] = ACTIONS(1111),
    [anon_sym_PLUS] = ACTIONS(1113),
    [anon_sym_DASH] = ACTIONS(1113),
    [anon_sym_TILDE] = ACTIONS(1113),
    [anon_sym_lambda] = ACTIONS(1111),
    [anon_sym_yield] = ACTIONS(1111),
    [anon_sym_LBRACK] = ACTIONS(1113),
    [sym_ellipsis] = ACTIONS(1113),
    [anon_sym_LBRACE] = ACTIONS(1113),
    [sym_integer] = ACTIONS(1111),
    [sym_float] = ACTIONS(1113),
    [sym_true] = ACTIONS(1111),
    [sym_false] = ACTIONS(1111),
    [sym_none] = ACTIONS(1111),
    [anon_sym_await] = ACTIONS(1111),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1113),
  },
  [484] = {
    [ts_builtin_sym_end] = ACTIONS(1157),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_import] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_print] = ACTIONS(1155),
    [anon_sym_assert] = ACTIONS(1155),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_del] = ACTIONS(1155),
    [anon_sym_raise] = ACTIONS(1155),
    [anon_sym_pass] = ACTIONS(1155),
    [anon_sym_break] = ACTIONS(1155),
    [anon_sym_continue] = ACTIONS(1155),
    [anon_sym_if] = ACTIONS(1155),
    [anon_sym_async] = ACTIONS(1155),
    [anon_sym_for] = ACTIONS(1155),
    [anon_sym_while] = ACTIONS(1155),
    [anon_sym_try] = ACTIONS(1155),
    [anon_sym_with] = ACTIONS(1155),
    [anon_sym_def] = ACTIONS(1155),
    [anon_sym_global] = ACTIONS(1155),
    [anon_sym_nonlocal] = ACTIONS(1155),
    [anon_sym_exec] = ACTIONS(1155),
    [anon_sym_class] = ACTIONS(1155),
    [anon_sym_AT] = ACTIONS(1157),
    [anon_sym_not] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1157),
    [anon_sym_DASH] = ACTIONS(1157),
    [anon_sym_TILDE] = ACTIONS(1157),
    [anon_sym_lambda] = ACTIONS(1155),
    [anon_sym_yield] = ACTIONS(1155),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [sym_ellipsis] = ACTIONS(1157),
    [anon_sym_LBRACE] = ACTIONS(1157),
    [sym_integer] = ACTIONS(1155),
    [sym_float] = ACTIONS(1157),
    [sym_true] = ACTIONS(1155),
    [sym_false] = ACTIONS(1155),
    [sym_none] = ACTIONS(1155),
    [anon_sym_await] = ACTIONS(1155),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1157),
  },
  [485] = {
    [sym_identifier] = ACTIONS(1037),
    [anon_sym_import] = ACTIONS(1037),
    [anon_sym_from] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(1035),
    [anon_sym_print] = ACTIONS(1037),
    [anon_sym_assert] = ACTIONS(1037),
    [anon_sym_return] = ACTIONS(1037),
    [anon_sym_del] = ACTIONS(1037),
    [anon_sym_raise] = ACTIONS(1037),
    [anon_sym_pass] = ACTIONS(1037),
    [anon_sym_break] = ACTIONS(1037),
    [anon_sym_continue] = ACTIONS(1037),
    [anon_sym_if] = ACTIONS(1037),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1037),
    [anon_sym_while] = ACTIONS(1037),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_with] = ACTIONS(1037),
    [anon_sym_def] = ACTIONS(1037),
    [anon_sym_global] = ACTIONS(1037),
    [anon_sym_nonlocal] = ACTIONS(1037),
    [anon_sym_exec] = ACTIONS(1037),
    [anon_sym_class] = ACTIONS(1037),
    [anon_sym_AT] = ACTIONS(1035),
    [anon_sym_not] = ACTIONS(1037),
    [anon_sym_PLUS] = ACTIONS(1035),
    [anon_sym_DASH] = ACTIONS(1035),
    [anon_sym_TILDE] = ACTIONS(1035),
    [anon_sym_lambda] = ACTIONS(1037),
    [anon_sym_yield] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1035),
    [sym_ellipsis] = ACTIONS(1035),
    [anon_sym_LBRACE] = ACTIONS(1035),
    [sym_integer] = ACTIONS(1037),
    [sym_float] = ACTIONS(1035),
    [sym_true] = ACTIONS(1037),
    [sym_false] = ACTIONS(1037),
    [sym_none] = ACTIONS(1037),
    [anon_sym_await] = ACTIONS(1037),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1035),
    [sym__string_start] = ACTIONS(1035),
  },
  [486] = {
    [ts_builtin_sym_end] = ACTIONS(1117),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_import] = ACTIONS(1115),
    [anon_sym_from] = ACTIONS(1115),
    [anon_sym_LPAREN] = ACTIONS(1117),
    [anon_sym_print] = ACTIONS(1115),
    [anon_sym_assert] = ACTIONS(1115),
    [anon_sym_return] = ACTIONS(1115),
    [anon_sym_del] = ACTIONS(1115),
    [anon_sym_raise] = ACTIONS(1115),
    [anon_sym_pass] = ACTIONS(1115),
    [anon_sym_break] = ACTIONS(1115),
    [anon_sym_continue] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(1115),
    [anon_sym_async] = ACTIONS(1115),
    [anon_sym_for] = ACTIONS(1115),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_try] = ACTIONS(1115),
    [anon_sym_with] = ACTIONS(1115),
    [anon_sym_def] = ACTIONS(1115),
    [anon_sym_global] = ACTIONS(1115),
    [anon_sym_nonlocal] = ACTIONS(1115),
    [anon_sym_exec] = ACTIONS(1115),
    [anon_sym_class] = ACTIONS(1115),
    [anon_sym_AT] = ACTIONS(1117),
    [anon_sym_not] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_TILDE] = ACTIONS(1117),
    [anon_sym_lambda] = ACTIONS(1115),
    [anon_sym_yield] = ACTIONS(1115),
    [anon_sym_LBRACK] = ACTIONS(1117),
    [sym_ellipsis] = ACTIONS(1117),
    [anon_sym_LBRACE] = ACTIONS(1117),
    [sym_integer] = ACTIONS(1115),
    [sym_float] = ACTIONS(1117),
    [sym_true] = ACTIONS(1115),
    [sym_false] = ACTIONS(1115),
    [sym_none] = ACTIONS(1115),
    [anon_sym_await] = ACTIONS(1115),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1117),
  },
  [487] = {
    [ts_builtin_sym_end] = ACTIONS(1163),
    [sym_identifier] = ACTIONS(1165),
    [anon_sym_import] = ACTIONS(1165),
    [anon_sym_from] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_print] = ACTIONS(1165),
    [anon_sym_assert] = ACTIONS(1165),
    [anon_sym_return] = ACTIONS(1165),
    [anon_sym_del] = ACTIONS(1165),
    [anon_sym_raise] = ACTIONS(1165),
    [anon_sym_pass] = ACTIONS(1165),
    [anon_sym_break] = ACTIONS(1165),
    [anon_sym_continue] = ACTIONS(1165),
    [anon_sym_if] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1165),
    [anon_sym_for] = ACTIONS(1165),
    [anon_sym_while] = ACTIONS(1165),
    [anon_sym_try] = ACTIONS(1165),
    [anon_sym_with] = ACTIONS(1165),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_global] = ACTIONS(1165),
    [anon_sym_nonlocal] = ACTIONS(1165),
    [anon_sym_exec] = ACTIONS(1165),
    [anon_sym_class] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1165),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_lambda] = ACTIONS(1165),
    [anon_sym_yield] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(1163),
    [sym_ellipsis] = ACTIONS(1163),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [sym_integer] = ACTIONS(1165),
    [sym_float] = ACTIONS(1163),
    [sym_true] = ACTIONS(1165),
    [sym_false] = ACTIONS(1165),
    [sym_none] = ACTIONS(1165),
    [anon_sym_await] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1163),
  },
  [488] = {
    [sym_identifier] = ACTIONS(1165),
    [anon_sym_import] = ACTIONS(1165),
    [anon_sym_from] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_print] = ACTIONS(1165),
    [anon_sym_assert] = ACTIONS(1165),
    [anon_sym_return] = ACTIONS(1165),
    [anon_sym_del] = ACTIONS(1165),
    [anon_sym_raise] = ACTIONS(1165),
    [anon_sym_pass] = ACTIONS(1165),
    [anon_sym_break] = ACTIONS(1165),
    [anon_sym_continue] = ACTIONS(1165),
    [anon_sym_if] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1165),
    [anon_sym_for] = ACTIONS(1165),
    [anon_sym_while] = ACTIONS(1165),
    [anon_sym_try] = ACTIONS(1165),
    [anon_sym_with] = ACTIONS(1165),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_global] = ACTIONS(1165),
    [anon_sym_nonlocal] = ACTIONS(1165),
    [anon_sym_exec] = ACTIONS(1165),
    [anon_sym_class] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1165),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_lambda] = ACTIONS(1165),
    [anon_sym_yield] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(1163),
    [sym_ellipsis] = ACTIONS(1163),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [sym_integer] = ACTIONS(1165),
    [sym_float] = ACTIONS(1163),
    [sym_true] = ACTIONS(1165),
    [sym_false] = ACTIONS(1165),
    [sym_none] = ACTIONS(1165),
    [anon_sym_await] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1163),
    [sym__string_start] = ACTIONS(1163),
  },
  [489] = {
    [ts_builtin_sym_end] = ACTIONS(1129),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_import] = ACTIONS(1127),
    [anon_sym_from] = ACTIONS(1127),
    [anon_sym_LPAREN] = ACTIONS(1129),
    [anon_sym_print] = ACTIONS(1127),
    [anon_sym_assert] = ACTIONS(1127),
    [anon_sym_return] = ACTIONS(1127),
    [anon_sym_del] = ACTIONS(1127),
    [anon_sym_raise] = ACTIONS(1127),
    [anon_sym_pass] = ACTIONS(1127),
    [anon_sym_break] = ACTIONS(1127),
    [anon_sym_continue] = ACTIONS(1127),
    [anon_sym_if] = ACTIONS(1127),
    [anon_sym_async] = ACTIONS(1127),
    [anon_sym_for] = ACTIONS(1127),
    [anon_sym_while] = ACTIONS(1127),
    [anon_sym_try] = ACTIONS(1127),
    [anon_sym_with] = ACTIONS(1127),
    [anon_sym_def] = ACTIONS(1127),
    [anon_sym_global] = ACTIONS(1127),
    [anon_sym_nonlocal] = ACTIONS(1127),
    [anon_sym_exec] = ACTIONS(1127),
    [anon_sym_class] = ACTIONS(1127),
    [anon_sym_AT] = ACTIONS(1129),
    [anon_sym_not] = ACTIONS(1127),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_lambda] = ACTIONS(1127),
    [anon_sym_yield] = ACTIONS(1127),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [sym_ellipsis] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(1129),
    [sym_integer] = ACTIONS(1127),
    [sym_float] = ACTIONS(1129),
    [sym_true] = ACTIONS(1127),
    [sym_false] = ACTIONS(1127),
    [sym_none] = ACTIONS(1127),
    [anon_sym_await] = ACTIONS(1127),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1129),
  },
  [490] = {
    [ts_builtin_sym_end] = ACTIONS(1121),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_from] = ACTIONS(1119),
    [anon_sym_LPAREN] = ACTIONS(1121),
    [anon_sym_print] = ACTIONS(1119),
    [anon_sym_assert] = ACTIONS(1119),
    [anon_sym_return] = ACTIONS(1119),
    [anon_sym_del] = ACTIONS(1119),
    [anon_sym_raise] = ACTIONS(1119),
    [anon_sym_pass] = ACTIONS(1119),
    [anon_sym_break] = ACTIONS(1119),
    [anon_sym_continue] = ACTIONS(1119),
    [anon_sym_if] = ACTIONS(1119),
    [anon_sym_async] = ACTIONS(1119),
    [anon_sym_for] = ACTIONS(1119),
    [anon_sym_while] = ACTIONS(1119),
    [anon_sym_try] = ACTIONS(1119),
    [anon_sym_with] = ACTIONS(1119),
    [anon_sym_def] = ACTIONS(1119),
    [anon_sym_global] = ACTIONS(1119),
    [anon_sym_nonlocal] = ACTIONS(1119),
    [anon_sym_exec] = ACTIONS(1119),
    [anon_sym_class] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(1121),
    [anon_sym_not] = ACTIONS(1119),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_TILDE] = ACTIONS(1121),
    [anon_sym_lambda] = ACTIONS(1119),
    [anon_sym_yield] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [sym_ellipsis] = ACTIONS(1121),
    [anon_sym_LBRACE] = ACTIONS(1121),
    [sym_integer] = ACTIONS(1119),
    [sym_float] = ACTIONS(1121),
    [sym_true] = ACTIONS(1119),
    [sym_false] = ACTIONS(1119),
    [sym_none] = ACTIONS(1119),
    [anon_sym_await] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1121),
  },
  [491] = {
    [sym_identifier] = ACTIONS(1153),
    [anon_sym_import] = ACTIONS(1153),
    [anon_sym_from] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_print] = ACTIONS(1153),
    [anon_sym_assert] = ACTIONS(1153),
    [anon_sym_return] = ACTIONS(1153),
    [anon_sym_del] = ACTIONS(1153),
    [anon_sym_raise] = ACTIONS(1153),
    [anon_sym_pass] = ACTIONS(1153),
    [anon_sym_break] = ACTIONS(1153),
    [anon_sym_continue] = ACTIONS(1153),
    [anon_sym_if] = ACTIONS(1153),
    [anon_sym_async] = ACTIONS(1153),
    [anon_sym_for] = ACTIONS(1153),
    [anon_sym_while] = ACTIONS(1153),
    [anon_sym_try] = ACTIONS(1153),
    [anon_sym_with] = ACTIONS(1153),
    [anon_sym_def] = ACTIONS(1153),
    [anon_sym_global] = ACTIONS(1153),
    [anon_sym_nonlocal] = ACTIONS(1153),
    [anon_sym_exec] = ACTIONS(1153),
    [anon_sym_class] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(1151),
    [anon_sym_not] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_TILDE] = ACTIONS(1151),
    [anon_sym_lambda] = ACTIONS(1153),
    [anon_sym_yield] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1151),
    [sym_ellipsis] = ACTIONS(1151),
    [anon_sym_LBRACE] = ACTIONS(1151),
    [sym_integer] = ACTIONS(1153),
    [sym_float] = ACTIONS(1151),
    [sym_true] = ACTIONS(1153),
    [sym_false] = ACTIONS(1153),
    [sym_none] = ACTIONS(1153),
    [anon_sym_await] = ACTIONS(1153),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1151),
    [sym__string_start] = ACTIONS(1151),
  },
  [492] = {
    [sym_identifier] = ACTIONS(1161),
    [anon_sym_import] = ACTIONS(1161),
    [anon_sym_from] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [anon_sym_print] = ACTIONS(1161),
    [anon_sym_assert] = ACTIONS(1161),
    [anon_sym_return] = ACTIONS(1161),
    [anon_sym_del] = ACTIONS(1161),
    [anon_sym_raise] = ACTIONS(1161),
    [anon_sym_pass] = ACTIONS(1161),
    [anon_sym_break] = ACTIONS(1161),
    [anon_sym_continue] = ACTIONS(1161),
    [anon_sym_if] = ACTIONS(1161),
    [anon_sym_async] = ACTIONS(1161),
    [anon_sym_for] = ACTIONS(1161),
    [anon_sym_while] = ACTIONS(1161),
    [anon_sym_try] = ACTIONS(1161),
    [anon_sym_with] = ACTIONS(1161),
    [anon_sym_def] = ACTIONS(1161),
    [anon_sym_global] = ACTIONS(1161),
    [anon_sym_nonlocal] = ACTIONS(1161),
    [anon_sym_exec] = ACTIONS(1161),
    [anon_sym_class] = ACTIONS(1161),
    [anon_sym_AT] = ACTIONS(1159),
    [anon_sym_not] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_TILDE] = ACTIONS(1159),
    [anon_sym_lambda] = ACTIONS(1161),
    [anon_sym_yield] = ACTIONS(1161),
    [anon_sym_LBRACK] = ACTIONS(1159),
    [sym_ellipsis] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [sym_integer] = ACTIONS(1161),
    [sym_float] = ACTIONS(1159),
    [sym_true] = ACTIONS(1161),
    [sym_false] = ACTIONS(1161),
    [sym_none] = ACTIONS(1161),
    [anon_sym_await] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1159),
    [sym__string_start] = ACTIONS(1159),
  },
  [493] = {
    [ts_builtin_sym_end] = ACTIONS(1109),
    [sym_identifier] = ACTIONS(1107),
    [anon_sym_import] = ACTIONS(1107),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_LPAREN] = ACTIONS(1109),
    [anon_sym_print] = ACTIONS(1107),
    [anon_sym_assert] = ACTIONS(1107),
    [anon_sym_return] = ACTIONS(1107),
    [anon_sym_del] = ACTIONS(1107),
    [anon_sym_raise] = ACTIONS(1107),
    [anon_sym_pass] = ACTIONS(1107),
    [anon_sym_break] = ACTIONS(1107),
    [anon_sym_continue] = ACTIONS(1107),
    [anon_sym_if] = ACTIONS(1107),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_for] = ACTIONS(1107),
    [anon_sym_while] = ACTIONS(1107),
    [anon_sym_try] = ACTIONS(1107),
    [anon_sym_with] = ACTIONS(1107),
    [anon_sym_def] = ACTIONS(1107),
    [anon_sym_global] = ACTIONS(1107),
    [anon_sym_nonlocal] = ACTIONS(1107),
    [anon_sym_exec] = ACTIONS(1107),
    [anon_sym_class] = ACTIONS(1107),
    [anon_sym_AT] = ACTIONS(1109),
    [anon_sym_not] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_DASH] = ACTIONS(1109),
    [anon_sym_TILDE] = ACTIONS(1109),
    [anon_sym_lambda] = ACTIONS(1107),
    [anon_sym_yield] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [sym_ellipsis] = ACTIONS(1109),
    [anon_sym_LBRACE] = ACTIONS(1109),
    [sym_integer] = ACTIONS(1107),
    [sym_float] = ACTIONS(1109),
    [sym_true] = ACTIONS(1107),
    [sym_false] = ACTIONS(1107),
    [sym_none] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1107),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1109),
  },
  [494] = {
    [ts_builtin_sym_end] = ACTIONS(1137),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_from] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_print] = ACTIONS(1135),
    [anon_sym_assert] = ACTIONS(1135),
    [anon_sym_return] = ACTIONS(1135),
    [anon_sym_del] = ACTIONS(1135),
    [anon_sym_raise] = ACTIONS(1135),
    [anon_sym_pass] = ACTIONS(1135),
    [anon_sym_break] = ACTIONS(1135),
    [anon_sym_continue] = ACTIONS(1135),
    [anon_sym_if] = ACTIONS(1135),
    [anon_sym_async] = ACTIONS(1135),
    [anon_sym_for] = ACTIONS(1135),
    [anon_sym_while] = ACTIONS(1135),
    [anon_sym_try] = ACTIONS(1135),
    [anon_sym_with] = ACTIONS(1135),
    [anon_sym_def] = ACTIONS(1135),
    [anon_sym_global] = ACTIONS(1135),
    [anon_sym_nonlocal] = ACTIONS(1135),
    [anon_sym_exec] = ACTIONS(1135),
    [anon_sym_class] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(1137),
    [anon_sym_not] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1137),
    [anon_sym_DASH] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1137),
    [anon_sym_lambda] = ACTIONS(1135),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_ellipsis] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(1137),
    [sym_integer] = ACTIONS(1135),
    [sym_float] = ACTIONS(1137),
    [sym_true] = ACTIONS(1135),
    [sym_false] = ACTIONS(1135),
    [sym_none] = ACTIONS(1135),
    [anon_sym_await] = ACTIONS(1135),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1137),
  },
  [495] = {
    [anon_sym_DOT] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_RPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(602),
    [anon_sym_STAR] = ACTIONS(604),
    [anon_sym_GT_GT] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(602),
    [anon_sym_else] = ACTIONS(602),
    [anon_sym_async] = ACTIONS(602),
    [anon_sym_for] = ACTIONS(602),
    [anon_sym_in] = ACTIONS(602),
    [anon_sym_EQ] = ACTIONS(604),
    [anon_sym_AT] = ACTIONS(602),
    [anon_sym_not] = ACTIONS(602),
    [anon_sym_and] = ACTIONS(602),
    [anon_sym_or] = ACTIONS(602),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_SLASH] = ACTIONS(604),
    [anon_sym_PERCENT] = ACTIONS(602),
    [anon_sym_SLASH_SLASH] = ACTIONS(602),
    [anon_sym_STAR_STAR] = ACTIONS(602),
    [anon_sym_PIPE] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(602),
    [anon_sym_CARET] = ACTIONS(602),
    [anon_sym_LT_LT] = ACTIONS(602),
    [anon_sym_LT] = ACTIONS(604),
    [anon_sym_LT_EQ] = ACTIONS(602),
    [anon_sym_EQ_EQ] = ACTIONS(602),
    [anon_sym_BANG_EQ] = ACTIONS(602),
    [anon_sym_GT_EQ] = ACTIONS(602),
    [anon_sym_GT] = ACTIONS(604),
    [anon_sym_LT_GT] = ACTIONS(602),
    [anon_sym_is] = ACTIONS(602),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_RBRACK] = ACTIONS(602),
    [anon_sym_RBRACE] = ACTIONS(602),
    [sym_type_conversion] = ACTIONS(602),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(602),
  },
  [496] = {
    [anon_sym_DOT] = ACTIONS(578),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(580),
    [anon_sym_GT_GT] = ACTIONS(578),
    [anon_sym_if] = ACTIONS(578),
    [anon_sym_COLON] = ACTIONS(578),
    [anon_sym_else] = ACTIONS(578),
    [anon_sym_async] = ACTIONS(578),
    [anon_sym_for] = ACTIONS(578),
    [anon_sym_in] = ACTIONS(578),
    [anon_sym_EQ] = ACTIONS(580),
    [anon_sym_AT] = ACTIONS(578),
    [anon_sym_not] = ACTIONS(578),
    [anon_sym_and] = ACTIONS(578),
    [anon_sym_or] = ACTIONS(578),
    [anon_sym_PLUS] = ACTIONS(578),
    [anon_sym_DASH] = ACTIONS(578),
    [anon_sym_SLASH] = ACTIONS(580),
    [anon_sym_PERCENT] = ACTIONS(578),
    [anon_sym_SLASH_SLASH] = ACTIONS(578),
    [anon_sym_STAR_STAR] = ACTIONS(578),
    [anon_sym_PIPE] = ACTIONS(578),
    [anon_sym_AMP] = ACTIONS(578),
    [anon_sym_CARET] = ACTIONS(578),
    [anon_sym_LT_LT] = ACTIONS(578),
    [anon_sym_LT] = ACTIONS(580),
    [anon_sym_LT_EQ] = ACTIONS(578),
    [anon_sym_EQ_EQ] = ACTIONS(578),
    [anon_sym_BANG_EQ] = ACTIONS(578),
    [anon_sym_GT_EQ] = ACTIONS(578),
    [anon_sym_GT] = ACTIONS(580),
    [anon_sym_LT_GT] = ACTIONS(578),
    [anon_sym_is] = ACTIONS(578),
    [anon_sym_LBRACK] = ACTIONS(578),
    [anon_sym_RBRACK] = ACTIONS(578),
    [anon_sym_RBRACE] = ACTIONS(578),
    [sym_type_conversion] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(578),
  },
  [497] = {
    [anon_sym_DOT] = ACTIONS(440),
    [anon_sym_LPAREN] = ACTIONS(440),
    [anon_sym_RPAREN] = ACTIONS(440),
    [anon_sym_COMMA] = ACTIONS(440),
    [anon_sym_STAR] = ACTIONS(442),
    [anon_sym_GT_GT] = ACTIONS(440),
    [anon_sym_COLON_EQ] = ACTIONS(1167),
    [anon_sym_if] = ACTIONS(440),
    [anon_sym_COLON] = ACTIONS(442),
    [anon_sym_else] = ACTIONS(440),
    [anon_sym_async] = ACTIONS(440),
    [anon_sym_for] = ACTIONS(440),
    [anon_sym_in] = ACTIONS(440),
    [anon_sym_EQ] = ACTIONS(442),
    [anon_sym_AT] = ACTIONS(440),
    [anon_sym_not] = ACTIONS(440),
    [anon_sym_and] = ACTIONS(440),
    [anon_sym_or] = ACTIONS(440),
    [anon_sym_PLUS] = ACTIONS(440),
    [anon_sym_DASH] = ACTIONS(440),
    [anon_sym_SLASH] = ACTIONS(442),
    [anon_sym_PERCENT] = ACTIONS(440),
    [anon_sym_SLASH_SLASH] = ACTIONS(440),
    [anon_sym_STAR_STAR] = ACTIONS(440),
    [anon_sym_PIPE] = ACTIONS(440),
    [anon_sym_AMP] = ACTIONS(440),
    [anon_sym_CARET] = ACTIONS(440),
    [anon_sym_LT_LT] = ACTIONS(440),
    [anon_sym_LT] = ACTIONS(442),
    [anon_sym_LT_EQ] = ACTIONS(440),
    [anon_sym_EQ_EQ] = ACTIONS(440),
    [anon_sym_BANG_EQ] = ACTIONS(440),
    [anon_sym_GT_EQ] = ACTIONS(440),
    [anon_sym_GT] = ACTIONS(442),
    [anon_sym_LT_GT] = ACTIONS(440),
    [anon_sym_is] = ACTIONS(440),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_RBRACK] = ACTIONS(440),
    [anon_sym_RBRACE] = ACTIONS(440),
    [sym_type_conversion] = ACTIONS(440),
    [sym_comment] = ACTIONS(3),
  },
  [498] = {
    [anon_sym_DOT] = ACTIONS(758),
    [anon_sym_LPAREN] = ACTIONS(758),
    [anon_sym_RPAREN] = ACTIONS(758),
    [anon_sym_COMMA] = ACTIONS(758),
    [anon_sym_STAR] = ACTIONS(760),
    [anon_sym_GT_GT] = ACTIONS(758),
    [anon_sym_if] = ACTIONS(758),
    [anon_sym_COLON] = ACTIONS(758),
    [anon_sym_else] = ACTIONS(758),
    [anon_sym_async] = ACTIONS(758),
    [anon_sym_for] = ACTIONS(758),
    [anon_sym_in] = ACTIONS(758),
    [anon_sym_EQ] = ACTIONS(760),
    [anon_sym_AT] = ACTIONS(758),
    [anon_sym_not] = ACTIONS(758),
    [anon_sym_and] = ACTIONS(758),
    [anon_sym_or] = ACTIONS(758),
    [anon_sym_PLUS] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(758),
    [anon_sym_SLASH] = ACTIONS(760),
    [anon_sym_PERCENT] = ACTIONS(758),
    [anon_sym_SLASH_SLASH] = ACTIONS(758),
    [anon_sym_STAR_STAR] = ACTIONS(758),
    [anon_sym_PIPE] = ACTIONS(758),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_CARET] = ACTIONS(758),
    [anon_sym_LT_LT] = ACTIONS(758),
    [anon_sym_LT] = ACTIONS(760),
    [anon_sym_LT_EQ] = ACTIONS(758),
    [anon_sym_EQ_EQ] = ACTIONS(758),
    [anon_sym_BANG_EQ] = ACTIONS(758),
    [anon_sym_GT_EQ] = ACTIONS(758),
    [anon_sym_GT] = ACTIONS(760),
    [anon_sym_LT_GT] = ACTIONS(758),
    [anon_sym_is] = ACTIONS(758),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_RBRACK] = ACTIONS(758),
    [anon_sym_RBRACE] = ACTIONS(758),
    [sym_type_conversion] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
  },
  [499] = {
    [anon_sym_DOT] = ACTIONS(806),
    [anon_sym_LPAREN] = ACTIONS(806),
    [anon_sym_RPAREN] = ACTIONS(806),
    [anon_sym_COMMA] = ACTIONS(806),
    [anon_sym_STAR] = ACTIONS(808),
    [anon_sym_GT_GT] = ACTIONS(806),
    [anon_sym_if] = ACTIONS(806),
    [anon_sym_COLON] = ACTIONS(806),
    [anon_sym_else] = ACTIONS(806),
    [anon_sym_async] = ACTIONS(806),
    [anon_sym_for] = ACTIONS(806),
    [anon_sym_in] = ACTIONS(806),
    [anon_sym_EQ] = ACTIONS(808),
    [anon_sym_AT] = ACTIONS(806),
    [anon_sym_not] = ACTIONS(806),
    [anon_sym_and] = ACTIONS(806),
    [anon_sym_or] = ACTIONS(806),
    [anon_sym_PLUS] = ACTIONS(806),
    [anon_sym_DASH] = ACTIONS(806),
    [anon_sym_SLASH] = ACTIONS(808),
    [anon_sym_PERCENT] = ACTIONS(806),
    [anon_sym_SLASH_SLASH] = ACTIONS(806),
    [anon_sym_STAR_STAR] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(806),
    [anon_sym_AMP] = ACTIONS(806),
    [anon_sym_CARET] = ACTIONS(806),
    [anon_sym_LT_LT] = ACTIONS(806),
    [anon_sym_LT] = ACTIONS(808),
    [anon_sym_LT_EQ] = ACTIONS(806),
    [anon_sym_EQ_EQ] = ACTIONS(806),
    [anon_sym_BANG_EQ] = ACTIONS(806),
    [anon_sym_GT_EQ] = ACTIONS(806),
    [anon_sym_GT] = ACTIONS(808),
    [anon_sym_LT_GT] = ACTIONS(806),
    [anon_sym_is] = ACTIONS(806),
    [anon_sym_LBRACK] = ACTIONS(806),
    [anon_sym_RBRACK] = ACTIONS(806),
    [anon_sym_RBRACE] = ACTIONS(806),
    [sym_type_conversion] = ACTIONS(806),
    [sym_comment] = ACTIONS(3),
  },
  [500] = {
    [anon_sym_DOT] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(816),
    [anon_sym_RPAREN] = ACTIONS(816),
    [anon_sym_COMMA] = ACTIONS(816),
    [anon_sym_STAR] = ACTIONS(818),
    [anon_sym_GT_GT] = ACTIONS(816),
    [anon_sym_if] = ACTIONS(816),
    [anon_sym_COLON] = ACTIONS(816),
    [anon_sym_else] = ACTIONS(816),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_for] = ACTIONS(816),
    [anon_sym_in] = ACTIONS(816),
    [anon_sym_EQ] = ACTIONS(818),
    [anon_sym_AT] = ACTIONS(816),
    [anon_sym_not] = ACTIONS(816),
    [anon_sym_and] = ACTIONS(816),
    [anon_sym_or] = ACTIONS(816),
    [anon_sym_PLUS] = ACTIONS(816),
    [anon_sym_DASH] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(818),
    [anon_sym_PERCENT] = ACTIONS(816),
    [anon_sym_SLASH_SLASH] = ACTIONS(816),
    [anon_sym_STAR_STAR] = ACTIONS(816),
    [anon_sym_PIPE] = ACTIONS(816),
    [anon_sym_AMP] = ACTIONS(816),
    [anon_sym_CARET] = ACTIONS(816),
    [anon_sym_LT_LT] = ACTIONS(816),
    [anon_sym_LT] = ACTIONS(818),
    [anon_sym_LT_EQ] = ACTIONS(816),
    [anon_sym_EQ_EQ] = ACTIONS(816),
    [anon_sym_BANG_EQ] = ACTIONS(816),
    [anon_sym_GT_EQ] = ACTIONS(816),
    [anon_sym_GT] = ACTIONS(818),
    [anon_sym_LT_GT] = ACTIONS(816),
    [anon_sym_is] = ACTIONS(816),
    [anon_sym_LBRACK] = ACTIONS(816),
    [anon_sym_RBRACK] = ACTIONS(816),
    [anon_sym_RBRACE] = ACTIONS(816),
    [sym_type_conversion] = ACTIONS(816),
    [sym_comment] = ACTIONS(3),
  },
  [501] = {
    [anon_sym_DOT] = ACTIONS(792),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_RPAREN] = ACTIONS(792),
    [anon_sym_COMMA] = ACTIONS(792),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_GT_GT] = ACTIONS(792),
    [anon_sym_if] = ACTIONS(792),
    [anon_sym_COLON] = ACTIONS(792),
    [anon_sym_else] = ACTIONS(792),
    [anon_sym_async] = ACTIONS(792),
    [anon_sym_for] = ACTIONS(792),
    [anon_sym_in] = ACTIONS(792),
    [anon_sym_EQ] = ACTIONS(794),
    [anon_sym_AT] = ACTIONS(792),
    [anon_sym_not] = ACTIONS(792),
    [anon_sym_and] = ACTIONS(792),
    [anon_sym_or] = ACTIONS(792),
    [anon_sym_PLUS] = ACTIONS(792),
    [anon_sym_DASH] = ACTIONS(792),
    [anon_sym_SLASH] = ACTIONS(794),
    [anon_sym_PERCENT] = ACTIONS(792),
    [anon_sym_SLASH_SLASH] = ACTIONS(792),
    [anon_sym_STAR_STAR] = ACTIONS(792),
    [anon_sym_PIPE] = ACTIONS(792),
    [anon_sym_AMP] = ACTIONS(792),
    [anon_sym_CARET] = ACTIONS(792),
    [anon_sym_LT_LT] = ACTIONS(792),
    [anon_sym_LT] = ACTIONS(794),
    [anon_sym_LT_EQ] = ACTIONS(792),
    [anon_sym_EQ_EQ] = ACTIONS(792),
    [anon_sym_BANG_EQ] = ACTIONS(792),
    [anon_sym_GT_EQ] = ACTIONS(792),
    [anon_sym_GT] = ACTIONS(794),
    [anon_sym_LT_GT] = ACTIONS(792),
    [anon_sym_is] = ACTIONS(792),
    [anon_sym_LBRACK] = ACTIONS(792),
    [anon_sym_RBRACK] = ACTIONS(792),
    [anon_sym_RBRACE] = ACTIONS(792),
    [sym_type_conversion] = ACTIONS(792),
    [sym_comment] = ACTIONS(3),
  },
  [502] = {
    [anon_sym_DOT] = ACTIONS(788),
    [anon_sym_LPAREN] = ACTIONS(788),
    [anon_sym_RPAREN] = ACTIONS(788),
    [anon_sym_COMMA] = ACTIONS(788),
    [anon_sym_STAR] = ACTIONS(790),
    [anon_sym_GT_GT] = ACTIONS(788),
    [anon_sym_if] = ACTIONS(788),
    [anon_sym_COLON] = ACTIONS(788),
    [anon_sym_else] = ACTIONS(788),
    [anon_sym_async] = ACTIONS(788),
    [anon_sym_for] = ACTIONS(788),
    [anon_sym_in] = ACTIONS(788),
    [anon_sym_EQ] = ACTIONS(790),
    [anon_sym_AT] = ACTIONS(788),
    [anon_sym_not] = ACTIONS(788),
    [anon_sym_and] = ACTIONS(788),
    [anon_sym_or] = ACTIONS(788),
    [anon_sym_PLUS] = ACTIONS(788),
    [anon_sym_DASH] = ACTIONS(788),
    [anon_sym_SLASH] = ACTIONS(790),
    [anon_sym_PERCENT] = ACTIONS(788),
    [anon_sym_SLASH_SLASH] = ACTIONS(788),
    [anon_sym_STAR_STAR] = ACTIONS(788),
    [anon_sym_PIPE] = ACTIONS(788),
    [anon_sym_AMP] = ACTIONS(788),
    [anon_sym_CARET] = ACTIONS(788),
    [anon_sym_LT_LT] = ACTIONS(788),
    [anon_sym_LT] = ACTIONS(790),
    [anon_sym_LT_EQ] = ACTIONS(788),
    [anon_sym_EQ_EQ] = ACTIONS(788),
    [anon_sym_BANG_EQ] = ACTIONS(788),
    [anon_sym_GT_EQ] = ACTIONS(788),
    [anon_sym_GT] = ACTIONS(790),
    [anon_sym_LT_GT] = ACTIONS(788),
    [anon_sym_is] = ACTIONS(788),
    [anon_sym_LBRACK] = ACTIONS(788),
    [anon_sym_RBRACK] = ACTIONS(788),
    [anon_sym_RBRACE] = ACTIONS(788),
    [sym_type_conversion] = ACTIONS(788),
    [sym_comment] = ACTIONS(3),
  },
  [503] = {
    [anon_sym_DOT] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(780),
    [anon_sym_RPAREN] = ACTIONS(780),
    [anon_sym_COMMA] = ACTIONS(780),
    [anon_sym_STAR] = ACTIONS(782),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_if] = ACTIONS(780),
    [anon_sym_COLON] = ACTIONS(780),
    [anon_sym_else] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(780),
    [anon_sym_for] = ACTIONS(780),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_EQ] = ACTIONS(782),
    [anon_sym_AT] = ACTIONS(780),
    [anon_sym_not] = ACTIONS(780),
    [anon_sym_and] = ACTIONS(780),
    [anon_sym_or] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(782),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_SLASH_SLASH] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_LT_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_GT_EQ] = ACTIONS(780),
    [anon_sym_GT] = ACTIONS(782),
    [anon_sym_LT_GT] = ACTIONS(780),
    [anon_sym_is] = ACTIONS(780),
    [anon_sym_LBRACK] = ACTIONS(780),
    [anon_sym_RBRACK] = ACTIONS(780),
    [anon_sym_RBRACE] = ACTIONS(780),
    [sym_type_conversion] = ACTIONS(780),
    [sym_comment] = ACTIONS(3),
  },
  [504] = {
    [anon_sym_DOT] = ACTIONS(766),
    [anon_sym_LPAREN] = ACTIONS(766),
    [anon_sym_RPAREN] = ACTIONS(766),
    [anon_sym_COMMA] = ACTIONS(766),
    [anon_sym_STAR] = ACTIONS(768),
    [anon_sym_GT_GT] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(766),
    [anon_sym_COLON] = ACTIONS(766),
    [anon_sym_else] = ACTIONS(766),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_for] = ACTIONS(766),
    [anon_sym_in] = ACTIONS(766),
    [anon_sym_EQ] = ACTIONS(768),
    [anon_sym_AT] = ACTIONS(766),
    [anon_sym_not] = ACTIONS(766),
    [anon_sym_and] = ACTIONS(766),
    [anon_sym_or] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_PERCENT] = ACTIONS(766),
    [anon_sym_SLASH_SLASH] = ACTIONS(766),
    [anon_sym_STAR_STAR] = ACTIONS(766),
    [anon_sym_PIPE] = ACTIONS(766),
    [anon_sym_AMP] = ACTIONS(766),
    [anon_sym_CARET] = ACTIONS(766),
    [anon_sym_LT_LT] = ACTIONS(766),
    [anon_sym_LT] = ACTIONS(768),
    [anon_sym_LT_EQ] = ACTIONS(766),
    [anon_sym_EQ_EQ] = ACTIONS(766),
    [anon_sym_BANG_EQ] = ACTIONS(766),
    [anon_sym_GT_EQ] = ACTIONS(766),
    [anon_sym_GT] = ACTIONS(768),
    [anon_sym_LT_GT] = ACTIONS(766),
    [anon_sym_is] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(766),
    [anon_sym_RBRACK] = ACTIONS(766),
    [anon_sym_RBRACE] = ACTIONS(766),
    [sym_type_conversion] = ACTIONS(766),
    [sym_comment] = ACTIONS(3),
  },
  [505] = {
    [anon_sym_DOT] = ACTIONS(682),
    [anon_sym_LPAREN] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(682),
    [anon_sym_COMMA] = ACTIONS(682),
    [anon_sym_STAR] = ACTIONS(684),
    [anon_sym_GT_GT] = ACTIONS(682),
    [anon_sym_if] = ACTIONS(682),
    [anon_sym_COLON] = ACTIONS(682),
    [anon_sym_else] = ACTIONS(682),
    [anon_sym_async] = ACTIONS(682),
    [anon_sym_for] = ACTIONS(682),
    [anon_sym_in] = ACTIONS(682),
    [anon_sym_EQ] = ACTIONS(684),
    [anon_sym_AT] = ACTIONS(682),
    [anon_sym_not] = ACTIONS(682),
    [anon_sym_and] = ACTIONS(682),
    [anon_sym_or] = ACTIONS(682),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_SLASH] = ACTIONS(684),
    [anon_sym_PERCENT] = ACTIONS(682),
    [anon_sym_SLASH_SLASH] = ACTIONS(682),
    [anon_sym_STAR_STAR] = ACTIONS(682),
    [anon_sym_PIPE] = ACTIONS(682),
    [anon_sym_AMP] = ACTIONS(682),
    [anon_sym_CARET] = ACTIONS(682),
    [anon_sym_LT_LT] = ACTIONS(682),
    [anon_sym_LT] = ACTIONS(684),
    [anon_sym_LT_EQ] = ACTIONS(682),
    [anon_sym_EQ_EQ] = ACTIONS(682),
    [anon_sym_BANG_EQ] = ACTIONS(682),
    [anon_sym_GT_EQ] = ACTIONS(682),
    [anon_sym_GT] = ACTIONS(684),
    [anon_sym_LT_GT] = ACTIONS(682),
    [anon_sym_is] = ACTIONS(682),
    [anon_sym_LBRACK] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(682),
    [sym_type_conversion] = ACTIONS(682),
    [sym_comment] = ACTIONS(3),
  },
  [506] = {
    [anon_sym_DOT] = ACTIONS(776),
    [anon_sym_LPAREN] = ACTIONS(776),
    [anon_sym_RPAREN] = ACTIONS(776),
    [anon_sym_COMMA] = ACTIONS(776),
    [anon_sym_STAR] = ACTIONS(778),
    [anon_sym_GT_GT] = ACTIONS(776),
    [anon_sym_if] = ACTIONS(776),
    [anon_sym_COLON] = ACTIONS(776),
    [anon_sym_else] = ACTIONS(776),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_for] = ACTIONS(776),
    [anon_sym_in] = ACTIONS(776),
    [anon_sym_EQ] = ACTIONS(778),
    [anon_sym_AT] = ACTIONS(776),
    [anon_sym_not] = ACTIONS(776),
    [anon_sym_and] = ACTIONS(776),
    [anon_sym_or] = ACTIONS(776),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_PERCENT] = ACTIONS(776),
    [anon_sym_SLASH_SLASH] = ACTIONS(776),
    [anon_sym_STAR_STAR] = ACTIONS(776),
    [anon_sym_PIPE] = ACTIONS(776),
    [anon_sym_AMP] = ACTIONS(776),
    [anon_sym_CARET] = ACTIONS(776),
    [anon_sym_LT_LT] = ACTIONS(776),
    [anon_sym_LT] = ACTIONS(778),
    [anon_sym_LT_EQ] = ACTIONS(776),
    [anon_sym_EQ_EQ] = ACTIONS(776),
    [anon_sym_BANG_EQ] = ACTIONS(776),
    [anon_sym_GT_EQ] = ACTIONS(776),
    [anon_sym_GT] = ACTIONS(778),
    [anon_sym_LT_GT] = ACTIONS(776),
    [anon_sym_is] = ACTIONS(776),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_RBRACK] = ACTIONS(776),
    [anon_sym_RBRACE] = ACTIONS(776),
    [sym_type_conversion] = ACTIONS(776),
    [sym_comment] = ACTIONS(3),
  },
  [507] = {
    [anon_sym_DOT] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_RPAREN] = ACTIONS(237),
    [anon_sym_COMMA] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(237),
    [anon_sym_if] = ACTIONS(237),
    [anon_sym_COLON] = ACTIONS(237),
    [anon_sym_else] = ACTIONS(237),
    [anon_sym_async] = ACTIONS(237),
    [anon_sym_for] = ACTIONS(237),
    [anon_sym_in] = ACTIONS(237),
    [anon_sym_EQ] = ACTIONS(235),
    [anon_sym_AT] = ACTIONS(237),
    [anon_sym_not] = ACTIONS(237),
    [anon_sym_and] = ACTIONS(237),
    [anon_sym_or] = ACTIONS(237),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(237),
    [anon_sym_SLASH_SLASH] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(237),
    [anon_sym_PIPE] = ACTIONS(237),
    [anon_sym_AMP] = ACTIONS(237),
    [anon_sym_CARET] = ACTIONS(237),
    [anon_sym_LT_LT] = ACTIONS(237),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_LT_GT] = ACTIONS(237),
    [anon_sym_is] = ACTIONS(237),
    [anon_sym_LBRACK] = ACTIONS(237),
    [anon_sym_RBRACK] = ACTIONS(237),
    [anon_sym_RBRACE] = ACTIONS(237),
    [sym_type_conversion] = ACTIONS(237),
    [sym_comment] = ACTIONS(3),
  },
  [508] = {
    [anon_sym_DOT] = ACTIONS(636),
    [anon_sym_LPAREN] = ACTIONS(636),
    [anon_sym_RPAREN] = ACTIONS(636),
    [anon_sym_COMMA] = ACTIONS(636),
    [anon_sym_STAR] = ACTIONS(638),
    [anon_sym_GT_GT] = ACTIONS(636),
    [anon_sym_if] = ACTIONS(636),
    [anon_sym_COLON] = ACTIONS(636),
    [anon_sym_else] = ACTIONS(636),
    [anon_sym_async] = ACTIONS(636),
    [anon_sym_for] = ACTIONS(636),
    [anon_sym_in] = ACTIONS(636),
    [anon_sym_EQ] = ACTIONS(638),
    [anon_sym_AT] = ACTIONS(636),
    [anon_sym_not] = ACTIONS(636),
    [anon_sym_and] = ACTIONS(636),
    [anon_sym_or] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(636),
    [anon_sym_DASH] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(638),
    [anon_sym_PERCENT] = ACTIONS(636),
    [anon_sym_SLASH_SLASH] = ACTIONS(636),
    [anon_sym_STAR_STAR] = ACTIONS(636),
    [anon_sym_PIPE] = ACTIONS(636),
    [anon_sym_AMP] = ACTIONS(636),
    [anon_sym_CARET] = ACTIONS(636),
    [anon_sym_LT_LT] = ACTIONS(636),
    [anon_sym_LT] = ACTIONS(638),
    [anon_sym_LT_EQ] = ACTIONS(636),
    [anon_sym_EQ_EQ] = ACTIONS(636),
    [anon_sym_BANG_EQ] = ACTIONS(636),
    [anon_sym_GT_EQ] = ACTIONS(636),
    [anon_sym_GT] = ACTIONS(638),
    [anon_sym_LT_GT] = ACTIONS(636),
    [anon_sym_is] = ACTIONS(636),
    [anon_sym_LBRACK] = ACTIONS(636),
    [anon_sym_RBRACK] = ACTIONS(636),
    [anon_sym_RBRACE] = ACTIONS(636),
    [sym_type_conversion] = ACTIONS(636),
    [sym_comment] = ACTIONS(3),
  },
  [509] = {
    [anon_sym_DOT] = ACTIONS(644),
    [anon_sym_LPAREN] = ACTIONS(644),
    [anon_sym_RPAREN] = ACTIONS(644),
    [anon_sym_COMMA] = ACTIONS(644),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_GT_GT] = ACTIONS(644),
    [anon_sym_if] = ACTIONS(644),
    [anon_sym_COLON] = ACTIONS(644),
    [anon_sym_else] = ACTIONS(644),
    [anon_sym_async] = ACTIONS(644),
    [anon_sym_for] = ACTIONS(644),
    [anon_sym_in] = ACTIONS(644),
    [anon_sym_EQ] = ACTIONS(646),
    [anon_sym_AT] = ACTIONS(644),
    [anon_sym_not] = ACTIONS(644),
    [anon_sym_and] = ACTIONS(644),
    [anon_sym_or] = ACTIONS(644),
    [anon_sym_PLUS] = ACTIONS(644),
    [anon_sym_DASH] = ACTIONS(644),
    [anon_sym_SLASH] = ACTIONS(646),
    [anon_sym_PERCENT] = ACTIONS(644),
    [anon_sym_SLASH_SLASH] = ACTIONS(644),
    [anon_sym_STAR_STAR] = ACTIONS(644),
    [anon_sym_PIPE] = ACTIONS(644),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_CARET] = ACTIONS(644),
    [anon_sym_LT_LT] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_LT_EQ] = ACTIONS(644),
    [anon_sym_EQ_EQ] = ACTIONS(644),
    [anon_sym_BANG_EQ] = ACTIONS(644),
    [anon_sym_GT_EQ] = ACTIONS(644),
    [anon_sym_GT] = ACTIONS(646),
    [anon_sym_LT_GT] = ACTIONS(644),
    [anon_sym_is] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(644),
    [anon_sym_RBRACK] = ACTIONS(644),
    [anon_sym_RBRACE] = ACTIONS(644),
    [sym_type_conversion] = ACTIONS(644),
    [sym_comment] = ACTIONS(3),
  },
  [510] = {
    [anon_sym_DOT] = ACTIONS(812),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_RPAREN] = ACTIONS(812),
    [anon_sym_COMMA] = ACTIONS(812),
    [anon_sym_STAR] = ACTIONS(814),
    [anon_sym_GT_GT] = ACTIONS(812),
    [anon_sym_if] = ACTIONS(812),
    [anon_sym_COLON] = ACTIONS(812),
    [anon_sym_else] = ACTIONS(812),
    [anon_sym_async] = ACTIONS(812),
    [anon_sym_for] = ACTIONS(812),
    [anon_sym_in] = ACTIONS(812),
    [anon_sym_EQ] = ACTIONS(814),
    [anon_sym_AT] = ACTIONS(812),
    [anon_sym_not] = ACTIONS(812),
    [anon_sym_and] = ACTIONS(812),
    [anon_sym_or] = ACTIONS(812),
    [anon_sym_PLUS] = ACTIONS(812),
    [anon_sym_DASH] = ACTIONS(812),
    [anon_sym_SLASH] = ACTIONS(814),
    [anon_sym_PERCENT] = ACTIONS(812),
    [anon_sym_SLASH_SLASH] = ACTIONS(812),
    [anon_sym_STAR_STAR] = ACTIONS(812),
    [anon_sym_PIPE] = ACTIONS(812),
    [anon_sym_AMP] = ACTIONS(812),
    [anon_sym_CARET] = ACTIONS(812),
    [anon_sym_LT_LT] = ACTIONS(812),
    [anon_sym_LT] = ACTIONS(814),
    [anon_sym_LT_EQ] = ACTIONS(812),
    [anon_sym_EQ_EQ] = ACTIONS(812),
    [anon_sym_BANG_EQ] = ACTIONS(812),
    [anon_sym_GT_EQ] = ACTIONS(812),
    [anon_sym_GT] = ACTIONS(814),
    [anon_sym_LT_GT] = ACTIONS(812),
    [anon_sym_is] = ACTIONS(812),
    [anon_sym_LBRACK] = ACTIONS(812),
    [anon_sym_RBRACK] = ACTIONS(812),
    [anon_sym_RBRACE] = ACTIONS(812),
    [sym_type_conversion] = ACTIONS(812),
    [sym_comment] = ACTIONS(3),
  },
  [511] = {
    [anon_sym_DOT] = ACTIONS(762),
    [anon_sym_LPAREN] = ACTIONS(762),
    [anon_sym_RPAREN] = ACTIONS(762),
    [anon_sym_COMMA] = ACTIONS(762),
    [anon_sym_STAR] = ACTIONS(764),
    [anon_sym_GT_GT] = ACTIONS(762),
    [anon_sym_if] = ACTIONS(762),
    [anon_sym_COLON] = ACTIONS(762),
    [anon_sym_else] = ACTIONS(762),
    [anon_sym_async] = ACTIONS(762),
    [anon_sym_for] = ACTIONS(762),
    [anon_sym_in] = ACTIONS(762),
    [anon_sym_EQ] = ACTIONS(764),
    [anon_sym_AT] = ACTIONS(762),
    [anon_sym_not] = ACTIONS(762),
    [anon_sym_and] = ACTIONS(762),
    [anon_sym_or] = ACTIONS(762),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_SLASH] = ACTIONS(764),
    [anon_sym_PERCENT] = ACTIONS(762),
    [anon_sym_SLASH_SLASH] = ACTIONS(762),
    [anon_sym_STAR_STAR] = ACTIONS(762),
    [anon_sym_PIPE] = ACTIONS(762),
    [anon_sym_AMP] = ACTIONS(762),
    [anon_sym_CARET] = ACTIONS(762),
    [anon_sym_LT_LT] = ACTIONS(762),
    [anon_sym_LT] = ACTIONS(764),
    [anon_sym_LT_EQ] = ACTIONS(762),
    [anon_sym_EQ_EQ] = ACTIONS(762),
    [anon_sym_BANG_EQ] = ACTIONS(762),
    [anon_sym_GT_EQ] = ACTIONS(762),
    [anon_sym_GT] = ACTIONS(764),
    [anon_sym_LT_GT] = ACTIONS(762),
    [anon_sym_is] = ACTIONS(762),
    [anon_sym_LBRACK] = ACTIONS(762),
    [anon_sym_RBRACK] = ACTIONS(762),
    [anon_sym_RBRACE] = ACTIONS(762),
    [sym_type_conversion] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
  },
  [512] = {
    [anon_sym_DOT] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(740),
    [anon_sym_RPAREN] = ACTIONS(740),
    [anon_sym_COMMA] = ACTIONS(740),
    [anon_sym_STAR] = ACTIONS(742),
    [anon_sym_GT_GT] = ACTIONS(740),
    [anon_sym_if] = ACTIONS(740),
    [anon_sym_COLON] = ACTIONS(740),
    [anon_sym_else] = ACTIONS(740),
    [anon_sym_async] = ACTIONS(740),
    [anon_sym_for] = ACTIONS(740),
    [anon_sym_in] = ACTIONS(740),
    [anon_sym_EQ] = ACTIONS(742),
    [anon_sym_AT] = ACTIONS(740),
    [anon_sym_not] = ACTIONS(740),
    [anon_sym_and] = ACTIONS(740),
    [anon_sym_or] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(740),
    [anon_sym_DASH] = ACTIONS(740),
    [anon_sym_SLASH] = ACTIONS(742),
    [anon_sym_PERCENT] = ACTIONS(740),
    [anon_sym_SLASH_SLASH] = ACTIONS(740),
    [anon_sym_STAR_STAR] = ACTIONS(740),
    [anon_sym_PIPE] = ACTIONS(740),
    [anon_sym_AMP] = ACTIONS(740),
    [anon_sym_CARET] = ACTIONS(740),
    [anon_sym_LT_LT] = ACTIONS(740),
    [anon_sym_LT] = ACTIONS(742),
    [anon_sym_LT_EQ] = ACTIONS(740),
    [anon_sym_EQ_EQ] = ACTIONS(740),
    [anon_sym_BANG_EQ] = ACTIONS(740),
    [anon_sym_GT_EQ] = ACTIONS(740),
    [anon_sym_GT] = ACTIONS(742),
    [anon_sym_LT_GT] = ACTIONS(740),
    [anon_sym_is] = ACTIONS(740),
    [anon_sym_LBRACK] = ACTIONS(740),
    [anon_sym_RBRACK] = ACTIONS(740),
    [anon_sym_RBRACE] = ACTIONS(740),
    [sym_type_conversion] = ACTIONS(740),
    [sym_comment] = ACTIONS(3),
  },
  [513] = {
    [anon_sym_DOT] = ACTIONS(710),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_RPAREN] = ACTIONS(710),
    [anon_sym_COMMA] = ACTIONS(710),
    [anon_sym_STAR] = ACTIONS(712),
    [anon_sym_GT_GT] = ACTIONS(710),
    [anon_sym_if] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(710),
    [anon_sym_else] = ACTIONS(710),
    [anon_sym_async] = ACTIONS(710),
    [anon_sym_for] = ACTIONS(710),
    [anon_sym_in] = ACTIONS(710),
    [anon_sym_EQ] = ACTIONS(712),
    [anon_sym_AT] = ACTIONS(710),
    [anon_sym_not] = ACTIONS(710),
    [anon_sym_and] = ACTIONS(710),
    [anon_sym_or] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(710),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_SLASH] = ACTIONS(712),
    [anon_sym_PERCENT] = ACTIONS(710),
    [anon_sym_SLASH_SLASH] = ACTIONS(710),
    [anon_sym_STAR_STAR] = ACTIONS(710),
    [anon_sym_PIPE] = ACTIONS(710),
    [anon_sym_AMP] = ACTIONS(710),
    [anon_sym_CARET] = ACTIONS(710),
    [anon_sym_LT_LT] = ACTIONS(710),
    [anon_sym_LT] = ACTIONS(712),
    [anon_sym_LT_EQ] = ACTIONS(710),
    [anon_sym_EQ_EQ] = ACTIONS(710),
    [anon_sym_BANG_EQ] = ACTIONS(710),
    [anon_sym_GT_EQ] = ACTIONS(710),
    [anon_sym_GT] = ACTIONS(712),
    [anon_sym_LT_GT] = ACTIONS(710),
    [anon_sym_is] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(710),
    [anon_sym_RBRACK] = ACTIONS(710),
    [anon_sym_RBRACE] = ACTIONS(710),
    [sym_type_conversion] = ACTIONS(710),
    [sym_comment] = ACTIONS(3),
  },
  [514] = {
    [anon_sym_DOT] = ACTIONS(664),
    [anon_sym_LPAREN] = ACTIONS(664),
    [anon_sym_RPAREN] = ACTIONS(664),
    [anon_sym_COMMA] = ACTIONS(664),
    [anon_sym_STAR] = ACTIONS(666),
    [anon_sym_GT_GT] = ACTIONS(664),
    [anon_sym_if] = ACTIONS(664),
    [anon_sym_COLON] = ACTIONS(664),
    [anon_sym_else] = ACTIONS(664),
    [anon_sym_async] = ACTIONS(664),
    [anon_sym_for] = ACTIONS(664),
    [anon_sym_in] = ACTIONS(664),
    [anon_sym_EQ] = ACTIONS(666),
    [anon_sym_AT] = ACTIONS(664),
    [anon_sym_not] = ACTIONS(664),
    [anon_sym_and] = ACTIONS(664),
    [anon_sym_or] = ACTIONS(664),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_SLASH] = ACTIONS(666),
    [anon_sym_PERCENT] = ACTIONS(664),
    [anon_sym_SLASH_SLASH] = ACTIONS(664),
    [anon_sym_STAR_STAR] = ACTIONS(664),
    [anon_sym_PIPE] = ACTIONS(664),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_CARET] = ACTIONS(664),
    [anon_sym_LT_LT] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(666),
    [anon_sym_LT_EQ] = ACTIONS(664),
    [anon_sym_EQ_EQ] = ACTIONS(664),
    [anon_sym_BANG_EQ] = ACTIONS(664),
    [anon_sym_GT_EQ] = ACTIONS(664),
    [anon_sym_GT] = ACTIONS(666),
    [anon_sym_LT_GT] = ACTIONS(664),
    [anon_sym_is] = ACTIONS(664),
    [anon_sym_LBRACK] = ACTIONS(664),
    [anon_sym_RBRACK] = ACTIONS(664),
    [anon_sym_RBRACE] = ACTIONS(664),
    [sym_type_conversion] = ACTIONS(664),
    [sym_comment] = ACTIONS(3),
  },
  [515] = {
    [anon_sym_DOT] = ACTIONS(796),
    [anon_sym_LPAREN] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(796),
    [anon_sym_COMMA] = ACTIONS(796),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_GT_GT] = ACTIONS(796),
    [anon_sym_if] = ACTIONS(796),
    [anon_sym_COLON] = ACTIONS(796),
    [anon_sym_else] = ACTIONS(796),
    [anon_sym_async] = ACTIONS(796),
    [anon_sym_for] = ACTIONS(796),
    [anon_sym_in] = ACTIONS(796),
    [anon_sym_EQ] = ACTIONS(798),
    [anon_sym_AT] = ACTIONS(796),
    [anon_sym_not] = ACTIONS(796),
    [anon_sym_and] = ACTIONS(796),
    [anon_sym_or] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(796),
    [anon_sym_DASH] = ACTIONS(796),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_PERCENT] = ACTIONS(796),
    [anon_sym_SLASH_SLASH] = ACTIONS(796),
    [anon_sym_STAR_STAR] = ACTIONS(796),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_AMP] = ACTIONS(796),
    [anon_sym_CARET] = ACTIONS(796),
    [anon_sym_LT_LT] = ACTIONS(796),
    [anon_sym_LT] = ACTIONS(798),
    [anon_sym_LT_EQ] = ACTIONS(796),
    [anon_sym_EQ_EQ] = ACTIONS(796),
    [anon_sym_BANG_EQ] = ACTIONS(796),
    [anon_sym_GT_EQ] = ACTIONS(796),
    [anon_sym_GT] = ACTIONS(798),
    [anon_sym_LT_GT] = ACTIONS(796),
    [anon_sym_is] = ACTIONS(796),
    [anon_sym_LBRACK] = ACTIONS(796),
    [anon_sym_RBRACK] = ACTIONS(796),
    [anon_sym_RBRACE] = ACTIONS(796),
    [sym_type_conversion] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
  },
  [516] = {
    [anon_sym_DOT] = ACTIONS(802),
    [anon_sym_LPAREN] = ACTIONS(802),
    [anon_sym_RPAREN] = ACTIONS(802),
    [anon_sym_COMMA] = ACTIONS(802),
    [anon_sym_STAR] = ACTIONS(804),
    [anon_sym_GT_GT] = ACTIONS(802),
    [anon_sym_if] = ACTIONS(802),
    [anon_sym_COLON] = ACTIONS(802),
    [anon_sym_else] = ACTIONS(802),
    [anon_sym_async] = ACTIONS(802),
    [anon_sym_for] = ACTIONS(802),
    [anon_sym_in] = ACTIONS(802),
    [anon_sym_EQ] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(802),
    [anon_sym_not] = ACTIONS(802),
    [anon_sym_and] = ACTIONS(802),
    [anon_sym_or] = ACTIONS(802),
    [anon_sym_PLUS] = ACTIONS(802),
    [anon_sym_DASH] = ACTIONS(802),
    [anon_sym_SLASH] = ACTIONS(804),
    [anon_sym_PERCENT] = ACTIONS(802),
    [anon_sym_SLASH_SLASH] = ACTIONS(802),
    [anon_sym_STAR_STAR] = ACTIONS(802),
    [anon_sym_PIPE] = ACTIONS(802),
    [anon_sym_AMP] = ACTIONS(802),
    [anon_sym_CARET] = ACTIONS(802),
    [anon_sym_LT_LT] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(804),
    [anon_sym_LT_EQ] = ACTIONS(802),
    [anon_sym_EQ_EQ] = ACTIONS(802),
    [anon_sym_BANG_EQ] = ACTIONS(802),
    [anon_sym_GT_EQ] = ACTIONS(802),
    [anon_sym_GT] = ACTIONS(804),
    [anon_sym_LT_GT] = ACTIONS(802),
    [anon_sym_is] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(802),
    [anon_sym_RBRACK] = ACTIONS(802),
    [anon_sym_RBRACE] = ACTIONS(802),
    [sym_type_conversion] = ACTIONS(802),
    [sym_comment] = ACTIONS(3),
  },
  [517] = {
    [anon_sym_DOT] = ACTIONS(752),
    [anon_sym_LPAREN] = ACTIONS(752),
    [anon_sym_RPAREN] = ACTIONS(752),
    [anon_sym_COMMA] = ACTIONS(752),
    [anon_sym_STAR] = ACTIONS(754),
    [anon_sym_GT_GT] = ACTIONS(752),
    [anon_sym_if] = ACTIONS(752),
    [anon_sym_COLON] = ACTIONS(752),
    [anon_sym_else] = ACTIONS(752),
    [anon_sym_async] = ACTIONS(752),
    [anon_sym_for] = ACTIONS(752),
    [anon_sym_in] = ACTIONS(752),
    [anon_sym_EQ] = ACTIONS(754),
    [anon_sym_AT] = ACTIONS(752),
    [anon_sym_not] = ACTIONS(752),
    [anon_sym_and] = ACTIONS(752),
    [anon_sym_or] = ACTIONS(752),
    [anon_sym_PLUS] = ACTIONS(752),
    [anon_sym_DASH] = ACTIONS(752),
    [anon_sym_SLASH] = ACTIONS(754),
    [anon_sym_PERCENT] = ACTIONS(752),
    [anon_sym_SLASH_SLASH] = ACTIONS(752),
    [anon_sym_STAR_STAR] = ACTIONS(752),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_AMP] = ACTIONS(752),
    [anon_sym_CARET] = ACTIONS(752),
    [anon_sym_LT_LT] = ACTIONS(752),
    [anon_sym_LT] = ACTIONS(754),
    [anon_sym_LT_EQ] = ACTIONS(752),
    [anon_sym_EQ_EQ] = ACTIONS(752),
    [anon_sym_BANG_EQ] = ACTIONS(752),
    [anon_sym_GT_EQ] = ACTIONS(752),
    [anon_sym_GT] = ACTIONS(754),
    [anon_sym_LT_GT] = ACTIONS(752),
    [anon_sym_is] = ACTIONS(752),
    [anon_sym_LBRACK] = ACTIONS(752),
    [anon_sym_RBRACK] = ACTIONS(752),
    [anon_sym_RBRACE] = ACTIONS(752),
    [sym_type_conversion] = ACTIONS(752),
    [sym_comment] = ACTIONS(3),
  },
  [518] = {
    [anon_sym_DOT] = ACTIONS(746),
    [anon_sym_LPAREN] = ACTIONS(746),
    [anon_sym_RPAREN] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_GT_GT] = ACTIONS(746),
    [anon_sym_if] = ACTIONS(746),
    [anon_sym_COLON] = ACTIONS(746),
    [anon_sym_else] = ACTIONS(746),
    [anon_sym_async] = ACTIONS(746),
    [anon_sym_for] = ACTIONS(746),
    [anon_sym_in] = ACTIONS(746),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_AT] = ACTIONS(746),
    [anon_sym_not] = ACTIONS(746),
    [anon_sym_and] = ACTIONS(746),
    [anon_sym_or] = ACTIONS(746),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_SLASH] = ACTIONS(748),
    [anon_sym_PERCENT] = ACTIONS(746),
    [anon_sym_SLASH_SLASH] = ACTIONS(746),
    [anon_sym_STAR_STAR] = ACTIONS(746),
    [anon_sym_PIPE] = ACTIONS(746),
    [anon_sym_AMP] = ACTIONS(746),
    [anon_sym_CARET] = ACTIONS(746),
    [anon_sym_LT_LT] = ACTIONS(746),
    [anon_sym_LT] = ACTIONS(748),
    [anon_sym_LT_EQ] = ACTIONS(746),
    [anon_sym_EQ_EQ] = ACTIONS(746),
    [anon_sym_BANG_EQ] = ACTIONS(746),
    [anon_sym_GT_EQ] = ACTIONS(746),
    [anon_sym_GT] = ACTIONS(748),
    [anon_sym_LT_GT] = ACTIONS(746),
    [anon_sym_is] = ACTIONS(746),
    [anon_sym_LBRACK] = ACTIONS(746),
    [anon_sym_RBRACK] = ACTIONS(746),
    [anon_sym_RBRACE] = ACTIONS(746),
    [sym_type_conversion] = ACTIONS(746),
    [sym_comment] = ACTIONS(3),
  },
  [519] = {
    [anon_sym_DOT] = ACTIONS(734),
    [anon_sym_LPAREN] = ACTIONS(734),
    [anon_sym_RPAREN] = ACTIONS(734),
    [anon_sym_COMMA] = ACTIONS(734),
    [anon_sym_STAR] = ACTIONS(736),
    [anon_sym_GT_GT] = ACTIONS(734),
    [anon_sym_if] = ACTIONS(734),
    [anon_sym_COLON] = ACTIONS(734),
    [anon_sym_else] = ACTIONS(734),
    [anon_sym_async] = ACTIONS(734),
    [anon_sym_for] = ACTIONS(734),
    [anon_sym_in] = ACTIONS(734),
    [anon_sym_EQ] = ACTIONS(736),
    [anon_sym_AT] = ACTIONS(734),
    [anon_sym_not] = ACTIONS(734),
    [anon_sym_and] = ACTIONS(734),
    [anon_sym_or] = ACTIONS(734),
    [anon_sym_PLUS] = ACTIONS(734),
    [anon_sym_DASH] = ACTIONS(734),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_PERCENT] = ACTIONS(734),
    [anon_sym_SLASH_SLASH] = ACTIONS(734),
    [anon_sym_STAR_STAR] = ACTIONS(734),
    [anon_sym_PIPE] = ACTIONS(734),
    [anon_sym_AMP] = ACTIONS(734),
    [anon_sym_CARET] = ACTIONS(734),
    [anon_sym_LT_LT] = ACTIONS(734),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_LT_EQ] = ACTIONS(734),
    [anon_sym_EQ_EQ] = ACTIONS(734),
    [anon_sym_BANG_EQ] = ACTIONS(734),
    [anon_sym_GT_EQ] = ACTIONS(734),
    [anon_sym_GT] = ACTIONS(736),
    [anon_sym_LT_GT] = ACTIONS(734),
    [anon_sym_is] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_RBRACK] = ACTIONS(734),
    [anon_sym_RBRACE] = ACTIONS(734),
    [sym_type_conversion] = ACTIONS(734),
    [sym_comment] = ACTIONS(3),
  },
  [520] = {
    [anon_sym_DOT] = ACTIONS(706),
    [anon_sym_LPAREN] = ACTIONS(706),
    [anon_sym_RPAREN] = ACTIONS(706),
    [anon_sym_COMMA] = ACTIONS(706),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_GT_GT] = ACTIONS(706),
    [anon_sym_if] = ACTIONS(706),
    [anon_sym_COLON] = ACTIONS(706),
    [anon_sym_else] = ACTIONS(706),
    [anon_sym_async] = ACTIONS(706),
    [anon_sym_for] = ACTIONS(706),
    [anon_sym_in] = ACTIONS(706),
    [anon_sym_EQ] = ACTIONS(708),
    [anon_sym_AT] = ACTIONS(706),
    [anon_sym_not] = ACTIONS(706),
    [anon_sym_and] = ACTIONS(706),
    [anon_sym_or] = ACTIONS(706),
    [anon_sym_PLUS] = ACTIONS(706),
    [anon_sym_DASH] = ACTIONS(706),
    [anon_sym_SLASH] = ACTIONS(708),
    [anon_sym_PERCENT] = ACTIONS(706),
    [anon_sym_SLASH_SLASH] = ACTIONS(706),
    [anon_sym_STAR_STAR] = ACTIONS(706),
    [anon_sym_PIPE] = ACTIONS(706),
    [anon_sym_AMP] = ACTIONS(706),
    [anon_sym_CARET] = ACTIONS(706),
    [anon_sym_LT_LT] = ACTIONS(706),
    [anon_sym_LT] = ACTIONS(708),
    [anon_sym_LT_EQ] = ACTIONS(706),
    [anon_sym_EQ_EQ] = ACTIONS(706),
    [anon_sym_BANG_EQ] = ACTIONS(706),
    [anon_sym_GT_EQ] = ACTIONS(706),
    [anon_sym_GT] = ACTIONS(708),
    [anon_sym_LT_GT] = ACTIONS(706),
    [anon_sym_is] = ACTIONS(706),
    [anon_sym_LBRACK] = ACTIONS(706),
    [anon_sym_RBRACK] = ACTIONS(706),
    [anon_sym_RBRACE] = ACTIONS(706),
    [sym_type_conversion] = ACTIONS(706),
    [sym_comment] = ACTIONS(3),
  },
  [521] = {
    [anon_sym_DOT] = ACTIONS(730),
    [anon_sym_LPAREN] = ACTIONS(730),
    [anon_sym_RPAREN] = ACTIONS(730),
    [anon_sym_COMMA] = ACTIONS(730),
    [anon_sym_STAR] = ACTIONS(732),
    [anon_sym_GT_GT] = ACTIONS(730),
    [anon_sym_if] = ACTIONS(730),
    [anon_sym_COLON] = ACTIONS(730),
    [anon_sym_else] = ACTIONS(730),
    [anon_sym_async] = ACTIONS(730),
    [anon_sym_for] = ACTIONS(730),
    [anon_sym_in] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_AT] = ACTIONS(730),
    [anon_sym_not] = ACTIONS(730),
    [anon_sym_and] = ACTIONS(730),
    [anon_sym_or] = ACTIONS(730),
    [anon_sym_PLUS] = ACTIONS(730),
    [anon_sym_DASH] = ACTIONS(730),
    [anon_sym_SLASH] = ACTIONS(732),
    [anon_sym_PERCENT] = ACTIONS(730),
    [anon_sym_SLASH_SLASH] = ACTIONS(730),
    [anon_sym_STAR_STAR] = ACTIONS(730),
    [anon_sym_PIPE] = ACTIONS(730),
    [anon_sym_AMP] = ACTIONS(730),
    [anon_sym_CARET] = ACTIONS(730),
    [anon_sym_LT_LT] = ACTIONS(730),
    [anon_sym_LT] = ACTIONS(732),
    [anon_sym_LT_EQ] = ACTIONS(730),
    [anon_sym_EQ_EQ] = ACTIONS(730),
    [anon_sym_BANG_EQ] = ACTIONS(730),
    [anon_sym_GT_EQ] = ACTIONS(730),
    [anon_sym_GT] = ACTIONS(732),
    [anon_sym_LT_GT] = ACTIONS(730),
    [anon_sym_is] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(730),
    [anon_sym_RBRACK] = ACTIONS(730),
    [anon_sym_RBRACE] = ACTIONS(730),
    [sym_type_conversion] = ACTIONS(730),
    [sym_comment] = ACTIONS(3),
  },
  [522] = {
    [anon_sym_DOT] = ACTIONS(822),
    [anon_sym_LPAREN] = ACTIONS(822),
    [anon_sym_RPAREN] = ACTIONS(822),
    [anon_sym_COMMA] = ACTIONS(822),
    [anon_sym_STAR] = ACTIONS(824),
    [anon_sym_GT_GT] = ACTIONS(822),
    [anon_sym_if] = ACTIONS(822),
    [anon_sym_COLON] = ACTIONS(822),
    [anon_sym_else] = ACTIONS(822),
    [anon_sym_async] = ACTIONS(822),
    [anon_sym_for] = ACTIONS(822),
    [anon_sym_in] = ACTIONS(822),
    [anon_sym_EQ] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(822),
    [anon_sym_not] = ACTIONS(822),
    [anon_sym_and] = ACTIONS(822),
    [anon_sym_or] = ACTIONS(822),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_SLASH] = ACTIONS(824),
    [anon_sym_PERCENT] = ACTIONS(822),
    [anon_sym_SLASH_SLASH] = ACTIONS(822),
    [anon_sym_STAR_STAR] = ACTIONS(822),
    [anon_sym_PIPE] = ACTIONS(822),
    [anon_sym_AMP] = ACTIONS(822),
    [anon_sym_CARET] = ACTIONS(822),
    [anon_sym_LT_LT] = ACTIONS(822),
    [anon_sym_LT] = ACTIONS(824),
    [anon_sym_LT_EQ] = ACTIONS(822),
    [anon_sym_EQ_EQ] = ACTIONS(822),
    [anon_sym_BANG_EQ] = ACTIONS(822),
    [anon_sym_GT_EQ] = ACTIONS(822),
    [anon_sym_GT] = ACTIONS(824),
    [anon_sym_LT_GT] = ACTIONS(822),
    [anon_sym_is] = ACTIONS(822),
    [anon_sym_LBRACK] = ACTIONS(822),
    [anon_sym_RBRACK] = ACTIONS(822),
    [anon_sym_RBRACE] = ACTIONS(822),
    [sym_type_conversion] = ACTIONS(822),
    [sym_comment] = ACTIONS(3),
  },
  [523] = {
    [anon_sym_DOT] = ACTIONS(654),
    [anon_sym_LPAREN] = ACTIONS(654),
    [anon_sym_RPAREN] = ACTIONS(654),
    [anon_sym_COMMA] = ACTIONS(654),
    [anon_sym_STAR] = ACTIONS(656),
    [anon_sym_GT_GT] = ACTIONS(654),
    [anon_sym_if] = ACTIONS(654),
    [anon_sym_COLON] = ACTIONS(654),
    [anon_sym_else] = ACTIONS(654),
    [anon_sym_async] = ACTIONS(654),
    [anon_sym_for] = ACTIONS(654),
    [anon_sym_in] = ACTIONS(654),
    [anon_sym_EQ] = ACTIONS(656),
    [anon_sym_AT] = ACTIONS(654),
    [anon_sym_not] = ACTIONS(654),
    [anon_sym_and] = ACTIONS(654),
    [anon_sym_or] = ACTIONS(654),
    [anon_sym_PLUS] = ACTIONS(654),
    [anon_sym_DASH] = ACTIONS(654),
    [anon_sym_SLASH] = ACTIONS(656),
    [anon_sym_PERCENT] = ACTIONS(654),
    [anon_sym_SLASH_SLASH] = ACTIONS(654),
    [anon_sym_STAR_STAR] = ACTIONS(654),
    [anon_sym_PIPE] = ACTIONS(654),
    [anon_sym_AMP] = ACTIONS(654),
    [anon_sym_CARET] = ACTIONS(654),
    [anon_sym_LT_LT] = ACTIONS(654),
    [anon_sym_LT] = ACTIONS(656),
    [anon_sym_LT_EQ] = ACTIONS(654),
    [anon_sym_EQ_EQ] = ACTIONS(654),
    [anon_sym_BANG_EQ] = ACTIONS(654),
    [anon_sym_GT_EQ] = ACTIONS(654),
    [anon_sym_GT] = ACTIONS(656),
    [anon_sym_LT_GT] = ACTIONS(654),
    [anon_sym_is] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(654),
    [anon_sym_RBRACK] = ACTIONS(654),
    [anon_sym_RBRACE] = ACTIONS(654),
    [sym_type_conversion] = ACTIONS(654),
    [sym_comment] = ACTIONS(3),
  },
  [524] = {
    [anon_sym_DOT] = ACTIONS(670),
    [anon_sym_LPAREN] = ACTIONS(670),
    [anon_sym_RPAREN] = ACTIONS(670),
    [anon_sym_COMMA] = ACTIONS(670),
    [anon_sym_STAR] = ACTIONS(672),
    [anon_sym_GT_GT] = ACTIONS(670),
    [anon_sym_if] = ACTIONS(670),
    [anon_sym_COLON] = ACTIONS(670),
    [anon_sym_else] = ACTIONS(670),
    [anon_sym_async] = ACTIONS(670),
    [anon_sym_for] = ACTIONS(670),
    [anon_sym_in] = ACTIONS(670),
    [anon_sym_EQ] = ACTIONS(672),
    [anon_sym_AT] = ACTIONS(670),
    [anon_sym_not] = ACTIONS(670),
    [anon_sym_and] = ACTIONS(670),
    [anon_sym_or] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(670),
    [anon_sym_DASH] = ACTIONS(670),
    [anon_sym_SLASH] = ACTIONS(672),
    [anon_sym_PERCENT] = ACTIONS(670),
    [anon_sym_SLASH_SLASH] = ACTIONS(670),
    [anon_sym_STAR_STAR] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(670),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_CARET] = ACTIONS(670),
    [anon_sym_LT_LT] = ACTIONS(670),
    [anon_sym_LT] = ACTIONS(672),
    [anon_sym_LT_EQ] = ACTIONS(670),
    [anon_sym_EQ_EQ] = ACTIONS(670),
    [anon_sym_BANG_EQ] = ACTIONS(670),
    [anon_sym_GT_EQ] = ACTIONS(670),
    [anon_sym_GT] = ACTIONS(672),
    [anon_sym_LT_GT] = ACTIONS(670),
    [anon_sym_is] = ACTIONS(670),
    [anon_sym_LBRACK] = ACTIONS(670),
    [anon_sym_RBRACK] = ACTIONS(670),
    [anon_sym_RBRACE] = ACTIONS(670),
    [sym_type_conversion] = ACTIONS(670),
    [sym_comment] = ACTIONS(3),
  },
  [525] = {
    [anon_sym_DOT] = ACTIONS(660),
    [anon_sym_LPAREN] = ACTIONS(660),
    [anon_sym_RPAREN] = ACTIONS(660),
    [anon_sym_COMMA] = ACTIONS(660),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_GT_GT] = ACTIONS(660),
    [anon_sym_if] = ACTIONS(660),
    [anon_sym_COLON] = ACTIONS(660),
    [anon_sym_else] = ACTIONS(660),
    [anon_sym_async] = ACTIONS(660),
    [anon_sym_for] = ACTIONS(660),
    [anon_sym_in] = ACTIONS(660),
    [anon_sym_EQ] = ACTIONS(662),
    [anon_sym_AT] = ACTIONS(660),
    [anon_sym_not] = ACTIONS(660),
    [anon_sym_and] = ACTIONS(660),
    [anon_sym_or] = ACTIONS(660),
    [anon_sym_PLUS] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(660),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_PERCENT] = ACTIONS(660),
    [anon_sym_SLASH_SLASH] = ACTIONS(660),
    [anon_sym_STAR_STAR] = ACTIONS(660),
    [anon_sym_PIPE] = ACTIONS(660),
    [anon_sym_AMP] = ACTIONS(660),
    [anon_sym_CARET] = ACTIONS(660),
    [anon_sym_LT_LT] = ACTIONS(660),
    [anon_sym_LT] = ACTIONS(662),
    [anon_sym_LT_EQ] = ACTIONS(660),
    [anon_sym_EQ_EQ] = ACTIONS(660),
    [anon_sym_BANG_EQ] = ACTIONS(660),
    [anon_sym_GT_EQ] = ACTIONS(660),
    [anon_sym_GT] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(660),
    [anon_sym_is] = ACTIONS(660),
    [anon_sym_LBRACK] = ACTIONS(660),
    [anon_sym_RBRACK] = ACTIONS(660),
    [anon_sym_RBRACE] = ACTIONS(660),
    [sym_type_conversion] = ACTIONS(660),
    [sym_comment] = ACTIONS(3),
  },
  [526] = {
    [anon_sym_DOT] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(698),
    [anon_sym_RPAREN] = ACTIONS(698),
    [anon_sym_COMMA] = ACTIONS(698),
    [anon_sym_STAR] = ACTIONS(700),
    [anon_sym_GT_GT] = ACTIONS(698),
    [anon_sym_if] = ACTIONS(698),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_else] = ACTIONS(698),
    [anon_sym_async] = ACTIONS(698),
    [anon_sym_for] = ACTIONS(698),
    [anon_sym_in] = ACTIONS(698),
    [anon_sym_EQ] = ACTIONS(700),
    [anon_sym_AT] = ACTIONS(698),
    [anon_sym_not] = ACTIONS(698),
    [anon_sym_and] = ACTIONS(698),
    [anon_sym_or] = ACTIONS(698),
    [anon_sym_PLUS] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(700),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH_SLASH] = ACTIONS(698),
    [anon_sym_STAR_STAR] = ACTIONS(698),
    [anon_sym_PIPE] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_CARET] = ACTIONS(698),
    [anon_sym_LT_LT] = ACTIONS(698),
    [anon_sym_LT] = ACTIONS(700),
    [anon_sym_LT_EQ] = ACTIONS(698),
    [anon_sym_EQ_EQ] = ACTIONS(698),
    [anon_sym_BANG_EQ] = ACTIONS(698),
    [anon_sym_GT_EQ] = ACTIONS(698),
    [anon_sym_GT] = ACTIONS(700),
    [anon_sym_LT_GT] = ACTIONS(698),
    [anon_sym_is] = ACTIONS(698),
    [anon_sym_LBRACK] = ACTIONS(698),
    [anon_sym_RBRACK] = ACTIONS(698),
    [anon_sym_RBRACE] = ACTIONS(698),
    [sym_type_conversion] = ACTIONS(698),
    [sym_comment] = ACTIONS(3),
  },
  [527] = {
    [anon_sym_DOT] = ACTIONS(770),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_RPAREN] = ACTIONS(770),
    [anon_sym_COMMA] = ACTIONS(770),
    [anon_sym_STAR] = ACTIONS(772),
    [anon_sym_GT_GT] = ACTIONS(770),
    [anon_sym_if] = ACTIONS(770),
    [anon_sym_COLON] = ACTIONS(770),
    [anon_sym_else] = ACTIONS(770),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_for] = ACTIONS(770),
    [anon_sym_in] = ACTIONS(770),
    [anon_sym_EQ] = ACTIONS(772),
    [anon_sym_AT] = ACTIONS(770),
    [anon_sym_not] = ACTIONS(770),
    [anon_sym_and] = ACTIONS(770),
    [anon_sym_or] = ACTIONS(770),
    [anon_sym_PLUS] = ACTIONS(770),
    [anon_sym_DASH] = ACTIONS(770),
    [anon_sym_SLASH] = ACTIONS(772),
    [anon_sym_PERCENT] = ACTIONS(770),
    [anon_sym_SLASH_SLASH] = ACTIONS(770),
    [anon_sym_STAR_STAR] = ACTIONS(770),
    [anon_sym_PIPE] = ACTIONS(770),
    [anon_sym_AMP] = ACTIONS(770),
    [anon_sym_CARET] = ACTIONS(770),
    [anon_sym_LT_LT] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(772),
    [anon_sym_LT_EQ] = ACTIONS(770),
    [anon_sym_EQ_EQ] = ACTIONS(770),
    [anon_sym_BANG_EQ] = ACTIONS(770),
    [anon_sym_GT_EQ] = ACTIONS(770),
    [anon_sym_GT] = ACTIONS(772),
    [anon_sym_LT_GT] = ACTIONS(770),
    [anon_sym_is] = ACTIONS(770),
    [anon_sym_LBRACK] = ACTIONS(770),
    [anon_sym_RBRACK] = ACTIONS(770),
    [anon_sym_RBRACE] = ACTIONS(770),
    [sym_type_conversion] = ACTIONS(770),
    [sym_comment] = ACTIONS(3),
  },
  [528] = {
    [anon_sym_DOT] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_RPAREN] = ACTIONS(678),
    [anon_sym_COMMA] = ACTIONS(678),
    [anon_sym_STAR] = ACTIONS(680),
    [anon_sym_GT_GT] = ACTIONS(678),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_COLON] = ACTIONS(678),
    [anon_sym_else] = ACTIONS(678),
    [anon_sym_async] = ACTIONS(678),
    [anon_sym_for] = ACTIONS(678),
    [anon_sym_in] = ACTIONS(678),
    [anon_sym_EQ] = ACTIONS(680),
    [anon_sym_AT] = ACTIONS(678),
    [anon_sym_not] = ACTIONS(678),
    [anon_sym_and] = ACTIONS(678),
    [anon_sym_or] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_SLASH] = ACTIONS(680),
    [anon_sym_PERCENT] = ACTIONS(678),
    [anon_sym_SLASH_SLASH] = ACTIONS(678),
    [anon_sym_STAR_STAR] = ACTIONS(678),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_AMP] = ACTIONS(678),
    [anon_sym_CARET] = ACTIONS(678),
    [anon_sym_LT_LT] = ACTIONS(678),
    [anon_sym_LT] = ACTIONS(680),
    [anon_sym_LT_EQ] = ACTIONS(678),
    [anon_sym_EQ_EQ] = ACTIONS(678),
    [anon_sym_BANG_EQ] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(678),
    [anon_sym_GT] = ACTIONS(680),
    [anon_sym_LT_GT] = ACTIONS(678),
    [anon_sym_is] = ACTIONS(678),
    [anon_sym_LBRACK] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(678),
    [anon_sym_RBRACE] = ACTIONS(678),
    [sym_type_conversion] = ACTIONS(678),
    [sym_comment] = ACTIONS(3),
  },
  [529] = {
    [sym_string] = STATE(529),
    [aux_sym_concatenated_string_repeat1] = STATE(529),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_from] = ACTIONS(429),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_COMMA] = ACTIONS(429),
    [anon_sym_STAR] = ACTIONS(431),
    [anon_sym_GT_GT] = ACTIONS(429),
    [anon_sym_if] = ACTIONS(429),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_EQ] = ACTIONS(431),
    [anon_sym_AT] = ACTIONS(429),
    [anon_sym_not] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PLUS] = ACTIONS(429),
    [anon_sym_DASH] = ACTIONS(429),
    [anon_sym_SLASH] = ACTIONS(431),
    [anon_sym_PERCENT] = ACTIONS(429),
    [anon_sym_SLASH_SLASH] = ACTIONS(429),
    [anon_sym_STAR_STAR] = ACTIONS(429),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(429),
    [anon_sym_LT_LT] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(431),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(431),
    [anon_sym_LT_GT] = ACTIONS(429),
    [anon_sym_is] = ACTIONS(429),
    [anon_sym_LBRACK] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(429),
    [sym__newline] = ACTIONS(429),
    [sym__string_start] = ACTIONS(1169),
  },
  [530] = {
    [sym_string] = STATE(531),
    [aux_sym_concatenated_string_repeat1] = STATE(531),
    [anon_sym_DOT] = ACTIONS(440),
    [anon_sym_from] = ACTIONS(440),
    [anon_sym_LPAREN] = ACTIONS(440),
    [anon_sym_COMMA] = ACTIONS(440),
    [anon_sym_STAR] = ACTIONS(442),
    [anon_sym_GT_GT] = ACTIONS(440),
    [anon_sym_if] = ACTIONS(440),
    [anon_sym_in] = ACTIONS(440),
    [anon_sym_EQ] = ACTIONS(442),
    [anon_sym_AT] = ACTIONS(440),
    [anon_sym_not] = ACTIONS(440),
    [anon_sym_and] = ACTIONS(440),
    [anon_sym_or] = ACTIONS(440),
    [anon_sym_PLUS] = ACTIONS(440),
    [anon_sym_DASH] = ACTIONS(440),
    [anon_sym_SLASH] = ACTIONS(442),
    [anon_sym_PERCENT] = ACTIONS(440),
    [anon_sym_SLASH_SLASH] = ACTIONS(440),
    [anon_sym_STAR_STAR] = ACTIONS(440),
    [anon_sym_PIPE] = ACTIONS(440),
    [anon_sym_AMP] = ACTIONS(440),
    [anon_sym_CARET] = ACTIONS(440),
    [anon_sym_LT_LT] = ACTIONS(440),
    [anon_sym_LT] = ACTIONS(442),
    [anon_sym_LT_EQ] = ACTIONS(440),
    [anon_sym_EQ_EQ] = ACTIONS(440),
    [anon_sym_BANG_EQ] = ACTIONS(440),
    [anon_sym_GT_EQ] = ACTIONS(440),
    [anon_sym_GT] = ACTIONS(442),
    [anon_sym_LT_GT] = ACTIONS(440),
    [anon_sym_is] = ACTIONS(440),
    [anon_sym_LBRACK] = ACTIONS(440),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(440),
    [sym__newline] = ACTIONS(440),
    [sym__string_start] = ACTIONS(255),
  },
  [531] = {
    [sym_string] = STATE(529),
    [aux_sym_concatenated_string_repeat1] = STATE(529),
    [anon_sym_DOT] = ACTIONS(401),
    [anon_sym_from] = ACTIONS(401),
    [anon_sym_LPAREN] = ACTIONS(401),
    [anon_sym_COMMA] = ACTIONS(401),
    [anon_sym_STAR] = ACTIONS(403),
    [anon_sym_GT_GT] = ACTIONS(401),
    [anon_sym_if] = ACTIONS(401),
    [anon_sym_in] = ACTIONS(401),
    [anon_sym_EQ] = ACTIONS(403),
    [anon_sym_AT] = ACTIONS(401),
    [anon_sym_not] = ACTIONS(401),
    [anon_sym_and] = ACTIONS(401),
    [anon_sym_or] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(401),
    [anon_sym_DASH] = ACTIONS(401),
    [anon_sym_SLASH] = ACTIONS(403),
    [anon_sym_PERCENT] = ACTIONS(401),
    [anon_sym_SLASH_SLASH] = ACTIONS(401),
    [anon_sym_STAR_STAR] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(401),
    [anon_sym_AMP] = ACTIONS(401),
    [anon_sym_CARET] = ACTIONS(401),
    [anon_sym_LT_LT] = ACTIONS(401),
    [anon_sym_LT] = ACTIONS(403),
    [anon_sym_LT_EQ] = ACTIONS(401),
    [anon_sym_EQ_EQ] = ACTIONS(401),
    [anon_sym_BANG_EQ] = ACTIONS(401),
    [anon_sym_GT_EQ] = ACTIONS(401),
    [anon_sym_GT] = ACTIONS(403),
    [anon_sym_LT_GT] = ACTIONS(401),
    [anon_sym_is] = ACTIONS(401),
    [anon_sym_LBRACK] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(401),
    [sym__newline] = ACTIONS(401),
    [sym__string_start] = ACTIONS(255),
  },
  [532] = {
    [sym_argument_list] = STATE(599),
    [sym_generator_expression] = STATE(599),
    [aux_sym_comparison_operator_repeat1] = STATE(701),
    [anon_sym_DOT] = ACTIONS(1172),
    [anon_sym_from] = ACTIONS(460),
    [anon_sym_LPAREN] = ACTIONS(1174),
    [anon_sym_COMMA] = ACTIONS(460),
    [anon_sym_STAR] = ACTIONS(1176),
    [anon_sym_GT_GT] = ACTIONS(1178),
    [anon_sym_if] = ACTIONS(460),
    [anon_sym_in] = ACTIONS(1180),
    [anon_sym_EQ] = ACTIONS(468),
    [anon_sym_AT] = ACTIONS(1182),
    [anon_sym_not] = ACTIONS(1184),
    [anon_sym_and] = ACTIONS(460),
    [anon_sym_or] = ACTIONS(460),
    [anon_sym_PLUS] = ACTIONS(1186),
    [anon_sym_DASH] = ACTIONS(1186),
    [anon_sym_SLASH] = ACTIONS(1176),
    [anon_sym_PERCENT] = ACTIONS(1182),
    [anon_sym_SLASH_SLASH] = ACTIONS(1182),
    [anon_sym_STAR_STAR] = ACTIONS(1188),
    [anon_sym_PIPE] = ACTIONS(1190),
    [anon_sym_AMP] = ACTIONS(1192),
    [anon_sym_CARET] = ACTIONS(1194),
    [anon_sym_LT_LT] = ACTIONS(1178),
    [anon_sym_LT] = ACTIONS(1196),
    [anon_sym_LT_EQ] = ACTIONS(1180),
    [anon_sym_EQ_EQ] = ACTIONS(1180),
    [anon_sym_BANG_EQ] = ACTIONS(1180),
    [anon_sym_GT_EQ] = ACTIONS(1180),
    [anon_sym_GT] = ACTIONS(1196),
    [anon_sym_LT_GT] = ACTIONS(1180),
    [anon_sym_is] = ACTIONS(1198),
    [anon_sym_LBRACK] = ACTIONS(1200),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(460),
    [sym__newline] = ACTIONS(460),
  },
  [533] = {
    [sym_argument_list] = STATE(599),
    [sym_generator_expression] = STATE(599),
    [anon_sym_DOT] = ACTIONS(488),
    [anon_sym_from] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(1174),
    [anon_sym_COMMA] = ACTIONS(488),
    [anon_sym_STAR] = ACTIONS(1176),
    [anon_sym_GT_GT] = ACTIONS(1178),
    [anon_sym_if] = ACTIONS(488),
    [anon_sym_in] = ACTIONS(488),
    [anon_sym_EQ] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(1182),
    [anon_sym_not] = ACTIONS(488),
    [anon_sym_and] = ACTIONS(488),
    [anon_sym_or] = ACTIONS(488),
    [anon_sym_PLUS] = ACTIONS(1186),
    [anon_sym_DASH] = ACTIONS(1186),
    [anon_sym_SLASH] = ACTIONS(1176),
    [anon_sym_PERCENT] = ACTIONS(1182),
    [anon_sym_SLASH_SLASH] = ACTIONS(1182),
    [anon_sym_STAR_STAR] = ACTIONS(1188),
    [anon_sym_PIPE] = ACTIONS(488),
    [anon_sym_AMP] = ACTIONS(488),
    [anon_sym_CARET] = ACTIONS(488),
    [anon_sym_LT_LT] = ACTIONS(1178),
    [anon_sym_LT] = ACTIONS(490),
    [anon_sym_LT_EQ] = ACTIONS(488),
    [anon_sym_EQ_EQ] = ACTIONS(488),
    [anon_sym_BANG_EQ] = ACTIONS(488),
    [anon_sym_GT_EQ] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(490),
    [anon_sym_LT_GT] = ACTIONS(488),
    [anon_sym_is] = ACTIONS(488),
    [anon_sym_LBRACK] = ACTIONS(488),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(488),
    [sym__newline] = ACTIONS(488),
  },
  [534] = {
    [sym_argument_list] = STATE(599),
    [sym_generator_expression] = STATE(599),
    [anon_sym_DOT] = ACTIONS(488),
    [anon_sym_from] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(1174),
    [anon_sym_COMMA] = ACTIONS(488),
    [anon_sym_STAR] = ACTIONS(490),
    [anon_sym_GT_GT] = ACTIONS(488),
    [anon_sym_if] = ACTIONS(488),
    [anon_sym_in] = ACTIONS(488),
    [anon_sym_EQ] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_not] = ACTIONS(488),
    [anon_sym_and] = ACTIONS(488),
    [anon_sym_or] = ACTIONS(488),
    [anon_sym_PLUS] = ACTIONS(488),
    [anon_sym_DASH] = ACTIONS(488),
    [anon_sym_SLASH] = ACTIONS(490),
    [anon_sym_PERCENT] = ACTIONS(488),
    [anon_sym_SLASH_SLASH] = ACTIONS(488),
    [anon_sym_STAR_STAR] = ACTIONS(488),
    [anon_sym_PIPE] = ACTIONS(488),
    [anon_sym_AMP] = ACTIONS(488),
    [anon_sym_CARET] = ACTIONS(488),
    [anon_sym_LT_LT] = ACTIONS(488),
    [anon_sym_LT] = ACTIONS(490),
    [anon_sym_LT_EQ] = ACTIONS(488),
    [anon_sym_EQ_EQ] = ACTIONS(488),
    [anon_sym_BANG_EQ] = ACTIONS(488),
    [anon_sym_GT_EQ] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(490),
    [anon_sym_LT_GT] = ACTIONS(488),
    [anon_sym_is] = ACTIONS(488),
    [anon_sym_LBRACK] = ACTIONS(488),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(488),
    [sym__newline] = ACTIONS(488),
  },
  [535] = {
    [sym_argument_list] = STATE(599),
    [sym_generator_expression] = STATE(599),
    [anon_sym_DOT] = ACTIONS(1172),
    [anon_sym_from] = ACTIONS(496),
    [anon_sym_LPAREN] = ACTIONS(1174),
    [anon_sym_COMMA] = ACTIONS(496),
    [anon_sym_STAR] = ACTIONS(1176),
    [anon_sym_GT_GT] = ACTIONS(1178),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_in] = ACTIONS(496),
    [anon_sym_EQ] = ACTIONS(498),
    [anon_sym_AT] = ACTIONS(1182),
    [anon_sym_not] = ACTIONS(496),
    [anon_sym_and] = ACTIONS(496),
    [anon_sym_or] = ACTIONS(496),
    [anon_sym_PLUS] = ACTIONS(1186),
    [anon_sym_DASH] = ACTIONS(1186),
    [anon_sym_SLASH] = ACTIONS(1176),
    [anon_sym_PERCENT] = ACTIONS(1182),
    [anon_sym_SLASH_SLASH] = ACTIONS(1182),
    [anon_sym_STAR_STAR] = ACTIONS(1188),
    [anon_sym_PIPE] = ACTIONS(1190),
    [anon_sym_AMP] = ACTIONS(1192),
    [anon_sym_CARET] = ACTIONS(1194),
    [anon_sym_LT_LT] = ACTIONS(1178),
    [anon_sym_LT] = ACTIONS(498),
    [anon_sym_LT_EQ] = ACTIONS(496),
    [anon_sym_EQ_EQ] = ACTIONS(496),
    [anon_sym_BANG_EQ] = ACTIONS(496),
    [anon_sym_GT_EQ] = ACTIONS(496),
    [anon_sym_GT] = ACTIONS(498),
    [anon_sym_LT_GT] = ACTIONS(496),
    [anon_sym_is] = ACTIONS(496),
    [anon_sym_LBRACK] = ACTIONS(1200),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(496),
    [sym__newline] = ACTIONS(496),
  },
  [536] = {
    [sym_argument_list] = STATE(599),
    [sym_generator_expression] = STATE(599),
    [anon_sym_DOT] = ACTIONS(508),
    [anon_sym_from] = ACTIONS(508),
    [anon_sym_LPAREN] = ACTIONS(1174),
    [anon_sym_COMMA] = ACTIONS(508),
    [anon_sym_STAR] = ACTIONS(510),
    [anon_sym_GT_GT] = ACTIONS(508),
    [anon_sym_if] = ACTIONS(508),
    [anon_sym_in] = ACTIONS(508),
    [anon_sym_EQ] = ACTIONS(510),
    [anon_sym_AT] = ACTIONS(508),
    [anon_sym_not] = ACTIONS(508),
    [anon_sym_and] = ACTIONS(508),
    [anon_sym_or] = ACTIONS(508),
    [anon_sym_PLUS] = ACTIONS(508),
    [anon_sym_DASH] = ACTIONS(508),
    [anon_sym_SLASH] = ACTIONS(510),
    [anon_sym_PERCENT] = ACTIONS(508),
    [anon_sym_SLASH_SLASH] = ACTIONS(508),
    [anon_sym_STAR_STAR] = ACTIONS(508),
    [anon_sym_PIPE] = ACTIONS(508),
    [anon_sym_AMP] = ACTIONS(508),
    [anon_sym_CARET] = ACTIONS(508),
    [anon_sym_LT_LT] = ACTIONS(508),
    [anon_sym_LT] = ACTIONS(510),
    [anon_sym_LT_EQ] = ACTIONS(508),
    [anon_sym_EQ_EQ] = ACTIONS(508),
    [anon_sym_BANG_EQ] = ACTIONS(508),
    [anon_sym_GT_EQ] = ACTIONS(508),
    [anon_sym_GT] = ACTIONS(510),
    [anon_sym_LT_GT] = ACTIONS(508),
    [anon_sym_is] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(508),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(508),
    [sym__newline] = ACTIONS(508),
  },
  [537] = {
    [sym_argument_list] = STATE(599),
    [sym_generator_expression] = STATE(599),
    [anon_sym_DOT] = ACTIONS(488),
    [anon_sym_from] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(1174),
    [anon_sym_COMMA] = ACTIONS(488),
    [anon_sym_STAR] = ACTIONS(1176),
    [anon_sym_GT_GT] = ACTIONS(488),
    [anon_sym_if] = ACTIONS(488),
    [anon_sym_in] = ACTIONS(488),
    [anon_sym_EQ] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(1182),
    [anon_sym_not] = ACTIONS(488),
    [anon_sym_and] = ACTIONS(488),
    [anon_sym_or] = ACTIONS(488),
    [anon_sym_PLUS] = ACTIONS(488),
    [anon_sym_DASH] = ACTIONS(488),
    [anon_sym_SLASH] = ACTIONS(1176),
    [anon_sym_PERCENT] = ACTIONS(1182),
    [anon_sym_SLASH_SLASH] = ACTIONS(1182),
    [anon_sym_STAR_STAR] = ACTIONS(1188),
    [anon_sym_PIPE] = ACTIONS(488),
    [anon_sym_AMP] = ACTIONS(488),
    [anon_sym_CARET] = ACTIONS(488),
    [anon_sym_LT_LT] = ACTIONS(488),
    [anon_sym_LT] = ACTIONS(490),
    [anon_sym_LT_EQ] = ACTIONS(488),
    [anon_sym_EQ_EQ] = ACTIONS(488),
    [anon_sym_BANG_EQ] = ACTIONS(488),
    [anon_sym_GT_EQ] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(490),
    [anon_sym_LT_GT] = ACTIONS(488),
    [anon_sym_is] = ACTIONS(488),
    [anon_sym_LBRACK] = ACTIONS(488),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(488),
    [sym__newline] = ACTIONS(488),
  },
  [538] = {
    [sym_argument_list] = STATE(599),
    [sym_generator_expression] = STATE(599),
    [anon_sym_DOT] = ACTIONS(488),
    [anon_sym_from] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(1174),
    [anon_sym_COMMA] = ACTIONS(488),
    [anon_sym_STAR] = ACTIONS(490),
    [anon_sym_GT_GT] = ACTIONS(488),
    [anon_sym_if] = ACTIONS(488),
    [anon_sym_in] = ACTIONS(488),
    [anon_sym_EQ] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_not] = ACTIONS(488),
    [anon_sym_and] = ACTIONS(488),
    [anon_sym_or] = ACTIONS(488),
    [anon_sym_PLUS] = ACTIONS(488),
    [anon_sym_DASH] = ACTIONS(488),
    [anon_sym_SLASH] = ACTIONS(490),
    [anon_sym_PERCENT] = ACTIONS(488),
    [anon_sym_SLASH_SLASH] = ACTIONS(488),
    [anon_sym_STAR_STAR] = ACTIONS(1188),
    [anon_sym_PIPE] = ACTIONS(488),
    [anon_sym_AMP] = ACTIONS(488),
    [anon_sym_CARET] = ACTIONS(488),
    [anon_sym_LT_LT] = ACTIONS(488),
    [anon_sym_LT] = ACTIONS(490),
    [anon_sym_LT_EQ] = ACTIONS(488),
    [anon_sym_EQ_EQ] = ACTIONS(488),
    [anon_sym_BANG_EQ] = ACTIONS(488),
    [anon_sym_GT_EQ] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(490),
    [anon_sym_LT_GT] = ACTIONS(488),
    [anon_sym_is] = ACTIONS(488),
    [anon_sym_LBRACK] = ACTIONS(488),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(488),
    [sym__newline] = ACTIONS(488),
  },
  [539] = {
    [sym_argument_list] = STATE(599),
    [sym_generator_expression] = STATE(599),
    [anon_sym_DOT] = ACTIONS(488),
    [anon_sym_from] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(1174),
    [anon_sym_COMMA] = ACTIONS(488),
    [anon_sym_STAR] = ACTIONS(1176),
    [anon_sym_GT_GT] = ACTIONS(1178),
    [anon_sym_if] = ACTIONS(488),
    [anon_sym_in] = ACTIONS(488),
    [anon_sym_EQ] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(1182),
    [anon_sym_not] = ACTIONS(488),
    [anon_sym_and] = ACTIONS(488),
    [anon_sym_or] = ACTIONS(488),
    [anon_sym_PLUS] = ACTIONS(1186),
    [anon_sym_DASH] = ACTIONS(1186),
    [anon_sym_SLASH] = ACTIONS(1176),
    [anon_sym_PERCENT] = ACTIONS(1182),
    [anon_sym_SLASH_SLASH] = ACTIONS(1182),
    [anon_sym_STAR_STAR] = ACTIONS(1188),
    [anon_sym_PIPE] = ACTIONS(488),
    [anon_sym_AMP] = ACTIONS(488),
    [anon_sym_CARET] = ACTIONS(1194),
    [anon_sym_LT_LT] = ACTIONS(1178),
    [anon_sym_LT] = ACTIONS(490),
    [anon_sym_LT_EQ] = ACTIONS(488),
    [anon_sym_EQ_EQ] = ACTIONS(488),
    [anon_sym_BANG_EQ] = ACTIONS(488),
    [anon_sym_GT_EQ] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(490),
    [anon_sym_LT_GT] = ACTIONS(488),
    [anon_sym_is] = ACTIONS(488),
    [anon_sym_LBRACK] = ACTIONS(488),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(488),
    [sym__newline] = ACTIONS(488),
  },
  [540] = {
    [sym_argument_list] = STATE(599),
    [sym_generator_expression] = STATE(599),
    [anon_sym_DOT] = ACTIONS(1172),
    [anon_sym_from] = ACTIONS(502),
    [anon_sym_LPAREN] = ACTIONS(1174),
    [anon_sym_COMMA] = ACTIONS(502),
    [anon_sym_STAR] = ACTIONS(1176),
    [anon_sym_GT_GT] = ACTIONS(1178),
    [anon_sym_if] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(502),
    [anon_sym_EQ] = ACTIONS(504),
    [anon_sym_AT] = ACTIONS(1182),
    [anon_sym_not] = ACTIONS(502),
    [anon_sym_and] = ACTIONS(502),
    [anon_sym_or] = ACTIONS(502),
    [anon_sym_PLUS] = ACTIONS(1186),
    [anon_sym_DASH] = ACTIONS(1186),
    [anon_sym_SLASH] = ACTIONS(1176),
    [anon_sym_PERCENT] = ACTIONS(1182),
    [anon_sym_SLASH_SLASH] = ACTIONS(1182),
    [anon_sym_STAR_STAR] = ACTIONS(1188),
    [anon_sym_PIPE] = ACTIONS(1190),
    [anon_sym_AMP] = ACTIONS(1192),
    [anon_sym_CARET] = ACTIONS(1194),
    [anon_sym_LT_LT] = ACTIONS(1178),
    [anon_sym_LT] = ACTIONS(504),
    [anon_sym_LT_EQ] = ACTIONS(502),
    [anon_sym_EQ_EQ] = ACTIONS(502),
    [anon_sym_BANG_EQ] = ACTIONS(502),
    [anon_sym_GT_EQ] = ACTIONS(502),
    [anon_sym_GT] = ACTIONS(504),
    [anon_sym_LT_GT] = ACTIONS(502),
    [anon_sym_is] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(1200),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(502),
    [sym__newline] = ACTIONS(502),
  },
  [541] = {
    [sym_argument_list] = STATE(599),
    [sym_generator_expression] = STATE(599),
    [anon_sym_DOT] = ACTIONS(488),
    [anon_sym_from] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(1174),
    [anon_sym_COMMA] = ACTIONS(488),
    [anon_sym_STAR] = ACTIONS(1176),
    [anon_sym_GT_GT] = ACTIONS(1178),
    [anon_sym_if] = ACTIONS(488),
    [anon_sym_in] = ACTIONS(488),
    [anon_sym_EQ] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(1182),
    [anon_sym_not] = ACTIONS(488),
    [anon_sym_and] = ACTIONS(488),
    [anon_sym_or] = ACTIONS(488),
    [anon_sym_PLUS] = ACTIONS(1186),
    [anon_sym_DASH] = ACTIONS(1186),
    [anon_sym_SLASH] = ACTIONS(1176),
    [anon_sym_PERCENT] = ACTIONS(1182),
    [anon_sym_SLASH_SLASH] = ACTIONS(1182),
    [anon_sym_STAR_STAR] = ACTIONS(1188),
    [anon_sym_PIPE] = ACTIONS(488),
    [anon_sym_AMP] = ACTIONS(1192),
    [anon_sym_CARET] = ACTIONS(1194),
    [anon_sym_LT_LT] = ACTIONS(1178),
    [anon_sym_LT] = ACTIONS(490),
    [anon_sym_LT_EQ] = ACTIONS(488),
    [anon_sym_EQ_EQ] = ACTIONS(488),
    [anon_sym_BANG_EQ] = ACTIONS(488),
    [anon_sym_GT_EQ] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(490),
    [anon_sym_LT_GT] = ACTIONS(488),
    [anon_sym_is] = ACTIONS(488),
    [anon_sym_LBRACK] = ACTIONS(488),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(488),
    [sym__newline] = ACTIONS(488),
  },
  [542] = {
    [sym_argument_list] = STATE(599),
    [sym_generator_expression] = STATE(599),
    [anon_sym_DOT] = ACTIONS(488),
    [anon_sym_from] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(1174),
    [anon_sym_COMMA] = ACTIONS(488),
    [anon_sym_STAR] = ACTIONS(1176),
    [anon_sym_GT_GT] = ACTIONS(488),
    [anon_sym_if] = ACTIONS(488),
    [anon_sym_in] = ACTIONS(488),
    [anon_sym_EQ] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(1182),
    [anon_sym_not] = ACTIONS(488),
    [anon_sym_and] = ACTIONS(488),
    [anon_sym_or] = ACTIONS(488),
    [anon_sym_PLUS] = ACTIONS(1186),
    [anon_sym_DASH] = ACTIONS(1186),
    [anon_sym_SLASH] = ACTIONS(1176),
    [anon_sym_PERCENT] = ACTIONS(1182),
    [anon_sym_SLASH_SLASH] = ACTIONS(1182),
    [anon_sym_STAR_STAR] = ACTIONS(1188),
    [anon_sym_PIPE] = ACTIONS(488),
    [anon_sym_AMP] = ACTIONS(488),
    [anon_sym_CARET] = ACTIONS(488),
    [anon_sym_LT_LT] = ACTIONS(488),
    [anon_sym_LT] = ACTIONS(490),
    [anon_sym_LT_EQ] = ACTIONS(488),
    [anon_sym_EQ_EQ] = ACTIONS(488),
    [anon_sym_BANG_EQ] = ACTIONS(488),
    [anon_sym_GT_EQ] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(490),
    [anon_sym_LT_GT] = ACTIONS(488),
    [anon_sym_is] = ACTIONS(488),
    [anon_sym_LBRACK] = ACTIONS(488),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(488),
    [sym__newline] = ACTIONS(488),
  },
  [543] = {
    [sym_string] = STATE(548),
    [aux_sym_concatenated_string_repeat1] = STATE(548),
    [anon_sym_DOT] = ACTIONS(440),
    [anon_sym_LPAREN] = ACTIONS(440),
    [anon_sym_COMMA] = ACTIONS(440),
    [anon_sym_as] = ACTIONS(440),
    [anon_sym_STAR] = ACTIONS(442),
    [anon_sym_GT_GT] = ACTIONS(440),
    [anon_sym_if] = ACTIONS(440),
    [anon_sym_COLON] = ACTIONS(440),
    [anon_sym_in] = ACTIONS(440),
    [anon_sym_AT] = ACTIONS(440),
    [anon_sym_not] = ACTIONS(440),
    [anon_sym_and] = ACTIONS(440),
    [anon_sym_or] = ACTIONS(440),
    [anon_sym_PLUS] = ACTIONS(440),
    [anon_sym_DASH] = ACTIONS(440),
    [anon_sym_SLASH] = ACTIONS(442),
    [anon_sym_PERCENT] = ACTIONS(440),
    [anon_sym_SLASH_SLASH] = ACTIONS(440),
    [anon_sym_STAR_STAR] = ACTIONS(440),
    [anon_sym_PIPE] = ACTIONS(440),
    [anon_sym_AMP] = ACTIONS(440),
    [anon_sym_CARET] = ACTIONS(440),
    [anon_sym_LT_LT] = ACTIONS(440),
    [anon_sym_LT] = ACTIONS(442),
    [anon_sym_LT_EQ] = ACTIONS(440),
    [anon_sym_EQ_EQ] = ACTIONS(440),
    [anon_sym_BANG_EQ] = ACTIONS(440),
    [anon_sym_GT_EQ] = ACTIONS(440),
    [anon_sym_GT] = ACTIONS(442),
    [anon_sym_LT_GT] = ACTIONS(440),
    [anon_sym_is] = ACTIONS(440),
    [anon_sym_LBRACK] = ACTIONS(440),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(890),
  },
  [544] = {
    [anon_sym_DOT] = ACTIONS(440),
    [anon_sym_from] = ACTIONS(440),
    [anon_sym_LPAREN] = ACTIONS(440),
    [anon_sym_COMMA] = ACTIONS(440),
    [anon_sym_STAR] = ACTIONS(442),
    [anon_sym_GT_GT] = ACTIONS(440),
    [anon_sym_COLON_EQ] = ACTIONS(1202),
    [anon_sym_if] = ACTIONS(440),
    [anon_sym_in] = ACTIONS(440),
    [anon_sym_EQ] = ACTIONS(442),
    [anon_sym_AT] = ACTIONS(440),
    [anon_sym_not] = ACTIONS(440),
    [anon_sym_and] = ACTIONS(440),
    [anon_sym_or] = ACTIONS(440),
    [anon_sym_PLUS] = ACTIONS(440),
    [anon_sym_DASH] = ACTIONS(440),
    [anon_sym_SLASH] = ACTIONS(442),
    [anon_sym_PERCENT] = ACTIONS(440),
    [anon_sym_SLASH_SLASH] = ACTIONS(440),
    [anon_sym_STAR_STAR] = ACTIONS(440),
    [anon_sym_PIPE] = ACTIONS(440),
    [anon_sym_AMP] = ACTIONS(440),
    [anon_sym_CARET] = ACTIONS(440),
    [anon_sym_LT_LT] = ACTIONS(440),
    [anon_sym_LT] = ACTIONS(442),
    [anon_sym_LT_EQ] = ACTIONS(440),
    [anon_sym_EQ_EQ] = ACTIONS(440),
    [anon_sym_BANG_EQ] = ACTIONS(440),
    [anon_sym_GT_EQ] = ACTIONS(440),
    [anon_sym_GT] = ACTIONS(442),
    [anon_sym_LT_GT] = ACTIONS(440),
    [anon_sym_is] = ACTIONS(440),
    [anon_sym_LBRACK] = ACTIONS(440),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(440),
    [sym__newline] = ACTIONS(440),
  },
  [545] = {
    [anon_sym_DOT] = ACTIONS(578),
    [anon_sym_from] = ACTIONS(578),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(580),
    [anon_sym_GT_GT] = ACTIONS(578),
    [anon_sym_if] = ACTIONS(578),
    [anon_sym_in] = ACTIONS(578),
    [anon_sym_EQ] = ACTIONS(580),
    [anon_sym_AT] = ACTIONS(578),
    [anon_sym_not] = ACTIONS(578),
    [anon_sym_and] = ACTIONS(578),
    [anon_sym_or] = ACTIONS(578),
    [anon_sym_PLUS] = ACTIONS(578),
    [anon_sym_DASH] = ACTIONS(578),
    [anon_sym_SLASH] = ACTIONS(580),
    [anon_sym_PERCENT] = ACTIONS(578),
    [anon_sym_SLASH_SLASH] = ACTIONS(578),
    [anon_sym_STAR_STAR] = ACTIONS(578),
    [anon_sym_PIPE] = ACTIONS(578),
    [anon_sym_AMP] = ACTIONS(578),
    [anon_sym_CARET] = ACTIONS(578),
    [anon_sym_LT_LT] = ACTIONS(578),
    [anon_sym_LT] = ACTIONS(580),
    [anon_sym_LT_EQ] = ACTIONS(578),
    [anon_sym_EQ_EQ] = ACTIONS(578),
    [anon_sym_BANG_EQ] = ACTIONS(578),
    [anon_sym_GT_EQ] = ACTIONS(578),
    [anon_sym_GT] = ACTIONS(580),
    [anon_sym_LT_GT] = ACTIONS(578),
    [anon_sym_is] = ACTIONS(578),
    [anon_sym_LBRACK] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(578),
    [sym__newline] = ACTIONS(578),
    [sym__string_start] = ACTIONS(578),
  },
  [546] = {
    [anon_sym_DOT] = ACTIONS(602),
    [anon_sym_from] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(602),
    [anon_sym_STAR] = ACTIONS(604),
    [anon_sym_GT_GT] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(602),
    [anon_sym_in] = ACTIONS(602),
    [anon_sym_EQ] = ACTIONS(604),
    [anon_sym_AT] = ACTIONS(602),
    [anon_sym_not] = ACTIONS(602),
    [anon_sym_and] = ACTIONS(602),
    [anon_sym_or] = ACTIONS(602),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_SLASH] = ACTIONS(604),
    [anon_sym_PERCENT] = ACTIONS(602),
    [anon_sym_SLASH_SLASH] = ACTIONS(602),
    [anon_sym_STAR_STAR] = ACTIONS(602),
    [anon_sym_PIPE] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(602),
    [anon_sym_CARET] = ACTIONS(602),
    [anon_sym_LT_LT] = ACTIONS(602),
    [anon_sym_LT] = ACTIONS(604),
    [anon_sym_LT_EQ] = ACTIONS(602),
    [anon_sym_EQ_EQ] = ACTIONS(602),
    [anon_sym_BANG_EQ] = ACTIONS(602),
    [anon_sym_GT_EQ] = ACTIONS(602),
    [anon_sym_GT] = ACTIONS(604),
    [anon_sym_LT_GT] = ACTIONS(602),
    [anon_sym_is] = ACTIONS(602),
    [anon_sym_LBRACK] = ACTIONS(602),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(602),
    [sym__newline] = ACTIONS(602),
    [sym__string_start] = ACTIONS(602),
  },
  [547] = {
    [sym_argument_list] = STATE(680),
    [sym_generator_expression] = STATE(680),
    [aux_sym_comparison_operator_repeat1] = STATE(704),
    [anon_sym_DOT] = ACTIONS(1204),
    [anon_sym_LPAREN] = ACTIONS(1206),
    [anon_sym_COMMA] = ACTIONS(460),
    [anon_sym_as] = ACTIONS(460),
    [anon_sym_STAR] = ACTIONS(1208),
    [anon_sym_GT_GT] = ACTIONS(1210),
    [anon_sym_if] = ACTIONS(460),
    [anon_sym_COLON] = ACTIONS(460),
    [anon_sym_in] = ACTIONS(1212),
    [anon_sym_AT] = ACTIONS(1214),
    [anon_sym_not] = ACTIONS(1216),
    [anon_sym_and] = ACTIONS(460),
    [anon_sym_or] = ACTIONS(460),
    [anon_sym_PLUS] = ACTIONS(1218),
    [anon_sym_DASH] = ACTIONS(1218),
    [anon_sym_SLASH] = ACTIONS(1208),
    [anon_sym_PERCENT] = ACTIONS(1214),
    [anon_sym_SLASH_SLASH] = ACTIONS(1214),
    [anon_sym_STAR_STAR] = ACTIONS(1220),
    [anon_sym_PIPE] = ACTIONS(1222),
    [anon_sym_AMP] = ACTIONS(1224),
    [anon_sym_CARET] = ACTIONS(1226),
    [anon_sym_LT_LT] = ACTIONS(1210),
    [anon_sym_LT] = ACTIONS(1228),
    [anon_sym_LT_EQ] = ACTIONS(1212),
    [anon_sym_EQ_EQ] = ACTIONS(1212),
    [anon_sym_BANG_EQ] = ACTIONS(1212),
    [anon_sym_GT_EQ] = ACTIONS(1212),
    [anon_sym_GT] = ACTIONS(1228),
    [anon_sym_LT_GT] = ACTIONS(1212),
    [anon_sym_is] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [sym_comment] = ACTIONS(3),
  },
  [548] = {
    [sym_string] = STATE(549),
    [aux_sym_concatenated_string_repeat1] = STATE(549),
    [anon_sym_DOT] = ACTIONS(401),
    [anon_sym_LPAREN] = ACTIONS(401),
    [anon_sym_COMMA] = ACTIONS(401),
    [anon_sym_as] = ACTIONS(401),
    [anon_sym_STAR] = ACTIONS(403),
    [anon_sym_GT_GT] = ACTIONS(401),
    [anon_sym_if] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(401),
    [anon_sym_in] = ACTIONS(401),
    [anon_sym_AT] = ACTIONS(401),
    [anon_sym_not] = ACTIONS(401),
    [anon_sym_and] = ACTIONS(401),
    [anon_sym_or] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(401),
    [anon_sym_DASH] = ACTIONS(401),
    [anon_sym_SLASH] = ACTIONS(403),
    [anon_sym_PERCENT] = ACTIONS(401),
    [anon_sym_SLASH_SLASH] = ACTIONS(401),
    [anon_sym_STAR_STAR] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(401),
    [anon_sym_AMP] = ACTIONS(401),
    [anon_sym_CARET] = ACTIONS(401),
    [anon_sym_LT_LT] = ACTIONS(401),
    [anon_sym_LT] = ACTIONS(403),
    [anon_sym_LT_EQ] = ACTIONS(401),
    [anon_sym_EQ_EQ] = ACTIONS(401),
    [anon_sym_BANG_EQ] = ACTIONS(401),
    [anon_sym_GT_EQ] = ACTIONS(401),
    [anon_sym_GT] = ACTIONS(403),
    [anon_sym_LT_GT] = ACTIONS(401),
    [anon_sym_is] = ACTIONS(401),
    [anon_sym_LBRACK] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(890),
  },
  [549] = {
    [sym_string] = STATE(549),
    [aux_sym_concatenated_string_repeat1] = STATE(549),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_COMMA] = ACTIONS(429),
    [anon_sym_as] = ACTIONS(429),
    [anon_sym_STAR] = ACTIONS(431),
    [anon_sym_GT_GT] = ACTIONS(429),
    [anon_sym_if] = ACTIONS(429),
    [anon_sym_COLON] = ACTIONS(429),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_AT] = ACTIONS(429),
    [anon_sym_not] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PLUS] = ACTIONS(429),
    [anon_sym_DASH] = ACTIONS(429),
    [anon_sym_SLASH] = ACTIONS(431),
    [anon_sym_PERCENT] = ACTIONS(429),
    [anon_sym_SLASH_SLASH] = ACTIONS(429),
    [anon_sym_STAR_STAR] = ACTIONS(429),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(429),
    [anon_sym_LT_LT] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(431),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(431),
    [anon_sym_LT_GT] = ACTIONS(429),
    [anon_sym_is] = ACTIONS(429),
    [anon_sym_LBRACK] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1234),
  },
  [550] = {
    [anon_sym_DOT] = ACTIONS(440),
    [anon_sym_LPAREN] = ACTIONS(440),
    [anon_sym_RPAREN] = ACTIONS(440),
    [anon_sym_COMMA] = ACTIONS(440),
    [anon_sym_STAR] = ACTIONS(442),
    [anon_sym_GT_GT] = ACTIONS(440),
    [anon_sym_COLON_EQ] = ACTIONS(1167),
    [anon_sym_if] = ACTIONS(440),
    [anon_sym_async] = ACTIONS(440),
    [anon_sym_for] = ACTIONS(440),
    [anon_sym_in] = ACTIONS(440),
    [anon_sym_EQ] = ACTIONS(1237),
    [anon_sym_AT] = ACTIONS(440),
    [anon_sym_not] = ACTIONS(440),
    [anon_sym_and] = ACTIONS(440),
    [anon_sym_or] = ACTIONS(440),
    [anon_sym_PLUS] = ACTIONS(440),
    [anon_sym_DASH] = ACTIONS(440),
    [anon_sym_SLASH] = ACTIONS(442),
    [anon_sym_PERCENT] = ACTIONS(440),
    [anon_sym_SLASH_SLASH] = ACTIONS(440),
    [anon_sym_STAR_STAR] = ACTIONS(440),
    [anon_sym_PIPE] = ACTIONS(440),
    [anon_sym_AMP] = ACTIONS(440),
    [anon_sym_CARET] = ACTIONS(440),
    [anon_sym_LT_LT] = ACTIONS(440),
    [anon_sym_LT] = ACTIONS(442),
    [anon_sym_LT_EQ] = ACTIONS(440),
    [anon_sym_EQ_EQ] = ACTIONS(440),
    [anon_sym_BANG_EQ] = ACTIONS(440),
    [anon_sym_GT_EQ] = ACTIONS(440),
    [anon_sym_GT] = ACTIONS(442),
    [anon_sym_LT_GT] = ACTIONS(440),
    [anon_sym_is] = ACTIONS(440),
    [anon_sym_LBRACK] = ACTIONS(440),
    [sym_comment] = ACTIONS(3),
  },
  [551] = {
    [sym__primary_expression] = STATE(696),
    [sym_binary_operator] = STATE(696),
    [sym_unary_operator] = STATE(696),
    [sym_attribute] = STATE(696),
    [sym_subscript] = STATE(696),
    [sym_call] = STATE(696),
    [sym_list] = STATE(696),
    [sym_list_comprehension] = STATE(696),
    [sym_dictionary] = STATE(696),
    [sym_dictionary_comprehension] = STATE(696),
    [sym_set] = STATE(696),
    [sym_set_comprehension] = STATE(696),
    [sym_parenthesized_expression] = STATE(696),
    [sym_tuple] = STATE(696),
    [sym_generator_expression] = STATE(696),
    [sym_concatenated_string] = STATE(696),
    [sym_string] = STATE(403),
    [sym_identifier] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_in] = ACTIONS(1241),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(1239),
    [sym_float] = ACTIONS(1243),
    [sym_true] = ACTIONS(1239),
    [sym_false] = ACTIONS(1239),
    [sym_none] = ACTIONS(1239),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [552] = {
    [sym__primary_expression] = STATE(127),
    [sym_binary_operator] = STATE(127),
    [sym_unary_operator] = STATE(127),
    [sym_attribute] = STATE(127),
    [sym_subscript] = STATE(127),
    [sym_call] = STATE(127),
    [sym_list] = STATE(127),
    [sym_list_comprehension] = STATE(127),
    [sym_dictionary] = STATE(127),
    [sym_dictionary_comprehension] = STATE(127),
    [sym_set] = STATE(127),
    [sym_set_comprehension] = STATE(127),
    [sym_parenthesized_expression] = STATE(127),
    [sym_tuple] = STATE(127),
    [sym_generator_expression] = STATE(127),
    [sym_concatenated_string] = STATE(127),
    [sym_string] = STATE(113),
    [sym_identifier] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(349),
    [anon_sym_exec] = ACTIONS(349),
    [anon_sym_not] = ACTIONS(1247),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(1249),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(1245),
    [sym_float] = ACTIONS(1249),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_none] = ACTIONS(1245),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [553] = {
    [anon_sym_DOT] = ACTIONS(816),
    [anon_sym_from] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(816),
    [anon_sym_COMMA] = ACTIONS(816),
    [anon_sym_STAR] = ACTIONS(818),
    [anon_sym_GT_GT] = ACTIONS(816),
    [anon_sym_if] = ACTIONS(816),
    [anon_sym_in] = ACTIONS(816),
    [anon_sym_EQ] = ACTIONS(818),
    [anon_sym_AT] = ACTIONS(816),
    [anon_sym_not] = ACTIONS(816),
    [anon_sym_and] = ACTIONS(816),
    [anon_sym_or] = ACTIONS(816),
    [anon_sym_PLUS] = ACTIONS(816),
    [anon_sym_DASH] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(818),
    [anon_sym_PERCENT] = ACTIONS(816),
    [anon_sym_SLASH_SLASH] = ACTIONS(816),
    [anon_sym_STAR_STAR] = ACTIONS(816),
    [anon_sym_PIPE] = ACTIONS(816),
    [anon_sym_AMP] = ACTIONS(816),
    [anon_sym_CARET] = ACTIONS(816),
    [anon_sym_LT_LT] = ACTIONS(816),
    [anon_sym_LT] = ACTIONS(818),
    [anon_sym_LT_EQ] = ACTIONS(816),
    [anon_sym_EQ_EQ] = ACTIONS(816),
    [anon_sym_BANG_EQ] = ACTIONS(816),
    [anon_sym_GT_EQ] = ACTIONS(816),
    [anon_sym_GT] = ACTIONS(818),
    [anon_sym_LT_GT] = ACTIONS(816),
    [anon_sym_is] = ACTIONS(816),
    [anon_sym_LBRACK] = ACTIONS(816),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(816),
    [sym__newline] = ACTIONS(816),
  },
  [554] = {
    [anon_sym_DOT] = ACTIONS(792),
    [anon_sym_from] = ACTIONS(792),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_COMMA] = ACTIONS(792),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_GT_GT] = ACTIONS(792),
    [anon_sym_if] = ACTIONS(792),
    [anon_sym_in] = ACTIONS(792),
    [anon_sym_EQ] = ACTIONS(794),
    [anon_sym_AT] = ACTIONS(792),
    [anon_sym_not] = ACTIONS(792),
    [anon_sym_and] = ACTIONS(792),
    [anon_sym_or] = ACTIONS(792),
    [anon_sym_PLUS] = ACTIONS(792),
    [anon_sym_DASH] = ACTIONS(792),
    [anon_sym_SLASH] = ACTIONS(794),
    [anon_sym_PERCENT] = ACTIONS(792),
    [anon_sym_SLASH_SLASH] = ACTIONS(792),
    [anon_sym_STAR_STAR] = ACTIONS(792),
    [anon_sym_PIPE] = ACTIONS(792),
    [anon_sym_AMP] = ACTIONS(792),
    [anon_sym_CARET] = ACTIONS(792),
    [anon_sym_LT_LT] = ACTIONS(792),
    [anon_sym_LT] = ACTIONS(794),
    [anon_sym_LT_EQ] = ACTIONS(792),
    [anon_sym_EQ_EQ] = ACTIONS(792),
    [anon_sym_BANG_EQ] = ACTIONS(792),
    [anon_sym_GT_EQ] = ACTIONS(792),
    [anon_sym_GT] = ACTIONS(794),
    [anon_sym_LT_GT] = ACTIONS(792),
    [anon_sym_is] = ACTIONS(792),
    [anon_sym_LBRACK] = ACTIONS(792),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(792),
    [sym__newline] = ACTIONS(792),
  },
  [555] = {
    [anon_sym_DOT] = ACTIONS(644),
    [anon_sym_from] = ACTIONS(644),
    [anon_sym_LPAREN] = ACTIONS(644),
    [anon_sym_COMMA] = ACTIONS(644),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_GT_GT] = ACTIONS(644),
    [anon_sym_if] = ACTIONS(644),
    [anon_sym_in] = ACTIONS(644),
    [anon_sym_EQ] = ACTIONS(646),
    [anon_sym_AT] = ACTIONS(644),
    [anon_sym_not] = ACTIONS(644),
    [anon_sym_and] = ACTIONS(644),
    [anon_sym_or] = ACTIONS(644),
    [anon_sym_PLUS] = ACTIONS(644),
    [anon_sym_DASH] = ACTIONS(644),
    [anon_sym_SLASH] = ACTIONS(646),
    [anon_sym_PERCENT] = ACTIONS(644),
    [anon_sym_SLASH_SLASH] = ACTIONS(644),
    [anon_sym_STAR_STAR] = ACTIONS(644),
    [anon_sym_PIPE] = ACTIONS(644),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_CARET] = ACTIONS(644),
    [anon_sym_LT_LT] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_LT_EQ] = ACTIONS(644),
    [anon_sym_EQ_EQ] = ACTIONS(644),
    [anon_sym_BANG_EQ] = ACTIONS(644),
    [anon_sym_GT_EQ] = ACTIONS(644),
    [anon_sym_GT] = ACTIONS(646),
    [anon_sym_LT_GT] = ACTIONS(644),
    [anon_sym_is] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(644),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(644),
    [sym__newline] = ACTIONS(644),
  },
  [556] = {
    [anon_sym_DOT] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_RPAREN] = ACTIONS(237),
    [anon_sym_COMMA] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(237),
    [anon_sym_if] = ACTIONS(237),
    [anon_sym_async] = ACTIONS(237),
    [anon_sym_for] = ACTIONS(237),
    [anon_sym_in] = ACTIONS(237),
    [anon_sym_EQ] = ACTIONS(1251),
    [anon_sym_AT] = ACTIONS(237),
    [anon_sym_not] = ACTIONS(237),
    [anon_sym_and] = ACTIONS(237),
    [anon_sym_or] = ACTIONS(237),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(237),
    [anon_sym_SLASH_SLASH] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(237),
    [anon_sym_PIPE] = ACTIONS(237),
    [anon_sym_AMP] = ACTIONS(237),
    [anon_sym_CARET] = ACTIONS(237),
    [anon_sym_LT_LT] = ACTIONS(237),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_LT_GT] = ACTIONS(237),
    [anon_sym_is] = ACTIONS(237),
    [anon_sym_LBRACK] = ACTIONS(237),
    [sym_comment] = ACTIONS(3),
  },
  [557] = {
    [anon_sym_DOT] = ACTIONS(788),
    [anon_sym_from] = ACTIONS(788),
    [anon_sym_LPAREN] = ACTIONS(788),
    [anon_sym_COMMA] = ACTIONS(788),
    [anon_sym_STAR] = ACTIONS(790),
    [anon_sym_GT_GT] = ACTIONS(788),
    [anon_sym_if] = ACTIONS(788),
    [anon_sym_in] = ACTIONS(788),
    [anon_sym_EQ] = ACTIONS(790),
    [anon_sym_AT] = ACTIONS(788),
    [anon_sym_not] = ACTIONS(788),
    [anon_sym_and] = ACTIONS(788),
    [anon_sym_or] = ACTIONS(788),
    [anon_sym_PLUS] = ACTIONS(788),
    [anon_sym_DASH] = ACTIONS(788),
    [anon_sym_SLASH] = ACTIONS(790),
    [anon_sym_PERCENT] = ACTIONS(788),
    [anon_sym_SLASH_SLASH] = ACTIONS(788),
    [anon_sym_STAR_STAR] = ACTIONS(788),
    [anon_sym_PIPE] = ACTIONS(788),
    [anon_sym_AMP] = ACTIONS(788),
    [anon_sym_CARET] = ACTIONS(788),
    [anon_sym_LT_LT] = ACTIONS(788),
    [anon_sym_LT] = ACTIONS(790),
    [anon_sym_LT_EQ] = ACTIONS(788),
    [anon_sym_EQ_EQ] = ACTIONS(788),
    [anon_sym_BANG_EQ] = ACTIONS(788),
    [anon_sym_GT_EQ] = ACTIONS(788),
    [anon_sym_GT] = ACTIONS(790),
    [anon_sym_LT_GT] = ACTIONS(788),
    [anon_sym_is] = ACTIONS(788),
    [anon_sym_LBRACK] = ACTIONS(788),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(788),
    [sym__newline] = ACTIONS(788),
  },
  [558] = {
    [anon_sym_DOT] = ACTIONS(780),
    [anon_sym_from] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(780),
    [anon_sym_COMMA] = ACTIONS(780),
    [anon_sym_STAR] = ACTIONS(782),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_if] = ACTIONS(780),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_EQ] = ACTIONS(782),
    [anon_sym_AT] = ACTIONS(780),
    [anon_sym_not] = ACTIONS(780),
    [anon_sym_and] = ACTIONS(780),
    [anon_sym_or] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(782),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_SLASH_SLASH] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_LT_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_GT_EQ] = ACTIONS(780),
    [anon_sym_GT] = ACTIONS(782),
    [anon_sym_LT_GT] = ACTIONS(780),
    [anon_sym_is] = ACTIONS(780),
    [anon_sym_LBRACK] = ACTIONS(780),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(780),
    [sym__newline] = ACTIONS(780),
  },
  [559] = {
    [anon_sym_DOT] = ACTIONS(660),
    [anon_sym_from] = ACTIONS(660),
    [anon_sym_LPAREN] = ACTIONS(660),
    [anon_sym_COMMA] = ACTIONS(660),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_GT_GT] = ACTIONS(660),
    [anon_sym_if] = ACTIONS(660),
    [anon_sym_in] = ACTIONS(660),
    [anon_sym_EQ] = ACTIONS(662),
    [anon_sym_AT] = ACTIONS(660),
    [anon_sym_not] = ACTIONS(660),
    [anon_sym_and] = ACTIONS(660),
    [anon_sym_or] = ACTIONS(660),
    [anon_sym_PLUS] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(660),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_PERCENT] = ACTIONS(660),
    [anon_sym_SLASH_SLASH] = ACTIONS(660),
    [anon_sym_STAR_STAR] = ACTIONS(660),
    [anon_sym_PIPE] = ACTIONS(660),
    [anon_sym_AMP] = ACTIONS(660),
    [anon_sym_CARET] = ACTIONS(660),
    [anon_sym_LT_LT] = ACTIONS(660),
    [anon_sym_LT] = ACTIONS(662),
    [anon_sym_LT_EQ] = ACTIONS(660),
    [anon_sym_EQ_EQ] = ACTIONS(660),
    [anon_sym_BANG_EQ] = ACTIONS(660),
    [anon_sym_GT_EQ] = ACTIONS(660),
    [anon_sym_GT] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(660),
    [anon_sym_is] = ACTIONS(660),
    [anon_sym_LBRACK] = ACTIONS(660),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(660),
    [sym__newline] = ACTIONS(660),
  },
  [560] = {
    [sym_variables] = STATE(1155),
    [sym__primary_expression] = STATE(694),
    [sym_binary_operator] = STATE(694),
    [sym_unary_operator] = STATE(694),
    [sym_attribute] = STATE(694),
    [sym_subscript] = STATE(694),
    [sym_call] = STATE(694),
    [sym_list] = STATE(694),
    [sym_list_comprehension] = STATE(694),
    [sym_dictionary] = STATE(694),
    [sym_dictionary_comprehension] = STATE(694),
    [sym_set] = STATE(694),
    [sym_set_comprehension] = STATE(694),
    [sym_parenthesized_expression] = STATE(694),
    [sym_tuple] = STATE(694),
    [sym_generator_expression] = STATE(694),
    [sym_concatenated_string] = STATE(694),
    [sym_string] = STATE(403),
    [sym_identifier] = ACTIONS(1253),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(1255),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(1253),
    [sym_float] = ACTIONS(1255),
    [sym_true] = ACTIONS(1253),
    [sym_false] = ACTIONS(1253),
    [sym_none] = ACTIONS(1253),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [561] = {
    [sym__primary_expression] = STATE(565),
    [sym_binary_operator] = STATE(565),
    [sym_unary_operator] = STATE(565),
    [sym_attribute] = STATE(565),
    [sym_subscript] = STATE(565),
    [sym_call] = STATE(565),
    [sym_list] = STATE(565),
    [sym_list_comprehension] = STATE(565),
    [sym_dictionary] = STATE(565),
    [sym_dictionary_comprehension] = STATE(565),
    [sym_set] = STATE(565),
    [sym_set_comprehension] = STATE(565),
    [sym_parenthesized_expression] = STATE(565),
    [sym_tuple] = STATE(565),
    [sym_generator_expression] = STATE(565),
    [sym_concatenated_string] = STATE(565),
    [sym_string] = STATE(543),
    [sym_identifier] = ACTIONS(1257),
    [anon_sym_LPAREN] = ACTIONS(870),
    [anon_sym_print] = ACTIONS(872),
    [anon_sym_exec] = ACTIONS(872),
    [anon_sym_not] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(876),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_TILDE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(880),
    [sym_ellipsis] = ACTIONS(1261),
    [anon_sym_LBRACE] = ACTIONS(884),
    [sym_integer] = ACTIONS(1257),
    [sym_float] = ACTIONS(1261),
    [sym_true] = ACTIONS(1257),
    [sym_false] = ACTIONS(1257),
    [sym_none] = ACTIONS(1257),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(890),
  },
  [562] = {
    [sym__primary_expression] = STATE(696),
    [sym_binary_operator] = STATE(696),
    [sym_unary_operator] = STATE(696),
    [sym_attribute] = STATE(696),
    [sym_subscript] = STATE(696),
    [sym_call] = STATE(696),
    [sym_list] = STATE(696),
    [sym_list_comprehension] = STATE(696),
    [sym_dictionary] = STATE(696),
    [sym_dictionary_comprehension] = STATE(696),
    [sym_set] = STATE(696),
    [sym_set_comprehension] = STATE(696),
    [sym_parenthesized_expression] = STATE(696),
    [sym_tuple] = STATE(696),
    [sym_generator_expression] = STATE(696),
    [sym_concatenated_string] = STATE(696),
    [sym_string] = STATE(403),
    [sym_identifier] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_in] = ACTIONS(1263),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(1239),
    [sym_float] = ACTIONS(1243),
    [sym_true] = ACTIONS(1239),
    [sym_false] = ACTIONS(1239),
    [sym_none] = ACTIONS(1239),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [563] = {
    [sym_argument_list] = STATE(680),
    [sym_generator_expression] = STATE(680),
    [anon_sym_DOT] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(1206),
    [anon_sym_COMMA] = ACTIONS(488),
    [anon_sym_as] = ACTIONS(488),
    [anon_sym_STAR] = ACTIONS(490),
    [anon_sym_GT_GT] = ACTIONS(488),
    [anon_sym_if] = ACTIONS(488),
    [anon_sym_COLON] = ACTIONS(488),
    [anon_sym_in] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_not] = ACTIONS(488),
    [anon_sym_and] = ACTIONS(488),
    [anon_sym_or] = ACTIONS(488),
    [anon_sym_PLUS] = ACTIONS(488),
    [anon_sym_DASH] = ACTIONS(488),
    [anon_sym_SLASH] = ACTIONS(490),
    [anon_sym_PERCENT] = ACTIONS(488),
    [anon_sym_SLASH_SLASH] = ACTIONS(488),
    [anon_sym_STAR_STAR] = ACTIONS(1220),
    [anon_sym_PIPE] = ACTIONS(488),
    [anon_sym_AMP] = ACTIONS(488),
    [anon_sym_CARET] = ACTIONS(488),
    [anon_sym_LT_LT] = ACTIONS(488),
    [anon_sym_LT] = ACTIONS(490),
    [anon_sym_LT_EQ] = ACTIONS(488),
    [anon_sym_EQ_EQ] = ACTIONS(488),
    [anon_sym_BANG_EQ] = ACTIONS(488),
    [anon_sym_GT_EQ] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(490),
    [anon_sym_LT_GT] = ACTIONS(488),
    [anon_sym_is] = ACTIONS(488),
    [anon_sym_LBRACK] = ACTIONS(488),
    [sym_comment] = ACTIONS(3),
  },
  [564] = {
    [sym_argument_list] = STATE(680),
    [sym_generator_expression] = STATE(680),
    [anon_sym_DOT] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(1206),
    [anon_sym_COMMA] = ACTIONS(488),
    [anon_sym_as] = ACTIONS(488),
    [anon_sym_STAR] = ACTIONS(1208),
    [anon_sym_GT_GT] = ACTIONS(488),
    [anon_sym_if] = ACTIONS(488),
    [anon_sym_COLON] = ACTIONS(488),
    [anon_sym_in] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(1214),
    [anon_sym_not] = ACTIONS(488),
    [anon_sym_and] = ACTIONS(488),
    [anon_sym_or] = ACTIONS(488),
    [anon_sym_PLUS] = ACTIONS(1218),
    [anon_sym_DASH] = ACTIONS(1218),
    [anon_sym_SLASH] = ACTIONS(1208),
    [anon_sym_PERCENT] = ACTIONS(1214),
    [anon_sym_SLASH_SLASH] = ACTIONS(1214),
    [anon_sym_STAR_STAR] = ACTIONS(1220),
    [anon_sym_PIPE] = ACTIONS(488),
    [anon_sym_AMP] = ACTIONS(488),
    [anon_sym_CARET] = ACTIONS(488),
    [anon_sym_LT_LT] = ACTIONS(488),
    [anon_sym_LT] = ACTIONS(490),
    [anon_sym_LT_EQ] = ACTIONS(488),
    [anon_sym_EQ_EQ] = ACTIONS(488),
    [anon_sym_BANG_EQ] = ACTIONS(488),
    [anon_sym_GT_EQ] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(490),
    [anon_sym_LT_GT] = ACTIONS(488),
    [anon_sym_is] = ACTIONS(488),
    [anon_sym_LBRACK] = ACTIONS(488),
    [sym_comment] = ACTIONS(3),
  },
  [565] = {
    [sym_argument_list] = STATE(680),
    [sym_generator_expression] = STATE(680),
    [anon_sym_DOT] = ACTIONS(1204),
    [anon_sym_LPAREN] = ACTIONS(1206),
    [anon_sym_COMMA] = ACTIONS(502),
    [anon_sym_as] = ACTIONS(502),
    [anon_sym_STAR] = ACTIONS(1208),
    [anon_sym_GT_GT] = ACTIONS(1210),
    [anon_sym_if] = ACTIONS(502),
    [anon_sym_COLON] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(502),
    [anon_sym_AT] = ACTIONS(1214),
    [anon_sym_not] = ACTIONS(502),
    [anon_sym_and] = ACTIONS(502),
    [anon_sym_or] = ACTIONS(502),
    [anon_sym_PLUS] = ACTIONS(1218),
    [anon_sym_DASH] = ACTIONS(1218),
    [anon_sym_SLASH] = ACTIONS(1208),
    [anon_sym_PERCENT] = ACTIONS(1214),
    [anon_sym_SLASH_SLASH] = ACTIONS(1214),
    [anon_sym_STAR_STAR] = ACTIONS(1220),
    [anon_sym_PIPE] = ACTIONS(1222),
    [anon_sym_AMP] = ACTIONS(1224),
    [anon_sym_CARET] = ACTIONS(1226),
    [anon_sym_LT_LT] = ACTIONS(1210),
    [anon_sym_LT] = ACTIONS(504),
    [anon_sym_LT_EQ] = ACTIONS(502),
    [anon_sym_EQ_EQ] = ACTIONS(502),
    [anon_sym_BANG_EQ] = ACTIONS(502),
    [anon_sym_GT_EQ] = ACTIONS(502),
    [anon_sym_GT] = ACTIONS(504),
    [anon_sym_LT_GT] = ACTIONS(502),
    [anon_sym_is] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [sym_comment] = ACTIONS(3),
  },
  [566] = {
    [sym_variables] = STATE(1072),
    [sym__primary_expression] = STATE(694),
    [sym_binary_operator] = STATE(694),
    [sym_unary_operator] = STATE(694),
    [sym_attribute] = STATE(694),
    [sym_subscript] = STATE(694),
    [sym_call] = STATE(694),
    [sym_list] = STATE(694),
    [sym_list_comprehension] = STATE(694),
    [sym_dictionary] = STATE(694),
    [sym_dictionary_comprehension] = STATE(694),
    [sym_set] = STATE(694),
    [sym_set_comprehension] = STATE(694),
    [sym_parenthesized_expression] = STATE(694),
    [sym_tuple] = STATE(694),
    [sym_generator_expression] = STATE(694),
    [sym_concatenated_string] = STATE(694),
    [sym_string] = STATE(403),
    [sym_identifier] = ACTIONS(1253),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(1255),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(1253),
    [sym_float] = ACTIONS(1255),
    [sym_true] = ACTIONS(1253),
    [sym_false] = ACTIONS(1253),
    [sym_none] = ACTIONS(1253),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [567] = {
    [sym_argument_list] = STATE(680),
    [sym_generator_expression] = STATE(680),
    [anon_sym_DOT] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(1206),
    [anon_sym_COMMA] = ACTIONS(488),
    [anon_sym_as] = ACTIONS(488),
    [anon_sym_STAR] = ACTIONS(1208),
    [anon_sym_GT_GT] = ACTIONS(488),
    [anon_sym_if] = ACTIONS(488),
    [anon_sym_COLON] = ACTIONS(488),
    [anon_sym_in] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(1214),
    [anon_sym_not] = ACTIONS(488),
    [anon_sym_and] = ACTIONS(488),
    [anon_sym_or] = ACTIONS(488),
    [anon_sym_PLUS] = ACTIONS(488),
    [anon_sym_DASH] = ACTIONS(488),
    [anon_sym_SLASH] = ACTIONS(1208),
    [anon_sym_PERCENT] = ACTIONS(1214),
    [anon_sym_SLASH_SLASH] = ACTIONS(1214),
    [anon_sym_STAR_STAR] = ACTIONS(1220),
    [anon_sym_PIPE] = ACTIONS(488),
    [anon_sym_AMP] = ACTIONS(488),
    [anon_sym_CARET] = ACTIONS(488),
    [anon_sym_LT_LT] = ACTIONS(488),
    [anon_sym_LT] = ACTIONS(490),
    [anon_sym_LT_EQ] = ACTIONS(488),
    [anon_sym_EQ_EQ] = ACTIONS(488),
    [anon_sym_BANG_EQ] = ACTIONS(488),
    [anon_sym_GT_EQ] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(490),
    [anon_sym_LT_GT] = ACTIONS(488),
    [anon_sym_is] = ACTIONS(488),
    [anon_sym_LBRACK] = ACTIONS(488),
    [sym_comment] = ACTIONS(3),
  },
  [568] = {
    [anon_sym_DOT] = ACTIONS(806),
    [anon_sym_from] = ACTIONS(806),
    [anon_sym_LPAREN] = ACTIONS(806),
    [anon_sym_COMMA] = ACTIONS(806),
    [anon_sym_STAR] = ACTIONS(808),
    [anon_sym_GT_GT] = ACTIONS(806),
    [anon_sym_if] = ACTIONS(806),
    [anon_sym_in] = ACTIONS(806),
    [anon_sym_EQ] = ACTIONS(808),
    [anon_sym_AT] = ACTIONS(806),
    [anon_sym_not] = ACTIONS(806),
    [anon_sym_and] = ACTIONS(806),
    [anon_sym_or] = ACTIONS(806),
    [anon_sym_PLUS] = ACTIONS(806),
    [anon_sym_DASH] = ACTIONS(806),
    [anon_sym_SLASH] = ACTIONS(808),
    [anon_sym_PERCENT] = ACTIONS(806),
    [anon_sym_SLASH_SLASH] = ACTIONS(806),
    [anon_sym_STAR_STAR] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(806),
    [anon_sym_AMP] = ACTIONS(806),
    [anon_sym_CARET] = ACTIONS(806),
    [anon_sym_LT_LT] = ACTIONS(806),
    [anon_sym_LT] = ACTIONS(808),
    [anon_sym_LT_EQ] = ACTIONS(806),
    [anon_sym_EQ_EQ] = ACTIONS(806),
    [anon_sym_BANG_EQ] = ACTIONS(806),
    [anon_sym_GT_EQ] = ACTIONS(806),
    [anon_sym_GT] = ACTIONS(808),
    [anon_sym_LT_GT] = ACTIONS(806),
    [anon_sym_is] = ACTIONS(806),
    [anon_sym_LBRACK] = ACTIONS(806),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(806),
    [sym__newline] = ACTIONS(806),
  },
  [569] = {
    [sym_argument_list] = STATE(680),
    [sym_generator_expression] = STATE(680),
    [anon_sym_DOT] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(1206),
    [anon_sym_COMMA] = ACTIONS(488),
    [anon_sym_as] = ACTIONS(488),
    [anon_sym_STAR] = ACTIONS(490),
    [anon_sym_GT_GT] = ACTIONS(488),
    [anon_sym_if] = ACTIONS(488),
    [anon_sym_COLON] = ACTIONS(488),
    [anon_sym_in] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_not] = ACTIONS(488),
    [anon_sym_and] = ACTIONS(488),
    [anon_sym_or] = ACTIONS(488),
    [anon_sym_PLUS] = ACTIONS(488),
    [anon_sym_DASH] = ACTIONS(488),
    [anon_sym_SLASH] = ACTIONS(490),
    [anon_sym_PERCENT] = ACTIONS(488),
    [anon_sym_SLASH_SLASH] = ACTIONS(488),
    [anon_sym_STAR_STAR] = ACTIONS(488),
    [anon_sym_PIPE] = ACTIONS(488),
    [anon_sym_AMP] = ACTIONS(488),
    [anon_sym_CARET] = ACTIONS(488),
    [anon_sym_LT_LT] = ACTIONS(488),
    [anon_sym_LT] = ACTIONS(490),
    [anon_sym_LT_EQ] = ACTIONS(488),
    [anon_sym_EQ_EQ] = ACTIONS(488),
    [anon_sym_BANG_EQ] = ACTIONS(488),
    [anon_sym_GT_EQ] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(490),
    [anon_sym_LT_GT] = ACTIONS(488),
    [anon_sym_is] = ACTIONS(488),
    [anon_sym_LBRACK] = ACTIONS(488),
    [sym_comment] = ACTIONS(3),
  },
  [570] = {
    [anon_sym_DOT] = ACTIONS(237),
    [anon_sym_from] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_COMMA] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(237),
    [anon_sym_if] = ACTIONS(237),
    [anon_sym_in] = ACTIONS(237),
    [anon_sym_EQ] = ACTIONS(235),
    [anon_sym_AT] = ACTIONS(237),
    [anon_sym_not] = ACTIONS(237),
    [anon_sym_and] = ACTIONS(237),
    [anon_sym_or] = ACTIONS(237),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(237),
    [anon_sym_SLASH_SLASH] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(237),
    [anon_sym_PIPE] = ACTIONS(237),
    [anon_sym_AMP] = ACTIONS(237),
    [anon_sym_CARET] = ACTIONS(237),
    [anon_sym_LT_LT] = ACTIONS(237),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_LT_GT] = ACTIONS(237),
    [anon_sym_is] = ACTIONS(237),
    [anon_sym_LBRACK] = ACTIONS(237),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(237),
    [sym__newline] = ACTIONS(237),
  },
  [571] = {
    [anon_sym_DOT] = ACTIONS(802),
    [anon_sym_from] = ACTIONS(802),
    [anon_sym_LPAREN] = ACTIONS(802),
    [anon_sym_COMMA] = ACTIONS(802),
    [anon_sym_STAR] = ACTIONS(804),
    [anon_sym_GT_GT] = ACTIONS(802),
    [anon_sym_if] = ACTIONS(802),
    [anon_sym_in] = ACTIONS(802),
    [anon_sym_EQ] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(802),
    [anon_sym_not] = ACTIONS(802),
    [anon_sym_and] = ACTIONS(802),
    [anon_sym_or] = ACTIONS(802),
    [anon_sym_PLUS] = ACTIONS(802),
    [anon_sym_DASH] = ACTIONS(802),
    [anon_sym_SLASH] = ACTIONS(804),
    [anon_sym_PERCENT] = ACTIONS(802),
    [anon_sym_SLASH_SLASH] = ACTIONS(802),
    [anon_sym_STAR_STAR] = ACTIONS(802),
    [anon_sym_PIPE] = ACTIONS(802),
    [anon_sym_AMP] = ACTIONS(802),
    [anon_sym_CARET] = ACTIONS(802),
    [anon_sym_LT_LT] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(804),
    [anon_sym_LT_EQ] = ACTIONS(802),
    [anon_sym_EQ_EQ] = ACTIONS(802),
    [anon_sym_BANG_EQ] = ACTIONS(802),
    [anon_sym_GT_EQ] = ACTIONS(802),
    [anon_sym_GT] = ACTIONS(804),
    [anon_sym_LT_GT] = ACTIONS(802),
    [anon_sym_is] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(802),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(802),
    [sym__newline] = ACTIONS(802),
  },
  [572] = {
    [anon_sym_DOT] = ACTIONS(752),
    [anon_sym_from] = ACTIONS(752),
    [anon_sym_LPAREN] = ACTIONS(752),
    [anon_sym_COMMA] = ACTIONS(752),
    [anon_sym_STAR] = ACTIONS(754),
    [anon_sym_GT_GT] = ACTIONS(752),
    [anon_sym_if] = ACTIONS(752),
    [anon_sym_in] = ACTIONS(752),
    [anon_sym_EQ] = ACTIONS(754),
    [anon_sym_AT] = ACTIONS(752),
    [anon_sym_not] = ACTIONS(752),
    [anon_sym_and] = ACTIONS(752),
    [anon_sym_or] = ACTIONS(752),
    [anon_sym_PLUS] = ACTIONS(752),
    [anon_sym_DASH] = ACTIONS(752),
    [anon_sym_SLASH] = ACTIONS(754),
    [anon_sym_PERCENT] = ACTIONS(752),
    [anon_sym_SLASH_SLASH] = ACTIONS(752),
    [anon_sym_STAR_STAR] = ACTIONS(752),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_AMP] = ACTIONS(752),
    [anon_sym_CARET] = ACTIONS(752),
    [anon_sym_LT_LT] = ACTIONS(752),
    [anon_sym_LT] = ACTIONS(754),
    [anon_sym_LT_EQ] = ACTIONS(752),
    [anon_sym_EQ_EQ] = ACTIONS(752),
    [anon_sym_BANG_EQ] = ACTIONS(752),
    [anon_sym_GT_EQ] = ACTIONS(752),
    [anon_sym_GT] = ACTIONS(754),
    [anon_sym_LT_GT] = ACTIONS(752),
    [anon_sym_is] = ACTIONS(752),
    [anon_sym_LBRACK] = ACTIONS(752),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(752),
    [sym__newline] = ACTIONS(752),
  },
  [573] = {
    [sym_argument_list] = STATE(680),
    [sym_generator_expression] = STATE(680),
    [anon_sym_DOT] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(1206),
    [anon_sym_COMMA] = ACTIONS(488),
    [anon_sym_as] = ACTIONS(488),
    [anon_sym_STAR] = ACTIONS(1208),
    [anon_sym_GT_GT] = ACTIONS(1210),
    [anon_sym_if] = ACTIONS(488),
    [anon_sym_COLON] = ACTIONS(488),
    [anon_sym_in] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(1214),
    [anon_sym_not] = ACTIONS(488),
    [anon_sym_and] = ACTIONS(488),
    [anon_sym_or] = ACTIONS(488),
    [anon_sym_PLUS] = ACTIONS(1218),
    [anon_sym_DASH] = ACTIONS(1218),
    [anon_sym_SLASH] = ACTIONS(1208),
    [anon_sym_PERCENT] = ACTIONS(1214),
    [anon_sym_SLASH_SLASH] = ACTIONS(1214),
    [anon_sym_STAR_STAR] = ACTIONS(1220),
    [anon_sym_PIPE] = ACTIONS(488),
    [anon_sym_AMP] = ACTIONS(1224),
    [anon_sym_CARET] = ACTIONS(1226),
    [anon_sym_LT_LT] = ACTIONS(1210),
    [anon_sym_LT] = ACTIONS(490),
    [anon_sym_LT_EQ] = ACTIONS(488),
    [anon_sym_EQ_EQ] = ACTIONS(488),
    [anon_sym_BANG_EQ] = ACTIONS(488),
    [anon_sym_GT_EQ] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(490),
    [anon_sym_LT_GT] = ACTIONS(488),
    [anon_sym_is] = ACTIONS(488),
    [anon_sym_LBRACK] = ACTIONS(488),
    [sym_comment] = ACTIONS(3),
  },
  [574] = {
    [sym_argument_list] = STATE(680),
    [sym_generator_expression] = STATE(680),
    [anon_sym_DOT] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(1206),
    [anon_sym_COMMA] = ACTIONS(488),
    [anon_sym_as] = ACTIONS(488),
    [anon_sym_STAR] = ACTIONS(1208),
    [anon_sym_GT_GT] = ACTIONS(1210),
    [anon_sym_if] = ACTIONS(488),
    [anon_sym_COLON] = ACTIONS(488),
    [anon_sym_in] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(1214),
    [anon_sym_not] = ACTIONS(488),
    [anon_sym_and] = ACTIONS(488),
    [anon_sym_or] = ACTIONS(488),
    [anon_sym_PLUS] = ACTIONS(1218),
    [anon_sym_DASH] = ACTIONS(1218),
    [anon_sym_SLASH] = ACTIONS(1208),
    [anon_sym_PERCENT] = ACTIONS(1214),
    [anon_sym_SLASH_SLASH] = ACTIONS(1214),
    [anon_sym_STAR_STAR] = ACTIONS(1220),
    [anon_sym_PIPE] = ACTIONS(488),
    [anon_sym_AMP] = ACTIONS(488),
    [anon_sym_CARET] = ACTIONS(1226),
    [anon_sym_LT_LT] = ACTIONS(1210),
    [anon_sym_LT] = ACTIONS(490),
    [anon_sym_LT_EQ] = ACTIONS(488),
    [anon_sym_EQ_EQ] = ACTIONS(488),
    [anon_sym_BANG_EQ] = ACTIONS(488),
    [anon_sym_GT_EQ] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(490),
    [anon_sym_LT_GT] = ACTIONS(488),
    [anon_sym_is] = ACTIONS(488),
    [anon_sym_LBRACK] = ACTIONS(488),
    [sym_comment] = ACTIONS(3),
  },
  [575] = {
    [sym_argument_list] = STATE(680),
    [sym_generator_expression] = STATE(680),
    [anon_sym_DOT] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(1206),
    [anon_sym_COMMA] = ACTIONS(488),
    [anon_sym_as] = ACTIONS(488),
    [anon_sym_STAR] = ACTIONS(1208),
    [anon_sym_GT_GT] = ACTIONS(1210),
    [anon_sym_if] = ACTIONS(488),
    [anon_sym_COLON] = ACTIONS(488),
    [anon_sym_in] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(1214),
    [anon_sym_not] = ACTIONS(488),
    [anon_sym_and] = ACTIONS(488),
    [anon_sym_or] = ACTIONS(488),
    [anon_sym_PLUS] = ACTIONS(1218),
    [anon_sym_DASH] = ACTIONS(1218),
    [anon_sym_SLASH] = ACTIONS(1208),
    [anon_sym_PERCENT] = ACTIONS(1214),
    [anon_sym_SLASH_SLASH] = ACTIONS(1214),
    [anon_sym_STAR_STAR] = ACTIONS(1220),
    [anon_sym_PIPE] = ACTIONS(488),
    [anon_sym_AMP] = ACTIONS(488),
    [anon_sym_CARET] = ACTIONS(488),
    [anon_sym_LT_LT] = ACTIONS(1210),
    [anon_sym_LT] = ACTIONS(490),
    [anon_sym_LT_EQ] = ACTIONS(488),
    [anon_sym_EQ_EQ] = ACTIONS(488),
    [anon_sym_BANG_EQ] = ACTIONS(488),
    [anon_sym_GT_EQ] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(490),
    [anon_sym_LT_GT] = ACTIONS(488),
    [anon_sym_is] = ACTIONS(488),
    [anon_sym_LBRACK] = ACTIONS(488),
    [sym_comment] = ACTIONS(3),
  },
  [576] = {
    [anon_sym_DOT] = ACTIONS(636),
    [anon_sym_from] = ACTIONS(636),
    [anon_sym_LPAREN] = ACTIONS(636),
    [anon_sym_COMMA] = ACTIONS(636),
    [anon_sym_STAR] = ACTIONS(638),
    [anon_sym_GT_GT] = ACTIONS(636),
    [anon_sym_if] = ACTIONS(636),
    [anon_sym_in] = ACTIONS(636),
    [anon_sym_EQ] = ACTIONS(638),
    [anon_sym_AT] = ACTIONS(636),
    [anon_sym_not] = ACTIONS(636),
    [anon_sym_and] = ACTIONS(636),
    [anon_sym_or] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(636),
    [anon_sym_DASH] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(638),
    [anon_sym_PERCENT] = ACTIONS(636),
    [anon_sym_SLASH_SLASH] = ACTIONS(636),
    [anon_sym_STAR_STAR] = ACTIONS(636),
    [anon_sym_PIPE] = ACTIONS(636),
    [anon_sym_AMP] = ACTIONS(636),
    [anon_sym_CARET] = ACTIONS(636),
    [anon_sym_LT_LT] = ACTIONS(636),
    [anon_sym_LT] = ACTIONS(638),
    [anon_sym_LT_EQ] = ACTIONS(636),
    [anon_sym_EQ_EQ] = ACTIONS(636),
    [anon_sym_BANG_EQ] = ACTIONS(636),
    [anon_sym_GT_EQ] = ACTIONS(636),
    [anon_sym_GT] = ACTIONS(638),
    [anon_sym_LT_GT] = ACTIONS(636),
    [anon_sym_is] = ACTIONS(636),
    [anon_sym_LBRACK] = ACTIONS(636),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(636),
    [sym__newline] = ACTIONS(636),
  },
  [577] = {
    [anon_sym_DOT] = ACTIONS(746),
    [anon_sym_from] = ACTIONS(746),
    [anon_sym_LPAREN] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_GT_GT] = ACTIONS(746),
    [anon_sym_if] = ACTIONS(746),
    [anon_sym_in] = ACTIONS(746),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_AT] = ACTIONS(746),
    [anon_sym_not] = ACTIONS(746),
    [anon_sym_and] = ACTIONS(746),
    [anon_sym_or] = ACTIONS(746),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_SLASH] = ACTIONS(748),
    [anon_sym_PERCENT] = ACTIONS(746),
    [anon_sym_SLASH_SLASH] = ACTIONS(746),
    [anon_sym_STAR_STAR] = ACTIONS(746),
    [anon_sym_PIPE] = ACTIONS(746),
    [anon_sym_AMP] = ACTIONS(746),
    [anon_sym_CARET] = ACTIONS(746),
    [anon_sym_LT_LT] = ACTIONS(746),
    [anon_sym_LT] = ACTIONS(748),
    [anon_sym_LT_EQ] = ACTIONS(746),
    [anon_sym_EQ_EQ] = ACTIONS(746),
    [anon_sym_BANG_EQ] = ACTIONS(746),
    [anon_sym_GT_EQ] = ACTIONS(746),
    [anon_sym_GT] = ACTIONS(748),
    [anon_sym_LT_GT] = ACTIONS(746),
    [anon_sym_is] = ACTIONS(746),
    [anon_sym_LBRACK] = ACTIONS(746),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(746),
    [sym__newline] = ACTIONS(746),
  },
  [578] = {
    [sym_argument_list] = STATE(680),
    [sym_generator_expression] = STATE(680),
    [anon_sym_DOT] = ACTIONS(1204),
    [anon_sym_LPAREN] = ACTIONS(1206),
    [anon_sym_COMMA] = ACTIONS(496),
    [anon_sym_as] = ACTIONS(496),
    [anon_sym_STAR] = ACTIONS(1208),
    [anon_sym_GT_GT] = ACTIONS(1210),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_COLON] = ACTIONS(496),
    [anon_sym_in] = ACTIONS(496),
    [anon_sym_AT] = ACTIONS(1214),
    [anon_sym_not] = ACTIONS(496),
    [anon_sym_and] = ACTIONS(496),
    [anon_sym_or] = ACTIONS(496),
    [anon_sym_PLUS] = ACTIONS(1218),
    [anon_sym_DASH] = ACTIONS(1218),
    [anon_sym_SLASH] = ACTIONS(1208),
    [anon_sym_PERCENT] = ACTIONS(1214),
    [anon_sym_SLASH_SLASH] = ACTIONS(1214),
    [anon_sym_STAR_STAR] = ACTIONS(1220),
    [anon_sym_PIPE] = ACTIONS(1222),
    [anon_sym_AMP] = ACTIONS(1224),
    [anon_sym_CARET] = ACTIONS(1226),
    [anon_sym_LT_LT] = ACTIONS(1210),
    [anon_sym_LT] = ACTIONS(498),
    [anon_sym_LT_EQ] = ACTIONS(496),
    [anon_sym_EQ_EQ] = ACTIONS(496),
    [anon_sym_BANG_EQ] = ACTIONS(496),
    [anon_sym_GT_EQ] = ACTIONS(496),
    [anon_sym_GT] = ACTIONS(498),
    [anon_sym_LT_GT] = ACTIONS(496),
    [anon_sym_is] = ACTIONS(496),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [sym_comment] = ACTIONS(3),
  },
  [579] = {
    [anon_sym_DOT] = ACTIONS(766),
    [anon_sym_from] = ACTIONS(766),
    [anon_sym_LPAREN] = ACTIONS(766),
    [anon_sym_COMMA] = ACTIONS(766),
    [anon_sym_STAR] = ACTIONS(768),
    [anon_sym_GT_GT] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(766),
    [anon_sym_in] = ACTIONS(766),
    [anon_sym_EQ] = ACTIONS(768),
    [anon_sym_AT] = ACTIONS(766),
    [anon_sym_not] = ACTIONS(766),
    [anon_sym_and] = ACTIONS(766),
    [anon_sym_or] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_PERCENT] = ACTIONS(766),
    [anon_sym_SLASH_SLASH] = ACTIONS(766),
    [anon_sym_STAR_STAR] = ACTIONS(766),
    [anon_sym_PIPE] = ACTIONS(766),
    [anon_sym_AMP] = ACTIONS(766),
    [anon_sym_CARET] = ACTIONS(766),
    [anon_sym_LT_LT] = ACTIONS(766),
    [anon_sym_LT] = ACTIONS(768),
    [anon_sym_LT_EQ] = ACTIONS(766),
    [anon_sym_EQ_EQ] = ACTIONS(766),
    [anon_sym_BANG_EQ] = ACTIONS(766),
    [anon_sym_GT_EQ] = ACTIONS(766),
    [anon_sym_GT] = ACTIONS(768),
    [anon_sym_LT_GT] = ACTIONS(766),
    [anon_sym_is] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(766),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(766),
    [sym__newline] = ACTIONS(766),
  },
  [580] = {
    [anon_sym_DOT] = ACTIONS(762),
    [anon_sym_from] = ACTIONS(762),
    [anon_sym_LPAREN] = ACTIONS(762),
    [anon_sym_COMMA] = ACTIONS(762),
    [anon_sym_STAR] = ACTIONS(764),
    [anon_sym_GT_GT] = ACTIONS(762),
    [anon_sym_if] = ACTIONS(762),
    [anon_sym_in] = ACTIONS(762),
    [anon_sym_EQ] = ACTIONS(764),
    [anon_sym_AT] = ACTIONS(762),
    [anon_sym_not] = ACTIONS(762),
    [anon_sym_and] = ACTIONS(762),
    [anon_sym_or] = ACTIONS(762),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_SLASH] = ACTIONS(764),
    [anon_sym_PERCENT] = ACTIONS(762),
    [anon_sym_SLASH_SLASH] = ACTIONS(762),
    [anon_sym_STAR_STAR] = ACTIONS(762),
    [anon_sym_PIPE] = ACTIONS(762),
    [anon_sym_AMP] = ACTIONS(762),
    [anon_sym_CARET] = ACTIONS(762),
    [anon_sym_LT_LT] = ACTIONS(762),
    [anon_sym_LT] = ACTIONS(764),
    [anon_sym_LT_EQ] = ACTIONS(762),
    [anon_sym_EQ_EQ] = ACTIONS(762),
    [anon_sym_BANG_EQ] = ACTIONS(762),
    [anon_sym_GT_EQ] = ACTIONS(762),
    [anon_sym_GT] = ACTIONS(764),
    [anon_sym_LT_GT] = ACTIONS(762),
    [anon_sym_is] = ACTIONS(762),
    [anon_sym_LBRACK] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(762),
    [sym__newline] = ACTIONS(762),
  },
  [581] = {
    [anon_sym_DOT] = ACTIONS(740),
    [anon_sym_from] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(740),
    [anon_sym_COMMA] = ACTIONS(740),
    [anon_sym_STAR] = ACTIONS(742),
    [anon_sym_GT_GT] = ACTIONS(740),
    [anon_sym_if] = ACTIONS(740),
    [anon_sym_in] = ACTIONS(740),
    [anon_sym_EQ] = ACTIONS(742),
    [anon_sym_AT] = ACTIONS(740),
    [anon_sym_not] = ACTIONS(740),
    [anon_sym_and] = ACTIONS(740),
    [anon_sym_or] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(740),
    [anon_sym_DASH] = ACTIONS(740),
    [anon_sym_SLASH] = ACTIONS(742),
    [anon_sym_PERCENT] = ACTIONS(740),
    [anon_sym_SLASH_SLASH] = ACTIONS(740),
    [anon_sym_STAR_STAR] = ACTIONS(740),
    [anon_sym_PIPE] = ACTIONS(740),
    [anon_sym_AMP] = ACTIONS(740),
    [anon_sym_CARET] = ACTIONS(740),
    [anon_sym_LT_LT] = ACTIONS(740),
    [anon_sym_LT] = ACTIONS(742),
    [anon_sym_LT_EQ] = ACTIONS(740),
    [anon_sym_EQ_EQ] = ACTIONS(740),
    [anon_sym_BANG_EQ] = ACTIONS(740),
    [anon_sym_GT_EQ] = ACTIONS(740),
    [anon_sym_GT] = ACTIONS(742),
    [anon_sym_LT_GT] = ACTIONS(740),
    [anon_sym_is] = ACTIONS(740),
    [anon_sym_LBRACK] = ACTIONS(740),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(740),
    [sym__newline] = ACTIONS(740),
  },
  [582] = {
    [sym_argument_list] = STATE(680),
    [sym_generator_expression] = STATE(680),
    [anon_sym_DOT] = ACTIONS(508),
    [anon_sym_LPAREN] = ACTIONS(1206),
    [anon_sym_COMMA] = ACTIONS(508),
    [anon_sym_as] = ACTIONS(508),
    [anon_sym_STAR] = ACTIONS(510),
    [anon_sym_GT_GT] = ACTIONS(508),
    [anon_sym_if] = ACTIONS(508),
    [anon_sym_COLON] = ACTIONS(508),
    [anon_sym_in] = ACTIONS(508),
    [anon_sym_AT] = ACTIONS(508),
    [anon_sym_not] = ACTIONS(508),
    [anon_sym_and] = ACTIONS(508),
    [anon_sym_or] = ACTIONS(508),
    [anon_sym_PLUS] = ACTIONS(508),
    [anon_sym_DASH] = ACTIONS(508),
    [anon_sym_SLASH] = ACTIONS(510),
    [anon_sym_PERCENT] = ACTIONS(508),
    [anon_sym_SLASH_SLASH] = ACTIONS(508),
    [anon_sym_STAR_STAR] = ACTIONS(508),
    [anon_sym_PIPE] = ACTIONS(508),
    [anon_sym_AMP] = ACTIONS(508),
    [anon_sym_CARET] = ACTIONS(508),
    [anon_sym_LT_LT] = ACTIONS(508),
    [anon_sym_LT] = ACTIONS(510),
    [anon_sym_LT_EQ] = ACTIONS(508),
    [anon_sym_EQ_EQ] = ACTIONS(508),
    [anon_sym_BANG_EQ] = ACTIONS(508),
    [anon_sym_GT_EQ] = ACTIONS(508),
    [anon_sym_GT] = ACTIONS(510),
    [anon_sym_LT_GT] = ACTIONS(508),
    [anon_sym_is] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(508),
    [sym_comment] = ACTIONS(3),
  },
  [583] = {
    [sym_variables] = STATE(1119),
    [sym__primary_expression] = STATE(694),
    [sym_binary_operator] = STATE(694),
    [sym_unary_operator] = STATE(694),
    [sym_attribute] = STATE(694),
    [sym_subscript] = STATE(694),
    [sym_call] = STATE(694),
    [sym_list] = STATE(694),
    [sym_list_comprehension] = STATE(694),
    [sym_dictionary] = STATE(694),
    [sym_dictionary_comprehension] = STATE(694),
    [sym_set] = STATE(694),
    [sym_set_comprehension] = STATE(694),
    [sym_parenthesized_expression] = STATE(694),
    [sym_tuple] = STATE(694),
    [sym_generator_expression] = STATE(694),
    [sym_concatenated_string] = STATE(694),
    [sym_string] = STATE(403),
    [sym_identifier] = ACTIONS(1253),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(1255),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(1253),
    [sym_float] = ACTIONS(1255),
    [sym_true] = ACTIONS(1253),
    [sym_false] = ACTIONS(1253),
    [sym_none] = ACTIONS(1253),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [584] = {
    [anon_sym_DOT] = ACTIONS(710),
    [anon_sym_from] = ACTIONS(710),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_COMMA] = ACTIONS(710),
    [anon_sym_STAR] = ACTIONS(712),
    [anon_sym_GT_GT] = ACTIONS(710),
    [anon_sym_if] = ACTIONS(710),
    [anon_sym_in] = ACTIONS(710),
    [anon_sym_EQ] = ACTIONS(712),
    [anon_sym_AT] = ACTIONS(710),
    [anon_sym_not] = ACTIONS(710),
    [anon_sym_and] = ACTIONS(710),
    [anon_sym_or] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(710),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_SLASH] = ACTIONS(712),
    [anon_sym_PERCENT] = ACTIONS(710),
    [anon_sym_SLASH_SLASH] = ACTIONS(710),
    [anon_sym_STAR_STAR] = ACTIONS(710),
    [anon_sym_PIPE] = ACTIONS(710),
    [anon_sym_AMP] = ACTIONS(710),
    [anon_sym_CARET] = ACTIONS(710),
    [anon_sym_LT_LT] = ACTIONS(710),
    [anon_sym_LT] = ACTIONS(712),
    [anon_sym_LT_EQ] = ACTIONS(710),
    [anon_sym_EQ_EQ] = ACTIONS(710),
    [anon_sym_BANG_EQ] = ACTIONS(710),
    [anon_sym_GT_EQ] = ACTIONS(710),
    [anon_sym_GT] = ACTIONS(712),
    [anon_sym_LT_GT] = ACTIONS(710),
    [anon_sym_is] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(710),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(710),
    [sym__newline] = ACTIONS(710),
  },
  [585] = {
    [anon_sym_DOT] = ACTIONS(664),
    [anon_sym_from] = ACTIONS(664),
    [anon_sym_LPAREN] = ACTIONS(664),
    [anon_sym_COMMA] = ACTIONS(664),
    [anon_sym_STAR] = ACTIONS(666),
    [anon_sym_GT_GT] = ACTIONS(664),
    [anon_sym_if] = ACTIONS(664),
    [anon_sym_in] = ACTIONS(664),
    [anon_sym_EQ] = ACTIONS(666),
    [anon_sym_AT] = ACTIONS(664),
    [anon_sym_not] = ACTIONS(664),
    [anon_sym_and] = ACTIONS(664),
    [anon_sym_or] = ACTIONS(664),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_SLASH] = ACTIONS(666),
    [anon_sym_PERCENT] = ACTIONS(664),
    [anon_sym_SLASH_SLASH] = ACTIONS(664),
    [anon_sym_STAR_STAR] = ACTIONS(664),
    [anon_sym_PIPE] = ACTIONS(664),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_CARET] = ACTIONS(664),
    [anon_sym_LT_LT] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(666),
    [anon_sym_LT_EQ] = ACTIONS(664),
    [anon_sym_EQ_EQ] = ACTIONS(664),
    [anon_sym_BANG_EQ] = ACTIONS(664),
    [anon_sym_GT_EQ] = ACTIONS(664),
    [anon_sym_GT] = ACTIONS(666),
    [anon_sym_LT_GT] = ACTIONS(664),
    [anon_sym_is] = ACTIONS(664),
    [anon_sym_LBRACK] = ACTIONS(664),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(664),
    [sym__newline] = ACTIONS(664),
  },
  [586] = {
    [anon_sym_DOT] = ACTIONS(670),
    [anon_sym_from] = ACTIONS(670),
    [anon_sym_LPAREN] = ACTIONS(670),
    [anon_sym_COMMA] = ACTIONS(670),
    [anon_sym_STAR] = ACTIONS(672),
    [anon_sym_GT_GT] = ACTIONS(670),
    [anon_sym_if] = ACTIONS(670),
    [anon_sym_in] = ACTIONS(670),
    [anon_sym_EQ] = ACTIONS(672),
    [anon_sym_AT] = ACTIONS(670),
    [anon_sym_not] = ACTIONS(670),
    [anon_sym_and] = ACTIONS(670),
    [anon_sym_or] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(670),
    [anon_sym_DASH] = ACTIONS(670),
    [anon_sym_SLASH] = ACTIONS(672),
    [anon_sym_PERCENT] = ACTIONS(670),
    [anon_sym_SLASH_SLASH] = ACTIONS(670),
    [anon_sym_STAR_STAR] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(670),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_CARET] = ACTIONS(670),
    [anon_sym_LT_LT] = ACTIONS(670),
    [anon_sym_LT] = ACTIONS(672),
    [anon_sym_LT_EQ] = ACTIONS(670),
    [anon_sym_EQ_EQ] = ACTIONS(670),
    [anon_sym_BANG_EQ] = ACTIONS(670),
    [anon_sym_GT_EQ] = ACTIONS(670),
    [anon_sym_GT] = ACTIONS(672),
    [anon_sym_LT_GT] = ACTIONS(670),
    [anon_sym_is] = ACTIONS(670),
    [anon_sym_LBRACK] = ACTIONS(670),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(670),
    [sym__newline] = ACTIONS(670),
  },
  [587] = {
    [sym__primary_expression] = STATE(431),
    [sym_binary_operator] = STATE(431),
    [sym_unary_operator] = STATE(431),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(431),
    [sym_list] = STATE(431),
    [sym_list_comprehension] = STATE(431),
    [sym_dictionary] = STATE(431),
    [sym_dictionary_comprehension] = STATE(431),
    [sym_set] = STATE(431),
    [sym_set_comprehension] = STATE(431),
    [sym_parenthesized_expression] = STATE(431),
    [sym_tuple] = STATE(431),
    [sym_generator_expression] = STATE(431),
    [sym_concatenated_string] = STATE(431),
    [sym_string] = STATE(403),
    [sym_identifier] = ACTIONS(1265),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_not] = ACTIONS(1267),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(1269),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(1265),
    [sym_float] = ACTIONS(1269),
    [sym_true] = ACTIONS(1265),
    [sym_false] = ACTIONS(1265),
    [sym_none] = ACTIONS(1265),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [588] = {
    [anon_sym_DOT] = ACTIONS(678),
    [anon_sym_from] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_COMMA] = ACTIONS(678),
    [anon_sym_STAR] = ACTIONS(680),
    [anon_sym_GT_GT] = ACTIONS(678),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_in] = ACTIONS(678),
    [anon_sym_EQ] = ACTIONS(680),
    [anon_sym_AT] = ACTIONS(678),
    [anon_sym_not] = ACTIONS(678),
    [anon_sym_and] = ACTIONS(678),
    [anon_sym_or] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_SLASH] = ACTIONS(680),
    [anon_sym_PERCENT] = ACTIONS(678),
    [anon_sym_SLASH_SLASH] = ACTIONS(678),
    [anon_sym_STAR_STAR] = ACTIONS(678),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_AMP] = ACTIONS(678),
    [anon_sym_CARET] = ACTIONS(678),
    [anon_sym_LT_LT] = ACTIONS(678),
    [anon_sym_LT] = ACTIONS(680),
    [anon_sym_LT_EQ] = ACTIONS(678),
    [anon_sym_EQ_EQ] = ACTIONS(678),
    [anon_sym_BANG_EQ] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(678),
    [anon_sym_GT] = ACTIONS(680),
    [anon_sym_LT_GT] = ACTIONS(678),
    [anon_sym_is] = ACTIONS(678),
    [anon_sym_LBRACK] = ACTIONS(678),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(678),
    [sym__newline] = ACTIONS(678),
  },
  [589] = {
    [anon_sym_DOT] = ACTIONS(734),
    [anon_sym_from] = ACTIONS(734),
    [anon_sym_LPAREN] = ACTIONS(734),
    [anon_sym_COMMA] = ACTIONS(734),
    [anon_sym_STAR] = ACTIONS(736),
    [anon_sym_GT_GT] = ACTIONS(734),
    [anon_sym_if] = ACTIONS(734),
    [anon_sym_in] = ACTIONS(734),
    [anon_sym_EQ] = ACTIONS(736),
    [anon_sym_AT] = ACTIONS(734),
    [anon_sym_not] = ACTIONS(734),
    [anon_sym_and] = ACTIONS(734),
    [anon_sym_or] = ACTIONS(734),
    [anon_sym_PLUS] = ACTIONS(734),
    [anon_sym_DASH] = ACTIONS(734),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_PERCENT] = ACTIONS(734),
    [anon_sym_SLASH_SLASH] = ACTIONS(734),
    [anon_sym_STAR_STAR] = ACTIONS(734),
    [anon_sym_PIPE] = ACTIONS(734),
    [anon_sym_AMP] = ACTIONS(734),
    [anon_sym_CARET] = ACTIONS(734),
    [anon_sym_LT_LT] = ACTIONS(734),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_LT_EQ] = ACTIONS(734),
    [anon_sym_EQ_EQ] = ACTIONS(734),
    [anon_sym_BANG_EQ] = ACTIONS(734),
    [anon_sym_GT_EQ] = ACTIONS(734),
    [anon_sym_GT] = ACTIONS(736),
    [anon_sym_LT_GT] = ACTIONS(734),
    [anon_sym_is] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(734),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(734),
    [sym__newline] = ACTIONS(734),
  },
  [590] = {
    [anon_sym_DOT] = ACTIONS(796),
    [anon_sym_from] = ACTIONS(796),
    [anon_sym_LPAREN] = ACTIONS(796),
    [anon_sym_COMMA] = ACTIONS(796),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_GT_GT] = ACTIONS(796),
    [anon_sym_if] = ACTIONS(796),
    [anon_sym_in] = ACTIONS(796),
    [anon_sym_EQ] = ACTIONS(798),
    [anon_sym_AT] = ACTIONS(796),
    [anon_sym_not] = ACTIONS(796),
    [anon_sym_and] = ACTIONS(796),
    [anon_sym_or] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(796),
    [anon_sym_DASH] = ACTIONS(796),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_PERCENT] = ACTIONS(796),
    [anon_sym_SLASH_SLASH] = ACTIONS(796),
    [anon_sym_STAR_STAR] = ACTIONS(796),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_AMP] = ACTIONS(796),
    [anon_sym_CARET] = ACTIONS(796),
    [anon_sym_LT_LT] = ACTIONS(796),
    [anon_sym_LT] = ACTIONS(798),
    [anon_sym_LT_EQ] = ACTIONS(796),
    [anon_sym_EQ_EQ] = ACTIONS(796),
    [anon_sym_BANG_EQ] = ACTIONS(796),
    [anon_sym_GT_EQ] = ACTIONS(796),
    [anon_sym_GT] = ACTIONS(798),
    [anon_sym_LT_GT] = ACTIONS(796),
    [anon_sym_is] = ACTIONS(796),
    [anon_sym_LBRACK] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(796),
    [sym__newline] = ACTIONS(796),
  },
  [591] = {
    [anon_sym_DOT] = ACTIONS(654),
    [anon_sym_from] = ACTIONS(654),
    [anon_sym_LPAREN] = ACTIONS(654),
    [anon_sym_COMMA] = ACTIONS(654),
    [anon_sym_STAR] = ACTIONS(656),
    [anon_sym_GT_GT] = ACTIONS(654),
    [anon_sym_if] = ACTIONS(654),
    [anon_sym_in] = ACTIONS(654),
    [anon_sym_EQ] = ACTIONS(656),
    [anon_sym_AT] = ACTIONS(654),
    [anon_sym_not] = ACTIONS(654),
    [anon_sym_and] = ACTIONS(654),
    [anon_sym_or] = ACTIONS(654),
    [anon_sym_PLUS] = ACTIONS(654),
    [anon_sym_DASH] = ACTIONS(654),
    [anon_sym_SLASH] = ACTIONS(656),
    [anon_sym_PERCENT] = ACTIONS(654),
    [anon_sym_SLASH_SLASH] = ACTIONS(654),
    [anon_sym_STAR_STAR] = ACTIONS(654),
    [anon_sym_PIPE] = ACTIONS(654),
    [anon_sym_AMP] = ACTIONS(654),
    [anon_sym_CARET] = ACTIONS(654),
    [anon_sym_LT_LT] = ACTIONS(654),
    [anon_sym_LT] = ACTIONS(656),
    [anon_sym_LT_EQ] = ACTIONS(654),
    [anon_sym_EQ_EQ] = ACTIONS(654),
    [anon_sym_BANG_EQ] = ACTIONS(654),
    [anon_sym_GT_EQ] = ACTIONS(654),
    [anon_sym_GT] = ACTIONS(656),
    [anon_sym_LT_GT] = ACTIONS(654),
    [anon_sym_is] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(654),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(654),
    [sym__newline] = ACTIONS(654),
  },
  [592] = {
    [anon_sym_DOT] = ACTIONS(706),
    [anon_sym_from] = ACTIONS(706),
    [anon_sym_LPAREN] = ACTIONS(706),
    [anon_sym_COMMA] = ACTIONS(706),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_GT_GT] = ACTIONS(706),
    [anon_sym_if] = ACTIONS(706),
    [anon_sym_in] = ACTIONS(706),
    [anon_sym_EQ] = ACTIONS(708),
    [anon_sym_AT] = ACTIONS(706),
    [anon_sym_not] = ACTIONS(706),
    [anon_sym_and] = ACTIONS(706),
    [anon_sym_or] = ACTIONS(706),
    [anon_sym_PLUS] = ACTIONS(706),
    [anon_sym_DASH] = ACTIONS(706),
    [anon_sym_SLASH] = ACTIONS(708),
    [anon_sym_PERCENT] = ACTIONS(706),
    [anon_sym_SLASH_SLASH] = ACTIONS(706),
    [anon_sym_STAR_STAR] = ACTIONS(706),
    [anon_sym_PIPE] = ACTIONS(706),
    [anon_sym_AMP] = ACTIONS(706),
    [anon_sym_CARET] = ACTIONS(706),
    [anon_sym_LT_LT] = ACTIONS(706),
    [anon_sym_LT] = ACTIONS(708),
    [anon_sym_LT_EQ] = ACTIONS(706),
    [anon_sym_EQ_EQ] = ACTIONS(706),
    [anon_sym_BANG_EQ] = ACTIONS(706),
    [anon_sym_GT_EQ] = ACTIONS(706),
    [anon_sym_GT] = ACTIONS(708),
    [anon_sym_LT_GT] = ACTIONS(706),
    [anon_sym_is] = ACTIONS(706),
    [anon_sym_LBRACK] = ACTIONS(706),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(706),
    [sym__newline] = ACTIONS(706),
  },
  [593] = {
    [anon_sym_DOT] = ACTIONS(730),
    [anon_sym_from] = ACTIONS(730),
    [anon_sym_LPAREN] = ACTIONS(730),
    [anon_sym_COMMA] = ACTIONS(730),
    [anon_sym_STAR] = ACTIONS(732),
    [anon_sym_GT_GT] = ACTIONS(730),
    [anon_sym_if] = ACTIONS(730),
    [anon_sym_in] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_AT] = ACTIONS(730),
    [anon_sym_not] = ACTIONS(730),
    [anon_sym_and] = ACTIONS(730),
    [anon_sym_or] = ACTIONS(730),
    [anon_sym_PLUS] = ACTIONS(730),
    [anon_sym_DASH] = ACTIONS(730),
    [anon_sym_SLASH] = ACTIONS(732),
    [anon_sym_PERCENT] = ACTIONS(730),
    [anon_sym_SLASH_SLASH] = ACTIONS(730),
    [anon_sym_STAR_STAR] = ACTIONS(730),
    [anon_sym_PIPE] = ACTIONS(730),
    [anon_sym_AMP] = ACTIONS(730),
    [anon_sym_CARET] = ACTIONS(730),
    [anon_sym_LT_LT] = ACTIONS(730),
    [anon_sym_LT] = ACTIONS(732),
    [anon_sym_LT_EQ] = ACTIONS(730),
    [anon_sym_EQ_EQ] = ACTIONS(730),
    [anon_sym_BANG_EQ] = ACTIONS(730),
    [anon_sym_GT_EQ] = ACTIONS(730),
    [anon_sym_GT] = ACTIONS(732),
    [anon_sym_LT_GT] = ACTIONS(730),
    [anon_sym_is] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(730),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(730),
    [sym__newline] = ACTIONS(730),
  },
  [594] = {
    [sym_variables] = STATE(1106),
    [sym__primary_expression] = STATE(694),
    [sym_binary_operator] = STATE(694),
    [sym_unary_operator] = STATE(694),
    [sym_attribute] = STATE(694),
    [sym_subscript] = STATE(694),
    [sym_call] = STATE(694),
    [sym_list] = STATE(694),
    [sym_list_comprehension] = STATE(694),
    [sym_dictionary] = STATE(694),
    [sym_dictionary_comprehension] = STATE(694),
    [sym_set] = STATE(694),
    [sym_set_comprehension] = STATE(694),
    [sym_parenthesized_expression] = STATE(694),
    [sym_tuple] = STATE(694),
    [sym_generator_expression] = STATE(694),
    [sym_concatenated_string] = STATE(694),
    [sym_string] = STATE(403),
    [sym_identifier] = ACTIONS(1253),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(1255),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(1253),
    [sym_float] = ACTIONS(1255),
    [sym_true] = ACTIONS(1253),
    [sym_false] = ACTIONS(1253),
    [sym_none] = ACTIONS(1253),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [595] = {
    [anon_sym_DOT] = ACTIONS(776),
    [anon_sym_from] = ACTIONS(776),
    [anon_sym_LPAREN] = ACTIONS(776),
    [anon_sym_COMMA] = ACTIONS(776),
    [anon_sym_STAR] = ACTIONS(778),
    [anon_sym_GT_GT] = ACTIONS(776),
    [anon_sym_if] = ACTIONS(776),
    [anon_sym_in] = ACTIONS(776),
    [anon_sym_EQ] = ACTIONS(778),
    [anon_sym_AT] = ACTIONS(776),
    [anon_sym_not] = ACTIONS(776),
    [anon_sym_and] = ACTIONS(776),
    [anon_sym_or] = ACTIONS(776),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_PERCENT] = ACTIONS(776),
    [anon_sym_SLASH_SLASH] = ACTIONS(776),
    [anon_sym_STAR_STAR] = ACTIONS(776),
    [anon_sym_PIPE] = ACTIONS(776),
    [anon_sym_AMP] = ACTIONS(776),
    [anon_sym_CARET] = ACTIONS(776),
    [anon_sym_LT_LT] = ACTIONS(776),
    [anon_sym_LT] = ACTIONS(778),
    [anon_sym_LT_EQ] = ACTIONS(776),
    [anon_sym_EQ_EQ] = ACTIONS(776),
    [anon_sym_BANG_EQ] = ACTIONS(776),
    [anon_sym_GT_EQ] = ACTIONS(776),
    [anon_sym_GT] = ACTIONS(778),
    [anon_sym_LT_GT] = ACTIONS(776),
    [anon_sym_is] = ACTIONS(776),
    [anon_sym_LBRACK] = ACTIONS(776),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(776),
    [sym__newline] = ACTIONS(776),
  },
  [596] = {
    [sym_variables] = STATE(1137),
    [sym__primary_expression] = STATE(694),
    [sym_binary_operator] = STATE(694),
    [sym_unary_operator] = STATE(694),
    [sym_attribute] = STATE(694),
    [sym_subscript] = STATE(694),
    [sym_call] = STATE(694),
    [sym_list] = STATE(694),
    [sym_list_comprehension] = STATE(694),
    [sym_dictionary] = STATE(694),
    [sym_dictionary_comprehension] = STATE(694),
    [sym_set] = STATE(694),
    [sym_set_comprehension] = STATE(694),
    [sym_parenthesized_expression] = STATE(694),
    [sym_tuple] = STATE(694),
    [sym_generator_expression] = STATE(694),
    [sym_concatenated_string] = STATE(694),
    [sym_string] = STATE(403),
    [sym_identifier] = ACTIONS(1253),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(1255),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(1253),
    [sym_float] = ACTIONS(1255),
    [sym_true] = ACTIONS(1253),
    [sym_false] = ACTIONS(1253),
    [sym_none] = ACTIONS(1253),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [597] = {
    [anon_sym_DOT] = ACTIONS(812),
    [anon_sym_from] = ACTIONS(812),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_COMMA] = ACTIONS(812),
    [anon_sym_STAR] = ACTIONS(814),
    [anon_sym_GT_GT] = ACTIONS(812),
    [anon_sym_if] = ACTIONS(812),
    [anon_sym_in] = ACTIONS(812),
    [anon_sym_EQ] = ACTIONS(814),
    [anon_sym_AT] = ACTIONS(812),
    [anon_sym_not] = ACTIONS(812),
    [anon_sym_and] = ACTIONS(812),
    [anon_sym_or] = ACTIONS(812),
    [anon_sym_PLUS] = ACTIONS(812),
    [anon_sym_DASH] = ACTIONS(812),
    [anon_sym_SLASH] = ACTIONS(814),
    [anon_sym_PERCENT] = ACTIONS(812),
    [anon_sym_SLASH_SLASH] = ACTIONS(812),
    [anon_sym_STAR_STAR] = ACTIONS(812),
    [anon_sym_PIPE] = ACTIONS(812),
    [anon_sym_AMP] = ACTIONS(812),
    [anon_sym_CARET] = ACTIONS(812),
    [anon_sym_LT_LT] = ACTIONS(812),
    [anon_sym_LT] = ACTIONS(814),
    [anon_sym_LT_EQ] = ACTIONS(812),
    [anon_sym_EQ_EQ] = ACTIONS(812),
    [anon_sym_BANG_EQ] = ACTIONS(812),
    [anon_sym_GT_EQ] = ACTIONS(812),
    [anon_sym_GT] = ACTIONS(814),
    [anon_sym_LT_GT] = ACTIONS(812),
    [anon_sym_is] = ACTIONS(812),
    [anon_sym_LBRACK] = ACTIONS(812),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(812),
    [sym__newline] = ACTIONS(812),
  },
  [598] = {
    [anon_sym_DOT] = ACTIONS(822),
    [anon_sym_from] = ACTIONS(822),
    [anon_sym_LPAREN] = ACTIONS(822),
    [anon_sym_COMMA] = ACTIONS(822),
    [anon_sym_STAR] = ACTIONS(824),
    [anon_sym_GT_GT] = ACTIONS(822),
    [anon_sym_if] = ACTIONS(822),
    [anon_sym_in] = ACTIONS(822),
    [anon_sym_EQ] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(822),
    [anon_sym_not] = ACTIONS(822),
    [anon_sym_and] = ACTIONS(822),
    [anon_sym_or] = ACTIONS(822),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_SLASH] = ACTIONS(824),
    [anon_sym_PERCENT] = ACTIONS(822),
    [anon_sym_SLASH_SLASH] = ACTIONS(822),
    [anon_sym_STAR_STAR] = ACTIONS(822),
    [anon_sym_PIPE] = ACTIONS(822),
    [anon_sym_AMP] = ACTIONS(822),
    [anon_sym_CARET] = ACTIONS(822),
    [anon_sym_LT_LT] = ACTIONS(822),
    [anon_sym_LT] = ACTIONS(824),
    [anon_sym_LT_EQ] = ACTIONS(822),
    [anon_sym_EQ_EQ] = ACTIONS(822),
    [anon_sym_BANG_EQ] = ACTIONS(822),
    [anon_sym_GT_EQ] = ACTIONS(822),
    [anon_sym_GT] = ACTIONS(824),
    [anon_sym_LT_GT] = ACTIONS(822),
    [anon_sym_is] = ACTIONS(822),
    [anon_sym_LBRACK] = ACTIONS(822),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(822),
    [sym__newline] = ACTIONS(822),
  },
  [599] = {
    [anon_sym_DOT] = ACTIONS(758),
    [anon_sym_from] = ACTIONS(758),
    [anon_sym_LPAREN] = ACTIONS(758),
    [anon_sym_COMMA] = ACTIONS(758),
    [anon_sym_STAR] = ACTIONS(760),
    [anon_sym_GT_GT] = ACTIONS(758),
    [anon_sym_if] = ACTIONS(758),
    [anon_sym_in] = ACTIONS(758),
    [anon_sym_EQ] = ACTIONS(760),
    [anon_sym_AT] = ACTIONS(758),
    [anon_sym_not] = ACTIONS(758),
    [anon_sym_and] = ACTIONS(758),
    [anon_sym_or] = ACTIONS(758),
    [anon_sym_PLUS] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(758),
    [anon_sym_SLASH] = ACTIONS(760),
    [anon_sym_PERCENT] = ACTIONS(758),
    [anon_sym_SLASH_SLASH] = ACTIONS(758),
    [anon_sym_STAR_STAR] = ACTIONS(758),
    [anon_sym_PIPE] = ACTIONS(758),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_CARET] = ACTIONS(758),
    [anon_sym_LT_LT] = ACTIONS(758),
    [anon_sym_LT] = ACTIONS(760),
    [anon_sym_LT_EQ] = ACTIONS(758),
    [anon_sym_EQ_EQ] = ACTIONS(758),
    [anon_sym_BANG_EQ] = ACTIONS(758),
    [anon_sym_GT_EQ] = ACTIONS(758),
    [anon_sym_GT] = ACTIONS(760),
    [anon_sym_LT_GT] = ACTIONS(758),
    [anon_sym_is] = ACTIONS(758),
    [anon_sym_LBRACK] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(758),
    [sym__newline] = ACTIONS(758),
  },
  [600] = {
    [anon_sym_DOT] = ACTIONS(682),
    [anon_sym_from] = ACTIONS(682),
    [anon_sym_LPAREN] = ACTIONS(682),
    [anon_sym_COMMA] = ACTIONS(682),
    [anon_sym_STAR] = ACTIONS(684),
    [anon_sym_GT_GT] = ACTIONS(682),
    [anon_sym_if] = ACTIONS(682),
    [anon_sym_in] = ACTIONS(682),
    [anon_sym_EQ] = ACTIONS(684),
    [anon_sym_AT] = ACTIONS(682),
    [anon_sym_not] = ACTIONS(682),
    [anon_sym_and] = ACTIONS(682),
    [anon_sym_or] = ACTIONS(682),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_SLASH] = ACTIONS(684),
    [anon_sym_PERCENT] = ACTIONS(682),
    [anon_sym_SLASH_SLASH] = ACTIONS(682),
    [anon_sym_STAR_STAR] = ACTIONS(682),
    [anon_sym_PIPE] = ACTIONS(682),
    [anon_sym_AMP] = ACTIONS(682),
    [anon_sym_CARET] = ACTIONS(682),
    [anon_sym_LT_LT] = ACTIONS(682),
    [anon_sym_LT] = ACTIONS(684),
    [anon_sym_LT_EQ] = ACTIONS(682),
    [anon_sym_EQ_EQ] = ACTIONS(682),
    [anon_sym_BANG_EQ] = ACTIONS(682),
    [anon_sym_GT_EQ] = ACTIONS(682),
    [anon_sym_GT] = ACTIONS(684),
    [anon_sym_LT_GT] = ACTIONS(682),
    [anon_sym_is] = ACTIONS(682),
    [anon_sym_LBRACK] = ACTIONS(682),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(682),
    [sym__newline] = ACTIONS(682),
  },
  [601] = {
    [sym__primary_expression] = STATE(540),
    [sym_binary_operator] = STATE(540),
    [sym_unary_operator] = STATE(540),
    [sym_attribute] = STATE(540),
    [sym_subscript] = STATE(540),
    [sym_call] = STATE(540),
    [sym_list] = STATE(540),
    [sym_list_comprehension] = STATE(540),
    [sym_dictionary] = STATE(540),
    [sym_dictionary_comprehension] = STATE(540),
    [sym_set] = STATE(540),
    [sym_set_comprehension] = STATE(540),
    [sym_parenthesized_expression] = STATE(540),
    [sym_tuple] = STATE(540),
    [sym_generator_expression] = STATE(540),
    [sym_concatenated_string] = STATE(540),
    [sym_string] = STATE(530),
    [sym_identifier] = ACTIONS(1271),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_print] = ACTIONS(239),
    [anon_sym_exec] = ACTIONS(239),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_PLUS] = ACTIONS(243),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_TILDE] = ACTIONS(243),
    [anon_sym_LBRACK] = ACTIONS(538),
    [sym_ellipsis] = ACTIONS(1275),
    [anon_sym_LBRACE] = ACTIONS(249),
    [sym_integer] = ACTIONS(1271),
    [sym_float] = ACTIONS(1275),
    [sym_true] = ACTIONS(1271),
    [sym_false] = ACTIONS(1271),
    [sym_none] = ACTIONS(1271),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(255),
  },
  [602] = {
    [anon_sym_DOT] = ACTIONS(698),
    [anon_sym_from] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(698),
    [anon_sym_COMMA] = ACTIONS(698),
    [anon_sym_STAR] = ACTIONS(700),
    [anon_sym_GT_GT] = ACTIONS(698),
    [anon_sym_if] = ACTIONS(698),
    [anon_sym_in] = ACTIONS(698),
    [anon_sym_EQ] = ACTIONS(700),
    [anon_sym_AT] = ACTIONS(698),
    [anon_sym_not] = ACTIONS(698),
    [anon_sym_and] = ACTIONS(698),
    [anon_sym_or] = ACTIONS(698),
    [anon_sym_PLUS] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(700),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH_SLASH] = ACTIONS(698),
    [anon_sym_STAR_STAR] = ACTIONS(698),
    [anon_sym_PIPE] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_CARET] = ACTIONS(698),
    [anon_sym_LT_LT] = ACTIONS(698),
    [anon_sym_LT] = ACTIONS(700),
    [anon_sym_LT_EQ] = ACTIONS(698),
    [anon_sym_EQ_EQ] = ACTIONS(698),
    [anon_sym_BANG_EQ] = ACTIONS(698),
    [anon_sym_GT_EQ] = ACTIONS(698),
    [anon_sym_GT] = ACTIONS(700),
    [anon_sym_LT_GT] = ACTIONS(698),
    [anon_sym_is] = ACTIONS(698),
    [anon_sym_LBRACK] = ACTIONS(698),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(698),
    [sym__newline] = ACTIONS(698),
  },
  [603] = {
    [sym_variables] = STATE(1157),
    [sym__primary_expression] = STATE(694),
    [sym_binary_operator] = STATE(694),
    [sym_unary_operator] = STATE(694),
    [sym_attribute] = STATE(694),
    [sym_subscript] = STATE(694),
    [sym_call] = STATE(694),
    [sym_list] = STATE(694),
    [sym_list_comprehension] = STATE(694),
    [sym_dictionary] = STATE(694),
    [sym_dictionary_comprehension] = STATE(694),
    [sym_set] = STATE(694),
    [sym_set_comprehension] = STATE(694),
    [sym_parenthesized_expression] = STATE(694),
    [sym_tuple] = STATE(694),
    [sym_generator_expression] = STATE(694),
    [sym_concatenated_string] = STATE(694),
    [sym_string] = STATE(403),
    [sym_identifier] = ACTIONS(1253),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(1255),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(1253),
    [sym_float] = ACTIONS(1255),
    [sym_true] = ACTIONS(1253),
    [sym_false] = ACTIONS(1253),
    [sym_none] = ACTIONS(1253),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [604] = {
    [anon_sym_DOT] = ACTIONS(770),
    [anon_sym_from] = ACTIONS(770),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_COMMA] = ACTIONS(770),
    [anon_sym_STAR] = ACTIONS(772),
    [anon_sym_GT_GT] = ACTIONS(770),
    [anon_sym_if] = ACTIONS(770),
    [anon_sym_in] = ACTIONS(770),
    [anon_sym_EQ] = ACTIONS(772),
    [anon_sym_AT] = ACTIONS(770),
    [anon_sym_not] = ACTIONS(770),
    [anon_sym_and] = ACTIONS(770),
    [anon_sym_or] = ACTIONS(770),
    [anon_sym_PLUS] = ACTIONS(770),
    [anon_sym_DASH] = ACTIONS(770),
    [anon_sym_SLASH] = ACTIONS(772),
    [anon_sym_PERCENT] = ACTIONS(770),
    [anon_sym_SLASH_SLASH] = ACTIONS(770),
    [anon_sym_STAR_STAR] = ACTIONS(770),
    [anon_sym_PIPE] = ACTIONS(770),
    [anon_sym_AMP] = ACTIONS(770),
    [anon_sym_CARET] = ACTIONS(770),
    [anon_sym_LT_LT] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(772),
    [anon_sym_LT_EQ] = ACTIONS(770),
    [anon_sym_EQ_EQ] = ACTIONS(770),
    [anon_sym_BANG_EQ] = ACTIONS(770),
    [anon_sym_GT_EQ] = ACTIONS(770),
    [anon_sym_GT] = ACTIONS(772),
    [anon_sym_LT_GT] = ACTIONS(770),
    [anon_sym_is] = ACTIONS(770),
    [anon_sym_LBRACK] = ACTIONS(770),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(770),
    [sym__newline] = ACTIONS(770),
  },
  [605] = {
    [sym__primary_expression] = STATE(121),
    [sym_binary_operator] = STATE(121),
    [sym_unary_operator] = STATE(121),
    [sym_attribute] = STATE(121),
    [sym_subscript] = STATE(121),
    [sym_call] = STATE(121),
    [sym_list] = STATE(121),
    [sym_list_comprehension] = STATE(121),
    [sym_dictionary] = STATE(121),
    [sym_dictionary_comprehension] = STATE(121),
    [sym_set] = STATE(121),
    [sym_set_comprehension] = STATE(121),
    [sym_parenthesized_expression] = STATE(121),
    [sym_tuple] = STATE(121),
    [sym_generator_expression] = STATE(121),
    [sym_concatenated_string] = STATE(121),
    [sym_string] = STATE(113),
    [sym_identifier] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(349),
    [anon_sym_exec] = ACTIONS(349),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(1279),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(1277),
    [sym_float] = ACTIONS(1279),
    [sym_true] = ACTIONS(1277),
    [sym_false] = ACTIONS(1277),
    [sym_none] = ACTIONS(1277),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [606] = {
    [sym__primary_expression] = STATE(538),
    [sym_binary_operator] = STATE(538),
    [sym_unary_operator] = STATE(538),
    [sym_attribute] = STATE(538),
    [sym_subscript] = STATE(538),
    [sym_call] = STATE(538),
    [sym_list] = STATE(538),
    [sym_list_comprehension] = STATE(538),
    [sym_dictionary] = STATE(538),
    [sym_dictionary_comprehension] = STATE(538),
    [sym_set] = STATE(538),
    [sym_set_comprehension] = STATE(538),
    [sym_parenthesized_expression] = STATE(538),
    [sym_tuple] = STATE(538),
    [sym_generator_expression] = STATE(538),
    [sym_concatenated_string] = STATE(538),
    [sym_string] = STATE(530),
    [sym_identifier] = ACTIONS(1281),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_print] = ACTIONS(239),
    [anon_sym_exec] = ACTIONS(239),
    [anon_sym_PLUS] = ACTIONS(243),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_TILDE] = ACTIONS(243),
    [anon_sym_LBRACK] = ACTIONS(538),
    [sym_ellipsis] = ACTIONS(1283),
    [anon_sym_LBRACE] = ACTIONS(249),
    [sym_integer] = ACTIONS(1281),
    [sym_float] = ACTIONS(1283),
    [sym_true] = ACTIONS(1281),
    [sym_false] = ACTIONS(1281),
    [sym_none] = ACTIONS(1281),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(255),
  },
  [607] = {
    [sym__primary_expression] = STATE(135),
    [sym_binary_operator] = STATE(135),
    [sym_unary_operator] = STATE(135),
    [sym_attribute] = STATE(135),
    [sym_subscript] = STATE(135),
    [sym_call] = STATE(135),
    [sym_list] = STATE(135),
    [sym_list_comprehension] = STATE(135),
    [sym_dictionary] = STATE(135),
    [sym_dictionary_comprehension] = STATE(135),
    [sym_set] = STATE(135),
    [sym_set_comprehension] = STATE(135),
    [sym_parenthesized_expression] = STATE(135),
    [sym_tuple] = STATE(135),
    [sym_generator_expression] = STATE(135),
    [sym_concatenated_string] = STATE(135),
    [sym_string] = STATE(113),
    [sym_identifier] = ACTIONS(1285),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(349),
    [anon_sym_exec] = ACTIONS(349),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(1287),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(1285),
    [sym_float] = ACTIONS(1287),
    [sym_true] = ACTIONS(1285),
    [sym_false] = ACTIONS(1285),
    [sym_none] = ACTIONS(1285),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [608] = {
    [anon_sym_DOT] = ACTIONS(440),
    [anon_sym_LPAREN] = ACTIONS(440),
    [anon_sym_COMMA] = ACTIONS(440),
    [anon_sym_as] = ACTIONS(440),
    [anon_sym_STAR] = ACTIONS(442),
    [anon_sym_GT_GT] = ACTIONS(440),
    [anon_sym_COLON_EQ] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(440),
    [anon_sym_COLON] = ACTIONS(442),
    [anon_sym_in] = ACTIONS(440),
    [anon_sym_AT] = ACTIONS(440),
    [anon_sym_not] = ACTIONS(440),
    [anon_sym_and] = ACTIONS(440),
    [anon_sym_or] = ACTIONS(440),
    [anon_sym_PLUS] = ACTIONS(440),
    [anon_sym_DASH] = ACTIONS(440),
    [anon_sym_SLASH] = ACTIONS(442),
    [anon_sym_PERCENT] = ACTIONS(440),
    [anon_sym_SLASH_SLASH] = ACTIONS(440),
    [anon_sym_STAR_STAR] = ACTIONS(440),
    [anon_sym_PIPE] = ACTIONS(440),
    [anon_sym_AMP] = ACTIONS(440),
    [anon_sym_CARET] = ACTIONS(440),
    [anon_sym_LT_LT] = ACTIONS(440),
    [anon_sym_LT] = ACTIONS(442),
    [anon_sym_LT_EQ] = ACTIONS(440),
    [anon_sym_EQ_EQ] = ACTIONS(440),
    [anon_sym_BANG_EQ] = ACTIONS(440),
    [anon_sym_GT_EQ] = ACTIONS(440),
    [anon_sym_GT] = ACTIONS(442),
    [anon_sym_LT_GT] = ACTIONS(440),
    [anon_sym_is] = ACTIONS(440),
    [anon_sym_LBRACK] = ACTIONS(440),
    [sym_comment] = ACTIONS(3),
  },
  [609] = {
    [sym__primary_expression] = STATE(533),
    [sym_binary_operator] = STATE(533),
    [sym_unary_operator] = STATE(533),
    [sym_attribute] = STATE(533),
    [sym_subscript] = STATE(533),
    [sym_call] = STATE(533),
    [sym_list] = STATE(533),
    [sym_list_comprehension] = STATE(533),
    [sym_dictionary] = STATE(533),
    [sym_dictionary_comprehension] = STATE(533),
    [sym_set] = STATE(533),
    [sym_set_comprehension] = STATE(533),
    [sym_parenthesized_expression] = STATE(533),
    [sym_tuple] = STATE(533),
    [sym_generator_expression] = STATE(533),
    [sym_concatenated_string] = STATE(533),
    [sym_string] = STATE(530),
    [sym_identifier] = ACTIONS(1291),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_print] = ACTIONS(239),
    [anon_sym_exec] = ACTIONS(239),
    [anon_sym_PLUS] = ACTIONS(243),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_TILDE] = ACTIONS(243),
    [anon_sym_LBRACK] = ACTIONS(538),
    [sym_ellipsis] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(249),
    [sym_integer] = ACTIONS(1291),
    [sym_float] = ACTIONS(1293),
    [sym_true] = ACTIONS(1291),
    [sym_false] = ACTIONS(1291),
    [sym_none] = ACTIONS(1291),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(255),
  },
  [610] = {
    [sym__primary_expression] = STATE(539),
    [sym_binary_operator] = STATE(539),
    [sym_unary_operator] = STATE(539),
    [sym_attribute] = STATE(539),
    [sym_subscript] = STATE(539),
    [sym_call] = STATE(539),
    [sym_list] = STATE(539),
    [sym_list_comprehension] = STATE(539),
    [sym_dictionary] = STATE(539),
    [sym_dictionary_comprehension] = STATE(539),
    [sym_set] = STATE(539),
    [sym_set_comprehension] = STATE(539),
    [sym_parenthesized_expression] = STATE(539),
    [sym_tuple] = STATE(539),
    [sym_generator_expression] = STATE(539),
    [sym_concatenated_string] = STATE(539),
    [sym_string] = STATE(530),
    [sym_identifier] = ACTIONS(1295),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_print] = ACTIONS(239),
    [anon_sym_exec] = ACTIONS(239),
    [anon_sym_PLUS] = ACTIONS(243),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_TILDE] = ACTIONS(243),
    [anon_sym_LBRACK] = ACTIONS(538),
    [sym_ellipsis] = ACTIONS(1297),
    [anon_sym_LBRACE] = ACTIONS(249),
    [sym_integer] = ACTIONS(1295),
    [sym_float] = ACTIONS(1297),
    [sym_true] = ACTIONS(1295),
    [sym_false] = ACTIONS(1295),
    [sym_none] = ACTIONS(1295),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(255),
  },
  [611] = {
    [sym__primary_expression] = STATE(128),
    [sym_binary_operator] = STATE(128),
    [sym_unary_operator] = STATE(128),
    [sym_attribute] = STATE(128),
    [sym_subscript] = STATE(128),
    [sym_call] = STATE(128),
    [sym_list] = STATE(128),
    [sym_list_comprehension] = STATE(128),
    [sym_dictionary] = STATE(128),
    [sym_dictionary_comprehension] = STATE(128),
    [sym_set] = STATE(128),
    [sym_set_comprehension] = STATE(128),
    [sym_parenthesized_expression] = STATE(128),
    [sym_tuple] = STATE(128),
    [sym_generator_expression] = STATE(128),
    [sym_concatenated_string] = STATE(128),
    [sym_string] = STATE(113),
    [sym_identifier] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(349),
    [anon_sym_exec] = ACTIONS(349),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(1301),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(1299),
    [sym_float] = ACTIONS(1301),
    [sym_true] = ACTIONS(1299),
    [sym_false] = ACTIONS(1299),
    [sym_none] = ACTIONS(1299),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [612] = {
    [sym__primary_expression] = STATE(541),
    [sym_binary_operator] = STATE(541),
    [sym_unary_operator] = STATE(541),
    [sym_attribute] = STATE(541),
    [sym_subscript] = STATE(541),
    [sym_call] = STATE(541),
    [sym_list] = STATE(541),
    [sym_list_comprehension] = STATE(541),
    [sym_dictionary] = STATE(541),
    [sym_dictionary_comprehension] = STATE(541),
    [sym_set] = STATE(541),
    [sym_set_comprehension] = STATE(541),
    [sym_parenthesized_expression] = STATE(541),
    [sym_tuple] = STATE(541),
    [sym_generator_expression] = STATE(541),
    [sym_concatenated_string] = STATE(541),
    [sym_string] = STATE(530),
    [sym_identifier] = ACTIONS(1303),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_print] = ACTIONS(239),
    [anon_sym_exec] = ACTIONS(239),
    [anon_sym_PLUS] = ACTIONS(243),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_TILDE] = ACTIONS(243),
    [anon_sym_LBRACK] = ACTIONS(538),
    [sym_ellipsis] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(249),
    [sym_integer] = ACTIONS(1303),
    [sym_float] = ACTIONS(1305),
    [sym_true] = ACTIONS(1303),
    [sym_false] = ACTIONS(1303),
    [sym_none] = ACTIONS(1303),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(255),
  },
  [613] = {
    [sym__primary_expression] = STATE(127),
    [sym_binary_operator] = STATE(127),
    [sym_unary_operator] = STATE(127),
    [sym_attribute] = STATE(127),
    [sym_subscript] = STATE(127),
    [sym_call] = STATE(127),
    [sym_list] = STATE(127),
    [sym_list_comprehension] = STATE(127),
    [sym_dictionary] = STATE(127),
    [sym_dictionary_comprehension] = STATE(127),
    [sym_set] = STATE(127),
    [sym_set_comprehension] = STATE(127),
    [sym_parenthesized_expression] = STATE(127),
    [sym_tuple] = STATE(127),
    [sym_generator_expression] = STATE(127),
    [sym_concatenated_string] = STATE(127),
    [sym_string] = STATE(113),
    [sym_identifier] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(349),
    [anon_sym_exec] = ACTIONS(349),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(1249),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(1245),
    [sym_float] = ACTIONS(1249),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_none] = ACTIONS(1245),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [614] = {
    [sym__primary_expression] = STATE(534),
    [sym_binary_operator] = STATE(534),
    [sym_unary_operator] = STATE(534),
    [sym_attribute] = STATE(534),
    [sym_subscript] = STATE(534),
    [sym_call] = STATE(534),
    [sym_list] = STATE(534),
    [sym_list_comprehension] = STATE(534),
    [sym_dictionary] = STATE(534),
    [sym_dictionary_comprehension] = STATE(534),
    [sym_set] = STATE(534),
    [sym_set_comprehension] = STATE(534),
    [sym_parenthesized_expression] = STATE(534),
    [sym_tuple] = STATE(534),
    [sym_generator_expression] = STATE(534),
    [sym_concatenated_string] = STATE(534),
    [sym_string] = STATE(530),
    [sym_identifier] = ACTIONS(1307),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_print] = ACTIONS(239),
    [anon_sym_exec] = ACTIONS(239),
    [anon_sym_PLUS] = ACTIONS(243),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_TILDE] = ACTIONS(243),
    [anon_sym_LBRACK] = ACTIONS(538),
    [sym_ellipsis] = ACTIONS(1309),
    [anon_sym_LBRACE] = ACTIONS(249),
    [sym_integer] = ACTIONS(1307),
    [sym_float] = ACTIONS(1309),
    [sym_true] = ACTIONS(1307),
    [sym_false] = ACTIONS(1307),
    [sym_none] = ACTIONS(1307),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(255),
  },
  [615] = {
    [sym__primary_expression] = STATE(124),
    [sym_binary_operator] = STATE(124),
    [sym_unary_operator] = STATE(124),
    [sym_attribute] = STATE(124),
    [sym_subscript] = STATE(124),
    [sym_call] = STATE(124),
    [sym_list] = STATE(124),
    [sym_list_comprehension] = STATE(124),
    [sym_dictionary] = STATE(124),
    [sym_dictionary_comprehension] = STATE(124),
    [sym_set] = STATE(124),
    [sym_set_comprehension] = STATE(124),
    [sym_parenthesized_expression] = STATE(124),
    [sym_tuple] = STATE(124),
    [sym_generator_expression] = STATE(124),
    [sym_concatenated_string] = STATE(124),
    [sym_string] = STATE(113),
    [sym_identifier] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(349),
    [anon_sym_exec] = ACTIONS(349),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(1311),
    [sym_float] = ACTIONS(1313),
    [sym_true] = ACTIONS(1311),
    [sym_false] = ACTIONS(1311),
    [sym_none] = ACTIONS(1311),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [616] = {
    [sym__primary_expression] = STATE(134),
    [sym_binary_operator] = STATE(134),
    [sym_unary_operator] = STATE(134),
    [sym_attribute] = STATE(134),
    [sym_subscript] = STATE(134),
    [sym_call] = STATE(134),
    [sym_list] = STATE(134),
    [sym_list_comprehension] = STATE(134),
    [sym_dictionary] = STATE(134),
    [sym_dictionary_comprehension] = STATE(134),
    [sym_set] = STATE(134),
    [sym_set_comprehension] = STATE(134),
    [sym_parenthesized_expression] = STATE(134),
    [sym_tuple] = STATE(134),
    [sym_generator_expression] = STATE(134),
    [sym_concatenated_string] = STATE(134),
    [sym_string] = STATE(113),
    [sym_identifier] = ACTIONS(1315),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(349),
    [anon_sym_exec] = ACTIONS(349),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(1317),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(1315),
    [sym_float] = ACTIONS(1317),
    [sym_true] = ACTIONS(1315),
    [sym_false] = ACTIONS(1315),
    [sym_none] = ACTIONS(1315),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [617] = {
    [sym__primary_expression] = STATE(537),
    [sym_binary_operator] = STATE(537),
    [sym_unary_operator] = STATE(537),
    [sym_attribute] = STATE(537),
    [sym_subscript] = STATE(537),
    [sym_call] = STATE(537),
    [sym_list] = STATE(537),
    [sym_list_comprehension] = STATE(537),
    [sym_dictionary] = STATE(537),
    [sym_dictionary_comprehension] = STATE(537),
    [sym_set] = STATE(537),
    [sym_set_comprehension] = STATE(537),
    [sym_parenthesized_expression] = STATE(537),
    [sym_tuple] = STATE(537),
    [sym_generator_expression] = STATE(537),
    [sym_concatenated_string] = STATE(537),
    [sym_string] = STATE(530),
    [sym_identifier] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_print] = ACTIONS(239),
    [anon_sym_exec] = ACTIONS(239),
    [anon_sym_PLUS] = ACTIONS(243),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_TILDE] = ACTIONS(243),
    [anon_sym_LBRACK] = ACTIONS(538),
    [sym_ellipsis] = ACTIONS(1321),
    [anon_sym_LBRACE] = ACTIONS(249),
    [sym_integer] = ACTIONS(1319),
    [sym_float] = ACTIONS(1321),
    [sym_true] = ACTIONS(1319),
    [sym_false] = ACTIONS(1319),
    [sym_none] = ACTIONS(1319),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(255),
  },
  [618] = {
    [sym__primary_expression] = STATE(540),
    [sym_binary_operator] = STATE(540),
    [sym_unary_operator] = STATE(540),
    [sym_attribute] = STATE(540),
    [sym_subscript] = STATE(540),
    [sym_call] = STATE(540),
    [sym_list] = STATE(540),
    [sym_list_comprehension] = STATE(540),
    [sym_dictionary] = STATE(540),
    [sym_dictionary_comprehension] = STATE(540),
    [sym_set] = STATE(540),
    [sym_set_comprehension] = STATE(540),
    [sym_parenthesized_expression] = STATE(540),
    [sym_tuple] = STATE(540),
    [sym_generator_expression] = STATE(540),
    [sym_concatenated_string] = STATE(540),
    [sym_string] = STATE(530),
    [sym_identifier] = ACTIONS(1271),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_print] = ACTIONS(239),
    [anon_sym_exec] = ACTIONS(239),
    [anon_sym_PLUS] = ACTIONS(243),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_TILDE] = ACTIONS(243),
    [anon_sym_LBRACK] = ACTIONS(538),
    [sym_ellipsis] = ACTIONS(1275),
    [anon_sym_LBRACE] = ACTIONS(249),
    [sym_integer] = ACTIONS(1271),
    [sym_float] = ACTIONS(1275),
    [sym_true] = ACTIONS(1271),
    [sym_false] = ACTIONS(1271),
    [sym_none] = ACTIONS(1271),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(255),
  },
  [619] = {
    [sym__primary_expression] = STATE(542),
    [sym_binary_operator] = STATE(542),
    [sym_unary_operator] = STATE(542),
    [sym_attribute] = STATE(542),
    [sym_subscript] = STATE(542),
    [sym_call] = STATE(542),
    [sym_list] = STATE(542),
    [sym_list_comprehension] = STATE(542),
    [sym_dictionary] = STATE(542),
    [sym_dictionary_comprehension] = STATE(542),
    [sym_set] = STATE(542),
    [sym_set_comprehension] = STATE(542),
    [sym_parenthesized_expression] = STATE(542),
    [sym_tuple] = STATE(542),
    [sym_generator_expression] = STATE(542),
    [sym_concatenated_string] = STATE(542),
    [sym_string] = STATE(530),
    [sym_identifier] = ACTIONS(1323),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_print] = ACTIONS(239),
    [anon_sym_exec] = ACTIONS(239),
    [anon_sym_PLUS] = ACTIONS(243),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_TILDE] = ACTIONS(243),
    [anon_sym_LBRACK] = ACTIONS(538),
    [sym_ellipsis] = ACTIONS(1325),
    [anon_sym_LBRACE] = ACTIONS(249),
    [sym_integer] = ACTIONS(1323),
    [sym_float] = ACTIONS(1325),
    [sym_true] = ACTIONS(1323),
    [sym_false] = ACTIONS(1323),
    [sym_none] = ACTIONS(1323),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(255),
  },
  [620] = {
    [sym__primary_expression] = STATE(418),
    [sym_binary_operator] = STATE(418),
    [sym_unary_operator] = STATE(418),
    [sym_attribute] = STATE(418),
    [sym_subscript] = STATE(418),
    [sym_call] = STATE(418),
    [sym_list] = STATE(418),
    [sym_list_comprehension] = STATE(418),
    [sym_dictionary] = STATE(418),
    [sym_dictionary_comprehension] = STATE(418),
    [sym_set] = STATE(418),
    [sym_set_comprehension] = STATE(418),
    [sym_parenthesized_expression] = STATE(418),
    [sym_tuple] = STATE(418),
    [sym_generator_expression] = STATE(418),
    [sym_concatenated_string] = STATE(418),
    [sym_string] = STATE(403),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(1327),
    [sym_float] = ACTIONS(1329),
    [sym_true] = ACTIONS(1327),
    [sym_false] = ACTIONS(1327),
    [sym_none] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [621] = {
    [sym__primary_expression] = STATE(126),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(113),
    [sym_identifier] = ACTIONS(1331),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(349),
    [anon_sym_exec] = ACTIONS(349),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(1333),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(1331),
    [sym_float] = ACTIONS(1333),
    [sym_true] = ACTIONS(1331),
    [sym_false] = ACTIONS(1331),
    [sym_none] = ACTIONS(1331),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [622] = {
    [anon_sym_DOT] = ACTIONS(578),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(578),
    [anon_sym_as] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(580),
    [anon_sym_GT_GT] = ACTIONS(578),
    [anon_sym_if] = ACTIONS(578),
    [anon_sym_COLON] = ACTIONS(578),
    [anon_sym_in] = ACTIONS(578),
    [anon_sym_AT] = ACTIONS(578),
    [anon_sym_not] = ACTIONS(578),
    [anon_sym_and] = ACTIONS(578),
    [anon_sym_or] = ACTIONS(578),
    [anon_sym_PLUS] = ACTIONS(578),
    [anon_sym_DASH] = ACTIONS(578),
    [anon_sym_SLASH] = ACTIONS(580),
    [anon_sym_PERCENT] = ACTIONS(578),
    [anon_sym_SLASH_SLASH] = ACTIONS(578),
    [anon_sym_STAR_STAR] = ACTIONS(578),
    [anon_sym_PIPE] = ACTIONS(578),
    [anon_sym_AMP] = ACTIONS(578),
    [anon_sym_CARET] = ACTIONS(578),
    [anon_sym_LT_LT] = ACTIONS(578),
    [anon_sym_LT] = ACTIONS(580),
    [anon_sym_LT_EQ] = ACTIONS(578),
    [anon_sym_EQ_EQ] = ACTIONS(578),
    [anon_sym_BANG_EQ] = ACTIONS(578),
    [anon_sym_GT_EQ] = ACTIONS(578),
    [anon_sym_GT] = ACTIONS(580),
    [anon_sym_LT_GT] = ACTIONS(578),
    [anon_sym_is] = ACTIONS(578),
    [anon_sym_LBRACK] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(578),
  },
  [623] = {
    [sym__primary_expression] = STATE(453),
    [sym_binary_operator] = STATE(453),
    [sym_unary_operator] = STATE(453),
    [sym_attribute] = STATE(453),
    [sym_subscript] = STATE(453),
    [sym_call] = STATE(453),
    [sym_list] = STATE(453),
    [sym_list_comprehension] = STATE(453),
    [sym_dictionary] = STATE(453),
    [sym_dictionary_comprehension] = STATE(453),
    [sym_set] = STATE(453),
    [sym_set_comprehension] = STATE(453),
    [sym_parenthesized_expression] = STATE(453),
    [sym_tuple] = STATE(453),
    [sym_generator_expression] = STATE(453),
    [sym_concatenated_string] = STATE(453),
    [sym_string] = STATE(403),
    [sym_identifier] = ACTIONS(1335),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(1337),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(1335),
    [sym_float] = ACTIONS(1337),
    [sym_true] = ACTIONS(1335),
    [sym_false] = ACTIONS(1335),
    [sym_none] = ACTIONS(1335),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [624] = {
    [sym__primary_expression] = STATE(564),
    [sym_binary_operator] = STATE(564),
    [sym_unary_operator] = STATE(564),
    [sym_attribute] = STATE(564),
    [sym_subscript] = STATE(564),
    [sym_call] = STATE(564),
    [sym_list] = STATE(564),
    [sym_list_comprehension] = STATE(564),
    [sym_dictionary] = STATE(564),
    [sym_dictionary_comprehension] = STATE(564),
    [sym_set] = STATE(564),
    [sym_set_comprehension] = STATE(564),
    [sym_parenthesized_expression] = STATE(564),
    [sym_tuple] = STATE(564),
    [sym_generator_expression] = STATE(564),
    [sym_concatenated_string] = STATE(564),
    [sym_string] = STATE(543),
    [sym_identifier] = ACTIONS(1339),
    [anon_sym_LPAREN] = ACTIONS(870),
    [anon_sym_print] = ACTIONS(872),
    [anon_sym_exec] = ACTIONS(872),
    [anon_sym_PLUS] = ACTIONS(876),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_TILDE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(880),
    [sym_ellipsis] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(884),
    [sym_integer] = ACTIONS(1339),
    [sym_float] = ACTIONS(1341),
    [sym_true] = ACTIONS(1339),
    [sym_false] = ACTIONS(1339),
    [sym_none] = ACTIONS(1339),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(890),
  },
  [625] = {
    [sym__primary_expression] = STATE(129),
    [sym_binary_operator] = STATE(129),
    [sym_unary_operator] = STATE(129),
    [sym_attribute] = STATE(129),
    [sym_subscript] = STATE(129),
    [sym_call] = STATE(129),
    [sym_list] = STATE(129),
    [sym_list_comprehension] = STATE(129),
    [sym_dictionary] = STATE(129),
    [sym_dictionary_comprehension] = STATE(129),
    [sym_set] = STATE(129),
    [sym_set_comprehension] = STATE(129),
    [sym_parenthesized_expression] = STATE(129),
    [sym_tuple] = STATE(129),
    [sym_generator_expression] = STATE(129),
    [sym_concatenated_string] = STATE(129),
    [sym_string] = STATE(113),
    [sym_identifier] = ACTIONS(1343),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(349),
    [anon_sym_exec] = ACTIONS(349),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(1345),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(1343),
    [sym_float] = ACTIONS(1345),
    [sym_true] = ACTIONS(1343),
    [sym_false] = ACTIONS(1343),
    [sym_none] = ACTIONS(1343),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [626] = {
    [sym__primary_expression] = STATE(130),
    [sym_binary_operator] = STATE(130),
    [sym_unary_operator] = STATE(130),
    [sym_attribute] = STATE(130),
    [sym_subscript] = STATE(130),
    [sym_call] = STATE(130),
    [sym_list] = STATE(130),
    [sym_list_comprehension] = STATE(130),
    [sym_dictionary] = STATE(130),
    [sym_dictionary_comprehension] = STATE(130),
    [sym_set] = STATE(130),
    [sym_set_comprehension] = STATE(130),
    [sym_parenthesized_expression] = STATE(130),
    [sym_tuple] = STATE(130),
    [sym_generator_expression] = STATE(130),
    [sym_concatenated_string] = STATE(130),
    [sym_string] = STATE(113),
    [sym_identifier] = ACTIONS(1347),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(349),
    [anon_sym_exec] = ACTIONS(349),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(1349),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(1347),
    [sym_float] = ACTIONS(1349),
    [sym_true] = ACTIONS(1347),
    [sym_false] = ACTIONS(1347),
    [sym_none] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [627] = {
    [sym__primary_expression] = STATE(575),
    [sym_binary_operator] = STATE(575),
    [sym_unary_operator] = STATE(575),
    [sym_attribute] = STATE(575),
    [sym_subscript] = STATE(575),
    [sym_call] = STATE(575),
    [sym_list] = STATE(575),
    [sym_list_comprehension] = STATE(575),
    [sym_dictionary] = STATE(575),
    [sym_dictionary_comprehension] = STATE(575),
    [sym_set] = STATE(575),
    [sym_set_comprehension] = STATE(575),
    [sym_parenthesized_expression] = STATE(575),
    [sym_tuple] = STATE(575),
    [sym_generator_expression] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string] = STATE(543),
    [sym_identifier] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(870),
    [anon_sym_print] = ACTIONS(872),
    [anon_sym_exec] = ACTIONS(872),
    [anon_sym_PLUS] = ACTIONS(876),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_TILDE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(880),
    [sym_ellipsis] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(884),
    [sym_integer] = ACTIONS(1351),
    [sym_float] = ACTIONS(1353),
    [sym_true] = ACTIONS(1351),
    [sym_false] = ACTIONS(1351),
    [sym_none] = ACTIONS(1351),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(890),
  },
  [628] = {
    [sym__primary_expression] = STATE(536),
    [sym_binary_operator] = STATE(536),
    [sym_unary_operator] = STATE(536),
    [sym_attribute] = STATE(536),
    [sym_subscript] = STATE(536),
    [sym_call] = STATE(536),
    [sym_list] = STATE(536),
    [sym_list_comprehension] = STATE(536),
    [sym_dictionary] = STATE(536),
    [sym_dictionary_comprehension] = STATE(536),
    [sym_set] = STATE(536),
    [sym_set_comprehension] = STATE(536),
    [sym_parenthesized_expression] = STATE(536),
    [sym_tuple] = STATE(536),
    [sym_generator_expression] = STATE(536),
    [sym_concatenated_string] = STATE(536),
    [sym_string] = STATE(530),
    [sym_identifier] = ACTIONS(1355),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_print] = ACTIONS(239),
    [anon_sym_exec] = ACTIONS(239),
    [anon_sym_PLUS] = ACTIONS(243),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_TILDE] = ACTIONS(243),
    [anon_sym_LBRACK] = ACTIONS(538),
    [sym_ellipsis] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(249),
    [sym_integer] = ACTIONS(1355),
    [sym_float] = ACTIONS(1357),
    [sym_true] = ACTIONS(1355),
    [sym_false] = ACTIONS(1355),
    [sym_none] = ACTIONS(1355),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(255),
  },
  [629] = {
    [sym__primary_expression] = STATE(422),
    [sym_binary_operator] = STATE(422),
    [sym_unary_operator] = STATE(422),
    [sym_attribute] = STATE(422),
    [sym_subscript] = STATE(422),
    [sym_call] = STATE(422),
    [sym_list] = STATE(422),
    [sym_list_comprehension] = STATE(422),
    [sym_dictionary] = STATE(422),
    [sym_dictionary_comprehension] = STATE(422),
    [sym_set] = STATE(422),
    [sym_set_comprehension] = STATE(422),
    [sym_parenthesized_expression] = STATE(422),
    [sym_tuple] = STATE(422),
    [sym_generator_expression] = STATE(422),
    [sym_concatenated_string] = STATE(422),
    [sym_string] = STATE(403),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(1361),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(1359),
    [sym_float] = ACTIONS(1361),
    [sym_true] = ACTIONS(1359),
    [sym_false] = ACTIONS(1359),
    [sym_none] = ACTIONS(1359),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [630] = {
    [sym__primary_expression] = STATE(427),
    [sym_binary_operator] = STATE(427),
    [sym_unary_operator] = STATE(427),
    [sym_attribute] = STATE(427),
    [sym_subscript] = STATE(427),
    [sym_call] = STATE(427),
    [sym_list] = STATE(427),
    [sym_list_comprehension] = STATE(427),
    [sym_dictionary] = STATE(427),
    [sym_dictionary_comprehension] = STATE(427),
    [sym_set] = STATE(427),
    [sym_set_comprehension] = STATE(427),
    [sym_parenthesized_expression] = STATE(427),
    [sym_tuple] = STATE(427),
    [sym_generator_expression] = STATE(427),
    [sym_concatenated_string] = STATE(427),
    [sym_string] = STATE(403),
    [sym_identifier] = ACTIONS(1363),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(1365),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(1363),
    [sym_float] = ACTIONS(1365),
    [sym_true] = ACTIONS(1363),
    [sym_false] = ACTIONS(1363),
    [sym_none] = ACTIONS(1363),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [631] = {
    [sym__primary_expression] = STATE(563),
    [sym_binary_operator] = STATE(563),
    [sym_unary_operator] = STATE(563),
    [sym_attribute] = STATE(563),
    [sym_subscript] = STATE(563),
    [sym_call] = STATE(563),
    [sym_list] = STATE(563),
    [sym_list_comprehension] = STATE(563),
    [sym_dictionary] = STATE(563),
    [sym_dictionary_comprehension] = STATE(563),
    [sym_set] = STATE(563),
    [sym_set_comprehension] = STATE(563),
    [sym_parenthesized_expression] = STATE(563),
    [sym_tuple] = STATE(563),
    [sym_generator_expression] = STATE(563),
    [sym_concatenated_string] = STATE(563),
    [sym_string] = STATE(543),
    [sym_identifier] = ACTIONS(1367),
    [anon_sym_LPAREN] = ACTIONS(870),
    [anon_sym_print] = ACTIONS(872),
    [anon_sym_exec] = ACTIONS(872),
    [anon_sym_PLUS] = ACTIONS(876),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_TILDE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(880),
    [sym_ellipsis] = ACTIONS(1369),
    [anon_sym_LBRACE] = ACTIONS(884),
    [sym_integer] = ACTIONS(1367),
    [sym_float] = ACTIONS(1369),
    [sym_true] = ACTIONS(1367),
    [sym_false] = ACTIONS(1367),
    [sym_none] = ACTIONS(1367),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(890),
  },
  [632] = {
    [sym__primary_expression] = STATE(428),
    [sym_binary_operator] = STATE(428),
    [sym_unary_operator] = STATE(428),
    [sym_attribute] = STATE(428),
    [sym_subscript] = STATE(428),
    [sym_call] = STATE(428),
    [sym_list] = STATE(428),
    [sym_list_comprehension] = STATE(428),
    [sym_dictionary] = STATE(428),
    [sym_dictionary_comprehension] = STATE(428),
    [sym_set] = STATE(428),
    [sym_set_comprehension] = STATE(428),
    [sym_parenthesized_expression] = STATE(428),
    [sym_tuple] = STATE(428),
    [sym_generator_expression] = STATE(428),
    [sym_concatenated_string] = STATE(428),
    [sym_string] = STATE(403),
    [sym_identifier] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(1373),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(1371),
    [sym_float] = ACTIONS(1373),
    [sym_true] = ACTIONS(1371),
    [sym_false] = ACTIONS(1371),
    [sym_none] = ACTIONS(1371),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [633] = {
    [sym__primary_expression] = STATE(429),
    [sym_binary_operator] = STATE(429),
    [sym_unary_operator] = STATE(429),
    [sym_attribute] = STATE(429),
    [sym_subscript] = STATE(429),
    [sym_call] = STATE(429),
    [sym_list] = STATE(429),
    [sym_list_comprehension] = STATE(429),
    [sym_dictionary] = STATE(429),
    [sym_dictionary_comprehension] = STATE(429),
    [sym_set] = STATE(429),
    [sym_set_comprehension] = STATE(429),
    [sym_parenthesized_expression] = STATE(429),
    [sym_tuple] = STATE(429),
    [sym_generator_expression] = STATE(429),
    [sym_concatenated_string] = STATE(429),
    [sym_string] = STATE(403),
    [sym_identifier] = ACTIONS(1375),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(1375),
    [sym_float] = ACTIONS(1377),
    [sym_true] = ACTIONS(1375),
    [sym_false] = ACTIONS(1375),
    [sym_none] = ACTIONS(1375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [634] = {
    [sym__primary_expression] = STATE(430),
    [sym_binary_operator] = STATE(430),
    [sym_unary_operator] = STATE(430),
    [sym_attribute] = STATE(430),
    [sym_subscript] = STATE(430),
    [sym_call] = STATE(430),
    [sym_list] = STATE(430),
    [sym_list_comprehension] = STATE(430),
    [sym_dictionary] = STATE(430),
    [sym_dictionary_comprehension] = STATE(430),
    [sym_set] = STATE(430),
    [sym_set_comprehension] = STATE(430),
    [sym_parenthesized_expression] = STATE(430),
    [sym_tuple] = STATE(430),
    [sym_generator_expression] = STATE(430),
    [sym_concatenated_string] = STATE(430),
    [sym_string] = STATE(403),
    [sym_identifier] = ACTIONS(1379),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(1379),
    [sym_float] = ACTIONS(1381),
    [sym_true] = ACTIONS(1379),
    [sym_false] = ACTIONS(1379),
    [sym_none] = ACTIONS(1379),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [635] = {
    [sym__primary_expression] = STATE(431),
    [sym_binary_operator] = STATE(431),
    [sym_unary_operator] = STATE(431),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(431),
    [sym_list] = STATE(431),
    [sym_list_comprehension] = STATE(431),
    [sym_dictionary] = STATE(431),
    [sym_dictionary_comprehension] = STATE(431),
    [sym_set] = STATE(431),
    [sym_set_comprehension] = STATE(431),
    [sym_parenthesized_expression] = STATE(431),
    [sym_tuple] = STATE(431),
    [sym_generator_expression] = STATE(431),
    [sym_concatenated_string] = STATE(431),
    [sym_string] = STATE(403),
    [sym_identifier] = ACTIONS(1265),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(1269),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(1265),
    [sym_float] = ACTIONS(1269),
    [sym_true] = ACTIONS(1265),
    [sym_false] = ACTIONS(1265),
    [sym_none] = ACTIONS(1265),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [636] = {
    [sym__primary_expression] = STATE(432),
    [sym_binary_operator] = STATE(432),
    [sym_unary_operator] = STATE(432),
    [sym_attribute] = STATE(432),
    [sym_subscript] = STATE(432),
    [sym_call] = STATE(432),
    [sym_list] = STATE(432),
    [sym_list_comprehension] = STATE(432),
    [sym_dictionary] = STATE(432),
    [sym_dictionary_comprehension] = STATE(432),
    [sym_set] = STATE(432),
    [sym_set_comprehension] = STATE(432),
    [sym_parenthesized_expression] = STATE(432),
    [sym_tuple] = STATE(432),
    [sym_generator_expression] = STATE(432),
    [sym_concatenated_string] = STATE(432),
    [sym_string] = STATE(403),
    [sym_identifier] = ACTIONS(1383),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(1385),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(1383),
    [sym_float] = ACTIONS(1385),
    [sym_true] = ACTIONS(1383),
    [sym_false] = ACTIONS(1383),
    [sym_none] = ACTIONS(1383),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [637] = {
    [sym__primary_expression] = STATE(582),
    [sym_binary_operator] = STATE(582),
    [sym_unary_operator] = STATE(582),
    [sym_attribute] = STATE(582),
    [sym_subscript] = STATE(582),
    [sym_call] = STATE(582),
    [sym_list] = STATE(582),
    [sym_list_comprehension] = STATE(582),
    [sym_dictionary] = STATE(582),
    [sym_dictionary_comprehension] = STATE(582),
    [sym_set] = STATE(582),
    [sym_set_comprehension] = STATE(582),
    [sym_parenthesized_expression] = STATE(582),
    [sym_tuple] = STATE(582),
    [sym_generator_expression] = STATE(582),
    [sym_concatenated_string] = STATE(582),
    [sym_string] = STATE(543),
    [sym_identifier] = ACTIONS(1387),
    [anon_sym_LPAREN] = ACTIONS(870),
    [anon_sym_print] = ACTIONS(872),
    [anon_sym_exec] = ACTIONS(872),
    [anon_sym_PLUS] = ACTIONS(876),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_TILDE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(880),
    [sym_ellipsis] = ACTIONS(1389),
    [anon_sym_LBRACE] = ACTIONS(884),
    [sym_integer] = ACTIONS(1387),
    [sym_float] = ACTIONS(1389),
    [sym_true] = ACTIONS(1387),
    [sym_false] = ACTIONS(1387),
    [sym_none] = ACTIONS(1387),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(890),
  },
  [638] = {
    [sym__primary_expression] = STATE(433),
    [sym_binary_operator] = STATE(433),
    [sym_unary_operator] = STATE(433),
    [sym_attribute] = STATE(433),
    [sym_subscript] = STATE(433),
    [sym_call] = STATE(433),
    [sym_list] = STATE(433),
    [sym_list_comprehension] = STATE(433),
    [sym_dictionary] = STATE(433),
    [sym_dictionary_comprehension] = STATE(433),
    [sym_set] = STATE(433),
    [sym_set_comprehension] = STATE(433),
    [sym_parenthesized_expression] = STATE(433),
    [sym_tuple] = STATE(433),
    [sym_generator_expression] = STATE(433),
    [sym_concatenated_string] = STATE(433),
    [sym_string] = STATE(403),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(1393),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(1391),
    [sym_float] = ACTIONS(1393),
    [sym_true] = ACTIONS(1391),
    [sym_false] = ACTIONS(1391),
    [sym_none] = ACTIONS(1391),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [639] = {
    [sym__primary_expression] = STATE(132),
    [sym_binary_operator] = STATE(132),
    [sym_unary_operator] = STATE(132),
    [sym_attribute] = STATE(132),
    [sym_subscript] = STATE(132),
    [sym_call] = STATE(132),
    [sym_list] = STATE(132),
    [sym_list_comprehension] = STATE(132),
    [sym_dictionary] = STATE(132),
    [sym_dictionary_comprehension] = STATE(132),
    [sym_set] = STATE(132),
    [sym_set_comprehension] = STATE(132),
    [sym_parenthesized_expression] = STATE(132),
    [sym_tuple] = STATE(132),
    [sym_generator_expression] = STATE(132),
    [sym_concatenated_string] = STATE(132),
    [sym_string] = STATE(113),
    [sym_identifier] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(349),
    [anon_sym_exec] = ACTIONS(349),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(1397),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [sym_true] = ACTIONS(1395),
    [sym_false] = ACTIONS(1395),
    [sym_none] = ACTIONS(1395),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [640] = {
    [sym__primary_expression] = STATE(578),
    [sym_binary_operator] = STATE(578),
    [sym_unary_operator] = STATE(578),
    [sym_attribute] = STATE(578),
    [sym_subscript] = STATE(578),
    [sym_call] = STATE(578),
    [sym_list] = STATE(578),
    [sym_list_comprehension] = STATE(578),
    [sym_dictionary] = STATE(578),
    [sym_dictionary_comprehension] = STATE(578),
    [sym_set] = STATE(578),
    [sym_set_comprehension] = STATE(578),
    [sym_parenthesized_expression] = STATE(578),
    [sym_tuple] = STATE(578),
    [sym_generator_expression] = STATE(578),
    [sym_concatenated_string] = STATE(578),
    [sym_string] = STATE(543),
    [sym_identifier] = ACTIONS(1399),
    [anon_sym_LPAREN] = ACTIONS(870),
    [anon_sym_print] = ACTIONS(872),
    [anon_sym_exec] = ACTIONS(872),
    [anon_sym_PLUS] = ACTIONS(876),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_TILDE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(880),
    [sym_ellipsis] = ACTIONS(1401),
    [anon_sym_LBRACE] = ACTIONS(884),
    [sym_integer] = ACTIONS(1399),
    [sym_float] = ACTIONS(1401),
    [sym_true] = ACTIONS(1399),
    [sym_false] = ACTIONS(1399),
    [sym_none] = ACTIONS(1399),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(890),
  },
  [641] = {
    [anon_sym_DOT] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(602),
    [anon_sym_as] = ACTIONS(602),
    [anon_sym_STAR] = ACTIONS(604),
    [anon_sym_GT_GT] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(602),
    [anon_sym_in] = ACTIONS(602),
    [anon_sym_AT] = ACTIONS(602),
    [anon_sym_not] = ACTIONS(602),
    [anon_sym_and] = ACTIONS(602),
    [anon_sym_or] = ACTIONS(602),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_SLASH] = ACTIONS(604),
    [anon_sym_PERCENT] = ACTIONS(602),
    [anon_sym_SLASH_SLASH] = ACTIONS(602),
    [anon_sym_STAR_STAR] = ACTIONS(602),
    [anon_sym_PIPE] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(602),
    [anon_sym_CARET] = ACTIONS(602),
    [anon_sym_LT_LT] = ACTIONS(602),
    [anon_sym_LT] = ACTIONS(604),
    [anon_sym_LT_EQ] = ACTIONS(602),
    [anon_sym_EQ_EQ] = ACTIONS(602),
    [anon_sym_BANG_EQ] = ACTIONS(602),
    [anon_sym_GT_EQ] = ACTIONS(602),
    [anon_sym_GT] = ACTIONS(604),
    [anon_sym_LT_GT] = ACTIONS(602),
    [anon_sym_is] = ACTIONS(602),
    [anon_sym_LBRACK] = ACTIONS(602),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(602),
  },
  [642] = {
    [sym__primary_expression] = STATE(535),
    [sym_binary_operator] = STATE(535),
    [sym_unary_operator] = STATE(535),
    [sym_attribute] = STATE(535),
    [sym_subscript] = STATE(535),
    [sym_call] = STATE(535),
    [sym_list] = STATE(535),
    [sym_list_comprehension] = STATE(535),
    [sym_dictionary] = STATE(535),
    [sym_dictionary_comprehension] = STATE(535),
    [sym_set] = STATE(535),
    [sym_set_comprehension] = STATE(535),
    [sym_parenthesized_expression] = STATE(535),
    [sym_tuple] = STATE(535),
    [sym_generator_expression] = STATE(535),
    [sym_concatenated_string] = STATE(535),
    [sym_string] = STATE(530),
    [sym_identifier] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_print] = ACTIONS(239),
    [anon_sym_exec] = ACTIONS(239),
    [anon_sym_PLUS] = ACTIONS(243),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_TILDE] = ACTIONS(243),
    [anon_sym_LBRACK] = ACTIONS(538),
    [sym_ellipsis] = ACTIONS(1405),
    [anon_sym_LBRACE] = ACTIONS(249),
    [sym_integer] = ACTIONS(1403),
    [sym_float] = ACTIONS(1405),
    [sym_true] = ACTIONS(1403),
    [sym_false] = ACTIONS(1403),
    [sym_none] = ACTIONS(1403),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(255),
  },
  [643] = {
    [sym__primary_expression] = STATE(696),
    [sym_binary_operator] = STATE(696),
    [sym_unary_operator] = STATE(696),
    [sym_attribute] = STATE(696),
    [sym_subscript] = STATE(696),
    [sym_call] = STATE(696),
    [sym_list] = STATE(696),
    [sym_list_comprehension] = STATE(696),
    [sym_dictionary] = STATE(696),
    [sym_dictionary_comprehension] = STATE(696),
    [sym_set] = STATE(696),
    [sym_set_comprehension] = STATE(696),
    [sym_parenthesized_expression] = STATE(696),
    [sym_tuple] = STATE(696),
    [sym_generator_expression] = STATE(696),
    [sym_concatenated_string] = STATE(696),
    [sym_string] = STATE(403),
    [sym_identifier] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_print] = ACTIONS(367),
    [anon_sym_exec] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_ellipsis] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(381),
    [sym_integer] = ACTIONS(1239),
    [sym_float] = ACTIONS(1243),
    [sym_true] = ACTIONS(1239),
    [sym_false] = ACTIONS(1239),
    [sym_none] = ACTIONS(1239),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(387),
  },
  [644] = {
    [sym__primary_expression] = STATE(565),
    [sym_binary_operator] = STATE(565),
    [sym_unary_operator] = STATE(565),
    [sym_attribute] = STATE(565),
    [sym_subscript] = STATE(565),
    [sym_call] = STATE(565),
    [sym_list] = STATE(565),
    [sym_list_comprehension] = STATE(565),
    [sym_dictionary] = STATE(565),
    [sym_dictionary_comprehension] = STATE(565),
    [sym_set] = STATE(565),
    [sym_set_comprehension] = STATE(565),
    [sym_parenthesized_expression] = STATE(565),
    [sym_tuple] = STATE(565),
    [sym_generator_expression] = STATE(565),
    [sym_concatenated_string] = STATE(565),
    [sym_string] = STATE(543),
    [sym_identifier] = ACTIONS(1257),
    [anon_sym_LPAREN] = ACTIONS(870),
    [anon_sym_print] = ACTIONS(872),
    [anon_sym_exec] = ACTIONS(872),
    [anon_sym_PLUS] = ACTIONS(876),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_TILDE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(880),
    [sym_ellipsis] = ACTIONS(1261),
    [anon_sym_LBRACE] = ACTIONS(884),
    [sym_integer] = ACTIONS(1257),
    [sym_float] = ACTIONS(1261),
    [sym_true] = ACTIONS(1257),
    [sym_false] = ACTIONS(1257),
    [sym_none] = ACTIONS(1257),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(890),
  },
  [645] = {
    [sym__primary_expression] = STATE(574),
    [sym_binary_operator] = STATE(574),
    [sym_unary_operator] = STATE(574),
    [sym_attribute] = STATE(574),
    [sym_subscript] = STATE(574),
    [sym_call] = STATE(574),
    [sym_list] = STATE(574),
    [sym_list_comprehension] = STATE(574),
    [sym_dictionary] = STATE(574),
    [sym_dictionary_comprehension] = STATE(574),
    [sym_set] = STATE(574),
    [sym_set_comprehension] = STATE(574),
    [sym_parenthesized_expression] = STATE(574),
    [sym_tuple] = STATE(574),
    [sym_generator_expression] = STATE(574),
    [sym_concatenated_string] = STATE(574),
    [sym_string] = STATE(543),
    [sym_identifier] = ACTIONS(1407),
    [anon_sym_LPAREN] = ACTIONS(870),
    [anon_sym_print] = ACTIONS(872),
    [anon_sym_exec] = ACTIONS(872),
    [anon_sym_PLUS] = ACTIONS(876),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_TILDE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(880),
    [sym_ellipsis] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(884),
    [sym_integer] = ACTIONS(1407),
    [sym_float] = ACTIONS(1409),
    [sym_true] = ACTIONS(1407),
    [sym_false] = ACTIONS(1407),
    [sym_none] = ACTIONS(1407),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(890),
  },
  [646] = {
    [sym__primary_expression] = STATE(573),
    [sym_binary_operator] = STATE(573),
    [sym_unary_operator] = STATE(573),
    [sym_attribute] = STATE(573),
    [sym_subscript] = STATE(573),
    [sym_call] = STATE(573),
    [sym_list] = STATE(573),
    [sym_list_comprehension] = STATE(573),
    [sym_dictionary] = STATE(573),
    [sym_dictionary_comprehension] = STATE(573),
    [sym_set] = STATE(573),
    [sym_set_comprehension] = STATE(573),
    [sym_parenthesized_expression] = STATE(573),
    [sym_tuple] = STATE(573),
    [sym_generator_expression] = STATE(573),
    [sym_concatenated_string] = STATE(573),
    [sym_string] = STATE(543),
    [sym_identifier] = ACTIONS(1411),
    [anon_sym_LPAREN] = ACTIONS(870),
    [anon_sym_print] = ACTIONS(872),
    [anon_sym_exec] = ACTIONS(872),
    [anon_sym_PLUS] = ACTIONS(876),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_TILDE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(880),
    [sym_ellipsis] = ACTIONS(1413),
    [anon_sym_LBRACE] = ACTIONS(884),
    [sym_integer] = ACTIONS(1411),
    [sym_float] = ACTIONS(1413),
    [sym_true] = ACTIONS(1411),
    [sym_false] = ACTIONS(1411),
    [sym_none] = ACTIONS(1411),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(890),
  },
  [647] = {
    [sym__primary_expression] = STATE(569),
    [sym_binary_operator] = STATE(569),
    [sym_unary_operator] = STATE(569),
    [sym_attribute] = STATE(569),
    [sym_subscript] = STATE(569),
    [sym_call] = STATE(569),
    [sym_list] = STATE(569),
    [sym_list_comprehension] = STATE(569),
    [sym_dictionary] = STATE(569),
    [sym_dictionary_comprehension] = STATE(569),
    [sym_set] = STATE(569),
    [sym_set_comprehension] = STATE(569),
    [sym_parenthesized_expression] = STATE(569),
    [sym_tuple] = STATE(569),
    [sym_generator_expression] = STATE(569),
    [sym_concatenated_string] = STATE(569),
    [sym_string] = STATE(543),
    [sym_identifier] = ACTIONS(1415),
    [anon_sym_LPAREN] = ACTIONS(870),
    [anon_sym_print] = ACTIONS(872),
    [anon_sym_exec] = ACTIONS(872),
    [anon_sym_PLUS] = ACTIONS(876),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_TILDE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(880),
    [sym_ellipsis] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(884),
    [sym_integer] = ACTIONS(1415),
    [sym_float] = ACTIONS(1417),
    [sym_true] = ACTIONS(1415),
    [sym_false] = ACTIONS(1415),
    [sym_none] = ACTIONS(1415),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(890),
  },
  [648] = {
    [sym__primary_expression] = STATE(567),
    [sym_binary_operator] = STATE(567),
    [sym_unary_operator] = STATE(567),
    [sym_attribute] = STATE(567),
    [sym_subscript] = STATE(567),
    [sym_call] = STATE(567),
    [sym_list] = STATE(567),
    [sym_list_comprehension] = STATE(567),
    [sym_dictionary] = STATE(567),
    [sym_dictionary_comprehension] = STATE(567),
    [sym_set] = STATE(567),
    [sym_set_comprehension] = STATE(567),
    [sym_parenthesized_expression] = STATE(567),
    [sym_tuple] = STATE(567),
    [sym_generator_expression] = STATE(567),
    [sym_concatenated_string] = STATE(567),
    [sym_string] = STATE(543),
    [sym_identifier] = ACTIONS(1419),
    [anon_sym_LPAREN] = ACTIONS(870),
    [anon_sym_print] = ACTIONS(872),
    [anon_sym_exec] = ACTIONS(872),
    [anon_sym_PLUS] = ACTIONS(876),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_TILDE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(880),
    [sym_ellipsis] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(884),
    [sym_integer] = ACTIONS(1419),
    [sym_float] = ACTIONS(1421),
    [sym_true] = ACTIONS(1419),
    [sym_false] = ACTIONS(1419),
    [sym_none] = ACTIONS(1419),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(890),
  },
  [649] = {
    [anon_sym_DOT] = ACTIONS(792),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_COMMA] = ACTIONS(792),
    [anon_sym_as] = ACTIONS(792),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_GT_GT] = ACTIONS(792),
    [anon_sym_if] = ACTIONS(792),
    [anon_sym_COLON] = ACTIONS(792),
    [anon_sym_in] = ACTIONS(792),
    [anon_sym_AT] = ACTIONS(792),
    [anon_sym_not] = ACTIONS(792),
    [anon_sym_and] = ACTIONS(792),
    [anon_sym_or] = ACTIONS(792),
    [anon_sym_PLUS] = ACTIONS(792),
    [anon_sym_DASH] = ACTIONS(792),
    [anon_sym_SLASH] = ACTIONS(794),
    [anon_sym_PERCENT] = ACTIONS(792),
    [anon_sym_SLASH_SLASH] = ACTIONS(792),
    [anon_sym_STAR_STAR] = ACTIONS(792),
    [anon_sym_PIPE] = ACTIONS(792),
    [anon_sym_AMP] = ACTIONS(792),
    [anon_sym_CARET] = ACTIONS(792),
    [anon_sym_LT_LT] = ACTIONS(792),
    [anon_sym_LT] = ACTIONS(794),
    [anon_sym_LT_EQ] = ACTIONS(792),
    [anon_sym_EQ_EQ] = ACTIONS(792),
    [anon_sym_BANG_EQ] = ACTIONS(792),
    [anon_sym_GT_EQ] = ACTIONS(792),
    [anon_sym_GT] = ACTIONS(794),
    [anon_sym_LT_GT] = ACTIONS(792),
    [anon_sym_is] = ACTIONS(792),
    [anon_sym_LBRACK] = ACTIONS(792),
    [sym_comment] = ACTIONS(3),
  },
  [650] = {
    [aux_sym_comparison_operator_repeat1] = STATE(650),
    [anon_sym_COMMA] = ACTIONS(502),
    [anon_sym_if] = ACTIONS(502),
    [anon_sym_COLON] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(1423),
    [anon_sym_EQ] = ACTIONS(504),
    [anon_sym_not] = ACTIONS(1426),
    [anon_sym_and] = ACTIONS(502),
    [anon_sym_or] = ACTIONS(502),
    [anon_sym_LT] = ACTIONS(1429),
    [anon_sym_LT_EQ] = ACTIONS(1423),
    [anon_sym_EQ_EQ] = ACTIONS(1423),
    [anon_sym_BANG_EQ] = ACTIONS(1423),
    [anon_sym_GT_EQ] = ACTIONS(1423),
    [anon_sym_GT] = ACTIONS(1429),
    [anon_sym_LT_GT] = ACTIONS(1423),
    [anon_sym_is] = ACTIONS(1432),
    [anon_sym_PLUS_EQ] = ACTIONS(502),
    [anon_sym_DASH_EQ] = ACTIONS(502),
    [anon_sym_STAR_EQ] = ACTIONS(502),
    [anon_sym_SLASH_EQ] = ACTIONS(502),
    [anon_sym_AT_EQ] = ACTIONS(502),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(502),
    [anon_sym_PERCENT_EQ] = ACTIONS(502),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(502),
    [anon_sym_GT_GT_EQ] = ACTIONS(502),
    [anon_sym_LT_LT_EQ] = ACTIONS(502),
    [anon_sym_AMP_EQ] = ACTIONS(502),
    [anon_sym_CARET_EQ] = ACTIONS(502),
    [anon_sym_PIPE_EQ] = ACTIONS(502),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(502),
    [sym__newline] = ACTIONS(502),
  },
  [651] = {
    [anon_sym_DOT] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(780),
    [anon_sym_COMMA] = ACTIONS(780),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_STAR] = ACTIONS(782),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_if] = ACTIONS(780),
    [anon_sym_COLON] = ACTIONS(780),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_AT] = ACTIONS(780),
    [anon_sym_not] = ACTIONS(780),
    [anon_sym_and] = ACTIONS(780),
    [anon_sym_or] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(782),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_SLASH_SLASH] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_LT_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_GT_EQ] = ACTIONS(780),
    [anon_sym_GT] = ACTIONS(782),
    [anon_sym_LT_GT] = ACTIONS(780),
    [anon_sym_is] = ACTIONS(780),
    [anon_sym_LBRACK] = ACTIONS(780),
    [sym_comment] = ACTIONS(3),
  },
  [652] = {
    [anon_sym_DOT] = ACTIONS(766),
    [anon_sym_LPAREN] = ACTIONS(766),
    [anon_sym_COMMA] = ACTIONS(766),
    [anon_sym_as] = ACTIONS(766),
    [anon_sym_STAR] = ACTIONS(768),
    [anon_sym_GT_GT] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(766),
    [anon_sym_COLON] = ACTIONS(766),
    [anon_sym_in] = ACTIONS(766),
    [anon_sym_AT] = ACTIONS(766),
    [anon_sym_not] = ACTIONS(766),
    [anon_sym_and] = ACTIONS(766),
    [anon_sym_or] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_PERCENT] = ACTIONS(766),
    [anon_sym_SLASH_SLASH] = ACTIONS(766),
    [anon_sym_STAR_STAR] = ACTIONS(766),
    [anon_sym_PIPE] = ACTIONS(766),
    [anon_sym_AMP] = ACTIONS(766),
    [anon_sym_CARET] = ACTIONS(766),
    [anon_sym_LT_LT] = ACTIONS(766),
    [anon_sym_LT] = ACTIONS(768),
    [anon_sym_LT_EQ] = ACTIONS(766),
    [anon_sym_EQ_EQ] = ACTIONS(766),
    [anon_sym_BANG_EQ] = ACTIONS(766),
    [anon_sym_GT_EQ] = ACTIONS(766),
    [anon_sym_GT] = ACTIONS(768),
    [anon_sym_LT_GT] = ACTIONS(766),
    [anon_sym_is] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(766),
    [sym_comment] = ACTIONS(3),
  },
  [653] = {
    [anon_sym_DOT] = ACTIONS(762),
    [anon_sym_LPAREN] = ACTIONS(762),
    [anon_sym_COMMA] = ACTIONS(762),
    [anon_sym_as] = ACTIONS(762),
    [anon_sym_STAR] = ACTIONS(764),
    [anon_sym_GT_GT] = ACTIONS(762),
    [anon_sym_if] = ACTIONS(762),
    [anon_sym_COLON] = ACTIONS(762),
    [anon_sym_in] = ACTIONS(762),
    [anon_sym_AT] = ACTIONS(762),
    [anon_sym_not] = ACTIONS(762),
    [anon_sym_and] = ACTIONS(762),
    [anon_sym_or] = ACTIONS(762),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_SLASH] = ACTIONS(764),
    [anon_sym_PERCENT] = ACTIONS(762),
    [anon_sym_SLASH_SLASH] = ACTIONS(762),
    [anon_sym_STAR_STAR] = ACTIONS(762),
    [anon_sym_PIPE] = ACTIONS(762),
    [anon_sym_AMP] = ACTIONS(762),
    [anon_sym_CARET] = ACTIONS(762),
    [anon_sym_LT_LT] = ACTIONS(762),
    [anon_sym_LT] = ACTIONS(764),
    [anon_sym_LT_EQ] = ACTIONS(762),
    [anon_sym_EQ_EQ] = ACTIONS(762),
    [anon_sym_BANG_EQ] = ACTIONS(762),
    [anon_sym_GT_EQ] = ACTIONS(762),
    [anon_sym_GT] = ACTIONS(764),
    [anon_sym_LT_GT] = ACTIONS(762),
    [anon_sym_is] = ACTIONS(762),
    [anon_sym_LBRACK] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
  },
  [654] = {
    [anon_sym_DOT] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(740),
    [anon_sym_COMMA] = ACTIONS(740),
    [anon_sym_as] = ACTIONS(740),
    [anon_sym_STAR] = ACTIONS(742),
    [anon_sym_GT_GT] = ACTIONS(740),
    [anon_sym_if] = ACTIONS(740),
    [anon_sym_COLON] = ACTIONS(740),
    [anon_sym_in] = ACTIONS(740),
    [anon_sym_AT] = ACTIONS(740),
    [anon_sym_not] = ACTIONS(740),
    [anon_sym_and] = ACTIONS(740),
    [anon_sym_or] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(740),
    [anon_sym_DASH] = ACTIONS(740),
    [anon_sym_SLASH] = ACTIONS(742),
    [anon_sym_PERCENT] = ACTIONS(740),
    [anon_sym_SLASH_SLASH] = ACTIONS(740),
    [anon_sym_STAR_STAR] = ACTIONS(740),
    [anon_sym_PIPE] = ACTIONS(740),
    [anon_sym_AMP] = ACTIONS(740),
    [anon_sym_CARET] = ACTIONS(740),
    [anon_sym_LT_LT] = ACTIONS(740),
    [anon_sym_LT] = ACTIONS(742),
    [anon_sym_LT_EQ] = ACTIONS(740),
    [anon_sym_EQ_EQ] = ACTIONS(740),
    [anon_sym_BANG_EQ] = ACTIONS(740),
    [anon_sym_GT_EQ] = ACTIONS(740),
    [anon_sym_GT] = ACTIONS(742),
    [anon_sym_LT_GT] = ACTIONS(740),
    [anon_sym_is] = ACTIONS(740),
    [anon_sym_LBRACK] = ACTIONS(740),
    [sym_comment] = ACTIONS(3),
  },
  [655] = {
    [anon_sym_DOT] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_COMMA] = ACTIONS(678),
    [anon_sym_as] = ACTIONS(678),
    [anon_sym_STAR] = ACTIONS(680),
    [anon_sym_GT_GT] = ACTIONS(678),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_COLON] = ACTIONS(678),
    [anon_sym_in] = ACTIONS(678),
    [anon_sym_AT] = ACTIONS(678),
    [anon_sym_not] = ACTIONS(678),
    [anon_sym_and] = ACTIONS(678),
    [anon_sym_or] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_SLASH] = ACTIONS(680),
    [anon_sym_PERCENT] = ACTIONS(678),
    [anon_sym_SLASH_SLASH] = ACTIONS(678),
    [anon_sym_STAR_STAR] = ACTIONS(678),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_AMP] = ACTIONS(678),
    [anon_sym_CARET] = ACTIONS(678),
    [anon_sym_LT_LT] = ACTIONS(678),
    [anon_sym_LT] = ACTIONS(680),
    [anon_sym_LT_EQ] = ACTIONS(678),
    [anon_sym_EQ_EQ] = ACTIONS(678),
    [anon_sym_BANG_EQ] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(678),
    [anon_sym_GT] = ACTIONS(680),
    [anon_sym_LT_GT] = ACTIONS(678),
    [anon_sym_is] = ACTIONS(678),
    [anon_sym_LBRACK] = ACTIONS(678),
    [sym_comment] = ACTIONS(3),
  },
  [656] = {
    [anon_sym_DOT] = ACTIONS(710),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_COMMA] = ACTIONS(710),
    [anon_sym_as] = ACTIONS(710),
    [anon_sym_STAR] = ACTIONS(712),
    [anon_sym_GT_GT] = ACTIONS(710),
    [anon_sym_if] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(710),
    [anon_sym_in] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(710),
    [anon_sym_not] = ACTIONS(710),
    [anon_sym_and] = ACTIONS(710),
    [anon_sym_or] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(710),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_SLASH] = ACTIONS(712),
    [anon_sym_PERCENT] = ACTIONS(710),
    [anon_sym_SLASH_SLASH] = ACTIONS(710),
    [anon_sym_STAR_STAR] = ACTIONS(710),
    [anon_sym_PIPE] = ACTIONS(710),
    [anon_sym_AMP] = ACTIONS(710),
    [anon_sym_CARET] = ACTIONS(710),
    [anon_sym_LT_LT] = ACTIONS(710),
    [anon_sym_LT] = ACTIONS(712),
    [anon_sym_LT_EQ] = ACTIONS(710),
    [anon_sym_EQ_EQ] = ACTIONS(710),
    [anon_sym_BANG_EQ] = ACTIONS(710),
    [anon_sym_GT_EQ] = ACTIONS(710),
    [anon_sym_GT] = ACTIONS(712),
    [anon_sym_LT_GT] = ACTIONS(710),
    [anon_sym_is] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(710),
    [sym_comment] = ACTIONS(3),
  },
  [657] = {
    [anon_sym_DOT] = ACTIONS(660),
    [anon_sym_LPAREN] = ACTIONS(660),
    [anon_sym_COMMA] = ACTIONS(660),
    [anon_sym_as] = ACTIONS(660),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_GT_GT] = ACTIONS(660),
    [anon_sym_if] = ACTIONS(660),
    [anon_sym_COLON] = ACTIONS(660),
    [anon_sym_in] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(660),
    [anon_sym_not] = ACTIONS(660),
    [anon_sym_and] = ACTIONS(660),
    [anon_sym_or] = ACTIONS(660),
    [anon_sym_PLUS] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(660),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_PERCENT] = ACTIONS(660),
    [anon_sym_SLASH_SLASH] = ACTIONS(660),
    [anon_sym_STAR_STAR] = ACTIONS(660),
    [anon_sym_PIPE] = ACTIONS(660),
    [anon_sym_AMP] = ACTIONS(660),
    [anon_sym_CARET] = ACTIONS(660),
    [anon_sym_LT_LT] = ACTIONS(660),
    [anon_sym_LT] = ACTIONS(662),
    [anon_sym_LT_EQ] = ACTIONS(660),
    [anon_sym_EQ_EQ] = ACTIONS(660),
    [anon_sym_BANG_EQ] = ACTIONS(660),
    [anon_sym_GT_EQ] = ACTIONS(660),
    [anon_sym_GT] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(660),
    [anon_sym_is] = ACTIONS(660),
    [anon_sym_LBRACK] = ACTIONS(660),
    [sym_comment] = ACTIONS(3),
  },
  [658] = {
    [anon_sym_DOT] = ACTIONS(654),
    [anon_sym_LPAREN] = ACTIONS(654),
    [anon_sym_COMMA] = ACTIONS(654),
    [anon_sym_as] = ACTIONS(654),
    [anon_sym_STAR] = ACTIONS(656),
    [anon_sym_GT_GT] = ACTIONS(654),
    [anon_sym_if] = ACTIONS(654),
    [anon_sym_COLON] = ACTIONS(654),
    [anon_sym_in] = ACTIONS(654),
    [anon_sym_AT] = ACTIONS(654),
    [anon_sym_not] = ACTIONS(654),
    [anon_sym_and] = ACTIONS(654),
    [anon_sym_or] = ACTIONS(654),
    [anon_sym_PLUS] = ACTIONS(654),
    [anon_sym_DASH] = ACTIONS(654),
    [anon_sym_SLASH] = ACTIONS(656),
    [anon_sym_PERCENT] = ACTIONS(654),
    [anon_sym_SLASH_SLASH] = ACTIONS(654),
    [anon_sym_STAR_STAR] = ACTIONS(654),
    [anon_sym_PIPE] = ACTIONS(654),
    [anon_sym_AMP] = ACTIONS(654),
    [anon_sym_CARET] = ACTIONS(654),
    [anon_sym_LT_LT] = ACTIONS(654),
    [anon_sym_LT] = ACTIONS(656),
    [anon_sym_LT_EQ] = ACTIONS(654),
    [anon_sym_EQ_EQ] = ACTIONS(654),
    [anon_sym_BANG_EQ] = ACTIONS(654),
    [anon_sym_GT_EQ] = ACTIONS(654),
    [anon_sym_GT] = ACTIONS(656),
    [anon_sym_LT_GT] = ACTIONS(654),
    [anon_sym_is] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(654),
    [sym_comment] = ACTIONS(3),
  },
  [659] = {
    [anon_sym_DOT] = ACTIONS(664),
    [anon_sym_LPAREN] = ACTIONS(664),
    [anon_sym_COMMA] = ACTIONS(664),
    [anon_sym_as] = ACTIONS(664),
    [anon_sym_STAR] = ACTIONS(666),
    [anon_sym_GT_GT] = ACTIONS(664),
    [anon_sym_if] = ACTIONS(664),
    [anon_sym_COLON] = ACTIONS(664),
    [anon_sym_in] = ACTIONS(664),
    [anon_sym_AT] = ACTIONS(664),
    [anon_sym_not] = ACTIONS(664),
    [anon_sym_and] = ACTIONS(664),
    [anon_sym_or] = ACTIONS(664),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_SLASH] = ACTIONS(666),
    [anon_sym_PERCENT] = ACTIONS(664),
    [anon_sym_SLASH_SLASH] = ACTIONS(664),
    [anon_sym_STAR_STAR] = ACTIONS(664),
    [anon_sym_PIPE] = ACTIONS(664),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_CARET] = ACTIONS(664),
    [anon_sym_LT_LT] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(666),
    [anon_sym_LT_EQ] = ACTIONS(664),
    [anon_sym_EQ_EQ] = ACTIONS(664),
    [anon_sym_BANG_EQ] = ACTIONS(664),
    [anon_sym_GT_EQ] = ACTIONS(664),
    [anon_sym_GT] = ACTIONS(666),
    [anon_sym_LT_GT] = ACTIONS(664),
    [anon_sym_is] = ACTIONS(664),
    [anon_sym_LBRACK] = ACTIONS(664),
    [sym_comment] = ACTIONS(3),
  },
  [660] = {
    [anon_sym_DOT] = ACTIONS(776),
    [anon_sym_LPAREN] = ACTIONS(776),
    [anon_sym_COMMA] = ACTIONS(776),
    [anon_sym_as] = ACTIONS(776),
    [anon_sym_STAR] = ACTIONS(778),
    [anon_sym_GT_GT] = ACTIONS(776),
    [anon_sym_if] = ACTIONS(776),
    [anon_sym_COLON] = ACTIONS(776),
    [anon_sym_in] = ACTIONS(776),
    [anon_sym_AT] = ACTIONS(776),
    [anon_sym_not] = ACTIONS(776),
    [anon_sym_and] = ACTIONS(776),
    [anon_sym_or] = ACTIONS(776),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_PERCENT] = ACTIONS(776),
    [anon_sym_SLASH_SLASH] = ACTIONS(776),
    [anon_sym_STAR_STAR] = ACTIONS(776),
    [anon_sym_PIPE] = ACTIONS(776),
    [anon_sym_AMP] = ACTIONS(776),
    [anon_sym_CARET] = ACTIONS(776),
    [anon_sym_LT_LT] = ACTIONS(776),
    [anon_sym_LT] = ACTIONS(778),
    [anon_sym_LT_EQ] = ACTIONS(776),
    [anon_sym_EQ_EQ] = ACTIONS(776),
    [anon_sym_BANG_EQ] = ACTIONS(776),
    [anon_sym_GT_EQ] = ACTIONS(776),
    [anon_sym_GT] = ACTIONS(778),
    [anon_sym_LT_GT] = ACTIONS(776),
    [anon_sym_is] = ACTIONS(776),
    [anon_sym_LBRACK] = ACTIONS(776),
    [sym_comment] = ACTIONS(3),
  },
  [661] = {
    [anon_sym_DOT] = ACTIONS(812),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_COMMA] = ACTIONS(812),
    [anon_sym_as] = ACTIONS(812),
    [anon_sym_STAR] = ACTIONS(814),
    [anon_sym_GT_GT] = ACTIONS(812),
    [anon_sym_if] = ACTIONS(812),
    [anon_sym_COLON] = ACTIONS(812),
    [anon_sym_in] = ACTIONS(812),
    [anon_sym_AT] = ACTIONS(812),
    [anon_sym_not] = ACTIONS(812),
    [anon_sym_and] = ACTIONS(812),
    [anon_sym_or] = ACTIONS(812),
    [anon_sym_PLUS] = ACTIONS(812),
    [anon_sym_DASH] = ACTIONS(812),
    [anon_sym_SLASH] = ACTIONS(814),
    [anon_sym_PERCENT] = ACTIONS(812),
    [anon_sym_SLASH_SLASH] = ACTIONS(812),
    [anon_sym_STAR_STAR] = ACTIONS(812),
    [anon_sym_PIPE] = ACTIONS(812),
    [anon_sym_AMP] = ACTIONS(812),
    [anon_sym_CARET] = ACTIONS(812),
    [anon_sym_LT_LT] = ACTIONS(812),
    [anon_sym_LT] = ACTIONS(814),
    [anon_sym_LT_EQ] = ACTIONS(812),
    [anon_sym_EQ_EQ] = ACTIONS(812),
    [anon_sym_BANG_EQ] = ACTIONS(812),
    [anon_sym_GT_EQ] = ACTIONS(812),
    [anon_sym_GT] = ACTIONS(814),
    [anon_sym_LT_GT] = ACTIONS(812),
    [anon_sym_is] = ACTIONS(812),
    [anon_sym_LBRACK] = ACTIONS(812),
    [sym_comment] = ACTIONS(3),
  },
  [662] = {
    [anon_sym_DOT] = ACTIONS(806),
    [anon_sym_LPAREN] = ACTIONS(806),
    [anon_sym_COMMA] = ACTIONS(806),
    [anon_sym_as] = ACTIONS(806),
    [anon_sym_STAR] = ACTIONS(808),
    [anon_sym_GT_GT] = ACTIONS(806),
    [anon_sym_if] = ACTIONS(806),
    [anon_sym_COLON] = ACTIONS(806),
    [anon_sym_in] = ACTIONS(806),
    [anon_sym_AT] = ACTIONS(806),
    [anon_sym_not] = ACTIONS(806),
    [anon_sym_and] = ACTIONS(806),
    [anon_sym_or] = ACTIONS(806),
    [anon_sym_PLUS] = ACTIONS(806),
    [anon_sym_DASH] = ACTIONS(806),
    [anon_sym_SLASH] = ACTIONS(808),
    [anon_sym_PERCENT] = ACTIONS(806),
    [anon_sym_SLASH_SLASH] = ACTIONS(806),
    [anon_sym_STAR_STAR] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(806),
    [anon_sym_AMP] = ACTIONS(806),
    [anon_sym_CARET] = ACTIONS(806),
    [anon_sym_LT_LT] = ACTIONS(806),
    [anon_sym_LT] = ACTIONS(808),
    [anon_sym_LT_EQ] = ACTIONS(806),
    [anon_sym_EQ_EQ] = ACTIONS(806),
    [anon_sym_BANG_EQ] = ACTIONS(806),
    [anon_sym_GT_EQ] = ACTIONS(806),
    [anon_sym_GT] = ACTIONS(808),
    [anon_sym_LT_GT] = ACTIONS(806),
    [anon_sym_is] = ACTIONS(806),
    [anon_sym_LBRACK] = ACTIONS(806),
    [sym_comment] = ACTIONS(3),
  },
  [663] = {
    [anon_sym_DOT] = ACTIONS(802),
    [anon_sym_LPAREN] = ACTIONS(802),
    [anon_sym_COMMA] = ACTIONS(802),
    [anon_sym_as] = ACTIONS(802),
    [anon_sym_STAR] = ACTIONS(804),
    [anon_sym_GT_GT] = ACTIONS(802),
    [anon_sym_if] = ACTIONS(802),
    [anon_sym_COLON] = ACTIONS(802),
    [anon_sym_in] = ACTIONS(802),
    [anon_sym_AT] = ACTIONS(802),
    [anon_sym_not] = ACTIONS(802),
    [anon_sym_and] = ACTIONS(802),
    [anon_sym_or] = ACTIONS(802),
    [anon_sym_PLUS] = ACTIONS(802),
    [anon_sym_DASH] = ACTIONS(802),
    [anon_sym_SLASH] = ACTIONS(804),
    [anon_sym_PERCENT] = ACTIONS(802),
    [anon_sym_SLASH_SLASH] = ACTIONS(802),
    [anon_sym_STAR_STAR] = ACTIONS(802),
    [anon_sym_PIPE] = ACTIONS(802),
    [anon_sym_AMP] = ACTIONS(802),
    [anon_sym_CARET] = ACTIONS(802),
    [anon_sym_LT_LT] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(804),
    [anon_sym_LT_EQ] = ACTIONS(802),
    [anon_sym_EQ_EQ] = ACTIONS(802),
    [anon_sym_BANG_EQ] = ACTIONS(802),
    [anon_sym_GT_EQ] = ACTIONS(802),
    [anon_sym_GT] = ACTIONS(804),
    [anon_sym_LT_GT] = ACTIONS(802),
    [anon_sym_is] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(802),
    [sym_comment] = ACTIONS(3),
  },
  [664] = {
    [anon_sym_DOT] = ACTIONS(752),
    [anon_sym_LPAREN] = ACTIONS(752),
    [anon_sym_COMMA] = ACTIONS(752),
    [anon_sym_as] = ACTIONS(752),
    [anon_sym_STAR] = ACTIONS(754),
    [anon_sym_GT_GT] = ACTIONS(752),
    [anon_sym_if] = ACTIONS(752),
    [anon_sym_COLON] = ACTIONS(752),
    [anon_sym_in] = ACTIONS(752),
    [anon_sym_AT] = ACTIONS(752),
    [anon_sym_not] = ACTIONS(752),
    [anon_sym_and] = ACTIONS(752),
    [anon_sym_or] = ACTIONS(752),
    [anon_sym_PLUS] = ACTIONS(752),
    [anon_sym_DASH] = ACTIONS(752),
    [anon_sym_SLASH] = ACTIONS(754),
    [anon_sym_PERCENT] = ACTIONS(752),
    [anon_sym_SLASH_SLASH] = ACTIONS(752),
    [anon_sym_STAR_STAR] = ACTIONS(752),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_AMP] = ACTIONS(752),
    [anon_sym_CARET] = ACTIONS(752),
    [anon_sym_LT_LT] = ACTIONS(752),
    [anon_sym_LT] = ACTIONS(754),
    [anon_sym_LT_EQ] = ACTIONS(752),
    [anon_sym_EQ_EQ] = ACTIONS(752),
    [anon_sym_BANG_EQ] = ACTIONS(752),
    [anon_sym_GT_EQ] = ACTIONS(752),
    [anon_sym_GT] = ACTIONS(754),
    [anon_sym_LT_GT] = ACTIONS(752),
    [anon_sym_is] = ACTIONS(752),
    [anon_sym_LBRACK] = ACTIONS(752),
    [sym_comment] = ACTIONS(3),
  },
  [665] = {
    [anon_sym_DOT] = ACTIONS(746),
    [anon_sym_LPAREN] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(746),
    [anon_sym_as] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_GT_GT] = ACTIONS(746),
    [anon_sym_if] = ACTIONS(746),
    [anon_sym_COLON] = ACTIONS(746),
    [anon_sym_in] = ACTIONS(746),
    [anon_sym_AT] = ACTIONS(746),
    [anon_sym_not] = ACTIONS(746),
    [anon_sym_and] = ACTIONS(746),
    [anon_sym_or] = ACTIONS(746),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_SLASH] = ACTIONS(748),
    [anon_sym_PERCENT] = ACTIONS(746),
    [anon_sym_SLASH_SLASH] = ACTIONS(746),
    [anon_sym_STAR_STAR] = ACTIONS(746),
    [anon_sym_PIPE] = ACTIONS(746),
    [anon_sym_AMP] = ACTIONS(746),
    [anon_sym_CARET] = ACTIONS(746),
    [anon_sym_LT_LT] = ACTIONS(746),
    [anon_sym_LT] = ACTIONS(748),
    [anon_sym_LT_EQ] = ACTIONS(746),
    [anon_sym_EQ_EQ] = ACTIONS(746),
    [anon_sym_BANG_EQ] = ACTIONS(746),
    [anon_sym_GT_EQ] = ACTIONS(746),
    [anon_sym_GT] = ACTIONS(748),
    [anon_sym_LT_GT] = ACTIONS(746),
    [anon_sym_is] = ACTIONS(746),
    [anon_sym_LBRACK] = ACTIONS(746),
    [sym_comment] = ACTIONS(3),
  },
  [666] = {
    [anon_sym_DOT] = ACTIONS(670),
    [anon_sym_LPAREN] = ACTIONS(670),
    [anon_sym_COMMA] = ACTIONS(670),
    [anon_sym_as] = ACTIONS(670),
    [anon_sym_STAR] = ACTIONS(672),
    [anon_sym_GT_GT] = ACTIONS(670),
    [anon_sym_if] = ACTIONS(670),
    [anon_sym_COLON] = ACTIONS(670),
    [anon_sym_in] = ACTIONS(670),
    [anon_sym_AT] = ACTIONS(670),
    [anon_sym_not] = ACTIONS(670),
    [anon_sym_and] = ACTIONS(670),
    [anon_sym_or] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(670),
    [anon_sym_DASH] = ACTIONS(670),
    [anon_sym_SLASH] = ACTIONS(672),
    [anon_sym_PERCENT] = ACTIONS(670),
    [anon_sym_SLASH_SLASH] = ACTIONS(670),
    [anon_sym_STAR_STAR] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(670),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_CARET] = ACTIONS(670),
    [anon_sym_LT_LT] = ACTIONS(670),
    [anon_sym_LT] = ACTIONS(672),
    [anon_sym_LT_EQ] = ACTIONS(670),
    [anon_sym_EQ_EQ] = ACTIONS(670),
    [anon_sym_BANG_EQ] = ACTIONS(670),
    [anon_sym_GT_EQ] = ACTIONS(670),
    [anon_sym_GT] = ACTIONS(672),
    [anon_sym_LT_GT] = ACTIONS(670),
    [anon_sym_is] = ACTIONS(670),
    [anon_sym_LBRACK] = ACTIONS(670),
    [sym_comment] = ACTIONS(3),
  },
  [667] = {
    [anon_sym_DOT] = ACTIONS(734),
    [anon_sym_LPAREN] = ACTIONS(734),
    [anon_sym_COMMA] = ACTIONS(734),
    [anon_sym_as] = ACTIONS(734),
    [anon_sym_STAR] = ACTIONS(736),
    [anon_sym_GT_GT] = ACTIONS(734),
    [anon_sym_if] = ACTIONS(734),
    [anon_sym_COLON] = ACTIONS(734),
    [anon_sym_in] = ACTIONS(734),
    [anon_sym_AT] = ACTIONS(734),
    [anon_sym_not] = ACTIONS(734),
    [anon_sym_and] = ACTIONS(734),
    [anon_sym_or] = ACTIONS(734),
    [anon_sym_PLUS] = ACTIONS(734),
    [anon_sym_DASH] = ACTIONS(734),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_PERCENT] = ACTIONS(734),
    [anon_sym_SLASH_SLASH] = ACTIONS(734),
    [anon_sym_STAR_STAR] = ACTIONS(734),
    [anon_sym_PIPE] = ACTIONS(734),
    [anon_sym_AMP] = ACTIONS(734),
    [anon_sym_CARET] = ACTIONS(734),
    [anon_sym_LT_LT] = ACTIONS(734),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_LT_EQ] = ACTIONS(734),
    [anon_sym_EQ_EQ] = ACTIONS(734),
    [anon_sym_BANG_EQ] = ACTIONS(734),
    [anon_sym_GT_EQ] = ACTIONS(734),
    [anon_sym_GT] = ACTIONS(736),
    [anon_sym_LT_GT] = ACTIONS(734),
    [anon_sym_is] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(734),
    [sym_comment] = ACTIONS(3),
  },
  [668] = {
    [anon_sym_DOT] = ACTIONS(682),
    [anon_sym_LPAREN] = ACTIONS(682),
    [anon_sym_COMMA] = ACTIONS(682),
    [anon_sym_as] = ACTIONS(682),
    [anon_sym_STAR] = ACTIONS(684),
    [anon_sym_GT_GT] = ACTIONS(682),
    [anon_sym_if] = ACTIONS(682),
    [anon_sym_COLON] = ACTIONS(682),
    [anon_sym_in] = ACTIONS(682),
    [anon_sym_AT] = ACTIONS(682),
    [anon_sym_not] = ACTIONS(682),
    [anon_sym_and] = ACTIONS(682),
    [anon_sym_or] = ACTIONS(682),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_SLASH] = ACTIONS(684),
    [anon_sym_PERCENT] = ACTIONS(682),
    [anon_sym_SLASH_SLASH] = ACTIONS(682),
    [anon_sym_STAR_STAR] = ACTIONS(682),
    [anon_sym_PIPE] = ACTIONS(682),
    [anon_sym_AMP] = ACTIONS(682),
    [anon_sym_CARET] = ACTIONS(682),
    [anon_sym_LT_LT] = ACTIONS(682),
    [anon_sym_LT] = ACTIONS(684),
    [anon_sym_LT_EQ] = ACTIONS(682),
    [anon_sym_EQ_EQ] = ACTIONS(682),
    [anon_sym_BANG_EQ] = ACTIONS(682),
    [anon_sym_GT_EQ] = ACTIONS(682),
    [anon_sym_GT] = ACTIONS(684),
    [anon_sym_LT_GT] = ACTIONS(682),
    [anon_sym_is] = ACTIONS(682),
    [anon_sym_LBRACK] = ACTIONS(682),
    [sym_comment] = ACTIONS(3),
  },
  [669] = {
    [anon_sym_DOT] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_COMMA] = ACTIONS(237),
    [anon_sym_as] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(237),
    [anon_sym_if] = ACTIONS(237),
    [anon_sym_COLON] = ACTIONS(237),
    [anon_sym_in] = ACTIONS(237),
    [anon_sym_AT] = ACTIONS(237),
    [anon_sym_not] = ACTIONS(237),
    [anon_sym_and] = ACTIONS(237),
    [anon_sym_or] = ACTIONS(237),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(237),
    [anon_sym_SLASH_SLASH] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(237),
    [anon_sym_PIPE] = ACTIONS(237),
    [anon_sym_AMP] = ACTIONS(237),
    [anon_sym_CARET] = ACTIONS(237),
    [anon_sym_LT_LT] = ACTIONS(237),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_LT_GT] = ACTIONS(237),
    [anon_sym_is] = ACTIONS(237),
    [anon_sym_LBRACK] = ACTIONS(237),
    [sym_comment] = ACTIONS(3),
  },
  [670] = {
    [anon_sym_DOT] = ACTIONS(788),
    [anon_sym_LPAREN] = ACTIONS(788),
    [anon_sym_COMMA] = ACTIONS(788),
    [anon_sym_as] = ACTIONS(788),
    [anon_sym_STAR] = ACTIONS(790),
    [anon_sym_GT_GT] = ACTIONS(788),
    [anon_sym_if] = ACTIONS(788),
    [anon_sym_COLON] = ACTIONS(788),
    [anon_sym_in] = ACTIONS(788),
    [anon_sym_AT] = ACTIONS(788),
    [anon_sym_not] = ACTIONS(788),
    [anon_sym_and] = ACTIONS(788),
    [anon_sym_or] = ACTIONS(788),
    [anon_sym_PLUS] = ACTIONS(788),
    [anon_sym_DASH] = ACTIONS(788),
    [anon_sym_SLASH] = ACTIONS(790),
    [anon_sym_PERCENT] = ACTIONS(788),
    [anon_sym_SLASH_SLASH] = ACTIONS(788),
    [anon_sym_STAR_STAR] = ACTIONS(788),
    [anon_sym_PIPE] = ACTIONS(788),
    [anon_sym_AMP] = ACTIONS(788),
    [anon_sym_CARET] = ACTIONS(788),
    [anon_sym_LT_LT] = ACTIONS(788),
    [anon_sym_LT] = ACTIONS(790),
    [anon_sym_LT_EQ] = ACTIONS(788),
    [anon_sym_EQ_EQ] = ACTIONS(788),
    [anon_sym_BANG_EQ] = ACTIONS(788),
    [anon_sym_GT_EQ] = ACTIONS(788),
    [anon_sym_GT] = ACTIONS(790),
    [anon_sym_LT_GT] = ACTIONS(788),
    [anon_sym_is] = ACTIONS(788),
    [anon_sym_LBRACK] = ACTIONS(788),
    [sym_comment] = ACTIONS(3),
  },
  [671] = {
    [anon_sym_DOT] = ACTIONS(706),
    [anon_sym_LPAREN] = ACTIONS(706),
    [anon_sym_COMMA] = ACTIONS(706),
    [anon_sym_as] = ACTIONS(706),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_GT_GT] = ACTIONS(706),
    [anon_sym_if] = ACTIONS(706),
    [anon_sym_COLON] = ACTIONS(706),
    [anon_sym_in] = ACTIONS(706),
    [anon_sym_AT] = ACTIONS(706),
    [anon_sym_not] = ACTIONS(706),
    [anon_sym_and] = ACTIONS(706),
    [anon_sym_or] = ACTIONS(706),
    [anon_sym_PLUS] = ACTIONS(706),
    [anon_sym_DASH] = ACTIONS(706),
    [anon_sym_SLASH] = ACTIONS(708),
    [anon_sym_PERCENT] = ACTIONS(706),
    [anon_sym_SLASH_SLASH] = ACTIONS(706),
    [anon_sym_STAR_STAR] = ACTIONS(706),
    [anon_sym_PIPE] = ACTIONS(706),
    [anon_sym_AMP] = ACTIONS(706),
    [anon_sym_CARET] = ACTIONS(706),
    [anon_sym_LT_LT] = ACTIONS(706),
    [anon_sym_LT] = ACTIONS(708),
    [anon_sym_LT_EQ] = ACTIONS(706),
    [anon_sym_EQ_EQ] = ACTIONS(706),
    [anon_sym_BANG_EQ] = ACTIONS(706),
    [anon_sym_GT_EQ] = ACTIONS(706),
    [anon_sym_GT] = ACTIONS(708),
    [anon_sym_LT_GT] = ACTIONS(706),
    [anon_sym_is] = ACTIONS(706),
    [anon_sym_LBRACK] = ACTIONS(706),
    [sym_comment] = ACTIONS(3),
  },
  [672] = {
    [anon_sym_DOT] = ACTIONS(730),
    [anon_sym_LPAREN] = ACTIONS(730),
    [anon_sym_COMMA] = ACTIONS(730),
    [anon_sym_as] = ACTIONS(730),
    [anon_sym_STAR] = ACTIONS(732),
    [anon_sym_GT_GT] = ACTIONS(730),
    [anon_sym_if] = ACTIONS(730),
    [anon_sym_COLON] = ACTIONS(730),
    [anon_sym_in] = ACTIONS(730),
    [anon_sym_AT] = ACTIONS(730),
    [anon_sym_not] = ACTIONS(730),
    [anon_sym_and] = ACTIONS(730),
    [anon_sym_or] = ACTIONS(730),
    [anon_sym_PLUS] = ACTIONS(730),
    [anon_sym_DASH] = ACTIONS(730),
    [anon_sym_SLASH] = ACTIONS(732),
    [anon_sym_PERCENT] = ACTIONS(730),
    [anon_sym_SLASH_SLASH] = ACTIONS(730),
    [anon_sym_STAR_STAR] = ACTIONS(730),
    [anon_sym_PIPE] = ACTIONS(730),
    [anon_sym_AMP] = ACTIONS(730),
    [anon_sym_CARET] = ACTIONS(730),
    [anon_sym_LT_LT] = ACTIONS(730),
    [anon_sym_LT] = ACTIONS(732),
    [anon_sym_LT_EQ] = ACTIONS(730),
    [anon_sym_EQ_EQ] = ACTIONS(730),
    [anon_sym_BANG_EQ] = ACTIONS(730),
    [anon_sym_GT_EQ] = ACTIONS(730),
    [anon_sym_GT] = ACTIONS(732),
    [anon_sym_LT_GT] = ACTIONS(730),
    [anon_sym_is] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(730),
    [sym_comment] = ACTIONS(3),
  },
  [673] = {
    [anon_sym_DOT] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(698),
    [anon_sym_COMMA] = ACTIONS(698),
    [anon_sym_as] = ACTIONS(698),
    [anon_sym_STAR] = ACTIONS(700),
    [anon_sym_GT_GT] = ACTIONS(698),
    [anon_sym_if] = ACTIONS(698),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_in] = ACTIONS(698),
    [anon_sym_AT] = ACTIONS(698),
    [anon_sym_not] = ACTIONS(698),
    [anon_sym_and] = ACTIONS(698),
    [anon_sym_or] = ACTIONS(698),
    [anon_sym_PLUS] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(700),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH_SLASH] = ACTIONS(698),
    [anon_sym_STAR_STAR] = ACTIONS(698),
    [anon_sym_PIPE] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_CARET] = ACTIONS(698),
    [anon_sym_LT_LT] = ACTIONS(698),
    [anon_sym_LT] = ACTIONS(700),
    [anon_sym_LT_EQ] = ACTIONS(698),
    [anon_sym_EQ_EQ] = ACTIONS(698),
    [anon_sym_BANG_EQ] = ACTIONS(698),
    [anon_sym_GT_EQ] = ACTIONS(698),
    [anon_sym_GT] = ACTIONS(700),
    [anon_sym_LT_GT] = ACTIONS(698),
    [anon_sym_is] = ACTIONS(698),
    [anon_sym_LBRACK] = ACTIONS(698),
    [sym_comment] = ACTIONS(3),
  },
  [674] = {
    [anon_sym_DOT] = ACTIONS(822),
    [anon_sym_LPAREN] = ACTIONS(822),
    [anon_sym_COMMA] = ACTIONS(822),
    [anon_sym_as] = ACTIONS(822),
    [anon_sym_STAR] = ACTIONS(824),
    [anon_sym_GT_GT] = ACTIONS(822),
    [anon_sym_if] = ACTIONS(822),
    [anon_sym_COLON] = ACTIONS(822),
    [anon_sym_in] = ACTIONS(822),
    [anon_sym_AT] = ACTIONS(822),
    [anon_sym_not] = ACTIONS(822),
    [anon_sym_and] = ACTIONS(822),
    [anon_sym_or] = ACTIONS(822),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_SLASH] = ACTIONS(824),
    [anon_sym_PERCENT] = ACTIONS(822),
    [anon_sym_SLASH_SLASH] = ACTIONS(822),
    [anon_sym_STAR_STAR] = ACTIONS(822),
    [anon_sym_PIPE] = ACTIONS(822),
    [anon_sym_AMP] = ACTIONS(822),
    [anon_sym_CARET] = ACTIONS(822),
    [anon_sym_LT_LT] = ACTIONS(822),
    [anon_sym_LT] = ACTIONS(824),
    [anon_sym_LT_EQ] = ACTIONS(822),
    [anon_sym_EQ_EQ] = ACTIONS(822),
    [anon_sym_BANG_EQ] = ACTIONS(822),
    [anon_sym_GT_EQ] = ACTIONS(822),
    [anon_sym_GT] = ACTIONS(824),
    [anon_sym_LT_GT] = ACTIONS(822),
    [anon_sym_is] = ACTIONS(822),
    [anon_sym_LBRACK] = ACTIONS(822),
    [sym_comment] = ACTIONS(3),
  },
  [675] = {
    [anon_sym_DOT] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(816),
    [anon_sym_COMMA] = ACTIONS(816),
    [anon_sym_as] = ACTIONS(816),
    [anon_sym_STAR] = ACTIONS(818),
    [anon_sym_GT_GT] = ACTIONS(816),
    [anon_sym_if] = ACTIONS(816),
    [anon_sym_COLON] = ACTIONS(816),
    [anon_sym_in] = ACTIONS(816),
    [anon_sym_AT] = ACTIONS(816),
    [anon_sym_not] = ACTIONS(816),
    [anon_sym_and] = ACTIONS(816),
    [anon_sym_or] = ACTIONS(816),
    [anon_sym_PLUS] = ACTIONS(816),
    [anon_sym_DASH] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(818),
    [anon_sym_PERCENT] = ACTIONS(816),
    [anon_sym_SLASH_SLASH] = ACTIONS(816),
    [anon_sym_STAR_STAR] = ACTIONS(816),
    [anon_sym_PIPE] = ACTIONS(816),
    [anon_sym_AMP] = ACTIONS(816),
    [anon_sym_CARET] = ACTIONS(816),
    [anon_sym_LT_LT] = ACTIONS(816),
    [anon_sym_LT] = ACTIONS(818),
    [anon_sym_LT_EQ] = ACTIONS(816),
    [anon_sym_EQ_EQ] = ACTIONS(816),
    [anon_sym_BANG_EQ] = ACTIONS(816),
    [anon_sym_GT_EQ] = ACTIONS(816),
    [anon_sym_GT] = ACTIONS(818),
    [anon_sym_LT_GT] = ACTIONS(816),
    [anon_sym_is] = ACTIONS(816),
    [anon_sym_LBRACK] = ACTIONS(816),
    [sym_comment] = ACTIONS(3),
  },
  [676] = {
    [anon_sym_DOT] = ACTIONS(636),
    [anon_sym_LPAREN] = ACTIONS(636),
    [anon_sym_COMMA] = ACTIONS(636),
    [anon_sym_as] = ACTIONS(636),
    [anon_sym_STAR] = ACTIONS(638),
    [anon_sym_GT_GT] = ACTIONS(636),
    [anon_sym_if] = ACTIONS(636),
    [anon_sym_COLON] = ACTIONS(636),
    [anon_sym_in] = ACTIONS(636),
    [anon_sym_AT] = ACTIONS(636),
    [anon_sym_not] = ACTIONS(636),
    [anon_sym_and] = ACTIONS(636),
    [anon_sym_or] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(636),
    [anon_sym_DASH] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(638),
    [anon_sym_PERCENT] = ACTIONS(636),
    [anon_sym_SLASH_SLASH] = ACTIONS(636),
    [anon_sym_STAR_STAR] = ACTIONS(636),
    [anon_sym_PIPE] = ACTIONS(636),
    [anon_sym_AMP] = ACTIONS(636),
    [anon_sym_CARET] = ACTIONS(636),
    [anon_sym_LT_LT] = ACTIONS(636),
    [anon_sym_LT] = ACTIONS(638),
    [anon_sym_LT_EQ] = ACTIONS(636),
    [anon_sym_EQ_EQ] = ACTIONS(636),
    [anon_sym_BANG_EQ] = ACTIONS(636),
    [anon_sym_GT_EQ] = ACTIONS(636),
    [anon_sym_GT] = ACTIONS(638),
    [anon_sym_LT_GT] = ACTIONS(636),
    [anon_sym_is] = ACTIONS(636),
    [anon_sym_LBRACK] = ACTIONS(636),
    [sym_comment] = ACTIONS(3),
  },
  [677] = {
    [anon_sym_DOT] = ACTIONS(644),
    [anon_sym_LPAREN] = ACTIONS(644),
    [anon_sym_COMMA] = ACTIONS(644),
    [anon_sym_as] = ACTIONS(644),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_GT_GT] = ACTIONS(644),
    [anon_sym_if] = ACTIONS(644),
    [anon_sym_COLON] = ACTIONS(644),
    [anon_sym_in] = ACTIONS(644),
    [anon_sym_AT] = ACTIONS(644),
    [anon_sym_not] = ACTIONS(644),
    [anon_sym_and] = ACTIONS(644),
    [anon_sym_or] = ACTIONS(644),
    [anon_sym_PLUS] = ACTIONS(644),
    [anon_sym_DASH] = ACTIONS(644),
    [anon_sym_SLASH] = ACTIONS(646),
    [anon_sym_PERCENT] = ACTIONS(644),
    [anon_sym_SLASH_SLASH] = ACTIONS(644),
    [anon_sym_STAR_STAR] = ACTIONS(644),
    [anon_sym_PIPE] = ACTIONS(644),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_CARET] = ACTIONS(644),
    [anon_sym_LT_LT] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_LT_EQ] = ACTIONS(644),
    [anon_sym_EQ_EQ] = ACTIONS(644),
    [anon_sym_BANG_EQ] = ACTIONS(644),
    [anon_sym_GT_EQ] = ACTIONS(644),
    [anon_sym_GT] = ACTIONS(646),
    [anon_sym_LT_GT] = ACTIONS(644),
    [anon_sym_is] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(644),
    [sym_comment] = ACTIONS(3),
  },
  [678] = {
    [anon_sym_DOT] = ACTIONS(770),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_COMMA] = ACTIONS(770),
    [anon_sym_as] = ACTIONS(770),
    [anon_sym_STAR] = ACTIONS(772),
    [anon_sym_GT_GT] = ACTIONS(770),
    [anon_sym_if] = ACTIONS(770),
    [anon_sym_COLON] = ACTIONS(770),
    [anon_sym_in] = ACTIONS(770),
    [anon_sym_AT] = ACTIONS(770),
    [anon_sym_not] = ACTIONS(770),
    [anon_sym_and] = ACTIONS(770),
    [anon_sym_or] = ACTIONS(770),
    [anon_sym_PLUS] = ACTIONS(770),
    [anon_sym_DASH] = ACTIONS(770),
    [anon_sym_SLASH] = ACTIONS(772),
    [anon_sym_PERCENT] = ACTIONS(770),
    [anon_sym_SLASH_SLASH] = ACTIONS(770),
    [anon_sym_STAR_STAR] = ACTIONS(770),
    [anon_sym_PIPE] = ACTIONS(770),
    [anon_sym_AMP] = ACTIONS(770),
    [anon_sym_CARET] = ACTIONS(770),
    [anon_sym_LT_LT] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(772),
    [anon_sym_LT_EQ] = ACTIONS(770),
    [anon_sym_EQ_EQ] = ACTIONS(770),
    [anon_sym_BANG_EQ] = ACTIONS(770),
    [anon_sym_GT_EQ] = ACTIONS(770),
    [anon_sym_GT] = ACTIONS(772),
    [anon_sym_LT_GT] = ACTIONS(770),
    [anon_sym_is] = ACTIONS(770),
    [anon_sym_LBRACK] = ACTIONS(770),
    [sym_comment] = ACTIONS(3),
  },
  [679] = {
    [anon_sym_DOT] = ACTIONS(796),
    [anon_sym_LPAREN] = ACTIONS(796),
    [anon_sym_COMMA] = ACTIONS(796),
    [anon_sym_as] = ACTIONS(796),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_GT_GT] = ACTIONS(796),
    [anon_sym_if] = ACTIONS(796),
    [anon_sym_COLON] = ACTIONS(796),
    [anon_sym_in] = ACTIONS(796),
    [anon_sym_AT] = ACTIONS(796),
    [anon_sym_not] = ACTIONS(796),
    [anon_sym_and] = ACTIONS(796),
    [anon_sym_or] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(796),
    [anon_sym_DASH] = ACTIONS(796),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_PERCENT] = ACTIONS(796),
    [anon_sym_SLASH_SLASH] = ACTIONS(796),
    [anon_sym_STAR_STAR] = ACTIONS(796),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_AMP] = ACTIONS(796),
    [anon_sym_CARET] = ACTIONS(796),
    [anon_sym_LT_LT] = ACTIONS(796),
    [anon_sym_LT] = ACTIONS(798),
    [anon_sym_LT_EQ] = ACTIONS(796),
    [anon_sym_EQ_EQ] = ACTIONS(796),
    [anon_sym_BANG_EQ] = ACTIONS(796),
    [anon_sym_GT_EQ] = ACTIONS(796),
    [anon_sym_GT] = ACTIONS(798),
    [anon_sym_LT_GT] = ACTIONS(796),
    [anon_sym_is] = ACTIONS(796),
    [anon_sym_LBRACK] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
  },
  [680] = {
    [anon_sym_DOT] = ACTIONS(758),
    [anon_sym_LPAREN] = ACTIONS(758),
    [anon_sym_COMMA] = ACTIONS(758),
    [anon_sym_as] = ACTIONS(758),
    [anon_sym_STAR] = ACTIONS(760),
    [anon_sym_GT_GT] = ACTIONS(758),
    [anon_sym_if] = ACTIONS(758),
    [anon_sym_COLON] = ACTIONS(758),
    [anon_sym_in] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(758),
    [anon_sym_not] = ACTIONS(758),
    [anon_sym_and] = ACTIONS(758),
    [anon_sym_or] = ACTIONS(758),
    [anon_sym_PLUS] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(758),
    [anon_sym_SLASH] = ACTIONS(760),
    [anon_sym_PERCENT] = ACTIONS(758),
    [anon_sym_SLASH_SLASH] = ACTIONS(758),
    [anon_sym_STAR_STAR] = ACTIONS(758),
    [anon_sym_PIPE] = ACTIONS(758),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_CARET] = ACTIONS(758),
    [anon_sym_LT_LT] = ACTIONS(758),
    [anon_sym_LT] = ACTIONS(760),
    [anon_sym_LT_EQ] = ACTIONS(758),
    [anon_sym_EQ_EQ] = ACTIONS(758),
    [anon_sym_BANG_EQ] = ACTIONS(758),
    [anon_sym_GT_EQ] = ACTIONS(758),
    [anon_sym_GT] = ACTIONS(760),
    [anon_sym_LT_GT] = ACTIONS(758),
    [anon_sym_is] = ACTIONS(758),
    [anon_sym_LBRACK] = ACTIONS(758),
    [sym_comment] = ACTIONS(3),
  },
  [681] = {
    [aux_sym_comparison_operator_repeat1] = STATE(650),
    [anon_sym_COMMA] = ACTIONS(1435),
    [anon_sym_if] = ACTIONS(1435),
    [anon_sym_COLON] = ACTIONS(1435),
    [anon_sym_in] = ACTIONS(466),
    [anon_sym_EQ] = ACTIONS(1437),
    [anon_sym_not] = ACTIONS(470),
    [anon_sym_and] = ACTIONS(1435),
    [anon_sym_or] = ACTIONS(1435),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_LT_EQ] = ACTIONS(466),
    [anon_sym_EQ_EQ] = ACTIONS(466),
    [anon_sym_BANG_EQ] = ACTIONS(466),
    [anon_sym_GT_EQ] = ACTIONS(466),
    [anon_sym_GT] = ACTIONS(482),
    [anon_sym_LT_GT] = ACTIONS(466),
    [anon_sym_is] = ACTIONS(484),
    [anon_sym_PLUS_EQ] = ACTIONS(1435),
    [anon_sym_DASH_EQ] = ACTIONS(1435),
    [anon_sym_STAR_EQ] = ACTIONS(1435),
    [anon_sym_SLASH_EQ] = ACTIONS(1435),
    [anon_sym_AT_EQ] = ACTIONS(1435),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1435),
    [anon_sym_PERCENT_EQ] = ACTIONS(1435),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1435),
    [anon_sym_GT_GT_EQ] = ACTIONS(1435),
    [anon_sym_LT_LT_EQ] = ACTIONS(1435),
    [anon_sym_AMP_EQ] = ACTIONS(1435),
    [anon_sym_CARET_EQ] = ACTIONS(1435),
    [anon_sym_PIPE_EQ] = ACTIONS(1435),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1435),
    [sym__newline] = ACTIONS(1435),
  },
  [682] = {
    [aux_sym_comparison_operator_repeat1] = STATE(683),
    [anon_sym_RPAREN] = ACTIONS(1435),
    [anon_sym_COMMA] = ACTIONS(1435),
    [anon_sym_if] = ACTIONS(1435),
    [anon_sym_COLON] = ACTIONS(1435),
    [anon_sym_else] = ACTIONS(1435),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_for] = ACTIONS(1435),
    [anon_sym_in] = ACTIONS(1005),
    [anon_sym_EQ] = ACTIONS(1437),
    [anon_sym_not] = ACTIONS(1009),
    [anon_sym_and] = ACTIONS(1435),
    [anon_sym_or] = ACTIONS(1435),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1005),
    [anon_sym_EQ_EQ] = ACTIONS(1005),
    [anon_sym_BANG_EQ] = ACTIONS(1005),
    [anon_sym_GT_EQ] = ACTIONS(1005),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT_GT] = ACTIONS(1005),
    [anon_sym_is] = ACTIONS(1023),
    [anon_sym_RBRACK] = ACTIONS(1435),
    [anon_sym_RBRACE] = ACTIONS(1435),
    [sym_type_conversion] = ACTIONS(1435),
    [sym_comment] = ACTIONS(3),
  },
  [683] = {
    [aux_sym_comparison_operator_repeat1] = STATE(683),
    [anon_sym_RPAREN] = ACTIONS(502),
    [anon_sym_COMMA] = ACTIONS(502),
    [anon_sym_if] = ACTIONS(502),
    [anon_sym_COLON] = ACTIONS(502),
    [anon_sym_else] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_for] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(1439),
    [anon_sym_EQ] = ACTIONS(504),
    [anon_sym_not] = ACTIONS(1442),
    [anon_sym_and] = ACTIONS(502),
    [anon_sym_or] = ACTIONS(502),
    [anon_sym_LT] = ACTIONS(1445),
    [anon_sym_LT_EQ] = ACTIONS(1439),
    [anon_sym_EQ_EQ] = ACTIONS(1439),
    [anon_sym_BANG_EQ] = ACTIONS(1439),
    [anon_sym_GT_EQ] = ACTIONS(1439),
    [anon_sym_GT] = ACTIONS(1445),
    [anon_sym_LT_GT] = ACTIONS(1439),
    [anon_sym_is] = ACTIONS(1448),
    [anon_sym_RBRACK] = ACTIONS(502),
    [anon_sym_RBRACE] = ACTIONS(502),
    [sym_type_conversion] = ACTIONS(502),
    [sym_comment] = ACTIONS(3),
  },
  [684] = {
    [anon_sym_from] = ACTIONS(1451),
    [anon_sym_COMMA] = ACTIONS(1451),
    [anon_sym_if] = ACTIONS(1451),
    [anon_sym_COLON] = ACTIONS(1451),
    [anon_sym_EQ] = ACTIONS(1451),
    [anon_sym_and] = ACTIONS(1451),
    [anon_sym_or] = ACTIONS(1451),
    [anon_sym_PLUS_EQ] = ACTIONS(1451),
    [anon_sym_DASH_EQ] = ACTIONS(1451),
    [anon_sym_STAR_EQ] = ACTIONS(1451),
    [anon_sym_SLASH_EQ] = ACTIONS(1451),
    [anon_sym_AT_EQ] = ACTIONS(1451),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1451),
    [anon_sym_PERCENT_EQ] = ACTIONS(1451),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1451),
    [anon_sym_GT_GT_EQ] = ACTIONS(1451),
    [anon_sym_LT_LT_EQ] = ACTIONS(1451),
    [anon_sym_AMP_EQ] = ACTIONS(1451),
    [anon_sym_CARET_EQ] = ACTIONS(1451),
    [anon_sym_PIPE_EQ] = ACTIONS(1451),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1451),
    [sym__newline] = ACTIONS(1451),
  },
  [685] = {
    [aux_sym_assert_statement_repeat1] = STATE(700),
    [anon_sym_COMMA] = ACTIONS(1453),
    [anon_sym_if] = ACTIONS(1455),
    [anon_sym_COLON] = ACTIONS(1457),
    [anon_sym_EQ] = ACTIONS(1457),
    [anon_sym_and] = ACTIONS(1459),
    [anon_sym_or] = ACTIONS(1461),
    [anon_sym_PLUS_EQ] = ACTIONS(1457),
    [anon_sym_DASH_EQ] = ACTIONS(1457),
    [anon_sym_STAR_EQ] = ACTIONS(1457),
    [anon_sym_SLASH_EQ] = ACTIONS(1457),
    [anon_sym_AT_EQ] = ACTIONS(1457),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1457),
    [anon_sym_PERCENT_EQ] = ACTIONS(1457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1457),
    [anon_sym_GT_GT_EQ] = ACTIONS(1457),
    [anon_sym_LT_LT_EQ] = ACTIONS(1457),
    [anon_sym_AMP_EQ] = ACTIONS(1457),
    [anon_sym_CARET_EQ] = ACTIONS(1457),
    [anon_sym_PIPE_EQ] = ACTIONS(1457),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1457),
    [sym__newline] = ACTIONS(1457),
  },
  [686] = {
    [anon_sym_from] = ACTIONS(1463),
    [anon_sym_COMMA] = ACTIONS(1463),
    [anon_sym_if] = ACTIONS(1463),
    [anon_sym_COLON] = ACTIONS(1463),
    [anon_sym_EQ] = ACTIONS(1463),
    [anon_sym_and] = ACTIONS(1463),
    [anon_sym_or] = ACTIONS(1463),
    [anon_sym_PLUS_EQ] = ACTIONS(1463),
    [anon_sym_DASH_EQ] = ACTIONS(1463),
    [anon_sym_STAR_EQ] = ACTIONS(1463),
    [anon_sym_SLASH_EQ] = ACTIONS(1463),
    [anon_sym_AT_EQ] = ACTIONS(1463),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1463),
    [anon_sym_PERCENT_EQ] = ACTIONS(1463),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1463),
    [anon_sym_GT_GT_EQ] = ACTIONS(1463),
    [anon_sym_LT_LT_EQ] = ACTIONS(1463),
    [anon_sym_AMP_EQ] = ACTIONS(1463),
    [anon_sym_CARET_EQ] = ACTIONS(1463),
    [anon_sym_PIPE_EQ] = ACTIONS(1463),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1463),
    [sym__newline] = ACTIONS(1463),
  },
  [687] = {
    [aux_sym_assert_statement_repeat1] = STATE(697),
    [anon_sym_COMMA] = ACTIONS(1465),
    [anon_sym_if] = ACTIONS(1455),
    [anon_sym_COLON] = ACTIONS(1457),
    [anon_sym_EQ] = ACTIONS(1457),
    [anon_sym_and] = ACTIONS(1459),
    [anon_sym_or] = ACTIONS(1461),
    [anon_sym_PLUS_EQ] = ACTIONS(1457),
    [anon_sym_DASH_EQ] = ACTIONS(1457),
    [anon_sym_STAR_EQ] = ACTIONS(1457),
    [anon_sym_SLASH_EQ] = ACTIONS(1457),
    [anon_sym_AT_EQ] = ACTIONS(1457),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1457),
    [anon_sym_PERCENT_EQ] = ACTIONS(1457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1457),
    [anon_sym_GT_GT_EQ] = ACTIONS(1457),
    [anon_sym_LT_LT_EQ] = ACTIONS(1457),
    [anon_sym_AMP_EQ] = ACTIONS(1457),
    [anon_sym_CARET_EQ] = ACTIONS(1457),
    [anon_sym_PIPE_EQ] = ACTIONS(1457),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1467),
    [sym__newline] = ACTIONS(1467),
  },
  [688] = {
    [anon_sym_COMMA] = ACTIONS(1469),
    [anon_sym_if] = ACTIONS(1469),
    [anon_sym_COLON] = ACTIONS(1469),
    [anon_sym_EQ] = ACTIONS(1469),
    [anon_sym_and] = ACTIONS(1459),
    [anon_sym_or] = ACTIONS(1469),
    [anon_sym_PLUS_EQ] = ACTIONS(1469),
    [anon_sym_DASH_EQ] = ACTIONS(1469),
    [anon_sym_STAR_EQ] = ACTIONS(1469),
    [anon_sym_SLASH_EQ] = ACTIONS(1469),
    [anon_sym_AT_EQ] = ACTIONS(1469),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1469),
    [anon_sym_PERCENT_EQ] = ACTIONS(1469),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1469),
    [anon_sym_GT_GT_EQ] = ACTIONS(1469),
    [anon_sym_LT_LT_EQ] = ACTIONS(1469),
    [anon_sym_AMP_EQ] = ACTIONS(1469),
    [anon_sym_CARET_EQ] = ACTIONS(1469),
    [anon_sym_PIPE_EQ] = ACTIONS(1469),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1469),
    [sym__newline] = ACTIONS(1469),
  },
  [689] = {
    [anon_sym_COMMA] = ACTIONS(1471),
    [anon_sym_if] = ACTIONS(1471),
    [anon_sym_COLON] = ACTIONS(1471),
    [anon_sym_EQ] = ACTIONS(1471),
    [anon_sym_and] = ACTIONS(1459),
    [anon_sym_or] = ACTIONS(1461),
    [anon_sym_PLUS_EQ] = ACTIONS(1471),
    [anon_sym_DASH_EQ] = ACTIONS(1471),
    [anon_sym_STAR_EQ] = ACTIONS(1471),
    [anon_sym_SLASH_EQ] = ACTIONS(1471),
    [anon_sym_AT_EQ] = ACTIONS(1471),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1471),
    [anon_sym_PERCENT_EQ] = ACTIONS(1471),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1471),
    [anon_sym_GT_GT_EQ] = ACTIONS(1471),
    [anon_sym_LT_LT_EQ] = ACTIONS(1471),
    [anon_sym_AMP_EQ] = ACTIONS(1471),
    [anon_sym_CARET_EQ] = ACTIONS(1471),
    [anon_sym_PIPE_EQ] = ACTIONS(1471),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1471),
    [sym__newline] = ACTIONS(1471),
  },
  [690] = {
    [anon_sym_COMMA] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(1455),
    [anon_sym_COLON] = ACTIONS(1473),
    [anon_sym_EQ] = ACTIONS(1473),
    [anon_sym_and] = ACTIONS(1459),
    [anon_sym_or] = ACTIONS(1461),
    [anon_sym_PLUS_EQ] = ACTIONS(1473),
    [anon_sym_DASH_EQ] = ACTIONS(1473),
    [anon_sym_STAR_EQ] = ACTIONS(1473),
    [anon_sym_SLASH_EQ] = ACTIONS(1473),
    [anon_sym_AT_EQ] = ACTIONS(1473),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1473),
    [anon_sym_PERCENT_EQ] = ACTIONS(1473),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1473),
    [anon_sym_GT_GT_EQ] = ACTIONS(1473),
    [anon_sym_LT_LT_EQ] = ACTIONS(1473),
    [anon_sym_AMP_EQ] = ACTIONS(1473),
    [anon_sym_CARET_EQ] = ACTIONS(1473),
    [anon_sym_PIPE_EQ] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1473),
    [sym__newline] = ACTIONS(1473),
  },
  [691] = {
    [anon_sym_COMMA] = ACTIONS(1475),
    [anon_sym_if] = ACTIONS(1475),
    [anon_sym_COLON] = ACTIONS(1475),
    [anon_sym_EQ] = ACTIONS(1475),
    [anon_sym_and] = ACTIONS(1459),
    [anon_sym_or] = ACTIONS(1461),
    [anon_sym_PLUS_EQ] = ACTIONS(1475),
    [anon_sym_DASH_EQ] = ACTIONS(1475),
    [anon_sym_STAR_EQ] = ACTIONS(1475),
    [anon_sym_SLASH_EQ] = ACTIONS(1475),
    [anon_sym_AT_EQ] = ACTIONS(1475),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1475),
    [anon_sym_PERCENT_EQ] = ACTIONS(1475),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1475),
    [anon_sym_GT_GT_EQ] = ACTIONS(1475),
    [anon_sym_LT_LT_EQ] = ACTIONS(1475),
    [anon_sym_AMP_EQ] = ACTIONS(1475),
    [anon_sym_CARET_EQ] = ACTIONS(1475),
    [anon_sym_PIPE_EQ] = ACTIONS(1475),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1475),
    [sym__newline] = ACTIONS(1475),
  },
  [692] = {
    [anon_sym_COMMA] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1455),
    [anon_sym_COLON] = ACTIONS(1477),
    [anon_sym_EQ] = ACTIONS(1477),
    [anon_sym_and] = ACTIONS(1459),
    [anon_sym_or] = ACTIONS(1461),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_AT_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1477),
    [sym__newline] = ACTIONS(1477),
  },
  [693] = {
    [anon_sym_COMMA] = ACTIONS(1479),
    [anon_sym_if] = ACTIONS(1455),
    [anon_sym_COLON] = ACTIONS(1479),
    [anon_sym_EQ] = ACTIONS(1479),
    [anon_sym_and] = ACTIONS(1459),
    [anon_sym_or] = ACTIONS(1461),
    [anon_sym_PLUS_EQ] = ACTIONS(1479),
    [anon_sym_DASH_EQ] = ACTIONS(1479),
    [anon_sym_STAR_EQ] = ACTIONS(1479),
    [anon_sym_SLASH_EQ] = ACTIONS(1479),
    [anon_sym_AT_EQ] = ACTIONS(1479),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1479),
    [anon_sym_PERCENT_EQ] = ACTIONS(1479),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1479),
    [anon_sym_GT_GT_EQ] = ACTIONS(1479),
    [anon_sym_LT_LT_EQ] = ACTIONS(1479),
    [anon_sym_AMP_EQ] = ACTIONS(1479),
    [anon_sym_CARET_EQ] = ACTIONS(1479),
    [anon_sym_PIPE_EQ] = ACTIONS(1479),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1479),
    [sym__newline] = ACTIONS(1479),
  },
  [694] = {
    [sym_argument_list] = STATE(498),
    [sym_generator_expression] = STATE(498),
    [aux_sym_variables_repeat1] = STATE(964),
    [anon_sym_DOT] = ACTIONS(997),
    [anon_sym_LPAREN] = ACTIONS(999),
    [anon_sym_COMMA] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(1001),
    [anon_sym_GT_GT] = ACTIONS(1003),
    [anon_sym_in] = ACTIONS(1483),
    [anon_sym_AT] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(1011),
    [anon_sym_DASH] = ACTIONS(1011),
    [anon_sym_SLASH] = ACTIONS(1001),
    [anon_sym_PERCENT] = ACTIONS(1007),
    [anon_sym_SLASH_SLASH] = ACTIONS(1007),
    [anon_sym_STAR_STAR] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_AMP] = ACTIONS(1017),
    [anon_sym_CARET] = ACTIONS(1019),
    [anon_sym_LT_LT] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1025),
    [sym_comment] = ACTIONS(3),
  },
  [695] = {
    [anon_sym_COMMA] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(1455),
    [anon_sym_COLON] = ACTIONS(1485),
    [anon_sym_EQ] = ACTIONS(1485),
    [anon_sym_and] = ACTIONS(1459),
    [anon_sym_or] = ACTIONS(1461),
    [anon_sym_PLUS_EQ] = ACTIONS(1485),
    [anon_sym_DASH_EQ] = ACTIONS(1485),
    [anon_sym_STAR_EQ] = ACTIONS(1485),
    [anon_sym_SLASH_EQ] = ACTIONS(1485),
    [anon_sym_AT_EQ] = ACTIONS(1485),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1485),
    [anon_sym_PERCENT_EQ] = ACTIONS(1485),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1485),
    [anon_sym_GT_GT_EQ] = ACTIONS(1485),
    [anon_sym_LT_LT_EQ] = ACTIONS(1485),
    [anon_sym_AMP_EQ] = ACTIONS(1485),
    [anon_sym_CARET_EQ] = ACTIONS(1485),
    [anon_sym_PIPE_EQ] = ACTIONS(1485),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1485),
    [sym__newline] = ACTIONS(1485),
  },
  [696] = {
    [sym_argument_list] = STATE(498),
    [sym_generator_expression] = STATE(498),
    [anon_sym_DOT] = ACTIONS(997),
    [anon_sym_LPAREN] = ACTIONS(999),
    [anon_sym_COMMA] = ACTIONS(1487),
    [anon_sym_STAR] = ACTIONS(1001),
    [anon_sym_GT_GT] = ACTIONS(1003),
    [anon_sym_in] = ACTIONS(1487),
    [anon_sym_AT] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(1011),
    [anon_sym_DASH] = ACTIONS(1011),
    [anon_sym_SLASH] = ACTIONS(1001),
    [anon_sym_PERCENT] = ACTIONS(1007),
    [anon_sym_SLASH_SLASH] = ACTIONS(1007),
    [anon_sym_STAR_STAR] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_AMP] = ACTIONS(1017),
    [anon_sym_CARET] = ACTIONS(1019),
    [anon_sym_LT_LT] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1025),
    [sym_comment] = ACTIONS(3),
  },
  [697] = {
    [aux_sym_assert_statement_repeat1] = STATE(698),
    [anon_sym_COMMA] = ACTIONS(1489),
    [anon_sym_COLON] = ACTIONS(355),
    [anon_sym_EQ] = ACTIONS(355),
    [anon_sym_PLUS_EQ] = ACTIONS(355),
    [anon_sym_DASH_EQ] = ACTIONS(355),
    [anon_sym_STAR_EQ] = ACTIONS(355),
    [anon_sym_SLASH_EQ] = ACTIONS(355),
    [anon_sym_AT_EQ] = ACTIONS(355),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(355),
    [anon_sym_PERCENT_EQ] = ACTIONS(355),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(355),
    [anon_sym_GT_GT_EQ] = ACTIONS(355),
    [anon_sym_LT_LT_EQ] = ACTIONS(355),
    [anon_sym_AMP_EQ] = ACTIONS(355),
    [anon_sym_CARET_EQ] = ACTIONS(355),
    [anon_sym_PIPE_EQ] = ACTIONS(355),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(357),
    [sym__newline] = ACTIONS(357),
  },
  [698] = {
    [aux_sym_assert_statement_repeat1] = STATE(698),
    [anon_sym_COMMA] = ACTIONS(1491),
    [anon_sym_COLON] = ACTIONS(1485),
    [anon_sym_EQ] = ACTIONS(1485),
    [anon_sym_PLUS_EQ] = ACTIONS(1485),
    [anon_sym_DASH_EQ] = ACTIONS(1485),
    [anon_sym_STAR_EQ] = ACTIONS(1485),
    [anon_sym_SLASH_EQ] = ACTIONS(1485),
    [anon_sym_AT_EQ] = ACTIONS(1485),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1485),
    [anon_sym_PERCENT_EQ] = ACTIONS(1485),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1485),
    [anon_sym_GT_GT_EQ] = ACTIONS(1485),
    [anon_sym_LT_LT_EQ] = ACTIONS(1485),
    [anon_sym_AMP_EQ] = ACTIONS(1485),
    [anon_sym_CARET_EQ] = ACTIONS(1485),
    [anon_sym_PIPE_EQ] = ACTIONS(1485),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1485),
    [sym__newline] = ACTIONS(1485),
  },
  [699] = {
    [aux_sym_comparison_operator_repeat1] = STATE(699),
    [anon_sym_from] = ACTIONS(502),
    [anon_sym_COMMA] = ACTIONS(502),
    [anon_sym_if] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(1494),
    [anon_sym_EQ] = ACTIONS(504),
    [anon_sym_not] = ACTIONS(1497),
    [anon_sym_and] = ACTIONS(502),
    [anon_sym_or] = ACTIONS(502),
    [anon_sym_LT] = ACTIONS(1500),
    [anon_sym_LT_EQ] = ACTIONS(1494),
    [anon_sym_EQ_EQ] = ACTIONS(1494),
    [anon_sym_BANG_EQ] = ACTIONS(1494),
    [anon_sym_GT_EQ] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1500),
    [anon_sym_LT_GT] = ACTIONS(1494),
    [anon_sym_is] = ACTIONS(1503),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(502),
    [sym__newline] = ACTIONS(502),
  },
  [700] = {
    [aux_sym_assert_statement_repeat1] = STATE(698),
    [anon_sym_COMMA] = ACTIONS(1506),
    [anon_sym_COLON] = ACTIONS(355),
    [anon_sym_EQ] = ACTIONS(355),
    [anon_sym_PLUS_EQ] = ACTIONS(355),
    [anon_sym_DASH_EQ] = ACTIONS(355),
    [anon_sym_STAR_EQ] = ACTIONS(355),
    [anon_sym_SLASH_EQ] = ACTIONS(355),
    [anon_sym_AT_EQ] = ACTIONS(355),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(355),
    [anon_sym_PERCENT_EQ] = ACTIONS(355),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(355),
    [anon_sym_GT_GT_EQ] = ACTIONS(355),
    [anon_sym_LT_LT_EQ] = ACTIONS(355),
    [anon_sym_AMP_EQ] = ACTIONS(355),
    [anon_sym_CARET_EQ] = ACTIONS(355),
    [anon_sym_PIPE_EQ] = ACTIONS(355),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(355),
    [sym__newline] = ACTIONS(355),
  },
  [701] = {
    [aux_sym_comparison_operator_repeat1] = STATE(699),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_COMMA] = ACTIONS(1435),
    [anon_sym_if] = ACTIONS(1435),
    [anon_sym_in] = ACTIONS(1180),
    [anon_sym_EQ] = ACTIONS(1437),
    [anon_sym_not] = ACTIONS(1184),
    [anon_sym_and] = ACTIONS(1435),
    [anon_sym_or] = ACTIONS(1435),
    [anon_sym_LT] = ACTIONS(1196),
    [anon_sym_LT_EQ] = ACTIONS(1180),
    [anon_sym_EQ_EQ] = ACTIONS(1180),
    [anon_sym_BANG_EQ] = ACTIONS(1180),
    [anon_sym_GT_EQ] = ACTIONS(1180),
    [anon_sym_GT] = ACTIONS(1196),
    [anon_sym_LT_GT] = ACTIONS(1180),
    [anon_sym_is] = ACTIONS(1198),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1435),
    [sym__newline] = ACTIONS(1435),
  },
  [702] = {
    [anon_sym_COLON] = ACTIONS(1508),
    [anon_sym_EQ] = ACTIONS(1510),
    [anon_sym_PLUS_EQ] = ACTIONS(1512),
    [anon_sym_DASH_EQ] = ACTIONS(1512),
    [anon_sym_STAR_EQ] = ACTIONS(1512),
    [anon_sym_SLASH_EQ] = ACTIONS(1512),
    [anon_sym_AT_EQ] = ACTIONS(1512),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1512),
    [anon_sym_PERCENT_EQ] = ACTIONS(1512),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1512),
    [anon_sym_GT_GT_EQ] = ACTIONS(1512),
    [anon_sym_LT_LT_EQ] = ACTIONS(1512),
    [anon_sym_AMP_EQ] = ACTIONS(1512),
    [anon_sym_CARET_EQ] = ACTIONS(1512),
    [anon_sym_PIPE_EQ] = ACTIONS(1512),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1514),
    [sym__newline] = ACTIONS(1514),
  },
  [703] = {
    [aux_sym_comparison_operator_repeat1] = STATE(703),
    [anon_sym_COMMA] = ACTIONS(502),
    [anon_sym_as] = ACTIONS(502),
    [anon_sym_if] = ACTIONS(502),
    [anon_sym_COLON] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(1516),
    [anon_sym_not] = ACTIONS(1519),
    [anon_sym_and] = ACTIONS(502),
    [anon_sym_or] = ACTIONS(502),
    [anon_sym_LT] = ACTIONS(1522),
    [anon_sym_LT_EQ] = ACTIONS(1516),
    [anon_sym_EQ_EQ] = ACTIONS(1516),
    [anon_sym_BANG_EQ] = ACTIONS(1516),
    [anon_sym_GT_EQ] = ACTIONS(1516),
    [anon_sym_GT] = ACTIONS(1522),
    [anon_sym_LT_GT] = ACTIONS(1516),
    [anon_sym_is] = ACTIONS(1525),
    [sym_comment] = ACTIONS(3),
  },
  [704] = {
    [aux_sym_comparison_operator_repeat1] = STATE(703),
    [anon_sym_COMMA] = ACTIONS(1435),
    [anon_sym_as] = ACTIONS(1435),
    [anon_sym_if] = ACTIONS(1435),
    [anon_sym_COLON] = ACTIONS(1435),
    [anon_sym_in] = ACTIONS(1212),
    [anon_sym_not] = ACTIONS(1216),
    [anon_sym_and] = ACTIONS(1435),
    [anon_sym_or] = ACTIONS(1435),
    [anon_sym_LT] = ACTIONS(1228),
    [anon_sym_LT_EQ] = ACTIONS(1212),
    [anon_sym_EQ_EQ] = ACTIONS(1212),
    [anon_sym_BANG_EQ] = ACTIONS(1212),
    [anon_sym_GT_EQ] = ACTIONS(1212),
    [anon_sym_GT] = ACTIONS(1228),
    [anon_sym_LT_GT] = ACTIONS(1212),
    [anon_sym_is] = ACTIONS(1230),
    [sym_comment] = ACTIONS(3),
  },
  [705] = {
    [anon_sym_COLON] = ACTIONS(1508),
    [anon_sym_EQ] = ACTIONS(1510),
    [anon_sym_PLUS_EQ] = ACTIONS(1512),
    [anon_sym_DASH_EQ] = ACTIONS(1512),
    [anon_sym_STAR_EQ] = ACTIONS(1512),
    [anon_sym_SLASH_EQ] = ACTIONS(1512),
    [anon_sym_AT_EQ] = ACTIONS(1512),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1512),
    [anon_sym_PERCENT_EQ] = ACTIONS(1512),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1512),
    [anon_sym_GT_GT_EQ] = ACTIONS(1512),
    [anon_sym_LT_LT_EQ] = ACTIONS(1512),
    [anon_sym_AMP_EQ] = ACTIONS(1512),
    [anon_sym_CARET_EQ] = ACTIONS(1512),
    [anon_sym_PIPE_EQ] = ACTIONS(1512),
    [sym_comment] = ACTIONS(3),
  },
  [706] = {
    [sym_lambda_parameters] = STATE(1065),
    [sym__parameters] = STATE(1098),
    [sym_default_parameter] = STATE(1005),
    [sym_typed_default_parameter] = STATE(1005),
    [sym_list_splat] = STATE(1003),
    [sym_dictionary_splat] = STATE(1003),
    [sym_typed_parameter] = STATE(1005),
    [sym_tuple] = STATE(1005),
    [sym_identifier] = ACTIONS(1528),
    [anon_sym_LPAREN] = ACTIONS(1530),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_print] = ACTIONS(1532),
    [anon_sym_COLON] = ACTIONS(1534),
    [anon_sym_exec] = ACTIONS(1532),
    [sym_comment] = ACTIONS(3),
  },
  [707] = {
    [sym_lambda_parameters] = STATE(1094),
    [sym__parameters] = STATE(1098),
    [sym_default_parameter] = STATE(1005),
    [sym_typed_default_parameter] = STATE(1005),
    [sym_list_splat] = STATE(1003),
    [sym_dictionary_splat] = STATE(1003),
    [sym_typed_parameter] = STATE(1005),
    [sym_tuple] = STATE(1005),
    [sym_identifier] = ACTIONS(1528),
    [anon_sym_LPAREN] = ACTIONS(1530),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_print] = ACTIONS(1532),
    [anon_sym_COLON] = ACTIONS(1536),
    [anon_sym_exec] = ACTIONS(1532),
    [sym_comment] = ACTIONS(3),
  },
  [708] = {
    [sym_lambda_parameters] = STATE(1088),
    [sym__parameters] = STATE(1098),
    [sym_default_parameter] = STATE(1005),
    [sym_typed_default_parameter] = STATE(1005),
    [sym_list_splat] = STATE(1003),
    [sym_dictionary_splat] = STATE(1003),
    [sym_typed_parameter] = STATE(1005),
    [sym_tuple] = STATE(1005),
    [sym_identifier] = ACTIONS(1528),
    [anon_sym_LPAREN] = ACTIONS(1530),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_print] = ACTIONS(1532),
    [anon_sym_COLON] = ACTIONS(1538),
    [anon_sym_exec] = ACTIONS(1532),
    [sym_comment] = ACTIONS(3),
  },
  [709] = {
    [sym_lambda_parameters] = STATE(1158),
    [sym__parameters] = STATE(1098),
    [sym_default_parameter] = STATE(1005),
    [sym_typed_default_parameter] = STATE(1005),
    [sym_list_splat] = STATE(1003),
    [sym_dictionary_splat] = STATE(1003),
    [sym_typed_parameter] = STATE(1005),
    [sym_tuple] = STATE(1005),
    [sym_identifier] = ACTIONS(1528),
    [anon_sym_LPAREN] = ACTIONS(1530),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_print] = ACTIONS(1532),
    [anon_sym_COLON] = ACTIONS(1540),
    [anon_sym_exec] = ACTIONS(1532),
    [sym_comment] = ACTIONS(3),
  },
  [710] = {
    [sym_lambda_parameters] = STATE(1067),
    [sym__parameters] = STATE(1098),
    [sym_default_parameter] = STATE(1005),
    [sym_typed_default_parameter] = STATE(1005),
    [sym_list_splat] = STATE(1003),
    [sym_dictionary_splat] = STATE(1003),
    [sym_typed_parameter] = STATE(1005),
    [sym_tuple] = STATE(1005),
    [sym_identifier] = ACTIONS(1528),
    [anon_sym_LPAREN] = ACTIONS(1530),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_print] = ACTIONS(1532),
    [anon_sym_COLON] = ACTIONS(1542),
    [anon_sym_exec] = ACTIONS(1532),
    [sym_comment] = ACTIONS(3),
  },
  [711] = {
    [anon_sym_RPAREN] = ACTIONS(1479),
    [anon_sym_COMMA] = ACTIONS(1479),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_COLON] = ACTIONS(1479),
    [anon_sym_else] = ACTIONS(1479),
    [anon_sym_async] = ACTIONS(1479),
    [anon_sym_for] = ACTIONS(1479),
    [anon_sym_EQ] = ACTIONS(1479),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [anon_sym_RBRACK] = ACTIONS(1479),
    [anon_sym_RBRACE] = ACTIONS(1479),
    [sym_type_conversion] = ACTIONS(1479),
    [sym_comment] = ACTIONS(3),
  },
  [712] = {
    [anon_sym_RPAREN] = ACTIONS(1451),
    [anon_sym_COMMA] = ACTIONS(1451),
    [anon_sym_if] = ACTIONS(1451),
    [anon_sym_COLON] = ACTIONS(1451),
    [anon_sym_else] = ACTIONS(1451),
    [anon_sym_async] = ACTIONS(1451),
    [anon_sym_for] = ACTIONS(1451),
    [anon_sym_EQ] = ACTIONS(1451),
    [anon_sym_and] = ACTIONS(1451),
    [anon_sym_or] = ACTIONS(1451),
    [anon_sym_RBRACK] = ACTIONS(1451),
    [anon_sym_RBRACE] = ACTIONS(1451),
    [sym_type_conversion] = ACTIONS(1451),
    [sym_comment] = ACTIONS(3),
  },
  [713] = {
    [anon_sym_RPAREN] = ACTIONS(1469),
    [anon_sym_COMMA] = ACTIONS(1469),
    [anon_sym_if] = ACTIONS(1469),
    [anon_sym_COLON] = ACTIONS(1469),
    [anon_sym_else] = ACTIONS(1469),
    [anon_sym_async] = ACTIONS(1469),
    [anon_sym_for] = ACTIONS(1469),
    [anon_sym_EQ] = ACTIONS(1469),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1469),
    [anon_sym_RBRACK] = ACTIONS(1469),
    [anon_sym_RBRACE] = ACTIONS(1469),
    [sym_type_conversion] = ACTIONS(1469),
    [sym_comment] = ACTIONS(3),
  },
  [714] = {
    [anon_sym_RPAREN] = ACTIONS(1463),
    [anon_sym_COMMA] = ACTIONS(1463),
    [anon_sym_if] = ACTIONS(1463),
    [anon_sym_COLON] = ACTIONS(1463),
    [anon_sym_else] = ACTIONS(1463),
    [anon_sym_async] = ACTIONS(1463),
    [anon_sym_for] = ACTIONS(1463),
    [anon_sym_EQ] = ACTIONS(1463),
    [anon_sym_and] = ACTIONS(1463),
    [anon_sym_or] = ACTIONS(1463),
    [anon_sym_RBRACK] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(1463),
    [sym_type_conversion] = ACTIONS(1463),
    [sym_comment] = ACTIONS(3),
  },
  [715] = {
    [anon_sym_RPAREN] = ACTIONS(1473),
    [anon_sym_COMMA] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_COLON] = ACTIONS(1473),
    [anon_sym_else] = ACTIONS(1473),
    [anon_sym_async] = ACTIONS(1473),
    [anon_sym_for] = ACTIONS(1473),
    [anon_sym_EQ] = ACTIONS(1473),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [anon_sym_RBRACK] = ACTIONS(1473),
    [anon_sym_RBRACE] = ACTIONS(1473),
    [sym_type_conversion] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
  },
  [716] = {
    [sym__parameters] = STATE(1135),
    [sym_default_parameter] = STATE(979),
    [sym_typed_default_parameter] = STATE(979),
    [sym_list_splat] = STATE(885),
    [sym_dictionary_splat] = STATE(885),
    [sym_typed_parameter] = STATE(979),
    [sym_tuple] = STATE(979),
    [sym_identifier] = ACTIONS(1550),
    [anon_sym_LPAREN] = ACTIONS(1530),
    [anon_sym_RPAREN] = ACTIONS(1552),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_print] = ACTIONS(1554),
    [anon_sym_exec] = ACTIONS(1554),
    [sym_comment] = ACTIONS(3),
  },
  [717] = {
    [anon_sym_RPAREN] = ACTIONS(1471),
    [anon_sym_COMMA] = ACTIONS(1471),
    [anon_sym_if] = ACTIONS(1471),
    [anon_sym_COLON] = ACTIONS(1471),
    [anon_sym_else] = ACTIONS(1471),
    [anon_sym_async] = ACTIONS(1471),
    [anon_sym_for] = ACTIONS(1471),
    [anon_sym_EQ] = ACTIONS(1471),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [anon_sym_RBRACK] = ACTIONS(1471),
    [anon_sym_RBRACE] = ACTIONS(1471),
    [sym_type_conversion] = ACTIONS(1471),
    [sym_comment] = ACTIONS(3),
  },
  [718] = {
    [anon_sym_RPAREN] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_COLON] = ACTIONS(1477),
    [anon_sym_else] = ACTIONS(1477),
    [anon_sym_async] = ACTIONS(1477),
    [anon_sym_for] = ACTIONS(1477),
    [anon_sym_EQ] = ACTIONS(1477),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [anon_sym_RBRACK] = ACTIONS(1477),
    [anon_sym_RBRACE] = ACTIONS(1477),
    [sym_type_conversion] = ACTIONS(1477),
    [sym_comment] = ACTIONS(3),
  },
  [719] = {
    [anon_sym_RPAREN] = ACTIONS(1475),
    [anon_sym_COMMA] = ACTIONS(1475),
    [anon_sym_if] = ACTIONS(1475),
    [anon_sym_COLON] = ACTIONS(1475),
    [anon_sym_else] = ACTIONS(1475),
    [anon_sym_async] = ACTIONS(1475),
    [anon_sym_for] = ACTIONS(1475),
    [anon_sym_EQ] = ACTIONS(1475),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [anon_sym_RBRACK] = ACTIONS(1475),
    [anon_sym_RBRACE] = ACTIONS(1475),
    [sym_type_conversion] = ACTIONS(1475),
    [sym_comment] = ACTIONS(3),
  },
  [720] = {
    [sym_default_parameter] = STATE(959),
    [sym_typed_default_parameter] = STATE(959),
    [sym_list_splat] = STATE(1036),
    [sym_dictionary_splat] = STATE(1036),
    [sym_typed_parameter] = STATE(959),
    [sym_tuple] = STATE(959),
    [sym_identifier] = ACTIONS(1556),
    [anon_sym_LPAREN] = ACTIONS(1530),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_print] = ACTIONS(1558),
    [anon_sym_COLON] = ACTIONS(1560),
    [anon_sym_exec] = ACTIONS(1558),
    [sym_comment] = ACTIONS(3),
  },
  [721] = {
    [sym_default_parameter] = STATE(959),
    [sym_typed_default_parameter] = STATE(959),
    [sym_list_splat] = STATE(920),
    [sym_dictionary_splat] = STATE(920),
    [sym_typed_parameter] = STATE(959),
    [sym_tuple] = STATE(959),
    [sym_identifier] = ACTIONS(1562),
    [anon_sym_LPAREN] = ACTIONS(1530),
    [anon_sym_RPAREN] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_print] = ACTIONS(1566),
    [anon_sym_exec] = ACTIONS(1566),
    [sym_comment] = ACTIONS(3),
  },
  [722] = {
    [sym_default_parameter] = STATE(959),
    [sym_typed_default_parameter] = STATE(959),
    [sym_list_splat] = STATE(920),
    [sym_dictionary_splat] = STATE(920),
    [sym_typed_parameter] = STATE(959),
    [sym_tuple] = STATE(959),
    [sym_identifier] = ACTIONS(1562),
    [anon_sym_LPAREN] = ACTIONS(1530),
    [anon_sym_RPAREN] = ACTIONS(1568),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_print] = ACTIONS(1566),
    [anon_sym_exec] = ACTIONS(1566),
    [sym_comment] = ACTIONS(3),
  },
  [723] = {
    [sym_default_parameter] = STATE(959),
    [sym_typed_default_parameter] = STATE(959),
    [sym_list_splat] = STATE(1036),
    [sym_dictionary_splat] = STATE(1036),
    [sym_typed_parameter] = STATE(959),
    [sym_tuple] = STATE(959),
    [sym_identifier] = ACTIONS(1556),
    [anon_sym_LPAREN] = ACTIONS(1530),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_print] = ACTIONS(1558),
    [anon_sym_COLON] = ACTIONS(1568),
    [anon_sym_exec] = ACTIONS(1558),
    [sym_comment] = ACTIONS(3),
  },
  [724] = {
    [sym_default_parameter] = STATE(959),
    [sym_typed_default_parameter] = STATE(959),
    [sym_list_splat] = STATE(1036),
    [sym_dictionary_splat] = STATE(1036),
    [sym_typed_parameter] = STATE(959),
    [sym_tuple] = STATE(959),
    [sym_identifier] = ACTIONS(1556),
    [anon_sym_LPAREN] = ACTIONS(1530),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_print] = ACTIONS(1558),
    [anon_sym_COLON] = ACTIONS(1564),
    [anon_sym_exec] = ACTIONS(1558),
    [sym_comment] = ACTIONS(3),
  },
  [725] = {
    [sym_default_parameter] = STATE(959),
    [sym_typed_default_parameter] = STATE(959),
    [sym_list_splat] = STATE(920),
    [sym_dictionary_splat] = STATE(920),
    [sym_typed_parameter] = STATE(959),
    [sym_tuple] = STATE(959),
    [sym_identifier] = ACTIONS(1562),
    [anon_sym_LPAREN] = ACTIONS(1530),
    [anon_sym_RPAREN] = ACTIONS(1560),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_print] = ACTIONS(1566),
    [anon_sym_exec] = ACTIONS(1566),
    [sym_comment] = ACTIONS(3),
  },
  [726] = {
    [sym_default_parameter] = STATE(959),
    [sym_typed_default_parameter] = STATE(959),
    [sym_list_splat] = STATE(920),
    [sym_dictionary_splat] = STATE(920),
    [sym_typed_parameter] = STATE(959),
    [sym_tuple] = STATE(959),
    [sym_identifier] = ACTIONS(1562),
    [anon_sym_LPAREN] = ACTIONS(1530),
    [anon_sym_RPAREN] = ACTIONS(1570),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_print] = ACTIONS(1566),
    [anon_sym_exec] = ACTIONS(1566),
    [sym_comment] = ACTIONS(3),
  },
  [727] = {
    [sym_default_parameter] = STATE(959),
    [sym_typed_default_parameter] = STATE(959),
    [sym_list_splat] = STATE(1036),
    [sym_dictionary_splat] = STATE(1036),
    [sym_typed_parameter] = STATE(959),
    [sym_tuple] = STATE(959),
    [sym_identifier] = ACTIONS(1556),
    [anon_sym_LPAREN] = ACTIONS(1530),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_print] = ACTIONS(1558),
    [anon_sym_COLON] = ACTIONS(1570),
    [anon_sym_exec] = ACTIONS(1558),
    [sym_comment] = ACTIONS(3),
  },
  [728] = {
    [sym_default_parameter] = STATE(959),
    [sym_typed_default_parameter] = STATE(959),
    [sym_list_splat] = STATE(1036),
    [sym_dictionary_splat] = STATE(1036),
    [sym_typed_parameter] = STATE(959),
    [sym_tuple] = STATE(959),
    [sym_identifier] = ACTIONS(1556),
    [anon_sym_LPAREN] = ACTIONS(1530),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_print] = ACTIONS(1558),
    [anon_sym_exec] = ACTIONS(1558),
    [sym_comment] = ACTIONS(3),
  },
  [729] = {
    [sym__comprehension_clauses] = STATE(1064),
    [sym_for_in_clause] = STATE(746),
    [aux_sym_list_repeat1] = STATE(977),
    [anon_sym_COMMA] = ACTIONS(1572),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_COLON] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1576),
    [anon_sym_for] = ACTIONS(1578),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [anon_sym_RBRACE] = ACTIONS(1580),
    [sym_comment] = ACTIONS(3),
  },
  [730] = {
    [sym_default_parameter] = STATE(959),
    [sym_typed_default_parameter] = STATE(959),
    [sym_list_splat] = STATE(920),
    [sym_dictionary_splat] = STATE(920),
    [sym_typed_parameter] = STATE(959),
    [sym_tuple] = STATE(959),
    [sym_identifier] = ACTIONS(1562),
    [anon_sym_LPAREN] = ACTIONS(1530),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_print] = ACTIONS(1566),
    [anon_sym_exec] = ACTIONS(1566),
    [sym_comment] = ACTIONS(3),
  },
  [731] = {
    [sym__comprehension_clauses] = STATE(1089),
    [sym_for_in_clause] = STATE(746),
    [aux_sym_list_repeat1] = STATE(1019),
    [anon_sym_COMMA] = ACTIONS(1582),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_COLON] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1576),
    [anon_sym_for] = ACTIONS(1578),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [anon_sym_RBRACE] = ACTIONS(1584),
    [sym_comment] = ACTIONS(3),
  },
  [732] = {
    [sym__comprehension_clauses] = STATE(1075),
    [sym_for_in_clause] = STATE(746),
    [aux_sym_list_repeat1] = STATE(953),
    [anon_sym_COMMA] = ACTIONS(1586),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_COLON] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1576),
    [anon_sym_for] = ACTIONS(1578),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [anon_sym_RBRACE] = ACTIONS(1588),
    [sym_comment] = ACTIONS(3),
  },
  [733] = {
    [sym__comprehension_clauses] = STATE(1125),
    [sym_for_in_clause] = STATE(746),
    [aux_sym_list_repeat1] = STATE(950),
    [anon_sym_COMMA] = ACTIONS(1590),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_COLON] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1576),
    [anon_sym_for] = ACTIONS(1578),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [anon_sym_RBRACE] = ACTIONS(1592),
    [sym_comment] = ACTIONS(3),
  },
  [734] = {
    [sym__comprehension_clauses] = STATE(1117),
    [sym_for_in_clause] = STATE(746),
    [aux_sym_tuple_repeat1] = STATE(973),
    [anon_sym_RPAREN] = ACTIONS(1594),
    [anon_sym_COMMA] = ACTIONS(1596),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_async] = ACTIONS(1576),
    [anon_sym_for] = ACTIONS(1578),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [sym_comment] = ACTIONS(3),
  },
  [735] = {
    [sym__comprehension_clauses] = STATE(1080),
    [sym_for_in_clause] = STATE(746),
    [aux_sym_argument_list_repeat1] = STATE(998),
    [anon_sym_RPAREN] = ACTIONS(1598),
    [anon_sym_COMMA] = ACTIONS(1600),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_async] = ACTIONS(1576),
    [anon_sym_for] = ACTIONS(1578),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [sym_comment] = ACTIONS(3),
  },
  [736] = {
    [sym__comprehension_clauses] = STATE(1083),
    [sym_for_in_clause] = STATE(746),
    [aux_sym_list_repeat1] = STATE(993),
    [anon_sym_COMMA] = ACTIONS(1602),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_async] = ACTIONS(1576),
    [anon_sym_for] = ACTIONS(1578),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [anon_sym_RBRACK] = ACTIONS(1604),
    [sym_comment] = ACTIONS(3),
  },
  [737] = {
    [sym__comprehension_clauses] = STATE(1131),
    [sym_for_in_clause] = STATE(746),
    [aux_sym_list_repeat1] = STATE(948),
    [anon_sym_COMMA] = ACTIONS(1606),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_async] = ACTIONS(1576),
    [anon_sym_for] = ACTIONS(1578),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [anon_sym_RBRACK] = ACTIONS(1608),
    [sym_comment] = ACTIONS(3),
  },
  [738] = {
    [sym__comprehension_clauses] = STATE(1070),
    [sym_for_in_clause] = STATE(746),
    [aux_sym_list_repeat1] = STATE(1008),
    [anon_sym_COMMA] = ACTIONS(1610),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_async] = ACTIONS(1576),
    [anon_sym_for] = ACTIONS(1578),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [anon_sym_RBRACK] = ACTIONS(1612),
    [sym_comment] = ACTIONS(3),
  },
  [739] = {
    [sym__comprehension_clauses] = STATE(1085),
    [sym_for_in_clause] = STATE(746),
    [aux_sym_tuple_repeat1] = STATE(1002),
    [anon_sym_RPAREN] = ACTIONS(1614),
    [anon_sym_COMMA] = ACTIONS(1616),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_async] = ACTIONS(1576),
    [anon_sym_for] = ACTIONS(1578),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [sym_comment] = ACTIONS(3),
  },
  [740] = {
    [sym__comprehension_clauses] = STATE(1138),
    [sym_for_in_clause] = STATE(746),
    [aux_sym_argument_list_repeat1] = STATE(972),
    [anon_sym_RPAREN] = ACTIONS(1618),
    [anon_sym_COMMA] = ACTIONS(1620),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_async] = ACTIONS(1576),
    [anon_sym_for] = ACTIONS(1578),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [sym_comment] = ACTIONS(3),
  },
  [741] = {
    [sym__comprehension_clauses] = STATE(1084),
    [sym_for_in_clause] = STATE(746),
    [aux_sym_list_repeat1] = STATE(915),
    [anon_sym_COMMA] = ACTIONS(1622),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_async] = ACTIONS(1576),
    [anon_sym_for] = ACTIONS(1578),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [anon_sym_RBRACK] = ACTIONS(1624),
    [sym_comment] = ACTIONS(3),
  },
  [742] = {
    [sym__comprehension_clauses] = STATE(1080),
    [sym_for_in_clause] = STATE(746),
    [aux_sym_tuple_repeat1] = STATE(992),
    [anon_sym_RPAREN] = ACTIONS(1626),
    [anon_sym_COMMA] = ACTIONS(1628),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_async] = ACTIONS(1576),
    [anon_sym_for] = ACTIONS(1578),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [sym_comment] = ACTIONS(3),
  },
  [743] = {
    [sym__comprehension_clauses] = STATE(1085),
    [sym_for_in_clause] = STATE(746),
    [aux_sym_argument_list_repeat1] = STATE(943),
    [anon_sym_RPAREN] = ACTIONS(1630),
    [anon_sym_COMMA] = ACTIONS(1632),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_async] = ACTIONS(1576),
    [anon_sym_for] = ACTIONS(1578),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [sym_comment] = ACTIONS(3),
  },
  [744] = {
    [sym__comprehension_clauses] = STATE(1117),
    [sym_for_in_clause] = STATE(746),
    [aux_sym_argument_list_repeat1] = STATE(982),
    [anon_sym_RPAREN] = ACTIONS(1634),
    [anon_sym_COMMA] = ACTIONS(1636),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_async] = ACTIONS(1576),
    [anon_sym_for] = ACTIONS(1578),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [sym_comment] = ACTIONS(3),
  },
  [745] = {
    [sym__comprehension_clauses] = STATE(1138),
    [sym_for_in_clause] = STATE(746),
    [aux_sym_tuple_repeat1] = STATE(939),
    [anon_sym_RPAREN] = ACTIONS(1638),
    [anon_sym_COMMA] = ACTIONS(1640),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_async] = ACTIONS(1576),
    [anon_sym_for] = ACTIONS(1578),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [sym_comment] = ACTIONS(3),
  },
  [746] = {
    [sym_for_in_clause] = STATE(750),
    [sym_if_clause] = STATE(750),
    [aux_sym__comprehension_clauses_repeat1] = STATE(750),
    [anon_sym_RPAREN] = ACTIONS(1642),
    [anon_sym_if] = ACTIONS(1644),
    [anon_sym_async] = ACTIONS(1576),
    [anon_sym_for] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1642),
    [anon_sym_RBRACE] = ACTIONS(1642),
    [sym_comment] = ACTIONS(3),
  },
  [747] = {
    [anon_sym_RPAREN] = ACTIONS(1646),
    [anon_sym_COMMA] = ACTIONS(1646),
    [anon_sym_if] = ACTIONS(1646),
    [anon_sym_async] = ACTIONS(1646),
    [anon_sym_for] = ACTIONS(1646),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [anon_sym_RBRACK] = ACTIONS(1646),
    [anon_sym_RBRACE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(3),
  },
  [748] = {
    [sym_for_in_clause] = STATE(748),
    [sym_if_clause] = STATE(748),
    [aux_sym__comprehension_clauses_repeat1] = STATE(748),
    [anon_sym_RPAREN] = ACTIONS(1648),
    [anon_sym_if] = ACTIONS(1650),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_for] = ACTIONS(1656),
    [anon_sym_RBRACK] = ACTIONS(1648),
    [anon_sym_RBRACE] = ACTIONS(1648),
    [sym_comment] = ACTIONS(3),
  },
  [749] = {
    [anon_sym_RPAREN] = ACTIONS(1646),
    [anon_sym_COMMA] = ACTIONS(1646),
    [anon_sym_if] = ACTIONS(1646),
    [anon_sym_async] = ACTIONS(1646),
    [anon_sym_for] = ACTIONS(1646),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [anon_sym_RBRACK] = ACTIONS(1646),
    [anon_sym_RBRACE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(3),
  },
  [750] = {
    [sym_for_in_clause] = STATE(748),
    [sym_if_clause] = STATE(748),
    [aux_sym__comprehension_clauses_repeat1] = STATE(748),
    [anon_sym_RPAREN] = ACTIONS(1659),
    [anon_sym_if] = ACTIONS(1644),
    [anon_sym_async] = ACTIONS(1576),
    [anon_sym_for] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1659),
    [anon_sym_RBRACE] = ACTIONS(1659),
    [sym_comment] = ACTIONS(3),
  },
  [751] = {
    [anon_sym_RPAREN] = ACTIONS(1646),
    [anon_sym_COMMA] = ACTIONS(1646),
    [anon_sym_if] = ACTIONS(1646),
    [anon_sym_async] = ACTIONS(1646),
    [anon_sym_for] = ACTIONS(1646),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [anon_sym_RBRACK] = ACTIONS(1646),
    [anon_sym_RBRACE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(3),
  },
  [752] = {
    [aux_sym_for_in_clause_repeat1] = STATE(755),
    [anon_sym_RPAREN] = ACTIONS(1661),
    [anon_sym_COMMA] = ACTIONS(1663),
    [anon_sym_if] = ACTIONS(1661),
    [anon_sym_async] = ACTIONS(1661),
    [anon_sym_for] = ACTIONS(1661),
    [anon_sym_RBRACK] = ACTIONS(1661),
    [anon_sym_RBRACE] = ACTIONS(1661),
    [sym_comment] = ACTIONS(3),
  },
  [753] = {
    [anon_sym_from] = ACTIONS(1473),
    [anon_sym_COMMA] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(1665),
    [anon_sym_EQ] = ACTIONS(1473),
    [anon_sym_and] = ACTIONS(1667),
    [anon_sym_or] = ACTIONS(1669),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1473),
    [sym__newline] = ACTIONS(1473),
  },
  [754] = {
    [sym_function_definition] = STATE(444),
    [sym_class_definition] = STATE(444),
    [sym_decorator] = STATE(829),
    [aux_sym_decorated_definition_repeat1] = STATE(829),
    [anon_sym_async] = ACTIONS(1671),
    [anon_sym_def] = ACTIONS(1673),
    [anon_sym_class] = ACTIONS(1675),
    [anon_sym_AT] = ACTIONS(53),
    [sym_comment] = ACTIONS(3),
  },
  [755] = {
    [aux_sym_for_in_clause_repeat1] = STATE(755),
    [anon_sym_RPAREN] = ACTIONS(1677),
    [anon_sym_COMMA] = ACTIONS(1679),
    [anon_sym_if] = ACTIONS(1677),
    [anon_sym_async] = ACTIONS(1677),
    [anon_sym_for] = ACTIONS(1677),
    [anon_sym_RBRACK] = ACTIONS(1677),
    [anon_sym_RBRACE] = ACTIONS(1677),
    [sym_comment] = ACTIONS(3),
  },
  [756] = {
    [aux_sym_for_in_clause_repeat1] = STATE(755),
    [anon_sym_RPAREN] = ACTIONS(1682),
    [anon_sym_COMMA] = ACTIONS(1684),
    [anon_sym_if] = ACTIONS(1682),
    [anon_sym_async] = ACTIONS(1682),
    [anon_sym_for] = ACTIONS(1682),
    [anon_sym_RBRACK] = ACTIONS(1682),
    [anon_sym_RBRACE] = ACTIONS(1682),
    [sym_comment] = ACTIONS(3),
  },
  [757] = {
    [anon_sym_RPAREN] = ACTIONS(1686),
    [anon_sym_if] = ACTIONS(1686),
    [anon_sym_async] = ACTIONS(1686),
    [anon_sym_for] = ACTIONS(1686),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [anon_sym_RBRACK] = ACTIONS(1686),
    [anon_sym_RBRACE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(3),
  },
  [758] = {
    [sym_function_definition] = STATE(448),
    [sym_class_definition] = STATE(448),
    [sym_decorator] = STATE(829),
    [aux_sym_decorated_definition_repeat1] = STATE(829),
    [anon_sym_async] = ACTIONS(1688),
    [anon_sym_def] = ACTIONS(1690),
    [anon_sym_class] = ACTIONS(1692),
    [anon_sym_AT] = ACTIONS(53),
    [sym_comment] = ACTIONS(3),
  },
  [759] = {
    [aux_sym_for_in_clause_repeat1] = STATE(756),
    [anon_sym_RPAREN] = ACTIONS(1694),
    [anon_sym_COMMA] = ACTIONS(1696),
    [anon_sym_if] = ACTIONS(1694),
    [anon_sym_async] = ACTIONS(1694),
    [anon_sym_for] = ACTIONS(1694),
    [anon_sym_RBRACK] = ACTIONS(1694),
    [anon_sym_RBRACE] = ACTIONS(1694),
    [sym_comment] = ACTIONS(3),
  },
  [760] = {
    [aux_sym_assert_statement_repeat1] = STATE(842),
    [anon_sym_from] = ACTIONS(1457),
    [anon_sym_COMMA] = ACTIONS(1698),
    [anon_sym_if] = ACTIONS(1665),
    [anon_sym_and] = ACTIONS(1667),
    [anon_sym_or] = ACTIONS(1669),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1457),
    [sym__newline] = ACTIONS(1457),
  },
  [761] = {
    [aux_sym_for_in_clause_repeat1] = STATE(752),
    [anon_sym_RPAREN] = ACTIONS(1700),
    [anon_sym_COMMA] = ACTIONS(1702),
    [anon_sym_if] = ACTIONS(1700),
    [anon_sym_async] = ACTIONS(1700),
    [anon_sym_for] = ACTIONS(1700),
    [anon_sym_RBRACK] = ACTIONS(1700),
    [anon_sym_RBRACE] = ACTIONS(1700),
    [sym_comment] = ACTIONS(3),
  },
  [762] = {
    [anon_sym_from] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1665),
    [anon_sym_EQ] = ACTIONS(1477),
    [anon_sym_and] = ACTIONS(1667),
    [anon_sym_or] = ACTIONS(1669),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1477),
    [sym__newline] = ACTIONS(1477),
  },
  [763] = {
    [anon_sym_RPAREN] = ACTIONS(1704),
    [anon_sym_COMMA] = ACTIONS(1704),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_COLON] = ACTIONS(1704),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [anon_sym_RBRACK] = ACTIONS(1704),
    [anon_sym_RBRACE] = ACTIONS(1704),
    [sym_comment] = ACTIONS(3),
  },
  [764] = {
    [anon_sym_from] = ACTIONS(1469),
    [anon_sym_COMMA] = ACTIONS(1469),
    [anon_sym_if] = ACTIONS(1469),
    [anon_sym_EQ] = ACTIONS(1469),
    [anon_sym_and] = ACTIONS(1667),
    [anon_sym_or] = ACTIONS(1469),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1469),
    [sym__newline] = ACTIONS(1469),
  },
  [765] = {
    [anon_sym_from] = ACTIONS(1475),
    [anon_sym_COMMA] = ACTIONS(1475),
    [anon_sym_if] = ACTIONS(1475),
    [anon_sym_EQ] = ACTIONS(1475),
    [anon_sym_and] = ACTIONS(1667),
    [anon_sym_or] = ACTIONS(1669),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1475),
    [sym__newline] = ACTIONS(1475),
  },
  [766] = {
    [anon_sym_from] = ACTIONS(1479),
    [anon_sym_COMMA] = ACTIONS(1479),
    [anon_sym_if] = ACTIONS(1665),
    [anon_sym_EQ] = ACTIONS(1479),
    [anon_sym_and] = ACTIONS(1667),
    [anon_sym_or] = ACTIONS(1669),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1479),
    [sym__newline] = ACTIONS(1479),
  },
  [767] = {
    [anon_sym_from] = ACTIONS(1471),
    [anon_sym_COMMA] = ACTIONS(1471),
    [anon_sym_if] = ACTIONS(1471),
    [anon_sym_EQ] = ACTIONS(1471),
    [anon_sym_and] = ACTIONS(1667),
    [anon_sym_or] = ACTIONS(1669),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1471),
    [sym__newline] = ACTIONS(1471),
  },
  [768] = {
    [anon_sym_RPAREN] = ACTIONS(1706),
    [anon_sym_COMMA] = ACTIONS(1706),
    [anon_sym_if] = ACTIONS(1706),
    [anon_sym_async] = ACTIONS(1706),
    [anon_sym_for] = ACTIONS(1706),
    [anon_sym_RBRACK] = ACTIONS(1706),
    [anon_sym_RBRACE] = ACTIONS(1706),
    [sym_comment] = ACTIONS(3),
  },
  [769] = {
    [sym__comprehension_clauses] = STATE(1123),
    [sym_for_in_clause] = STATE(746),
    [aux_sym_dictionary_repeat1] = STATE(952),
    [anon_sym_COMMA] = ACTIONS(1708),
    [anon_sym_async] = ACTIONS(1576),
    [anon_sym_for] = ACTIONS(1578),
    [anon_sym_RBRACE] = ACTIONS(1710),
    [sym_comment] = ACTIONS(3),
  },
  [770] = {
    [anon_sym_COMMA] = ACTIONS(1712),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_async] = ACTIONS(1712),
    [anon_sym_for] = ACTIONS(1712),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [anon_sym_RBRACE] = ACTIONS(1712),
    [sym_comment] = ACTIONS(3),
  },
  [771] = {
    [aux_sym_dotted_name_repeat1] = STATE(788),
    [anon_sym_DOT] = ACTIONS(1714),
    [anon_sym_LPAREN] = ACTIONS(1716),
    [anon_sym_COMMA] = ACTIONS(1716),
    [anon_sym_as] = ACTIONS(1716),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1716),
    [sym__newline] = ACTIONS(1716),
  },
  [772] = {
    [anon_sym_from] = ACTIONS(1485),
    [anon_sym_COMMA] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(1665),
    [anon_sym_and] = ACTIONS(1667),
    [anon_sym_or] = ACTIONS(1669),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1485),
    [sym__newline] = ACTIONS(1485),
  },
  [773] = {
    [anon_sym_RPAREN] = ACTIONS(1718),
    [anon_sym_COMMA] = ACTIONS(1718),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_COLON] = ACTIONS(1718),
    [anon_sym_EQ] = ACTIONS(1718),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [sym_comment] = ACTIONS(3),
  },
  [774] = {
    [aux_sym_subscript_repeat1] = STATE(994),
    [anon_sym_COMMA] = ACTIONS(1720),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_COLON] = ACTIONS(1722),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [anon_sym_RBRACK] = ACTIONS(1724),
    [sym_comment] = ACTIONS(3),
  },
  [775] = {
    [aux_sym_print_statement_repeat1] = STATE(905),
    [anon_sym_COMMA] = ACTIONS(1726),
    [anon_sym_if] = ACTIONS(1665),
    [anon_sym_and] = ACTIONS(1667),
    [anon_sym_or] = ACTIONS(1669),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1728),
    [sym__newline] = ACTIONS(1728),
  },
  [776] = {
    [sym_format_specifier] = STATE(1105),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_COLON] = ACTIONS(1730),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [anon_sym_RBRACE] = ACTIONS(1732),
    [sym_type_conversion] = ACTIONS(1734),
    [sym_comment] = ACTIONS(3),
  },
  [777] = {
    [aux_sym_assert_statement_repeat1] = STATE(903),
    [anon_sym_COMMA] = ACTIONS(1736),
    [anon_sym_if] = ACTIONS(1665),
    [anon_sym_and] = ACTIONS(1667),
    [anon_sym_or] = ACTIONS(1669),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1738),
    [sym__newline] = ACTIONS(1738),
  },
  [778] = {
    [sym__comprehension_clauses] = STATE(1090),
    [sym_for_in_clause] = STATE(746),
    [aux_sym_dictionary_repeat1] = STATE(1016),
    [anon_sym_COMMA] = ACTIONS(1740),
    [anon_sym_async] = ACTIONS(1576),
    [anon_sym_for] = ACTIONS(1578),
    [anon_sym_RBRACE] = ACTIONS(1742),
    [sym_comment] = ACTIONS(3),
  },
  [779] = {
    [aux_sym_assert_statement_repeat1] = STATE(880),
    [anon_sym_RPAREN] = ACTIONS(1457),
    [anon_sym_COMMA] = ACTIONS(1744),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_COLON] = ACTIONS(1457),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [sym_comment] = ACTIONS(3),
  },
  [780] = {
    [aux_sym_subscript_repeat1] = STATE(984),
    [anon_sym_COMMA] = ACTIONS(1746),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_COLON] = ACTIONS(1722),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [anon_sym_RBRACK] = ACTIONS(1748),
    [sym_comment] = ACTIONS(3),
  },
  [781] = {
    [anon_sym_RPAREN] = ACTIONS(1677),
    [anon_sym_COMMA] = ACTIONS(1677),
    [anon_sym_if] = ACTIONS(1677),
    [anon_sym_async] = ACTIONS(1677),
    [anon_sym_for] = ACTIONS(1677),
    [anon_sym_RBRACK] = ACTIONS(1677),
    [anon_sym_RBRACE] = ACTIONS(1677),
    [sym_comment] = ACTIONS(3),
  },
  [782] = {
    [aux_sym_subscript_repeat1] = STATE(974),
    [anon_sym_COMMA] = ACTIONS(1750),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_COLON] = ACTIONS(1722),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [anon_sym_RBRACK] = ACTIONS(1752),
    [sym_comment] = ACTIONS(3),
  },
  [783] = {
    [sym__comprehension_clauses] = STATE(1069),
    [sym_for_in_clause] = STATE(746),
    [aux_sym_dictionary_repeat1] = STATE(949),
    [anon_sym_COMMA] = ACTIONS(1754),
    [anon_sym_async] = ACTIONS(1576),
    [anon_sym_for] = ACTIONS(1578),
    [anon_sym_RBRACE] = ACTIONS(1756),
    [sym_comment] = ACTIONS(3),
  },
  [784] = {
    [anon_sym_RPAREN] = ACTIONS(1758),
    [anon_sym_COMMA] = ACTIONS(1758),
    [anon_sym_if] = ACTIONS(1758),
    [anon_sym_async] = ACTIONS(1758),
    [anon_sym_for] = ACTIONS(1758),
    [anon_sym_RBRACK] = ACTIONS(1758),
    [anon_sym_RBRACE] = ACTIONS(1758),
    [sym_comment] = ACTIONS(3),
  },
  [785] = {
    [sym__import_list] = STATE(1047),
    [sym_aliased_import] = STATE(878),
    [sym_wildcard_import] = STATE(1047),
    [sym_dotted_name] = STATE(854),
    [sym_identifier] = ACTIONS(1760),
    [anon_sym_LPAREN] = ACTIONS(1762),
    [anon_sym_STAR] = ACTIONS(1764),
    [sym_comment] = ACTIONS(3),
  },
  [786] = {
    [anon_sym_RPAREN] = ACTIONS(1766),
    [anon_sym_COMMA] = ACTIONS(1766),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_COLON] = ACTIONS(1766),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [anon_sym_RBRACE] = ACTIONS(1766),
    [sym_comment] = ACTIONS(3),
  },
  [787] = {
    [sym_import_prefix] = STATE(1000),
    [sym_relative_import] = STATE(1099),
    [sym_dotted_name] = STATE(1099),
    [aux_sym_import_prefix_repeat1] = STATE(879),
    [sym_identifier] = ACTIONS(1768),
    [anon_sym_DOT] = ACTIONS(1770),
    [anon_sym___future__] = ACTIONS(1772),
    [sym_comment] = ACTIONS(3),
  },
  [788] = {
    [aux_sym_dotted_name_repeat1] = STATE(790),
    [anon_sym_DOT] = ACTIONS(1714),
    [anon_sym_LPAREN] = ACTIONS(1774),
    [anon_sym_COMMA] = ACTIONS(1774),
    [anon_sym_as] = ACTIONS(1774),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1774),
    [sym__newline] = ACTIONS(1774),
  },
  [789] = {
    [aux_sym_assert_statement_repeat1] = STATE(899),
    [anon_sym_COMMA] = ACTIONS(1736),
    [anon_sym_if] = ACTIONS(1665),
    [anon_sym_and] = ACTIONS(1667),
    [anon_sym_or] = ACTIONS(1669),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1776),
    [sym__newline] = ACTIONS(1776),
  },
  [790] = {
    [aux_sym_dotted_name_repeat1] = STATE(790),
    [anon_sym_DOT] = ACTIONS(1778),
    [anon_sym_LPAREN] = ACTIONS(1781),
    [anon_sym_COMMA] = ACTIONS(1781),
    [anon_sym_as] = ACTIONS(1781),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1781),
    [sym__newline] = ACTIONS(1781),
  },
  [791] = {
    [aux_sym_subscript_repeat1] = STATE(940),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_COLON] = ACTIONS(1722),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [anon_sym_RBRACK] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
  },
  [792] = {
    [sym__comprehension_clauses] = STATE(1081),
    [sym_for_in_clause] = STATE(746),
    [aux_sym_dictionary_repeat1] = STATE(966),
    [anon_sym_COMMA] = ACTIONS(1787),
    [anon_sym_async] = ACTIONS(1576),
    [anon_sym_for] = ACTIONS(1578),
    [anon_sym_RBRACE] = ACTIONS(1789),
    [sym_comment] = ACTIONS(3),
  },
  [793] = {
    [anon_sym_COMMA] = ACTIONS(1791),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [anon_sym_RBRACK] = ACTIONS(1791),
    [anon_sym_RBRACE] = ACTIONS(1791),
    [sym_comment] = ACTIONS(3),
  },
  [794] = {
    [anon_sym_COMMA] = ACTIONS(1793),
    [anon_sym_as] = ACTIONS(1795),
    [anon_sym_if] = ACTIONS(1797),
    [anon_sym_COLON] = ACTIONS(1793),
    [anon_sym_and] = ACTIONS(1799),
    [anon_sym_or] = ACTIONS(1801),
    [sym_comment] = ACTIONS(3),
  },
  [795] = {
    [anon_sym_COMMA] = ACTIONS(1803),
    [anon_sym_as] = ACTIONS(1803),
    [anon_sym_if] = ACTIONS(1797),
    [anon_sym_COLON] = ACTIONS(1805),
    [anon_sym_and] = ACTIONS(1799),
    [anon_sym_or] = ACTIONS(1801),
    [sym_comment] = ACTIONS(3),
  },
  [796] = {
    [sym_interpolation] = STATE(801),
    [aux_sym_string_repeat1] = STATE(801),
    [anon_sym_LBRACE] = ACTIONS(1807),
    [sym_escape_sequence] = ACTIONS(1809),
    [sym_comment] = ACTIONS(1811),
    [sym__string_content] = ACTIONS(1809),
    [sym__string_end] = ACTIONS(1813),
  },
  [797] = {
    [anon_sym_COMMA] = ACTIONS(1815),
    [anon_sym_as] = ACTIONS(1815),
    [anon_sym_if] = ACTIONS(1797),
    [anon_sym_COLON] = ACTIONS(1817),
    [anon_sym_and] = ACTIONS(1799),
    [anon_sym_or] = ACTIONS(1801),
    [sym_comment] = ACTIONS(3),
  },
  [798] = {
    [sym_interpolation] = STATE(813),
    [aux_sym_string_repeat1] = STATE(813),
    [anon_sym_LBRACE] = ACTIONS(1807),
    [sym_escape_sequence] = ACTIONS(1819),
    [sym_comment] = ACTIONS(1811),
    [sym__string_content] = ACTIONS(1819),
    [sym__string_end] = ACTIONS(1821),
  },
  [799] = {
    [anon_sym_if] = ACTIONS(1665),
    [anon_sym_EQ] = ACTIONS(1718),
    [anon_sym_and] = ACTIONS(1667),
    [anon_sym_or] = ACTIONS(1669),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1718),
    [sym__newline] = ACTIONS(1718),
  },
  [800] = {
    [sym_interpolation] = STATE(801),
    [aux_sym_string_repeat1] = STATE(801),
    [anon_sym_LBRACE] = ACTIONS(1807),
    [sym_escape_sequence] = ACTIONS(1809),
    [sym_comment] = ACTIONS(1811),
    [sym__string_content] = ACTIONS(1809),
    [sym__string_end] = ACTIONS(1823),
  },
  [801] = {
    [sym_interpolation] = STATE(801),
    [aux_sym_string_repeat1] = STATE(801),
    [anon_sym_LBRACE] = ACTIONS(1825),
    [sym_escape_sequence] = ACTIONS(1828),
    [sym_comment] = ACTIONS(1811),
    [sym__string_content] = ACTIONS(1828),
    [sym__string_end] = ACTIONS(1831),
  },
  [802] = {
    [sym_interpolation] = STATE(801),
    [aux_sym_string_repeat1] = STATE(801),
    [anon_sym_LBRACE] = ACTIONS(1807),
    [sym_escape_sequence] = ACTIONS(1809),
    [sym_comment] = ACTIONS(1811),
    [sym__string_content] = ACTIONS(1809),
    [sym__string_end] = ACTIONS(1833),
  },
  [803] = {
    [anon_sym_COMMA] = ACTIONS(1835),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_COLON] = ACTIONS(1722),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [anon_sym_RBRACK] = ACTIONS(1835),
    [sym_comment] = ACTIONS(3),
  },
  [804] = {
    [sym_interpolation] = STATE(802),
    [aux_sym_string_repeat1] = STATE(802),
    [anon_sym_LBRACE] = ACTIONS(1807),
    [sym_escape_sequence] = ACTIONS(1837),
    [sym_comment] = ACTIONS(1811),
    [sym__string_content] = ACTIONS(1837),
    [sym__string_end] = ACTIONS(1839),
  },
  [805] = {
    [aux_sym_dotted_name_repeat1] = STATE(805),
    [anon_sym_import] = ACTIONS(1781),
    [anon_sym_DOT] = ACTIONS(1841),
    [anon_sym_RPAREN] = ACTIONS(1781),
    [anon_sym_COMMA] = ACTIONS(1781),
    [anon_sym_as] = ACTIONS(1781),
    [sym_comment] = ACTIONS(3),
  },
  [806] = {
    [anon_sym_COMMA] = ACTIONS(832),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_COLON] = ACTIONS(1844),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [anon_sym_RBRACK] = ACTIONS(832),
    [sym_comment] = ACTIONS(3),
  },
  [807] = {
    [anon_sym_COMMA] = ACTIONS(1846),
    [anon_sym_if] = ACTIONS(1665),
    [anon_sym_and] = ACTIONS(1667),
    [anon_sym_or] = ACTIONS(1669),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1846),
    [sym__newline] = ACTIONS(1846),
  },
  [808] = {
    [sym_interpolation] = STATE(800),
    [aux_sym_string_repeat1] = STATE(800),
    [anon_sym_LBRACE] = ACTIONS(1807),
    [sym_escape_sequence] = ACTIONS(1848),
    [sym_comment] = ACTIONS(1811),
    [sym__string_content] = ACTIONS(1848),
    [sym__string_end] = ACTIONS(1850),
  },
  [809] = {
    [anon_sym_COMMA] = ACTIONS(1469),
    [anon_sym_as] = ACTIONS(1469),
    [anon_sym_if] = ACTIONS(1469),
    [anon_sym_COLON] = ACTIONS(1469),
    [anon_sym_and] = ACTIONS(1799),
    [anon_sym_or] = ACTIONS(1469),
    [sym_comment] = ACTIONS(3),
  },
  [810] = {
    [anon_sym_COMMA] = ACTIONS(1473),
    [anon_sym_as] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(1797),
    [anon_sym_COLON] = ACTIONS(1473),
    [anon_sym_and] = ACTIONS(1799),
    [anon_sym_or] = ACTIONS(1801),
    [sym_comment] = ACTIONS(3),
  },
  [811] = {
    [anon_sym_COMMA] = ACTIONS(1475),
    [anon_sym_as] = ACTIONS(1475),
    [anon_sym_if] = ACTIONS(1475),
    [anon_sym_COLON] = ACTIONS(1475),
    [anon_sym_and] = ACTIONS(1799),
    [anon_sym_or] = ACTIONS(1801),
    [sym_comment] = ACTIONS(3),
  },
  [812] = {
    [anon_sym_RPAREN] = ACTIONS(1852),
    [anon_sym_COMMA] = ACTIONS(1852),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_COLON] = ACTIONS(1852),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [sym_comment] = ACTIONS(3),
  },
  [813] = {
    [sym_interpolation] = STATE(801),
    [aux_sym_string_repeat1] = STATE(801),
    [anon_sym_LBRACE] = ACTIONS(1807),
    [sym_escape_sequence] = ACTIONS(1809),
    [sym_comment] = ACTIONS(1811),
    [sym__string_content] = ACTIONS(1809),
    [sym__string_end] = ACTIONS(1854),
  },
  [814] = {
    [anon_sym_COMMA] = ACTIONS(1451),
    [anon_sym_as] = ACTIONS(1451),
    [anon_sym_if] = ACTIONS(1451),
    [anon_sym_COLON] = ACTIONS(1451),
    [anon_sym_and] = ACTIONS(1451),
    [anon_sym_or] = ACTIONS(1451),
    [sym_comment] = ACTIONS(3),
  },
  [815] = {
    [anon_sym_COMMA] = ACTIONS(1479),
    [anon_sym_as] = ACTIONS(1479),
    [anon_sym_if] = ACTIONS(1797),
    [anon_sym_COLON] = ACTIONS(1479),
    [anon_sym_and] = ACTIONS(1799),
    [anon_sym_or] = ACTIONS(1801),
    [sym_comment] = ACTIONS(3),
  },
  [816] = {
    [sym_interpolation] = STATE(823),
    [aux_sym_string_repeat1] = STATE(823),
    [anon_sym_LBRACE] = ACTIONS(1807),
    [sym_escape_sequence] = ACTIONS(1856),
    [sym_comment] = ACTIONS(1811),
    [sym__string_content] = ACTIONS(1856),
    [sym__string_end] = ACTIONS(1858),
  },
  [817] = {
    [anon_sym_RPAREN] = ACTIONS(1860),
    [anon_sym_COMMA] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_COLON] = ACTIONS(1860),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [sym_comment] = ACTIONS(3),
  },
  [818] = {
    [anon_sym_RPAREN] = ACTIONS(1862),
    [anon_sym_COMMA] = ACTIONS(1862),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_COLON] = ACTIONS(1862),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [sym_comment] = ACTIONS(3),
  },
  [819] = {
    [anon_sym_RPAREN] = ACTIONS(1485),
    [anon_sym_COMMA] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_COLON] = ACTIONS(1485),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [sym_comment] = ACTIONS(3),
  },
  [820] = {
    [aux_sym_dotted_name_repeat1] = STATE(805),
    [anon_sym_import] = ACTIONS(1774),
    [anon_sym_DOT] = ACTIONS(1864),
    [anon_sym_RPAREN] = ACTIONS(1774),
    [anon_sym_COMMA] = ACTIONS(1774),
    [anon_sym_as] = ACTIONS(1774),
    [sym_comment] = ACTIONS(3),
  },
  [821] = {
    [anon_sym_COMMA] = ACTIONS(1463),
    [anon_sym_as] = ACTIONS(1463),
    [anon_sym_if] = ACTIONS(1463),
    [anon_sym_COLON] = ACTIONS(1463),
    [anon_sym_and] = ACTIONS(1463),
    [anon_sym_or] = ACTIONS(1463),
    [sym_comment] = ACTIONS(3),
  },
  [822] = {
    [anon_sym_COMMA] = ACTIONS(1866),
    [anon_sym_if] = ACTIONS(1665),
    [anon_sym_and] = ACTIONS(1667),
    [anon_sym_or] = ACTIONS(1669),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1866),
    [sym__newline] = ACTIONS(1866),
  },
  [823] = {
    [sym_interpolation] = STATE(801),
    [aux_sym_string_repeat1] = STATE(801),
    [anon_sym_LBRACE] = ACTIONS(1807),
    [sym_escape_sequence] = ACTIONS(1809),
    [sym_comment] = ACTIONS(1811),
    [sym__string_content] = ACTIONS(1809),
    [sym__string_end] = ACTIONS(1868),
  },
  [824] = {
    [aux_sym_argument_list_repeat1] = STATE(982),
    [anon_sym_RPAREN] = ACTIONS(1634),
    [anon_sym_COMMA] = ACTIONS(1636),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [sym_comment] = ACTIONS(3),
  },
  [825] = {
    [anon_sym_DOT] = ACTIONS(1781),
    [anon_sym_LPAREN] = ACTIONS(1781),
    [anon_sym_COMMA] = ACTIONS(1781),
    [anon_sym_as] = ACTIONS(1781),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1781),
    [sym__newline] = ACTIONS(1781),
  },
  [826] = {
    [aux_sym_tuple_repeat1] = STATE(939),
    [anon_sym_RPAREN] = ACTIONS(1870),
    [anon_sym_COMMA] = ACTIONS(1640),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [sym_comment] = ACTIONS(3),
  },
  [827] = {
    [aux_sym_argument_list_repeat1] = STATE(972),
    [anon_sym_RPAREN] = ACTIONS(1618),
    [anon_sym_COMMA] = ACTIONS(1620),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [sym_comment] = ACTIONS(3),
  },
  [828] = {
    [sym_interpolation] = STATE(796),
    [aux_sym_string_repeat1] = STATE(796),
    [anon_sym_LBRACE] = ACTIONS(1807),
    [sym_escape_sequence] = ACTIONS(1872),
    [sym_comment] = ACTIONS(1811),
    [sym__string_content] = ACTIONS(1872),
    [sym__string_end] = ACTIONS(1874),
  },
  [829] = {
    [sym_decorator] = STATE(829),
    [aux_sym_decorated_definition_repeat1] = STATE(829),
    [anon_sym_async] = ACTIONS(1876),
    [anon_sym_def] = ACTIONS(1876),
    [anon_sym_class] = ACTIONS(1876),
    [anon_sym_AT] = ACTIONS(1878),
    [sym_comment] = ACTIONS(3),
  },
  [830] = {
    [anon_sym_COMMA] = ACTIONS(1471),
    [anon_sym_as] = ACTIONS(1471),
    [anon_sym_if] = ACTIONS(1471),
    [anon_sym_COLON] = ACTIONS(1471),
    [anon_sym_and] = ACTIONS(1799),
    [anon_sym_or] = ACTIONS(1801),
    [sym_comment] = ACTIONS(3),
  },
  [831] = {
    [anon_sym_RPAREN] = ACTIONS(1881),
    [anon_sym_COMMA] = ACTIONS(1881),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_COLON] = ACTIONS(1881),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [sym_comment] = ACTIONS(3),
  },
  [832] = {
    [anon_sym_COMMA] = ACTIONS(1477),
    [anon_sym_as] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1797),
    [anon_sym_COLON] = ACTIONS(1477),
    [anon_sym_and] = ACTIONS(1799),
    [anon_sym_or] = ACTIONS(1801),
    [sym_comment] = ACTIONS(3),
  },
  [833] = {
    [anon_sym_COMMA] = ACTIONS(716),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [anon_sym_RBRACK] = ACTIONS(716),
    [sym_comment] = ACTIONS(3),
  },
  [834] = {
    [aux_sym_dotted_name_repeat1] = STATE(820),
    [anon_sym_import] = ACTIONS(1716),
    [anon_sym_DOT] = ACTIONS(1864),
    [anon_sym_RPAREN] = ACTIONS(1716),
    [anon_sym_COMMA] = ACTIONS(1716),
    [anon_sym_as] = ACTIONS(1716),
    [sym_comment] = ACTIONS(3),
  },
  [835] = {
    [anon_sym_COMMA] = ACTIONS(1883),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [anon_sym_RBRACK] = ACTIONS(1883),
    [sym_comment] = ACTIONS(3),
  },
  [836] = {
    [sym_format_expression] = STATE(860),
    [aux_sym_format_specifier_repeat1] = STATE(860),
    [anon_sym_LBRACE] = ACTIONS(1885),
    [anon_sym_RBRACE] = ACTIONS(1887),
    [aux_sym_format_specifier_token1] = ACTIONS(1889),
    [sym_comment] = ACTIONS(1811),
  },
  [837] = {
    [sym__import_list] = STATE(1033),
    [sym_aliased_import] = STATE(878),
    [sym_dotted_name] = STATE(854),
    [sym_identifier] = ACTIONS(1760),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [sym_comment] = ACTIONS(3),
  },
  [838] = {
    [aux_sym__parameters_repeat1] = STATE(945),
    [anon_sym_RPAREN] = ACTIONS(1893),
    [anon_sym_COMMA] = ACTIONS(1895),
    [anon_sym_COLON] = ACTIONS(1897),
    [anon_sym_EQ] = ACTIONS(1899),
    [sym_comment] = ACTIONS(3),
  },
  [839] = {
    [aux_sym__parameters_repeat1] = STATE(947),
    [anon_sym_RPAREN] = ACTIONS(1901),
    [anon_sym_COMMA] = ACTIONS(1903),
    [anon_sym_COLON] = ACTIONS(1905),
    [anon_sym_EQ] = ACTIONS(1907),
    [sym_comment] = ACTIONS(3),
  },
  [840] = {
    [anon_sym_COMMA] = ACTIONS(1909),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_COLON] = ACTIONS(1909),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [sym_comment] = ACTIONS(3),
  },
  [841] = {
    [sym_except_clause] = STATE(164),
    [sym_finally_clause] = STATE(416),
    [aux_sym_try_statement_repeat1] = STATE(164),
    [anon_sym_except] = ACTIONS(1911),
    [anon_sym_finally] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
  },
  [842] = {
    [aux_sym_assert_statement_repeat1] = STATE(849),
    [anon_sym_from] = ACTIONS(355),
    [anon_sym_COMMA] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(355),
    [sym__newline] = ACTIONS(355),
  },
  [843] = {
    [sym_aliased_import] = STATE(988),
    [sym_dotted_name] = STATE(877),
    [sym_identifier] = ACTIONS(1760),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1917),
    [sym__newline] = ACTIONS(1917),
  },
  [844] = {
    [anon_sym_RPAREN] = ACTIONS(1919),
    [anon_sym_COMMA] = ACTIONS(1919),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [sym_comment] = ACTIONS(3),
  },
  [845] = {
    [sym_except_clause] = STATE(159),
    [sym_finally_clause] = STATE(481),
    [aux_sym_try_statement_repeat1] = STATE(159),
    [anon_sym_except] = ACTIONS(1921),
    [anon_sym_finally] = ACTIONS(1923),
    [sym_comment] = ACTIONS(3),
  },
  [846] = {
    [anon_sym_COMMA] = ACTIONS(845),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [anon_sym_RBRACK] = ACTIONS(845),
    [sym_comment] = ACTIONS(3),
  },
  [847] = {
    [sym_except_clause] = STATE(150),
    [sym_finally_clause] = STATE(440),
    [aux_sym_try_statement_repeat1] = STATE(150),
    [anon_sym_except] = ACTIONS(1911),
    [anon_sym_finally] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
  },
  [848] = {
    [anon_sym_if] = ACTIONS(1665),
    [anon_sym_and] = ACTIONS(1667),
    [anon_sym_or] = ACTIONS(1669),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1925),
    [sym__newline] = ACTIONS(1925),
  },
  [849] = {
    [aux_sym_assert_statement_repeat1] = STATE(849),
    [anon_sym_from] = ACTIONS(1485),
    [anon_sym_COMMA] = ACTIONS(1927),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1485),
    [sym__newline] = ACTIONS(1485),
  },
  [850] = {
    [anon_sym_import] = ACTIONS(1781),
    [anon_sym_DOT] = ACTIONS(1781),
    [anon_sym_RPAREN] = ACTIONS(1781),
    [anon_sym_COMMA] = ACTIONS(1781),
    [anon_sym_as] = ACTIONS(1781),
    [sym_comment] = ACTIONS(3),
  },
  [851] = {
    [anon_sym_RPAREN] = ACTIONS(1930),
    [anon_sym_COMMA] = ACTIONS(1930),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [sym_comment] = ACTIONS(3),
  },
  [852] = {
    [sym_aliased_import] = STATE(988),
    [sym_dotted_name] = STATE(877),
    [sym_identifier] = ACTIONS(1760),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1932),
    [sym__newline] = ACTIONS(1932),
  },
  [853] = {
    [sym_format_expression] = STATE(853),
    [aux_sym_format_specifier_repeat1] = STATE(853),
    [anon_sym_LBRACE] = ACTIONS(1934),
    [anon_sym_RBRACE] = ACTIONS(1937),
    [aux_sym_format_specifier_token1] = ACTIONS(1939),
    [sym_comment] = ACTIONS(1811),
  },
  [854] = {
    [aux_sym__import_list_repeat1] = STATE(910),
    [anon_sym_COMMA] = ACTIONS(1942),
    [anon_sym_as] = ACTIONS(1944),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1946),
    [sym__newline] = ACTIONS(1946),
  },
  [855] = {
    [anon_sym_if] = ACTIONS(1665),
    [anon_sym_and] = ACTIONS(1667),
    [anon_sym_or] = ACTIONS(1669),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1948),
    [sym__newline] = ACTIONS(1948),
  },
  [856] = {
    [anon_sym_if] = ACTIONS(1665),
    [anon_sym_and] = ACTIONS(1667),
    [anon_sym_or] = ACTIONS(1669),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1919),
    [sym__newline] = ACTIONS(1919),
  },
  [857] = {
    [anon_sym_COMMA] = ACTIONS(832),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [anon_sym_RBRACK] = ACTIONS(832),
    [sym_comment] = ACTIONS(3),
  },
  [858] = {
    [anon_sym_RPAREN] = ACTIONS(1950),
    [anon_sym_COMMA] = ACTIONS(1950),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [sym_comment] = ACTIONS(3),
  },
  [859] = {
    [sym_except_clause] = STATE(157),
    [sym_finally_clause] = STATE(424),
    [aux_sym_try_statement_repeat1] = STATE(157),
    [anon_sym_except] = ACTIONS(1921),
    [anon_sym_finally] = ACTIONS(1923),
    [sym_comment] = ACTIONS(3),
  },
  [860] = {
    [sym_format_expression] = STATE(853),
    [aux_sym_format_specifier_repeat1] = STATE(853),
    [anon_sym_LBRACE] = ACTIONS(1885),
    [anon_sym_RBRACE] = ACTIONS(1952),
    [aux_sym_format_specifier_token1] = ACTIONS(1954),
    [sym_comment] = ACTIONS(1811),
  },
  [861] = {
    [anon_sym_RPAREN] = ACTIONS(1956),
    [anon_sym_COMMA] = ACTIONS(1956),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [sym_comment] = ACTIONS(3),
  },
  [862] = {
    [anon_sym_RPAREN] = ACTIONS(1958),
    [anon_sym_COMMA] = ACTIONS(1958),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [sym_comment] = ACTIONS(3),
  },
  [863] = {
    [aux_sym_assert_statement_repeat1] = STATE(863),
    [anon_sym_RPAREN] = ACTIONS(1485),
    [anon_sym_COMMA] = ACTIONS(1960),
    [anon_sym_COLON] = ACTIONS(1485),
    [sym_comment] = ACTIONS(3),
  },
  [864] = {
    [aux_sym_import_prefix_repeat1] = STATE(864),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_import] = ACTIONS(1963),
    [anon_sym_DOT] = ACTIONS(1965),
    [sym_comment] = ACTIONS(3),
  },
  [865] = {
    [sym__import_list] = STATE(1030),
    [sym_aliased_import] = STATE(878),
    [sym_dotted_name] = STATE(854),
    [sym_identifier] = ACTIONS(1760),
    [sym_comment] = ACTIONS(3),
  },
  [866] = {
    [aux_sym_print_statement_repeat1] = STATE(866),
    [anon_sym_COMMA] = ACTIONS(1968),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1971),
    [sym__newline] = ACTIONS(1971),
  },
  [867] = {
    [anon_sym_RPAREN] = ACTIONS(1973),
    [anon_sym_COMMA] = ACTIONS(1973),
    [anon_sym_COLON] = ACTIONS(1905),
    [anon_sym_EQ] = ACTIONS(1907),
    [sym_comment] = ACTIONS(3),
  },
  [868] = {
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_COLON] = ACTIONS(1975),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [sym_comment] = ACTIONS(3),
  },
  [869] = {
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_COLON] = ACTIONS(1977),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [sym_comment] = ACTIONS(3),
  },
  [870] = {
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_COLON] = ACTIONS(1979),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [sym_comment] = ACTIONS(3),
  },
  [871] = {
    [sym_aliased_import] = STATE(1031),
    [sym_dotted_name] = STATE(985),
    [sym_identifier] = ACTIONS(1981),
    [anon_sym_RPAREN] = ACTIONS(1917),
    [sym_comment] = ACTIONS(3),
  },
  [872] = {
    [sym__import_list] = STATE(1107),
    [sym_aliased_import] = STATE(928),
    [sym_dotted_name] = STATE(887),
    [sym_identifier] = ACTIONS(1981),
    [sym_comment] = ACTIONS(3),
  },
  [873] = {
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_COLON] = ACTIONS(1983),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [sym_comment] = ACTIONS(3),
  },
  [874] = {
    [sym__import_list] = STATE(1108),
    [sym_aliased_import] = STATE(928),
    [sym_dotted_name] = STATE(887),
    [sym_identifier] = ACTIONS(1981),
    [sym_comment] = ACTIONS(3),
  },
  [875] = {
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_COLON] = ACTIONS(1985),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [sym_comment] = ACTIONS(3),
  },
  [876] = {
    [aux_sym__import_list_repeat1] = STATE(876),
    [anon_sym_COMMA] = ACTIONS(1987),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1990),
    [sym__newline] = ACTIONS(1990),
  },
  [877] = {
    [anon_sym_COMMA] = ACTIONS(1992),
    [anon_sym_as] = ACTIONS(1944),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1992),
    [sym__newline] = ACTIONS(1992),
  },
  [878] = {
    [aux_sym__import_list_repeat1] = STATE(910),
    [anon_sym_COMMA] = ACTIONS(1942),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1946),
    [sym__newline] = ACTIONS(1946),
  },
  [879] = {
    [aux_sym_import_prefix_repeat1] = STATE(864),
    [sym_identifier] = ACTIONS(1994),
    [anon_sym_import] = ACTIONS(1994),
    [anon_sym_DOT] = ACTIONS(1996),
    [sym_comment] = ACTIONS(3),
  },
  [880] = {
    [aux_sym_assert_statement_repeat1] = STATE(863),
    [anon_sym_RPAREN] = ACTIONS(355),
    [anon_sym_COMMA] = ACTIONS(1998),
    [anon_sym_COLON] = ACTIONS(355),
    [sym_comment] = ACTIONS(3),
  },
  [881] = {
    [anon_sym_LBRACE] = ACTIONS(2000),
    [sym_escape_sequence] = ACTIONS(2002),
    [sym_comment] = ACTIONS(1811),
    [sym__string_content] = ACTIONS(2002),
    [sym__string_end] = ACTIONS(2002),
  },
  [882] = {
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_else] = ACTIONS(2004),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [sym_comment] = ACTIONS(3),
  },
  [883] = {
    [sym_aliased_import] = STATE(1031),
    [sym_dotted_name] = STATE(985),
    [sym_identifier] = ACTIONS(1981),
    [anon_sym_RPAREN] = ACTIONS(1932),
    [sym_comment] = ACTIONS(3),
  },
  [884] = {
    [aux_sym_print_statement_repeat1] = STATE(907),
    [anon_sym_COMMA] = ACTIONS(2006),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2008),
    [sym__newline] = ACTIONS(2008),
  },
  [885] = {
    [aux_sym__parameters_repeat1] = STATE(947),
    [anon_sym_RPAREN] = ACTIONS(1901),
    [anon_sym_COMMA] = ACTIONS(1903),
    [anon_sym_COLON] = ACTIONS(2010),
    [sym_comment] = ACTIONS(3),
  },
  [886] = {
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_else] = ACTIONS(2012),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [sym_comment] = ACTIONS(3),
  },
  [887] = {
    [aux_sym__import_list_repeat1] = STATE(1010),
    [anon_sym_RPAREN] = ACTIONS(1946),
    [anon_sym_COMMA] = ACTIONS(2014),
    [anon_sym_as] = ACTIONS(2016),
    [sym_comment] = ACTIONS(3),
  },
  [888] = {
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_COLON] = ACTIONS(2018),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [sym_comment] = ACTIONS(3),
  },
  [889] = {
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_COLON] = ACTIONS(2020),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [sym_comment] = ACTIONS(3),
  },
  [890] = {
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_COLON] = ACTIONS(2022),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [sym_comment] = ACTIONS(3),
  },
  [891] = {
    [anon_sym_LBRACE] = ACTIONS(2024),
    [sym_escape_sequence] = ACTIONS(2026),
    [sym_comment] = ACTIONS(1811),
    [sym__string_content] = ACTIONS(2026),
    [sym__string_end] = ACTIONS(2026),
  },
  [892] = {
    [aux_sym_global_statement_repeat1] = STATE(909),
    [anon_sym_COMMA] = ACTIONS(2028),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2030),
    [sym__newline] = ACTIONS(2030),
  },
  [893] = {
    [aux_sym_global_statement_repeat1] = STATE(906),
    [anon_sym_COMMA] = ACTIONS(2028),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2032),
    [sym__newline] = ACTIONS(2032),
  },
  [894] = {
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [anon_sym_RBRACE] = ACTIONS(2034),
    [sym_comment] = ACTIONS(3),
  },
  [895] = {
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_else] = ACTIONS(2036),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [sym_comment] = ACTIONS(3),
  },
  [896] = {
    [anon_sym_RPAREN] = ACTIONS(2038),
    [anon_sym_COMMA] = ACTIONS(2038),
    [anon_sym_COLON] = ACTIONS(1897),
    [anon_sym_EQ] = ACTIONS(1899),
    [sym_comment] = ACTIONS(3),
  },
  [897] = {
    [aux_sym__parameters_repeat1] = STATE(1013),
    [anon_sym_COMMA] = ACTIONS(2040),
    [anon_sym_COLON] = ACTIONS(1893),
    [anon_sym_EQ] = ACTIONS(1899),
    [sym_comment] = ACTIONS(3),
  },
  [898] = {
    [aux_sym__parameters_repeat1] = STATE(961),
    [anon_sym_COMMA] = ACTIONS(2042),
    [anon_sym_COLON] = ACTIONS(1901),
    [anon_sym_EQ] = ACTIONS(1907),
    [sym_comment] = ACTIONS(3),
  },
  [899] = {
    [aux_sym_assert_statement_repeat1] = STATE(849),
    [anon_sym_COMMA] = ACTIONS(1736),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2044),
    [sym__newline] = ACTIONS(2044),
  },
  [900] = {
    [anon_sym_async] = ACTIONS(2046),
    [anon_sym_def] = ACTIONS(2046),
    [anon_sym_class] = ACTIONS(2046),
    [anon_sym_AT] = ACTIONS(2046),
    [sym_comment] = ACTIONS(3),
  },
  [901] = {
    [anon_sym_LBRACE] = ACTIONS(2048),
    [sym_escape_sequence] = ACTIONS(2050),
    [sym_comment] = ACTIONS(1811),
    [sym__string_content] = ACTIONS(2050),
    [sym__string_end] = ACTIONS(2050),
  },
  [902] = {
    [anon_sym_async] = ACTIONS(2052),
    [anon_sym_def] = ACTIONS(2052),
    [anon_sym_class] = ACTIONS(2052),
    [anon_sym_AT] = ACTIONS(2052),
    [sym_comment] = ACTIONS(3),
  },
  [903] = {
    [aux_sym_assert_statement_repeat1] = STATE(849),
    [anon_sym_COMMA] = ACTIONS(1736),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2054),
    [sym__newline] = ACTIONS(2054),
  },
  [904] = {
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_else] = ACTIONS(2056),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [sym_comment] = ACTIONS(3),
  },
  [905] = {
    [aux_sym_print_statement_repeat1] = STATE(866),
    [anon_sym_COMMA] = ACTIONS(2058),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2060),
    [sym__newline] = ACTIONS(2060),
  },
  [906] = {
    [aux_sym_global_statement_repeat1] = STATE(913),
    [anon_sym_COMMA] = ACTIONS(2028),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2062),
    [sym__newline] = ACTIONS(2062),
  },
  [907] = {
    [aux_sym_print_statement_repeat1] = STATE(866),
    [anon_sym_COMMA] = ACTIONS(2064),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2066),
    [sym__newline] = ACTIONS(2066),
  },
  [908] = {
    [aux_sym_list_repeat1] = STATE(908),
    [anon_sym_COMMA] = ACTIONS(2068),
    [anon_sym_RBRACK] = ACTIONS(1791),
    [anon_sym_RBRACE] = ACTIONS(1791),
    [sym_comment] = ACTIONS(3),
  },
  [909] = {
    [aux_sym_global_statement_repeat1] = STATE(913),
    [anon_sym_COMMA] = ACTIONS(2028),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2071),
    [sym__newline] = ACTIONS(2071),
  },
  [910] = {
    [aux_sym__import_list_repeat1] = STATE(876),
    [anon_sym_COMMA] = ACTIONS(2073),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2075),
    [sym__newline] = ACTIONS(2075),
  },
  [911] = {
    [anon_sym_RPAREN] = ACTIONS(2077),
    [anon_sym_COMMA] = ACTIONS(2077),
    [anon_sym_COLON] = ACTIONS(2077),
    [anon_sym_EQ] = ACTIONS(2079),
    [sym_comment] = ACTIONS(3),
  },
  [912] = {
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_COLON] = ACTIONS(1574),
    [anon_sym_and] = ACTIONS(1546),
    [anon_sym_or] = ACTIONS(1548),
    [sym_comment] = ACTIONS(3),
  },
  [913] = {
    [aux_sym_global_statement_repeat1] = STATE(913),
    [anon_sym_COMMA] = ACTIONS(2081),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2084),
    [sym__newline] = ACTIONS(2084),
  },
  [914] = {
    [aux_sym_tuple_repeat1] = STATE(973),
    [anon_sym_RPAREN] = ACTIONS(1594),
    [anon_sym_COMMA] = ACTIONS(1596),
    [sym_comment] = ACTIONS(3),
  },
  [915] = {
    [aux_sym_list_repeat1] = STATE(908),
    [anon_sym_COMMA] = ACTIONS(2086),
    [anon_sym_RBRACK] = ACTIONS(728),
    [sym_comment] = ACTIONS(3),
  },
  [916] = {
    [aux_sym__simple_statements_repeat1] = STATE(931),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2088),
    [sym__newline] = ACTIONS(2090),
  },
  [917] = {
    [aux_sym_tuple_repeat1] = STATE(917),
    [anon_sym_RPAREN] = ACTIONS(1930),
    [anon_sym_COMMA] = ACTIONS(2092),
    [sym_comment] = ACTIONS(3),
  },
  [918] = {
    [aux_sym_tuple_repeat1] = STATE(939),
    [anon_sym_RPAREN] = ACTIONS(1638),
    [anon_sym_COMMA] = ACTIONS(1640),
    [sym_comment] = ACTIONS(3),
  },
  [919] = {
    [anon_sym_COMMA] = ACTIONS(1973),
    [anon_sym_COLON] = ACTIONS(1973),
    [anon_sym_EQ] = ACTIONS(1907),
    [sym_comment] = ACTIONS(3),
  },
  [920] = {
    [anon_sym_RPAREN] = ACTIONS(1973),
    [anon_sym_COMMA] = ACTIONS(1973),
    [anon_sym_COLON] = ACTIONS(2010),
    [sym_comment] = ACTIONS(3),
  },
  [921] = {
    [anon_sym_for] = ACTIONS(2095),
    [anon_sym_with] = ACTIONS(2097),
    [anon_sym_def] = ACTIONS(2099),
    [sym_comment] = ACTIONS(3),
  },
  [922] = {
    [aux_sym_dictionary_repeat1] = STATE(1016),
    [anon_sym_COMMA] = ACTIONS(1740),
    [anon_sym_RBRACE] = ACTIONS(1742),
    [sym_comment] = ACTIONS(3),
  },
  [923] = {
    [aux_sym_list_repeat1] = STATE(948),
    [anon_sym_COMMA] = ACTIONS(1606),
    [anon_sym_RBRACK] = ACTIONS(1608),
    [sym_comment] = ACTIONS(3),
  },
  [924] = {
    [aux_sym_variables_repeat1] = STATE(924),
    [anon_sym_COMMA] = ACTIONS(2101),
    [anon_sym_in] = ACTIONS(1487),
    [sym_comment] = ACTIONS(3),
  },
  [925] = {
    [aux_sym_list_repeat1] = STATE(1019),
    [anon_sym_COMMA] = ACTIONS(1582),
    [anon_sym_RBRACE] = ACTIONS(1584),
    [sym_comment] = ACTIONS(3),
  },
  [926] = {
    [aux_sym_list_repeat1] = STATE(950),
    [anon_sym_COMMA] = ACTIONS(1590),
    [anon_sym_RBRACE] = ACTIONS(1592),
    [sym_comment] = ACTIONS(3),
  },
  [927] = {
    [aux_sym_dictionary_repeat1] = STATE(952),
    [anon_sym_COMMA] = ACTIONS(1708),
    [anon_sym_RBRACE] = ACTIONS(1710),
    [sym_comment] = ACTIONS(3),
  },
  [928] = {
    [aux_sym__import_list_repeat1] = STATE(1010),
    [anon_sym_RPAREN] = ACTIONS(1946),
    [anon_sym_COMMA] = ACTIONS(2014),
    [sym_comment] = ACTIONS(3),
  },
  [929] = {
    [aux_sym_list_repeat1] = STATE(915),
    [anon_sym_COMMA] = ACTIONS(1622),
    [anon_sym_RBRACK] = ACTIONS(1624),
    [sym_comment] = ACTIONS(3),
  },
  [930] = {
    [aux_sym_tuple_repeat1] = STATE(992),
    [anon_sym_RPAREN] = ACTIONS(1626),
    [anon_sym_COMMA] = ACTIONS(1628),
    [sym_comment] = ACTIONS(3),
  },
  [931] = {
    [aux_sym__simple_statements_repeat1] = STATE(937),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2104),
    [sym__newline] = ACTIONS(345),
  },
  [932] = {
    [anon_sym_for] = ACTIONS(2106),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_def] = ACTIONS(2110),
    [sym_comment] = ACTIONS(3),
  },
  [933] = {
    [aux_sym_with_statement_repeat1] = STATE(933),
    [anon_sym_COMMA] = ACTIONS(2112),
    [anon_sym_COLON] = ACTIONS(2115),
    [sym_comment] = ACTIONS(3),
  },
  [934] = {
    [anon_sym_LBRACE] = ACTIONS(2117),
    [anon_sym_RBRACE] = ACTIONS(2117),
    [aux_sym_format_specifier_token1] = ACTIONS(2117),
    [sym_comment] = ACTIONS(1811),
  },
  [935] = {
    [anon_sym_EQ] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2121),
    [sym__newline] = ACTIONS(2121),
  },
  [936] = {
    [anon_sym_from] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2125),
    [sym__newline] = ACTIONS(2125),
  },
  [937] = {
    [aux_sym__simple_statements_repeat1] = STATE(937),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2127),
    [sym__newline] = ACTIONS(2130),
  },
  [938] = {
    [aux_sym__simple_statements_repeat1] = STATE(991),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2132),
    [sym__newline] = ACTIONS(2134),
  },
  [939] = {
    [aux_sym_tuple_repeat1] = STATE(917),
    [anon_sym_RPAREN] = ACTIONS(696),
    [anon_sym_COMMA] = ACTIONS(2136),
    [sym_comment] = ACTIONS(3),
  },
  [940] = {
    [aux_sym_subscript_repeat1] = STATE(955),
    [anon_sym_COMMA] = ACTIONS(2138),
    [anon_sym_RBRACK] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
  },
  [941] = {
    [aux_sym_tuple_repeat1] = STATE(939),
    [anon_sym_RPAREN] = ACTIONS(1870),
    [anon_sym_COMMA] = ACTIONS(1640),
    [sym_comment] = ACTIONS(3),
  },
  [942] = {
    [anon_sym_COMMA] = ACTIONS(2084),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2084),
    [sym__newline] = ACTIONS(2084),
  },
  [943] = {
    [aux_sym_argument_list_repeat1] = STATE(997),
    [anon_sym_RPAREN] = ACTIONS(500),
    [anon_sym_COMMA] = ACTIONS(2142),
    [sym_comment] = ACTIONS(3),
  },
  [944] = {
    [aux_sym_with_statement_repeat1] = STATE(962),
    [anon_sym_COMMA] = ACTIONS(2144),
    [anon_sym_COLON] = ACTIONS(2146),
    [sym_comment] = ACTIONS(3),
  },
  [945] = {
    [aux_sym__parameters_repeat1] = STATE(971),
    [anon_sym_RPAREN] = ACTIONS(1570),
    [anon_sym_COMMA] = ACTIONS(2148),
    [sym_comment] = ACTIONS(3),
  },
  [946] = {
    [anon_sym_COMMA] = ACTIONS(2038),
    [anon_sym_COLON] = ACTIONS(2038),
    [anon_sym_EQ] = ACTIONS(1899),
    [sym_comment] = ACTIONS(3),
  },
  [947] = {
    [aux_sym__parameters_repeat1] = STATE(971),
    [anon_sym_RPAREN] = ACTIONS(1560),
    [anon_sym_COMMA] = ACTIONS(2150),
    [sym_comment] = ACTIONS(3),
  },
  [948] = {
    [aux_sym_list_repeat1] = STATE(908),
    [anon_sym_COMMA] = ACTIONS(2152),
    [anon_sym_RBRACK] = ACTIONS(626),
    [sym_comment] = ACTIONS(3),
  },
  [949] = {
    [aux_sym_dictionary_repeat1] = STATE(981),
    [anon_sym_COMMA] = ACTIONS(2154),
    [anon_sym_RBRACE] = ACTIONS(556),
    [sym_comment] = ACTIONS(3),
  },
  [950] = {
    [aux_sym_list_repeat1] = STATE(908),
    [anon_sym_COMMA] = ACTIONS(2156),
    [anon_sym_RBRACE] = ACTIONS(676),
    [sym_comment] = ACTIONS(3),
  },
  [951] = {
    [aux_sym_subscript_repeat1] = STATE(940),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_RBRACK] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
  },
  [952] = {
    [aux_sym_dictionary_repeat1] = STATE(981),
    [anon_sym_COMMA] = ACTIONS(2158),
    [anon_sym_RBRACE] = ACTIONS(596),
    [sym_comment] = ACTIONS(3),
  },
  [953] = {
    [aux_sym_list_repeat1] = STATE(908),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_RBRACE] = ACTIONS(750),
    [sym_comment] = ACTIONS(3),
  },
  [954] = {
    [aux_sym_with_statement_repeat1] = STATE(933),
    [anon_sym_COMMA] = ACTIONS(2144),
    [anon_sym_COLON] = ACTIONS(2162),
    [sym_comment] = ACTIONS(3),
  },
  [955] = {
    [aux_sym_subscript_repeat1] = STATE(955),
    [anon_sym_COMMA] = ACTIONS(2164),
    [anon_sym_RBRACK] = ACTIONS(1835),
    [sym_comment] = ACTIONS(3),
  },
  [956] = {
    [aux_sym_argument_list_repeat1] = STATE(943),
    [anon_sym_RPAREN] = ACTIONS(1630),
    [anon_sym_COMMA] = ACTIONS(1632),
    [sym_comment] = ACTIONS(3),
  },
  [957] = {
    [aux_sym_argument_list_repeat1] = STATE(972),
    [anon_sym_RPAREN] = ACTIONS(1618),
    [anon_sym_COMMA] = ACTIONS(1620),
    [sym_comment] = ACTIONS(3),
  },
  [958] = {
    [anon_sym_in] = ACTIONS(2167),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2169),
    [sym__newline] = ACTIONS(2169),
  },
  [959] = {
    [anon_sym_RPAREN] = ACTIONS(1973),
    [anon_sym_COMMA] = ACTIONS(1973),
    [anon_sym_COLON] = ACTIONS(1973),
    [sym_comment] = ACTIONS(3),
  },
  [960] = {
    [aux_sym_subscript_repeat1] = STATE(974),
    [anon_sym_COMMA] = ACTIONS(1750),
    [anon_sym_RBRACK] = ACTIONS(1752),
    [sym_comment] = ACTIONS(3),
  },
  [961] = {
    [aux_sym__parameters_repeat1] = STATE(965),
    [anon_sym_COMMA] = ACTIONS(2171),
    [anon_sym_COLON] = ACTIONS(1560),
    [sym_comment] = ACTIONS(3),
  },
  [962] = {
    [aux_sym_with_statement_repeat1] = STATE(933),
    [anon_sym_COMMA] = ACTIONS(2144),
    [anon_sym_COLON] = ACTIONS(2173),
    [sym_comment] = ACTIONS(3),
  },
  [963] = {
    [aux_sym_with_statement_repeat1] = STATE(933),
    [anon_sym_COMMA] = ACTIONS(2144),
    [anon_sym_COLON] = ACTIONS(2175),
    [sym_comment] = ACTIONS(3),
  },
  [964] = {
    [aux_sym_variables_repeat1] = STATE(924),
    [anon_sym_COMMA] = ACTIONS(2177),
    [anon_sym_in] = ACTIONS(2179),
    [sym_comment] = ACTIONS(3),
  },
  [965] = {
    [aux_sym__parameters_repeat1] = STATE(965),
    [anon_sym_COMMA] = ACTIONS(2181),
    [anon_sym_COLON] = ACTIONS(1973),
    [sym_comment] = ACTIONS(3),
  },
  [966] = {
    [aux_sym_dictionary_repeat1] = STATE(981),
    [anon_sym_COMMA] = ACTIONS(2184),
    [anon_sym_RBRACE] = ACTIONS(584),
    [sym_comment] = ACTIONS(3),
  },
  [967] = {
    [aux_sym_with_statement_repeat1] = STATE(978),
    [anon_sym_COMMA] = ACTIONS(2144),
    [anon_sym_COLON] = ACTIONS(2173),
    [sym_comment] = ACTIONS(3),
  },
  [968] = {
    [sym_argument_list] = STATE(1133),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2188),
    [sym_comment] = ACTIONS(3),
  },
  [969] = {
    [anon_sym_RPAREN] = ACTIONS(2077),
    [anon_sym_COMMA] = ACTIONS(2077),
    [anon_sym_COLON] = ACTIONS(2077),
    [sym_comment] = ACTIONS(3),
  },
  [970] = {
    [anon_sym_COMMA] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(1791),
    [anon_sym_RBRACE] = ACTIONS(1791),
    [sym_comment] = ACTIONS(3),
  },
  [971] = {
    [aux_sym__parameters_repeat1] = STATE(971),
    [anon_sym_RPAREN] = ACTIONS(1973),
    [anon_sym_COMMA] = ACTIONS(2190),
    [sym_comment] = ACTIONS(3),
  },
  [972] = {
    [aux_sym_argument_list_repeat1] = STATE(997),
    [anon_sym_RPAREN] = ACTIONS(494),
    [anon_sym_COMMA] = ACTIONS(2193),
    [sym_comment] = ACTIONS(3),
  },
  [973] = {
    [aux_sym_tuple_repeat1] = STATE(917),
    [anon_sym_RPAREN] = ACTIONS(694),
    [anon_sym_COMMA] = ACTIONS(2195),
    [sym_comment] = ACTIONS(3),
  },
  [974] = {
    [aux_sym_subscript_repeat1] = STATE(955),
    [anon_sym_COMMA] = ACTIONS(2197),
    [anon_sym_RBRACK] = ACTIONS(2199),
    [sym_comment] = ACTIONS(3),
  },
  [975] = {
    [aux_sym_with_statement_repeat1] = STATE(954),
    [anon_sym_COMMA] = ACTIONS(2144),
    [anon_sym_COLON] = ACTIONS(2175),
    [sym_comment] = ACTIONS(3),
  },
  [976] = {
    [aux_sym__import_list_repeat1] = STATE(976),
    [anon_sym_RPAREN] = ACTIONS(1990),
    [anon_sym_COMMA] = ACTIONS(2201),
    [sym_comment] = ACTIONS(3),
  },
  [977] = {
    [aux_sym_list_repeat1] = STATE(908),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_RBRACE] = ACTIONS(692),
    [sym_comment] = ACTIONS(3),
  },
  [978] = {
    [aux_sym_with_statement_repeat1] = STATE(933),
    [anon_sym_COMMA] = ACTIONS(2144),
    [anon_sym_COLON] = ACTIONS(2206),
    [sym_comment] = ACTIONS(3),
  },
  [979] = {
    [aux_sym__parameters_repeat1] = STATE(947),
    [anon_sym_RPAREN] = ACTIONS(1901),
    [anon_sym_COMMA] = ACTIONS(1903),
    [sym_comment] = ACTIONS(3),
  },
  [980] = {
    [sym_argument_list] = STATE(1121),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2208),
    [sym_comment] = ACTIONS(3),
  },
  [981] = {
    [aux_sym_dictionary_repeat1] = STATE(981),
    [anon_sym_COMMA] = ACTIONS(2210),
    [anon_sym_RBRACE] = ACTIONS(2213),
    [sym_comment] = ACTIONS(3),
  },
  [982] = {
    [aux_sym_argument_list_repeat1] = STATE(997),
    [anon_sym_RPAREN] = ACTIONS(512),
    [anon_sym_COMMA] = ACTIONS(2215),
    [sym_comment] = ACTIONS(3),
  },
  [983] = {
    [aux_sym_with_statement_repeat1] = STATE(963),
    [anon_sym_COMMA] = ACTIONS(2144),
    [anon_sym_COLON] = ACTIONS(2217),
    [sym_comment] = ACTIONS(3),
  },
  [984] = {
    [aux_sym_subscript_repeat1] = STATE(955),
    [anon_sym_COMMA] = ACTIONS(2219),
    [anon_sym_RBRACK] = ACTIONS(2221),
    [sym_comment] = ACTIONS(3),
  },
  [985] = {
    [anon_sym_RPAREN] = ACTIONS(1992),
    [anon_sym_COMMA] = ACTIONS(1992),
    [anon_sym_as] = ACTIONS(2016),
    [sym_comment] = ACTIONS(3),
  },
  [986] = {
    [anon_sym_COMMA] = ACTIONS(2223),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2223),
    [sym__newline] = ACTIONS(2223),
  },
  [987] = {
    [sym_argument_list] = STATE(1134),
    [anon_sym_LPAREN] = ACTIONS(2225),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(2227),
  },
  [988] = {
    [anon_sym_COMMA] = ACTIONS(1992),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1992),
    [sym__newline] = ACTIONS(1992),
  },
  [989] = {
    [sym_aliased_import] = STATE(1031),
    [sym_dotted_name] = STATE(985),
    [sym_identifier] = ACTIONS(1981),
    [sym_comment] = ACTIONS(3),
  },
  [990] = {
    [sym_aliased_import] = STATE(988),
    [sym_dotted_name] = STATE(877),
    [sym_identifier] = ACTIONS(1760),
    [sym_comment] = ACTIONS(3),
  },
  [991] = {
    [aux_sym__simple_statements_repeat1] = STATE(937),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2229),
    [sym__newline] = ACTIONS(343),
  },
  [992] = {
    [aux_sym_tuple_repeat1] = STATE(917),
    [anon_sym_RPAREN] = ACTIONS(744),
    [anon_sym_COMMA] = ACTIONS(2231),
    [sym_comment] = ACTIONS(3),
  },
  [993] = {
    [aux_sym_list_repeat1] = STATE(908),
    [anon_sym_COMMA] = ACTIONS(2233),
    [anon_sym_RBRACK] = ACTIONS(690),
    [sym_comment] = ACTIONS(3),
  },
  [994] = {
    [aux_sym_subscript_repeat1] = STATE(955),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_RBRACK] = ACTIONS(2237),
    [sym_comment] = ACTIONS(3),
  },
  [995] = {
    [aux_sym_dictionary_repeat1] = STATE(949),
    [anon_sym_COMMA] = ACTIONS(1754),
    [anon_sym_RBRACE] = ACTIONS(1756),
    [sym_comment] = ACTIONS(3),
  },
  [996] = {
    [aux_sym_list_repeat1] = STATE(953),
    [anon_sym_COMMA] = ACTIONS(1586),
    [anon_sym_RBRACE] = ACTIONS(1588),
    [sym_comment] = ACTIONS(3),
  },
  [997] = {
    [aux_sym_argument_list_repeat1] = STATE(997),
    [anon_sym_RPAREN] = ACTIONS(1950),
    [anon_sym_COMMA] = ACTIONS(2239),
    [sym_comment] = ACTIONS(3),
  },
  [998] = {
    [aux_sym_argument_list_repeat1] = STATE(997),
    [anon_sym_RPAREN] = ACTIONS(524),
    [anon_sym_COMMA] = ACTIONS(2242),
    [sym_comment] = ACTIONS(3),
  },
  [999] = {
    [aux_sym_list_repeat1] = STATE(1008),
    [anon_sym_COMMA] = ACTIONS(1610),
    [anon_sym_RBRACK] = ACTIONS(1612),
    [sym_comment] = ACTIONS(3),
  },
  [1000] = {
    [sym_dotted_name] = STATE(1115),
    [sym_identifier] = ACTIONS(1768),
    [anon_sym_import] = ACTIONS(2244),
    [sym_comment] = ACTIONS(3),
  },
  [1001] = {
    [sym_format_specifier] = STATE(1112),
    [anon_sym_COLON] = ACTIONS(1730),
    [anon_sym_RBRACE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
  },
  [1002] = {
    [aux_sym_tuple_repeat1] = STATE(917),
    [anon_sym_RPAREN] = ACTIONS(688),
    [anon_sym_COMMA] = ACTIONS(2248),
    [sym_comment] = ACTIONS(3),
  },
  [1003] = {
    [aux_sym__parameters_repeat1] = STATE(961),
    [anon_sym_COMMA] = ACTIONS(2042),
    [anon_sym_COLON] = ACTIONS(1901),
    [sym_comment] = ACTIONS(3),
  },
  [1004] = {
    [anon_sym_in] = ACTIONS(602),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(602),
    [sym__newline] = ACTIONS(602),
  },
  [1005] = {
    [aux_sym__parameters_repeat1] = STATE(961),
    [anon_sym_COMMA] = ACTIONS(2042),
    [anon_sym_COLON] = ACTIONS(1901),
    [sym_comment] = ACTIONS(3),
  },
  [1006] = {
    [aux_sym_subscript_repeat1] = STATE(994),
    [anon_sym_COMMA] = ACTIONS(1720),
    [anon_sym_RBRACK] = ACTIONS(1724),
    [sym_comment] = ACTIONS(3),
  },
  [1007] = {
    [aux_sym__simple_statements_repeat1] = STATE(1020),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2250),
    [sym__newline] = ACTIONS(2252),
  },
  [1008] = {
    [aux_sym_list_repeat1] = STATE(908),
    [anon_sym_COMMA] = ACTIONS(2254),
    [anon_sym_RBRACK] = ACTIONS(738),
    [sym_comment] = ACTIONS(3),
  },
  [1009] = {
    [aux_sym_subscript_repeat1] = STATE(984),
    [anon_sym_COMMA] = ACTIONS(1746),
    [anon_sym_RBRACK] = ACTIONS(1748),
    [sym_comment] = ACTIONS(3),
  },
  [1010] = {
    [aux_sym__import_list_repeat1] = STATE(976),
    [anon_sym_RPAREN] = ACTIONS(2075),
    [anon_sym_COMMA] = ACTIONS(2256),
    [sym_comment] = ACTIONS(3),
  },
  [1011] = {
    [aux_sym_tuple_repeat1] = STATE(1002),
    [anon_sym_RPAREN] = ACTIONS(1614),
    [anon_sym_COMMA] = ACTIONS(1616),
    [sym_comment] = ACTIONS(3),
  },
  [1012] = {
    [aux_sym_argument_list_repeat1] = STATE(998),
    [anon_sym_RPAREN] = ACTIONS(1598),
    [anon_sym_COMMA] = ACTIONS(1600),
    [sym_comment] = ACTIONS(3),
  },
  [1013] = {
    [aux_sym__parameters_repeat1] = STATE(965),
    [anon_sym_COMMA] = ACTIONS(2258),
    [anon_sym_COLON] = ACTIONS(1570),
    [sym_comment] = ACTIONS(3),
  },
  [1014] = {
    [aux_sym_list_repeat1] = STATE(993),
    [anon_sym_COMMA] = ACTIONS(1602),
    [anon_sym_RBRACK] = ACTIONS(1604),
    [sym_comment] = ACTIONS(3),
  },
  [1015] = {
    [anon_sym_in] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(578),
    [sym__newline] = ACTIONS(578),
  },
  [1016] = {
    [aux_sym_dictionary_repeat1] = STATE(981),
    [anon_sym_COMMA] = ACTIONS(2260),
    [anon_sym_RBRACE] = ACTIONS(582),
    [sym_comment] = ACTIONS(3),
  },
  [1017] = {
    [aux_sym_list_repeat1] = STATE(977),
    [anon_sym_COMMA] = ACTIONS(1572),
    [anon_sym_RBRACE] = ACTIONS(1580),
    [sym_comment] = ACTIONS(3),
  },
  [1018] = {
    [aux_sym_dictionary_repeat1] = STATE(966),
    [anon_sym_COMMA] = ACTIONS(1787),
    [anon_sym_RBRACE] = ACTIONS(1789),
    [sym_comment] = ACTIONS(3),
  },
  [1019] = {
    [aux_sym_list_repeat1] = STATE(908),
    [anon_sym_COMMA] = ACTIONS(2262),
    [anon_sym_RBRACE] = ACTIONS(726),
    [sym_comment] = ACTIONS(3),
  },
  [1020] = {
    [aux_sym__simple_statements_repeat1] = STATE(937),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2264),
    [sym__newline] = ACTIONS(339),
  },
  [1021] = {
    [aux_sym_argument_list_repeat1] = STATE(982),
    [anon_sym_RPAREN] = ACTIONS(1634),
    [anon_sym_COMMA] = ACTIONS(1636),
    [sym_comment] = ACTIONS(3),
  },
  [1022] = {
    [anon_sym_RPAREN] = ACTIONS(2223),
    [anon_sym_COMMA] = ACTIONS(2223),
    [sym_comment] = ACTIONS(3),
  },
  [1023] = {
    [anon_sym_COMMA] = ACTIONS(2213),
    [anon_sym_RBRACE] = ACTIONS(2213),
    [sym_comment] = ACTIONS(3),
  },
  [1024] = {
    [anon_sym_COLON] = ACTIONS(2266),
    [anon_sym_DASH_GT] = ACTIONS(2266),
    [sym_comment] = ACTIONS(3),
  },
  [1025] = {
    [anon_sym_COLON] = ACTIONS(2268),
    [anon_sym_DASH_GT] = ACTIONS(2270),
    [sym_comment] = ACTIONS(3),
  },
  [1026] = {
    [anon_sym_except] = ACTIONS(902),
    [anon_sym_finally] = ACTIONS(902),
    [sym_comment] = ACTIONS(3),
  },
  [1027] = {
    [anon_sym_RPAREN] = ACTIONS(2272),
    [anon_sym_COMMA] = ACTIONS(2272),
    [sym_comment] = ACTIONS(3),
  },
  [1028] = {
    [sym_parameters] = STATE(1040),
    [anon_sym_LPAREN] = ACTIONS(2274),
    [sym_comment] = ACTIONS(3),
  },
  [1029] = {
    [anon_sym_RPAREN] = ACTIONS(1950),
    [anon_sym_COMMA] = ACTIONS(1950),
    [sym_comment] = ACTIONS(3),
  },
  [1030] = {
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2276),
    [sym__newline] = ACTIONS(2276),
  },
  [1031] = {
    [anon_sym_RPAREN] = ACTIONS(1992),
    [anon_sym_COMMA] = ACTIONS(1992),
    [sym_comment] = ACTIONS(3),
  },
  [1032] = {
    [anon_sym_except] = ACTIONS(911),
    [anon_sym_finally] = ACTIONS(911),
    [sym_comment] = ACTIONS(3),
  },
  [1033] = {
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2278),
    [sym__newline] = ACTIONS(2278),
  },
  [1034] = {
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1467),
    [sym__newline] = ACTIONS(1467),
  },
  [1035] = {
    [sym_parameters] = STATE(1025),
    [anon_sym_LPAREN] = ACTIONS(2274),
    [sym_comment] = ACTIONS(3),
  },
  [1036] = {
    [anon_sym_COMMA] = ACTIONS(1973),
    [anon_sym_COLON] = ACTIONS(1973),
    [sym_comment] = ACTIONS(3),
  },
  [1037] = {
    [anon_sym_except] = ACTIONS(894),
    [anon_sym_finally] = ACTIONS(894),
    [sym_comment] = ACTIONS(3),
  },
  [1038] = {
    [anon_sym_COMMA] = ACTIONS(1835),
    [anon_sym_RBRACK] = ACTIONS(1835),
    [sym_comment] = ACTIONS(3),
  },
  [1039] = {
    [anon_sym_COLON] = ACTIONS(2280),
    [anon_sym_DASH_GT] = ACTIONS(2282),
    [sym_comment] = ACTIONS(3),
  },
  [1040] = {
    [anon_sym_COLON] = ACTIONS(2284),
    [anon_sym_DASH_GT] = ACTIONS(2286),
    [sym_comment] = ACTIONS(3),
  },
  [1041] = {
    [anon_sym_COLON] = ACTIONS(2288),
    [anon_sym_DASH_GT] = ACTIONS(2290),
    [sym_comment] = ACTIONS(3),
  },
  [1042] = {
    [anon_sym_except] = ACTIONS(922),
    [anon_sym_finally] = ACTIONS(922),
    [sym_comment] = ACTIONS(3),
  },
  [1043] = {
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2292),
    [sym__newline] = ACTIONS(2292),
  },
  [1044] = {
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2272),
    [sym__newline] = ACTIONS(2272),
  },
  [1045] = {
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2294),
    [sym__newline] = ACTIONS(2294),
  },
  [1046] = {
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2130),
    [sym__newline] = ACTIONS(2130),
  },
  [1047] = {
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2296),
    [sym__newline] = ACTIONS(2296),
  },
  [1048] = {
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2298),
    [sym__newline] = ACTIONS(2298),
  },
  [1049] = {
    [anon_sym_RPAREN] = ACTIONS(1930),
    [anon_sym_COMMA] = ACTIONS(1930),
    [sym_comment] = ACTIONS(3),
  },
  [1050] = {
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2300),
    [sym__newline] = ACTIONS(2300),
  },
  [1051] = {
    [anon_sym_COLON] = ACTIONS(2302),
    [anon_sym_DASH_GT] = ACTIONS(2302),
    [sym_comment] = ACTIONS(3),
  },
  [1052] = {
    [sym_dotted_name] = STATE(987),
    [sym_identifier] = ACTIONS(1760),
    [sym_comment] = ACTIONS(3),
  },
  [1053] = {
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2304),
    [sym__newline] = ACTIONS(2304),
  },
  [1054] = {
    [sym_parameters] = STATE(1039),
    [anon_sym_LPAREN] = ACTIONS(2274),
    [sym_comment] = ACTIONS(3),
  },
  [1055] = {
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2306),
    [sym__newline] = ACTIONS(2306),
  },
  [1056] = {
    [sym_parameters] = STATE(1041),
    [anon_sym_LPAREN] = ACTIONS(2274),
    [sym_comment] = ACTIONS(3),
  },
  [1057] = {
    [anon_sym_COMMA] = ACTIONS(2115),
    [anon_sym_COLON] = ACTIONS(2115),
    [sym_comment] = ACTIONS(3),
  },
  [1058] = {
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2308),
    [sym__newline] = ACTIONS(2308),
  },
  [1059] = {
    [anon_sym_except] = ACTIONS(898),
    [anon_sym_finally] = ACTIONS(898),
    [sym_comment] = ACTIONS(3),
  },
  [1060] = {
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2310),
    [sym__newline] = ACTIONS(2310),
  },
  [1061] = {
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2312),
    [sym__newline] = ACTIONS(2312),
  },
  [1062] = {
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2314),
    [sym__newline] = ACTIONS(2314),
  },
  [1063] = {
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2316),
    [sym__newline] = ACTIONS(2316),
  },
  [1064] = {
    [anon_sym_RBRACE] = ACTIONS(2318),
    [sym_comment] = ACTIONS(3),
  },
  [1065] = {
    [anon_sym_COLON] = ACTIONS(2320),
    [sym_comment] = ACTIONS(3),
  },
  [1066] = {
    [anon_sym_RPAREN] = ACTIONS(1630),
    [sym_comment] = ACTIONS(3),
  },
  [1067] = {
    [anon_sym_COLON] = ACTIONS(2322),
    [sym_comment] = ACTIONS(3),
  },
  [1068] = {
    [anon_sym_RBRACK] = ACTIONS(1624),
    [sym_comment] = ACTIONS(3),
  },
  [1069] = {
    [anon_sym_RBRACE] = ACTIONS(2324),
    [sym_comment] = ACTIONS(3),
  },
  [1070] = {
    [anon_sym_RBRACK] = ACTIONS(2326),
    [sym_comment] = ACTIONS(3),
  },
  [1071] = {
    [anon_sym_RBRACE] = ACTIONS(1742),
    [sym_comment] = ACTIONS(3),
  },
  [1072] = {
    [anon_sym_in] = ACTIONS(2328),
    [sym_comment] = ACTIONS(3),
  },
  [1073] = {
    [anon_sym_COLON] = ACTIONS(2330),
    [sym_comment] = ACTIONS(3),
  },
  [1074] = {
    [sym_identifier] = ACTIONS(2332),
    [sym_comment] = ACTIONS(3),
  },
  [1075] = {
    [anon_sym_RBRACE] = ACTIONS(2334),
    [sym_comment] = ACTIONS(3),
  },
  [1076] = {
    [sym_identifier] = ACTIONS(2336),
    [sym_comment] = ACTIONS(3),
  },
  [1077] = {
    [anon_sym_RPAREN] = ACTIONS(2338),
    [sym_comment] = ACTIONS(3),
  },
  [1078] = {
    [anon_sym_in] = ACTIONS(2340),
    [sym_comment] = ACTIONS(3),
  },
  [1079] = {
    [anon_sym_RPAREN] = ACTIONS(1870),
    [sym_comment] = ACTIONS(3),
  },
  [1080] = {
    [anon_sym_RPAREN] = ACTIONS(2342),
    [sym_comment] = ACTIONS(3),
  },
  [1081] = {
    [anon_sym_RBRACE] = ACTIONS(2344),
    [sym_comment] = ACTIONS(3),
  },
  [1082] = {
    [anon_sym_RPAREN] = ACTIONS(1634),
    [sym_comment] = ACTIONS(3),
  },
  [1083] = {
    [anon_sym_RBRACK] = ACTIONS(2346),
    [sym_comment] = ACTIONS(3),
  },
  [1084] = {
    [anon_sym_RBRACK] = ACTIONS(2348),
    [sym_comment] = ACTIONS(3),
  },
  [1085] = {
    [anon_sym_RPAREN] = ACTIONS(2350),
    [sym_comment] = ACTIONS(3),
  },
  [1086] = {
    [anon_sym_in] = ACTIONS(2352),
    [sym_comment] = ACTIONS(3),
  },
  [1087] = {
    [sym_identifier] = ACTIONS(2354),
    [sym_comment] = ACTIONS(3),
  },
  [1088] = {
    [anon_sym_COLON] = ACTIONS(2356),
    [sym_comment] = ACTIONS(3),
  },
  [1089] = {
    [anon_sym_RBRACE] = ACTIONS(2358),
    [sym_comment] = ACTIONS(3),
  },
  [1090] = {
    [anon_sym_RBRACE] = ACTIONS(2360),
    [sym_comment] = ACTIONS(3),
  },
  [1091] = {
    [anon_sym_RBRACE] = ACTIONS(1789),
    [sym_comment] = ACTIONS(3),
  },
  [1092] = {
    [anon_sym_RPAREN] = ACTIONS(1598),
    [sym_comment] = ACTIONS(3),
  },
  [1093] = {
    [anon_sym_RBRACK] = ACTIONS(1604),
    [sym_comment] = ACTIONS(3),
  },
  [1094] = {
    [anon_sym_COLON] = ACTIONS(2362),
    [sym_comment] = ACTIONS(3),
  },
  [1095] = {
    [anon_sym_COLON] = ACTIONS(2364),
    [sym_comment] = ACTIONS(3),
  },
  [1096] = {
    [anon_sym_RPAREN] = ACTIONS(2366),
    [sym_comment] = ACTIONS(3),
  },
  [1097] = {
    [anon_sym_RPAREN] = ACTIONS(2368),
    [sym_comment] = ACTIONS(3),
  },
  [1098] = {
    [anon_sym_COLON] = ACTIONS(2370),
    [sym_comment] = ACTIONS(3),
  },
  [1099] = {
    [anon_sym_import] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
  },
  [1100] = {
    [anon_sym_RBRACK] = ACTIONS(1612),
    [sym_comment] = ACTIONS(3),
  },
  [1101] = {
    [anon_sym_import] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
  },
  [1102] = {
    [anon_sym_COLON] = ACTIONS(2376),
    [sym_comment] = ACTIONS(3),
  },
  [1103] = {
    [anon_sym_COLON] = ACTIONS(2378),
    [sym_comment] = ACTIONS(3),
  },
  [1104] = {
    [anon_sym_RBRACE] = ACTIONS(1756),
    [sym_comment] = ACTIONS(3),
  },
  [1105] = {
    [anon_sym_RBRACE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
  },
  [1106] = {
    [anon_sym_in] = ACTIONS(2380),
    [sym_comment] = ACTIONS(3),
  },
  [1107] = {
    [anon_sym_RPAREN] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
  },
  [1108] = {
    [anon_sym_RPAREN] = ACTIONS(2384),
    [sym_comment] = ACTIONS(3),
  },
  [1109] = {
    [sym_identifier] = ACTIONS(2386),
    [sym_comment] = ACTIONS(3),
  },
  [1110] = {
    [anon_sym_in] = ACTIONS(2388),
    [sym_comment] = ACTIONS(3),
  },
  [1111] = {
    [anon_sym_def] = ACTIONS(2110),
    [sym_comment] = ACTIONS(3),
  },
  [1112] = {
    [anon_sym_RBRACE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(3),
  },
  [1113] = {
    [sym_identifier] = ACTIONS(2392),
    [sym_comment] = ACTIONS(3),
  },
  [1114] = {
    [sym_identifier] = ACTIONS(2394),
    [sym_comment] = ACTIONS(3),
  },
  [1115] = {
    [anon_sym_import] = ACTIONS(2396),
    [sym_comment] = ACTIONS(3),
  },
  [1116] = {
    [anon_sym_for] = ACTIONS(2398),
    [sym_comment] = ACTIONS(3),
  },
  [1117] = {
    [anon_sym_RPAREN] = ACTIONS(2400),
    [sym_comment] = ACTIONS(3),
  },
  [1118] = {
    [anon_sym_STAR] = ACTIONS(522),
    [sym_comment] = ACTIONS(3),
  },
  [1119] = {
    [anon_sym_in] = ACTIONS(2402),
    [sym_comment] = ACTIONS(3),
  },
  [1120] = {
    [anon_sym_EQ] = ACTIONS(2404),
    [sym_comment] = ACTIONS(3),
  },
  [1121] = {
    [anon_sym_COLON] = ACTIONS(2406),
    [sym_comment] = ACTIONS(3),
  },
  [1122] = {
    [anon_sym_RPAREN] = ACTIONS(1618),
    [sym_comment] = ACTIONS(3),
  },
  [1123] = {
    [anon_sym_RBRACE] = ACTIONS(2408),
    [sym_comment] = ACTIONS(3),
  },
  [1124] = {
    [anon_sym_COLON] = ACTIONS(2410),
    [sym_comment] = ACTIONS(3),
  },
  [1125] = {
    [anon_sym_RBRACE] = ACTIONS(2412),
    [sym_comment] = ACTIONS(3),
  },
  [1126] = {
    [anon_sym_COLON] = ACTIONS(2414),
    [sym_comment] = ACTIONS(3),
  },
  [1127] = {
    [anon_sym_COLON] = ACTIONS(2416),
    [sym_comment] = ACTIONS(3),
  },
  [1128] = {
    [anon_sym_COLON] = ACTIONS(2418),
    [sym_comment] = ACTIONS(3),
  },
  [1129] = {
    [sym_identifier] = ACTIONS(2420),
    [sym_comment] = ACTIONS(3),
  },
  [1130] = {
    [anon_sym_COLON] = ACTIONS(2422),
    [sym_comment] = ACTIONS(3),
  },
  [1131] = {
    [anon_sym_RBRACK] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
  },
  [1132] = {
    [anon_sym_COLON] = ACTIONS(2426),
    [sym_comment] = ACTIONS(3),
  },
  [1133] = {
    [anon_sym_COLON] = ACTIONS(2428),
    [sym_comment] = ACTIONS(3),
  },
  [1134] = {
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(2430),
  },
  [1135] = {
    [anon_sym_RPAREN] = ACTIONS(2432),
    [sym_comment] = ACTIONS(3),
  },
  [1136] = {
    [ts_builtin_sym_end] = ACTIONS(2434),
    [sym_comment] = ACTIONS(3),
  },
  [1137] = {
    [anon_sym_in] = ACTIONS(2436),
    [sym_comment] = ACTIONS(3),
  },
  [1138] = {
    [anon_sym_RPAREN] = ACTIONS(2438),
    [sym_comment] = ACTIONS(3),
  },
  [1139] = {
    [sym_identifier] = ACTIONS(2440),
    [sym_comment] = ACTIONS(3),
  },
  [1140] = {
    [anon_sym_COLON] = ACTIONS(2442),
    [sym_comment] = ACTIONS(3),
  },
  [1141] = {
    [sym_identifier] = ACTIONS(2444),
    [sym_comment] = ACTIONS(3),
  },
  [1142] = {
    [sym_identifier] = ACTIONS(2446),
    [sym_comment] = ACTIONS(3),
  },
  [1143] = {
    [sym_identifier] = ACTIONS(2448),
    [sym_comment] = ACTIONS(3),
  },
  [1144] = {
    [sym_identifier] = ACTIONS(2450),
    [sym_comment] = ACTIONS(3),
  },
  [1145] = {
    [sym_identifier] = ACTIONS(2452),
    [sym_comment] = ACTIONS(3),
  },
  [1146] = {
    [sym_identifier] = ACTIONS(2454),
    [sym_comment] = ACTIONS(3),
  },
  [1147] = {
    [anon_sym_COLON] = ACTIONS(2456),
    [sym_comment] = ACTIONS(3),
  },
  [1148] = {
    [anon_sym_in] = ACTIONS(2458),
    [sym_comment] = ACTIONS(3),
  },
  [1149] = {
    [sym_identifier] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
  },
  [1150] = {
    [anon_sym_COLON] = ACTIONS(2462),
    [sym_comment] = ACTIONS(3),
  },
  [1151] = {
    [anon_sym_RBRACE] = ACTIONS(1710),
    [sym_comment] = ACTIONS(3),
  },
  [1152] = {
    [anon_sym_RBRACK] = ACTIONS(1608),
    [sym_comment] = ACTIONS(3),
  },
  [1153] = {
    [sym_identifier] = ACTIONS(2464),
    [sym_comment] = ACTIONS(3),
  },
  [1154] = {
    [sym_identifier] = ACTIONS(2466),
    [sym_comment] = ACTIONS(3),
  },
  [1155] = {
    [anon_sym_in] = ACTIONS(2468),
    [sym_comment] = ACTIONS(3),
  },
  [1156] = {
    [anon_sym_def] = ACTIONS(2099),
    [sym_comment] = ACTIONS(3),
  },
  [1157] = {
    [anon_sym_in] = ACTIONS(2470),
    [sym_comment] = ACTIONS(3),
  },
  [1158] = {
    [anon_sym_COLON] = ACTIONS(2472),
    [sym_comment] = ACTIONS(3),
  },
  [1159] = {
    [anon_sym_COLON] = ACTIONS(2474),
    [sym_comment] = ACTIONS(3),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = false}, RECOVER(),
  [3] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [5] = {.count = 1, .reusable = true}, REDUCE(sym_module, 0),
  [7] = {.count = 1, .reusable = false}, SHIFT(163),
  [9] = {.count = 1, .reusable = false}, SHIFT(865),
  [11] = {.count = 1, .reusable = false}, SHIFT(787),
  [13] = {.count = 1, .reusable = true}, SHIFT(151),
  [15] = {.count = 1, .reusable = false}, SHIFT(48),
  [17] = {.count = 1, .reusable = false}, SHIFT(320),
  [19] = {.count = 1, .reusable = false}, SHIFT(172),
  [21] = {.count = 1, .reusable = false}, SHIFT(280),
  [23] = {.count = 1, .reusable = false}, SHIFT(142),
  [25] = {.count = 1, .reusable = false}, SHIFT(1061),
  [27] = {.count = 1, .reusable = false}, SHIFT(1060),
  [29] = {.count = 1, .reusable = false}, SHIFT(1058),
  [31] = {.count = 1, .reusable = false}, SHIFT(364),
  [33] = {.count = 1, .reusable = false}, SHIFT(932),
  [35] = {.count = 1, .reusable = false}, SHIFT(566),
  [37] = {.count = 1, .reusable = false}, SHIFT(342),
  [39] = {.count = 1, .reusable = false}, SHIFT(1147),
  [41] = {.count = 1, .reusable = false}, SHIFT(282),
  [43] = {.count = 1, .reusable = false}, SHIFT(1146),
  [45] = {.count = 1, .reusable = false}, SHIFT(1143),
  [47] = {.count = 1, .reusable = false}, SHIFT(1141),
  [49] = {.count = 1, .reusable = false}, SHIFT(137),
  [51] = {.count = 1, .reusable = false}, SHIFT(1139),
  [53] = {.count = 1, .reusable = true}, SHIFT(1052),
  [55] = {.count = 1, .reusable = false}, SHIFT(321),
  [57] = {.count = 1, .reusable = true}, SHIFT(639),
  [59] = {.count = 1, .reusable = false}, SHIFT(708),
  [61] = {.count = 1, .reusable = false}, SHIFT(167),
  [63] = {.count = 1, .reusable = true}, SHIFT(166),
  [65] = {.count = 1, .reusable = true}, SHIFT(120),
  [67] = {.count = 1, .reusable = true}, SHIFT(119),
  [69] = {.count = 1, .reusable = false}, SHIFT(120),
  [71] = {.count = 1, .reusable = false}, SHIFT(309),
  [73] = {.count = 1, .reusable = true}, SHIFT(808),
  [75] = {.count = 1, .reusable = false}, SHIFT(326),
  [77] = {.count = 1, .reusable = false}, SHIFT(921),
  [79] = {.count = 1, .reusable = false}, SHIFT(560),
  [81] = {.count = 1, .reusable = false}, SHIFT(327),
  [83] = {.count = 1, .reusable = false}, SHIFT(1140),
  [85] = {.count = 1, .reusable = false}, SHIFT(275),
  [87] = {.count = 1, .reusable = false}, SHIFT(1153),
  [89] = {.count = 1, .reusable = false}, SHIFT(1142),
  [91] = {.count = 1, .reusable = true}, SHIFT(274),
  [93] = {.count = 1, .reusable = true}, SHIFT(296),
  [95] = {.count = 1, .reusable = true}, SHIFT(1059),
  [97] = {.count = 1, .reusable = true}, REDUCE(sym_module, 1),
  [99] = {.count = 1, .reusable = true}, SHIFT(283),
  [101] = {.count = 1, .reusable = true}, SHIFT(1026),
  [103] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(163),
  [106] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(865),
  [109] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(787),
  [112] = {.count = 2, .reusable = true}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(151),
  [115] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(48),
  [118] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(320),
  [121] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(172),
  [124] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(280),
  [127] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(142),
  [130] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1061),
  [133] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1060),
  [136] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1058),
  [139] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(326),
  [142] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(921),
  [145] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(560),
  [148] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(327),
  [151] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1140),
  [154] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(275),
  [157] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1153),
  [160] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1143),
  [163] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1141),
  [166] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(137),
  [169] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1142),
  [172] = {.count = 2, .reusable = true}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1052),
  [175] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(321),
  [178] = {.count = 2, .reusable = true}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(639),
  [181] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(708),
  [184] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(167),
  [187] = {.count = 2, .reusable = true}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(166),
  [190] = {.count = 2, .reusable = true}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(120),
  [193] = {.count = 2, .reusable = true}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(119),
  [196] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(120),
  [199] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(309),
  [202] = {.count = 1, .reusable = true}, REDUCE(aux_sym_module_repeat1, 2),
  [204] = {.count = 2, .reusable = true}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(808),
  [207] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(364),
  [210] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(932),
  [213] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(566),
  [216] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(342),
  [219] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1147),
  [222] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(282),
  [225] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1146),
  [228] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1139),
  [231] = {.count = 1, .reusable = true}, SHIFT(289),
  [233] = {.count = 1, .reusable = false}, SHIFT(544),
  [235] = {.count = 1, .reusable = false}, REDUCE(sym__primary_expression, 1, .production_id = 1),
  [237] = {.count = 1, .reusable = true}, REDUCE(sym__primary_expression, 1, .production_id = 1),
  [239] = {.count = 1, .reusable = false}, SHIFT(570),
  [241] = {.count = 1, .reusable = false}, SHIFT(333),
  [243] = {.count = 1, .reusable = true}, SHIFT(628),
  [245] = {.count = 1, .reusable = false}, SHIFT(707),
  [247] = {.count = 1, .reusable = true}, SHIFT(532),
  [249] = {.count = 1, .reusable = true}, SHIFT(106),
  [251] = {.count = 1, .reusable = false}, SHIFT(532),
  [253] = {.count = 1, .reusable = false}, SHIFT(308),
  [255] = {.count = 1, .reusable = true}, SHIFT(828),
  [257] = {.count = 1, .reusable = true}, SHIFT(24),
  [259] = {.count = 1, .reusable = true}, SHIFT(35),
  [261] = {.count = 1, .reusable = true}, SHIFT(37),
  [263] = {.count = 1, .reusable = true}, SHIFT(12),
  [265] = {.count = 1, .reusable = true}, SHIFT(26),
  [267] = {.count = 1, .reusable = true}, SHIFT(22),
  [269] = {.count = 1, .reusable = true}, SHIFT(18),
  [271] = {.count = 1, .reusable = true}, SHIFT(23),
  [273] = {.count = 1, .reusable = true}, SHIFT(20),
  [275] = {.count = 1, .reusable = true}, SHIFT(41),
  [277] = {.count = 1, .reusable = true}, SHIFT(15),
  [279] = {.count = 1, .reusable = true}, SHIFT(13),
  [281] = {.count = 1, .reusable = true}, SHIFT(11),
  [283] = {.count = 1, .reusable = true}, SHIFT(9),
  [285] = {.count = 1, .reusable = true}, SHIFT(2),
  [287] = {.count = 1, .reusable = true}, SHIFT(8),
  [289] = {.count = 1, .reusable = true}, SHIFT(10),
  [291] = {.count = 1, .reusable = true}, SHIFT(39),
  [293] = {.count = 1, .reusable = true}, SHIFT(25),
  [295] = {.count = 1, .reusable = true}, SHIFT(14),
  [297] = {.count = 1, .reusable = true}, SHIFT(5),
  [299] = {.count = 1, .reusable = true}, SHIFT(34),
  [301] = {.count = 1, .reusable = true}, SHIFT(32),
  [303] = {.count = 1, .reusable = true}, SHIFT(30),
  [305] = {.count = 1, .reusable = true}, SHIFT(6),
  [307] = {.count = 1, .reusable = true}, SHIFT(4),
  [309] = {.count = 1, .reusable = true}, SHIFT(33),
  [311] = {.count = 1, .reusable = true}, SHIFT(36),
  [313] = {.count = 1, .reusable = true}, SHIFT(27),
  [315] = {.count = 1, .reusable = true}, SHIFT(28),
  [317] = {.count = 1, .reusable = true}, SHIFT(38),
  [319] = {.count = 1, .reusable = true}, SHIFT(17),
  [321] = {.count = 1, .reusable = true}, SHIFT(31),
  [323] = {.count = 1, .reusable = true}, SHIFT(19),
  [325] = {.count = 1, .reusable = true}, SHIFT(3),
  [327] = {.count = 1, .reusable = true}, SHIFT(21),
  [329] = {.count = 1, .reusable = true}, SHIFT(7),
  [331] = {.count = 1, .reusable = true}, SHIFT(40),
  [333] = {.count = 1, .reusable = true}, SHIFT(29),
  [335] = {.count = 1, .reusable = true}, SHIFT(16),
  [337] = {.count = 1, .reusable = true}, SHIFT(295),
  [339] = {.count = 1, .reusable = true}, SHIFT(298),
  [341] = {.count = 1, .reusable = true}, SHIFT(1032),
  [343] = {.count = 1, .reusable = true}, SHIFT(300),
  [345] = {.count = 1, .reusable = true}, SHIFT(1042),
  [347] = {.count = 1, .reusable = true}, SHIFT(287),
  [349] = {.count = 1, .reusable = false}, SHIFT(185),
  [351] = {.count = 1, .reusable = true}, REDUCE(sym_expression_list, 3),
  [353] = {.count = 1, .reusable = false}, SHIFT(639),
  [355] = {.count = 1, .reusable = true}, REDUCE(sym_expression_list, 2),
  [357] = {.count = 1, .reusable = true}, REDUCE(sym_expression_statement, 2),
  [359] = {.count = 1, .reusable = true}, REDUCE(sym_expression_statement, 3),
  [361] = {.count = 1, .reusable = false}, SHIFT(497),
  [363] = {.count = 1, .reusable = true}, SHIFT(149),
  [365] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_clause, 5, .production_id = 57),
  [367] = {.count = 1, .reusable = false}, SHIFT(507),
  [369] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_clause, 5, .production_id = 57),
  [371] = {.count = 1, .reusable = false}, SHIFT(373),
  [373] = {.count = 1, .reusable = true}, SHIFT(623),
  [375] = {.count = 1, .reusable = false}, SHIFT(706),
  [377] = {.count = 1, .reusable = true}, SHIFT(141),
  [379] = {.count = 1, .reusable = true}, SHIFT(405),
  [381] = {.count = 1, .reusable = true}, SHIFT(105),
  [383] = {.count = 1, .reusable = false}, SHIFT(405),
  [385] = {.count = 1, .reusable = false}, SHIFT(354),
  [387] = {.count = 1, .reusable = true}, SHIFT(798),
  [389] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_clause, 7, .production_id = 82),
  [391] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_clause, 7, .production_id = 82),
  [393] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_clause, 6, .production_id = 72),
  [395] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_clause, 6, .production_id = 72),
  [397] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_clause, 6, .production_id = 73),
  [399] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_clause, 6, .production_id = 73),
  [401] = {.count = 1, .reusable = true}, REDUCE(sym_concatenated_string, 2),
  [403] = {.count = 1, .reusable = false}, REDUCE(sym_concatenated_string, 2),
  [405] = {.count = 1, .reusable = true}, SHIFT(1151),
  [407] = {.count = 1, .reusable = true}, SHIFT(139),
  [409] = {.count = 1, .reusable = false}, SHIFT(709),
  [411] = {.count = 1, .reusable = true}, SHIFT(523),
  [413] = {.count = 1, .reusable = true}, SHIFT(1091),
  [415] = {.count = 1, .reusable = true}, SHIFT(591),
  [417] = {.count = 1, .reusable = false}, SHIFT(550),
  [419] = {.count = 1, .reusable = true}, SHIFT(568),
  [421] = {.count = 1, .reusable = true}, SHIFT(1066),
  [423] = {.count = 1, .reusable = false}, SHIFT(556),
  [425] = {.count = 1, .reusable = true}, SHIFT(235),
  [427] = {.count = 1, .reusable = true}, SHIFT(1082),
  [429] = {.count = 1, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2),
  [431] = {.count = 1, .reusable = false}, REDUCE(aux_sym_concatenated_string_repeat1, 2),
  [433] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(808),
  [436] = {.count = 1, .reusable = true}, SHIFT(499),
  [438] = {.count = 1, .reusable = true}, SHIFT(1122),
  [440] = {.count = 1, .reusable = true}, REDUCE(sym__primary_expression, 1),
  [442] = {.count = 1, .reusable = false}, REDUCE(sym__primary_expression, 1),
  [444] = {.count = 1, .reusable = true}, SHIFT(662),
  [446] = {.count = 1, .reusable = true}, SHIFT(1092),
  [448] = {.count = 1, .reusable = true}, SHIFT(1071),
  [450] = {.count = 1, .reusable = true}, SHIFT(658),
  [452] = {.count = 1, .reusable = true}, SHIFT(1104),
  [454] = {.count = 1, .reusable = true}, SHIFT(180),
  [456] = {.count = 1, .reusable = true}, SHIFT(1109),
  [458] = {.count = 1, .reusable = true}, SHIFT(108),
  [460] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1),
  [462] = {.count = 1, .reusable = false}, SHIFT(605),
  [464] = {.count = 1, .reusable = false}, SHIFT(621),
  [466] = {.count = 1, .reusable = true}, SHIFT(613),
  [468] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1),
  [470] = {.count = 1, .reusable = true}, SHIFT(1110),
  [472] = {.count = 1, .reusable = false}, SHIFT(611),
  [474] = {.count = 1, .reusable = false}, SHIFT(625),
  [476] = {.count = 1, .reusable = false}, SHIFT(626),
  [478] = {.count = 1, .reusable = false}, SHIFT(616),
  [480] = {.count = 1, .reusable = false}, SHIFT(607),
  [482] = {.count = 1, .reusable = false}, SHIFT(613),
  [484] = {.count = 1, .reusable = true}, SHIFT(552),
  [486] = {.count = 1, .reusable = true}, SHIFT(245),
  [488] = {.count = 1, .reusable = true}, REDUCE(sym_binary_operator, 3, .production_id = 19),
  [490] = {.count = 1, .reusable = false}, REDUCE(sym_binary_operator, 3, .production_id = 19),
  [492] = {.count = 1, .reusable = true}, SHIFT(597),
  [494] = {.count = 1, .reusable = true}, SHIFT(527),
  [496] = {.count = 1, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 3),
  [498] = {.count = 1, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 3),
  [500] = {.count = 1, .reusable = true}, SHIFT(604),
  [502] = {.count = 1, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2),
  [504] = {.count = 1, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2),
  [506] = {.count = 1, .reusable = true}, SHIFT(237),
  [508] = {.count = 1, .reusable = true}, REDUCE(sym_unary_operator, 2, .production_id = 7),
  [510] = {.count = 1, .reusable = false}, REDUCE(sym_unary_operator, 2, .production_id = 7),
  [512] = {.count = 1, .reusable = true}, SHIFT(224),
  [514] = {.count = 1, .reusable = true}, SHIFT(661),
  [516] = {.count = 1, .reusable = true}, SHIFT(804),
  [518] = {.count = 1, .reusable = true}, SHIFT(510),
  [520] = {.count = 1, .reusable = true}, REDUCE(sym_list_splat, 1),
  [522] = {.count = 1, .reusable = true}, SHIFT(379),
  [524] = {.count = 1, .reusable = true}, SHIFT(678),
  [526] = {.count = 1, .reusable = true}, SHIFT(1152),
  [528] = {.count = 1, .reusable = true}, SHIFT(183),
  [530] = {.count = 1, .reusable = true}, SHIFT(525),
  [532] = {.count = 1, .reusable = false}, SHIFT(348),
  [534] = {.count = 1, .reusable = true}, SHIFT(165),
  [536] = {.count = 1, .reusable = false}, SHIFT(346),
  [538] = {.count = 1, .reusable = true}, SHIFT(156),
  [540] = {.count = 1, .reusable = true}, REDUCE(sym_raise_statement, 1),
  [542] = {.count = 1, .reusable = true}, SHIFT(655),
  [544] = {.count = 1, .reusable = true}, SHIFT(1077),
  [546] = {.count = 1, .reusable = false}, SHIFT(144),
  [548] = {.count = 1, .reusable = false}, SHIFT(361),
  [550] = {.count = 1, .reusable = true}, REDUCE(sym_yield, 1),
  [552] = {.count = 1, .reusable = true}, SHIFT(1118),
  [554] = {.count = 1, .reusable = true}, SHIFT(199),
  [556] = {.count = 1, .reusable = true}, SHIFT(227),
  [558] = {.count = 1, .reusable = true}, SHIFT(602),
  [560] = {.count = 1, .reusable = true}, SHIFT(528),
  [562] = {.count = 1, .reusable = true}, SHIFT(1079),
  [564] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 5, .production_id = 48),
  [566] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 5, .production_id = 48),
  [568] = {.count = 1, .reusable = false}, SHIFT(1127),
  [570] = {.count = 1, .reusable = false}, SHIFT(294),
  [572] = {.count = 1, .reusable = false}, SHIFT(1126),
  [574] = {.count = 1, .reusable = true}, SHIFT(191),
  [576] = {.count = 1, .reusable = true}, SHIFT(1097),
  [578] = {.count = 1, .reusable = true}, REDUCE(sym_string, 2),
  [580] = {.count = 1, .reusable = false}, REDUCE(sym_string, 2),
  [582] = {.count = 1, .reusable = true}, SHIFT(651),
  [584] = {.count = 1, .reusable = true}, SHIFT(558),
  [586] = {.count = 1, .reusable = true}, SHIFT(1093),
  [588] = {.count = 1, .reusable = true}, SHIFT(559),
  [590] = {.count = 1, .reusable = false}, SHIFT(1103),
  [592] = {.count = 1, .reusable = false}, SHIFT(301),
  [594] = {.count = 1, .reusable = false}, SHIFT(1150),
  [596] = {.count = 1, .reusable = true}, SHIFT(503),
  [598] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 4, .production_id = 30),
  [600] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 4, .production_id = 30),
  [602] = {.count = 1, .reusable = true}, REDUCE(sym_string, 3),
  [604] = {.count = 1, .reusable = false}, REDUCE(sym_string, 3),
  [606] = {.count = 1, .reusable = true}, SHIFT(526),
  [608] = {.count = 1, .reusable = true}, SHIFT(673),
  [610] = {.count = 1, .reusable = true}, SHIFT(335),
  [612] = {.count = 1, .reusable = true}, SHIFT(588),
  [614] = {.count = 1, .reusable = true}, SHIFT(1096),
  [616] = {.count = 1, .reusable = true}, SHIFT(1100),
  [618] = {.count = 1, .reusable = true}, SHIFT(182),
  [620] = {.count = 1, .reusable = false}, SHIFT(345),
  [622] = {.count = 1, .reusable = true}, SHIFT(1068),
  [624] = {.count = 1, .reusable = true}, SHIFT(657),
  [626] = {.count = 1, .reusable = true}, SHIFT(500),
  [628] = {.count = 1, .reusable = true}, SHIFT(600),
  [630] = {.count = 1, .reusable = true}, SHIFT(207),
  [632] = {.count = 1, .reusable = true}, SHIFT(515),
  [634] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 1),
  [636] = {.count = 1, .reusable = true}, REDUCE(sym_generator_expression, 4, .production_id = 25),
  [638] = {.count = 1, .reusable = false}, REDUCE(sym_generator_expression, 4, .production_id = 25),
  [640] = {.count = 1, .reusable = true}, SHIFT(505),
  [642] = {.count = 1, .reusable = true}, SHIFT(524),
  [644] = {.count = 1, .reusable = true}, REDUCE(sym_tuple, 4),
  [646] = {.count = 1, .reusable = false}, REDUCE(sym_tuple, 4),
  [648] = {.count = 1, .reusable = false}, REDUCE(sym_expression_list, 2),
  [650] = {.count = 1, .reusable = true}, SHIFT(679),
  [652] = {.count = 1, .reusable = true}, SHIFT(668),
  [654] = {.count = 1, .reusable = true}, REDUCE(sym_dictionary, 2),
  [656] = {.count = 1, .reusable = false}, REDUCE(sym_dictionary, 2),
  [658] = {.count = 1, .reusable = true}, SHIFT(666),
  [660] = {.count = 1, .reusable = true}, REDUCE(sym_list, 2),
  [662] = {.count = 1, .reusable = false}, REDUCE(sym_list, 2),
  [664] = {.count = 1, .reusable = true}, REDUCE(sym_tuple, 5),
  [666] = {.count = 1, .reusable = false}, REDUCE(sym_tuple, 5),
  [668] = {.count = 1, .reusable = true}, SHIFT(514),
  [670] = {.count = 1, .reusable = true}, REDUCE(sym_list, 5),
  [672] = {.count = 1, .reusable = false}, REDUCE(sym_list, 5),
  [674] = {.count = 1, .reusable = true}, SHIFT(659),
  [676] = {.count = 1, .reusable = true}, SHIFT(502),
  [678] = {.count = 1, .reusable = true}, REDUCE(sym_tuple, 2),
  [680] = {.count = 1, .reusable = false}, REDUCE(sym_tuple, 2),
  [682] = {.count = 1, .reusable = true}, REDUCE(sym_set, 5),
  [684] = {.count = 1, .reusable = false}, REDUCE(sym_set, 5),
  [686] = {.count = 1, .reusable = true}, SHIFT(660),
  [688] = {.count = 1, .reusable = true}, SHIFT(555),
  [690] = {.count = 1, .reusable = true}, SHIFT(553),
  [692] = {.count = 1, .reusable = true}, SHIFT(557),
  [694] = {.count = 1, .reusable = true}, SHIFT(176),
  [696] = {.count = 1, .reusable = true}, SHIFT(509),
  [698] = {.count = 1, .reusable = true}, REDUCE(sym_dictionary, 5),
  [700] = {.count = 1, .reusable = false}, REDUCE(sym_dictionary, 5),
  [702] = {.count = 1, .reusable = true}, SHIFT(585),
  [704] = {.count = 1, .reusable = true}, SHIFT(586),
  [706] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 3),
  [708] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 3),
  [710] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 4, .production_id = 40),
  [712] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 4, .production_id = 40),
  [714] = {.count = 1, .reusable = true}, SHIFT(184),
  [716] = {.count = 1, .reusable = true}, REDUCE(sym_slice, 2),
  [718] = {.count = 1, .reusable = true}, SHIFT(246),
  [720] = {.count = 1, .reusable = true}, SHIFT(232),
  [722] = {.count = 1, .reusable = true}, REDUCE(sym_slice, 1),
  [724] = {.count = 1, .reusable = true}, SHIFT(258),
  [726] = {.count = 1, .reusable = true}, SHIFT(670),
  [728] = {.count = 1, .reusable = true}, SHIFT(675),
  [730] = {.count = 1, .reusable = true}, REDUCE(sym_tuple, 3),
  [732] = {.count = 1, .reusable = false}, REDUCE(sym_tuple, 3),
  [734] = {.count = 1, .reusable = true}, REDUCE(sym_list, 3),
  [736] = {.count = 1, .reusable = false}, REDUCE(sym_list, 3),
  [738] = {.count = 1, .reusable = true}, SHIFT(238),
  [740] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 3),
  [742] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 3),
  [744] = {.count = 1, .reusable = true}, SHIFT(677),
  [746] = {.count = 1, .reusable = true}, REDUCE(sym_dictionary, 3),
  [748] = {.count = 1, .reusable = false}, REDUCE(sym_dictionary, 3),
  [750] = {.count = 1, .reusable = true}, SHIFT(230),
  [752] = {.count = 1, .reusable = true}, REDUCE(sym_set, 3),
  [754] = {.count = 1, .reusable = false}, REDUCE(sym_set, 3),
  [756] = {.count = 1, .reusable = false}, REDUCE(sym_expression_list, 3),
  [758] = {.count = 1, .reusable = true}, REDUCE(sym_call, 2, .production_id = 8),
  [760] = {.count = 1, .reusable = false}, REDUCE(sym_call, 2, .production_id = 8),
  [762] = {.count = 1, .reusable = true}, REDUCE(sym_dictionary_comprehension, 4, .production_id = 25),
  [764] = {.count = 1, .reusable = false}, REDUCE(sym_dictionary_comprehension, 4, .production_id = 25),
  [766] = {.count = 1, .reusable = true}, REDUCE(sym_set_comprehension, 4, .production_id = 25),
  [768] = {.count = 1, .reusable = false}, REDUCE(sym_set_comprehension, 4, .production_id = 25),
  [770] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 4),
  [772] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 4),
  [774] = {.count = 1, .reusable = true}, SHIFT(590),
  [776] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 6, .production_id = 54),
  [778] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 6, .production_id = 54),
  [780] = {.count = 1, .reusable = true}, REDUCE(sym_dictionary, 4),
  [782] = {.count = 1, .reusable = false}, REDUCE(sym_dictionary, 4),
  [784] = {.count = 1, .reusable = true}, SHIFT(506),
  [786] = {.count = 1, .reusable = true}, SHIFT(192),
  [788] = {.count = 1, .reusable = true}, REDUCE(sym_set, 4),
  [790] = {.count = 1, .reusable = false}, REDUCE(sym_set, 4),
  [792] = {.count = 1, .reusable = true}, REDUCE(sym_list_comprehension, 4, .production_id = 25),
  [794] = {.count = 1, .reusable = false}, REDUCE(sym_list_comprehension, 4, .production_id = 25),
  [796] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 5, .production_id = 40),
  [798] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 5, .production_id = 40),
  [800] = {.count = 1, .reusable = true}, SHIFT(595),
  [802] = {.count = 1, .reusable = true}, REDUCE(sym_attribute, 3),
  [804] = {.count = 1, .reusable = false}, REDUCE(sym_attribute, 3),
  [806] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 2),
  [808] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 2),
  [810] = {.count = 1, .reusable = true}, SHIFT(187),
  [812] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 5),
  [814] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 5),
  [816] = {.count = 1, .reusable = true}, REDUCE(sym_list, 4),
  [818] = {.count = 1, .reusable = false}, REDUCE(sym_list, 4),
  [820] = {.count = 1, .reusable = true}, SHIFT(226),
  [822] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 5, .production_id = 54),
  [824] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 5, .production_id = 54),
  [826] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 6, .production_id = 59),
  [828] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 6, .production_id = 59),
  [830] = {.count = 1, .reusable = false}, SHIFT(371),
  [832] = {.count = 1, .reusable = true}, REDUCE(sym_slice, 3),
  [834] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 5, .production_id = 41),
  [836] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 5, .production_id = 41),
  [838] = {.count = 1, .reusable = false}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [840] = {.count = 1, .reusable = true}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [842] = {.count = 2, .reusable = false}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(294),
  [845] = {.count = 1, .reusable = true}, REDUCE(sym_slice, 4),
  [847] = {.count = 1, .reusable = false}, SHIFT(339),
  [849] = {.count = 2, .reusable = false}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(301),
  [852] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 4, .production_id = 28),
  [854] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 4, .production_id = 28),
  [856] = {.count = 1, .reusable = true}, REDUCE(sym_print_statement, 4, .production_id = 12),
  [858] = {.count = 1, .reusable = true}, REDUCE(sym_print_statement, 4, .production_id = 11),
  [860] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 5, .production_id = 44),
  [862] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 5, .production_id = 44),
  [864] = {.count = 1, .reusable = true}, REDUCE(sym_print_statement, 3),
  [866] = {.count = 1, .reusable = true}, REDUCE(sym_print_statement, 3, .production_id = 4),
  [868] = {.count = 1, .reusable = false}, SHIFT(608),
  [870] = {.count = 1, .reusable = true}, SHIFT(143),
  [872] = {.count = 1, .reusable = false}, SHIFT(669),
  [874] = {.count = 1, .reusable = false}, SHIFT(340),
  [876] = {.count = 1, .reusable = true}, SHIFT(637),
  [878] = {.count = 1, .reusable = false}, SHIFT(710),
  [880] = {.count = 1, .reusable = true}, SHIFT(168),
  [882] = {.count = 1, .reusable = true}, SHIFT(547),
  [884] = {.count = 1, .reusable = true}, SHIFT(118),
  [886] = {.count = 1, .reusable = false}, SHIFT(547),
  [888] = {.count = 1, .reusable = false}, SHIFT(312),
  [890] = {.count = 1, .reusable = true}, SHIFT(816),
  [892] = {.count = 1, .reusable = false}, REDUCE(sym__simple_statements, 2),
  [894] = {.count = 1, .reusable = true}, REDUCE(sym__simple_statements, 2),
  [896] = {.count = 1, .reusable = false}, REDUCE(sym_block, 1),
  [898] = {.count = 1, .reusable = true}, REDUCE(sym_block, 1),
  [900] = {.count = 1, .reusable = false}, REDUCE(sym_block, 2),
  [902] = {.count = 1, .reusable = true}, REDUCE(sym_block, 2),
  [904] = {.count = 1, .reusable = true}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 61),
  [906] = {.count = 1, .reusable = false}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 61),
  [908] = {.count = 2, .reusable = false}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 61), SHIFT_REPEAT(339),
  [911] = {.count = 1, .reusable = true}, REDUCE(sym__simple_statements, 4),
  [913] = {.count = 1, .reusable = false}, REDUCE(sym__simple_statements, 4),
  [915] = {.count = 1, .reusable = true}, SHIFT(60),
  [917] = {.count = 2, .reusable = false}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 61), SHIFT_REPEAT(371),
  [920] = {.count = 1, .reusable = false}, REDUCE(sym__simple_statements, 3),
  [922] = {.count = 1, .reusable = true}, REDUCE(sym__simple_statements, 3),
  [924] = {.count = 1, .reusable = true}, SHIFT(53),
  [926] = {.count = 1, .reusable = true}, REDUCE(sym_except_clause, 4),
  [928] = {.count = 1, .reusable = false}, REDUCE(sym_except_clause, 4),
  [930] = {.count = 1, .reusable = false}, REDUCE(sym_except_clause, 7),
  [932] = {.count = 1, .reusable = true}, REDUCE(sym_except_clause, 7),
  [934] = {.count = 1, .reusable = true}, REDUCE(sym_except_clause, 4, .production_id = 80),
  [936] = {.count = 1, .reusable = false}, REDUCE(sym_except_clause, 4, .production_id = 80),
  [938] = {.count = 1, .reusable = true}, REDUCE(sym_except_clause, 3, .production_id = 67),
  [940] = {.count = 1, .reusable = false}, REDUCE(sym_except_clause, 3, .production_id = 67),
  [942] = {.count = 1, .reusable = true}, REDUCE(sym_except_clause, 5),
  [944] = {.count = 1, .reusable = false}, REDUCE(sym_except_clause, 5),
  [946] = {.count = 1, .reusable = true}, REDUCE(sym_except_clause, 6, .production_id = 90),
  [948] = {.count = 1, .reusable = false}, REDUCE(sym_except_clause, 6, .production_id = 90),
  [950] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 6, .production_id = 48),
  [952] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 6, .production_id = 48),
  [954] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 5, .production_id = 46),
  [956] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 5, .production_id = 46),
  [958] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 7, .production_id = 78),
  [960] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 7, .production_id = 78),
  [962] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 7, .production_id = 75),
  [964] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 7, .production_id = 75),
  [966] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 6, .production_id = 65),
  [968] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 6, .production_id = 65),
  [970] = {.count = 1, .reusable = true}, REDUCE(sym_elif_clause, 5, .production_id = 41),
  [972] = {.count = 1, .reusable = false}, REDUCE(sym_elif_clause, 5, .production_id = 41),
  [974] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 8, .production_id = 83),
  [976] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 8, .production_id = 83),
  [978] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 4, .production_id = 29),
  [980] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 4, .production_id = 29),
  [982] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 5, .production_id = 30),
  [984] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 5, .production_id = 30),
  [986] = {.count = 1, .reusable = false}, REDUCE(sym_elif_clause, 4, .production_id = 28),
  [988] = {.count = 1, .reusable = true}, REDUCE(sym_elif_clause, 4, .production_id = 28),
  [990] = {.count = 1, .reusable = true}, REDUCE(aux_sym_if_statement_repeat1, 1, .production_id = 42),
  [992] = {.count = 1, .reusable = false}, REDUCE(aux_sym_if_statement_repeat1, 1, .production_id = 42),
  [994] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(798),
  [997] = {.count = 1, .reusable = true}, SHIFT(1149),
  [999] = {.count = 1, .reusable = true}, SHIFT(114),
  [1001] = {.count = 1, .reusable = false}, SHIFT(638),
  [1003] = {.count = 1, .reusable = true}, SHIFT(636),
  [1005] = {.count = 1, .reusable = true}, SHIFT(635),
  [1007] = {.count = 1, .reusable = true}, SHIFT(638),
  [1009] = {.count = 1, .reusable = true}, SHIFT(1148),
  [1011] = {.count = 1, .reusable = true}, SHIFT(634),
  [1013] = {.count = 1, .reusable = true}, SHIFT(633),
  [1015] = {.count = 1, .reusable = true}, SHIFT(632),
  [1017] = {.count = 1, .reusable = true}, SHIFT(630),
  [1019] = {.count = 1, .reusable = true}, SHIFT(629),
  [1021] = {.count = 1, .reusable = false}, SHIFT(635),
  [1023] = {.count = 1, .reusable = true}, SHIFT(587),
  [1025] = {.count = 1, .reusable = true}, SHIFT(255),
  [1027] = {.count = 1, .reusable = true}, REDUCE(sym_else_clause, 3, .production_id = 30),
  [1029] = {.count = 1, .reusable = false}, REDUCE(sym_else_clause, 3, .production_id = 30),
  [1031] = {.count = 1, .reusable = true}, REDUCE(sym_else_clause, 4, .production_id = 48),
  [1033] = {.count = 1, .reusable = false}, REDUCE(sym_else_clause, 4, .production_id = 48),
  [1035] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 6, .production_id = 30),
  [1037] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 6, .production_id = 30),
  [1039] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 6, .production_id = 58),
  [1041] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 6, .production_id = 58),
  [1043] = {.count = 1, .reusable = false}, REDUCE(sym_class_definition, 4, .production_id = 33),
  [1045] = {.count = 1, .reusable = true}, REDUCE(sym_class_definition, 4, .production_id = 33),
  [1047] = {.count = 1, .reusable = false}, REDUCE(sym_with_statement, 4, .production_id = 31),
  [1049] = {.count = 1, .reusable = true}, REDUCE(sym_with_statement, 4, .production_id = 31),
  [1051] = {.count = 1, .reusable = true}, REDUCE(sym_with_statement, 5, .production_id = 49),
  [1053] = {.count = 1, .reusable = false}, REDUCE(sym_with_statement, 5, .production_id = 49),
  [1055] = {.count = 1, .reusable = true}, REDUCE(sym_with_statement, 5, .production_id = 45),
  [1057] = {.count = 1, .reusable = false}, REDUCE(sym_with_statement, 5, .production_id = 45),
  [1059] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 5, .production_id = 50),
  [1061] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 5, .production_id = 50),
  [1063] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 5, .production_id = 47),
  [1065] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 5, .production_id = 47),
  [1067] = {.count = 1, .reusable = true}, REDUCE(sym_class_definition, 5, .production_id = 51),
  [1069] = {.count = 1, .reusable = false}, REDUCE(sym_class_definition, 5, .production_id = 51),
  [1071] = {.count = 1, .reusable = true}, REDUCE(sym_class_definition, 5, .production_id = 52),
  [1073] = {.count = 1, .reusable = false}, REDUCE(sym_class_definition, 5, .production_id = 52),
  [1075] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 5, .production_id = 43),
  [1077] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 5, .production_id = 43),
  [1079] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 9, .production_id = 89),
  [1081] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 9, .production_id = 89),
  [1083] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 9, .production_id = 88),
  [1085] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 9, .production_id = 88),
  [1087] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 8, .production_id = 87),
  [1089] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 8, .production_id = 87),
  [1091] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 8, .production_id = 86),
  [1093] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 8, .production_id = 86),
  [1095] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 8, .production_id = 85),
  [1097] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 8, .production_id = 85),
  [1099] = {.count = 1, .reusable = true}, REDUCE(sym_decorated_definition, 2, .production_id = 9),
  [1101] = {.count = 1, .reusable = false}, REDUCE(sym_decorated_definition, 2, .production_id = 9),
  [1103] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 8, .production_id = 84),
  [1105] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 8, .production_id = 84),
  [1107] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 7, .production_id = 81),
  [1109] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 7, .production_id = 81),
  [1111] = {.count = 1, .reusable = false}, REDUCE(sym_finally_clause, 4),
  [1113] = {.count = 1, .reusable = true}, REDUCE(sym_finally_clause, 4),
  [1115] = {.count = 1, .reusable = false}, REDUCE(sym_class_definition, 6, .production_id = 69),
  [1117] = {.count = 1, .reusable = true}, REDUCE(sym_class_definition, 6, .production_id = 69),
  [1119] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 7, .production_id = 48),
  [1121] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 7, .production_id = 48),
  [1123] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 6, .production_id = 60),
  [1125] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 6, .production_id = 60),
  [1127] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 7, .production_id = 79),
  [1129] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 7, .production_id = 79),
  [1131] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 7, .production_id = 77),
  [1133] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 7, .production_id = 77),
  [1135] = {.count = 1, .reusable = false}, REDUCE(sym_with_statement, 7, .production_id = 76),
  [1137] = {.count = 1, .reusable = true}, REDUCE(sym_with_statement, 7, .production_id = 76),
  [1139] = {.count = 1, .reusable = false}, REDUCE(sym_with_statement, 6, .production_id = 62),
  [1141] = {.count = 1, .reusable = true}, REDUCE(sym_with_statement, 6, .production_id = 62),
  [1143] = {.count = 1, .reusable = false}, REDUCE(sym_with_statement, 6, .production_id = 63),
  [1145] = {.count = 1, .reusable = true}, REDUCE(sym_with_statement, 6, .production_id = 63),
  [1147] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 6, .production_id = 64),
  [1149] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 6, .production_id = 64),
  [1151] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 6, .production_id = 66),
  [1153] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 6, .production_id = 66),
  [1155] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 6, .production_id = 68),
  [1157] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 6, .production_id = 68),
  [1159] = {.count = 1, .reusable = true}, REDUCE(sym_finally_clause, 3, .production_id = 67),
  [1161] = {.count = 1, .reusable = false}, REDUCE(sym_finally_clause, 3, .production_id = 67),
  [1163] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 7, .production_id = 74),
  [1165] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 7, .production_id = 74),
  [1167] = {.count = 1, .reusable = true}, SHIFT(363),
  [1169] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(828),
  [1172] = {.count = 1, .reusable = true}, SHIFT(1087),
  [1174] = {.count = 1, .reusable = true}, SHIFT(107),
  [1176] = {.count = 1, .reusable = false}, SHIFT(606),
  [1178] = {.count = 1, .reusable = true}, SHIFT(619),
  [1180] = {.count = 1, .reusable = true}, SHIFT(618),
  [1182] = {.count = 1, .reusable = true}, SHIFT(606),
  [1184] = {.count = 1, .reusable = true}, SHIFT(1086),
  [1186] = {.count = 1, .reusable = true}, SHIFT(617),
  [1188] = {.count = 1, .reusable = true}, SHIFT(614),
  [1190] = {.count = 1, .reusable = true}, SHIFT(612),
  [1192] = {.count = 1, .reusable = true}, SHIFT(610),
  [1194] = {.count = 1, .reusable = true}, SHIFT(609),
  [1196] = {.count = 1, .reusable = false}, SHIFT(618),
  [1198] = {.count = 1, .reusable = true}, SHIFT(601),
  [1200] = {.count = 1, .reusable = true}, SHIFT(244),
  [1202] = {.count = 1, .reusable = true}, SHIFT(303),
  [1204] = {.count = 1, .reusable = true}, SHIFT(1076),
  [1206] = {.count = 1, .reusable = true}, SHIFT(117),
  [1208] = {.count = 1, .reusable = false}, SHIFT(631),
  [1210] = {.count = 1, .reusable = true}, SHIFT(624),
  [1212] = {.count = 1, .reusable = true}, SHIFT(644),
  [1214] = {.count = 1, .reusable = true}, SHIFT(631),
  [1216] = {.count = 1, .reusable = true}, SHIFT(1078),
  [1218] = {.count = 1, .reusable = true}, SHIFT(648),
  [1220] = {.count = 1, .reusable = true}, SHIFT(647),
  [1222] = {.count = 1, .reusable = true}, SHIFT(646),
  [1224] = {.count = 1, .reusable = true}, SHIFT(645),
  [1226] = {.count = 1, .reusable = true}, SHIFT(627),
  [1228] = {.count = 1, .reusable = false}, SHIFT(644),
  [1230] = {.count = 1, .reusable = true}, SHIFT(561),
  [1232] = {.count = 1, .reusable = true}, SHIFT(266),
  [1234] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(816),
  [1237] = {.count = 1, .reusable = false}, SHIFT(368),
  [1239] = {.count = 1, .reusable = false}, SHIFT(696),
  [1241] = {.count = 1, .reusable = false}, REDUCE(sym_variables, 2),
  [1243] = {.count = 1, .reusable = true}, SHIFT(696),
  [1245] = {.count = 1, .reusable = false}, SHIFT(127),
  [1247] = {.count = 1, .reusable = false}, SHIFT(615),
  [1249] = {.count = 1, .reusable = true}, SHIFT(127),
  [1251] = {.count = 1, .reusable = false}, SHIFT(367),
  [1253] = {.count = 1, .reusable = false}, SHIFT(694),
  [1255] = {.count = 1, .reusable = true}, SHIFT(694),
  [1257] = {.count = 1, .reusable = false}, SHIFT(565),
  [1259] = {.count = 1, .reusable = false}, SHIFT(640),
  [1261] = {.count = 1, .reusable = true}, SHIFT(565),
  [1263] = {.count = 1, .reusable = false}, REDUCE(sym_variables, 3),
  [1265] = {.count = 1, .reusable = false}, SHIFT(431),
  [1267] = {.count = 1, .reusable = false}, SHIFT(620),
  [1269] = {.count = 1, .reusable = true}, SHIFT(431),
  [1271] = {.count = 1, .reusable = false}, SHIFT(540),
  [1273] = {.count = 1, .reusable = false}, SHIFT(642),
  [1275] = {.count = 1, .reusable = true}, SHIFT(540),
  [1277] = {.count = 1, .reusable = false}, SHIFT(121),
  [1279] = {.count = 1, .reusable = true}, SHIFT(121),
  [1281] = {.count = 1, .reusable = false}, SHIFT(538),
  [1283] = {.count = 1, .reusable = true}, SHIFT(538),
  [1285] = {.count = 1, .reusable = false}, SHIFT(135),
  [1287] = {.count = 1, .reusable = true}, SHIFT(135),
  [1289] = {.count = 1, .reusable = true}, SHIFT(329),
  [1291] = {.count = 1, .reusable = false}, SHIFT(533),
  [1293] = {.count = 1, .reusable = true}, SHIFT(533),
  [1295] = {.count = 1, .reusable = false}, SHIFT(539),
  [1297] = {.count = 1, .reusable = true}, SHIFT(539),
  [1299] = {.count = 1, .reusable = false}, SHIFT(128),
  [1301] = {.count = 1, .reusable = true}, SHIFT(128),
  [1303] = {.count = 1, .reusable = false}, SHIFT(541),
  [1305] = {.count = 1, .reusable = true}, SHIFT(541),
  [1307] = {.count = 1, .reusable = false}, SHIFT(534),
  [1309] = {.count = 1, .reusable = true}, SHIFT(534),
  [1311] = {.count = 1, .reusable = false}, SHIFT(124),
  [1313] = {.count = 1, .reusable = true}, SHIFT(124),
  [1315] = {.count = 1, .reusable = false}, SHIFT(134),
  [1317] = {.count = 1, .reusable = true}, SHIFT(134),
  [1319] = {.count = 1, .reusable = false}, SHIFT(537),
  [1321] = {.count = 1, .reusable = true}, SHIFT(537),
  [1323] = {.count = 1, .reusable = false}, SHIFT(542),
  [1325] = {.count = 1, .reusable = true}, SHIFT(542),
  [1327] = {.count = 1, .reusable = false}, SHIFT(418),
  [1329] = {.count = 1, .reusable = true}, SHIFT(418),
  [1331] = {.count = 1, .reusable = false}, SHIFT(126),
  [1333] = {.count = 1, .reusable = true}, SHIFT(126),
  [1335] = {.count = 1, .reusable = false}, SHIFT(453),
  [1337] = {.count = 1, .reusable = true}, SHIFT(453),
  [1339] = {.count = 1, .reusable = false}, SHIFT(564),
  [1341] = {.count = 1, .reusable = true}, SHIFT(564),
  [1343] = {.count = 1, .reusable = false}, SHIFT(129),
  [1345] = {.count = 1, .reusable = true}, SHIFT(129),
  [1347] = {.count = 1, .reusable = false}, SHIFT(130),
  [1349] = {.count = 1, .reusable = true}, SHIFT(130),
  [1351] = {.count = 1, .reusable = false}, SHIFT(575),
  [1353] = {.count = 1, .reusable = true}, SHIFT(575),
  [1355] = {.count = 1, .reusable = false}, SHIFT(536),
  [1357] = {.count = 1, .reusable = true}, SHIFT(536),
  [1359] = {.count = 1, .reusable = false}, SHIFT(422),
  [1361] = {.count = 1, .reusable = true}, SHIFT(422),
  [1363] = {.count = 1, .reusable = false}, SHIFT(427),
  [1365] = {.count = 1, .reusable = true}, SHIFT(427),
  [1367] = {.count = 1, .reusable = false}, SHIFT(563),
  [1369] = {.count = 1, .reusable = true}, SHIFT(563),
  [1371] = {.count = 1, .reusable = false}, SHIFT(428),
  [1373] = {.count = 1, .reusable = true}, SHIFT(428),
  [1375] = {.count = 1, .reusable = false}, SHIFT(429),
  [1377] = {.count = 1, .reusable = true}, SHIFT(429),
  [1379] = {.count = 1, .reusable = false}, SHIFT(430),
  [1381] = {.count = 1, .reusable = true}, SHIFT(430),
  [1383] = {.count = 1, .reusable = false}, SHIFT(432),
  [1385] = {.count = 1, .reusable = true}, SHIFT(432),
  [1387] = {.count = 1, .reusable = false}, SHIFT(582),
  [1389] = {.count = 1, .reusable = true}, SHIFT(582),
  [1391] = {.count = 1, .reusable = false}, SHIFT(433),
  [1393] = {.count = 1, .reusable = true}, SHIFT(433),
  [1395] = {.count = 1, .reusable = false}, SHIFT(132),
  [1397] = {.count = 1, .reusable = true}, SHIFT(132),
  [1399] = {.count = 1, .reusable = false}, SHIFT(578),
  [1401] = {.count = 1, .reusable = true}, SHIFT(578),
  [1403] = {.count = 1, .reusable = false}, SHIFT(535),
  [1405] = {.count = 1, .reusable = true}, SHIFT(535),
  [1407] = {.count = 1, .reusable = false}, SHIFT(574),
  [1409] = {.count = 1, .reusable = true}, SHIFT(574),
  [1411] = {.count = 1, .reusable = false}, SHIFT(573),
  [1413] = {.count = 1, .reusable = true}, SHIFT(573),
  [1415] = {.count = 1, .reusable = false}, SHIFT(569),
  [1417] = {.count = 1, .reusable = true}, SHIFT(569),
  [1419] = {.count = 1, .reusable = false}, SHIFT(567),
  [1421] = {.count = 1, .reusable = true}, SHIFT(567),
  [1423] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(613),
  [1426] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1110),
  [1429] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(613),
  [1432] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(552),
  [1435] = {.count = 1, .reusable = true}, REDUCE(sym_comparison_operator, 2),
  [1437] = {.count = 1, .reusable = false}, REDUCE(sym_comparison_operator, 2),
  [1439] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(635),
  [1442] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1148),
  [1445] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(635),
  [1448] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(587),
  [1451] = {.count = 1, .reusable = true}, REDUCE(sym_await, 2),
  [1453] = {.count = 1, .reusable = true}, SHIFT(99),
  [1455] = {.count = 1, .reusable = true}, SHIFT(332),
  [1457] = {.count = 1, .reusable = true}, REDUCE(sym_expression_list, 1),
  [1459] = {.count = 1, .reusable = true}, SHIFT(325),
  [1461] = {.count = 1, .reusable = true}, SHIFT(324),
  [1463] = {.count = 1, .reusable = true}, REDUCE(sym_boolean_operator, 3, .production_id = 18),
  [1465] = {.count = 1, .reusable = true}, SHIFT(97),
  [1467] = {.count = 1, .reusable = true}, REDUCE(sym_expression_statement, 1),
  [1469] = {.count = 1, .reusable = true}, REDUCE(sym_boolean_operator, 3, .production_id = 19),
  [1471] = {.count = 1, .reusable = true}, REDUCE(sym_not_operator, 2, .production_id = 4),
  [1473] = {.count = 1, .reusable = true}, REDUCE(sym_lambda, 4, .production_id = 38),
  [1475] = {.count = 1, .reusable = true}, REDUCE(sym_named_expression, 3, .production_id = 15),
  [1477] = {.count = 1, .reusable = true}, REDUCE(sym_conditional_expression, 5),
  [1479] = {.count = 1, .reusable = true}, REDUCE(sym_lambda, 3, .production_id = 14),
  [1481] = {.count = 1, .reusable = true}, SHIFT(551),
  [1483] = {.count = 1, .reusable = true}, REDUCE(sym_variables, 1),
  [1485] = {.count = 1, .reusable = true}, REDUCE(aux_sym_assert_statement_repeat1, 2),
  [1487] = {.count = 1, .reusable = true}, REDUCE(aux_sym_variables_repeat1, 2),
  [1489] = {.count = 1, .reusable = true}, SHIFT(98),
  [1491] = {.count = 2, .reusable = true}, REDUCE(aux_sym_assert_statement_repeat1, 2), SHIFT_REPEAT(319),
  [1494] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(618),
  [1497] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1086),
  [1500] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(618),
  [1503] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(601),
  [1506] = {.count = 1, .reusable = true}, SHIFT(96),
  [1508] = {.count = 1, .reusable = true}, SHIFT(277),
  [1510] = {.count = 1, .reusable = true}, SHIFT(115),
  [1512] = {.count = 1, .reusable = true}, SHIFT(116),
  [1514] = {.count = 1, .reusable = true}, REDUCE(sym__right_hand_side, 1),
  [1516] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(644),
  [1519] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1078),
  [1522] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(644),
  [1525] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(561),
  [1528] = {.count = 1, .reusable = false}, SHIFT(898),
  [1530] = {.count = 1, .reusable = true}, SHIFT(155),
  [1532] = {.count = 1, .reusable = false}, SHIFT(897),
  [1534] = {.count = 1, .reusable = true}, SHIFT(242),
  [1536] = {.count = 1, .reusable = true}, SHIFT(347),
  [1538] = {.count = 1, .reusable = true}, SHIFT(380),
  [1540] = {.count = 1, .reusable = true}, SHIFT(360),
  [1542] = {.count = 1, .reusable = true}, SHIFT(328),
  [1544] = {.count = 1, .reusable = true}, SHIFT(311),
  [1546] = {.count = 1, .reusable = true}, SHIFT(369),
  [1548] = {.count = 1, .reusable = true}, SHIFT(375),
  [1550] = {.count = 1, .reusable = false}, SHIFT(839),
  [1552] = {.count = 1, .reusable = true}, SHIFT(1051),
  [1554] = {.count = 1, .reusable = false}, SHIFT(838),
  [1556] = {.count = 1, .reusable = false}, SHIFT(919),
  [1558] = {.count = 1, .reusable = false}, SHIFT(946),
  [1560] = {.count = 1, .reusable = true}, REDUCE(sym__parameters, 2),
  [1562] = {.count = 1, .reusable = false}, SHIFT(867),
  [1564] = {.count = 1, .reusable = true}, REDUCE(sym__parameters, 3, .production_id = 1),
  [1566] = {.count = 1, .reusable = false}, SHIFT(896),
  [1568] = {.count = 1, .reusable = true}, REDUCE(sym__parameters, 3),
  [1570] = {.count = 1, .reusable = true}, REDUCE(sym__parameters, 2, .production_id = 1),
  [1572] = {.count = 1, .reusable = true}, SHIFT(196),
  [1574] = {.count = 1, .reusable = true}, SHIFT(362),
  [1576] = {.count = 1, .reusable = true}, SHIFT(1116),
  [1578] = {.count = 1, .reusable = true}, SHIFT(596),
  [1580] = {.count = 1, .reusable = true}, SHIFT(572),
  [1582] = {.count = 1, .reusable = true}, SHIFT(210),
  [1584] = {.count = 1, .reusable = true}, SHIFT(664),
  [1586] = {.count = 1, .reusable = true}, SHIFT(218),
  [1588] = {.count = 1, .reusable = true}, SHIFT(219),
  [1590] = {.count = 1, .reusable = true}, SHIFT(189),
  [1592] = {.count = 1, .reusable = true}, SHIFT(517),
  [1594] = {.count = 1, .reusable = true}, SHIFT(202),
  [1596] = {.count = 1, .reusable = true}, SHIFT(197),
  [1598] = {.count = 1, .reusable = true}, SHIFT(654),
  [1600] = {.count = 1, .reusable = true}, SHIFT(140),
  [1602] = {.count = 1, .reusable = true}, SHIFT(195),
  [1604] = {.count = 1, .reusable = true}, SHIFT(589),
  [1606] = {.count = 1, .reusable = true}, SHIFT(169),
  [1608] = {.count = 1, .reusable = true}, SHIFT(519),
  [1610] = {.count = 1, .reusable = true}, SHIFT(214),
  [1612] = {.count = 1, .reusable = true}, SHIFT(213),
  [1614] = {.count = 1, .reusable = true}, SHIFT(592),
  [1616] = {.count = 1, .reusable = true}, SHIFT(194),
  [1618] = {.count = 1, .reusable = true}, SHIFT(512),
  [1620] = {.count = 1, .reusable = true}, SHIFT(123),
  [1622] = {.count = 1, .reusable = true}, SHIFT(211),
  [1624] = {.count = 1, .reusable = true}, SHIFT(667),
  [1626] = {.count = 1, .reusable = true}, SHIFT(671),
  [1628] = {.count = 1, .reusable = true}, SHIFT(216),
  [1630] = {.count = 1, .reusable = true}, SHIFT(581),
  [1632] = {.count = 1, .reusable = true}, SHIFT(125),
  [1634] = {.count = 1, .reusable = true}, SHIFT(215),
  [1636] = {.count = 1, .reusable = true}, SHIFT(133),
  [1638] = {.count = 1, .reusable = true}, SHIFT(520),
  [1640] = {.count = 1, .reusable = true}, SHIFT(198),
  [1642] = {.count = 1, .reusable = true}, REDUCE(sym__comprehension_clauses, 1),
  [1644] = {.count = 1, .reusable = true}, SHIFT(310),
  [1646] = {.count = 1, .reusable = true}, REDUCE(sym__expression_within_for_in_clause, 1),
  [1648] = {.count = 1, .reusable = true}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2),
  [1650] = {.count = 2, .reusable = true}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2), SHIFT_REPEAT(310),
  [1653] = {.count = 2, .reusable = true}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2), SHIFT_REPEAT(1116),
  [1656] = {.count = 2, .reusable = true}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2), SHIFT_REPEAT(596),
  [1659] = {.count = 1, .reusable = true}, REDUCE(sym__comprehension_clauses, 2),
  [1661] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_clause, 5, .production_id = 73),
  [1663] = {.count = 1, .reusable = true}, SHIFT(103),
  [1665] = {.count = 1, .reusable = true}, SHIFT(305),
  [1667] = {.count = 1, .reusable = true}, SHIFT(358),
  [1669] = {.count = 1, .reusable = true}, SHIFT(359),
  [1671] = {.count = 1, .reusable = true}, SHIFT(1111),
  [1673] = {.count = 1, .reusable = true}, SHIFT(1146),
  [1675] = {.count = 1, .reusable = true}, SHIFT(1139),
  [1677] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_in_clause_repeat1, 2),
  [1679] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_in_clause_repeat1, 2), SHIFT_REPEAT(247),
  [1682] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_clause, 6, .production_id = 82),
  [1684] = {.count = 1, .reusable = true}, SHIFT(101),
  [1686] = {.count = 1, .reusable = true}, REDUCE(sym_if_clause, 2),
  [1688] = {.count = 1, .reusable = true}, SHIFT(1156),
  [1690] = {.count = 1, .reusable = true}, SHIFT(1153),
  [1692] = {.count = 1, .reusable = true}, SHIFT(1142),
  [1694] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_clause, 5, .production_id = 72),
  [1696] = {.count = 1, .reusable = true}, SHIFT(102),
  [1698] = {.count = 1, .reusable = true}, SHIFT(177),
  [1700] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_clause, 4, .production_id = 57),
  [1702] = {.count = 1, .reusable = true}, SHIFT(100),
  [1704] = {.count = 1, .reusable = true}, REDUCE(sym_list_splat, 2),
  [1706] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_within_for_in_clause, 4, .production_id = 38),
  [1708] = {.count = 1, .reusable = true}, SHIFT(158),
  [1710] = {.count = 1, .reusable = true}, SHIFT(518),
  [1712] = {.count = 1, .reusable = true}, REDUCE(sym_pair, 3, .production_id = 39),
  [1714] = {.count = 1, .reusable = true}, SHIFT(1113),
  [1716] = {.count = 1, .reusable = true}, REDUCE(sym_dotted_name, 1),
  [1718] = {.count = 1, .reusable = true}, REDUCE(sym_type, 1),
  [1720] = {.count = 1, .reusable = true}, SHIFT(178),
  [1722] = {.count = 1, .reusable = true}, SHIFT(205),
  [1724] = {.count = 1, .reusable = true}, SHIFT(656),
  [1726] = {.count = 1, .reusable = true}, SHIFT(263),
  [1728] = {.count = 1, .reusable = true}, REDUCE(sym_print_statement, 2, .production_id = 4),
  [1730] = {.count = 1, .reusable = true}, SHIFT(836),
  [1732] = {.count = 1, .reusable = true}, SHIFT(881),
  [1734] = {.count = 1, .reusable = true}, SHIFT(1001),
  [1736] = {.count = 1, .reusable = true}, SHIFT(323),
  [1738] = {.count = 1, .reusable = true}, REDUCE(sym_assert_statement, 2),
  [1740] = {.count = 1, .reusable = true}, SHIFT(153),
  [1742] = {.count = 1, .reusable = true}, SHIFT(665),
  [1744] = {.count = 1, .reusable = true}, SHIFT(190),
  [1746] = {.count = 1, .reusable = true}, SHIFT(206),
  [1748] = {.count = 1, .reusable = true}, SHIFT(203),
  [1750] = {.count = 1, .reusable = true}, SHIFT(171),
  [1752] = {.count = 1, .reusable = true}, SHIFT(513),
  [1754] = {.count = 1, .reusable = true}, SHIFT(147),
  [1756] = {.count = 1, .reusable = true}, SHIFT(217),
  [1758] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_within_for_in_clause, 3, .production_id = 14),
  [1760] = {.count = 1, .reusable = true}, SHIFT(771),
  [1762] = {.count = 1, .reusable = true}, SHIFT(872),
  [1764] = {.count = 1, .reusable = true}, SHIFT(1045),
  [1766] = {.count = 1, .reusable = true}, REDUCE(sym_dictionary_splat, 3),
  [1768] = {.count = 1, .reusable = false}, SHIFT(834),
  [1770] = {.count = 1, .reusable = true}, SHIFT(879),
  [1772] = {.count = 1, .reusable = false}, SHIFT(1101),
  [1774] = {.count = 1, .reusable = true}, REDUCE(sym_dotted_name, 2),
  [1776] = {.count = 1, .reusable = true}, REDUCE(sym_exec_statement, 4, .production_id = 6),
  [1778] = {.count = 2, .reusable = true}, REDUCE(aux_sym_dotted_name_repeat1, 2), SHIFT_REPEAT(1113),
  [1781] = {.count = 1, .reusable = true}, REDUCE(aux_sym_dotted_name_repeat1, 2),
  [1783] = {.count = 1, .reusable = true}, SHIFT(225),
  [1785] = {.count = 1, .reusable = true}, SHIFT(584),
  [1787] = {.count = 1, .reusable = true}, SHIFT(154),
  [1789] = {.count = 1, .reusable = true}, SHIFT(577),
  [1791] = {.count = 1, .reusable = true}, REDUCE(aux_sym_list_repeat1, 2),
  [1793] = {.count = 1, .reusable = true}, REDUCE(sym_with_item, 1, .production_id = 5),
  [1795] = {.count = 1, .reusable = true}, SHIFT(350),
  [1797] = {.count = 1, .reusable = true}, SHIFT(317),
  [1799] = {.count = 1, .reusable = true}, SHIFT(330),
  [1801] = {.count = 1, .reusable = true}, SHIFT(331),
  [1803] = {.count = 1, .reusable = true}, SHIFT(316),
  [1805] = {.count = 1, .reusable = true}, SHIFT(73),
  [1807] = {.count = 1, .reusable = false}, SHIFT(355),
  [1809] = {.count = 1, .reusable = true}, SHIFT(801),
  [1811] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [1813] = {.count = 1, .reusable = true}, SHIFT(546),
  [1815] = {.count = 1, .reusable = true}, SHIFT(313),
  [1817] = {.count = 1, .reusable = true}, SHIFT(63),
  [1819] = {.count = 1, .reusable = true}, SHIFT(813),
  [1821] = {.count = 1, .reusable = true}, SHIFT(496),
  [1823] = {.count = 1, .reusable = true}, SHIFT(160),
  [1825] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(355),
  [1828] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(801),
  [1831] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2),
  [1833] = {.count = 1, .reusable = true}, SHIFT(1004),
  [1835] = {.count = 1, .reusable = true}, REDUCE(aux_sym_subscript_repeat1, 2),
  [1837] = {.count = 1, .reusable = true}, SHIFT(802),
  [1839] = {.count = 1, .reusable = true}, SHIFT(1015),
  [1841] = {.count = 2, .reusable = true}, REDUCE(aux_sym_dotted_name_repeat1, 2), SHIFT_REPEAT(1145),
  [1844] = {.count = 1, .reusable = true}, SHIFT(251),
  [1846] = {.count = 1, .reusable = true}, REDUCE(aux_sym_print_statement_repeat1, 2, .production_id = 4),
  [1848] = {.count = 1, .reusable = true}, SHIFT(800),
  [1850] = {.count = 1, .reusable = true}, SHIFT(152),
  [1852] = {.count = 1, .reusable = true}, REDUCE(sym_default_parameter, 3, .production_id = 15),
  [1854] = {.count = 1, .reusable = true}, SHIFT(495),
  [1856] = {.count = 1, .reusable = true}, SHIFT(823),
  [1858] = {.count = 1, .reusable = true}, SHIFT(622),
  [1860] = {.count = 1, .reusable = true}, REDUCE(sym_typed_default_parameter, 5, .production_id = 70),
  [1862] = {.count = 1, .reusable = true}, REDUCE(sym_typed_default_parameter, 5, .production_id = 71),
  [1864] = {.count = 1, .reusable = true}, SHIFT(1145),
  [1866] = {.count = 1, .reusable = true}, REDUCE(sym_chevron, 2),
  [1868] = {.count = 1, .reusable = true}, SHIFT(641),
  [1870] = {.count = 1, .reusable = true}, SHIFT(521),
  [1872] = {.count = 1, .reusable = true}, SHIFT(796),
  [1874] = {.count = 1, .reusable = true}, SHIFT(545),
  [1876] = {.count = 1, .reusable = true}, REDUCE(aux_sym_decorated_definition_repeat1, 2),
  [1878] = {.count = 2, .reusable = true}, REDUCE(aux_sym_decorated_definition_repeat1, 2), SHIFT_REPEAT(1052),
  [1881] = {.count = 1, .reusable = true}, REDUCE(sym_default_parameter, 3, .production_id = 36),
  [1883] = {.count = 1, .reusable = true}, REDUCE(sym_slice, 5),
  [1885] = {.count = 1, .reusable = false}, SHIFT(378),
  [1887] = {.count = 1, .reusable = false}, REDUCE(sym_format_specifier, 1),
  [1889] = {.count = 1, .reusable = false}, SHIFT(860),
  [1891] = {.count = 1, .reusable = true}, SHIFT(874),
  [1893] = {.count = 1, .reusable = true}, REDUCE(sym__parameters, 1, .production_id = 1),
  [1895] = {.count = 1, .reusable = true}, SHIFT(726),
  [1897] = {.count = 1, .reusable = true}, SHIFT(285),
  [1899] = {.count = 1, .reusable = true}, SHIFT(377),
  [1901] = {.count = 1, .reusable = true}, REDUCE(sym__parameters, 1),
  [1903] = {.count = 1, .reusable = true}, SHIFT(725),
  [1905] = {.count = 1, .reusable = true}, SHIFT(286),
  [1907] = {.count = 1, .reusable = true}, SHIFT(374),
  [1909] = {.count = 1, .reusable = true}, REDUCE(sym_with_item, 3, .production_id = 32),
  [1911] = {.count = 1, .reusable = true}, SHIFT(294),
  [1913] = {.count = 1, .reusable = true}, SHIFT(1126),
  [1915] = {.count = 1, .reusable = true}, SHIFT(220),
  [1917] = {.count = 1, .reusable = true}, REDUCE(sym__import_list, 3, .production_id = 10),
  [1919] = {.count = 1, .reusable = true}, REDUCE(sym_yield, 3),
  [1921] = {.count = 1, .reusable = true}, SHIFT(301),
  [1923] = {.count = 1, .reusable = true}, SHIFT(1150),
  [1925] = {.count = 1, .reusable = true}, REDUCE(sym_raise_statement, 3, .production_id = 13),
  [1927] = {.count = 2, .reusable = true}, REDUCE(aux_sym_assert_statement_repeat1, 2), SHIFT_REPEAT(323),
  [1930] = {.count = 1, .reusable = true}, REDUCE(aux_sym_tuple_repeat1, 2),
  [1932] = {.count = 1, .reusable = true}, REDUCE(sym__import_list, 2, .production_id = 3),
  [1934] = {.count = 2, .reusable = false}, REDUCE(aux_sym_format_specifier_repeat1, 2), SHIFT_REPEAT(378),
  [1937] = {.count = 1, .reusable = false}, REDUCE(aux_sym_format_specifier_repeat1, 2),
  [1939] = {.count = 2, .reusable = false}, REDUCE(aux_sym_format_specifier_repeat1, 2), SHIFT_REPEAT(853),
  [1942] = {.count = 1, .reusable = true}, SHIFT(852),
  [1944] = {.count = 1, .reusable = true}, SHIFT(1114),
  [1946] = {.count = 1, .reusable = true}, REDUCE(sym__import_list, 1, .production_id = 3),
  [1948] = {.count = 1, .reusable = true}, REDUCE(sym_raise_statement, 4, .production_id = 27),
  [1950] = {.count = 1, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2),
  [1952] = {.count = 1, .reusable = false}, REDUCE(sym_format_specifier, 2),
  [1954] = {.count = 1, .reusable = false}, SHIFT(853),
  [1956] = {.count = 1, .reusable = true}, REDUCE(sym_keyword_argument, 3, .production_id = 15),
  [1958] = {.count = 1, .reusable = true}, REDUCE(sym_keyword_argument, 3, .production_id = 36),
  [1960] = {.count = 2, .reusable = true}, REDUCE(aux_sym_assert_statement_repeat1, 2), SHIFT_REPEAT(343),
  [1963] = {.count = 1, .reusable = false}, REDUCE(aux_sym_import_prefix_repeat1, 2),
  [1965] = {.count = 2, .reusable = true}, REDUCE(aux_sym_import_prefix_repeat1, 2), SHIFT_REPEAT(864),
  [1968] = {.count = 2, .reusable = true}, REDUCE(aux_sym_print_statement_repeat1, 2, .production_id = 26), SHIFT_REPEAT(344),
  [1971] = {.count = 1, .reusable = true}, REDUCE(aux_sym_print_statement_repeat1, 2, .production_id = 26),
  [1973] = {.count = 1, .reusable = true}, REDUCE(aux_sym__parameters_repeat1, 2),
  [1975] = {.count = 1, .reusable = true}, SHIFT(68),
  [1977] = {.count = 1, .reusable = true}, SHIFT(75),
  [1979] = {.count = 1, .reusable = true}, SHIFT(77),
  [1981] = {.count = 1, .reusable = true}, SHIFT(834),
  [1983] = {.count = 1, .reusable = true}, SHIFT(81),
  [1985] = {.count = 1, .reusable = true}, SHIFT(79),
  [1987] = {.count = 2, .reusable = true}, REDUCE(aux_sym__import_list_repeat1, 2, .production_id = 21), SHIFT_REPEAT(990),
  [1990] = {.count = 1, .reusable = true}, REDUCE(aux_sym__import_list_repeat1, 2, .production_id = 21),
  [1992] = {.count = 1, .reusable = true}, REDUCE(aux_sym__import_list_repeat1, 2, .production_id = 20),
  [1994] = {.count = 1, .reusable = false}, REDUCE(sym_import_prefix, 1),
  [1996] = {.count = 1, .reusable = true}, SHIFT(864),
  [1998] = {.count = 1, .reusable = true}, SHIFT(209),
  [2000] = {.count = 1, .reusable = false}, REDUCE(sym_interpolation, 3),
  [2002] = {.count = 1, .reusable = true}, REDUCE(sym_interpolation, 3),
  [2004] = {.count = 1, .reusable = true}, SHIFT(366),
  [2006] = {.count = 1, .reusable = true}, SHIFT(261),
  [2008] = {.count = 1, .reusable = true}, REDUCE(sym_print_statement, 2),
  [2010] = {.count = 1, .reusable = true}, SHIFT(290),
  [2012] = {.count = 1, .reusable = true}, SHIFT(365),
  [2014] = {.count = 1, .reusable = true}, SHIFT(883),
  [2016] = {.count = 1, .reusable = true}, SHIFT(1144),
  [2018] = {.count = 1, .reusable = true}, SHIFT(76),
  [2020] = {.count = 1, .reusable = true}, SHIFT(83),
  [2022] = {.count = 1, .reusable = true}, SHIFT(70),
  [2024] = {.count = 1, .reusable = false}, REDUCE(sym_interpolation, 5),
  [2026] = {.count = 1, .reusable = true}, REDUCE(sym_interpolation, 5),
  [2028] = {.count = 1, .reusable = true}, SHIFT(1129),
  [2030] = {.count = 1, .reusable = true}, REDUCE(sym_global_statement, 2),
  [2032] = {.count = 1, .reusable = true}, REDUCE(sym_nonlocal_statement, 2),
  [2034] = {.count = 1, .reusable = true}, SHIFT(934),
  [2036] = {.count = 1, .reusable = true}, SHIFT(304),
  [2038] = {.count = 1, .reusable = true}, REDUCE(aux_sym__parameters_repeat1, 2, .production_id = 35),
  [2040] = {.count = 1, .reusable = true}, SHIFT(727),
  [2042] = {.count = 1, .reusable = true}, SHIFT(720),
  [2044] = {.count = 1, .reusable = true}, REDUCE(sym_exec_statement, 5, .production_id = 6),
  [2046] = {.count = 1, .reusable = true}, REDUCE(sym_decorator, 3),
  [2048] = {.count = 1, .reusable = false}, REDUCE(sym_interpolation, 4),
  [2050] = {.count = 1, .reusable = true}, REDUCE(sym_interpolation, 4),
  [2052] = {.count = 1, .reusable = true}, REDUCE(sym_decorator, 4, .production_id = 34),
  [2054] = {.count = 1, .reusable = true}, REDUCE(sym_assert_statement, 3),
  [2056] = {.count = 1, .reusable = true}, SHIFT(337),
  [2058] = {.count = 1, .reusable = true}, SHIFT(257),
  [2060] = {.count = 1, .reusable = true}, REDUCE(sym_print_statement, 3, .production_id = 12),
  [2062] = {.count = 1, .reusable = true}, REDUCE(sym_nonlocal_statement, 3),
  [2064] = {.count = 1, .reusable = true}, SHIFT(259),
  [2066] = {.count = 1, .reusable = true}, REDUCE(sym_print_statement, 3, .production_id = 11),
  [2068] = {.count = 2, .reusable = true}, REDUCE(aux_sym_list_repeat1, 2), SHIFT_REPEAT(262),
  [2071] = {.count = 1, .reusable = true}, REDUCE(sym_global_statement, 3),
  [2073] = {.count = 1, .reusable = true}, SHIFT(843),
  [2075] = {.count = 1, .reusable = true}, REDUCE(sym__import_list, 2, .production_id = 10),
  [2077] = {.count = 1, .reusable = true}, REDUCE(sym_typed_parameter, 3, .production_id = 37),
  [2079] = {.count = 1, .reusable = true}, SHIFT(376),
  [2081] = {.count = 2, .reusable = true}, REDUCE(aux_sym_global_statement_repeat1, 2), SHIFT_REPEAT(1129),
  [2084] = {.count = 1, .reusable = true}, REDUCE(aux_sym_global_statement_repeat1, 2),
  [2086] = {.count = 1, .reusable = true}, SHIFT(181),
  [2088] = {.count = 1, .reusable = true}, SHIFT(93),
  [2090] = {.count = 1, .reusable = true}, SHIFT(1037),
  [2092] = {.count = 2, .reusable = true}, REDUCE(aux_sym_tuple_repeat1, 2), SHIFT_REPEAT(268),
  [2095] = {.count = 1, .reusable = true}, SHIFT(603),
  [2097] = {.count = 1, .reusable = true}, SHIFT(278),
  [2099] = {.count = 1, .reusable = true}, SHIFT(1154),
  [2101] = {.count = 2, .reusable = true}, REDUCE(aux_sym_variables_repeat1, 2), SHIFT_REPEAT(643),
  [2104] = {.count = 1, .reusable = true}, SHIFT(91),
  [2106] = {.count = 1, .reusable = true}, SHIFT(583),
  [2108] = {.count = 1, .reusable = true}, SHIFT(299),
  [2110] = {.count = 1, .reusable = true}, SHIFT(1074),
  [2112] = {.count = 2, .reusable = true}, REDUCE(aux_sym_with_statement_repeat1, 2), SHIFT_REPEAT(270),
  [2115] = {.count = 1, .reusable = true}, REDUCE(aux_sym_with_statement_repeat1, 2),
  [2117] = {.count = 1, .reusable = false}, REDUCE(sym_format_expression, 3),
  [2119] = {.count = 1, .reusable = true}, SHIFT(111),
  [2121] = {.count = 1, .reusable = true}, REDUCE(sym_assignment, 3, .production_id = 16),
  [2123] = {.count = 1, .reusable = true}, SHIFT(334),
  [2125] = {.count = 1, .reusable = true}, REDUCE(sym_raise_statement, 2),
  [2127] = {.count = 2, .reusable = true}, REDUCE(aux_sym__simple_statements_repeat1, 2), SHIFT_REPEAT(95),
  [2130] = {.count = 1, .reusable = true}, REDUCE(aux_sym__simple_statements_repeat1, 2),
  [2132] = {.count = 1, .reusable = true}, SHIFT(92),
  [2134] = {.count = 1, .reusable = true}, SHIFT(276),
  [2136] = {.count = 1, .reusable = true}, SHIFT(186),
  [2138] = {.count = 1, .reusable = true}, SHIFT(233),
  [2140] = {.count = 1, .reusable = true}, SHIFT(598),
  [2142] = {.count = 1, .reusable = true}, SHIFT(122),
  [2144] = {.count = 1, .reusable = true}, SHIFT(270),
  [2146] = {.count = 1, .reusable = true}, SHIFT(78),
  [2148] = {.count = 1, .reusable = true}, SHIFT(721),
  [2150] = {.count = 1, .reusable = true}, SHIFT(722),
  [2152] = {.count = 1, .reusable = true}, SHIFT(175),
  [2154] = {.count = 1, .reusable = true}, SHIFT(145),
  [2156] = {.count = 1, .reusable = true}, SHIFT(174),
  [2158] = {.count = 1, .reusable = true}, SHIFT(161),
  [2160] = {.count = 1, .reusable = true}, SHIFT(229),
  [2162] = {.count = 1, .reusable = true}, SHIFT(64),
  [2164] = {.count = 2, .reusable = true}, REDUCE(aux_sym_subscript_repeat1, 2), SHIFT_REPEAT(256),
  [2167] = {.count = 1, .reusable = true}, SHIFT(357),
  [2169] = {.count = 1, .reusable = true}, REDUCE(sym_exec_statement, 2, .production_id = 6),
  [2171] = {.count = 1, .reusable = true}, SHIFT(723),
  [2173] = {.count = 1, .reusable = true}, SHIFT(65),
  [2175] = {.count = 1, .reusable = true}, SHIFT(59),
  [2177] = {.count = 1, .reusable = true}, SHIFT(562),
  [2179] = {.count = 1, .reusable = true}, REDUCE(sym_variables, 2),
  [2181] = {.count = 2, .reusable = true}, REDUCE(aux_sym__parameters_repeat1, 2), SHIFT_REPEAT(728),
  [2184] = {.count = 1, .reusable = true}, SHIFT(148),
  [2186] = {.count = 1, .reusable = true}, SHIFT(110),
  [2188] = {.count = 1, .reusable = true}, SHIFT(84),
  [2190] = {.count = 2, .reusable = true}, REDUCE(aux_sym__parameters_repeat1, 2), SHIFT_REPEAT(730),
  [2193] = {.count = 1, .reusable = true}, SHIFT(138),
  [2195] = {.count = 1, .reusable = true}, SHIFT(204),
  [2197] = {.count = 1, .reusable = true}, SHIFT(228),
  [2199] = {.count = 1, .reusable = true}, SHIFT(522),
  [2201] = {.count = 2, .reusable = true}, REDUCE(aux_sym__import_list_repeat1, 2, .production_id = 21), SHIFT_REPEAT(989),
  [2204] = {.count = 1, .reusable = true}, SHIFT(170),
  [2206] = {.count = 1, .reusable = true}, SHIFT(57),
  [2208] = {.count = 1, .reusable = true}, SHIFT(80),
  [2210] = {.count = 2, .reusable = true}, REDUCE(aux_sym_dictionary_repeat1, 2), SHIFT_REPEAT(208),
  [2213] = {.count = 1, .reusable = true}, REDUCE(aux_sym_dictionary_repeat1, 2),
  [2215] = {.count = 1, .reusable = true}, SHIFT(131),
  [2217] = {.count = 1, .reusable = true}, SHIFT(82),
  [2219] = {.count = 1, .reusable = true}, SHIFT(239),
  [2221] = {.count = 1, .reusable = true}, SHIFT(240),
  [2223] = {.count = 1, .reusable = true}, REDUCE(sym_aliased_import, 3, .production_id = 22),
  [2225] = {.count = 1, .reusable = true}, SHIFT(112),
  [2227] = {.count = 1, .reusable = true}, SHIFT(900),
  [2229] = {.count = 1, .reusable = true}, SHIFT(94),
  [2231] = {.count = 1, .reusable = true}, SHIFT(188),
  [2233] = {.count = 1, .reusable = true}, SHIFT(201),
  [2235] = {.count = 1, .reusable = true}, SHIFT(193),
  [2237] = {.count = 1, .reusable = true}, SHIFT(674),
  [2239] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(146),
  [2242] = {.count = 1, .reusable = true}, SHIFT(136),
  [2244] = {.count = 1, .reusable = false}, REDUCE(sym_relative_import, 1),
  [2246] = {.count = 1, .reusable = true}, SHIFT(901),
  [2248] = {.count = 1, .reusable = true}, SHIFT(200),
  [2250] = {.count = 1, .reusable = true}, SHIFT(90),
  [2252] = {.count = 1, .reusable = true}, SHIFT(272),
  [2254] = {.count = 1, .reusable = true}, SHIFT(236),
  [2256] = {.count = 1, .reusable = true}, SHIFT(871),
  [2258] = {.count = 1, .reusable = true}, SHIFT(724),
  [2260] = {.count = 1, .reusable = true}, SHIFT(162),
  [2262] = {.count = 1, .reusable = true}, SHIFT(179),
  [2264] = {.count = 1, .reusable = true}, SHIFT(89),
  [2266] = {.count = 1, .reusable = true}, REDUCE(sym_parameters, 3),
  [2268] = {.count = 1, .reusable = true}, SHIFT(54),
  [2270] = {.count = 1, .reusable = true}, SHIFT(281),
  [2272] = {.count = 1, .reusable = true}, REDUCE(sym_yield, 2),
  [2274] = {.count = 1, .reusable = true}, SHIFT(716),
  [2276] = {.count = 1, .reusable = true}, REDUCE(sym_import_statement, 2, .production_id = 2),
  [2278] = {.count = 1, .reusable = true}, REDUCE(sym_future_import_statement, 4, .production_id = 23),
  [2280] = {.count = 1, .reusable = true}, SHIFT(74),
  [2282] = {.count = 1, .reusable = true}, SHIFT(288),
  [2284] = {.count = 1, .reusable = true}, SHIFT(86),
  [2286] = {.count = 1, .reusable = true}, SHIFT(271),
  [2288] = {.count = 1, .reusable = true}, SHIFT(62),
  [2290] = {.count = 1, .reusable = true}, SHIFT(279),
  [2292] = {.count = 1, .reusable = true}, REDUCE(sym_assignment, 5, .production_id = 53),
  [2294] = {.count = 1, .reusable = true}, REDUCE(sym_wildcard_import, 1),
  [2296] = {.count = 1, .reusable = true}, REDUCE(sym_import_from_statement, 4, .production_id = 24),
  [2298] = {.count = 1, .reusable = true}, REDUCE(sym_future_import_statement, 6, .production_id = 55),
  [2300] = {.count = 1, .reusable = true}, REDUCE(sym_import_from_statement, 6, .production_id = 56),
  [2302] = {.count = 1, .reusable = true}, REDUCE(sym_parameters, 2),
  [2304] = {.count = 1, .reusable = true}, REDUCE(sym_delete_statement, 2),
  [2306] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 2),
  [2308] = {.count = 1, .reusable = true}, REDUCE(sym_continue_statement, 1),
  [2310] = {.count = 1, .reusable = true}, REDUCE(sym_break_statement, 1),
  [2312] = {.count = 1, .reusable = true}, REDUCE(sym_pass_statement, 1),
  [2314] = {.count = 1, .reusable = true}, REDUCE(sym_assignment, 3, .production_id = 17),
  [2316] = {.count = 1, .reusable = true}, REDUCE(sym_augmented_assignment, 3, .production_id = 17),
  [2318] = {.count = 1, .reusable = true}, SHIFT(579),
  [2320] = {.count = 1, .reusable = true}, SHIFT(267),
  [2322] = {.count = 1, .reusable = true}, SHIFT(352),
  [2324] = {.count = 1, .reusable = true}, SHIFT(222),
  [2326] = {.count = 1, .reusable = true}, SHIFT(231),
  [2328] = {.count = 1, .reusable = true}, SHIFT(273),
  [2330] = {.count = 1, .reusable = true}, SHIFT(52),
  [2332] = {.count = 1, .reusable = true}, SHIFT(1035),
  [2334] = {.count = 1, .reusable = true}, SHIFT(223),
  [2336] = {.count = 1, .reusable = true}, SHIFT(663),
  [2338] = {.count = 1, .reusable = true}, SHIFT(672),
  [2340] = {.count = 1, .reusable = true}, SHIFT(640),
  [2342] = {.count = 1, .reusable = true}, SHIFT(676),
  [2344] = {.count = 1, .reusable = true}, SHIFT(580),
  [2346] = {.count = 1, .reusable = true}, SHIFT(554),
  [2348] = {.count = 1, .reusable = true}, SHIFT(649),
  [2350] = {.count = 1, .reusable = true}, SHIFT(576),
  [2352] = {.count = 1, .reusable = true}, SHIFT(642),
  [2354] = {.count = 1, .reusable = true}, SHIFT(571),
  [2356] = {.count = 1, .reusable = true}, SHIFT(372),
  [2358] = {.count = 1, .reusable = true}, SHIFT(652),
  [2360] = {.count = 1, .reusable = true}, SHIFT(653),
  [2362] = {.count = 1, .reusable = true}, SHIFT(341),
  [2364] = {.count = 1, .reusable = true}, SHIFT(58),
  [2366] = {.count = 1, .reusable = true}, SHIFT(593),
  [2368] = {.count = 1, .reusable = true}, SHIFT(212),
  [2370] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_parameters, 1),
  [2372] = {.count = 1, .reusable = true}, SHIFT(785),
  [2374] = {.count = 1, .reusable = true}, SHIFT(837),
  [2376] = {.count = 1, .reusable = true}, SHIFT(71),
  [2378] = {.count = 1, .reusable = true}, SHIFT(66),
  [2380] = {.count = 1, .reusable = true}, SHIFT(250),
  [2382] = {.count = 1, .reusable = true}, SHIFT(1050),
  [2384] = {.count = 1, .reusable = true}, SHIFT(1048),
  [2386] = {.count = 1, .reusable = true}, SHIFT(234),
  [2388] = {.count = 1, .reusable = true}, SHIFT(615),
  [2390] = {.count = 1, .reusable = true}, SHIFT(891),
  [2392] = {.count = 1, .reusable = true}, SHIFT(825),
  [2394] = {.count = 1, .reusable = true}, SHIFT(986),
  [2396] = {.count = 1, .reusable = true}, REDUCE(sym_relative_import, 2),
  [2398] = {.count = 1, .reusable = true}, SHIFT(594),
  [2400] = {.count = 1, .reusable = true}, SHIFT(173),
  [2402] = {.count = 1, .reusable = true}, SHIFT(293),
  [2404] = {.count = 1, .reusable = true}, SHIFT(307),
  [2406] = {.count = 1, .reusable = true}, SHIFT(69),
  [2408] = {.count = 1, .reusable = true}, SHIFT(511),
  [2410] = {.count = 1, .reusable = true}, SHIFT(61),
  [2412] = {.count = 1, .reusable = true}, SHIFT(504),
  [2414] = {.count = 1, .reusable = true}, SHIFT(88),
  [2416] = {.count = 1, .reusable = true}, SHIFT(55),
  [2418] = {.count = 1, .reusable = true}, SHIFT(56),
  [2420] = {.count = 1, .reusable = true}, SHIFT(942),
  [2422] = {.count = 1, .reusable = true}, SHIFT(67),
  [2424] = {.count = 1, .reusable = true}, SHIFT(501),
  [2426] = {.count = 1, .reusable = true}, SHIFT(87),
  [2428] = {.count = 1, .reusable = true}, SHIFT(85),
  [2430] = {.count = 1, .reusable = true}, SHIFT(902),
  [2432] = {.count = 1, .reusable = true}, SHIFT(1024),
  [2434] = {.count = 1, .reusable = true},  ACCEPT_INPUT(),
  [2436] = {.count = 1, .reusable = true}, SHIFT(241),
  [2438] = {.count = 1, .reusable = true}, SHIFT(508),
  [2440] = {.count = 1, .reusable = true}, SHIFT(968),
  [2442] = {.count = 1, .reusable = true}, SHIFT(51),
  [2444] = {.count = 1, .reusable = true}, SHIFT(893),
  [2446] = {.count = 1, .reusable = true}, SHIFT(980),
  [2448] = {.count = 1, .reusable = true}, SHIFT(892),
  [2450] = {.count = 1, .reusable = true}, SHIFT(1022),
  [2452] = {.count = 1, .reusable = true}, SHIFT(850),
  [2454] = {.count = 1, .reusable = true}, SHIFT(1028),
  [2456] = {.count = 1, .reusable = true}, SHIFT(50),
  [2458] = {.count = 1, .reusable = true}, SHIFT(620),
  [2460] = {.count = 1, .reusable = true}, SHIFT(516),
  [2462] = {.count = 1, .reusable = true}, SHIFT(72),
  [2464] = {.count = 1, .reusable = true}, SHIFT(1054),
  [2466] = {.count = 1, .reusable = true}, SHIFT(1056),
  [2468] = {.count = 1, .reusable = true}, SHIFT(292),
  [2470] = {.count = 1, .reusable = true}, SHIFT(291),
  [2472] = {.count = 1, .reusable = true}, SHIFT(314),
  [2474] = {.count = 1, .reusable = true}, SHIFT(49),
};

void *tree_sitter_python_external_scanner_create(void);
void tree_sitter_python_external_scanner_destroy(void *);
bool tree_sitter_python_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_python_external_scanner_serialize(void *, char *);
void tree_sitter_python_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_python(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .field_count = FIELD_COUNT,
    .field_names = ts_field_names,
    .field_map_slices = (const TSFieldMapSlice *)ts_field_map_slices,
    .field_map_entries = (const TSFieldMapEntry *)ts_field_map_entries,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_python_external_scanner_create,
      tree_sitter_python_external_scanner_destroy,
      tree_sitter_python_external_scanner_scan,
      tree_sitter_python_external_scanner_serialize,
      tree_sitter_python_external_scanner_deserialize,
    },
  };
  return &language;
}
